/* SpringAnimation.c generated by valac 0.56.18, the Vala compiler
 * generated from SpringAnimation.vala, do not modify */

/* Copyright (C) 2023 Fyra Labs*/

#include "libhelium-1.h"
#include <glib.h>
#include <float.h>
#include <math.h>
#include <glib-object.h>
#include <gtk/gtk.h>

#define HE_SPRING_ANIMATION_EPSILON 0.001
#define HE_SPRING_ANIMATION_MS_TO_S 0.001
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	HE_SPRING_PARAMS_0_PROPERTY,
	HE_SPRING_PARAMS_DAMPING_PROPERTY,
	HE_SPRING_PARAMS_DAMPING_RATIO_PROPERTY,
	HE_SPRING_PARAMS_MASS_PROPERTY,
	HE_SPRING_PARAMS_STIFFNESS_PROPERTY,
	HE_SPRING_PARAMS_NUM_PROPERTIES
};
static GParamSpec* he_spring_params_properties[HE_SPRING_PARAMS_NUM_PROPERTIES];
enum  {
	HE_SPRING_ANIMATION_0_PROPERTY,
	HE_SPRING_ANIMATION_EPSILON_PROPERTY,
	HE_SPRING_ANIMATION_ESTIMATED_DURATION_PROPERTY,
	HE_SPRING_ANIMATION_INITIAL_VELOCITY_PROPERTY,
	HE_SPRING_ANIMATION_LATCH_PROPERTY,
	HE_SPRING_ANIMATION_SPRING_PARAMS_PROPERTY,
	HE_SPRING_ANIMATION_VALUE_FROM_PROPERTY,
	HE_SPRING_ANIMATION_VALUE_TO_PROPERTY,
	HE_SPRING_ANIMATION_VELOCITY_PROPERTY,
	HE_SPRING_ANIMATION_NUM_PROPERTIES
};
static GParamSpec* he_spring_animation_properties[HE_SPRING_ANIMATION_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _HeSpringParamsPrivate {
	gdouble _damping;
	gdouble _damping_ratio;
	gdouble _mass;
	gdouble _stiffness;
};

struct _HeSpringAnimationPrivate {
	gdouble _epsilon;
	guint _estimated_duration;
	gdouble _initial_velocity;
	gboolean _latch;
	HeSpringParams* _spring_params;
	gdouble _value_from;
	gdouble _value_to;
	gdouble _velocity;
};

static gint HeSpringParams_private_offset;
static gpointer he_spring_params_parent_class = NULL;
static gint HeSpringAnimation_private_offset;
static gpointer he_spring_animation_parent_class = NULL;

static void he_spring_params_finalize (GObject * obj);
static GType he_spring_params_get_type_once (void);
static void _vala_he_spring_params_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec);
static void _vala_he_spring_params_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec);
static void he_spring_animation_estimates_duration (HeSpringAnimation* self);
static guint he_spring_animation_real_estimate_duration (HeAnimation* base);
static guint he_spring_animation_calculate_duration (HeSpringAnimation* self);
static gdouble he_spring_animation_real_calculate_value (HeAnimation* base,
                                                  guint t);
static gdouble he_spring_animation_oscillate (HeSpringAnimation* self,
                                       gdouble time,
                                       gdouble* velocity);
static guint he_spring_animation_get_first_zero (HeSpringAnimation* self);
static void he_spring_animation_finalize (GObject * obj);
static GType he_spring_animation_get_type_once (void);
static void _vala_he_spring_animation_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec);
static void _vala_he_spring_animation_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec);

static inline gpointer
he_spring_params_get_instance_private (HeSpringParams* self)
{
	return G_STRUCT_MEMBER_P (self, HeSpringParams_private_offset);
}

gdouble
he_spring_params_get_damping (HeSpringParams* self)
{
	gdouble result;
#line 8 "../lib/Models/Animation/SpringAnimation.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 8 "../lib/Models/Animation/SpringAnimation.vala"
	result = self->priv->_damping;
#line 8 "../lib/Models/Animation/SpringAnimation.vala"
	return result;
#line 118 "SpringAnimation.c"
}

void
he_spring_params_set_damping (HeSpringParams* self,
                              gdouble value)
{
	gdouble old_value;
#line 8 "../lib/Models/Animation/SpringAnimation.vala"
	g_return_if_fail (self != NULL);
#line 8 "../lib/Models/Animation/SpringAnimation.vala"
	old_value = he_spring_params_get_damping (self);
#line 8 "../lib/Models/Animation/SpringAnimation.vala"
	if (old_value != value) {
#line 8 "../lib/Models/Animation/SpringAnimation.vala"
		self->priv->_damping = value;
#line 8 "../lib/Models/Animation/SpringAnimation.vala"
		g_object_notify_by_pspec ((GObject *) self, he_spring_params_properties[HE_SPRING_PARAMS_DAMPING_PROPERTY]);
#line 136 "SpringAnimation.c"
	}
}

gdouble
he_spring_params_get_damping_ratio (HeSpringParams* self)
{
	gdouble result;
#line 9 "../lib/Models/Animation/SpringAnimation.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 9 "../lib/Models/Animation/SpringAnimation.vala"
	result = self->priv->_damping_ratio;
#line 9 "../lib/Models/Animation/SpringAnimation.vala"
	return result;
#line 150 "SpringAnimation.c"
}

void
he_spring_params_set_damping_ratio (HeSpringParams* self,
                                    gdouble value)
{
	gdouble old_value;
#line 9 "../lib/Models/Animation/SpringAnimation.vala"
	g_return_if_fail (self != NULL);
#line 9 "../lib/Models/Animation/SpringAnimation.vala"
	old_value = he_spring_params_get_damping_ratio (self);
#line 9 "../lib/Models/Animation/SpringAnimation.vala"
	if (old_value != value) {
#line 9 "../lib/Models/Animation/SpringAnimation.vala"
		self->priv->_damping_ratio = value;
#line 9 "../lib/Models/Animation/SpringAnimation.vala"
		g_object_notify_by_pspec ((GObject *) self, he_spring_params_properties[HE_SPRING_PARAMS_DAMPING_RATIO_PROPERTY]);
#line 168 "SpringAnimation.c"
	}
}

gdouble
he_spring_params_get_mass (HeSpringParams* self)
{
	gdouble result;
#line 10 "../lib/Models/Animation/SpringAnimation.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 10 "../lib/Models/Animation/SpringAnimation.vala"
	result = self->priv->_mass;
#line 10 "../lib/Models/Animation/SpringAnimation.vala"
	return result;
#line 182 "SpringAnimation.c"
}

void
he_spring_params_set_mass (HeSpringParams* self,
                           gdouble value)
{
	gdouble old_value;
#line 10 "../lib/Models/Animation/SpringAnimation.vala"
	g_return_if_fail (self != NULL);
#line 10 "../lib/Models/Animation/SpringAnimation.vala"
	old_value = he_spring_params_get_mass (self);
#line 10 "../lib/Models/Animation/SpringAnimation.vala"
	if (old_value != value) {
#line 10 "../lib/Models/Animation/SpringAnimation.vala"
		self->priv->_mass = value;
#line 10 "../lib/Models/Animation/SpringAnimation.vala"
		g_object_notify_by_pspec ((GObject *) self, he_spring_params_properties[HE_SPRING_PARAMS_MASS_PROPERTY]);
#line 200 "SpringAnimation.c"
	}
}

gdouble
he_spring_params_get_stiffness (HeSpringParams* self)
{
	gdouble result;
#line 11 "../lib/Models/Animation/SpringAnimation.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 11 "../lib/Models/Animation/SpringAnimation.vala"
	result = self->priv->_stiffness;
#line 11 "../lib/Models/Animation/SpringAnimation.vala"
	return result;
#line 214 "SpringAnimation.c"
}

void
he_spring_params_set_stiffness (HeSpringParams* self,
                                gdouble value)
{
	gdouble old_value;
#line 11 "../lib/Models/Animation/SpringAnimation.vala"
	g_return_if_fail (self != NULL);
#line 11 "../lib/Models/Animation/SpringAnimation.vala"
	old_value = he_spring_params_get_stiffness (self);
#line 11 "../lib/Models/Animation/SpringAnimation.vala"
	if (old_value != value) {
#line 11 "../lib/Models/Animation/SpringAnimation.vala"
		self->priv->_stiffness = value;
#line 11 "../lib/Models/Animation/SpringAnimation.vala"
		g_object_notify_by_pspec ((GObject *) self, he_spring_params_properties[HE_SPRING_PARAMS_STIFFNESS_PROPERTY]);
#line 232 "SpringAnimation.c"
	}
}

HeSpringParams*
he_spring_params_construct (GType object_type,
                            gdouble damping_ratio,
                            gdouble mass,
                            gdouble stiffness)
{
	HeSpringParams * self = NULL;
	gdouble critical_damping = 0.0;
	gdouble damping = 0.0;
#line 13 "../lib/Models/Animation/SpringAnimation.vala"
	self = (HeSpringParams*) g_object_new (object_type, NULL);
#line 15 "../lib/Models/Animation/SpringAnimation.vala"
	critical_damping = 2 * sqrt (mass * stiffness);
#line 16 "../lib/Models/Animation/SpringAnimation.vala"
	damping = damping_ratio * critical_damping;
#line 18 "../lib/Models/Animation/SpringAnimation.vala"
	he_spring_params_set_damping (self, damping);
#line 19 "../lib/Models/Animation/SpringAnimation.vala"
	he_spring_params_set_mass (self, mass);
#line 20 "../lib/Models/Animation/SpringAnimation.vala"
	he_spring_params_set_stiffness (self, stiffness);
#line 13 "../lib/Models/Animation/SpringAnimation.vala"
	return self;
#line 259 "SpringAnimation.c"
}

HeSpringParams*
he_spring_params_new (gdouble damping_ratio,
                      gdouble mass,
                      gdouble stiffness)
{
#line 13 "../lib/Models/Animation/SpringAnimation.vala"
	return he_spring_params_construct (HE_TYPE_SPRING_PARAMS, damping_ratio, mass, stiffness);
#line 269 "SpringAnimation.c"
}

HeSpringParams*
he_spring_params_construct_full (GType object_type,
                                 gdouble damping,
                                 gdouble mass,
                                 gdouble stiffness)
{
	HeSpringParams * self = NULL;
#line 23 "../lib/Models/Animation/SpringAnimation.vala"
	self = (HeSpringParams*) g_object_new (object_type, NULL);
#line 24 "../lib/Models/Animation/SpringAnimation.vala"
	he_spring_params_set_damping (self, damping);
#line 25 "../lib/Models/Animation/SpringAnimation.vala"
	he_spring_params_set_mass (self, mass);
#line 26 "../lib/Models/Animation/SpringAnimation.vala"
	he_spring_params_set_stiffness (self, stiffness);
#line 23 "../lib/Models/Animation/SpringAnimation.vala"
	return self;
#line 289 "SpringAnimation.c"
}

HeSpringParams*
he_spring_params_new_full (gdouble damping,
                           gdouble mass,
                           gdouble stiffness)
{
#line 23 "../lib/Models/Animation/SpringAnimation.vala"
	return he_spring_params_construct_full (HE_TYPE_SPRING_PARAMS, damping, mass, stiffness);
#line 299 "SpringAnimation.c"
}

static void
he_spring_params_class_init (HeSpringParamsClass * klass,
                             gpointer klass_data)
{
#line 7 "../lib/Models/Animation/SpringAnimation.vala"
	he_spring_params_parent_class = g_type_class_peek_parent (klass);
#line 7 "../lib/Models/Animation/SpringAnimation.vala"
	g_type_class_adjust_private_offset (klass, &HeSpringParams_private_offset);
#line 7 "../lib/Models/Animation/SpringAnimation.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_he_spring_params_get_property;
#line 7 "../lib/Models/Animation/SpringAnimation.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_he_spring_params_set_property;
#line 7 "../lib/Models/Animation/SpringAnimation.vala"
	G_OBJECT_CLASS (klass)->finalize = he_spring_params_finalize;
#line 7 "../lib/Models/Animation/SpringAnimation.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_SPRING_PARAMS_DAMPING_PROPERTY, he_spring_params_properties[HE_SPRING_PARAMS_DAMPING_PROPERTY] = g_param_spec_double ("damping", "damping", "damping", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 7 "../lib/Models/Animation/SpringAnimation.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_SPRING_PARAMS_DAMPING_RATIO_PROPERTY, he_spring_params_properties[HE_SPRING_PARAMS_DAMPING_RATIO_PROPERTY] = g_param_spec_double ("damping-ratio", "damping-ratio", "damping-ratio", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 7 "../lib/Models/Animation/SpringAnimation.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_SPRING_PARAMS_MASS_PROPERTY, he_spring_params_properties[HE_SPRING_PARAMS_MASS_PROPERTY] = g_param_spec_double ("mass", "mass", "mass", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 7 "../lib/Models/Animation/SpringAnimation.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_SPRING_PARAMS_STIFFNESS_PROPERTY, he_spring_params_properties[HE_SPRING_PARAMS_STIFFNESS_PROPERTY] = g_param_spec_double ("stiffness", "stiffness", "stiffness", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 324 "SpringAnimation.c"
}

static void
he_spring_params_instance_init (HeSpringParams * self,
                                gpointer klass)
{
#line 7 "../lib/Models/Animation/SpringAnimation.vala"
	self->priv = he_spring_params_get_instance_private (self);
#line 333 "SpringAnimation.c"
}

static void
he_spring_params_finalize (GObject * obj)
{
	HeSpringParams * self;
#line 7 "../lib/Models/Animation/SpringAnimation.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_SPRING_PARAMS, HeSpringParams);
#line 7 "../lib/Models/Animation/SpringAnimation.vala"
	G_OBJECT_CLASS (he_spring_params_parent_class)->finalize (obj);
#line 344 "SpringAnimation.c"
}

static GType
he_spring_params_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HeSpringParamsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) he_spring_params_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HeSpringParams), 0, (GInstanceInitFunc) he_spring_params_instance_init, NULL };
	GType he_spring_params_type_id;
	he_spring_params_type_id = g_type_register_static (G_TYPE_OBJECT, "HeSpringParams", &g_define_type_info, 0);
	HeSpringParams_private_offset = g_type_add_instance_private (he_spring_params_type_id, sizeof (HeSpringParamsPrivate));
	return he_spring_params_type_id;
}

GType
he_spring_params_get_type (void)
{
	static volatile gsize he_spring_params_type_id__once = 0;
	if (g_once_init_enter (&he_spring_params_type_id__once)) {
		GType he_spring_params_type_id;
		he_spring_params_type_id = he_spring_params_get_type_once ();
		g_once_init_leave (&he_spring_params_type_id__once, he_spring_params_type_id);
	}
	return he_spring_params_type_id__once;
}

static void
_vala_he_spring_params_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec)
{
	HeSpringParams * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_SPRING_PARAMS, HeSpringParams);
#line 7 "../lib/Models/Animation/SpringAnimation.vala"
	switch (property_id) {
#line 7 "../lib/Models/Animation/SpringAnimation.vala"
		case HE_SPRING_PARAMS_DAMPING_PROPERTY:
#line 7 "../lib/Models/Animation/SpringAnimation.vala"
		g_value_set_double (value, he_spring_params_get_damping (self));
#line 7 "../lib/Models/Animation/SpringAnimation.vala"
		break;
#line 7 "../lib/Models/Animation/SpringAnimation.vala"
		case HE_SPRING_PARAMS_DAMPING_RATIO_PROPERTY:
#line 7 "../lib/Models/Animation/SpringAnimation.vala"
		g_value_set_double (value, he_spring_params_get_damping_ratio (self));
#line 7 "../lib/Models/Animation/SpringAnimation.vala"
		break;
#line 7 "../lib/Models/Animation/SpringAnimation.vala"
		case HE_SPRING_PARAMS_MASS_PROPERTY:
#line 7 "../lib/Models/Animation/SpringAnimation.vala"
		g_value_set_double (value, he_spring_params_get_mass (self));
#line 7 "../lib/Models/Animation/SpringAnimation.vala"
		break;
#line 7 "../lib/Models/Animation/SpringAnimation.vala"
		case HE_SPRING_PARAMS_STIFFNESS_PROPERTY:
#line 7 "../lib/Models/Animation/SpringAnimation.vala"
		g_value_set_double (value, he_spring_params_get_stiffness (self));
#line 7 "../lib/Models/Animation/SpringAnimation.vala"
		break;
#line 403 "SpringAnimation.c"
		default:
#line 7 "../lib/Models/Animation/SpringAnimation.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 7 "../lib/Models/Animation/SpringAnimation.vala"
		break;
#line 409 "SpringAnimation.c"
	}
}

static void
_vala_he_spring_params_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec)
{
	HeSpringParams * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_SPRING_PARAMS, HeSpringParams);
#line 7 "../lib/Models/Animation/SpringAnimation.vala"
	switch (property_id) {
#line 7 "../lib/Models/Animation/SpringAnimation.vala"
		case HE_SPRING_PARAMS_DAMPING_PROPERTY:
#line 7 "../lib/Models/Animation/SpringAnimation.vala"
		he_spring_params_set_damping (self, g_value_get_double (value));
#line 7 "../lib/Models/Animation/SpringAnimation.vala"
		break;
#line 7 "../lib/Models/Animation/SpringAnimation.vala"
		case HE_SPRING_PARAMS_DAMPING_RATIO_PROPERTY:
#line 7 "../lib/Models/Animation/SpringAnimation.vala"
		he_spring_params_set_damping_ratio (self, g_value_get_double (value));
#line 7 "../lib/Models/Animation/SpringAnimation.vala"
		break;
#line 7 "../lib/Models/Animation/SpringAnimation.vala"
		case HE_SPRING_PARAMS_MASS_PROPERTY:
#line 7 "../lib/Models/Animation/SpringAnimation.vala"
		he_spring_params_set_mass (self, g_value_get_double (value));
#line 7 "../lib/Models/Animation/SpringAnimation.vala"
		break;
#line 7 "../lib/Models/Animation/SpringAnimation.vala"
		case HE_SPRING_PARAMS_STIFFNESS_PROPERTY:
#line 7 "../lib/Models/Animation/SpringAnimation.vala"
		he_spring_params_set_stiffness (self, g_value_get_double (value));
#line 7 "../lib/Models/Animation/SpringAnimation.vala"
		break;
#line 447 "SpringAnimation.c"
		default:
#line 7 "../lib/Models/Animation/SpringAnimation.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 7 "../lib/Models/Animation/SpringAnimation.vala"
		break;
#line 453 "SpringAnimation.c"
	}
}

static inline gpointer
he_spring_animation_get_instance_private (HeSpringAnimation* self)
{
	return G_STRUCT_MEMBER_P (self, HeSpringAnimation_private_offset);
}

gdouble
he_spring_animation_get_epsilon (HeSpringAnimation* self)
{
	gdouble result;
#line 31 "../lib/Models/Animation/SpringAnimation.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 31 "../lib/Models/Animation/SpringAnimation.vala"
	result = self->priv->_epsilon;
#line 31 "../lib/Models/Animation/SpringAnimation.vala"
	return result;
#line 473 "SpringAnimation.c"
}

void
he_spring_animation_set_epsilon (HeSpringAnimation* self,
                                 gdouble value)
{
	gdouble old_value;
#line 31 "../lib/Models/Animation/SpringAnimation.vala"
	g_return_if_fail (self != NULL);
#line 31 "../lib/Models/Animation/SpringAnimation.vala"
	old_value = he_spring_animation_get_epsilon (self);
#line 31 "../lib/Models/Animation/SpringAnimation.vala"
	if (old_value != value) {
#line 31 "../lib/Models/Animation/SpringAnimation.vala"
		self->priv->_epsilon = value;
#line 31 "../lib/Models/Animation/SpringAnimation.vala"
		g_object_notify_by_pspec ((GObject *) self, he_spring_animation_properties[HE_SPRING_ANIMATION_EPSILON_PROPERTY]);
#line 491 "SpringAnimation.c"
	}
}

guint
he_spring_animation_get_estimated_duration (HeSpringAnimation* self)
{
	guint result;
#line 32 "../lib/Models/Animation/SpringAnimation.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 32 "../lib/Models/Animation/SpringAnimation.vala"
	result = self->priv->_estimated_duration;
#line 32 "../lib/Models/Animation/SpringAnimation.vala"
	return result;
#line 505 "SpringAnimation.c"
}

void
he_spring_animation_set_estimated_duration (HeSpringAnimation* self,
                                            guint value)
{
	guint old_value;
#line 32 "../lib/Models/Animation/SpringAnimation.vala"
	g_return_if_fail (self != NULL);
#line 32 "../lib/Models/Animation/SpringAnimation.vala"
	old_value = he_spring_animation_get_estimated_duration (self);
#line 32 "../lib/Models/Animation/SpringAnimation.vala"
	if (old_value != value) {
#line 32 "../lib/Models/Animation/SpringAnimation.vala"
		self->priv->_estimated_duration = value;
#line 32 "../lib/Models/Animation/SpringAnimation.vala"
		g_object_notify_by_pspec ((GObject *) self, he_spring_animation_properties[HE_SPRING_ANIMATION_ESTIMATED_DURATION_PROPERTY]);
#line 523 "SpringAnimation.c"
	}
}

gdouble
he_spring_animation_get_initial_velocity (HeSpringAnimation* self)
{
	gdouble result;
#line 33 "../lib/Models/Animation/SpringAnimation.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 33 "../lib/Models/Animation/SpringAnimation.vala"
	result = self->priv->_initial_velocity;
#line 33 "../lib/Models/Animation/SpringAnimation.vala"
	return result;
#line 537 "SpringAnimation.c"
}

void
he_spring_animation_set_initial_velocity (HeSpringAnimation* self,
                                          gdouble value)
{
	gdouble old_value;
#line 33 "../lib/Models/Animation/SpringAnimation.vala"
	g_return_if_fail (self != NULL);
#line 33 "../lib/Models/Animation/SpringAnimation.vala"
	old_value = he_spring_animation_get_initial_velocity (self);
#line 33 "../lib/Models/Animation/SpringAnimation.vala"
	if (old_value != value) {
#line 33 "../lib/Models/Animation/SpringAnimation.vala"
		self->priv->_initial_velocity = value;
#line 33 "../lib/Models/Animation/SpringAnimation.vala"
		g_object_notify_by_pspec ((GObject *) self, he_spring_animation_properties[HE_SPRING_ANIMATION_INITIAL_VELOCITY_PROPERTY]);
#line 555 "SpringAnimation.c"
	}
}

gboolean
he_spring_animation_get_latch (HeSpringAnimation* self)
{
	gboolean result;
#line 34 "../lib/Models/Animation/SpringAnimation.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 34 "../lib/Models/Animation/SpringAnimation.vala"
	result = self->priv->_latch;
#line 34 "../lib/Models/Animation/SpringAnimation.vala"
	return result;
#line 569 "SpringAnimation.c"
}

void
he_spring_animation_set_latch (HeSpringAnimation* self,
                               gboolean value)
{
	gboolean old_value;
#line 34 "../lib/Models/Animation/SpringAnimation.vala"
	g_return_if_fail (self != NULL);
#line 34 "../lib/Models/Animation/SpringAnimation.vala"
	old_value = he_spring_animation_get_latch (self);
#line 34 "../lib/Models/Animation/SpringAnimation.vala"
	if (old_value != value) {
#line 34 "../lib/Models/Animation/SpringAnimation.vala"
		self->priv->_latch = value;
#line 34 "../lib/Models/Animation/SpringAnimation.vala"
		g_object_notify_by_pspec ((GObject *) self, he_spring_animation_properties[HE_SPRING_ANIMATION_LATCH_PROPERTY]);
#line 587 "SpringAnimation.c"
	}
}

HeSpringParams*
he_spring_animation_get_spring_params (HeSpringAnimation* self)
{
	HeSpringParams* result;
	HeSpringParams* _tmp0_;
#line 35 "../lib/Models/Animation/SpringAnimation.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 35 "../lib/Models/Animation/SpringAnimation.vala"
	_tmp0_ = self->priv->_spring_params;
#line 35 "../lib/Models/Animation/SpringAnimation.vala"
	result = _tmp0_;
#line 35 "../lib/Models/Animation/SpringAnimation.vala"
	return result;
#line 604 "SpringAnimation.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 35 "../lib/Models/Animation/SpringAnimation.vala"
	return self ? g_object_ref (self) : NULL;
#line 612 "SpringAnimation.c"
}

void
he_spring_animation_set_spring_params (HeSpringAnimation* self,
                                       HeSpringParams* value)
{
	HeSpringParams* old_value;
#line 35 "../lib/Models/Animation/SpringAnimation.vala"
	g_return_if_fail (self != NULL);
#line 35 "../lib/Models/Animation/SpringAnimation.vala"
	old_value = he_spring_animation_get_spring_params (self);
#line 35 "../lib/Models/Animation/SpringAnimation.vala"
	if (old_value != value) {
#line 626 "SpringAnimation.c"
		HeSpringParams* _tmp0_;
#line 35 "../lib/Models/Animation/SpringAnimation.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 35 "../lib/Models/Animation/SpringAnimation.vala"
		_g_object_unref0 (self->priv->_spring_params);
#line 35 "../lib/Models/Animation/SpringAnimation.vala"
		self->priv->_spring_params = _tmp0_;
#line 35 "../lib/Models/Animation/SpringAnimation.vala"
		g_object_notify_by_pspec ((GObject *) self, he_spring_animation_properties[HE_SPRING_ANIMATION_SPRING_PARAMS_PROPERTY]);
#line 636 "SpringAnimation.c"
	}
}

gdouble
he_spring_animation_get_value_from (HeSpringAnimation* self)
{
	gdouble result;
#line 36 "../lib/Models/Animation/SpringAnimation.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 36 "../lib/Models/Animation/SpringAnimation.vala"
	result = self->priv->_value_from;
#line 36 "../lib/Models/Animation/SpringAnimation.vala"
	return result;
#line 650 "SpringAnimation.c"
}

void
he_spring_animation_set_value_from (HeSpringAnimation* self,
                                    gdouble value)
{
	gdouble old_value;
#line 36 "../lib/Models/Animation/SpringAnimation.vala"
	g_return_if_fail (self != NULL);
#line 36 "../lib/Models/Animation/SpringAnimation.vala"
	old_value = he_spring_animation_get_value_from (self);
#line 36 "../lib/Models/Animation/SpringAnimation.vala"
	if (old_value != value) {
#line 36 "../lib/Models/Animation/SpringAnimation.vala"
		self->priv->_value_from = value;
#line 36 "../lib/Models/Animation/SpringAnimation.vala"
		g_object_notify_by_pspec ((GObject *) self, he_spring_animation_properties[HE_SPRING_ANIMATION_VALUE_FROM_PROPERTY]);
#line 668 "SpringAnimation.c"
	}
}

gdouble
he_spring_animation_get_value_to (HeSpringAnimation* self)
{
	gdouble result;
#line 37 "../lib/Models/Animation/SpringAnimation.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 37 "../lib/Models/Animation/SpringAnimation.vala"
	result = self->priv->_value_to;
#line 37 "../lib/Models/Animation/SpringAnimation.vala"
	return result;
#line 682 "SpringAnimation.c"
}

void
he_spring_animation_set_value_to (HeSpringAnimation* self,
                                  gdouble value)
{
	gdouble old_value;
#line 37 "../lib/Models/Animation/SpringAnimation.vala"
	g_return_if_fail (self != NULL);
#line 37 "../lib/Models/Animation/SpringAnimation.vala"
	old_value = he_spring_animation_get_value_to (self);
#line 37 "../lib/Models/Animation/SpringAnimation.vala"
	if (old_value != value) {
#line 37 "../lib/Models/Animation/SpringAnimation.vala"
		self->priv->_value_to = value;
#line 37 "../lib/Models/Animation/SpringAnimation.vala"
		g_object_notify_by_pspec ((GObject *) self, he_spring_animation_properties[HE_SPRING_ANIMATION_VALUE_TO_PROPERTY]);
#line 700 "SpringAnimation.c"
	}
}

gdouble
he_spring_animation_get_velocity (HeSpringAnimation* self)
{
	gdouble result;
#line 38 "../lib/Models/Animation/SpringAnimation.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 38 "../lib/Models/Animation/SpringAnimation.vala"
	result = self->priv->_velocity;
#line 38 "../lib/Models/Animation/SpringAnimation.vala"
	return result;
#line 714 "SpringAnimation.c"
}

void
he_spring_animation_set_velocity (HeSpringAnimation* self,
                                  gdouble value)
{
	gdouble old_value;
#line 38 "../lib/Models/Animation/SpringAnimation.vala"
	g_return_if_fail (self != NULL);
#line 38 "../lib/Models/Animation/SpringAnimation.vala"
	old_value = he_spring_animation_get_velocity (self);
#line 38 "../lib/Models/Animation/SpringAnimation.vala"
	if (old_value != value) {
#line 38 "../lib/Models/Animation/SpringAnimation.vala"
		self->priv->_velocity = value;
#line 38 "../lib/Models/Animation/SpringAnimation.vala"
		g_object_notify_by_pspec ((GObject *) self, he_spring_animation_properties[HE_SPRING_ANIMATION_VELOCITY_PROPERTY]);
#line 732 "SpringAnimation.c"
	}
}

HeSpringAnimation*
he_spring_animation_construct (GType object_type,
                               GtkWidget* widget,
                               gdouble from,
                               gdouble to,
                               HeSpringParams* sparams,
                               HeAnimationTarget* target)
{
	HeSpringAnimation * self = NULL;
#line 43 "../lib/Models/Animation/SpringAnimation.vala"
	g_return_val_if_fail (widget != NULL, NULL);
#line 43 "../lib/Models/Animation/SpringAnimation.vala"
	g_return_val_if_fail (sparams != NULL, NULL);
#line 43 "../lib/Models/Animation/SpringAnimation.vala"
	g_return_val_if_fail (target != NULL, NULL);
#line 43 "../lib/Models/Animation/SpringAnimation.vala"
	self = (HeSpringAnimation*) he_animation_construct (object_type);
#line 44 "../lib/Models/Animation/SpringAnimation.vala"
	he_spring_animation_set_epsilon (self, HE_SPRING_ANIMATION_EPSILON);
#line 46 "../lib/Models/Animation/SpringAnimation.vala"
	he_animation_set_widget (G_TYPE_CHECK_INSTANCE_CAST (self, HE_TYPE_ANIMATION, HeAnimation), widget);
#line 47 "../lib/Models/Animation/SpringAnimation.vala"
	he_animation_set_target (G_TYPE_CHECK_INSTANCE_CAST (self, HE_TYPE_ANIMATION, HeAnimation), target);
#line 49 "../lib/Models/Animation/SpringAnimation.vala"
	if (sparams != NULL) {
#line 50 "../lib/Models/Animation/SpringAnimation.vala"
		he_spring_animation_set_spring_params (self, sparams);
#line 51 "../lib/Models/Animation/SpringAnimation.vala"
		he_spring_animation_estimates_duration (self);
#line 765 "SpringAnimation.c"
	}
#line 43 "../lib/Models/Animation/SpringAnimation.vala"
	_g_object_unref0 (sparams);
#line 43 "../lib/Models/Animation/SpringAnimation.vala"
	_g_object_unref0 (target);
#line 43 "../lib/Models/Animation/SpringAnimation.vala"
	return self;
#line 773 "SpringAnimation.c"
}

HeSpringAnimation*
he_spring_animation_new (GtkWidget* widget,
                         gdouble from,
                         gdouble to,
                         HeSpringParams* sparams,
                         HeAnimationTarget* target)
{
#line 43 "../lib/Models/Animation/SpringAnimation.vala"
	return he_spring_animation_construct (HE_TYPE_SPRING_ANIMATION, widget, from, to, sparams, target);
#line 785 "SpringAnimation.c"
}

static guint
he_spring_animation_real_estimate_duration (HeAnimation* base)
{
	HeSpringAnimation * self;
	guint _tmp0_;
	guint result;
#line 55 "../lib/Models/Animation/SpringAnimation.vala"
	self = (HeSpringAnimation*) base;
#line 56 "../lib/Models/Animation/SpringAnimation.vala"
	_tmp0_ = self->priv->_estimated_duration;
#line 56 "../lib/Models/Animation/SpringAnimation.vala"
	result = _tmp0_;
#line 56 "../lib/Models/Animation/SpringAnimation.vala"
	return result;
#line 802 "SpringAnimation.c"
}

static void
he_spring_animation_estimates_duration (HeSpringAnimation* self)
{
	HeSpringParams* _tmp0_;
#line 59 "../lib/Models/Animation/SpringAnimation.vala"
	g_return_if_fail (self != NULL);
#line 61 "../lib/Models/Animation/SpringAnimation.vala"
	_tmp0_ = self->priv->_spring_params;
#line 61 "../lib/Models/Animation/SpringAnimation.vala"
	if (_tmp0_ == NULL) {
#line 62 "../lib/Models/Animation/SpringAnimation.vala"
		return;
#line 817 "SpringAnimation.c"
	}
#line 64 "../lib/Models/Animation/SpringAnimation.vala"
	he_spring_animation_set_estimated_duration (self, (guint) he_spring_animation_calculate_duration (self));
#line 821 "SpringAnimation.c"
}

static gdouble
he_spring_animation_real_calculate_value (HeAnimation* base,
                                          guint t)
{
	HeSpringAnimation * self;
	gdouble value = 0.0;
	guint _tmp0_;
	gdouble _tmp2_;
	gdouble result;
#line 67 "../lib/Models/Animation/SpringAnimation.vala"
	self = (HeSpringAnimation*) base;
#line 70 "../lib/Models/Animation/SpringAnimation.vala"
	_tmp0_ = self->priv->_estimated_duration;
#line 70 "../lib/Models/Animation/SpringAnimation.vala"
	if (t >= _tmp0_) {
#line 839 "SpringAnimation.c"
		gdouble _tmp1_;
#line 71 "../lib/Models/Animation/SpringAnimation.vala"
		he_spring_animation_set_velocity (self, (gdouble) 0);
#line 72 "../lib/Models/Animation/SpringAnimation.vala"
		_tmp1_ = self->priv->_value_to;
#line 72 "../lib/Models/Animation/SpringAnimation.vala"
		result = _tmp1_;
#line 72 "../lib/Models/Animation/SpringAnimation.vala"
		return result;
#line 849 "SpringAnimation.c"
	}
#line 75 "../lib/Models/Animation/SpringAnimation.vala"
	_tmp2_ = self->priv->_velocity;
#line 75 "../lib/Models/Animation/SpringAnimation.vala"
	value = he_spring_animation_oscillate (self, (gdouble) t, &_tmp2_);
#line 76 "../lib/Models/Animation/SpringAnimation.vala"
	result = value;
#line 76 "../lib/Models/Animation/SpringAnimation.vala"
	return result;
#line 859 "SpringAnimation.c"
}

static guint
he_spring_animation_calculate_duration (HeSpringAnimation* self)
{
	gdouble damping = 0.0;
	HeSpringParams* _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble mass = 0.0;
	HeSpringParams* _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_;
	gdouble stiffness = 0.0;
	HeSpringParams* _tmp6_;
	gdouble _tmp7_;
	gdouble _tmp8_;
	gdouble beta = 0.0;
	gdouble omega0 = 0.0;
	gdouble x0 = 0.0;
	gdouble y0 = 0.0;
	gdouble x1 = 0.0;
	gdouble y1 = 0.0;
	gdouble m = 0.0;
	gint i = 0;
	gboolean _tmp9_;
	gdouble _tmp10_;
	gdouble _tmp11_;
	guint result;
#line 79 "../lib/Models/Animation/SpringAnimation.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 80 "../lib/Models/Animation/SpringAnimation.vala"
	_tmp0_ = self->priv->_spring_params;
#line 80 "../lib/Models/Animation/SpringAnimation.vala"
	_tmp1_ = he_spring_params_get_damping (_tmp0_);
#line 80 "../lib/Models/Animation/SpringAnimation.vala"
	_tmp2_ = _tmp1_;
#line 80 "../lib/Models/Animation/SpringAnimation.vala"
	damping = _tmp2_;
#line 81 "../lib/Models/Animation/SpringAnimation.vala"
	_tmp3_ = self->priv->_spring_params;
#line 81 "../lib/Models/Animation/SpringAnimation.vala"
	_tmp4_ = he_spring_params_get_mass (_tmp3_);
#line 81 "../lib/Models/Animation/SpringAnimation.vala"
	_tmp5_ = _tmp4_;
#line 81 "../lib/Models/Animation/SpringAnimation.vala"
	mass = _tmp5_;
#line 82 "../lib/Models/Animation/SpringAnimation.vala"
	_tmp6_ = self->priv->_spring_params;
#line 82 "../lib/Models/Animation/SpringAnimation.vala"
	_tmp7_ = he_spring_params_get_stiffness (_tmp6_);
#line 82 "../lib/Models/Animation/SpringAnimation.vala"
	_tmp8_ = _tmp7_;
#line 82 "../lib/Models/Animation/SpringAnimation.vala"
	stiffness = _tmp8_;
#line 83 "../lib/Models/Animation/SpringAnimation.vala"
	beta = damping / (2 * mass);
#line 89 "../lib/Models/Animation/SpringAnimation.vala"
	i = 0;
#line 91 "../lib/Models/Animation/SpringAnimation.vala"
	if (beta <= ((gdouble) 0)) {
#line 92 "../lib/Models/Animation/SpringAnimation.vala"
		result = (guint) 0xffffffffLL;
#line 92 "../lib/Models/Animation/SpringAnimation.vala"
		return result;
#line 925 "SpringAnimation.c"
	}
#line 94 "../lib/Models/Animation/SpringAnimation.vala"
	_tmp9_ = self->priv->_latch;
#line 94 "../lib/Models/Animation/SpringAnimation.vala"
	if (_tmp9_) {
#line 95 "../lib/Models/Animation/SpringAnimation.vala"
		result = he_spring_animation_get_first_zero (self);
#line 95 "../lib/Models/Animation/SpringAnimation.vala"
		return result;
#line 935 "SpringAnimation.c"
	}
#line 98 "../lib/Models/Animation/SpringAnimation.vala"
	omega0 = sqrt (stiffness / mass);
#line 105 "../lib/Models/Animation/SpringAnimation.vala"
	_tmp10_ = self->priv->_epsilon;
#line 105 "../lib/Models/Animation/SpringAnimation.vala"
	x0 = (-log (_tmp10_)) / beta;
#line 107 "../lib/Models/Animation/SpringAnimation.vala"
	if (beta <= omega0) {
#line 108 "../lib/Models/Animation/SpringAnimation.vala"
		result = (guint) (x0 * 1000);
#line 108 "../lib/Models/Animation/SpringAnimation.vala"
		return result;
#line 949 "SpringAnimation.c"
	}
#line 116 "../lib/Models/Animation/SpringAnimation.vala"
	y0 = he_spring_animation_oscillate (self, x0 * 1000, NULL);
#line 117 "../lib/Models/Animation/SpringAnimation.vala"
	m = (he_spring_animation_oscillate (self, (x0 + 0.001) * 1000, NULL) - y0) / 0.001;
#line 119 "../lib/Models/Animation/SpringAnimation.vala"
	_tmp11_ = self->priv->_value_to;
#line 119 "../lib/Models/Animation/SpringAnimation.vala"
	x1 = ((_tmp11_ - y0) + (m * x0)) / m;
#line 120 "../lib/Models/Animation/SpringAnimation.vala"
	y1 = he_spring_animation_oscillate (self, x1 * 1000, NULL);
#line 122 "../lib/Models/Animation/SpringAnimation.vala"
	while (TRUE) {
#line 963 "SpringAnimation.c"
		gdouble _tmp12_;
		gdouble _tmp13_;
		gdouble _tmp14_;
		gint _tmp15_;
#line 122 "../lib/Models/Animation/SpringAnimation.vala"
		_tmp12_ = self->priv->_value_to;
#line 122 "../lib/Models/Animation/SpringAnimation.vala"
		_tmp13_ = self->priv->_epsilon;
#line 122 "../lib/Models/Animation/SpringAnimation.vala"
		if (!(fabs (_tmp12_ - y1) > _tmp13_)) {
#line 122 "../lib/Models/Animation/SpringAnimation.vala"
			break;
#line 976 "SpringAnimation.c"
		}
#line 123 "../lib/Models/Animation/SpringAnimation.vala"
		if (i > 1000) {
#line 124 "../lib/Models/Animation/SpringAnimation.vala"
			result = (guint) 0;
#line 124 "../lib/Models/Animation/SpringAnimation.vala"
			return result;
#line 984 "SpringAnimation.c"
		}
#line 125 "../lib/Models/Animation/SpringAnimation.vala"
		x0 = x1;
#line 126 "../lib/Models/Animation/SpringAnimation.vala"
		y0 = y1;
#line 128 "../lib/Models/Animation/SpringAnimation.vala"
		m = (he_spring_animation_oscillate (self, (x0 + 0.001) * 1000, NULL) - y0) / 0.001;
#line 130 "../lib/Models/Animation/SpringAnimation.vala"
		_tmp14_ = self->priv->_value_to;
#line 130 "../lib/Models/Animation/SpringAnimation.vala"
		x1 = ((_tmp14_ - y0) + (m * x0)) / m;
#line 131 "../lib/Models/Animation/SpringAnimation.vala"
		y1 = he_spring_animation_oscillate (self, x1 * 1000, NULL);
#line 132 "../lib/Models/Animation/SpringAnimation.vala"
		_tmp15_ = i;
#line 132 "../lib/Models/Animation/SpringAnimation.vala"
		i = _tmp15_ + 1;
#line 1002 "SpringAnimation.c"
	}
#line 135 "../lib/Models/Animation/SpringAnimation.vala"
	result = (guint) (x1 * 1000);
#line 135 "../lib/Models/Animation/SpringAnimation.vala"
	return result;
#line 1008 "SpringAnimation.c"
}

static gdouble
he_spring_animation_oscillate (HeSpringAnimation* self,
                               gdouble time,
                               gdouble* velocity)
{
	gdouble b = 0.0;
	HeSpringParams* _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble m = 0.0;
	HeSpringParams* _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_;
	gdouble k = 0.0;
	HeSpringParams* _tmp6_;
	gdouble _tmp7_;
	gdouble _tmp8_;
	gdouble v0 = 0.0;
	gdouble _tmp9_;
	gdouble t = 0.0;
	gdouble beta = 0.0;
	gdouble omega0 = 0.0;
	gdouble x0 = 0.0;
	gdouble _tmp10_;
	gdouble _tmp11_;
	gdouble envelope = 0.0;
	gdouble _tmp17_;
	gdouble result;
#line 138 "../lib/Models/Animation/SpringAnimation.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 139 "../lib/Models/Animation/SpringAnimation.vala"
	_tmp0_ = self->priv->_spring_params;
#line 139 "../lib/Models/Animation/SpringAnimation.vala"
	_tmp1_ = he_spring_params_get_damping (_tmp0_);
#line 139 "../lib/Models/Animation/SpringAnimation.vala"
	_tmp2_ = _tmp1_;
#line 139 "../lib/Models/Animation/SpringAnimation.vala"
	b = _tmp2_;
#line 140 "../lib/Models/Animation/SpringAnimation.vala"
	_tmp3_ = self->priv->_spring_params;
#line 140 "../lib/Models/Animation/SpringAnimation.vala"
	_tmp4_ = he_spring_params_get_mass (_tmp3_);
#line 140 "../lib/Models/Animation/SpringAnimation.vala"
	_tmp5_ = _tmp4_;
#line 140 "../lib/Models/Animation/SpringAnimation.vala"
	m = _tmp5_;
#line 141 "../lib/Models/Animation/SpringAnimation.vala"
	_tmp6_ = self->priv->_spring_params;
#line 141 "../lib/Models/Animation/SpringAnimation.vala"
	_tmp7_ = he_spring_params_get_stiffness (_tmp6_);
#line 141 "../lib/Models/Animation/SpringAnimation.vala"
	_tmp8_ = _tmp7_;
#line 141 "../lib/Models/Animation/SpringAnimation.vala"
	k = _tmp8_;
#line 142 "../lib/Models/Animation/SpringAnimation.vala"
	_tmp9_ = self->priv->_initial_velocity;
#line 142 "../lib/Models/Animation/SpringAnimation.vala"
	v0 = _tmp9_;
#line 144 "../lib/Models/Animation/SpringAnimation.vala"
	t = time * HE_SPRING_ANIMATION_MS_TO_S;
#line 146 "../lib/Models/Animation/SpringAnimation.vala"
	beta = b / (2 * m);
#line 147 "../lib/Models/Animation/SpringAnimation.vala"
	omega0 = sqrt (k / m);
#line 149 "../lib/Models/Animation/SpringAnimation.vala"
	_tmp10_ = self->priv->_value_from;
#line 149 "../lib/Models/Animation/SpringAnimation.vala"
	_tmp11_ = self->priv->_value_to;
#line 149 "../lib/Models/Animation/SpringAnimation.vala"
	x0 = _tmp10_ - _tmp11_;
#line 151 "../lib/Models/Animation/SpringAnimation.vala"
	envelope = exp ((-beta) * t);
#line 159 "../lib/Models/Animation/SpringAnimation.vala"
	if (beta < omega0) {
#line 1085 "SpringAnimation.c"
		gdouble omega1 = 0.0;
		gdouble _tmp13_;
#line 160 "../lib/Models/Animation/SpringAnimation.vala"
		omega1 = sqrt ((omega0 * omega0) - (beta * beta));
#line 162 "../lib/Models/Animation/SpringAnimation.vala"
		if (velocity != NULL) {
#line 1092 "SpringAnimation.c"
			gdouble _tmp12_;
#line 163 "../lib/Models/Animation/SpringAnimation.vala"
			_tmp12_ = envelope * ((v0 * cos (omega1 * t)) - (((x0 * omega1) + ((((beta * beta) * x0) + (beta * v0)) / omega1)) * sin (omega1 * t)));
#line 163 "../lib/Models/Animation/SpringAnimation.vala"
			velocity = &_tmp12_;
#line 1098 "SpringAnimation.c"
		}
#line 165 "../lib/Models/Animation/SpringAnimation.vala"
		_tmp13_ = self->priv->_value_to;
#line 165 "../lib/Models/Animation/SpringAnimation.vala"
		result = _tmp13_ + (envelope * ((x0 * cos (omega1 * t)) + ((((beta * x0) + v0) / omega1) * sin (omega1 * t))));
#line 165 "../lib/Models/Animation/SpringAnimation.vala"
		return result;
#line 1106 "SpringAnimation.c"
	}
#line 169 "../lib/Models/Animation/SpringAnimation.vala"
	if (beta > omega0) {
#line 1110 "SpringAnimation.c"
		gdouble omega2 = 0.0;
		gdouble _tmp15_;
#line 170 "../lib/Models/Animation/SpringAnimation.vala"
		omega2 = sqrt ((beta * beta) - (omega0 * omega0));
#line 172 "../lib/Models/Animation/SpringAnimation.vala"
		if (velocity != NULL) {
#line 1117 "SpringAnimation.c"
			gdouble _tmp14_;
#line 173 "../lib/Models/Animation/SpringAnimation.vala"
			_tmp14_ = envelope * ((v0 * cosh (omega2 * t)) + (((omega2 * x0) - ((((beta * beta) * x0) + (beta * v0)) / omega2)) * sinh (omega2 * t)));
#line 173 "../lib/Models/Animation/SpringAnimation.vala"
			velocity = &_tmp14_;
#line 1123 "SpringAnimation.c"
		}
#line 175 "../lib/Models/Animation/SpringAnimation.vala"
		_tmp15_ = self->priv->_value_to;
#line 175 "../lib/Models/Animation/SpringAnimation.vala"
		result = _tmp15_ + (envelope * ((x0 * cosh (omega2 * t)) + ((((beta * x0) + v0) / omega2) * sinh (omega2 * t))));
#line 175 "../lib/Models/Animation/SpringAnimation.vala"
		return result;
#line 1131 "SpringAnimation.c"
	}
#line 179 "../lib/Models/Animation/SpringAnimation.vala"
	if (velocity != NULL) {
#line 1135 "SpringAnimation.c"
		gdouble _tmp16_;
#line 180 "../lib/Models/Animation/SpringAnimation.vala"
		_tmp16_ = (envelope * ((beta * x0) + v0)) * (1 - beta);
#line 180 "../lib/Models/Animation/SpringAnimation.vala"
		velocity = &_tmp16_;
#line 1141 "SpringAnimation.c"
	}
#line 181 "../lib/Models/Animation/SpringAnimation.vala"
	_tmp17_ = self->priv->_value_to;
#line 181 "../lib/Models/Animation/SpringAnimation.vala"
	result = _tmp17_ + (envelope * (x0 + (((beta * x0) + v0) * t)));
#line 181 "../lib/Models/Animation/SpringAnimation.vala"
	return result;
#line 1149 "SpringAnimation.c"
}

static guint
he_spring_animation_get_first_zero (HeSpringAnimation* self)
{
	guint i = 0U;
	gdouble y = 0.0;
	gdouble _tmp0_;
	guint result;
#line 184 "../lib/Models/Animation/SpringAnimation.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 187 "../lib/Models/Animation/SpringAnimation.vala"
	i = (guint) 1;
#line 188 "../lib/Models/Animation/SpringAnimation.vala"
	_tmp0_ = self->priv->_velocity;
#line 188 "../lib/Models/Animation/SpringAnimation.vala"
	y = he_spring_animation_oscillate (self, (gdouble) i, &_tmp0_);
#line 190 "../lib/Models/Animation/SpringAnimation.vala"
	while (TRUE) {
#line 1169 "SpringAnimation.c"
		gboolean _tmp1_ = FALSE;
		gboolean _tmp2_ = FALSE;
		gdouble _tmp3_;
		gdouble _tmp4_;
		guint _tmp12_;
		gdouble _tmp13_;
#line 190 "../lib/Models/Animation/SpringAnimation.vala"
		_tmp3_ = self->priv->_value_to;
#line 190 "../lib/Models/Animation/SpringAnimation.vala"
		_tmp4_ = self->priv->_value_from;
#line 190 "../lib/Models/Animation/SpringAnimation.vala"
		if ((_tmp3_ - _tmp4_) > ((gdouble) FLT_EPSILON)) {
#line 1182 "SpringAnimation.c"
			gdouble _tmp5_;
			gdouble _tmp6_;
#line 190 "../lib/Models/Animation/SpringAnimation.vala"
			_tmp5_ = self->priv->_value_to;
#line 190 "../lib/Models/Animation/SpringAnimation.vala"
			_tmp6_ = self->priv->_epsilon;
#line 190 "../lib/Models/Animation/SpringAnimation.vala"
			_tmp2_ = (_tmp5_ - y) > _tmp6_;
#line 1191 "SpringAnimation.c"
		} else {
#line 190 "../lib/Models/Animation/SpringAnimation.vala"
			_tmp2_ = FALSE;
#line 1195 "SpringAnimation.c"
		}
#line 190 "../lib/Models/Animation/SpringAnimation.vala"
		if (_tmp2_) {
#line 190 "../lib/Models/Animation/SpringAnimation.vala"
			_tmp1_ = TRUE;
#line 1201 "SpringAnimation.c"
		} else {
			gboolean _tmp7_ = FALSE;
			gdouble _tmp8_;
			gdouble _tmp9_;
#line 191 "../lib/Models/Animation/SpringAnimation.vala"
			_tmp8_ = self->priv->_value_from;
#line 191 "../lib/Models/Animation/SpringAnimation.vala"
			_tmp9_ = self->priv->_value_to;
#line 191 "../lib/Models/Animation/SpringAnimation.vala"
			if ((_tmp8_ - _tmp9_) > ((gdouble) FLT_EPSILON)) {
#line 1212 "SpringAnimation.c"
				gdouble _tmp10_;
				gdouble _tmp11_;
#line 191 "../lib/Models/Animation/SpringAnimation.vala"
				_tmp10_ = self->priv->_value_to;
#line 191 "../lib/Models/Animation/SpringAnimation.vala"
				_tmp11_ = self->priv->_epsilon;
#line 191 "../lib/Models/Animation/SpringAnimation.vala"
				_tmp7_ = (y - _tmp10_) > _tmp11_;
#line 1221 "SpringAnimation.c"
			} else {
#line 191 "../lib/Models/Animation/SpringAnimation.vala"
				_tmp7_ = FALSE;
#line 1225 "SpringAnimation.c"
			}
#line 191 "../lib/Models/Animation/SpringAnimation.vala"
			_tmp1_ = _tmp7_;
#line 1229 "SpringAnimation.c"
		}
#line 190 "../lib/Models/Animation/SpringAnimation.vala"
		if (!_tmp1_) {
#line 190 "../lib/Models/Animation/SpringAnimation.vala"
			break;
#line 1235 "SpringAnimation.c"
		}
#line 192 "../lib/Models/Animation/SpringAnimation.vala"
		if (i > ((guint) 200000)) {
#line 193 "../lib/Models/Animation/SpringAnimation.vala"
			result = (guint) 0;
#line 193 "../lib/Models/Animation/SpringAnimation.vala"
			return result;
#line 1243 "SpringAnimation.c"
		}
#line 195 "../lib/Models/Animation/SpringAnimation.vala"
		i = i + 1;
#line 195 "../lib/Models/Animation/SpringAnimation.vala"
		_tmp12_ = i;
#line 195 "../lib/Models/Animation/SpringAnimation.vala"
		_tmp13_ = self->priv->_velocity;
#line 195 "../lib/Models/Animation/SpringAnimation.vala"
		y = he_spring_animation_oscillate (self, (gdouble) _tmp12_, &_tmp13_);
#line 1253 "SpringAnimation.c"
	}
#line 198 "../lib/Models/Animation/SpringAnimation.vala"
	result = i;
#line 198 "../lib/Models/Animation/SpringAnimation.vala"
	return result;
#line 1259 "SpringAnimation.c"
}

static void
he_spring_animation_class_init (HeSpringAnimationClass * klass,
                                gpointer klass_data)
{
#line 30 "../lib/Models/Animation/SpringAnimation.vala"
	he_spring_animation_parent_class = g_type_class_peek_parent (klass);
#line 30 "../lib/Models/Animation/SpringAnimation.vala"
	g_type_class_adjust_private_offset (klass, &HeSpringAnimation_private_offset);
#line 30 "../lib/Models/Animation/SpringAnimation.vala"
	((HeAnimationClass *) klass)->estimate_duration = (guint (*) (HeAnimation*)) he_spring_animation_real_estimate_duration;
#line 30 "../lib/Models/Animation/SpringAnimation.vala"
	((HeAnimationClass *) klass)->calculate_value = (gdouble (*) (HeAnimation*, guint)) he_spring_animation_real_calculate_value;
#line 30 "../lib/Models/Animation/SpringAnimation.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_he_spring_animation_get_property;
#line 30 "../lib/Models/Animation/SpringAnimation.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_he_spring_animation_set_property;
#line 30 "../lib/Models/Animation/SpringAnimation.vala"
	G_OBJECT_CLASS (klass)->finalize = he_spring_animation_finalize;
#line 30 "../lib/Models/Animation/SpringAnimation.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_SPRING_ANIMATION_EPSILON_PROPERTY, he_spring_animation_properties[HE_SPRING_ANIMATION_EPSILON_PROPERTY] = g_param_spec_double ("epsilon", "epsilon", "epsilon", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../lib/Models/Animation/SpringAnimation.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_SPRING_ANIMATION_ESTIMATED_DURATION_PROPERTY, he_spring_animation_properties[HE_SPRING_ANIMATION_ESTIMATED_DURATION_PROPERTY] = g_param_spec_uint ("estimated-duration", "estimated-duration", "estimated-duration", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../lib/Models/Animation/SpringAnimation.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_SPRING_ANIMATION_INITIAL_VELOCITY_PROPERTY, he_spring_animation_properties[HE_SPRING_ANIMATION_INITIAL_VELOCITY_PROPERTY] = g_param_spec_double ("initial-velocity", "initial-velocity", "initial-velocity", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../lib/Models/Animation/SpringAnimation.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_SPRING_ANIMATION_LATCH_PROPERTY, he_spring_animation_properties[HE_SPRING_ANIMATION_LATCH_PROPERTY] = g_param_spec_boolean ("latch", "latch", "latch", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../lib/Models/Animation/SpringAnimation.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_SPRING_ANIMATION_SPRING_PARAMS_PROPERTY, he_spring_animation_properties[HE_SPRING_ANIMATION_SPRING_PARAMS_PROPERTY] = g_param_spec_object ("spring-params", "spring-params", "spring-params", HE_TYPE_SPRING_PARAMS, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 30 "../lib/Models/Animation/SpringAnimation.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_SPRING_ANIMATION_VALUE_FROM_PROPERTY, he_spring_animation_properties[HE_SPRING_ANIMATION_VALUE_FROM_PROPERTY] = g_param_spec_double ("value-from", "value-from", "value-from", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 30 "../lib/Models/Animation/SpringAnimation.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_SPRING_ANIMATION_VALUE_TO_PROPERTY, he_spring_animation_properties[HE_SPRING_ANIMATION_VALUE_TO_PROPERTY] = g_param_spec_double ("value-to", "value-to", "value-to", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 30 "../lib/Models/Animation/SpringAnimation.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_SPRING_ANIMATION_VELOCITY_PROPERTY, he_spring_animation_properties[HE_SPRING_ANIMATION_VELOCITY_PROPERTY] = g_param_spec_double ("velocity", "velocity", "velocity", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1296 "SpringAnimation.c"
}

static void
he_spring_animation_instance_init (HeSpringAnimation * self,
                                   gpointer klass)
{
#line 30 "../lib/Models/Animation/SpringAnimation.vala"
	self->priv = he_spring_animation_get_instance_private (self);
#line 1305 "SpringAnimation.c"
}

static void
he_spring_animation_finalize (GObject * obj)
{
	HeSpringAnimation * self;
#line 30 "../lib/Models/Animation/SpringAnimation.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_SPRING_ANIMATION, HeSpringAnimation);
#line 35 "../lib/Models/Animation/SpringAnimation.vala"
	_g_object_unref0 (self->priv->_spring_params);
#line 30 "../lib/Models/Animation/SpringAnimation.vala"
	G_OBJECT_CLASS (he_spring_animation_parent_class)->finalize (obj);
#line 1318 "SpringAnimation.c"
}

static GType
he_spring_animation_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HeSpringAnimationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) he_spring_animation_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HeSpringAnimation), 0, (GInstanceInitFunc) he_spring_animation_instance_init, NULL };
	GType he_spring_animation_type_id;
	he_spring_animation_type_id = g_type_register_static (HE_TYPE_ANIMATION, "HeSpringAnimation", &g_define_type_info, 0);
	HeSpringAnimation_private_offset = g_type_add_instance_private (he_spring_animation_type_id, sizeof (HeSpringAnimationPrivate));
	return he_spring_animation_type_id;
}

GType
he_spring_animation_get_type (void)
{
	static volatile gsize he_spring_animation_type_id__once = 0;
	if (g_once_init_enter (&he_spring_animation_type_id__once)) {
		GType he_spring_animation_type_id;
		he_spring_animation_type_id = he_spring_animation_get_type_once ();
		g_once_init_leave (&he_spring_animation_type_id__once, he_spring_animation_type_id);
	}
	return he_spring_animation_type_id__once;
}

static void
_vala_he_spring_animation_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec)
{
	HeSpringAnimation * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_SPRING_ANIMATION, HeSpringAnimation);
#line 30 "../lib/Models/Animation/SpringAnimation.vala"
	switch (property_id) {
#line 30 "../lib/Models/Animation/SpringAnimation.vala"
		case HE_SPRING_ANIMATION_EPSILON_PROPERTY:
#line 30 "../lib/Models/Animation/SpringAnimation.vala"
		g_value_set_double (value, he_spring_animation_get_epsilon (self));
#line 30 "../lib/Models/Animation/SpringAnimation.vala"
		break;
#line 30 "../lib/Models/Animation/SpringAnimation.vala"
		case HE_SPRING_ANIMATION_ESTIMATED_DURATION_PROPERTY:
#line 30 "../lib/Models/Animation/SpringAnimation.vala"
		g_value_set_uint (value, he_spring_animation_get_estimated_duration (self));
#line 30 "../lib/Models/Animation/SpringAnimation.vala"
		break;
#line 30 "../lib/Models/Animation/SpringAnimation.vala"
		case HE_SPRING_ANIMATION_INITIAL_VELOCITY_PROPERTY:
#line 30 "../lib/Models/Animation/SpringAnimation.vala"
		g_value_set_double (value, he_spring_animation_get_initial_velocity (self));
#line 30 "../lib/Models/Animation/SpringAnimation.vala"
		break;
#line 30 "../lib/Models/Animation/SpringAnimation.vala"
		case HE_SPRING_ANIMATION_LATCH_PROPERTY:
#line 30 "../lib/Models/Animation/SpringAnimation.vala"
		g_value_set_boolean (value, he_spring_animation_get_latch (self));
#line 30 "../lib/Models/Animation/SpringAnimation.vala"
		break;
#line 30 "../lib/Models/Animation/SpringAnimation.vala"
		case HE_SPRING_ANIMATION_SPRING_PARAMS_PROPERTY:
#line 30 "../lib/Models/Animation/SpringAnimation.vala"
		g_value_set_object (value, he_spring_animation_get_spring_params (self));
#line 30 "../lib/Models/Animation/SpringAnimation.vala"
		break;
#line 30 "../lib/Models/Animation/SpringAnimation.vala"
		case HE_SPRING_ANIMATION_VALUE_FROM_PROPERTY:
#line 30 "../lib/Models/Animation/SpringAnimation.vala"
		g_value_set_double (value, he_spring_animation_get_value_from (self));
#line 30 "../lib/Models/Animation/SpringAnimation.vala"
		break;
#line 30 "../lib/Models/Animation/SpringAnimation.vala"
		case HE_SPRING_ANIMATION_VALUE_TO_PROPERTY:
#line 30 "../lib/Models/Animation/SpringAnimation.vala"
		g_value_set_double (value, he_spring_animation_get_value_to (self));
#line 30 "../lib/Models/Animation/SpringAnimation.vala"
		break;
#line 30 "../lib/Models/Animation/SpringAnimation.vala"
		case HE_SPRING_ANIMATION_VELOCITY_PROPERTY:
#line 30 "../lib/Models/Animation/SpringAnimation.vala"
		g_value_set_double (value, he_spring_animation_get_velocity (self));
#line 30 "../lib/Models/Animation/SpringAnimation.vala"
		break;
#line 1401 "SpringAnimation.c"
		default:
#line 30 "../lib/Models/Animation/SpringAnimation.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 30 "../lib/Models/Animation/SpringAnimation.vala"
		break;
#line 1407 "SpringAnimation.c"
	}
}

static void
_vala_he_spring_animation_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec)
{
	HeSpringAnimation * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_SPRING_ANIMATION, HeSpringAnimation);
#line 30 "../lib/Models/Animation/SpringAnimation.vala"
	switch (property_id) {
#line 30 "../lib/Models/Animation/SpringAnimation.vala"
		case HE_SPRING_ANIMATION_EPSILON_PROPERTY:
#line 30 "../lib/Models/Animation/SpringAnimation.vala"
		he_spring_animation_set_epsilon (self, g_value_get_double (value));
#line 30 "../lib/Models/Animation/SpringAnimation.vala"
		break;
#line 30 "../lib/Models/Animation/SpringAnimation.vala"
		case HE_SPRING_ANIMATION_ESTIMATED_DURATION_PROPERTY:
#line 30 "../lib/Models/Animation/SpringAnimation.vala"
		he_spring_animation_set_estimated_duration (self, g_value_get_uint (value));
#line 30 "../lib/Models/Animation/SpringAnimation.vala"
		break;
#line 30 "../lib/Models/Animation/SpringAnimation.vala"
		case HE_SPRING_ANIMATION_INITIAL_VELOCITY_PROPERTY:
#line 30 "../lib/Models/Animation/SpringAnimation.vala"
		he_spring_animation_set_initial_velocity (self, g_value_get_double (value));
#line 30 "../lib/Models/Animation/SpringAnimation.vala"
		break;
#line 30 "../lib/Models/Animation/SpringAnimation.vala"
		case HE_SPRING_ANIMATION_LATCH_PROPERTY:
#line 30 "../lib/Models/Animation/SpringAnimation.vala"
		he_spring_animation_set_latch (self, g_value_get_boolean (value));
#line 30 "../lib/Models/Animation/SpringAnimation.vala"
		break;
#line 30 "../lib/Models/Animation/SpringAnimation.vala"
		case HE_SPRING_ANIMATION_SPRING_PARAMS_PROPERTY:
#line 30 "../lib/Models/Animation/SpringAnimation.vala"
		he_spring_animation_set_spring_params (self, g_value_get_object (value));
#line 30 "../lib/Models/Animation/SpringAnimation.vala"
		break;
#line 30 "../lib/Models/Animation/SpringAnimation.vala"
		case HE_SPRING_ANIMATION_VALUE_FROM_PROPERTY:
#line 30 "../lib/Models/Animation/SpringAnimation.vala"
		he_spring_animation_set_value_from (self, g_value_get_double (value));
#line 30 "../lib/Models/Animation/SpringAnimation.vala"
		break;
#line 30 "../lib/Models/Animation/SpringAnimation.vala"
		case HE_SPRING_ANIMATION_VALUE_TO_PROPERTY:
#line 30 "../lib/Models/Animation/SpringAnimation.vala"
		he_spring_animation_set_value_to (self, g_value_get_double (value));
#line 30 "../lib/Models/Animation/SpringAnimation.vala"
		break;
#line 30 "../lib/Models/Animation/SpringAnimation.vala"
		case HE_SPRING_ANIMATION_VELOCITY_PROPERTY:
#line 30 "../lib/Models/Animation/SpringAnimation.vala"
		he_spring_animation_set_velocity (self, g_value_get_double (value));
#line 30 "../lib/Models/Animation/SpringAnimation.vala"
		break;
#line 1469 "SpringAnimation.c"
		default:
#line 30 "../lib/Models/Animation/SpringAnimation.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 30 "../lib/Models/Animation/SpringAnimation.vala"
		break;
#line 1475 "SpringAnimation.c"
	}
}

