/* StyleManager.c generated by valac 0.56.18, the Vala compiler
 * generated from StyleManager.vala, do not modify */

/*
 * Copyright (c) 2023 Fyra Labs
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 */

#include "libhelium-1.h"
#include <glib.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <glib-object.h>

#define HE_STYLE_MANAGER_STYLE_PROVIDER_PRIORITY_PLATFORM GTK_STYLE_PROVIDER_PRIORITY_THEME
#define HE_STYLE_MANAGER_STYLE_PROVIDER_PRIORITY_ACCENT GTK_STYLE_PROVIDER_PRIORITY_SETTINGS
#define HE_STYLE_MANAGER_STYLE_PROVIDER_PRIORITY_USER_BASE GTK_STYLE_PROVIDER_PRIORITY_APPLICATION
#define HE_STYLE_MANAGER_STYLE_PROVIDER_PRIORITY_USER_DARK (GTK_STYLE_PROVIDER_PRIORITY_APPLICATION + 1)
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	HE_STYLE_MANAGER_0_PROPERTY,
	HE_STYLE_MANAGER_IS_REGISTERED_PROPERTY,
	HE_STYLE_MANAGER_USER_BASE_PROPERTY,
	HE_STYLE_MANAGER_USER_DARK_PROPERTY,
	HE_STYLE_MANAGER_NUM_PROPERTIES
};
static GParamSpec* he_style_manager_properties[HE_STYLE_MANAGER_NUM_PROPERTIES];
#define _he_rgb_color_free0(var) ((var == NULL) ? NULL : (var = (he_rgb_color_free (var), NULL)))
#define _g_free0(var) ((var == NULL) ? NULL : (var = (g_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _HeStyleManagerPrivate {
	gboolean _is_registered;
	GtkCssProvider* light;
	GtkCssProvider* dark;
	GtkCssProvider* accent;
	GtkCssProvider* _user_base;
	GtkCssProvider* _user_dark;
};

static gint HeStyleManager_private_offset;
static gpointer he_style_manager_parent_class = NULL;

static void he_style_manager_set_is_registered (HeStyleManager* self,
                                         gboolean value);
static gboolean _he_scheme_variant_equal (const HeSchemeVariant * s1,
                                   const HeSchemeVariant * s2);
static gchar* he_style_manager_roundness_refresh (HeStyleManager* self,
                                           gdouble roundness);
VALA_EXTERN void he_misc_init_css_provider_from_string (GtkCssProvider* provider,
                                            const gchar* css);
VALA_EXTERN void he_misc_toggle_style_provider (GtkStyleProvider* provider,
                                    gboolean enabled,
                                    gint priority);
static void he_style_manager_finalize (GObject * obj);
static GType he_style_manager_get_type_once (void);
static void _vala_he_style_manager_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec);
static void _vala_he_style_manager_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec);

VALA_EXTERN const HeRGBColor HE_DEFAULT_DARK_ACCENT;
VALA_EXTERN const HeRGBColor HE_DEFAULT_LIGHT_ACCENT;

static inline gpointer
he_style_manager_get_instance_private (HeStyleManager* self)
{
	return G_STRUCT_MEMBER_P (self, HeStyleManager_private_offset);
}

gboolean
he_style_manager_get_is_registered (HeStyleManager* self)
{
	gboolean result;
#line 59 "../lib/Models/StyleManager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 59 "../lib/Models/StyleManager.vala"
	result = self->priv->_is_registered;
#line 59 "../lib/Models/StyleManager.vala"
	return result;
#line 111 "StyleManager.c"
}

static void
he_style_manager_set_is_registered (HeStyleManager* self,
                                    gboolean value)
{
	gboolean old_value;
#line 59 "../lib/Models/StyleManager.vala"
	g_return_if_fail (self != NULL);
#line 59 "../lib/Models/StyleManager.vala"
	old_value = he_style_manager_get_is_registered (self);
#line 59 "../lib/Models/StyleManager.vala"
	if (old_value != value) {
#line 59 "../lib/Models/StyleManager.vala"
		self->priv->_is_registered = value;
#line 59 "../lib/Models/StyleManager.vala"
		g_object_notify_by_pspec ((GObject *) self, he_style_manager_properties[HE_STYLE_MANAGER_IS_REGISTERED_PROPERTY]);
#line 129 "StyleManager.c"
	}
}

GtkCssProvider*
he_style_manager_get_user_base (HeStyleManager* self)
{
	GtkCssProvider* result;
	GtkCssProvider* _tmp0_;
#line 73 "../lib/Models/StyleManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 73 "../lib/Models/StyleManager.vala"
	_tmp0_ = self->priv->_user_base;
#line 73 "../lib/Models/StyleManager.vala"
	result = _tmp0_;
#line 73 "../lib/Models/StyleManager.vala"
	return result;
#line 146 "StyleManager.c"
}

GtkCssProvider*
he_style_manager_get_user_dark (HeStyleManager* self)
{
	GtkCssProvider* result;
	GtkCssProvider* _tmp0_;
#line 77 "../lib/Models/StyleManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 77 "../lib/Models/StyleManager.vala"
	_tmp0_ = self->priv->_user_dark;
#line 77 "../lib/Models/StyleManager.vala"
	result = _tmp0_;
#line 77 "../lib/Models/StyleManager.vala"
	return result;
#line 162 "StyleManager.c"
}

/**
   * Runs all the necessary updates to apply the current style. If is_registered is false, this will do nothing.
   */
static gboolean
_he_scheme_variant_equal (const HeSchemeVariant * s1,
                          const HeSchemeVariant * s2)
{
#line 89 "../lib/Models/StyleManager.vala"
	if (s1 == s2) {
#line 89 "../lib/Models/StyleManager.vala"
		return TRUE;
#line 176 "StyleManager.c"
	}
#line 89 "../lib/Models/StyleManager.vala"
	if (s1 == NULL) {
#line 89 "../lib/Models/StyleManager.vala"
		return FALSE;
#line 182 "StyleManager.c"
	}
#line 89 "../lib/Models/StyleManager.vala"
	if (s2 == NULL) {
#line 89 "../lib/Models/StyleManager.vala"
		return FALSE;
#line 188 "StyleManager.c"
	}
#line 89 "../lib/Models/StyleManager.vala"
	return (*s1) == (*s2);
#line 192 "StyleManager.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 134 "../lib/Models/StyleManager.vala"
	return self ? g_object_ref (self) : NULL;
#line 200 "StyleManager.c"
}

void
he_style_manager_update (HeStyleManager* self)
{
	gboolean _tmp0_;
	HeRGBColor* _tmp1_ = NULL;
	HeRGBColor* _tmp2_;
	HeRGBColor rgb_color = {0};
	gchar* css = NULL;
	gchar* _tmp5_;
	HeSchemeVariant* _tmp6_;
	HeSchemeVariant _tmp7_;
	const gchar* _tmp104_;
	gchar* _tmp105_;
	gchar* _tmp106_;
	gchar* _tmp107_;
	const gchar* _tmp108_;
	gchar* _tmp109_;
	gchar* _tmp110_;
	gchar* _tmp111_;
	GtkCssProvider* _tmp112_;
	const gchar* _tmp113_;
	GtkCssProvider* _tmp114_;
	GtkCssProvider* _tmp115_;
	GtkCssProvider* _tmp116_;
	GtkSettings* settings = NULL;
	GtkSettings* _tmp117_;
	GtkSettings* _tmp118_;
	GtkSettings* _tmp119_;
#line 82 "../lib/Models/StyleManager.vala"
	g_return_if_fail (self != NULL);
#line 83 "../lib/Models/StyleManager.vala"
	_tmp0_ = self->priv->_is_registered;
#line 83 "../lib/Models/StyleManager.vala"
	if (!_tmp0_) {
#line 84 "../lib/Models/StyleManager.vala"
		return;
#line 239 "StyleManager.c"
	}
#line 86 "../lib/Models/StyleManager.vala"
	_tmp2_ = self->accent_color;
#line 86 "../lib/Models/StyleManager.vala"
	if (_tmp2_ != NULL) {
#line 245 "StyleManager.c"
		HeRGBColor* _tmp3_;
#line 86 "../lib/Models/StyleManager.vala"
		_tmp3_ = self->accent_color;
#line 86 "../lib/Models/StyleManager.vala"
		_tmp1_ = _tmp3_;
#line 251 "StyleManager.c"
	} else {
		HeRGBColor _tmp4_ = {0};
#line 86 "../lib/Models/StyleManager.vala"
		if (self->is_dark) {
#line 86 "../lib/Models/StyleManager.vala"
			_tmp4_ = HE_DEFAULT_DARK_ACCENT;
#line 258 "StyleManager.c"
		} else {
#line 86 "../lib/Models/StyleManager.vala"
			_tmp4_ = HE_DEFAULT_LIGHT_ACCENT;
#line 262 "StyleManager.c"
		}
#line 86 "../lib/Models/StyleManager.vala"
		_tmp1_ = &_tmp4_;
#line 266 "StyleManager.c"
	}
#line 86 "../lib/Models/StyleManager.vala"
	rgb_color = *_tmp1_;
#line 88 "../lib/Models/StyleManager.vala"
	_tmp5_ = g_strdup ("");
#line 88 "../lib/Models/StyleManager.vala"
	css = _tmp5_;
#line 89 "../lib/Models/StyleManager.vala"
	_tmp6_ = self->scheme_variant;
#line 89 "../lib/Models/StyleManager.vala"
	_tmp7_ = HE_SCHEME_VARIANT_DEFAULT;
#line 89 "../lib/Models/StyleManager.vala"
	if (_he_scheme_variant_equal (_tmp6_, &_tmp7_) == TRUE) {
#line 280 "StyleManager.c"
		HeRGBColor accent_color = {0};
		HeRGBColor _tmp8_;
		HeRGBColor _tmp9_;
		HeRGBColor _tmp10_;
		HeRGBColor _tmp11_ = {0};
		HeHCTColor hct = {0};
		HeRGBColor _tmp12_;
		HeHCTColor _tmp13_ = {0};
		HeDefaultScheme* scheme_factory = NULL;
		HeDefaultScheme* _tmp14_;
		const gchar* _tmp15_;
		HeDefaultScheme* _tmp16_;
		HeHCTColor _tmp17_;
		HeDynamicScheme* _tmp18_;
		HeDynamicScheme* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
#line 90 "../lib/Models/StyleManager.vala"
		_tmp8_ = rgb_color;
#line 90 "../lib/Models/StyleManager.vala"
		_tmp9_ = rgb_color;
#line 90 "../lib/Models/StyleManager.vala"
		_tmp10_ = rgb_color;
#line 90 "../lib/Models/StyleManager.vala"
		_tmp11_.r = _tmp8_.r * 255;
#line 90 "../lib/Models/StyleManager.vala"
		_tmp11_.g = _tmp9_.g * 255;
#line 90 "../lib/Models/StyleManager.vala"
		_tmp11_.b = _tmp10_.b * 255;
#line 90 "../lib/Models/StyleManager.vala"
		accent_color = _tmp11_;
#line 91 "../lib/Models/StyleManager.vala"
		_tmp12_ = accent_color;
#line 91 "../lib/Models/StyleManager.vala"
		he_hct_from_int (he_rgb_to_argb_int (&_tmp12_), &_tmp13_);
#line 91 "../lib/Models/StyleManager.vala"
		hct = _tmp13_;
#line 93 "../lib/Models/StyleManager.vala"
		_tmp14_ = he_default_scheme_new ();
#line 93 "../lib/Models/StyleManager.vala"
		scheme_factory = _tmp14_;
#line 94 "../lib/Models/StyleManager.vala"
		_tmp15_ = css;
#line 94 "../lib/Models/StyleManager.vala"
		_tmp16_ = scheme_factory;
#line 94 "../lib/Models/StyleManager.vala"
		_tmp17_ = hct;
#line 94 "../lib/Models/StyleManager.vala"
		_tmp18_ = he_default_scheme_generate (_tmp16_, &_tmp17_, self->is_dark, self->contrast);
#line 94 "../lib/Models/StyleManager.vala"
		_tmp19_ = _tmp18_;
#line 94 "../lib/Models/StyleManager.vala"
		_tmp20_ = he_style_manager_style_refresh (self, _tmp19_);
#line 94 "../lib/Models/StyleManager.vala"
		_tmp21_ = _tmp20_;
#line 94 "../lib/Models/StyleManager.vala"
		_tmp22_ = g_strconcat (_tmp15_, _tmp21_, NULL);
#line 94 "../lib/Models/StyleManager.vala"
		_g_free0 (css);
#line 94 "../lib/Models/StyleManager.vala"
		css = _tmp22_;
#line 94 "../lib/Models/StyleManager.vala"
		_g_free0 (_tmp21_);
#line 94 "../lib/Models/StyleManager.vala"
		_g_object_unref0 (_tmp19_);
#line 89 "../lib/Models/StyleManager.vala"
		_g_object_unref0 (scheme_factory);
#line 349 "StyleManager.c"
	} else {
		HeSchemeVariant* _tmp23_;
		HeSchemeVariant _tmp24_;
#line 95 "../lib/Models/StyleManager.vala"
		_tmp23_ = self->scheme_variant;
#line 95 "../lib/Models/StyleManager.vala"
		_tmp24_ = HE_SCHEME_VARIANT_MONOCHROME;
#line 95 "../lib/Models/StyleManager.vala"
		if (_he_scheme_variant_equal (_tmp23_, &_tmp24_) == TRUE) {
#line 359 "StyleManager.c"
			HeRGBColor accent_color = {0};
			HeRGBColor* _tmp25_;
			HeRGBColor* _tmp26_;
			HeRGBColor* _tmp27_;
			HeRGBColor _tmp28_ = {0};
			HeHCTColor hct = {0};
			HeRGBColor _tmp29_;
			HeHCTColor _tmp30_ = {0};
			HeMonochromaticScheme* scheme_factory = NULL;
			HeMonochromaticScheme* _tmp31_;
			const gchar* _tmp32_;
			HeMonochromaticScheme* _tmp33_;
			HeHCTColor _tmp34_;
			HeDynamicScheme* _tmp35_;
			HeDynamicScheme* _tmp36_;
			gchar* _tmp37_;
			gchar* _tmp38_;
			gchar* _tmp39_;
#line 96 "../lib/Models/StyleManager.vala"
			_tmp25_ = self->accent_color;
#line 96 "../lib/Models/StyleManager.vala"
			_tmp26_ = self->accent_color;
#line 96 "../lib/Models/StyleManager.vala"
			_tmp27_ = self->accent_color;
#line 96 "../lib/Models/StyleManager.vala"
			_tmp28_.r = (*_tmp25_).r * 255;
#line 96 "../lib/Models/StyleManager.vala"
			_tmp28_.g = (*_tmp26_).g * 255;
#line 96 "../lib/Models/StyleManager.vala"
			_tmp28_.b = (*_tmp27_).b * 255;
#line 96 "../lib/Models/StyleManager.vala"
			accent_color = _tmp28_;
#line 97 "../lib/Models/StyleManager.vala"
			_tmp29_ = accent_color;
#line 97 "../lib/Models/StyleManager.vala"
			he_hct_from_int (he_rgb_to_argb_int (&_tmp29_), &_tmp30_);
#line 97 "../lib/Models/StyleManager.vala"
			hct = _tmp30_;
#line 99 "../lib/Models/StyleManager.vala"
			_tmp31_ = he_monochromatic_scheme_new ();
#line 99 "../lib/Models/StyleManager.vala"
			scheme_factory = _tmp31_;
#line 100 "../lib/Models/StyleManager.vala"
			_tmp32_ = css;
#line 100 "../lib/Models/StyleManager.vala"
			_tmp33_ = scheme_factory;
#line 100 "../lib/Models/StyleManager.vala"
			_tmp34_ = hct;
#line 100 "../lib/Models/StyleManager.vala"
			_tmp35_ = he_monochromatic_scheme_generate (_tmp33_, &_tmp34_, self->is_dark, self->contrast);
#line 100 "../lib/Models/StyleManager.vala"
			_tmp36_ = _tmp35_;
#line 100 "../lib/Models/StyleManager.vala"
			_tmp37_ = he_style_manager_style_refresh (self, _tmp36_);
#line 100 "../lib/Models/StyleManager.vala"
			_tmp38_ = _tmp37_;
#line 100 "../lib/Models/StyleManager.vala"
			_tmp39_ = g_strconcat (_tmp32_, _tmp38_, NULL);
#line 100 "../lib/Models/StyleManager.vala"
			_g_free0 (css);
#line 100 "../lib/Models/StyleManager.vala"
			css = _tmp39_;
#line 100 "../lib/Models/StyleManager.vala"
			_g_free0 (_tmp38_);
#line 100 "../lib/Models/StyleManager.vala"
			_g_object_unref0 (_tmp36_);
#line 95 "../lib/Models/StyleManager.vala"
			_g_object_unref0 (scheme_factory);
#line 428 "StyleManager.c"
		} else {
			HeSchemeVariant* _tmp40_;
			HeSchemeVariant _tmp41_;
#line 101 "../lib/Models/StyleManager.vala"
			_tmp40_ = self->scheme_variant;
#line 101 "../lib/Models/StyleManager.vala"
			_tmp41_ = HE_SCHEME_VARIANT_MUTED;
#line 101 "../lib/Models/StyleManager.vala"
			if (_he_scheme_variant_equal (_tmp40_, &_tmp41_) == TRUE) {
#line 438 "StyleManager.c"
				HeRGBColor accent_color = {0};
				HeRGBColor* _tmp42_;
				HeRGBColor* _tmp43_;
				HeRGBColor* _tmp44_;
				HeRGBColor _tmp45_ = {0};
				HeHCTColor hct = {0};
				HeRGBColor _tmp46_;
				HeHCTColor _tmp47_ = {0};
				HeMutedScheme* scheme_factory = NULL;
				HeMutedScheme* _tmp48_;
				const gchar* _tmp49_;
				HeMutedScheme* _tmp50_;
				HeHCTColor _tmp51_;
				HeDynamicScheme* _tmp52_;
				HeDynamicScheme* _tmp53_;
				gchar* _tmp54_;
				gchar* _tmp55_;
				gchar* _tmp56_;
#line 102 "../lib/Models/StyleManager.vala"
				_tmp42_ = self->accent_color;
#line 102 "../lib/Models/StyleManager.vala"
				_tmp43_ = self->accent_color;
#line 102 "../lib/Models/StyleManager.vala"
				_tmp44_ = self->accent_color;
#line 102 "../lib/Models/StyleManager.vala"
				_tmp45_.r = (*_tmp42_).r * 255;
#line 102 "../lib/Models/StyleManager.vala"
				_tmp45_.g = (*_tmp43_).g * 255;
#line 102 "../lib/Models/StyleManager.vala"
				_tmp45_.b = (*_tmp44_).b * 255;
#line 102 "../lib/Models/StyleManager.vala"
				accent_color = _tmp45_;
#line 103 "../lib/Models/StyleManager.vala"
				_tmp46_ = accent_color;
#line 103 "../lib/Models/StyleManager.vala"
				he_hct_from_int (he_rgb_to_argb_int (&_tmp46_), &_tmp47_);
#line 103 "../lib/Models/StyleManager.vala"
				hct = _tmp47_;
#line 105 "../lib/Models/StyleManager.vala"
				_tmp48_ = he_muted_scheme_new ();
#line 105 "../lib/Models/StyleManager.vala"
				scheme_factory = _tmp48_;
#line 106 "../lib/Models/StyleManager.vala"
				_tmp49_ = css;
#line 106 "../lib/Models/StyleManager.vala"
				_tmp50_ = scheme_factory;
#line 106 "../lib/Models/StyleManager.vala"
				_tmp51_ = hct;
#line 106 "../lib/Models/StyleManager.vala"
				_tmp52_ = he_muted_scheme_generate (_tmp50_, &_tmp51_, self->is_dark, self->contrast);
#line 106 "../lib/Models/StyleManager.vala"
				_tmp53_ = _tmp52_;
#line 106 "../lib/Models/StyleManager.vala"
				_tmp54_ = he_style_manager_style_refresh (self, _tmp53_);
#line 106 "../lib/Models/StyleManager.vala"
				_tmp55_ = _tmp54_;
#line 106 "../lib/Models/StyleManager.vala"
				_tmp56_ = g_strconcat (_tmp49_, _tmp55_, NULL);
#line 106 "../lib/Models/StyleManager.vala"
				_g_free0 (css);
#line 106 "../lib/Models/StyleManager.vala"
				css = _tmp56_;
#line 106 "../lib/Models/StyleManager.vala"
				_g_free0 (_tmp55_);
#line 106 "../lib/Models/StyleManager.vala"
				_g_object_unref0 (_tmp53_);
#line 101 "../lib/Models/StyleManager.vala"
				_g_object_unref0 (scheme_factory);
#line 507 "StyleManager.c"
			} else {
				HeSchemeVariant* _tmp57_;
				HeSchemeVariant _tmp58_;
#line 107 "../lib/Models/StyleManager.vala"
				_tmp57_ = self->scheme_variant;
#line 107 "../lib/Models/StyleManager.vala"
				_tmp58_ = HE_SCHEME_VARIANT_SALAD;
#line 107 "../lib/Models/StyleManager.vala"
				if (_he_scheme_variant_equal (_tmp57_, &_tmp58_) == TRUE) {
#line 517 "StyleManager.c"
					HeRGBColor accent_color = {0};
					HeRGBColor* _tmp59_;
					HeRGBColor* _tmp60_;
					HeRGBColor* _tmp61_;
					HeRGBColor _tmp62_ = {0};
					HeHCTColor hct = {0};
					HeRGBColor _tmp63_;
					HeHCTColor _tmp64_ = {0};
					HeSaladScheme* scheme_factory = NULL;
					HeSaladScheme* _tmp65_;
					const gchar* _tmp66_;
					HeSaladScheme* _tmp67_;
					HeHCTColor _tmp68_;
					HeDynamicScheme* _tmp69_;
					HeDynamicScheme* _tmp70_;
					gchar* _tmp71_;
					gchar* _tmp72_;
					gchar* _tmp73_;
#line 108 "../lib/Models/StyleManager.vala"
					_tmp59_ = self->accent_color;
#line 108 "../lib/Models/StyleManager.vala"
					_tmp60_ = self->accent_color;
#line 108 "../lib/Models/StyleManager.vala"
					_tmp61_ = self->accent_color;
#line 108 "../lib/Models/StyleManager.vala"
					_tmp62_.r = (*_tmp59_).r * 255;
#line 108 "../lib/Models/StyleManager.vala"
					_tmp62_.g = (*_tmp60_).g * 255;
#line 108 "../lib/Models/StyleManager.vala"
					_tmp62_.b = (*_tmp61_).b * 255;
#line 108 "../lib/Models/StyleManager.vala"
					accent_color = _tmp62_;
#line 109 "../lib/Models/StyleManager.vala"
					_tmp63_ = accent_color;
#line 109 "../lib/Models/StyleManager.vala"
					he_hct_from_int (he_rgb_to_argb_int (&_tmp63_), &_tmp64_);
#line 109 "../lib/Models/StyleManager.vala"
					hct = _tmp64_;
#line 111 "../lib/Models/StyleManager.vala"
					_tmp65_ = he_salad_scheme_new ();
#line 111 "../lib/Models/StyleManager.vala"
					scheme_factory = _tmp65_;
#line 112 "../lib/Models/StyleManager.vala"
					_tmp66_ = css;
#line 112 "../lib/Models/StyleManager.vala"
					_tmp67_ = scheme_factory;
#line 112 "../lib/Models/StyleManager.vala"
					_tmp68_ = hct;
#line 112 "../lib/Models/StyleManager.vala"
					_tmp69_ = he_salad_scheme_generate (_tmp67_, &_tmp68_, self->is_dark, self->contrast);
#line 112 "../lib/Models/StyleManager.vala"
					_tmp70_ = _tmp69_;
#line 112 "../lib/Models/StyleManager.vala"
					_tmp71_ = he_style_manager_style_refresh (self, _tmp70_);
#line 112 "../lib/Models/StyleManager.vala"
					_tmp72_ = _tmp71_;
#line 112 "../lib/Models/StyleManager.vala"
					_tmp73_ = g_strconcat (_tmp66_, _tmp72_, NULL);
#line 112 "../lib/Models/StyleManager.vala"
					_g_free0 (css);
#line 112 "../lib/Models/StyleManager.vala"
					css = _tmp73_;
#line 112 "../lib/Models/StyleManager.vala"
					_g_free0 (_tmp72_);
#line 112 "../lib/Models/StyleManager.vala"
					_g_object_unref0 (_tmp70_);
#line 107 "../lib/Models/StyleManager.vala"
					_g_object_unref0 (scheme_factory);
#line 586 "StyleManager.c"
				} else {
					HeSchemeVariant* _tmp74_;
					HeSchemeVariant _tmp75_;
#line 113 "../lib/Models/StyleManager.vala"
					_tmp74_ = self->scheme_variant;
#line 113 "../lib/Models/StyleManager.vala"
					_tmp75_ = HE_SCHEME_VARIANT_VIBRANT;
#line 113 "../lib/Models/StyleManager.vala"
					if (_he_scheme_variant_equal (_tmp74_, &_tmp75_) == TRUE) {
#line 596 "StyleManager.c"
						HeRGBColor accent_color = {0};
						HeRGBColor* _tmp76_;
						HeRGBColor* _tmp77_;
						HeRGBColor* _tmp78_;
						HeRGBColor _tmp79_ = {0};
						HeHCTColor hct = {0};
						HeRGBColor _tmp80_;
						HeHCTColor _tmp81_ = {0};
						HeVibrantScheme* scheme_factory = NULL;
						HeVibrantScheme* _tmp82_;
						const gchar* _tmp83_;
						HeVibrantScheme* _tmp84_;
						HeHCTColor _tmp85_;
						HeDynamicScheme* _tmp86_;
						HeDynamicScheme* _tmp87_;
						gchar* _tmp88_;
						gchar* _tmp89_;
						gchar* _tmp90_;
#line 114 "../lib/Models/StyleManager.vala"
						_tmp76_ = self->accent_color;
#line 114 "../lib/Models/StyleManager.vala"
						_tmp77_ = self->accent_color;
#line 114 "../lib/Models/StyleManager.vala"
						_tmp78_ = self->accent_color;
#line 114 "../lib/Models/StyleManager.vala"
						_tmp79_.r = (*_tmp76_).r * 255;
#line 114 "../lib/Models/StyleManager.vala"
						_tmp79_.g = (*_tmp77_).g * 255;
#line 114 "../lib/Models/StyleManager.vala"
						_tmp79_.b = (*_tmp78_).b * 255;
#line 114 "../lib/Models/StyleManager.vala"
						accent_color = _tmp79_;
#line 115 "../lib/Models/StyleManager.vala"
						_tmp80_ = accent_color;
#line 115 "../lib/Models/StyleManager.vala"
						he_hct_from_int (he_rgb_to_argb_int (&_tmp80_), &_tmp81_);
#line 115 "../lib/Models/StyleManager.vala"
						hct = _tmp81_;
#line 117 "../lib/Models/StyleManager.vala"
						_tmp82_ = he_vibrant_scheme_new ();
#line 117 "../lib/Models/StyleManager.vala"
						scheme_factory = _tmp82_;
#line 118 "../lib/Models/StyleManager.vala"
						_tmp83_ = css;
#line 118 "../lib/Models/StyleManager.vala"
						_tmp84_ = scheme_factory;
#line 118 "../lib/Models/StyleManager.vala"
						_tmp85_ = hct;
#line 118 "../lib/Models/StyleManager.vala"
						_tmp86_ = he_vibrant_scheme_generate (_tmp84_, &_tmp85_, self->is_dark, self->contrast);
#line 118 "../lib/Models/StyleManager.vala"
						_tmp87_ = _tmp86_;
#line 118 "../lib/Models/StyleManager.vala"
						_tmp88_ = he_style_manager_style_refresh (self, _tmp87_);
#line 118 "../lib/Models/StyleManager.vala"
						_tmp89_ = _tmp88_;
#line 118 "../lib/Models/StyleManager.vala"
						_tmp90_ = g_strconcat (_tmp83_, _tmp89_, NULL);
#line 118 "../lib/Models/StyleManager.vala"
						_g_free0 (css);
#line 118 "../lib/Models/StyleManager.vala"
						css = _tmp90_;
#line 118 "../lib/Models/StyleManager.vala"
						_g_free0 (_tmp89_);
#line 118 "../lib/Models/StyleManager.vala"
						_g_object_unref0 (_tmp87_);
#line 113 "../lib/Models/StyleManager.vala"
						_g_object_unref0 (scheme_factory);
#line 665 "StyleManager.c"
					} else {
						HeSchemeVariant* _tmp91_;
						HeSchemeVariant _tmp92_;
#line 119 "../lib/Models/StyleManager.vala"
						_tmp91_ = self->scheme_variant;
#line 119 "../lib/Models/StyleManager.vala"
						_tmp92_ = HE_SCHEME_VARIANT_CONTENT;
#line 119 "../lib/Models/StyleManager.vala"
						if (_he_scheme_variant_equal (_tmp91_, &_tmp92_) == TRUE) {
#line 675 "StyleManager.c"
							HeHCTColor hct = {0};
							HeRGBColor _tmp93_;
							HeHCTColor _tmp94_ = {0};
							HeContentScheme* scheme_factory = NULL;
							HeContentScheme* _tmp95_;
							const gchar* _tmp96_;
							HeContentScheme* _tmp97_;
							HeHCTColor _tmp98_;
							HeDynamicScheme* _tmp99_;
							HeDynamicScheme* _tmp100_;
							gchar* _tmp101_;
							gchar* _tmp102_;
							gchar* _tmp103_;
#line 120 "../lib/Models/StyleManager.vala"
							_tmp93_ = rgb_color;
#line 120 "../lib/Models/StyleManager.vala"
							he_hct_from_int (he_rgb_to_argb_int (&_tmp93_), &_tmp94_);
#line 120 "../lib/Models/StyleManager.vala"
							hct = _tmp94_;
#line 122 "../lib/Models/StyleManager.vala"
							_tmp95_ = he_content_scheme_new ();
#line 122 "../lib/Models/StyleManager.vala"
							scheme_factory = _tmp95_;
#line 123 "../lib/Models/StyleManager.vala"
							_tmp96_ = css;
#line 123 "../lib/Models/StyleManager.vala"
							_tmp97_ = scheme_factory;
#line 123 "../lib/Models/StyleManager.vala"
							_tmp98_ = hct;
#line 123 "../lib/Models/StyleManager.vala"
							_tmp99_ = he_content_scheme_generate (_tmp97_, &_tmp98_, self->is_dark, self->contrast);
#line 123 "../lib/Models/StyleManager.vala"
							_tmp100_ = _tmp99_;
#line 123 "../lib/Models/StyleManager.vala"
							_tmp101_ = he_style_manager_style_refresh (self, _tmp100_);
#line 123 "../lib/Models/StyleManager.vala"
							_tmp102_ = _tmp101_;
#line 123 "../lib/Models/StyleManager.vala"
							_tmp103_ = g_strconcat (_tmp96_, _tmp102_, NULL);
#line 123 "../lib/Models/StyleManager.vala"
							_g_free0 (css);
#line 123 "../lib/Models/StyleManager.vala"
							css = _tmp103_;
#line 123 "../lib/Models/StyleManager.vala"
							_g_free0 (_tmp102_);
#line 123 "../lib/Models/StyleManager.vala"
							_g_object_unref0 (_tmp100_);
#line 119 "../lib/Models/StyleManager.vala"
							_g_object_unref0 (scheme_factory);
#line 725 "StyleManager.c"
						}
					}
				}
			}
		}
	}
#line 126 "../lib/Models/StyleManager.vala"
	_tmp104_ = css;
#line 126 "../lib/Models/StyleManager.vala"
	_tmp105_ = he_style_manager_weight_refresh (self, self->font_weight);
#line 126 "../lib/Models/StyleManager.vala"
	_tmp106_ = _tmp105_;
#line 126 "../lib/Models/StyleManager.vala"
	_tmp107_ = g_strconcat (_tmp104_, _tmp106_, NULL);
#line 126 "../lib/Models/StyleManager.vala"
	_g_free0 (css);
#line 126 "../lib/Models/StyleManager.vala"
	css = _tmp107_;
#line 126 "../lib/Models/StyleManager.vala"
	_g_free0 (_tmp106_);
#line 127 "../lib/Models/StyleManager.vala"
	_tmp108_ = css;
#line 127 "../lib/Models/StyleManager.vala"
	_tmp109_ = he_style_manager_roundness_refresh (self, self->roundness);
#line 127 "../lib/Models/StyleManager.vala"
	_tmp110_ = _tmp109_;
#line 127 "../lib/Models/StyleManager.vala"
	_tmp111_ = g_strconcat (_tmp108_, _tmp110_, NULL);
#line 127 "../lib/Models/StyleManager.vala"
	_g_free0 (css);
#line 127 "../lib/Models/StyleManager.vala"
	css = _tmp111_;
#line 127 "../lib/Models/StyleManager.vala"
	_g_free0 (_tmp110_);
#line 129 "../lib/Models/StyleManager.vala"
	_tmp112_ = self->priv->accent;
#line 129 "../lib/Models/StyleManager.vala"
	_tmp113_ = css;
#line 129 "../lib/Models/StyleManager.vala"
	he_misc_init_css_provider_from_string (_tmp112_, _tmp113_);
#line 130 "../lib/Models/StyleManager.vala"
	_tmp114_ = self->priv->light;
#line 130 "../lib/Models/StyleManager.vala"
	he_misc_toggle_style_provider ((GtkStyleProvider*) _tmp114_, !self->is_dark, HE_STYLE_MANAGER_STYLE_PROVIDER_PRIORITY_PLATFORM);
#line 131 "../lib/Models/StyleManager.vala"
	_tmp115_ = self->priv->dark;
#line 131 "../lib/Models/StyleManager.vala"
	he_misc_toggle_style_provider ((GtkStyleProvider*) _tmp115_, self->is_dark, HE_STYLE_MANAGER_STYLE_PROVIDER_PRIORITY_PLATFORM);
#line 132 "../lib/Models/StyleManager.vala"
	_tmp116_ = self->priv->_user_dark;
#line 132 "../lib/Models/StyleManager.vala"
	he_misc_toggle_style_provider ((GtkStyleProvider*) _tmp116_, self->is_dark, HE_STYLE_MANAGER_STYLE_PROVIDER_PRIORITY_USER_DARK);
#line 134 "../lib/Models/StyleManager.vala"
	_tmp117_ = gtk_settings_get_default ();
#line 134 "../lib/Models/StyleManager.vala"
	_tmp118_ = _g_object_ref0 (_tmp117_);
#line 134 "../lib/Models/StyleManager.vala"
	settings = _tmp118_;
#line 135 "../lib/Models/StyleManager.vala"
	_tmp119_ = settings;
#line 135 "../lib/Models/StyleManager.vala"
	g_object_set (_tmp119_, "gtk-application-prefer-dark-theme", self->is_dark, NULL);
#line 82 "../lib/Models/StyleManager.vala"
	_g_object_unref0 (settings);
#line 82 "../lib/Models/StyleManager.vala"
	_g_free0 (css);
#line 792 "StyleManager.c"
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
#line 1624 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1625 "glib-2.0.vapi"
	result = self;
#line 1625 "glib-2.0.vapi"
	return result;
#line 805 "StyleManager.c"
}

gchar*
he_style_manager_style_refresh (HeStyleManager* self,
                                HeDynamicScheme* scheme_factory)
{
	gchar* css = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	const gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	const gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	const gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	const gchar* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	const gchar* _tmp25_;
	gchar* _tmp26_;
	gchar* _tmp27_;
	const gchar* _tmp28_;
	gchar* _tmp29_;
	gchar* _tmp30_;
	const gchar* _tmp31_;
	gchar* _tmp32_;
	gchar* _tmp33_;
	const gchar* _tmp34_;
	gchar* _tmp35_;
	gchar* _tmp36_;
	const gchar* _tmp37_;
	gchar* _tmp38_;
	gchar* _tmp39_;
	const gchar* _tmp40_;
	gchar* _tmp41_;
	gchar* _tmp42_;
	const gchar* _tmp43_;
	gchar* _tmp44_;
	gchar* _tmp45_;
	const gchar* _tmp46_;
	gchar* _tmp47_;
	gchar* _tmp48_;
	const gchar* _tmp49_;
	gchar* _tmp50_;
	gchar* _tmp51_;
	const gchar* _tmp52_;
	gchar* _tmp53_;
	gchar* _tmp54_;
	const gchar* _tmp55_;
	gchar* _tmp56_;
	gchar* _tmp57_;
	const gchar* _tmp58_;
	gchar* _tmp59_;
	gchar* _tmp60_;
	const gchar* _tmp61_;
	gchar* _tmp62_;
	gchar* _tmp63_;
	const gchar* _tmp64_;
	gchar* _tmp65_;
	gchar* _tmp66_;
	const gchar* _tmp67_;
	gchar* _tmp68_;
	gchar* _tmp69_;
	const gchar* _tmp70_;
	gchar* _tmp71_;
	gchar* _tmp72_;
	const gchar* _tmp73_;
	gchar* _tmp74_;
	gchar* _tmp75_;
	gchar* _tmp76_;
	const gchar* _tmp77_;
	gchar* _tmp78_;
	gchar* _tmp79_;
	const gchar* _tmp80_;
	gchar* _tmp81_;
	gchar* _tmp82_;
	const gchar* _tmp83_;
	gchar* _tmp84_;
	gchar* _tmp85_;
	const gchar* _tmp86_;
	gchar* _tmp87_;
	gchar* _tmp88_;
	const gchar* _tmp89_;
	gchar* _tmp90_;
	gchar* _tmp91_;
	const gchar* _tmp92_;
	gchar* _tmp93_;
	gchar* _tmp94_;
	const gchar* _tmp95_;
	gchar* _tmp96_;
	gchar* _tmp97_;
	const gchar* _tmp98_;
	gchar* _tmp99_;
	gchar* _tmp100_;
	const gchar* _tmp101_;
	gchar* _tmp102_;
	gchar* _tmp103_;
	const gchar* _tmp104_;
	gchar* _tmp105_;
	gchar* _tmp106_;
	const gchar* _tmp107_;
	gchar* _tmp108_;
	gchar* _tmp109_;
	const gchar* _tmp110_;
	gchar* _tmp111_;
	gchar* _tmp112_;
	const gchar* _tmp113_;
	gchar* _tmp114_;
	gchar* _tmp115_;
	const gchar* _tmp116_;
	gchar* _tmp117_;
	gchar* _tmp118_;
	const gchar* _tmp119_;
	gchar* _tmp120_;
	gchar* _tmp121_;
	const gchar* _tmp122_;
	gchar* _tmp123_;
	gchar* _tmp124_;
	const gchar* _tmp125_;
	gchar* _tmp126_;
	gchar* _tmp127_;
	const gchar* _tmp128_;
	gchar* _tmp129_;
	gchar* _tmp130_;
	const gchar* _tmp131_;
	gchar* _tmp132_;
	gchar* _tmp133_;
	const gchar* _tmp134_;
	gchar* _tmp135_;
	gchar* _tmp136_;
	const gchar* _tmp137_;
	gchar* _tmp138_;
	gchar* _tmp139_;
	const gchar* _tmp140_;
	gchar* _tmp141_;
	gchar* _tmp142_;
	const gchar* _tmp143_;
	gchar* _tmp144_;
	gchar* _tmp145_;
	const gchar* _tmp146_;
	gchar* _tmp147_;
	gchar* _tmp148_;
	const gchar* _tmp149_;
	gchar* _tmp150_;
	gchar* _tmp151_;
	const gchar* _tmp152_;
	gchar* _tmp153_;
	gchar* _tmp154_;
	const gchar* _tmp155_;
	gchar* _tmp156_;
	gchar* _tmp157_;
	const gchar* _tmp158_;
	gchar* _tmp159_;
	gchar* _tmp160_;
	const gchar* _tmp161_;
	gchar* _tmp162_;
	gchar* _tmp163_;
	const gchar* _tmp164_;
	gchar* _tmp165_;
	gchar* _tmp166_;
	const gchar* _tmp167_;
	gchar* _tmp168_;
	gchar* _tmp169_;
	const gchar* _tmp170_;
	gchar* _tmp171_;
	gchar* _tmp172_;
	gchar* _tmp173_;
	gchar* result;
#line 138 "../lib/Models/StyleManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 138 "../lib/Models/StyleManager.vala"
	g_return_val_if_fail (scheme_factory != NULL, NULL);
#line 139 "../lib/Models/StyleManager.vala"
	_tmp0_ = g_strdup ("");
#line 139 "../lib/Models/StyleManager.vala"
	css = _tmp0_;
#line 140 "../lib/Models/StyleManager.vala"
	_tmp1_ = css;
#line 140 "../lib/Models/StyleManager.vala"
	_tmp2_ = he_dynamic_scheme_get_primary (scheme_factory);
#line 140 "../lib/Models/StyleManager.vala"
	_tmp3_ = _tmp2_;
#line 140 "../lib/Models/StyleManager.vala"
	_tmp4_ = string_to_string (_tmp3_);
#line 140 "../lib/Models/StyleManager.vala"
	_tmp5_ = he_dynamic_scheme_get_primary (scheme_factory);
#line 140 "../lib/Models/StyleManager.vala"
	_tmp6_ = _tmp5_;
#line 140 "../lib/Models/StyleManager.vala"
	_tmp7_ = string_to_string (_tmp6_);
#line 140 "../lib/Models/StyleManager.vala"
	_tmp8_ = he_dynamic_scheme_get_on_primary (scheme_factory);
#line 140 "../lib/Models/StyleManager.vala"
	_tmp9_ = _tmp8_;
#line 140 "../lib/Models/StyleManager.vala"
	_tmp10_ = string_to_string (_tmp9_);
#line 140 "../lib/Models/StyleManager.vala"
	_tmp11_ = he_dynamic_scheme_get_primary_container (scheme_factory);
#line 140 "../lib/Models/StyleManager.vala"
	_tmp12_ = _tmp11_;
#line 140 "../lib/Models/StyleManager.vala"
	_tmp13_ = string_to_string (_tmp12_);
#line 140 "../lib/Models/StyleManager.vala"
	_tmp14_ = he_dynamic_scheme_get_primary_container (scheme_factory);
#line 140 "../lib/Models/StyleManager.vala"
	_tmp15_ = _tmp14_;
#line 140 "../lib/Models/StyleManager.vala"
	_tmp16_ = string_to_string (_tmp15_);
#line 140 "../lib/Models/StyleManager.vala"
	_tmp17_ = he_dynamic_scheme_get_on_primary_container (scheme_factory);
#line 140 "../lib/Models/StyleManager.vala"
	_tmp18_ = _tmp17_;
#line 140 "../lib/Models/StyleManager.vala"
	_tmp19_ = string_to_string (_tmp18_);
#line 140 "../lib/Models/StyleManager.vala"
	_tmp20_ = he_dynamic_scheme_get_surface (scheme_factory);
#line 140 "../lib/Models/StyleManager.vala"
	_tmp21_ = _tmp20_;
#line 140 "../lib/Models/StyleManager.vala"
	_tmp22_ = string_to_string (_tmp21_);
#line 140 "../lib/Models/StyleManager.vala"
	_tmp23_ = he_dynamic_scheme_get_surface (scheme_factory);
#line 140 "../lib/Models/StyleManager.vala"
	_tmp24_ = _tmp23_;
#line 140 "../lib/Models/StyleManager.vala"
	_tmp25_ = string_to_string (_tmp24_);
#line 140 "../lib/Models/StyleManager.vala"
	_tmp26_ = he_dynamic_scheme_get_surface_variant (scheme_factory);
#line 140 "../lib/Models/StyleManager.vala"
	_tmp27_ = _tmp26_;
#line 140 "../lib/Models/StyleManager.vala"
	_tmp28_ = string_to_string (_tmp27_);
#line 140 "../lib/Models/StyleManager.vala"
	_tmp29_ = he_dynamic_scheme_get_surface_container_high (scheme_factory);
#line 140 "../lib/Models/StyleManager.vala"
	_tmp30_ = _tmp29_;
#line 140 "../lib/Models/StyleManager.vala"
	_tmp31_ = string_to_string (_tmp30_);
#line 140 "../lib/Models/StyleManager.vala"
	_tmp32_ = he_dynamic_scheme_get_surface_container (scheme_factory);
#line 140 "../lib/Models/StyleManager.vala"
	_tmp33_ = _tmp32_;
#line 140 "../lib/Models/StyleManager.vala"
	_tmp34_ = string_to_string (_tmp33_);
#line 140 "../lib/Models/StyleManager.vala"
	_tmp35_ = he_dynamic_scheme_get_on_surface (scheme_factory);
#line 140 "../lib/Models/StyleManager.vala"
	_tmp36_ = _tmp35_;
#line 140 "../lib/Models/StyleManager.vala"
	_tmp37_ = string_to_string (_tmp36_);
#line 140 "../lib/Models/StyleManager.vala"
	_tmp38_ = he_dynamic_scheme_get_on_surface_variant (scheme_factory);
#line 140 "../lib/Models/StyleManager.vala"
	_tmp39_ = _tmp38_;
#line 140 "../lib/Models/StyleManager.vala"
	_tmp40_ = string_to_string (_tmp39_);
#line 140 "../lib/Models/StyleManager.vala"
	_tmp41_ = he_dynamic_scheme_get_on_surface_variant (scheme_factory);
#line 140 "../lib/Models/StyleManager.vala"
	_tmp42_ = _tmp41_;
#line 140 "../lib/Models/StyleManager.vala"
	_tmp43_ = string_to_string (_tmp42_);
#line 140 "../lib/Models/StyleManager.vala"
	_tmp44_ = he_dynamic_scheme_get_on_surface (scheme_factory);
#line 140 "../lib/Models/StyleManager.vala"
	_tmp45_ = _tmp44_;
#line 140 "../lib/Models/StyleManager.vala"
	_tmp46_ = string_to_string (_tmp45_);
#line 140 "../lib/Models/StyleManager.vala"
	_tmp47_ = he_dynamic_scheme_get_on_surface (scheme_factory);
#line 140 "../lib/Models/StyleManager.vala"
	_tmp48_ = _tmp47_;
#line 140 "../lib/Models/StyleManager.vala"
	_tmp49_ = string_to_string (_tmp48_);
#line 140 "../lib/Models/StyleManager.vala"
	_tmp50_ = he_dynamic_scheme_get_surface_bright (scheme_factory);
#line 140 "../lib/Models/StyleManager.vala"
	_tmp51_ = _tmp50_;
#line 140 "../lib/Models/StyleManager.vala"
	_tmp52_ = string_to_string (_tmp51_);
#line 140 "../lib/Models/StyleManager.vala"
	_tmp53_ = he_dynamic_scheme_get_surface (scheme_factory);
#line 140 "../lib/Models/StyleManager.vala"
	_tmp54_ = _tmp53_;
#line 140 "../lib/Models/StyleManager.vala"
	_tmp55_ = string_to_string (_tmp54_);
#line 140 "../lib/Models/StyleManager.vala"
	_tmp56_ = he_dynamic_scheme_get_surface_dim (scheme_factory);
#line 140 "../lib/Models/StyleManager.vala"
	_tmp57_ = _tmp56_;
#line 140 "../lib/Models/StyleManager.vala"
	_tmp58_ = string_to_string (_tmp57_);
#line 140 "../lib/Models/StyleManager.vala"
	_tmp59_ = he_dynamic_scheme_get_surface_container_lowest (scheme_factory);
#line 140 "../lib/Models/StyleManager.vala"
	_tmp60_ = _tmp59_;
#line 140 "../lib/Models/StyleManager.vala"
	_tmp61_ = string_to_string (_tmp60_);
#line 140 "../lib/Models/StyleManager.vala"
	_tmp62_ = he_dynamic_scheme_get_surface_container_low (scheme_factory);
#line 140 "../lib/Models/StyleManager.vala"
	_tmp63_ = _tmp62_;
#line 140 "../lib/Models/StyleManager.vala"
	_tmp64_ = string_to_string (_tmp63_);
#line 140 "../lib/Models/StyleManager.vala"
	_tmp65_ = he_dynamic_scheme_get_surface_container (scheme_factory);
#line 140 "../lib/Models/StyleManager.vala"
	_tmp66_ = _tmp65_;
#line 140 "../lib/Models/StyleManager.vala"
	_tmp67_ = string_to_string (_tmp66_);
#line 140 "../lib/Models/StyleManager.vala"
	_tmp68_ = he_dynamic_scheme_get_surface_container_high (scheme_factory);
#line 140 "../lib/Models/StyleManager.vala"
	_tmp69_ = _tmp68_;
#line 140 "../lib/Models/StyleManager.vala"
	_tmp70_ = string_to_string (_tmp69_);
#line 140 "../lib/Models/StyleManager.vala"
	_tmp71_ = he_dynamic_scheme_get_surface_container_highest (scheme_factory);
#line 140 "../lib/Models/StyleManager.vala"
	_tmp72_ = _tmp71_;
#line 140 "../lib/Models/StyleManager.vala"
	_tmp73_ = string_to_string (_tmp72_);
#line 140 "../lib/Models/StyleManager.vala"
	_tmp74_ = g_strconcat ("\n    @define-color accent_color ", _tmp4_, ";\n    @define-color accent_bg_color ", _tmp7_, ";\n    @define-color accent_fg_color ", _tmp10_, ";\n    @define-color accent_container_color ", _tmp13_, ";\n    @define-color accent_container_bg_color ", _tmp16_, ";\n    @define-color accent_container_fg_color ", _tmp19_, ";\n\n    @define-color window_bg_color ", _tmp22_, ";\n    @define-color view_bg_color ", _tmp25_, ";\n    @define-color headerbar_bg_color ", _tmp28_, ";\n    @define-color popover_bg_color ", _tmp31_, ";\n    @define-color card_bg_color ", _tmp34_, ";\n    @define-color window_fg_color ", _tmp37_, ";\n    @define-color view_fg_color ", _tmp40_, ";\n    @define-color headerbar_fg_color ", _tmp43_, ";\n    @define-color popover_fg_color ", _tmp46_, ";\n    @define-color card_fg_color ", _tmp49_, ";\n\n    @define-color surface_bright_bg_color ", _tmp52_, ";\n    @define-color surface_bg_color ", _tmp55_, ";\n    @define-color surface_dim_bg_color ", _tmp58_, ";\n    @define-color surface_container_lowest_bg_color ", _tmp61_, ";\n    @define-color surface_container_low_bg_color ", _tmp64_, ";\n    @define-color surface_container_bg_color ", _tmp67_, ";\n    @define-color surface_container_high_bg_color ", _tmp70_, ";\n    @define-color surface_container_highest_bg_color ", _tmp73_, ";\n    ", NULL);
#line 140 "../lib/Models/StyleManager.vala"
	_tmp75_ = _tmp74_;
#line 140 "../lib/Models/StyleManager.vala"
	_tmp76_ = g_strconcat (_tmp1_, _tmp75_, NULL);
#line 140 "../lib/Models/StyleManager.vala"
	_g_free0 (css);
#line 140 "../lib/Models/StyleManager.vala"
	css = _tmp76_;
#line 140 "../lib/Models/StyleManager.vala"
	_g_free0 (_tmp75_);
#line 140 "../lib/Models/StyleManager.vala"
	_g_free0 (_tmp72_);
#line 140 "../lib/Models/StyleManager.vala"
	_g_free0 (_tmp69_);
#line 140 "../lib/Models/StyleManager.vala"
	_g_free0 (_tmp66_);
#line 140 "../lib/Models/StyleManager.vala"
	_g_free0 (_tmp63_);
#line 140 "../lib/Models/StyleManager.vala"
	_g_free0 (_tmp60_);
#line 140 "../lib/Models/StyleManager.vala"
	_g_free0 (_tmp57_);
#line 140 "../lib/Models/StyleManager.vala"
	_g_free0 (_tmp54_);
#line 140 "../lib/Models/StyleManager.vala"
	_g_free0 (_tmp51_);
#line 140 "../lib/Models/StyleManager.vala"
	_g_free0 (_tmp48_);
#line 140 "../lib/Models/StyleManager.vala"
	_g_free0 (_tmp45_);
#line 140 "../lib/Models/StyleManager.vala"
	_g_free0 (_tmp42_);
#line 140 "../lib/Models/StyleManager.vala"
	_g_free0 (_tmp39_);
#line 140 "../lib/Models/StyleManager.vala"
	_g_free0 (_tmp36_);
#line 140 "../lib/Models/StyleManager.vala"
	_g_free0 (_tmp33_);
#line 140 "../lib/Models/StyleManager.vala"
	_g_free0 (_tmp30_);
#line 140 "../lib/Models/StyleManager.vala"
	_g_free0 (_tmp27_);
#line 140 "../lib/Models/StyleManager.vala"
	_g_free0 (_tmp24_);
#line 140 "../lib/Models/StyleManager.vala"
	_g_free0 (_tmp21_);
#line 140 "../lib/Models/StyleManager.vala"
	_g_free0 (_tmp18_);
#line 140 "../lib/Models/StyleManager.vala"
	_g_free0 (_tmp15_);
#line 140 "../lib/Models/StyleManager.vala"
	_g_free0 (_tmp12_);
#line 140 "../lib/Models/StyleManager.vala"
	_g_free0 (_tmp9_);
#line 140 "../lib/Models/StyleManager.vala"
	_g_free0 (_tmp6_);
#line 140 "../lib/Models/StyleManager.vala"
	_g_free0 (_tmp3_);
#line 169 "../lib/Models/StyleManager.vala"
	_tmp77_ = css;
#line 169 "../lib/Models/StyleManager.vala"
	_tmp78_ = he_dynamic_scheme_get_error (scheme_factory);
#line 169 "../lib/Models/StyleManager.vala"
	_tmp79_ = _tmp78_;
#line 169 "../lib/Models/StyleManager.vala"
	_tmp80_ = string_to_string (_tmp79_);
#line 169 "../lib/Models/StyleManager.vala"
	_tmp81_ = he_dynamic_scheme_get_on_error (scheme_factory);
#line 169 "../lib/Models/StyleManager.vala"
	_tmp82_ = _tmp81_;
#line 169 "../lib/Models/StyleManager.vala"
	_tmp83_ = string_to_string (_tmp82_);
#line 169 "../lib/Models/StyleManager.vala"
	_tmp84_ = he_dynamic_scheme_get_error (scheme_factory);
#line 169 "../lib/Models/StyleManager.vala"
	_tmp85_ = _tmp84_;
#line 169 "../lib/Models/StyleManager.vala"
	_tmp86_ = string_to_string (_tmp85_);
#line 169 "../lib/Models/StyleManager.vala"
	_tmp87_ = he_dynamic_scheme_get_on_error_container (scheme_factory);
#line 169 "../lib/Models/StyleManager.vala"
	_tmp88_ = _tmp87_;
#line 169 "../lib/Models/StyleManager.vala"
	_tmp89_ = string_to_string (_tmp88_);
#line 169 "../lib/Models/StyleManager.vala"
	_tmp90_ = he_dynamic_scheme_get_error_container (scheme_factory);
#line 169 "../lib/Models/StyleManager.vala"
	_tmp91_ = _tmp90_;
#line 169 "../lib/Models/StyleManager.vala"
	_tmp92_ = string_to_string (_tmp91_);
#line 169 "../lib/Models/StyleManager.vala"
	_tmp93_ = he_dynamic_scheme_get_on_error_container (scheme_factory);
#line 169 "../lib/Models/StyleManager.vala"
	_tmp94_ = _tmp93_;
#line 169 "../lib/Models/StyleManager.vala"
	_tmp95_ = string_to_string (_tmp94_);
#line 169 "../lib/Models/StyleManager.vala"
	_tmp96_ = he_dynamic_scheme_get_secondary (scheme_factory);
#line 169 "../lib/Models/StyleManager.vala"
	_tmp97_ = _tmp96_;
#line 169 "../lib/Models/StyleManager.vala"
	_tmp98_ = string_to_string (_tmp97_);
#line 169 "../lib/Models/StyleManager.vala"
	_tmp99_ = he_dynamic_scheme_get_on_secondary (scheme_factory);
#line 169 "../lib/Models/StyleManager.vala"
	_tmp100_ = _tmp99_;
#line 169 "../lib/Models/StyleManager.vala"
	_tmp101_ = string_to_string (_tmp100_);
#line 169 "../lib/Models/StyleManager.vala"
	_tmp102_ = he_dynamic_scheme_get_secondary (scheme_factory);
#line 169 "../lib/Models/StyleManager.vala"
	_tmp103_ = _tmp102_;
#line 169 "../lib/Models/StyleManager.vala"
	_tmp104_ = string_to_string (_tmp103_);
#line 169 "../lib/Models/StyleManager.vala"
	_tmp105_ = he_dynamic_scheme_get_secondary_container (scheme_factory);
#line 169 "../lib/Models/StyleManager.vala"
	_tmp106_ = _tmp105_;
#line 169 "../lib/Models/StyleManager.vala"
	_tmp107_ = string_to_string (_tmp106_);
#line 169 "../lib/Models/StyleManager.vala"
	_tmp108_ = he_dynamic_scheme_get_secondary_container (scheme_factory);
#line 169 "../lib/Models/StyleManager.vala"
	_tmp109_ = _tmp108_;
#line 169 "../lib/Models/StyleManager.vala"
	_tmp110_ = string_to_string (_tmp109_);
#line 169 "../lib/Models/StyleManager.vala"
	_tmp111_ = he_dynamic_scheme_get_on_secondary_container (scheme_factory);
#line 169 "../lib/Models/StyleManager.vala"
	_tmp112_ = _tmp111_;
#line 169 "../lib/Models/StyleManager.vala"
	_tmp113_ = string_to_string (_tmp112_);
#line 169 "../lib/Models/StyleManager.vala"
	_tmp114_ = he_dynamic_scheme_get_error (scheme_factory);
#line 169 "../lib/Models/StyleManager.vala"
	_tmp115_ = _tmp114_;
#line 169 "../lib/Models/StyleManager.vala"
	_tmp116_ = string_to_string (_tmp115_);
#line 169 "../lib/Models/StyleManager.vala"
	_tmp117_ = he_dynamic_scheme_get_on_error (scheme_factory);
#line 169 "../lib/Models/StyleManager.vala"
	_tmp118_ = _tmp117_;
#line 169 "../lib/Models/StyleManager.vala"
	_tmp119_ = string_to_string (_tmp118_);
#line 169 "../lib/Models/StyleManager.vala"
	_tmp120_ = he_dynamic_scheme_get_error (scheme_factory);
#line 169 "../lib/Models/StyleManager.vala"
	_tmp121_ = _tmp120_;
#line 169 "../lib/Models/StyleManager.vala"
	_tmp122_ = string_to_string (_tmp121_);
#line 169 "../lib/Models/StyleManager.vala"
	_tmp123_ = he_dynamic_scheme_get_on_error_container (scheme_factory);
#line 169 "../lib/Models/StyleManager.vala"
	_tmp124_ = _tmp123_;
#line 169 "../lib/Models/StyleManager.vala"
	_tmp125_ = string_to_string (_tmp124_);
#line 169 "../lib/Models/StyleManager.vala"
	_tmp126_ = he_dynamic_scheme_get_error_container (scheme_factory);
#line 169 "../lib/Models/StyleManager.vala"
	_tmp127_ = _tmp126_;
#line 169 "../lib/Models/StyleManager.vala"
	_tmp128_ = string_to_string (_tmp127_);
#line 169 "../lib/Models/StyleManager.vala"
	_tmp129_ = he_dynamic_scheme_get_on_error_container (scheme_factory);
#line 169 "../lib/Models/StyleManager.vala"
	_tmp130_ = _tmp129_;
#line 169 "../lib/Models/StyleManager.vala"
	_tmp131_ = string_to_string (_tmp130_);
#line 169 "../lib/Models/StyleManager.vala"
	_tmp132_ = he_dynamic_scheme_get_tertiary (scheme_factory);
#line 169 "../lib/Models/StyleManager.vala"
	_tmp133_ = _tmp132_;
#line 169 "../lib/Models/StyleManager.vala"
	_tmp134_ = string_to_string (_tmp133_);
#line 169 "../lib/Models/StyleManager.vala"
	_tmp135_ = he_dynamic_scheme_get_on_tertiary (scheme_factory);
#line 169 "../lib/Models/StyleManager.vala"
	_tmp136_ = _tmp135_;
#line 169 "../lib/Models/StyleManager.vala"
	_tmp137_ = string_to_string (_tmp136_);
#line 169 "../lib/Models/StyleManager.vala"
	_tmp138_ = he_dynamic_scheme_get_tertiary (scheme_factory);
#line 169 "../lib/Models/StyleManager.vala"
	_tmp139_ = _tmp138_;
#line 169 "../lib/Models/StyleManager.vala"
	_tmp140_ = string_to_string (_tmp139_);
#line 169 "../lib/Models/StyleManager.vala"
	_tmp141_ = he_dynamic_scheme_get_tertiary_container (scheme_factory);
#line 169 "../lib/Models/StyleManager.vala"
	_tmp142_ = _tmp141_;
#line 169 "../lib/Models/StyleManager.vala"
	_tmp143_ = string_to_string (_tmp142_);
#line 169 "../lib/Models/StyleManager.vala"
	_tmp144_ = he_dynamic_scheme_get_tertiary_container (scheme_factory);
#line 169 "../lib/Models/StyleManager.vala"
	_tmp145_ = _tmp144_;
#line 169 "../lib/Models/StyleManager.vala"
	_tmp146_ = string_to_string (_tmp145_);
#line 169 "../lib/Models/StyleManager.vala"
	_tmp147_ = he_dynamic_scheme_get_on_tertiary_container (scheme_factory);
#line 169 "../lib/Models/StyleManager.vala"
	_tmp148_ = _tmp147_;
#line 169 "../lib/Models/StyleManager.vala"
	_tmp149_ = string_to_string (_tmp148_);
#line 169 "../lib/Models/StyleManager.vala"
	_tmp150_ = he_dynamic_scheme_get_outline (scheme_factory);
#line 169 "../lib/Models/StyleManager.vala"
	_tmp151_ = _tmp150_;
#line 169 "../lib/Models/StyleManager.vala"
	_tmp152_ = string_to_string (_tmp151_);
#line 169 "../lib/Models/StyleManager.vala"
	_tmp153_ = he_dynamic_scheme_get_outline_variant (scheme_factory);
#line 169 "../lib/Models/StyleManager.vala"
	_tmp154_ = _tmp153_;
#line 169 "../lib/Models/StyleManager.vala"
	_tmp155_ = string_to_string (_tmp154_);
#line 169 "../lib/Models/StyleManager.vala"
	_tmp156_ = he_dynamic_scheme_get_shadow (scheme_factory);
#line 169 "../lib/Models/StyleManager.vala"
	_tmp157_ = _tmp156_;
#line 169 "../lib/Models/StyleManager.vala"
	_tmp158_ = string_to_string (_tmp157_);
#line 169 "../lib/Models/StyleManager.vala"
	_tmp159_ = he_dynamic_scheme_get_scrim (scheme_factory);
#line 169 "../lib/Models/StyleManager.vala"
	_tmp160_ = _tmp159_;
#line 169 "../lib/Models/StyleManager.vala"
	_tmp161_ = string_to_string (_tmp160_);
#line 169 "../lib/Models/StyleManager.vala"
	_tmp162_ = he_dynamic_scheme_get_inverse_surface (scheme_factory);
#line 169 "../lib/Models/StyleManager.vala"
	_tmp163_ = _tmp162_;
#line 169 "../lib/Models/StyleManager.vala"
	_tmp164_ = string_to_string (_tmp163_);
#line 169 "../lib/Models/StyleManager.vala"
	_tmp165_ = he_dynamic_scheme_get_inverse_on_surface (scheme_factory);
#line 169 "../lib/Models/StyleManager.vala"
	_tmp166_ = _tmp165_;
#line 169 "../lib/Models/StyleManager.vala"
	_tmp167_ = string_to_string (_tmp166_);
#line 169 "../lib/Models/StyleManager.vala"
	_tmp168_ = he_dynamic_scheme_get_inverse_primary (scheme_factory);
#line 169 "../lib/Models/StyleManager.vala"
	_tmp169_ = _tmp168_;
#line 169 "../lib/Models/StyleManager.vala"
	_tmp170_ = string_to_string (_tmp169_);
#line 169 "../lib/Models/StyleManager.vala"
	_tmp171_ = g_strconcat ("\n    @define-color destructive_bg_color ", _tmp80_, ";\n    @define-color destructive_fg_color ", _tmp83_, ";\n    @define-color destructive_color ", _tmp86_, ";\n    @define-color destructive_container_color ", _tmp89_, ";\n    @define-color destructive_container_bg_color ", _tmp92_, ";\n    @define-color destructive_container_fg_color ", _tmp95_, ";\n\n    @define-color suggested_bg_color ", _tmp98_, ";\n    @define-color suggested_fg_color ", _tmp101_, ";\n    @define-color suggested_color ", _tmp104_, ";\n    @define-color suggested_container_color ", _tmp107_, ";\n    @define-color suggested_container_bg_color ", _tmp110_, ";\n    @define-color suggested_container_fg_color ", _tmp113_, ";\n\n    @define-color error_bg_color ", _tmp116_, ";\n    @define-color error_fg_color ", _tmp119_, ";\n    @define-color error_color ", _tmp122_, ";\n    @define-color error_container_color ", _tmp125_, ";\n    @define-color error_container_bg_color ", _tmp128_, ";\n    @define-color error_container_fg_color ", _tmp131_, ";\n\n    @define-color success_bg_color ", _tmp134_, ";\n    @define-color success_fg_color ", _tmp137_, ";\n    @define-color success_color ", _tmp140_, ";\n    @define-color success_container_color ", _tmp143_, ";\n    @define-color success_container_bg_color ", _tmp146_, ";\n    @define-color success_container_fg_color ", _tmp149_, ";\n\n    @define-color outline ", _tmp152_, ";\n    @define-color borders ", _tmp155_, ";\n    @define-color shadow ", _tmp158_, ";\n    @define-color scrim ", _tmp161_, ";\n    @define-color osd_bg_color ", _tmp164_, ";\n    @define-color osd_fg_color ", _tmp167_, ";\n    @define-color osd_accent_color ", _tmp170_, ";\n    ", NULL);
#line 169 "../lib/Models/StyleManager.vala"
	_tmp172_ = _tmp171_;
#line 169 "../lib/Models/StyleManager.vala"
	_tmp173_ = g_strconcat (_tmp77_, _tmp172_, NULL);
#line 169 "../lib/Models/StyleManager.vala"
	_g_free0 (css);
#line 169 "../lib/Models/StyleManager.vala"
	css = _tmp173_;
#line 169 "../lib/Models/StyleManager.vala"
	_g_free0 (_tmp172_);
#line 169 "../lib/Models/StyleManager.vala"
	_g_free0 (_tmp169_);
#line 169 "../lib/Models/StyleManager.vala"
	_g_free0 (_tmp166_);
#line 169 "../lib/Models/StyleManager.vala"
	_g_free0 (_tmp163_);
#line 169 "../lib/Models/StyleManager.vala"
	_g_free0 (_tmp160_);
#line 169 "../lib/Models/StyleManager.vala"
	_g_free0 (_tmp157_);
#line 169 "../lib/Models/StyleManager.vala"
	_g_free0 (_tmp154_);
#line 169 "../lib/Models/StyleManager.vala"
	_g_free0 (_tmp151_);
#line 169 "../lib/Models/StyleManager.vala"
	_g_free0 (_tmp148_);
#line 169 "../lib/Models/StyleManager.vala"
	_g_free0 (_tmp145_);
#line 169 "../lib/Models/StyleManager.vala"
	_g_free0 (_tmp142_);
#line 169 "../lib/Models/StyleManager.vala"
	_g_free0 (_tmp139_);
#line 169 "../lib/Models/StyleManager.vala"
	_g_free0 (_tmp136_);
#line 169 "../lib/Models/StyleManager.vala"
	_g_free0 (_tmp133_);
#line 169 "../lib/Models/StyleManager.vala"
	_g_free0 (_tmp130_);
#line 169 "../lib/Models/StyleManager.vala"
	_g_free0 (_tmp127_);
#line 169 "../lib/Models/StyleManager.vala"
	_g_free0 (_tmp124_);
#line 169 "../lib/Models/StyleManager.vala"
	_g_free0 (_tmp121_);
#line 169 "../lib/Models/StyleManager.vala"
	_g_free0 (_tmp118_);
#line 169 "../lib/Models/StyleManager.vala"
	_g_free0 (_tmp115_);
#line 169 "../lib/Models/StyleManager.vala"
	_g_free0 (_tmp112_);
#line 169 "../lib/Models/StyleManager.vala"
	_g_free0 (_tmp109_);
#line 169 "../lib/Models/StyleManager.vala"
	_g_free0 (_tmp106_);
#line 169 "../lib/Models/StyleManager.vala"
	_g_free0 (_tmp103_);
#line 169 "../lib/Models/StyleManager.vala"
	_g_free0 (_tmp100_);
#line 169 "../lib/Models/StyleManager.vala"
	_g_free0 (_tmp97_);
#line 169 "../lib/Models/StyleManager.vala"
	_g_free0 (_tmp94_);
#line 169 "../lib/Models/StyleManager.vala"
	_g_free0 (_tmp91_);
#line 169 "../lib/Models/StyleManager.vala"
	_g_free0 (_tmp88_);
#line 169 "../lib/Models/StyleManager.vala"
	_g_free0 (_tmp85_);
#line 169 "../lib/Models/StyleManager.vala"
	_g_free0 (_tmp82_);
#line 169 "../lib/Models/StyleManager.vala"
	_g_free0 (_tmp79_);
#line 207 "../lib/Models/StyleManager.vala"
	result = css;
#line 207 "../lib/Models/StyleManager.vala"
	return result;
#line 1468 "StyleManager.c"
}

static gchar*
double_to_string (gdouble self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint _tmp1__length1;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* result;
#line 997 "glib-2.0.vapi"
	_tmp0_ = g_new0 (gchar, G_ASCII_DTOSTR_BUF_SIZE);
#line 997 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 997 "glib-2.0.vapi"
	_tmp1__length1 = G_ASCII_DTOSTR_BUF_SIZE;
#line 997 "glib-2.0.vapi"
	_tmp2_ = g_ascii_dtostr (_tmp1_, (gint) G_ASCII_DTOSTR_BUF_SIZE, self);
#line 997 "glib-2.0.vapi"
	_tmp3_ = g_strdup (_tmp2_);
#line 997 "glib-2.0.vapi"
	_tmp4_ = _tmp3_;
#line 997 "glib-2.0.vapi"
	_tmp1_ = (g_free (_tmp1_), NULL);
#line 997 "glib-2.0.vapi"
	result = _tmp4_;
#line 997 "glib-2.0.vapi"
	return result;
#line 1499 "StyleManager.c"
}

gchar*
he_style_manager_weight_refresh (HeStyleManager* self,
                                 gdouble font_weight)
{
	gdouble light_weight = 0.0;
	gdouble base_weight = 0.0;
	gdouble heavy_weight = 0.0;
	gchar* css = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* result;
#line 210 "../lib/Models/StyleManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 211 "../lib/Models/StyleManager.vala"
	light_weight = 200 * font_weight;
#line 212 "../lib/Models/StyleManager.vala"
	base_weight = 400 * font_weight;
#line 213 "../lib/Models/StyleManager.vala"
	heavy_weight = 600 * font_weight;
#line 215 "../lib/Models/StyleManager.vala"
	_tmp0_ = g_strdup ("");
#line 215 "../lib/Models/StyleManager.vala"
	css = _tmp0_;
#line 216 "../lib/Models/StyleManager.vala"
	_tmp1_ = css;
#line 216 "../lib/Models/StyleManager.vala"
	_tmp2_ = double_to_string (base_weight);
#line 216 "../lib/Models/StyleManager.vala"
	_tmp3_ = _tmp2_;
#line 216 "../lib/Models/StyleManager.vala"
	_tmp4_ = double_to_string (light_weight);
#line 216 "../lib/Models/StyleManager.vala"
	_tmp5_ = _tmp4_;
#line 216 "../lib/Models/StyleManager.vala"
	_tmp6_ = double_to_string (heavy_weight);
#line 216 "../lib/Models/StyleManager.vala"
	_tmp7_ = _tmp6_;
#line 216 "../lib/Models/StyleManager.vala"
	_tmp8_ = g_strconcat ("\n" \
"    label,\n" \
"    .big-display,\n" \
"    .view-subtitle,\n" \
"    .cb-subtitle,\n" \
"    .body,\n" \
"    .view-switcher button.toggle:checked label,\n" \
"    .view-switcher button.toggle:active label,\n" \
"    .navigation-rail-button label,\n" \
"    .navigation-section-button label,\n" \
"    .navigation-section-list row .mini-content-block label,\n" \
"    .text-field .placeholder,\n" \
"    .calendar button label {\n" \
"      font-weight: ", _tmp3_, ";\n" \
"    }\n" \
"    .large-title,\n" \
"    .display,\n" \
"    .view-title,\n" \
"    .view-switcher button.toggle label,\n" \
"    .appbar .text-field text,\n" \
"    .flat-appbar .text-field text {\n" \
"      font-weight: ", _tmp5_, ";\n" \
"    }\n" \
"    .title-1,\n" \
"    .title-2,\n" \
"    .title-3,\n" \
"    .title-4,\n" \
"    .heading,\n" \
"    .header,\n" \
"    .caption,\n" \
"    .caption-heading,\n" \
"    .cb-title,\n" \
"    button label,\n" \
"    .toast-box button label,\n" \
"    .navigation-section-list row .mini-content-block label.cb-title,\n" \
"    .mini-content-block .cb-title,\n" \
"    .badge label,\n" \
"    .badge-info label,\n" \
"    .tint-badge label,\n" \
"    .modifier-badge label,\n" \
"    .navigation-rail-button:checked label,\n" \
"    .navigation-section-button:checked label,\n" \
"    .calendar button.textual-button label,\n" \
"    .calendar button.day label {\n" \
"      font-weight: ", _tmp7_, ";\n    }\n    ", NULL);
#line 216 "../lib/Models/StyleManager.vala"
	_tmp9_ = _tmp8_;
#line 216 "../lib/Models/StyleManager.vala"
	_tmp10_ = g_strconcat (_tmp1_, _tmp9_, NULL);
#line 216 "../lib/Models/StyleManager.vala"
	_g_free0 (css);
#line 216 "../lib/Models/StyleManager.vala"
	css = _tmp10_;
#line 216 "../lib/Models/StyleManager.vala"
	_g_free0 (_tmp9_);
#line 216 "../lib/Models/StyleManager.vala"
	_g_free0 (_tmp7_);
#line 216 "../lib/Models/StyleManager.vala"
	_g_free0 (_tmp5_);
#line 216 "../lib/Models/StyleManager.vala"
	_g_free0 (_tmp3_);
#line 264 "../lib/Models/StyleManager.vala"
	result = css;
#line 264 "../lib/Models/StyleManager.vala"
	return result;
#line 1570 "StyleManager.c"
}

static gchar*
he_style_manager_roundness_refresh (HeStyleManager* self,
                                    gdouble roundness)
{
	gdouble _tmp0_ = 0.0;
	gdouble base_roundness = 0.0;
	gchar* small_roundness = NULL;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* medium_roundness = NULL;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* large_roundness = NULL;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* x_large_roundness = NULL;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* xx_large_roundness = NULL;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* circle_roundness = NULL;
	gchar* _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	gchar* css = NULL;
	gchar* _tmp25_;
	const gchar* _tmp26_;
	const gchar* _tmp27_;
	const gchar* _tmp28_;
	const gchar* _tmp29_;
	const gchar* _tmp30_;
	const gchar* _tmp31_;
	const gchar* _tmp32_;
	const gchar* _tmp33_;
	const gchar* _tmp34_;
	const gchar* _tmp35_;
	const gchar* _tmp36_;
	const gchar* _tmp37_;
	const gchar* _tmp38_;
	const gchar* _tmp39_;
	const gchar* _tmp40_;
	const gchar* _tmp41_;
	const gchar* _tmp42_;
	const gchar* _tmp43_;
	const gchar* _tmp44_;
	const gchar* _tmp45_;
	const gchar* _tmp46_;
	const gchar* _tmp47_;
	const gchar* _tmp48_;
	const gchar* _tmp49_;
	const gchar* _tmp50_;
	const gchar* _tmp51_;
	const gchar* _tmp52_;
	const gchar* _tmp53_;
	const gchar* _tmp54_;
	const gchar* _tmp55_;
	const gchar* _tmp56_;
	const gchar* _tmp57_;
	const gchar* _tmp58_;
	const gchar* _tmp59_;
	const gchar* _tmp60_;
	const gchar* _tmp61_;
	const gchar* _tmp62_;
	const gchar* _tmp63_;
	const gchar* _tmp64_;
	const gchar* _tmp65_;
	const gchar* _tmp66_;
	const gchar* _tmp67_;
	const gchar* _tmp68_;
	const gchar* _tmp69_;
	const gchar* _tmp70_;
	const gchar* _tmp71_;
	const gchar* _tmp72_;
	gchar* _tmp73_;
	gchar* _tmp74_;
	gchar* _tmp75_;
	gchar* result;
#line 267 "../lib/Models/StyleManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 268 "../lib/Models/StyleManager.vala"
	if (roundness != ((gdouble) 0)) {
#line 268 "../lib/Models/StyleManager.vala"
		_tmp0_ = 4 * roundness;
#line 1668 "StyleManager.c"
	} else {
#line 268 "../lib/Models/StyleManager.vala"
		_tmp0_ = (gdouble) 0;
#line 1672 "StyleManager.c"
	}
#line 268 "../lib/Models/StyleManager.vala"
	base_roundness = _tmp0_;
#line 269 "../lib/Models/StyleManager.vala"
	_tmp1_ = double_to_string (0.5 * base_roundness);
#line 269 "../lib/Models/StyleManager.vala"
	_tmp2_ = _tmp1_;
#line 269 "../lib/Models/StyleManager.vala"
	_tmp3_ = g_strconcat (_tmp2_, "px", NULL);
#line 269 "../lib/Models/StyleManager.vala"
	_tmp4_ = _tmp3_;
#line 269 "../lib/Models/StyleManager.vala"
	_g_free0 (_tmp2_);
#line 269 "../lib/Models/StyleManager.vala"
	small_roundness = _tmp4_;
#line 270 "../lib/Models/StyleManager.vala"
	_tmp5_ = double_to_string (1 * base_roundness);
#line 270 "../lib/Models/StyleManager.vala"
	_tmp6_ = _tmp5_;
#line 270 "../lib/Models/StyleManager.vala"
	_tmp7_ = g_strconcat (_tmp6_, "px", NULL);
#line 270 "../lib/Models/StyleManager.vala"
	_tmp8_ = _tmp7_;
#line 270 "../lib/Models/StyleManager.vala"
	_g_free0 (_tmp6_);
#line 270 "../lib/Models/StyleManager.vala"
	medium_roundness = _tmp8_;
#line 271 "../lib/Models/StyleManager.vala"
	_tmp9_ = double_to_string (2 * base_roundness);
#line 271 "../lib/Models/StyleManager.vala"
	_tmp10_ = _tmp9_;
#line 271 "../lib/Models/StyleManager.vala"
	_tmp11_ = g_strconcat (_tmp10_, "px", NULL);
#line 271 "../lib/Models/StyleManager.vala"
	_tmp12_ = _tmp11_;
#line 271 "../lib/Models/StyleManager.vala"
	_g_free0 (_tmp10_);
#line 271 "../lib/Models/StyleManager.vala"
	large_roundness = _tmp12_;
#line 272 "../lib/Models/StyleManager.vala"
	_tmp13_ = double_to_string (3 * base_roundness);
#line 272 "../lib/Models/StyleManager.vala"
	_tmp14_ = _tmp13_;
#line 272 "../lib/Models/StyleManager.vala"
	_tmp15_ = g_strconcat (_tmp14_, "px", NULL);
#line 272 "../lib/Models/StyleManager.vala"
	_tmp16_ = _tmp15_;
#line 272 "../lib/Models/StyleManager.vala"
	_g_free0 (_tmp14_);
#line 272 "../lib/Models/StyleManager.vala"
	x_large_roundness = _tmp16_;
#line 273 "../lib/Models/StyleManager.vala"
	_tmp17_ = double_to_string (6 * base_roundness);
#line 273 "../lib/Models/StyleManager.vala"
	_tmp18_ = _tmp17_;
#line 273 "../lib/Models/StyleManager.vala"
	_tmp19_ = g_strconcat (_tmp18_, "px", NULL);
#line 273 "../lib/Models/StyleManager.vala"
	_tmp20_ = _tmp19_;
#line 273 "../lib/Models/StyleManager.vala"
	_g_free0 (_tmp18_);
#line 273 "../lib/Models/StyleManager.vala"
	xx_large_roundness = _tmp20_;
#line 274 "../lib/Models/StyleManager.vala"
	_tmp21_ = double_to_string (12.5 * base_roundness);
#line 274 "../lib/Models/StyleManager.vala"
	_tmp22_ = _tmp21_;
#line 274 "../lib/Models/StyleManager.vala"
	_tmp23_ = g_strconcat (_tmp22_, "px", NULL);
#line 274 "../lib/Models/StyleManager.vala"
	_tmp24_ = _tmp23_;
#line 274 "../lib/Models/StyleManager.vala"
	_g_free0 (_tmp22_);
#line 274 "../lib/Models/StyleManager.vala"
	circle_roundness = _tmp24_;
#line 276 "../lib/Models/StyleManager.vala"
	_tmp25_ = g_strdup ("");
#line 276 "../lib/Models/StyleManager.vala"
	css = _tmp25_;
#line 277 "../lib/Models/StyleManager.vala"
	_tmp26_ = css;
#line 277 "../lib/Models/StyleManager.vala"
	_tmp27_ = string_to_string (small_roundness);
#line 277 "../lib/Models/StyleManager.vala"
	_tmp28_ = string_to_string (medium_roundness);
#line 277 "../lib/Models/StyleManager.vala"
	_tmp29_ = string_to_string (large_roundness);
#line 277 "../lib/Models/StyleManager.vala"
	_tmp30_ = string_to_string (x_large_roundness);
#line 277 "../lib/Models/StyleManager.vala"
	_tmp31_ = string_to_string (circle_roundness);
#line 277 "../lib/Models/StyleManager.vala"
	_tmp32_ = string_to_string (small_roundness);
#line 277 "../lib/Models/StyleManager.vala"
	_tmp33_ = string_to_string (medium_roundness);
#line 277 "../lib/Models/StyleManager.vala"
	_tmp34_ = string_to_string (large_roundness);
#line 277 "../lib/Models/StyleManager.vala"
	_tmp35_ = string_to_string (x_large_roundness);
#line 277 "../lib/Models/StyleManager.vala"
	_tmp36_ = string_to_string (xx_large_roundness);
#line 277 "../lib/Models/StyleManager.vala"
	_tmp37_ = string_to_string (xx_large_roundness);
#line 277 "../lib/Models/StyleManager.vala"
	_tmp38_ = string_to_string (xx_large_roundness);
#line 277 "../lib/Models/StyleManager.vala"
	_tmp39_ = string_to_string (circle_roundness);
#line 277 "../lib/Models/StyleManager.vala"
	_tmp40_ = string_to_string (xx_large_roundness);
#line 277 "../lib/Models/StyleManager.vala"
	_tmp41_ = string_to_string (xx_large_roundness);
#line 277 "../lib/Models/StyleManager.vala"
	_tmp42_ = string_to_string (large_roundness);
#line 277 "../lib/Models/StyleManager.vala"
	_tmp43_ = string_to_string (large_roundness);
#line 277 "../lib/Models/StyleManager.vala"
	_tmp44_ = string_to_string (large_roundness);
#line 277 "../lib/Models/StyleManager.vala"
	_tmp45_ = string_to_string (large_roundness);
#line 277 "../lib/Models/StyleManager.vala"
	_tmp46_ = string_to_string (large_roundness);
#line 277 "../lib/Models/StyleManager.vala"
	_tmp47_ = string_to_string (large_roundness);
#line 277 "../lib/Models/StyleManager.vala"
	_tmp48_ = string_to_string (large_roundness);
#line 277 "../lib/Models/StyleManager.vala"
	_tmp49_ = string_to_string (large_roundness);
#line 277 "../lib/Models/StyleManager.vala"
	_tmp50_ = string_to_string (xx_large_roundness);
#line 277 "../lib/Models/StyleManager.vala"
	_tmp51_ = string_to_string (xx_large_roundness);
#line 277 "../lib/Models/StyleManager.vala"
	_tmp52_ = string_to_string (x_large_roundness);
#line 277 "../lib/Models/StyleManager.vala"
	_tmp53_ = string_to_string (x_large_roundness);
#line 277 "../lib/Models/StyleManager.vala"
	_tmp54_ = string_to_string (x_large_roundness);
#line 277 "../lib/Models/StyleManager.vala"
	_tmp55_ = string_to_string (x_large_roundness);
#line 277 "../lib/Models/StyleManager.vala"
	_tmp56_ = string_to_string (x_large_roundness);
#line 277 "../lib/Models/StyleManager.vala"
	_tmp57_ = string_to_string (x_large_roundness);
#line 277 "../lib/Models/StyleManager.vala"
	_tmp58_ = string_to_string (x_large_roundness);
#line 277 "../lib/Models/StyleManager.vala"
	_tmp59_ = string_to_string (x_large_roundness);
#line 277 "../lib/Models/StyleManager.vala"
	_tmp60_ = string_to_string (x_large_roundness);
#line 277 "../lib/Models/StyleManager.vala"
	_tmp61_ = string_to_string (x_large_roundness);
#line 277 "../lib/Models/StyleManager.vala"
	_tmp62_ = string_to_string (x_large_roundness);
#line 277 "../lib/Models/StyleManager.vala"
	_tmp63_ = string_to_string (x_large_roundness);
#line 277 "../lib/Models/StyleManager.vala"
	_tmp64_ = string_to_string (large_roundness);
#line 277 "../lib/Models/StyleManager.vala"
	_tmp65_ = string_to_string (large_roundness);
#line 277 "../lib/Models/StyleManager.vala"
	_tmp66_ = string_to_string (large_roundness);
#line 277 "../lib/Models/StyleManager.vala"
	_tmp67_ = string_to_string (large_roundness);
#line 277 "../lib/Models/StyleManager.vala"
	_tmp68_ = string_to_string (large_roundness);
#line 277 "../lib/Models/StyleManager.vala"
	_tmp69_ = string_to_string (large_roundness);
#line 277 "../lib/Models/StyleManager.vala"
	_tmp70_ = string_to_string (large_roundness);
#line 277 "../lib/Models/StyleManager.vala"
	_tmp71_ = string_to_string (large_roundness);
#line 277 "../lib/Models/StyleManager.vala"
	_tmp72_ = string_to_string (large_roundness);
#line 277 "../lib/Models/StyleManager.vala"
	_tmp73_ = g_strconcat ("\n    .small-radius {\n      border-radius: ", _tmp27_, ";\n    }\n    .medium-radius {\n      border-radius: ", _tmp28_, ";\n    }\n    .large-radius {\n      border-radius: ", _tmp29_, ";\n    }\n    .x-large-radius {\n      border-radius: ", _tmp30_, ";\n    }\n    .circle-radius {\n      border-radius: ", _tmp31_, ";\n" \
"    }\n" \
"\n" \
"    .view-switcher button.toggle,\n" \
"    .bottom-bar {\n" \
"      border-radius: 0px;\n" \
"    }\n" \
"    .badge,\n" \
"    .badge-info,\n" \
"    .tint-badge {\n" \
"      border-radius: ", _tmp32_, ";\n" \
"    }\n" \
"    button,\n" \
"    .toast-box,\n" \
"    .text-view,\n" \
"    popover > contents,\n" \
"    check {\n" \
"      border-radius: ", _tmp33_, ";\n" \
"    }\n" \
"    .text-field,\n" \
"    .navigation-section-button,\n" \
"    scale > trough,\n" \
"    scale > trough > slider {\n" \
"      border-radius: ", _tmp34_, ";\n" \
"    }\n" \
"    .content-block,\n" \
"    .mini-content-block,\n" \
"    .dialog-content,\n" \
"    .switchbar,\n" \
"    .navigation-section-list row .mini-content-block,\n" \
"    window.csd {\n" \
"      border-radius: ", _tmp35_, ";\n" \
"    }\n" \
"    window.csd.dialog.message,\n" \
"    window.csd.dialog-content,\n" \
"    .dialog-sheet {\n" \
"      border-radius: ", _tmp36_, ";\n    }\n    .bottom-sheet {\n        border-top-left-radius: ", _tmp37_, ";\n" \
"        border-bottom-left-radius: 0;\n" \
"        border-top-right-radius: ", _tmp38_, ";\n" \
"        border-bottom-right-radius: 0;\n" \
"    }\n" \
"    .disclosure-button,\n" \
"    .disclosure-button .toggle,\n" \
"    .overlay-button,\n" \
"    .iconic-button,\n" \
"    .text-field.search,\n" \
"    .switch,\n" \
"    .switch > slider,\n" \
"    .modifier-badge,\n" \
"    .circular,\n" \
"    .pill-button,\n" \
"    .navigation-rail-button image,\n" \
"    switch,\n" \
"    switch > slider,\n" \
"    radio,\n" \
"    window.csd.dialog-content windowcontrols > button > image,\n" \
"    window.csd.dialog-content .fill-button,\n" \
"    window.csd.dialog-content .pill-button,\n" \
"    window.csd.dialog-content .tint-button,\n" \
"    window.csd.dialog-content .textual-button,\n" \
"    window.csd.dialog-content .outline-button,\n" \
"    windowcontrols > button > image {\n" \
"      border-radius: ", _tmp39_, ";\n" \
"    }\n" \
"    .content-list row:first-child .mini-content-block {\n" \
"      border-top-left-radius: ", _tmp40_, ";\n	    border-top-right-radius: ", _tmp41_, ";\n      border-bottom-left-radius: ", _tmp42_, ";\n      border-bottom-right-radius: ", _tmp43_, ";\n" \
"    }\n" \
"    .content-list row:first-child:last-child .mini-content-block {\n" \
"      border-top-left-radius: ", _tmp44_, ";\n	    border-top-right-radius: ", _tmp45_, ";\n      border-bottom-left-radius: ", _tmp46_, ";\n      border-bottom-right-radius: ", _tmp47_, ";\n" \
"    }\n" \
"    .content-list row:last-child .mini-content-block {\n" \
"      border-top-left-radius: ", _tmp48_, ";\n	    border-top-right-radius: ", _tmp49_, ";\n      border-bottom-left-radius: ", _tmp50_, ";\n      border-bottom-right-radius: ", _tmp51_, ";\n" \
"    }\n" \
"    .segmented-button > button:not(:first-child),\n" \
"    .segmented-button > button:not(:last-child) {\n" \
"        border-top-left-radius: 0;\n" \
"        border-bottom-left-radius: 0;\n" \
"        border-top-right-radius: 0;\n" \
"        border-bottom-right-radius: 0;\n" \
"    }\n" \
"    .segmented-button button:first-child {\n" \
"        border-top-left-radius: ", _tmp52_, ";\n        border-bottom-left-radius: ", _tmp53_, ";\n" \
"    }\n" \
"    .segmented-button button:first-child:dir(rtl) {\n" \
"        border-top-right-radius: ", _tmp54_, ";\n        border-bottom-right-radius: ", _tmp55_, ";\n" \
"    }\n" \
"    .segmented-button button:last-child {\n" \
"        border-top-right-radius: ", _tmp56_, ";\n        border-bottom-right-radius: ", _tmp57_, ";\n" \
"    }\n" \
"    .segmented-button button:last-child:dir(rtl) {\n" \
"        border-top-left-radius: ", _tmp58_, ";\n        border-bottom-left-radius: ", _tmp59_, ";\n" \
"    }\n" \
"    .vertical.segmented-button > button:not(:first-child),\n" \
"    .vertical.segmented-button > button:not(:last-child) {\n" \
"        border-top-left-radius: 0;\n" \
"        border-bottom-left-radius: 0;\n" \
"        border-top-right-radius: 0;\n" \
"        border-bottom-right-radius: 0;\n" \
"    }\n" \
"    .vertical.segmented-button button:first-child {\n" \
"      border-top-left-radius: ", _tmp60_, ";\n      border-top-right-radius: ", _tmp61_, ";\n" \
"    }\n" \
"    .vertical.segmented-button button:last-child {\n" \
"      border-bottom-left-radius: ", _tmp62_, ";\n      border-bottom-right-radius: ", _tmp63_, ";\n" \
"    }\n" \
"    progressbar > trough > progress {\n" \
"      border-radius: ", _tmp64_, ";\n" \
"    }\n" \
"    progressbar > trough > progress.left {\n" \
"      border-top-left-radius: ", _tmp65_, ";\n      border-bottom-left-radius: ", _tmp66_, ";\n" \
"    }\n" \
"    progressbar > trough > progress.right {\n" \
"      border-top-right-radius: ", _tmp67_, ";\n      border-bottom-right-radius: ", _tmp68_, ";\n" \
"    }\n" \
"    progressbar > trough > progress.top {\n" \
"      border-top-right-radius: ", _tmp69_, ";\n      border-top-left-radius: ", _tmp70_, ";\n" \
"    }\n" \
"    progressbar > trough > progress.bottom {\n" \
"      border-bottom-right-radius: ", _tmp71_, ";\n      border-bottom-left-radius: ", _tmp72_, ";\n    }\n    ", NULL);
#line 277 "../lib/Models/StyleManager.vala"
	_tmp74_ = _tmp73_;
#line 277 "../lib/Models/StyleManager.vala"
	_tmp75_ = g_strconcat (_tmp26_, _tmp74_, NULL);
#line 277 "../lib/Models/StyleManager.vala"
	_g_free0 (css);
#line 277 "../lib/Models/StyleManager.vala"
	css = _tmp75_;
#line 277 "../lib/Models/StyleManager.vala"
	_g_free0 (_tmp74_);
#line 435 "../lib/Models/StyleManager.vala"
	result = css;
#line 435 "../lib/Models/StyleManager.vala"
	_g_free0 (circle_roundness);
#line 435 "../lib/Models/StyleManager.vala"
	_g_free0 (xx_large_roundness);
#line 435 "../lib/Models/StyleManager.vala"
	_g_free0 (x_large_roundness);
#line 435 "../lib/Models/StyleManager.vala"
	_g_free0 (large_roundness);
#line 435 "../lib/Models/StyleManager.vala"
	_g_free0 (medium_roundness);
#line 435 "../lib/Models/StyleManager.vala"
	_g_free0 (small_roundness);
#line 435 "../lib/Models/StyleManager.vala"
	return result;
#line 1874 "StyleManager.c"
}

/**
   * Register the style manager with GTK. This will also call update.
   */
void
he_style_manager_register (HeStyleManager* self)
{
	GtkCssProvider* _tmp0_;
	GtkCssProvider* _tmp1_;
	GtkCssProvider* _tmp2_;
	GtkCssProvider* _tmp3_;
	GtkSettings* settings = NULL;
	GtkSettings* _tmp4_;
	GtkSettings* _tmp5_;
#line 441 "../lib/Models/StyleManager.vala"
	g_return_if_fail (self != NULL);
#line 443 "../lib/Models/StyleManager.vala"
	g_debug ("StyleManager.vala:443: Loading bundled Helium stylesheet");
#line 444 "../lib/Models/StyleManager.vala"
	_tmp0_ = self->priv->light;
#line 444 "../lib/Models/StyleManager.vala"
	gtk_css_provider_load_from_resource (_tmp0_, "/com/fyralabs/Helium/gtk.css");
#line 445 "../lib/Models/StyleManager.vala"
	_tmp1_ = self->priv->dark;
#line 445 "../lib/Models/StyleManager.vala"
	gtk_css_provider_load_from_resource (_tmp1_, "/com/fyralabs/Helium/gtk-dark.css");
#line 452 "../lib/Models/StyleManager.vala"
	_tmp2_ = self->priv->accent;
#line 452 "../lib/Models/StyleManager.vala"
	he_misc_toggle_style_provider ((GtkStyleProvider*) _tmp2_, TRUE, HE_STYLE_MANAGER_STYLE_PROVIDER_PRIORITY_ACCENT);
#line 453 "../lib/Models/StyleManager.vala"
	_tmp3_ = self->priv->_user_base;
#line 453 "../lib/Models/StyleManager.vala"
	he_misc_toggle_style_provider ((GtkStyleProvider*) _tmp3_, TRUE, HE_STYLE_MANAGER_STYLE_PROVIDER_PRIORITY_USER_BASE);
#line 456 "../lib/Models/StyleManager.vala"
	_tmp4_ = gtk_settings_get_default ();
#line 456 "../lib/Models/StyleManager.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 456 "../lib/Models/StyleManager.vala"
	settings = _tmp5_;
#line 457 "../lib/Models/StyleManager.vala"
	g_object_set (settings, "gtk-theme-name", "Helium-empty", NULL);
#line 458 "../lib/Models/StyleManager.vala"
	g_object_set (settings, "gtk-icon-theme-name", "Hydrogen", NULL);
#line 460 "../lib/Models/StyleManager.vala"
	he_style_manager_set_is_registered (self, TRUE);
#line 462 "../lib/Models/StyleManager.vala"
	he_style_manager_update (self);
#line 441 "../lib/Models/StyleManager.vala"
	_g_object_unref0 (settings);
#line 1926 "StyleManager.c"
}

/**
   * Unregister the style manager with GTK.
   */
void
he_style_manager_unregister (HeStyleManager* self)
{
	GtkCssProvider* _tmp0_;
	GtkCssProvider* _tmp1_;
	GtkCssProvider* _tmp2_;
	GtkCssProvider* _tmp3_;
	GtkCssProvider* _tmp4_;
#line 468 "../lib/Models/StyleManager.vala"
	g_return_if_fail (self != NULL);
#line 469 "../lib/Models/StyleManager.vala"
	_tmp0_ = self->priv->accent;
#line 469 "../lib/Models/StyleManager.vala"
	he_misc_toggle_style_provider ((GtkStyleProvider*) _tmp0_, FALSE, HE_STYLE_MANAGER_STYLE_PROVIDER_PRIORITY_ACCENT);
#line 470 "../lib/Models/StyleManager.vala"
	_tmp1_ = self->priv->light;
#line 470 "../lib/Models/StyleManager.vala"
	he_misc_toggle_style_provider ((GtkStyleProvider*) _tmp1_, FALSE, HE_STYLE_MANAGER_STYLE_PROVIDER_PRIORITY_PLATFORM);
#line 471 "../lib/Models/StyleManager.vala"
	_tmp2_ = self->priv->dark;
#line 471 "../lib/Models/StyleManager.vala"
	he_misc_toggle_style_provider ((GtkStyleProvider*) _tmp2_, FALSE, HE_STYLE_MANAGER_STYLE_PROVIDER_PRIORITY_PLATFORM);
#line 472 "../lib/Models/StyleManager.vala"
	_tmp3_ = self->priv->_user_base;
#line 472 "../lib/Models/StyleManager.vala"
	he_misc_toggle_style_provider ((GtkStyleProvider*) _tmp3_, FALSE, HE_STYLE_MANAGER_STYLE_PROVIDER_PRIORITY_USER_BASE);
#line 473 "../lib/Models/StyleManager.vala"
	_tmp4_ = self->priv->_user_dark;
#line 473 "../lib/Models/StyleManager.vala"
	he_misc_toggle_style_provider ((GtkStyleProvider*) _tmp4_, FALSE, HE_STYLE_MANAGER_STYLE_PROVIDER_PRIORITY_USER_DARK);
#line 475 "../lib/Models/StyleManager.vala"
	he_style_manager_set_is_registered (self, FALSE);
#line 1964 "StyleManager.c"
}

HeStyleManager*
he_style_manager_construct (GType object_type)
{
	HeStyleManager * self = NULL;
#line 24 "../lib/Models/StyleManager.vala"
	self = (HeStyleManager*) g_object_new (object_type, NULL);
#line 24 "../lib/Models/StyleManager.vala"
	return self;
#line 1975 "StyleManager.c"
}

HeStyleManager*
he_style_manager_new (void)
{
#line 24 "../lib/Models/StyleManager.vala"
	return he_style_manager_construct (HE_TYPE_STYLE_MANAGER);
#line 1983 "StyleManager.c"
}

static void
he_style_manager_class_init (HeStyleManagerClass * klass,
                             gpointer klass_data)
{
#line 24 "../lib/Models/StyleManager.vala"
	he_style_manager_parent_class = g_type_class_peek_parent (klass);
#line 24 "../lib/Models/StyleManager.vala"
	g_type_class_adjust_private_offset (klass, &HeStyleManager_private_offset);
#line 24 "../lib/Models/StyleManager.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_he_style_manager_get_property;
#line 24 "../lib/Models/StyleManager.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_he_style_manager_set_property;
#line 24 "../lib/Models/StyleManager.vala"
	G_OBJECT_CLASS (klass)->finalize = he_style_manager_finalize;
#line 2000 "StyleManager.c"
	/**
	   * Whether the style manager has been registered. Unregistered style managers will not apply their styles.
	   */
#line 24 "../lib/Models/StyleManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_STYLE_MANAGER_IS_REGISTERED_PROPERTY, he_style_manager_properties[HE_STYLE_MANAGER_IS_REGISTERED_PROPERTY] = g_param_spec_boolean ("is-registered", "is-registered", "is-registered", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2006 "StyleManager.c"
	/**
	   * The base style provider for application provided styles. In this case user refers to the application, not the user of the application.
	   */
#line 24 "../lib/Models/StyleManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_STYLE_MANAGER_USER_BASE_PROPERTY, he_style_manager_properties[HE_STYLE_MANAGER_USER_BASE_PROPERTY] = g_param_spec_object ("user-base", "user-base", "user-base", gtk_css_provider_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2012 "StyleManager.c"
	/**
	   * The dark style provider for application provided styles. This will be applied in addition to the base style provider when dark mode is enabled.
	   */
#line 24 "../lib/Models/StyleManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_STYLE_MANAGER_USER_DARK_PROPERTY, he_style_manager_properties[HE_STYLE_MANAGER_USER_DARK_PROPERTY] = g_param_spec_object ("user-dark", "user-dark", "user-dark", gtk_css_provider_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2018 "StyleManager.c"
}

static void
he_style_manager_instance_init (HeStyleManager * self,
                                gpointer klass)
{
	GtkCssProvider* _tmp0_;
	GtkCssProvider* _tmp1_;
	GtkCssProvider* _tmp2_;
	GtkCssProvider* _tmp3_;
	GtkCssProvider* _tmp4_;
#line 24 "../lib/Models/StyleManager.vala"
	self->priv = he_style_manager_get_instance_private (self);
#line 28 "../lib/Models/StyleManager.vala"
	self->accent_color = NULL;
#line 33 "../lib/Models/StyleManager.vala"
	self->font_weight = 1.0;
#line 38 "../lib/Models/StyleManager.vala"
	self->roundness = 1.0;
#line 43 "../lib/Models/StyleManager.vala"
	self->is_dark = FALSE;
#line 49 "../lib/Models/StyleManager.vala"
	self->contrast = 0.0;
#line 54 "../lib/Models/StyleManager.vala"
	self->scheme_variant = NULL;
#line 59 "../lib/Models/StyleManager.vala"
	self->priv->_is_registered = FALSE;
#line 66 "../lib/Models/StyleManager.vala"
	_tmp0_ = gtk_css_provider_new ();
#line 66 "../lib/Models/StyleManager.vala"
	self->priv->light = _tmp0_;
#line 67 "../lib/Models/StyleManager.vala"
	_tmp1_ = gtk_css_provider_new ();
#line 67 "../lib/Models/StyleManager.vala"
	self->priv->dark = _tmp1_;
#line 68 "../lib/Models/StyleManager.vala"
	_tmp2_ = gtk_css_provider_new ();
#line 68 "../lib/Models/StyleManager.vala"
	self->priv->accent = _tmp2_;
#line 73 "../lib/Models/StyleManager.vala"
	_tmp3_ = gtk_css_provider_new ();
#line 73 "../lib/Models/StyleManager.vala"
	self->priv->_user_base = _tmp3_;
#line 77 "../lib/Models/StyleManager.vala"
	_tmp4_ = gtk_css_provider_new ();
#line 77 "../lib/Models/StyleManager.vala"
	self->priv->_user_dark = _tmp4_;
#line 2066 "StyleManager.c"
}

static void
he_style_manager_finalize (GObject * obj)
{
	HeStyleManager * self;
#line 24 "../lib/Models/StyleManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_STYLE_MANAGER, HeStyleManager);
#line 479 "../lib/Models/StyleManager.vala"
	he_style_manager_unregister (self);
#line 28 "../lib/Models/StyleManager.vala"
	_he_rgb_color_free0 (self->accent_color);
#line 54 "../lib/Models/StyleManager.vala"
	_g_free0 (self->scheme_variant);
#line 66 "../lib/Models/StyleManager.vala"
	_g_object_unref0 (self->priv->light);
#line 67 "../lib/Models/StyleManager.vala"
	_g_object_unref0 (self->priv->dark);
#line 68 "../lib/Models/StyleManager.vala"
	_g_object_unref0 (self->priv->accent);
#line 73 "../lib/Models/StyleManager.vala"
	_g_object_unref0 (self->priv->_user_base);
#line 77 "../lib/Models/StyleManager.vala"
	_g_object_unref0 (self->priv->_user_dark);
#line 24 "../lib/Models/StyleManager.vala"
	G_OBJECT_CLASS (he_style_manager_parent_class)->finalize (obj);
#line 2093 "StyleManager.c"
}

/**
 * A class that manages the style of the application in conjunction with the provided preferences.
 * This is a low-level class that should not be used directly. Instead, let the `He.Application` class manage this for you.
 */
static GType
he_style_manager_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HeStyleManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) he_style_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HeStyleManager), 0, (GInstanceInitFunc) he_style_manager_instance_init, NULL };
	GType he_style_manager_type_id;
	he_style_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "HeStyleManager", &g_define_type_info, 0);
	HeStyleManager_private_offset = g_type_add_instance_private (he_style_manager_type_id, sizeof (HeStyleManagerPrivate));
	return he_style_manager_type_id;
}

GType
he_style_manager_get_type (void)
{
	static volatile gsize he_style_manager_type_id__once = 0;
	if (g_once_init_enter (&he_style_manager_type_id__once)) {
		GType he_style_manager_type_id;
		he_style_manager_type_id = he_style_manager_get_type_once ();
		g_once_init_leave (&he_style_manager_type_id__once, he_style_manager_type_id);
	}
	return he_style_manager_type_id__once;
}

static void
_vala_he_style_manager_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec)
{
	HeStyleManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_STYLE_MANAGER, HeStyleManager);
#line 24 "../lib/Models/StyleManager.vala"
	switch (property_id) {
#line 24 "../lib/Models/StyleManager.vala"
		case HE_STYLE_MANAGER_IS_REGISTERED_PROPERTY:
#line 24 "../lib/Models/StyleManager.vala"
		g_value_set_boolean (value, he_style_manager_get_is_registered (self));
#line 24 "../lib/Models/StyleManager.vala"
		break;
#line 24 "../lib/Models/StyleManager.vala"
		case HE_STYLE_MANAGER_USER_BASE_PROPERTY:
#line 24 "../lib/Models/StyleManager.vala"
		g_value_set_object (value, he_style_manager_get_user_base (self));
#line 24 "../lib/Models/StyleManager.vala"
		break;
#line 24 "../lib/Models/StyleManager.vala"
		case HE_STYLE_MANAGER_USER_DARK_PROPERTY:
#line 24 "../lib/Models/StyleManager.vala"
		g_value_set_object (value, he_style_manager_get_user_dark (self));
#line 24 "../lib/Models/StyleManager.vala"
		break;
#line 2150 "StyleManager.c"
		default:
#line 24 "../lib/Models/StyleManager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../lib/Models/StyleManager.vala"
		break;
#line 2156 "StyleManager.c"
	}
}

static void
_vala_he_style_manager_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec)
{
	HeStyleManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_STYLE_MANAGER, HeStyleManager);
#line 24 "../lib/Models/StyleManager.vala"
	switch (property_id) {
#line 24 "../lib/Models/StyleManager.vala"
		case HE_STYLE_MANAGER_IS_REGISTERED_PROPERTY:
#line 24 "../lib/Models/StyleManager.vala"
		he_style_manager_set_is_registered (self, g_value_get_boolean (value));
#line 24 "../lib/Models/StyleManager.vala"
		break;
#line 2176 "StyleManager.c"
		default:
#line 24 "../lib/Models/StyleManager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../lib/Models/StyleManager.vala"
		break;
#line 2182 "StyleManager.c"
	}
}

