/* Window.c generated by valac 0.56.18, the Vala compiler
 * generated from Window.vala, do not modify */

/*
 * Copyright (c) 2022-2024 Fyra Labs
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 */

#include "libhelium-1.h"
#include <gtk/gtk.h>
#include <glib.h>
#include <glib-object.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	HE_WINDOW_0_PROPERTY,
	HE_WINDOW_PARENT_PROPERTY,
	HE_WINDOW_HAS_TITLE_PROPERTY,
	HE_WINDOW_HAS_BACK_BUTTON_PROPERTY,
	HE_WINDOW_NUM_PROPERTIES
};
static GParamSpec* he_window_properties[HE_WINDOW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _HeWindowPrivate {
	HeAppBar* title;
	GtkWindow* _parent;
	gboolean _has_title;
	gboolean _has_back_button;
};

static gint HeWindow_private_offset;
static gpointer he_window_parent_class = NULL;

static GObject * he_window_constructor (GType type,
                                 guint n_construct_properties,
                                 GObjectConstructParam * construct_properties);
static void he_window_finalize (GObject * obj);
static GType he_window_get_type_once (void);
static void _vala_he_window_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec);
static void _vala_he_window_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec);

static inline gpointer
he_window_get_instance_private (HeWindow* self)
{
	return G_STRUCT_MEMBER_P (self, HeWindow_private_offset);
}

GtkWindow*
he_window_get_parent (HeWindow* self)
{
	GtkWindow* result;
	GtkWindow* _tmp0_;
#line 33 "../lib/Models/Window.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 34 "../lib/Models/Window.vala"
	_tmp0_ = gtk_window_get_transient_for ((GtkWindow*) self);
#line 34 "../lib/Models/Window.vala"
	result = _tmp0_;
#line 34 "../lib/Models/Window.vala"
	return result;
#line 91 "Window.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 37 "../lib/Models/Window.vala"
	return self ? g_object_ref (self) : NULL;
#line 99 "Window.c"
}

void
he_window_set_parent (HeWindow* self,
                      GtkWindow* value)
{
	GtkWindow* _tmp0_;
#line 36 "../lib/Models/Window.vala"
	g_return_if_fail (self != NULL);
#line 37 "../lib/Models/Window.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 37 "../lib/Models/Window.vala"
	_g_object_unref0 (self->priv->_parent);
#line 37 "../lib/Models/Window.vala"
	self->priv->_parent = _tmp0_;
#line 38 "../lib/Models/Window.vala"
	gtk_window_set_modal ((GtkWindow*) self, value != NULL);
#line 39 "../lib/Models/Window.vala"
	gtk_window_set_transient_for ((GtkWindow*) self, value);
#line 36 "../lib/Models/Window.vala"
	g_object_notify_by_pspec ((GObject *) self, he_window_properties[HE_WINDOW_PARENT_PROPERTY]);
#line 121 "Window.c"
}

gboolean
he_window_get_has_title (HeWindow* self)
{
	gboolean result;
#line 48 "../lib/Models/Window.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 49 "../lib/Models/Window.vala"
	result = self->priv->_has_title;
#line 49 "../lib/Models/Window.vala"
	return result;
#line 134 "Window.c"
}

void
he_window_set_has_title (HeWindow* self,
                         gboolean value)
{
#line 51 "../lib/Models/Window.vala"
	g_return_if_fail (self != NULL);
#line 52 "../lib/Models/Window.vala"
	self->priv->_has_title = value;
#line 53 "../lib/Models/Window.vala"
	if (!value) {
#line 147 "Window.c"
		GtkBox* box = NULL;
		GtkBox* _tmp0_;
		GtkBox* _tmp1_;
		GtkBox* _tmp2_;
#line 54 "../lib/Models/Window.vala"
		_tmp0_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
#line 54 "../lib/Models/Window.vala"
		g_object_ref_sink (_tmp0_);
#line 54 "../lib/Models/Window.vala"
		box = _tmp0_;
#line 55 "../lib/Models/Window.vala"
		_tmp1_ = box;
#line 55 "../lib/Models/Window.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp1_, FALSE);
#line 56 "../lib/Models/Window.vala"
		_tmp2_ = box;
#line 56 "../lib/Models/Window.vala"
		gtk_window_set_titlebar ((GtkWindow*) self, (GtkWidget*) _tmp2_);
#line 53 "../lib/Models/Window.vala"
		_g_object_unref0 (box);
#line 168 "Window.c"
	} else {
		HeAppBar* _tmp3_;
		HeAppBar* _tmp4_;
#line 58 "../lib/Models/Window.vala"
		_tmp3_ = self->priv->title;
#line 58 "../lib/Models/Window.vala"
		gtk_widget_add_css_class ((GtkWidget*) _tmp3_, "flat");
#line 59 "../lib/Models/Window.vala"
		_tmp4_ = self->priv->title;
#line 59 "../lib/Models/Window.vala"
		gtk_window_set_titlebar ((GtkWindow*) self, (GtkWidget*) _tmp4_);
#line 180 "Window.c"
	}
#line 51 "../lib/Models/Window.vala"
	g_object_notify_by_pspec ((GObject *) self, he_window_properties[HE_WINDOW_HAS_TITLE_PROPERTY]);
#line 184 "Window.c"
}

gboolean
he_window_get_has_back_button (HeWindow* self)
{
	gboolean result;
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 71 "../lib/Models/Window.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 72 "../lib/Models/Window.vala"
	_tmp0_ = he_window_get_has_back_button (self);
#line 72 "../lib/Models/Window.vala"
	_tmp1_ = _tmp0_;
#line 72 "../lib/Models/Window.vala"
	result = _tmp1_;
#line 72 "../lib/Models/Window.vala"
	return result;
#line 203 "Window.c"
}

void
he_window_set_has_back_button (HeWindow* self,
                               gboolean value)
{
	HeAppBar* _tmp0_;
#line 74 "../lib/Models/Window.vala"
	g_return_if_fail (self != NULL);
#line 75 "../lib/Models/Window.vala"
	self->priv->_has_back_button = value;
#line 76 "../lib/Models/Window.vala"
	_tmp0_ = self->priv->title;
#line 76 "../lib/Models/Window.vala"
	he_app_bar_set_show_back (_tmp0_, value);
#line 74 "../lib/Models/Window.vala"
	g_object_notify_by_pspec ((GObject *) self, he_window_properties[HE_WINDOW_HAS_BACK_BUTTON_PROPERTY]);
#line 221 "Window.c"
}

HeWindow*
he_window_construct (GType object_type)
{
	HeWindow * self = NULL;
#line 25 "../lib/Models/Window.vala"
	self = (HeWindow*) g_object_new (object_type, NULL);
#line 25 "../lib/Models/Window.vala"
	return self;
#line 232 "Window.c"
}

HeWindow*
he_window_new (void)
{
#line 25 "../lib/Models/Window.vala"
	return he_window_construct (HE_TYPE_WINDOW);
#line 240 "Window.c"
}

static GObject *
he_window_constructor (GType type,
                       guint n_construct_properties,
                       GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	HeWindow * self;
#line 80 "../lib/Models/Window.vala"
	parent_class = G_OBJECT_CLASS (he_window_parent_class);
#line 80 "../lib/Models/Window.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 80 "../lib/Models/Window.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_WINDOW, HeWindow);
#line 81 "../lib/Models/Window.vala"
	he_window_set_has_title (self, FALSE);
#line 82 "../lib/Models/Window.vala"
	he_window_set_has_back_button (self, FALSE);
#line 80 "../lib/Models/Window.vala"
	return obj;
#line 263 "Window.c"
}

static void
he_window_class_init (HeWindowClass * klass,
                      gpointer klass_data)
{
#line 25 "../lib/Models/Window.vala"
	he_window_parent_class = g_type_class_peek_parent (klass);
#line 25 "../lib/Models/Window.vala"
	g_type_class_adjust_private_offset (klass, &HeWindow_private_offset);
#line 25 "../lib/Models/Window.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_he_window_get_property;
#line 25 "../lib/Models/Window.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_he_window_set_property;
#line 25 "../lib/Models/Window.vala"
	G_OBJECT_CLASS (klass)->constructor = he_window_constructor;
#line 25 "../lib/Models/Window.vala"
	G_OBJECT_CLASS (klass)->finalize = he_window_finalize;
#line 25 "../lib/Models/Window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_WINDOW_PARENT_PROPERTY, he_window_properties[HE_WINDOW_PARENT_PROPERTY] = g_param_spec_object ("parent", "parent", "parent", gtk_window_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../lib/Models/Window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_WINDOW_HAS_TITLE_PROPERTY, he_window_properties[HE_WINDOW_HAS_TITLE_PROPERTY] = g_param_spec_boolean ("has-title", "has-title", "has-title", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../lib/Models/Window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_WINDOW_HAS_BACK_BUTTON_PROPERTY, he_window_properties[HE_WINDOW_HAS_BACK_BUTTON_PROPERTY] = g_param_spec_boolean ("has-back-button", "has-back-button", "has-back-button", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 288 "Window.c"
}

static void
he_window_instance_init (HeWindow * self,
                         gpointer klass)
{
	HeAppBar* _tmp0_;
#line 25 "../lib/Models/Window.vala"
	self->priv = he_window_get_instance_private (self);
#line 26 "../lib/Models/Window.vala"
	_tmp0_ = he_app_bar_new ();
#line 26 "../lib/Models/Window.vala"
	g_object_ref_sink (_tmp0_);
#line 26 "../lib/Models/Window.vala"
	self->priv->title = _tmp0_;
#line 31 "../lib/Models/Window.vala"
	self->priv->_parent = NULL;
#line 306 "Window.c"
}

static void
he_window_finalize (GObject * obj)
{
	HeWindow * self;
#line 25 "../lib/Models/Window.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_WINDOW, HeWindow);
#line 26 "../lib/Models/Window.vala"
	_g_object_unref0 (self->priv->title);
#line 31 "../lib/Models/Window.vala"
	_g_object_unref0 (self->priv->_parent);
#line 25 "../lib/Models/Window.vala"
	G_OBJECT_CLASS (he_window_parent_class)->finalize (obj);
#line 321 "Window.c"
}

/**
 * A Window is a container that has an {@link AppBar} and can be moved, resized, and closed.
 * It may be a top-level window or a dialog. The title bar can be made always visible.
 * Has an optional back button. The back button is only visible if has_back_button is true.
 */
static GType
he_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HeWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) he_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HeWindow), 0, (GInstanceInitFunc) he_window_instance_init, NULL };
	GType he_window_type_id;
	he_window_type_id = g_type_register_static (gtk_window_get_type (), "HeWindow", &g_define_type_info, 0);
	HeWindow_private_offset = g_type_add_instance_private (he_window_type_id, sizeof (HeWindowPrivate));
	return he_window_type_id;
}

GType
he_window_get_type (void)
{
	static volatile gsize he_window_type_id__once = 0;
	if (g_once_init_enter (&he_window_type_id__once)) {
		GType he_window_type_id;
		he_window_type_id = he_window_get_type_once ();
		g_once_init_leave (&he_window_type_id__once, he_window_type_id);
	}
	return he_window_type_id__once;
}

static void
_vala_he_window_get_property (GObject * object,
                              guint property_id,
                              GValue * value,
                              GParamSpec * pspec)
{
	HeWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_WINDOW, HeWindow);
#line 25 "../lib/Models/Window.vala"
	switch (property_id) {
#line 25 "../lib/Models/Window.vala"
		case HE_WINDOW_PARENT_PROPERTY:
#line 25 "../lib/Models/Window.vala"
		g_value_set_object (value, he_window_get_parent (self));
#line 25 "../lib/Models/Window.vala"
		break;
#line 25 "../lib/Models/Window.vala"
		case HE_WINDOW_HAS_TITLE_PROPERTY:
#line 25 "../lib/Models/Window.vala"
		g_value_set_boolean (value, he_window_get_has_title (self));
#line 25 "../lib/Models/Window.vala"
		break;
#line 25 "../lib/Models/Window.vala"
		case HE_WINDOW_HAS_BACK_BUTTON_PROPERTY:
#line 25 "../lib/Models/Window.vala"
		g_value_set_boolean (value, he_window_get_has_back_button (self));
#line 25 "../lib/Models/Window.vala"
		break;
#line 379 "Window.c"
		default:
#line 25 "../lib/Models/Window.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 25 "../lib/Models/Window.vala"
		break;
#line 385 "Window.c"
	}
}

static void
_vala_he_window_set_property (GObject * object,
                              guint property_id,
                              const GValue * value,
                              GParamSpec * pspec)
{
	HeWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_WINDOW, HeWindow);
#line 25 "../lib/Models/Window.vala"
	switch (property_id) {
#line 25 "../lib/Models/Window.vala"
		case HE_WINDOW_PARENT_PROPERTY:
#line 25 "../lib/Models/Window.vala"
		he_window_set_parent (self, g_value_get_object (value));
#line 25 "../lib/Models/Window.vala"
		break;
#line 25 "../lib/Models/Window.vala"
		case HE_WINDOW_HAS_TITLE_PROPERTY:
#line 25 "../lib/Models/Window.vala"
		he_window_set_has_title (self, g_value_get_boolean (value));
#line 25 "../lib/Models/Window.vala"
		break;
#line 25 "../lib/Models/Window.vala"
		case HE_WINDOW_HAS_BACK_BUTTON_PROPERTY:
#line 25 "../lib/Models/Window.vala"
		he_window_set_has_back_button (self, g_value_get_boolean (value));
#line 25 "../lib/Models/Window.vala"
		break;
#line 417 "Window.c"
		default:
#line 25 "../lib/Models/Window.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 25 "../lib/Models/Window.vala"
		break;
#line 423 "Window.c"
	}
}

