/* Desktop.c generated by valac 0.56.18, the Vala compiler
 * generated from Desktop.vala, do not modify */

/*
 * Copyright (c) 2022 Fyra Labs
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 */

#include "libhelium-1.h"
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <float.h>
#include <math.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define HE_PORTAL_TYPE_SETTINGS (he_portal_settings_get_type ())
#define HE_PORTAL_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), HE_PORTAL_TYPE_SETTINGS, HePortalSettings))
#define HE_PORTAL_IS_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), HE_PORTAL_TYPE_SETTINGS))
#define HE_PORTAL_SETTINGS_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), HE_PORTAL_TYPE_SETTINGS, HePortalSettingsIface))

typedef struct _HePortalSettings HePortalSettings;
typedef struct _HePortalSettingsIface HePortalSettingsIface;

#define HE_PORTAL_TYPE_SETTINGS_PROXY (he_portal_settings_proxy_get_type ())
enum  {
	HE_DESKTOP_0_PROPERTY,
	HE_DESKTOP_PREFERS_COLOR_SCHEME_PROPERTY,
	HE_DESKTOP_ENSOR_SCHEME_PROPERTY,
	HE_DESKTOP_ACCENT_COLOR_PROPERTY,
	HE_DESKTOP_FONT_WEIGHT_PROPERTY,
	HE_DESKTOP_ROUNDNESS_PROPERTY,
	HE_DESKTOP_CONTRAST_PROPERTY,
	HE_DESKTOP_NUM_PROPERTIES
};
static GParamSpec* he_desktop_properties[HE_DESKTOP_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) ((var == NULL) ? NULL : (var = (g_free (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _he_rgb_color_free0(var) ((var == NULL) ? NULL : (var = (he_rgb_color_free (var), NULL)))
#define _g_variant_iter_free0(var) ((var == NULL) ? NULL : (var = (g_variant_iter_free (var), NULL)))

struct _HePortalSettingsIface {
	GTypeInterface parent_iface;
	GHashTable* (*read_all) (HePortalSettings* self, gchar** namespaces, gint namespaces_length1, GError** error);
	GVariant* (*read) (HePortalSettings* self, const gchar* namespace, const gchar* key, GError** error);
};

struct _HeDesktopPrivate {
	HePortalSettings* portal;
	HeDesktopColorScheme* _prefers_color_scheme;
	HeDesktopEnsorScheme* _ensor_scheme;
	HeRGBColor* _accent_color;
	gdouble _font_weight;
	gdouble _roundness;
	gdouble* _contrast;
};

static gint HeDesktop_private_offset;
static gpointer he_desktop_parent_class = NULL;

VALA_EXTERN GType he_portal_settings_proxy_get_type (void) G_GNUC_CONST ;
VALA_EXTERN guint he_portal_settings_register_object (void* object,
                                          GDBusConnection* connection,
                                          const gchar* path,
                                          GError** error);
VALA_EXTERN GType he_portal_settings_get_type (void) G_GNUC_CONST ;
static HeDesktopColorScheme* _he_desktop_color_scheme_dup (HeDesktopColorScheme* self);
static void he_desktop_setup_prefers_color_scheme (HeDesktop* self);
VALA_EXTERN GVariant* he_portal_settings_read (HePortalSettings* self,
                                   const gchar* namespace,
                                   const gchar* key,
                                   GError** error);
static void he_desktop_set_ensor_scheme (HeDesktop* self,
                                  HeDesktopEnsorScheme value);
static HeDesktopEnsorScheme* _he_desktop_ensor_scheme_dup (HeDesktopEnsorScheme* self);
static void he_desktop_setup_ensor_scheme (HeDesktop* self);
static HeRGBColor* he_desktop_parse_accent_color (HeDesktop* self,
                                           GVariant* val);
static void he_desktop_setup_accent_color (HeDesktop* self);
static void he_desktop_setup_font_weight (HeDesktop* self);
static void he_desktop_setup_roundness (HeDesktop* self);
static gdouble* _double_dup (gdouble* self);
static void he_desktop_setup_contrast (HeDesktop* self);
static void he_desktop_init_handle_settings_change (HeDesktop* self);
static void __lambda6_ (HeDesktop* self,
                 const gchar* scheme,
                 const gchar* key,
                 GVariant* val);
static void ___lambda6__he_portal_settings_setting_changed (HePortalSettings* _sender,
                                                     const gchar* namespace,
                                                     const gchar* key,
                                                     GVariant* val,
                                                     gpointer self);
static GObject * he_desktop_constructor (GType type,
                                  guint n_construct_properties,
                                  GObjectConstructParam * construct_properties);
VALA_EXTERN HePortalSettings* he_portal_settings_get (GError** error);
static void he_desktop_finalize (GObject * obj);
static GType he_desktop_get_type_once (void);
static void _vala_he_desktop_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec);
static void _vala_he_desktop_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
he_desktop_get_instance_private (HeDesktop* self)
{
	return G_STRUCT_MEMBER_P (self, HeDesktop_private_offset);
}

/**
     * The color scheme preference enum, which is used to determine the color scheme of the desktop.
     */
static GType
he_desktop_color_scheme_get_type_once (void)
{
	static const GEnumValue values[] = {{HE_DESKTOP_COLOR_SCHEME_NO_PREFERENCE, "HE_DESKTOP_COLOR_SCHEME_NO_PREFERENCE", "no-preference"}, {HE_DESKTOP_COLOR_SCHEME_DARK, "HE_DESKTOP_COLOR_SCHEME_DARK", "dark"}, {HE_DESKTOP_COLOR_SCHEME_LIGHT, "HE_DESKTOP_COLOR_SCHEME_LIGHT", "light"}, {0, NULL, NULL}};
	GType he_desktop_color_scheme_type_id;
	he_desktop_color_scheme_type_id = g_enum_register_static ("HeDesktopColorScheme", values);
	return he_desktop_color_scheme_type_id;
}

GType
he_desktop_color_scheme_get_type (void)
{
	static volatile gsize he_desktop_color_scheme_type_id__once = 0;
	if (g_once_init_enter (&he_desktop_color_scheme_type_id__once)) {
		GType he_desktop_color_scheme_type_id;
		he_desktop_color_scheme_type_id = he_desktop_color_scheme_get_type_once ();
		g_once_init_leave (&he_desktop_color_scheme_type_id__once, he_desktop_color_scheme_type_id);
	}
	return he_desktop_color_scheme_type_id__once;
}

/**
     * The Ensor scheme preference enum, which is used to determine the Ensor scheme of the desktop.
     */
HeSchemeVariant
he_desktop_ensor_scheme_to_variant (HeDesktopEnsorScheme self)
{
	HeSchemeVariant result;
#line 75 "../lib/Utils/Desktop.vala"
	switch (self) {
#line 75 "../lib/Utils/Desktop.vala"
		case HE_DESKTOP_ENSOR_SCHEME_DEFAULT:
#line 179 "Desktop.c"
		{
#line 77 "../lib/Utils/Desktop.vala"
			result = HE_SCHEME_VARIANT_DEFAULT;
#line 77 "../lib/Utils/Desktop.vala"
			return result;
#line 185 "Desktop.c"
		}
#line 75 "../lib/Utils/Desktop.vala"
		case HE_DESKTOP_ENSOR_SCHEME_VIBRANT:
#line 189 "Desktop.c"
		{
#line 79 "../lib/Utils/Desktop.vala"
			result = HE_SCHEME_VARIANT_VIBRANT;
#line 79 "../lib/Utils/Desktop.vala"
			return result;
#line 195 "Desktop.c"
		}
#line 75 "../lib/Utils/Desktop.vala"
		case HE_DESKTOP_ENSOR_SCHEME_MUTED:
#line 199 "Desktop.c"
		{
#line 81 "../lib/Utils/Desktop.vala"
			result = HE_SCHEME_VARIANT_MUTED;
#line 81 "../lib/Utils/Desktop.vala"
			return result;
#line 205 "Desktop.c"
		}
#line 75 "../lib/Utils/Desktop.vala"
		case HE_DESKTOP_ENSOR_SCHEME_MONOCHROMATIC:
#line 209 "Desktop.c"
		{
#line 83 "../lib/Utils/Desktop.vala"
			result = HE_SCHEME_VARIANT_MONOCHROME;
#line 83 "../lib/Utils/Desktop.vala"
			return result;
#line 215 "Desktop.c"
		}
#line 75 "../lib/Utils/Desktop.vala"
		case HE_DESKTOP_ENSOR_SCHEME_SALAD:
#line 219 "Desktop.c"
		{
#line 85 "../lib/Utils/Desktop.vala"
			result = HE_SCHEME_VARIANT_SALAD;
#line 85 "../lib/Utils/Desktop.vala"
			return result;
#line 225 "Desktop.c"
		}
		default:
		{
#line 87 "../lib/Utils/Desktop.vala"
			result = HE_SCHEME_VARIANT_DEFAULT;
#line 87 "../lib/Utils/Desktop.vala"
			return result;
#line 233 "Desktop.c"
		}
	}
}

static GType
he_desktop_ensor_scheme_get_type_once (void)
{
	static const GEnumValue values[] = {{HE_DESKTOP_ENSOR_SCHEME_DEFAULT, "HE_DESKTOP_ENSOR_SCHEME_DEFAULT", "default"}, {HE_DESKTOP_ENSOR_SCHEME_VIBRANT, "HE_DESKTOP_ENSOR_SCHEME_VIBRANT", "vibrant"}, {HE_DESKTOP_ENSOR_SCHEME_MUTED, "HE_DESKTOP_ENSOR_SCHEME_MUTED", "muted"}, {HE_DESKTOP_ENSOR_SCHEME_MONOCHROMATIC, "HE_DESKTOP_ENSOR_SCHEME_MONOCHROMATIC", "monochromatic"}, {HE_DESKTOP_ENSOR_SCHEME_SALAD, "HE_DESKTOP_ENSOR_SCHEME_SALAD", "salad"}, {0, NULL, NULL}};
	GType he_desktop_ensor_scheme_type_id;
	he_desktop_ensor_scheme_type_id = g_enum_register_static ("HeDesktopEnsorScheme", values);
	return he_desktop_ensor_scheme_type_id;
}

GType
he_desktop_ensor_scheme_get_type (void)
{
	static volatile gsize he_desktop_ensor_scheme_type_id__once = 0;
	if (g_once_init_enter (&he_desktop_ensor_scheme_type_id__once)) {
		GType he_desktop_ensor_scheme_type_id;
		he_desktop_ensor_scheme_type_id = he_desktop_ensor_scheme_get_type_once ();
		g_once_init_leave (&he_desktop_ensor_scheme_type_id__once, he_desktop_ensor_scheme_type_id);
	}
	return he_desktop_ensor_scheme_type_id__once;
}

HeDesktopColorScheme
he_desktop_get_prefers_color_scheme (HeDesktop* self)
{
	HeDesktopColorScheme result;
	HeDesktopColorScheme* _tmp0_;
#line 41 "../lib/Utils/Desktop.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 42 "../lib/Utils/Desktop.vala"
	_tmp0_ = self->priv->_prefers_color_scheme;
#line 42 "../lib/Utils/Desktop.vala"
	result = *_tmp0_;
#line 42 "../lib/Utils/Desktop.vala"
	return result;
#line 272 "Desktop.c"
}

static HeDesktopColorScheme*
_he_desktop_color_scheme_dup (HeDesktopColorScheme* self)
{
	HeDesktopColorScheme* dup;
#line 45 "../lib/Utils/Desktop.vala"
	dup = g_new0 (HeDesktopColorScheme, 1);
#line 45 "../lib/Utils/Desktop.vala"
	memcpy (dup, self, sizeof (HeDesktopColorScheme));
#line 45 "../lib/Utils/Desktop.vala"
	return dup;
#line 285 "Desktop.c"
}

static gpointer
__he_desktop_color_scheme_dup0 (gpointer self)
{
#line 45 "../lib/Utils/Desktop.vala"
	return self ? _he_desktop_color_scheme_dup (self) : NULL;
#line 293 "Desktop.c"
}

void
he_desktop_set_prefers_color_scheme (HeDesktop* self,
                                     HeDesktopColorScheme value)
{
	HeDesktopColorScheme* _tmp0_;
#line 44 "../lib/Utils/Desktop.vala"
	g_return_if_fail (self != NULL);
#line 45 "../lib/Utils/Desktop.vala"
	_tmp0_ = __he_desktop_color_scheme_dup0 (&value);
#line 45 "../lib/Utils/Desktop.vala"
	_g_free0 (self->priv->_prefers_color_scheme);
#line 45 "../lib/Utils/Desktop.vala"
	self->priv->_prefers_color_scheme = _tmp0_;
#line 44 "../lib/Utils/Desktop.vala"
	g_object_notify_by_pspec ((GObject *) self, he_desktop_properties[HE_DESKTOP_PREFERS_COLOR_SCHEME_PROPERTY]);
#line 311 "Desktop.c"
}

static void
he_desktop_setup_prefers_color_scheme (HeDesktop* self)
{
	GError* _inner_error0_ = NULL;
#line 49 "../lib/Utils/Desktop.vala"
	g_return_if_fail (self != NULL);
#line 320 "Desktop.c"
	{
		GVariant* _tmp0_ = NULL;
		HePortalSettings* _tmp1_;
		GVariant* _tmp2_;
		GVariant* _tmp3_;
		GVariant* _tmp4_;
#line 51 "../lib/Utils/Desktop.vala"
		_tmp1_ = self->priv->portal;
#line 51 "../lib/Utils/Desktop.vala"
		_tmp2_ = he_portal_settings_read (_tmp1_, "org.freedesktop.appearance", "color-scheme", &_inner_error0_);
#line 51 "../lib/Utils/Desktop.vala"
		_tmp0_ = _tmp2_;
#line 51 "../lib/Utils/Desktop.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 335 "Desktop.c"
			goto __catch0_g_error;
		}
#line 51 "../lib/Utils/Desktop.vala"
		_tmp3_ = g_variant_get_variant (_tmp0_);
#line 51 "../lib/Utils/Desktop.vala"
		_tmp4_ = _tmp3_;
#line 51 "../lib/Utils/Desktop.vala"
		he_desktop_set_prefers_color_scheme (self, (HeDesktopColorScheme) g_variant_get_uint32 (_tmp4_));
#line 51 "../lib/Utils/Desktop.vala"
		_g_variant_unref0 (_tmp4_);
#line 56 "../lib/Utils/Desktop.vala"
		_g_variant_unref0 (_tmp0_);
#line 56 "../lib/Utils/Desktop.vala"
		return;
#line 350 "Desktop.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp5_;
		const gchar* _tmp6_;
#line 50 "../lib/Utils/Desktop.vala"
		e = _inner_error0_;
#line 50 "../lib/Utils/Desktop.vala"
		_inner_error0_ = NULL;
#line 58 "../lib/Utils/Desktop.vala"
		_tmp5_ = e;
#line 58 "../lib/Utils/Desktop.vala"
		_tmp6_ = _tmp5_->message;
#line 58 "../lib/Utils/Desktop.vala"
		g_debug ("Desktop.vala:58: %s", _tmp6_);
#line 50 "../lib/Utils/Desktop.vala"
		_g_error_free0 (e);
#line 370 "Desktop.c"
	}
	__finally0:
#line 50 "../lib/Utils/Desktop.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 50 "../lib/Utils/Desktop.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 50 "../lib/Utils/Desktop.vala"
		g_clear_error (&_inner_error0_);
#line 50 "../lib/Utils/Desktop.vala"
		return;
#line 381 "Desktop.c"
	}
#line 61 "../lib/Utils/Desktop.vala"
	he_desktop_set_prefers_color_scheme (self, HE_DESKTOP_COLOR_SCHEME_NO_PREFERENCE);
#line 385 "Desktop.c"
}

HeDesktopEnsorScheme
he_desktop_get_ensor_scheme (HeDesktop* self)
{
	HeDesktopEnsorScheme result;
	HeDesktopEnsorScheme* _tmp0_;
#line 97 "../lib/Utils/Desktop.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 98 "../lib/Utils/Desktop.vala"
	_tmp0_ = self->priv->_ensor_scheme;
#line 98 "../lib/Utils/Desktop.vala"
	result = *_tmp0_;
#line 98 "../lib/Utils/Desktop.vala"
	return result;
#line 401 "Desktop.c"
}

static HeDesktopEnsorScheme*
_he_desktop_ensor_scheme_dup (HeDesktopEnsorScheme* self)
{
	HeDesktopEnsorScheme* dup;
#line 101 "../lib/Utils/Desktop.vala"
	dup = g_new0 (HeDesktopEnsorScheme, 1);
#line 101 "../lib/Utils/Desktop.vala"
	memcpy (dup, self, sizeof (HeDesktopEnsorScheme));
#line 101 "../lib/Utils/Desktop.vala"
	return dup;
#line 414 "Desktop.c"
}

static gpointer
__he_desktop_ensor_scheme_dup0 (gpointer self)
{
#line 101 "../lib/Utils/Desktop.vala"
	return self ? _he_desktop_ensor_scheme_dup (self) : NULL;
#line 422 "Desktop.c"
}

static void
he_desktop_set_ensor_scheme (HeDesktop* self,
                             HeDesktopEnsorScheme value)
{
	HeDesktopEnsorScheme* _tmp0_;
#line 100 "../lib/Utils/Desktop.vala"
	g_return_if_fail (self != NULL);
#line 101 "../lib/Utils/Desktop.vala"
	_tmp0_ = __he_desktop_ensor_scheme_dup0 (&value);
#line 101 "../lib/Utils/Desktop.vala"
	_g_free0 (self->priv->_ensor_scheme);
#line 101 "../lib/Utils/Desktop.vala"
	self->priv->_ensor_scheme = _tmp0_;
#line 100 "../lib/Utils/Desktop.vala"
	g_object_notify_by_pspec ((GObject *) self, he_desktop_properties[HE_DESKTOP_ENSOR_SCHEME_PROPERTY]);
#line 440 "Desktop.c"
}

static void
he_desktop_setup_ensor_scheme (HeDesktop* self)
{
	GError* _inner_error0_ = NULL;
#line 105 "../lib/Utils/Desktop.vala"
	g_return_if_fail (self != NULL);
#line 449 "Desktop.c"
	{
		GVariant* _tmp0_ = NULL;
		HePortalSettings* _tmp1_;
		GVariant* _tmp2_;
		GVariant* _tmp3_;
		GVariant* _tmp4_;
#line 107 "../lib/Utils/Desktop.vala"
		_tmp1_ = self->priv->portal;
#line 107 "../lib/Utils/Desktop.vala"
		_tmp2_ = he_portal_settings_read (_tmp1_, "org.freedesktop.appearance", "ensor-scheme", &_inner_error0_);
#line 107 "../lib/Utils/Desktop.vala"
		_tmp0_ = _tmp2_;
#line 107 "../lib/Utils/Desktop.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 464 "Desktop.c"
			goto __catch0_g_error;
		}
#line 107 "../lib/Utils/Desktop.vala"
		_tmp3_ = g_variant_get_variant (_tmp0_);
#line 107 "../lib/Utils/Desktop.vala"
		_tmp4_ = _tmp3_;
#line 107 "../lib/Utils/Desktop.vala"
		he_desktop_set_ensor_scheme (self, (HeDesktopEnsorScheme) g_variant_get_uint32 (_tmp4_));
#line 107 "../lib/Utils/Desktop.vala"
		_g_variant_unref0 (_tmp4_);
#line 112 "../lib/Utils/Desktop.vala"
		_g_variant_unref0 (_tmp0_);
#line 112 "../lib/Utils/Desktop.vala"
		return;
#line 479 "Desktop.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp5_;
		const gchar* _tmp6_;
#line 106 "../lib/Utils/Desktop.vala"
		e = _inner_error0_;
#line 106 "../lib/Utils/Desktop.vala"
		_inner_error0_ = NULL;
#line 114 "../lib/Utils/Desktop.vala"
		_tmp5_ = e;
#line 114 "../lib/Utils/Desktop.vala"
		_tmp6_ = _tmp5_->message;
#line 114 "../lib/Utils/Desktop.vala"
		g_debug ("Desktop.vala:114: %s", _tmp6_);
#line 106 "../lib/Utils/Desktop.vala"
		_g_error_free0 (e);
#line 499 "Desktop.c"
	}
	__finally0:
#line 106 "../lib/Utils/Desktop.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 106 "../lib/Utils/Desktop.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 106 "../lib/Utils/Desktop.vala"
		g_clear_error (&_inner_error0_);
#line 106 "../lib/Utils/Desktop.vala"
		return;
#line 510 "Desktop.c"
	}
#line 117 "../lib/Utils/Desktop.vala"
	he_desktop_set_ensor_scheme (self, HE_DESKTOP_ENSOR_SCHEME_DEFAULT);
#line 514 "Desktop.c"
}

HeRGBColor*
he_desktop_get_accent_color (HeDesktop* self)
{
	HeRGBColor* result;
	HeRGBColor* _tmp0_;
#line 125 "../lib/Utils/Desktop.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 126 "../lib/Utils/Desktop.vala"
	_tmp0_ = self->priv->_accent_color;
#line 126 "../lib/Utils/Desktop.vala"
	result = _tmp0_;
#line 126 "../lib/Utils/Desktop.vala"
	return result;
#line 530 "Desktop.c"
}

static gpointer
_he_rgb_color_dup0 (gpointer self)
{
#line 129 "../lib/Utils/Desktop.vala"
	return self ? he_rgb_color_dup (self) : NULL;
#line 538 "Desktop.c"
}

void
he_desktop_set_accent_color (HeDesktop* self,
                             HeRGBColor* value)
{
	HeRGBColor* _tmp0_;
#line 128 "../lib/Utils/Desktop.vala"
	g_return_if_fail (self != NULL);
#line 129 "../lib/Utils/Desktop.vala"
	_tmp0_ = _he_rgb_color_dup0 (value);
#line 129 "../lib/Utils/Desktop.vala"
	_he_rgb_color_free0 (self->priv->_accent_color);
#line 129 "../lib/Utils/Desktop.vala"
	self->priv->_accent_color = _tmp0_;
#line 128 "../lib/Utils/Desktop.vala"
	g_object_notify_by_pspec ((GObject *) self, he_desktop_properties[HE_DESKTOP_ACCENT_COLOR_PROPERTY]);
#line 556 "Desktop.c"
}

static HeRGBColor*
he_desktop_parse_accent_color (HeDesktop* self,
                               GVariant* val)
{
	gdouble cr = 0.0;
	gdouble cg = 0.0;
	gdouble cb = 0.0;
	GVariantIter* iter = NULL;
	GVariantIter* _tmp0_;
	GVariantIter* _tmp1_;
	gdouble _tmp2_ = 0.0;
	GVariantIter* _tmp3_;
	gdouble _tmp4_ = 0.0;
	GVariantIter* _tmp5_;
	gdouble _tmp6_ = 0.0;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
	gboolean _tmp9_ = FALSE;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp11_ = FALSE;
	HeRGBColor rgb_color = {0};
	HeRGBColor _tmp12_ = {0};
	HeRGBColor* _tmp13_;
	HeRGBColor* result;
#line 133 "../lib/Utils/Desktop.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 133 "../lib/Utils/Desktop.vala"
	g_return_val_if_fail (val != NULL, NULL);
#line 136 "../lib/Utils/Desktop.vala"
	cb = 0.0;
#line 138 "../lib/Utils/Desktop.vala"
	_tmp0_ = g_variant_iter_new (val);
#line 138 "../lib/Utils/Desktop.vala"
	iter = _tmp0_;
#line 139 "../lib/Utils/Desktop.vala"
	_tmp1_ = iter;
#line 139 "../lib/Utils/Desktop.vala"
	g_variant_iter_next (_tmp1_, "d", &_tmp2_, NULL);
#line 139 "../lib/Utils/Desktop.vala"
	cr = _tmp2_;
#line 140 "../lib/Utils/Desktop.vala"
	_tmp3_ = iter;
#line 140 "../lib/Utils/Desktop.vala"
	g_variant_iter_next (_tmp3_, "d", &_tmp4_, NULL);
#line 140 "../lib/Utils/Desktop.vala"
	cg = _tmp4_;
#line 141 "../lib/Utils/Desktop.vala"
	_tmp5_ = iter;
#line 141 "../lib/Utils/Desktop.vala"
	g_variant_iter_next (_tmp5_, "d", &_tmp6_, NULL);
#line 141 "../lib/Utils/Desktop.vala"
	cb = _tmp6_;
#line 144 "../lib/Utils/Desktop.vala"
	if (cr >= 0.0) {
#line 144 "../lib/Utils/Desktop.vala"
		_tmp11_ = cr <= 1.0;
#line 615 "Desktop.c"
	} else {
#line 144 "../lib/Utils/Desktop.vala"
		_tmp11_ = FALSE;
#line 619 "Desktop.c"
	}
#line 144 "../lib/Utils/Desktop.vala"
	if (_tmp11_) {
#line 144 "../lib/Utils/Desktop.vala"
		_tmp10_ = cg >= 0.0;
#line 625 "Desktop.c"
	} else {
#line 144 "../lib/Utils/Desktop.vala"
		_tmp10_ = FALSE;
#line 629 "Desktop.c"
	}
#line 144 "../lib/Utils/Desktop.vala"
	if (_tmp10_) {
#line 144 "../lib/Utils/Desktop.vala"
		_tmp9_ = cg <= 1.0;
#line 635 "Desktop.c"
	} else {
#line 144 "../lib/Utils/Desktop.vala"
		_tmp9_ = FALSE;
#line 639 "Desktop.c"
	}
#line 144 "../lib/Utils/Desktop.vala"
	if (_tmp9_) {
#line 144 "../lib/Utils/Desktop.vala"
		_tmp8_ = cb >= 0.0;
#line 645 "Desktop.c"
	} else {
#line 144 "../lib/Utils/Desktop.vala"
		_tmp8_ = FALSE;
#line 649 "Desktop.c"
	}
#line 144 "../lib/Utils/Desktop.vala"
	if (_tmp8_) {
#line 144 "../lib/Utils/Desktop.vala"
		_tmp7_ = cb <= 1.0;
#line 655 "Desktop.c"
	} else {
#line 144 "../lib/Utils/Desktop.vala"
		_tmp7_ = FALSE;
#line 659 "Desktop.c"
	}
#line 144 "../lib/Utils/Desktop.vala"
	if (!_tmp7_) {
#line 145 "../lib/Utils/Desktop.vala"
		result = NULL;
#line 145 "../lib/Utils/Desktop.vala"
		_g_variant_iter_free0 (iter);
#line 145 "../lib/Utils/Desktop.vala"
		return result;
#line 669 "Desktop.c"
	}
#line 148 "../lib/Utils/Desktop.vala"
	_tmp12_.r = cr;
#line 148 "../lib/Utils/Desktop.vala"
	_tmp12_.g = cg;
#line 148 "../lib/Utils/Desktop.vala"
	_tmp12_.b = cb;
#line 148 "../lib/Utils/Desktop.vala"
	rgb_color = _tmp12_;
#line 154 "../lib/Utils/Desktop.vala"
	_tmp13_ = _he_rgb_color_dup0 (&rgb_color);
#line 154 "../lib/Utils/Desktop.vala"
	result = _tmp13_;
#line 154 "../lib/Utils/Desktop.vala"
	_g_variant_iter_free0 (iter);
#line 154 "../lib/Utils/Desktop.vala"
	return result;
#line 687 "Desktop.c"
}

static void
he_desktop_setup_accent_color (HeDesktop* self)
{
	GError* _inner_error0_ = NULL;
#line 157 "../lib/Utils/Desktop.vala"
	g_return_if_fail (self != NULL);
#line 696 "Desktop.c"
	{
		GVariant* _tmp0_ = NULL;
		HePortalSettings* _tmp1_;
		GVariant* _tmp2_;
		GVariant* accent = NULL;
		GVariant* _tmp3_;
		GVariant* _tmp4_;
		HeRGBColor* _tmp5_;
		HeRGBColor* _tmp6_;
#line 159 "../lib/Utils/Desktop.vala"
		_tmp1_ = self->priv->portal;
#line 159 "../lib/Utils/Desktop.vala"
		_tmp2_ = he_portal_settings_read (_tmp1_, "org.freedesktop.appearance", "accent-color", &_inner_error0_);
#line 159 "../lib/Utils/Desktop.vala"
		_tmp0_ = _tmp2_;
#line 159 "../lib/Utils/Desktop.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 714 "Desktop.c"
			goto __catch0_g_error;
		}
#line 159 "../lib/Utils/Desktop.vala"
		_tmp3_ = g_variant_get_variant (_tmp0_);
#line 159 "../lib/Utils/Desktop.vala"
		accent = _tmp3_;
#line 164 "../lib/Utils/Desktop.vala"
		_tmp4_ = accent;
#line 164 "../lib/Utils/Desktop.vala"
		_tmp5_ = he_desktop_parse_accent_color (self, _tmp4_);
#line 164 "../lib/Utils/Desktop.vala"
		_tmp6_ = _tmp5_;
#line 164 "../lib/Utils/Desktop.vala"
		he_desktop_set_accent_color (self, _tmp6_);
#line 164 "../lib/Utils/Desktop.vala"
		_he_rgb_color_free0 (_tmp6_);
#line 166 "../lib/Utils/Desktop.vala"
		_g_variant_unref0 (accent);
#line 166 "../lib/Utils/Desktop.vala"
		_g_variant_unref0 (_tmp0_);
#line 166 "../lib/Utils/Desktop.vala"
		return;
#line 737 "Desktop.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp7_;
		const gchar* _tmp8_;
#line 158 "../lib/Utils/Desktop.vala"
		e = _inner_error0_;
#line 158 "../lib/Utils/Desktop.vala"
		_inner_error0_ = NULL;
#line 168 "../lib/Utils/Desktop.vala"
		_tmp7_ = e;
#line 168 "../lib/Utils/Desktop.vala"
		_tmp8_ = _tmp7_->message;
#line 168 "../lib/Utils/Desktop.vala"
		g_debug ("Desktop.vala:168: %s", _tmp8_);
#line 158 "../lib/Utils/Desktop.vala"
		_g_error_free0 (e);
#line 757 "Desktop.c"
	}
	__finally0:
#line 158 "../lib/Utils/Desktop.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 158 "../lib/Utils/Desktop.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 158 "../lib/Utils/Desktop.vala"
		g_clear_error (&_inner_error0_);
#line 158 "../lib/Utils/Desktop.vala"
		return;
#line 768 "Desktop.c"
	}
#line 171 "../lib/Utils/Desktop.vala"
	he_desktop_set_accent_color (self, NULL);
#line 772 "Desktop.c"
}

gdouble
he_desktop_get_font_weight (HeDesktop* self)
{
	gdouble result;
#line 179 "../lib/Utils/Desktop.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 180 "../lib/Utils/Desktop.vala"
	result = self->priv->_font_weight;
#line 180 "../lib/Utils/Desktop.vala"
	return result;
#line 785 "Desktop.c"
}

void
he_desktop_set_font_weight (HeDesktop* self,
                            gdouble value)
{
#line 182 "../lib/Utils/Desktop.vala"
	g_return_if_fail (self != NULL);
#line 183 "../lib/Utils/Desktop.vala"
	self->priv->_font_weight = value;
#line 182 "../lib/Utils/Desktop.vala"
	g_object_notify_by_pspec ((GObject *) self, he_desktop_properties[HE_DESKTOP_FONT_WEIGHT_PROPERTY]);
#line 798 "Desktop.c"
}

static void
he_desktop_setup_font_weight (HeDesktop* self)
{
	GError* _inner_error0_ = NULL;
#line 187 "../lib/Utils/Desktop.vala"
	g_return_if_fail (self != NULL);
#line 807 "Desktop.c"
	{
		GVariant* _tmp0_ = NULL;
		HePortalSettings* _tmp1_;
		GVariant* _tmp2_;
		gdouble fw = 0.0;
		GVariant* _tmp3_;
		GVariant* _tmp4_;
		gdouble _tmp5_;
#line 189 "../lib/Utils/Desktop.vala"
		_tmp1_ = self->priv->portal;
#line 189 "../lib/Utils/Desktop.vala"
		_tmp2_ = he_portal_settings_read (_tmp1_, "org.freedesktop.appearance", "font-weight", &_inner_error0_);
#line 189 "../lib/Utils/Desktop.vala"
		_tmp0_ = _tmp2_;
#line 189 "../lib/Utils/Desktop.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 824 "Desktop.c"
			goto __catch0_g_error;
		}
#line 189 "../lib/Utils/Desktop.vala"
		_tmp3_ = g_variant_get_variant (_tmp0_);
#line 189 "../lib/Utils/Desktop.vala"
		_tmp4_ = _tmp3_;
#line 189 "../lib/Utils/Desktop.vala"
		_tmp5_ = g_variant_get_double (_tmp4_);
#line 189 "../lib/Utils/Desktop.vala"
		_g_variant_unref0 (_tmp4_);
#line 189 "../lib/Utils/Desktop.vala"
		fw = _tmp5_;
#line 194 "../lib/Utils/Desktop.vala"
		he_desktop_set_font_weight (self, (gdouble) fw);
#line 196 "../lib/Utils/Desktop.vala"
		_g_variant_unref0 (_tmp0_);
#line 196 "../lib/Utils/Desktop.vala"
		return;
#line 843 "Desktop.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp6_;
		const gchar* _tmp7_;
#line 188 "../lib/Utils/Desktop.vala"
		e = _inner_error0_;
#line 188 "../lib/Utils/Desktop.vala"
		_inner_error0_ = NULL;
#line 198 "../lib/Utils/Desktop.vala"
		_tmp6_ = e;
#line 198 "../lib/Utils/Desktop.vala"
		_tmp7_ = _tmp6_->message;
#line 198 "../lib/Utils/Desktop.vala"
		g_debug ("Desktop.vala:198: %s", _tmp7_);
#line 188 "../lib/Utils/Desktop.vala"
		_g_error_free0 (e);
#line 863 "Desktop.c"
	}
	__finally0:
#line 188 "../lib/Utils/Desktop.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 188 "../lib/Utils/Desktop.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 188 "../lib/Utils/Desktop.vala"
		g_clear_error (&_inner_error0_);
#line 188 "../lib/Utils/Desktop.vala"
		return;
#line 874 "Desktop.c"
	}
#line 201 "../lib/Utils/Desktop.vala"
	he_desktop_set_font_weight (self, 1.0);
#line 878 "Desktop.c"
}

gdouble
he_desktop_get_roundness (HeDesktop* self)
{
	gdouble result;
#line 209 "../lib/Utils/Desktop.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 210 "../lib/Utils/Desktop.vala"
	result = self->priv->_roundness;
#line 210 "../lib/Utils/Desktop.vala"
	return result;
#line 891 "Desktop.c"
}

void
he_desktop_set_roundness (HeDesktop* self,
                          gdouble value)
{
#line 212 "../lib/Utils/Desktop.vala"
	g_return_if_fail (self != NULL);
#line 213 "../lib/Utils/Desktop.vala"
	self->priv->_roundness = value;
#line 212 "../lib/Utils/Desktop.vala"
	g_object_notify_by_pspec ((GObject *) self, he_desktop_properties[HE_DESKTOP_ROUNDNESS_PROPERTY]);
#line 904 "Desktop.c"
}

static void
he_desktop_setup_roundness (HeDesktop* self)
{
	GError* _inner_error0_ = NULL;
#line 217 "../lib/Utils/Desktop.vala"
	g_return_if_fail (self != NULL);
#line 913 "Desktop.c"
	{
		GVariant* _tmp0_ = NULL;
		HePortalSettings* _tmp1_;
		GVariant* _tmp2_;
		gdouble round = 0.0;
		GVariant* _tmp3_;
		GVariant* _tmp4_;
		gdouble _tmp5_;
#line 219 "../lib/Utils/Desktop.vala"
		_tmp1_ = self->priv->portal;
#line 219 "../lib/Utils/Desktop.vala"
		_tmp2_ = he_portal_settings_read (_tmp1_, "org.freedesktop.appearance", "roundness", &_inner_error0_);
#line 219 "../lib/Utils/Desktop.vala"
		_tmp0_ = _tmp2_;
#line 219 "../lib/Utils/Desktop.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 930 "Desktop.c"
			goto __catch0_g_error;
		}
#line 219 "../lib/Utils/Desktop.vala"
		_tmp3_ = g_variant_get_variant (_tmp0_);
#line 219 "../lib/Utils/Desktop.vala"
		_tmp4_ = _tmp3_;
#line 219 "../lib/Utils/Desktop.vala"
		_tmp5_ = g_variant_get_double (_tmp4_);
#line 219 "../lib/Utils/Desktop.vala"
		_g_variant_unref0 (_tmp4_);
#line 219 "../lib/Utils/Desktop.vala"
		round = _tmp5_;
#line 224 "../lib/Utils/Desktop.vala"
		he_desktop_set_roundness (self, (gdouble) round);
#line 226 "../lib/Utils/Desktop.vala"
		_g_variant_unref0 (_tmp0_);
#line 226 "../lib/Utils/Desktop.vala"
		return;
#line 949 "Desktop.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp6_;
		const gchar* _tmp7_;
#line 218 "../lib/Utils/Desktop.vala"
		e = _inner_error0_;
#line 218 "../lib/Utils/Desktop.vala"
		_inner_error0_ = NULL;
#line 228 "../lib/Utils/Desktop.vala"
		_tmp6_ = e;
#line 228 "../lib/Utils/Desktop.vala"
		_tmp7_ = _tmp6_->message;
#line 228 "../lib/Utils/Desktop.vala"
		g_debug ("Desktop.vala:228: %s", _tmp7_);
#line 218 "../lib/Utils/Desktop.vala"
		_g_error_free0 (e);
#line 969 "Desktop.c"
	}
	__finally0:
#line 218 "../lib/Utils/Desktop.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 218 "../lib/Utils/Desktop.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 218 "../lib/Utils/Desktop.vala"
		g_clear_error (&_inner_error0_);
#line 218 "../lib/Utils/Desktop.vala"
		return;
#line 980 "Desktop.c"
	}
#line 231 "../lib/Utils/Desktop.vala"
	he_desktop_set_roundness (self, 1.0);
#line 984 "Desktop.c"
}

static gdouble*
_double_dup (gdouble* self)
{
	gdouble* dup;
#line 237 "../lib/Utils/Desktop.vala"
	dup = g_new0 (gdouble, 1);
#line 237 "../lib/Utils/Desktop.vala"
	memcpy (dup, self, sizeof (gdouble));
#line 237 "../lib/Utils/Desktop.vala"
	return dup;
#line 997 "Desktop.c"
}

static gpointer
__double_dup0 (gpointer self)
{
#line 237 "../lib/Utils/Desktop.vala"
	return self ? _double_dup (self) : NULL;
#line 1005 "Desktop.c"
}

gdouble
he_desktop_get_contrast (HeDesktop* self)
{
	gdouble result;
	gdouble* _tmp0_;
#line 239 "../lib/Utils/Desktop.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 240 "../lib/Utils/Desktop.vala"
	_tmp0_ = self->priv->_contrast;
#line 240 "../lib/Utils/Desktop.vala"
	result = *_tmp0_;
#line 240 "../lib/Utils/Desktop.vala"
	return result;
#line 1021 "Desktop.c"
}

void
he_desktop_set_contrast (HeDesktop* self,
                         gdouble value)
{
	gdouble* _tmp0_;
#line 242 "../lib/Utils/Desktop.vala"
	g_return_if_fail (self != NULL);
#line 243 "../lib/Utils/Desktop.vala"
	_tmp0_ = __double_dup0 (&value);
#line 243 "../lib/Utils/Desktop.vala"
	_g_free0 (self->priv->_contrast);
#line 243 "../lib/Utils/Desktop.vala"
	self->priv->_contrast = _tmp0_;
#line 242 "../lib/Utils/Desktop.vala"
	g_object_notify_by_pspec ((GObject *) self, he_desktop_properties[HE_DESKTOP_CONTRAST_PROPERTY]);
#line 1039 "Desktop.c"
}

static void
he_desktop_setup_contrast (HeDesktop* self)
{
	GError* _inner_error0_ = NULL;
#line 246 "../lib/Utils/Desktop.vala"
	g_return_if_fail (self != NULL);
#line 1048 "Desktop.c"
	{
		GVariant* _tmp0_ = NULL;
		HePortalSettings* _tmp1_;
		GVariant* _tmp2_;
		GVariant* _tmp3_;
		GVariant* _tmp4_;
#line 248 "../lib/Utils/Desktop.vala"
		_tmp1_ = self->priv->portal;
#line 248 "../lib/Utils/Desktop.vala"
		_tmp2_ = he_portal_settings_read (_tmp1_, "org.freedesktop.appearance", "contrast", &_inner_error0_);
#line 248 "../lib/Utils/Desktop.vala"
		_tmp0_ = _tmp2_;
#line 248 "../lib/Utils/Desktop.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1063 "Desktop.c"
			goto __catch0_g_error;
		}
#line 248 "../lib/Utils/Desktop.vala"
		_tmp3_ = g_variant_get_variant (_tmp0_);
#line 248 "../lib/Utils/Desktop.vala"
		_tmp4_ = _tmp3_;
#line 248 "../lib/Utils/Desktop.vala"
		he_desktop_set_contrast (self, g_variant_get_double (_tmp4_));
#line 248 "../lib/Utils/Desktop.vala"
		_g_variant_unref0 (_tmp4_);
#line 253 "../lib/Utils/Desktop.vala"
		_g_variant_unref0 (_tmp0_);
#line 253 "../lib/Utils/Desktop.vala"
		return;
#line 1078 "Desktop.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp5_;
		const gchar* _tmp6_;
#line 247 "../lib/Utils/Desktop.vala"
		e = _inner_error0_;
#line 247 "../lib/Utils/Desktop.vala"
		_inner_error0_ = NULL;
#line 255 "../lib/Utils/Desktop.vala"
		_tmp5_ = e;
#line 255 "../lib/Utils/Desktop.vala"
		_tmp6_ = _tmp5_->message;
#line 255 "../lib/Utils/Desktop.vala"
		g_debug ("Desktop.vala:255: %s", _tmp6_);
#line 247 "../lib/Utils/Desktop.vala"
		_g_error_free0 (e);
#line 1098 "Desktop.c"
	}
	__finally0:
#line 247 "../lib/Utils/Desktop.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 247 "../lib/Utils/Desktop.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 247 "../lib/Utils/Desktop.vala"
		g_clear_error (&_inner_error0_);
#line 247 "../lib/Utils/Desktop.vala"
		return;
#line 1109 "Desktop.c"
	}
#line 258 "../lib/Utils/Desktop.vala"
	he_desktop_set_contrast (self, 0.0);
#line 1113 "Desktop.c"
}

static void
__lambda6_ (HeDesktop* self,
            const gchar* scheme,
            const gchar* key,
            GVariant* val)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
#line 262 "../lib/Utils/Desktop.vala"
	g_return_if_fail (scheme != NULL);
#line 262 "../lib/Utils/Desktop.vala"
	g_return_if_fail (key != NULL);
#line 262 "../lib/Utils/Desktop.vala"
	g_return_if_fail (val != NULL);
#line 263 "../lib/Utils/Desktop.vala"
	if (g_strcmp0 (scheme, "org.freedesktop.appearance") == 0) {
#line 263 "../lib/Utils/Desktop.vala"
		_tmp0_ = g_strcmp0 (key, "accent-color") == 0;
#line 1138 "Desktop.c"
	} else {
#line 263 "../lib/Utils/Desktop.vala"
		_tmp0_ = FALSE;
#line 1142 "Desktop.c"
	}
#line 263 "../lib/Utils/Desktop.vala"
	if (_tmp0_) {
#line 1146 "Desktop.c"
		HeRGBColor* _tmp1_;
		HeRGBColor* _tmp2_;
#line 264 "../lib/Utils/Desktop.vala"
		_tmp1_ = he_desktop_parse_accent_color (self, val);
#line 264 "../lib/Utils/Desktop.vala"
		_tmp2_ = _tmp1_;
#line 264 "../lib/Utils/Desktop.vala"
		he_desktop_set_accent_color (self, _tmp2_);
#line 264 "../lib/Utils/Desktop.vala"
		_he_rgb_color_free0 (_tmp2_);
#line 1157 "Desktop.c"
	}
#line 267 "../lib/Utils/Desktop.vala"
	if (g_strcmp0 (scheme, "org.freedesktop.appearance") == 0) {
#line 267 "../lib/Utils/Desktop.vala"
		_tmp3_ = g_strcmp0 (key, "font-weight") == 0;
#line 1163 "Desktop.c"
	} else {
#line 267 "../lib/Utils/Desktop.vala"
		_tmp3_ = FALSE;
#line 1167 "Desktop.c"
	}
#line 267 "../lib/Utils/Desktop.vala"
	if (_tmp3_) {
#line 268 "../lib/Utils/Desktop.vala"
		he_desktop_set_font_weight (self, (gdouble) g_variant_get_double (val));
#line 1173 "Desktop.c"
	}
#line 271 "../lib/Utils/Desktop.vala"
	if (g_strcmp0 (scheme, "org.freedesktop.appearance") == 0) {
#line 271 "../lib/Utils/Desktop.vala"
		_tmp4_ = g_strcmp0 (key, "roundness") == 0;
#line 1179 "Desktop.c"
	} else {
#line 271 "../lib/Utils/Desktop.vala"
		_tmp4_ = FALSE;
#line 1183 "Desktop.c"
	}
#line 271 "../lib/Utils/Desktop.vala"
	if (_tmp4_) {
#line 272 "../lib/Utils/Desktop.vala"
		he_desktop_set_roundness (self, (gdouble) g_variant_get_double (val));
#line 1189 "Desktop.c"
	}
#line 275 "../lib/Utils/Desktop.vala"
	if (g_strcmp0 (scheme, "org.freedesktop.appearance") == 0) {
#line 275 "../lib/Utils/Desktop.vala"
		_tmp5_ = g_strcmp0 (key, "ensor-scheme") == 0;
#line 1195 "Desktop.c"
	} else {
#line 275 "../lib/Utils/Desktop.vala"
		_tmp5_ = FALSE;
#line 1199 "Desktop.c"
	}
#line 275 "../lib/Utils/Desktop.vala"
	if (_tmp5_) {
#line 276 "../lib/Utils/Desktop.vala"
		he_desktop_set_ensor_scheme (self, (HeDesktopEnsorScheme) g_variant_get_uint32 (val));
#line 1205 "Desktop.c"
	}
#line 279 "../lib/Utils/Desktop.vala"
	if (g_strcmp0 (scheme, "org.freedesktop.appearance") == 0) {
#line 279 "../lib/Utils/Desktop.vala"
		_tmp6_ = g_strcmp0 (key, "contrast") == 0;
#line 1211 "Desktop.c"
	} else {
#line 279 "../lib/Utils/Desktop.vala"
		_tmp6_ = FALSE;
#line 1215 "Desktop.c"
	}
#line 279 "../lib/Utils/Desktop.vala"
	if (_tmp6_) {
#line 280 "../lib/Utils/Desktop.vala"
		he_desktop_set_contrast (self, (gdouble) g_variant_get_double (val));
#line 1221 "Desktop.c"
	}
#line 283 "../lib/Utils/Desktop.vala"
	if (g_strcmp0 (scheme, "org.freedesktop.appearance") == 0) {
#line 283 "../lib/Utils/Desktop.vala"
		_tmp7_ = g_strcmp0 (key, "color-scheme") == 0;
#line 1227 "Desktop.c"
	} else {
#line 283 "../lib/Utils/Desktop.vala"
		_tmp7_ = FALSE;
#line 1231 "Desktop.c"
	}
#line 283 "../lib/Utils/Desktop.vala"
	if (_tmp7_) {
#line 284 "../lib/Utils/Desktop.vala"
		he_desktop_set_prefers_color_scheme (self, (HeDesktopColorScheme) g_variant_get_uint32 (val));
#line 1237 "Desktop.c"
	}
}

static void
___lambda6__he_portal_settings_setting_changed (HePortalSettings* _sender,
                                                const gchar* namespace,
                                                const gchar* key,
                                                GVariant* val,
                                                gpointer self)
{
#line 262 "../lib/Utils/Desktop.vala"
	__lambda6_ ((HeDesktop*) self, namespace, key, val);
#line 1250 "Desktop.c"
}

static void
he_desktop_init_handle_settings_change (HeDesktop* self)
{
	HePortalSettings* _tmp0_;
#line 261 "../lib/Utils/Desktop.vala"
	g_return_if_fail (self != NULL);
#line 262 "../lib/Utils/Desktop.vala"
	_tmp0_ = self->priv->portal;
#line 262 "../lib/Utils/Desktop.vala"
	g_signal_connect_object (_tmp0_, "setting-changed", (GCallback) ___lambda6__he_portal_settings_setting_changed, self, 0);
#line 1263 "Desktop.c"
}

HeDesktop*
he_desktop_construct (GType object_type)
{
	HeDesktop * self = NULL;
#line 24 "../lib/Utils/Desktop.vala"
	self = (HeDesktop*) g_object_new (object_type, NULL);
#line 24 "../lib/Utils/Desktop.vala"
	return self;
#line 1274 "Desktop.c"
}

HeDesktop*
he_desktop_new (void)
{
#line 24 "../lib/Utils/Desktop.vala"
	return he_desktop_construct (HE_TYPE_DESKTOP);
#line 1282 "Desktop.c"
}

static GObject *
he_desktop_constructor (GType type,
                        guint n_construct_properties,
                        GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
#line 289 "../lib/Utils/Desktop.vala"
	static GWeakRef HeDesktop_singleton__ref;
#line 289 "../lib/Utils/Desktop.vala"
	static GMutex HeDesktop_singleton__lock;
#line 1296 "Desktop.c"
	HeDesktop * self;
	GError* _inner_error0_ = NULL;
#line 289 "../lib/Utils/Desktop.vala"
	g_mutex_lock (&HeDesktop_singleton__lock);
#line 289 "../lib/Utils/Desktop.vala"
	obj = g_weak_ref_get (&HeDesktop_singleton__ref);
#line 289 "../lib/Utils/Desktop.vala"
	if (obj != NULL) {
#line 1305 "Desktop.c"
		g_mutex_unlock (&HeDesktop_singleton__lock);
		return obj;
	}
#line 289 "../lib/Utils/Desktop.vala"
	parent_class = G_OBJECT_CLASS (he_desktop_parent_class);
#line 289 "../lib/Utils/Desktop.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 289 "../lib/Utils/Desktop.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_DESKTOP, HeDesktop);
#line 1315 "Desktop.c"
	{
		HePortalSettings* _tmp0_ = NULL;
		HePortalSettings* _tmp1_;
		HePortalSettings* _tmp2_;
#line 291 "../lib/Utils/Desktop.vala"
		_tmp1_ = he_portal_settings_get (&_inner_error0_);
#line 291 "../lib/Utils/Desktop.vala"
		_tmp0_ = _tmp1_;
#line 291 "../lib/Utils/Desktop.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1326 "Desktop.c"
			goto __catch0_g_error;
		}
#line 291 "../lib/Utils/Desktop.vala"
		_tmp2_ = _tmp0_;
#line 291 "../lib/Utils/Desktop.vala"
		_tmp0_ = NULL;
#line 291 "../lib/Utils/Desktop.vala"
		_g_object_unref0 (self->priv->portal);
#line 291 "../lib/Utils/Desktop.vala"
		self->priv->portal = _tmp2_;
#line 292 "../lib/Utils/Desktop.vala"
		he_desktop_setup_prefers_color_scheme (self);
#line 293 "../lib/Utils/Desktop.vala"
		he_desktop_setup_contrast (self);
#line 294 "../lib/Utils/Desktop.vala"
		he_desktop_setup_roundness (self);
#line 295 "../lib/Utils/Desktop.vala"
		he_desktop_setup_accent_color (self);
#line 296 "../lib/Utils/Desktop.vala"
		he_desktop_setup_ensor_scheme (self);
#line 297 "../lib/Utils/Desktop.vala"
		he_desktop_setup_font_weight (self);
#line 298 "../lib/Utils/Desktop.vala"
		he_desktop_init_handle_settings_change (self);
#line 290 "../lib/Utils/Desktop.vala"
		_g_object_unref0 (_tmp0_);
#line 1353 "Desktop.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
#line 290 "../lib/Utils/Desktop.vala"
		e = _inner_error0_;
#line 290 "../lib/Utils/Desktop.vala"
		_inner_error0_ = NULL;
#line 300 "../lib/Utils/Desktop.vala"
		_tmp3_ = e;
#line 300 "../lib/Utils/Desktop.vala"
		_tmp4_ = _tmp3_->message;
#line 300 "../lib/Utils/Desktop.vala"
		g_debug ("Desktop.vala:300: %s", _tmp4_);
#line 290 "../lib/Utils/Desktop.vala"
		_g_error_free0 (e);
#line 1373 "Desktop.c"
	}
	__finally0:
#line 290 "../lib/Utils/Desktop.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 290 "../lib/Utils/Desktop.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 290 "../lib/Utils/Desktop.vala"
		g_clear_error (&_inner_error0_);
#line 1382 "Desktop.c"
	}
#line 289 "../lib/Utils/Desktop.vala"
	g_weak_ref_set (&HeDesktop_singleton__ref, obj);
#line 289 "../lib/Utils/Desktop.vala"
	g_mutex_unlock (&HeDesktop_singleton__lock);
#line 289 "../lib/Utils/Desktop.vala"
	return obj;
#line 1390 "Desktop.c"
}

static void
he_desktop_class_init (HeDesktopClass * klass,
                       gpointer klass_data)
{
#line 24 "../lib/Utils/Desktop.vala"
	he_desktop_parent_class = g_type_class_peek_parent (klass);
#line 24 "../lib/Utils/Desktop.vala"
	g_type_class_adjust_private_offset (klass, &HeDesktop_private_offset);
#line 24 "../lib/Utils/Desktop.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_he_desktop_get_property;
#line 24 "../lib/Utils/Desktop.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_he_desktop_set_property;
#line 24 "../lib/Utils/Desktop.vala"
	G_OBJECT_CLASS (klass)->constructor = he_desktop_constructor;
#line 24 "../lib/Utils/Desktop.vala"
	G_OBJECT_CLASS (klass)->finalize = he_desktop_finalize;
#line 24 "../lib/Utils/Desktop.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_DESKTOP_PREFERS_COLOR_SCHEME_PROPERTY, he_desktop_properties[HE_DESKTOP_PREFERS_COLOR_SCHEME_PROPERTY] = g_param_spec_enum ("prefers-color-scheme", "prefers-color-scheme", "prefers-color-scheme", HE_DESKTOP_TYPE_COLOR_SCHEME, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../lib/Utils/Desktop.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_DESKTOP_ENSOR_SCHEME_PROPERTY, he_desktop_properties[HE_DESKTOP_ENSOR_SCHEME_PROPERTY] = g_param_spec_enum ("ensor-scheme", "ensor-scheme", "ensor-scheme", HE_DESKTOP_TYPE_ENSOR_SCHEME, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../lib/Utils/Desktop.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_DESKTOP_ACCENT_COLOR_PROPERTY, he_desktop_properties[HE_DESKTOP_ACCENT_COLOR_PROPERTY] = g_param_spec_boxed ("accent-color", "accent-color", "accent-color", HE_TYPE_RGB_COLOR, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../lib/Utils/Desktop.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_DESKTOP_FONT_WEIGHT_PROPERTY, he_desktop_properties[HE_DESKTOP_FONT_WEIGHT_PROPERTY] = g_param_spec_double ("font-weight", "font-weight", "font-weight", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../lib/Utils/Desktop.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_DESKTOP_ROUNDNESS_PROPERTY, he_desktop_properties[HE_DESKTOP_ROUNDNESS_PROPERTY] = g_param_spec_double ("roundness", "roundness", "roundness", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../lib/Utils/Desktop.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_DESKTOP_CONTRAST_PROPERTY, he_desktop_properties[HE_DESKTOP_CONTRAST_PROPERTY] = g_param_spec_double ("contrast", "contrast", "contrast", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1421 "Desktop.c"
}

static void
he_desktop_instance_init (HeDesktop * self,
                          gpointer klass)
{
	gdouble _tmp0_;
	gdouble* _tmp1_;
#line 24 "../lib/Utils/Desktop.vala"
	self->priv = he_desktop_get_instance_private (self);
#line 25 "../lib/Utils/Desktop.vala"
	self->priv->portal = NULL;
#line 39 "../lib/Utils/Desktop.vala"
	self->priv->_prefers_color_scheme = NULL;
#line 95 "../lib/Utils/Desktop.vala"
	self->priv->_ensor_scheme = NULL;
#line 177 "../lib/Utils/Desktop.vala"
	self->priv->_font_weight = 1.0;
#line 207 "../lib/Utils/Desktop.vala"
	self->priv->_roundness = 1.0;
#line 237 "../lib/Utils/Desktop.vala"
	_tmp0_ = 0.0;
#line 237 "../lib/Utils/Desktop.vala"
	_tmp1_ = __double_dup0 (&_tmp0_);
#line 237 "../lib/Utils/Desktop.vala"
	self->priv->_contrast = _tmp1_;
#line 1448 "Desktop.c"
}

static void
he_desktop_finalize (GObject * obj)
{
	HeDesktop * self;
#line 24 "../lib/Utils/Desktop.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_DESKTOP, HeDesktop);
#line 25 "../lib/Utils/Desktop.vala"
	_g_object_unref0 (self->priv->portal);
#line 39 "../lib/Utils/Desktop.vala"
	_g_free0 (self->priv->_prefers_color_scheme);
#line 95 "../lib/Utils/Desktop.vala"
	_g_free0 (self->priv->_ensor_scheme);
#line 123 "../lib/Utils/Desktop.vala"
	_he_rgb_color_free0 (self->priv->_accent_color);
#line 237 "../lib/Utils/Desktop.vala"
	_g_free0 (self->priv->_contrast);
#line 24 "../lib/Utils/Desktop.vala"
	G_OBJECT_CLASS (he_desktop_parent_class)->finalize (obj);
#line 1469 "Desktop.c"
}

/**
 * Helper class to deal with desktop-specific settings.
 */
static GType
he_desktop_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HeDesktopClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) he_desktop_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HeDesktop), 0, (GInstanceInitFunc) he_desktop_instance_init, NULL };
	GType he_desktop_type_id;
	he_desktop_type_id = g_type_register_static (G_TYPE_OBJECT, "HeDesktop", &g_define_type_info, 0);
	HeDesktop_private_offset = g_type_add_instance_private (he_desktop_type_id, sizeof (HeDesktopPrivate));
	return he_desktop_type_id;
}

GType
he_desktop_get_type (void)
{
	static volatile gsize he_desktop_type_id__once = 0;
	if (g_once_init_enter (&he_desktop_type_id__once)) {
		GType he_desktop_type_id;
		he_desktop_type_id = he_desktop_get_type_once ();
		g_once_init_leave (&he_desktop_type_id__once, he_desktop_type_id);
	}
	return he_desktop_type_id__once;
}

static void
_vala_he_desktop_get_property (GObject * object,
                               guint property_id,
                               GValue * value,
                               GParamSpec * pspec)
{
	HeDesktop * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_DESKTOP, HeDesktop);
#line 24 "../lib/Utils/Desktop.vala"
	switch (property_id) {
#line 24 "../lib/Utils/Desktop.vala"
		case HE_DESKTOP_PREFERS_COLOR_SCHEME_PROPERTY:
#line 24 "../lib/Utils/Desktop.vala"
		g_value_set_enum (value, he_desktop_get_prefers_color_scheme (self));
#line 24 "../lib/Utils/Desktop.vala"
		break;
#line 24 "../lib/Utils/Desktop.vala"
		case HE_DESKTOP_ENSOR_SCHEME_PROPERTY:
#line 24 "../lib/Utils/Desktop.vala"
		g_value_set_enum (value, he_desktop_get_ensor_scheme (self));
#line 24 "../lib/Utils/Desktop.vala"
		break;
#line 24 "../lib/Utils/Desktop.vala"
		case HE_DESKTOP_ACCENT_COLOR_PROPERTY:
#line 1521 "Desktop.c"
		{
			HeRGBColor* boxed;
#line 24 "../lib/Utils/Desktop.vala"
			boxed = he_desktop_get_accent_color (self);
#line 24 "../lib/Utils/Desktop.vala"
			g_value_set_boxed (value, boxed);
#line 1528 "Desktop.c"
		}
#line 24 "../lib/Utils/Desktop.vala"
		break;
#line 24 "../lib/Utils/Desktop.vala"
		case HE_DESKTOP_FONT_WEIGHT_PROPERTY:
#line 24 "../lib/Utils/Desktop.vala"
		g_value_set_double (value, he_desktop_get_font_weight (self));
#line 24 "../lib/Utils/Desktop.vala"
		break;
#line 24 "../lib/Utils/Desktop.vala"
		case HE_DESKTOP_ROUNDNESS_PROPERTY:
#line 24 "../lib/Utils/Desktop.vala"
		g_value_set_double (value, he_desktop_get_roundness (self));
#line 24 "../lib/Utils/Desktop.vala"
		break;
#line 24 "../lib/Utils/Desktop.vala"
		case HE_DESKTOP_CONTRAST_PROPERTY:
#line 24 "../lib/Utils/Desktop.vala"
		g_value_set_double (value, he_desktop_get_contrast (self));
#line 24 "../lib/Utils/Desktop.vala"
		break;
#line 1550 "Desktop.c"
		default:
#line 24 "../lib/Utils/Desktop.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../lib/Utils/Desktop.vala"
		break;
#line 1556 "Desktop.c"
	}
}

static void
_vala_he_desktop_set_property (GObject * object,
                               guint property_id,
                               const GValue * value,
                               GParamSpec * pspec)
{
	HeDesktop * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_DESKTOP, HeDesktop);
#line 24 "../lib/Utils/Desktop.vala"
	switch (property_id) {
#line 24 "../lib/Utils/Desktop.vala"
		case HE_DESKTOP_PREFERS_COLOR_SCHEME_PROPERTY:
#line 24 "../lib/Utils/Desktop.vala"
		he_desktop_set_prefers_color_scheme (self, g_value_get_enum (value));
#line 24 "../lib/Utils/Desktop.vala"
		break;
#line 24 "../lib/Utils/Desktop.vala"
		case HE_DESKTOP_ENSOR_SCHEME_PROPERTY:
#line 24 "../lib/Utils/Desktop.vala"
		he_desktop_set_ensor_scheme (self, g_value_get_enum (value));
#line 24 "../lib/Utils/Desktop.vala"
		break;
#line 24 "../lib/Utils/Desktop.vala"
		case HE_DESKTOP_ACCENT_COLOR_PROPERTY:
#line 24 "../lib/Utils/Desktop.vala"
		he_desktop_set_accent_color (self, g_value_get_boxed (value));
#line 24 "../lib/Utils/Desktop.vala"
		break;
#line 24 "../lib/Utils/Desktop.vala"
		case HE_DESKTOP_FONT_WEIGHT_PROPERTY:
#line 24 "../lib/Utils/Desktop.vala"
		he_desktop_set_font_weight (self, g_value_get_double (value));
#line 24 "../lib/Utils/Desktop.vala"
		break;
#line 24 "../lib/Utils/Desktop.vala"
		case HE_DESKTOP_ROUNDNESS_PROPERTY:
#line 24 "../lib/Utils/Desktop.vala"
		he_desktop_set_roundness (self, g_value_get_double (value));
#line 24 "../lib/Utils/Desktop.vala"
		break;
#line 24 "../lib/Utils/Desktop.vala"
		case HE_DESKTOP_CONTRAST_PROPERTY:
#line 24 "../lib/Utils/Desktop.vala"
		he_desktop_set_contrast (self, g_value_get_double (value));
#line 24 "../lib/Utils/Desktop.vala"
		break;
#line 1606 "Desktop.c"
		default:
#line 24 "../lib/Utils/Desktop.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../lib/Utils/Desktop.vala"
		break;
#line 1612 "Desktop.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

