/* Contrast.c generated by valac 0.56.18, the Vala compiler
 * generated from Contrast.vala, do not modify */

#include "libhelium-1.h"
#include <glib.h>
#include <float.h>
#include <math.h>
#include <glib-object.h>
#include <gobject/gvaluecollector.h>
#include <string.h>

#define HE_CONTRAST_CONTRAST_RATIO_EPSILON 0.04
#define HE_CONTRAST_LUMINANCE_GAMUT_MAP_TOLERANCE 0.4
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

typedef struct _HeParamSpecContrast HeParamSpecContrast;

struct _HeParamSpecContrast {
	GParamSpec parent_instance;
};

static gpointer he_contrast_parent_class = NULL;

static HeContrast* he_contrast_new (void);
static HeContrast* he_contrast_construct (GType object_type);
static void he_contrast_finalize (HeContrast * obj);
static GType he_contrast_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static HeContrast*
he_contrast_construct (GType object_type)
{
	HeContrast* self = NULL;
#line 13 "../lib/Utils/Ensor/Contrast.vala"
	self = (HeContrast*) g_type_create_instance (object_type);
#line 13 "../lib/Utils/Ensor/Contrast.vala"
	return self;
#line 47 "Contrast.c"
}

static HeContrast*
he_contrast_new (void)
{
#line 13 "../lib/Utils/Ensor/Contrast.vala"
	return he_contrast_construct (HE_TYPE_CONTRAST);
#line 55 "Contrast.c"
}

/**
     * Contrast ratio is a measure of legibility, used to compare the lightness of two colors.
     */
gdouble
he_contrast_ratio_of_ys (gdouble y1,
                         gdouble y2)
{
	gdouble lighter = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble darker = 0.0;
	gdouble result;
#line 19 "../lib/Utils/Ensor/Contrast.vala"
	lighter = fmax (y1, y2);
#line 20 "../lib/Utils/Ensor/Contrast.vala"
	if (lighter == y2) {
#line 20 "../lib/Utils/Ensor/Contrast.vala"
		_tmp0_ = y1;
#line 75 "Contrast.c"
	} else {
#line 20 "../lib/Utils/Ensor/Contrast.vala"
		_tmp0_ = y2;
#line 79 "Contrast.c"
	}
#line 20 "../lib/Utils/Ensor/Contrast.vala"
	darker = _tmp0_;
#line 21 "../lib/Utils/Ensor/Contrast.vala"
	result = (lighter + 5.0) / (darker + 5.0);
#line 21 "../lib/Utils/Ensor/Contrast.vala"
	return result;
#line 87 "Contrast.c"
}

/**
     * Contrast ratio of two tones (T in HCT, L* in L*a*b*).
     */
gdouble
he_contrast_ratio_of_tones (gdouble t1,
                            gdouble t2)
{
	gdouble result;
#line 28 "../lib/Utils/Ensor/Contrast.vala"
	result = he_contrast_ratio_of_ys (he_math_utils_y_from_lstar (t1), he_math_utils_y_from_lstar (t2));
#line 28 "../lib/Utils/Ensor/Contrast.vala"
	return result;
#line 102 "Contrast.c"
}

/**
     * Returns tone >= tone parameter that ensures the ratio with the input tone.
     */
gdouble
he_contrast_lighter (gdouble tone,
                     gdouble ratio)
{
	gboolean _tmp0_ = FALSE;
	gdouble dark_y = 0.0;
	gdouble light_y = 0.0;
	gboolean _tmp1_ = FALSE;
	gdouble real_contrast = 0.0;
	gdouble delta = 0.0;
	gboolean _tmp2_ = FALSE;
	gdouble return_value = 0.0;
	gboolean _tmp3_ = FALSE;
	gdouble result;
#line 35 "../lib/Utils/Ensor/Contrast.vala"
	if (tone < 0.0) {
#line 35 "../lib/Utils/Ensor/Contrast.vala"
		_tmp0_ = TRUE;
#line 126 "Contrast.c"
	} else {
#line 35 "../lib/Utils/Ensor/Contrast.vala"
		_tmp0_ = tone > 100.0;
#line 130 "Contrast.c"
	}
#line 35 "../lib/Utils/Ensor/Contrast.vala"
	if (_tmp0_) {
#line 36 "../lib/Utils/Ensor/Contrast.vala"
		result = -1.0;
#line 36 "../lib/Utils/Ensor/Contrast.vala"
		return result;
#line 138 "Contrast.c"
	}
#line 39 "../lib/Utils/Ensor/Contrast.vala"
	dark_y = he_math_utils_y_from_lstar (tone);
#line 40 "../lib/Utils/Ensor/Contrast.vala"
	light_y = (ratio * (dark_y + 5.0)) - 5.0;
#line 42 "../lib/Utils/Ensor/Contrast.vala"
	if (light_y < 0.0) {
#line 42 "../lib/Utils/Ensor/Contrast.vala"
		_tmp1_ = TRUE;
#line 148 "Contrast.c"
	} else {
#line 42 "../lib/Utils/Ensor/Contrast.vala"
		_tmp1_ = light_y > 100.0;
#line 152 "Contrast.c"
	}
#line 42 "../lib/Utils/Ensor/Contrast.vala"
	if (_tmp1_) {
#line 43 "../lib/Utils/Ensor/Contrast.vala"
		result = -1.0;
#line 43 "../lib/Utils/Ensor/Contrast.vala"
		return result;
#line 160 "Contrast.c"
	}
#line 46 "../lib/Utils/Ensor/Contrast.vala"
	real_contrast = he_contrast_ratio_of_ys (light_y, dark_y);
#line 47 "../lib/Utils/Ensor/Contrast.vala"
	delta = fabs (real_contrast - ratio);
#line 49 "../lib/Utils/Ensor/Contrast.vala"
	if (real_contrast < ratio) {
#line 49 "../lib/Utils/Ensor/Contrast.vala"
		_tmp2_ = delta > HE_CONTRAST_CONTRAST_RATIO_EPSILON;
#line 170 "Contrast.c"
	} else {
#line 49 "../lib/Utils/Ensor/Contrast.vala"
		_tmp2_ = FALSE;
#line 174 "Contrast.c"
	}
#line 49 "../lib/Utils/Ensor/Contrast.vala"
	if (_tmp2_) {
#line 50 "../lib/Utils/Ensor/Contrast.vala"
		result = -1.0;
#line 50 "../lib/Utils/Ensor/Contrast.vala"
		return result;
#line 182 "Contrast.c"
	}
#line 53 "../lib/Utils/Ensor/Contrast.vala"
	return_value = he_math_utils_lstar_from_y (light_y) + HE_CONTRAST_LUMINANCE_GAMUT_MAP_TOLERANCE;
#line 55 "../lib/Utils/Ensor/Contrast.vala"
	if (return_value < ((gdouble) 0)) {
#line 55 "../lib/Utils/Ensor/Contrast.vala"
		_tmp3_ = TRUE;
#line 190 "Contrast.c"
	} else {
#line 55 "../lib/Utils/Ensor/Contrast.vala"
		_tmp3_ = return_value > ((gdouble) 100);
#line 194 "Contrast.c"
	}
#line 55 "../lib/Utils/Ensor/Contrast.vala"
	if (_tmp3_) {
#line 56 "../lib/Utils/Ensor/Contrast.vala"
		result = -1.0;
#line 56 "../lib/Utils/Ensor/Contrast.vala"
		return result;
#line 202 "Contrast.c"
	}
#line 59 "../lib/Utils/Ensor/Contrast.vala"
	result = return_value;
#line 59 "../lib/Utils/Ensor/Contrast.vala"
	return result;
#line 208 "Contrast.c"
}

/**
     * Tone >= tone parameter that ensures ratio. Returns 100 if ratio cannot be achieved.
     */
gdouble
he_contrast_lighter_unsafe (gdouble tone,
                            gdouble ratio)
{
	gdouble lighter_safe = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble result;
#line 66 "../lib/Utils/Ensor/Contrast.vala"
	lighter_safe = he_contrast_lighter (tone, ratio);
#line 67 "../lib/Utils/Ensor/Contrast.vala"
	if (lighter_safe < 0.0) {
#line 67 "../lib/Utils/Ensor/Contrast.vala"
		_tmp0_ = 100.0;
#line 227 "Contrast.c"
	} else {
#line 67 "../lib/Utils/Ensor/Contrast.vala"
		_tmp0_ = lighter_safe;
#line 231 "Contrast.c"
	}
#line 67 "../lib/Utils/Ensor/Contrast.vala"
	result = _tmp0_;
#line 67 "../lib/Utils/Ensor/Contrast.vala"
	return result;
#line 237 "Contrast.c"
}

/**
     * Returns tone <= tone parameter that ensures the ratio with the input tone.
     */
gdouble
he_contrast_darker (gdouble tone,
                    gdouble ratio)
{
	gboolean _tmp0_ = FALSE;
	gdouble light_y = 0.0;
	gdouble dark_y = 0.0;
	gboolean _tmp1_ = FALSE;
	gdouble real_contrast = 0.0;
	gdouble delta = 0.0;
	gboolean _tmp2_ = FALSE;
	gdouble return_value = 0.0;
	gboolean _tmp3_ = FALSE;
	gdouble result;
#line 74 "../lib/Utils/Ensor/Contrast.vala"
	if (tone < 0.0) {
#line 74 "../lib/Utils/Ensor/Contrast.vala"
		_tmp0_ = TRUE;
#line 261 "Contrast.c"
	} else {
#line 74 "../lib/Utils/Ensor/Contrast.vala"
		_tmp0_ = tone > 100.0;
#line 265 "Contrast.c"
	}
#line 74 "../lib/Utils/Ensor/Contrast.vala"
	if (_tmp0_) {
#line 75 "../lib/Utils/Ensor/Contrast.vala"
		result = -1.0;
#line 75 "../lib/Utils/Ensor/Contrast.vala"
		return result;
#line 273 "Contrast.c"
	}
#line 78 "../lib/Utils/Ensor/Contrast.vala"
	light_y = he_math_utils_y_from_lstar (tone);
#line 79 "../lib/Utils/Ensor/Contrast.vala"
	dark_y = ((light_y + 5.0) / ratio) - 5.0;
#line 81 "../lib/Utils/Ensor/Contrast.vala"
	if (dark_y < 0.0) {
#line 81 "../lib/Utils/Ensor/Contrast.vala"
		_tmp1_ = TRUE;
#line 283 "Contrast.c"
	} else {
#line 81 "../lib/Utils/Ensor/Contrast.vala"
		_tmp1_ = dark_y > 100.0;
#line 287 "Contrast.c"
	}
#line 81 "../lib/Utils/Ensor/Contrast.vala"
	if (_tmp1_) {
#line 82 "../lib/Utils/Ensor/Contrast.vala"
		result = -1.0;
#line 82 "../lib/Utils/Ensor/Contrast.vala"
		return result;
#line 295 "Contrast.c"
	}
#line 85 "../lib/Utils/Ensor/Contrast.vala"
	real_contrast = he_contrast_ratio_of_ys (light_y, dark_y);
#line 86 "../lib/Utils/Ensor/Contrast.vala"
	delta = fabs (real_contrast - ratio);
#line 88 "../lib/Utils/Ensor/Contrast.vala"
	if (real_contrast < ratio) {
#line 88 "../lib/Utils/Ensor/Contrast.vala"
		_tmp2_ = delta > HE_CONTRAST_CONTRAST_RATIO_EPSILON;
#line 305 "Contrast.c"
	} else {
#line 88 "../lib/Utils/Ensor/Contrast.vala"
		_tmp2_ = FALSE;
#line 309 "Contrast.c"
	}
#line 88 "../lib/Utils/Ensor/Contrast.vala"
	if (_tmp2_) {
#line 89 "../lib/Utils/Ensor/Contrast.vala"
		result = -1.0;
#line 89 "../lib/Utils/Ensor/Contrast.vala"
		return result;
#line 317 "Contrast.c"
	}
#line 92 "../lib/Utils/Ensor/Contrast.vala"
	return_value = he_math_utils_lstar_from_y (dark_y) - HE_CONTRAST_LUMINANCE_GAMUT_MAP_TOLERANCE;
#line 94 "../lib/Utils/Ensor/Contrast.vala"
	if (return_value < ((gdouble) 0)) {
#line 94 "../lib/Utils/Ensor/Contrast.vala"
		_tmp3_ = TRUE;
#line 325 "Contrast.c"
	} else {
#line 94 "../lib/Utils/Ensor/Contrast.vala"
		_tmp3_ = return_value > ((gdouble) 100);
#line 329 "Contrast.c"
	}
#line 94 "../lib/Utils/Ensor/Contrast.vala"
	if (_tmp3_) {
#line 95 "../lib/Utils/Ensor/Contrast.vala"
		result = -1.0;
#line 95 "../lib/Utils/Ensor/Contrast.vala"
		return result;
#line 337 "Contrast.c"
	}
#line 98 "../lib/Utils/Ensor/Contrast.vala"
	result = return_value;
#line 98 "../lib/Utils/Ensor/Contrast.vala"
	return result;
#line 343 "Contrast.c"
}

/**
     * Tone <= tone parameter that ensures ratio. Returns 0 if ratio cannot be achieved.
     */
gdouble
he_contrast_darker_unsafe (gdouble tone,
                           gdouble ratio)
{
	gdouble darker_safe = 0.0;
	gdouble result;
#line 105 "../lib/Utils/Ensor/Contrast.vala"
	darker_safe = he_contrast_darker (tone, ratio);
#line 106 "../lib/Utils/Ensor/Contrast.vala"
	result = fmax (0.0, darker_safe);
#line 106 "../lib/Utils/Ensor/Contrast.vala"
	return result;
#line 361 "Contrast.c"
}

static void
he_value_contrast_init (GValue* value)
{
#line 1 "../lib/Utils/Ensor/Contrast.vala"
	value->data[0].v_pointer = NULL;
#line 369 "Contrast.c"
}

static void
he_value_contrast_free_value (GValue* value)
{
#line 1 "../lib/Utils/Ensor/Contrast.vala"
	if (value->data[0].v_pointer) {
#line 1 "../lib/Utils/Ensor/Contrast.vala"
		he_contrast_unref (value->data[0].v_pointer);
#line 379 "Contrast.c"
	}
}

static void
he_value_contrast_copy_value (const GValue* src_value,
                              GValue* dest_value)
{
#line 1 "../lib/Utils/Ensor/Contrast.vala"
	if (src_value->data[0].v_pointer) {
#line 1 "../lib/Utils/Ensor/Contrast.vala"
		dest_value->data[0].v_pointer = he_contrast_ref (src_value->data[0].v_pointer);
#line 391 "Contrast.c"
	} else {
#line 1 "../lib/Utils/Ensor/Contrast.vala"
		dest_value->data[0].v_pointer = NULL;
#line 395 "Contrast.c"
	}
}

static gpointer
he_value_contrast_peek_pointer (const GValue* value)
{
#line 1 "../lib/Utils/Ensor/Contrast.vala"
	return value->data[0].v_pointer;
#line 404 "Contrast.c"
}

static gchar*
he_value_contrast_collect_value (GValue* value,
                                 guint n_collect_values,
                                 GTypeCValue* collect_values,
                                 guint collect_flags)
{
#line 1 "../lib/Utils/Ensor/Contrast.vala"
	if (collect_values[0].v_pointer) {
#line 415 "Contrast.c"
		HeContrast * object;
		object = collect_values[0].v_pointer;
#line 1 "../lib/Utils/Ensor/Contrast.vala"
		if (object->parent_instance.g_class == NULL) {
#line 1 "../lib/Utils/Ensor/Contrast.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 422 "Contrast.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 1 "../lib/Utils/Ensor/Contrast.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 426 "Contrast.c"
		}
#line 1 "../lib/Utils/Ensor/Contrast.vala"
		value->data[0].v_pointer = he_contrast_ref (object);
#line 430 "Contrast.c"
	} else {
#line 1 "../lib/Utils/Ensor/Contrast.vala"
		value->data[0].v_pointer = NULL;
#line 434 "Contrast.c"
	}
#line 1 "../lib/Utils/Ensor/Contrast.vala"
	return NULL;
#line 438 "Contrast.c"
}

static gchar*
he_value_contrast_lcopy_value (const GValue* value,
                               guint n_collect_values,
                               GTypeCValue* collect_values,
                               guint collect_flags)
{
	HeContrast ** object_p;
	object_p = collect_values[0].v_pointer;
#line 1 "../lib/Utils/Ensor/Contrast.vala"
	if (!object_p) {
#line 1 "../lib/Utils/Ensor/Contrast.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 453 "Contrast.c"
	}
#line 1 "../lib/Utils/Ensor/Contrast.vala"
	if (!value->data[0].v_pointer) {
#line 1 "../lib/Utils/Ensor/Contrast.vala"
		*object_p = NULL;
#line 459 "Contrast.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 1 "../lib/Utils/Ensor/Contrast.vala"
		*object_p = value->data[0].v_pointer;
#line 463 "Contrast.c"
	} else {
#line 1 "../lib/Utils/Ensor/Contrast.vala"
		*object_p = he_contrast_ref (value->data[0].v_pointer);
#line 467 "Contrast.c"
	}
#line 1 "../lib/Utils/Ensor/Contrast.vala"
	return NULL;
#line 471 "Contrast.c"
}

GParamSpec*
he_param_spec_contrast (const gchar* name,
                        const gchar* nick,
                        const gchar* blurb,
                        GType object_type,
                        GParamFlags flags)
{
	HeParamSpecContrast* spec;
#line 1 "../lib/Utils/Ensor/Contrast.vala"
	g_return_val_if_fail (g_type_is_a (object_type, HE_TYPE_CONTRAST), NULL);
#line 1 "../lib/Utils/Ensor/Contrast.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 1 "../lib/Utils/Ensor/Contrast.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 1 "../lib/Utils/Ensor/Contrast.vala"
	return G_PARAM_SPEC (spec);
#line 490 "Contrast.c"
}

gpointer
he_value_get_contrast (const GValue* value)
{
#line 1 "../lib/Utils/Ensor/Contrast.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, HE_TYPE_CONTRAST), NULL);
#line 1 "../lib/Utils/Ensor/Contrast.vala"
	return value->data[0].v_pointer;
#line 500 "Contrast.c"
}

void
he_value_set_contrast (GValue* value,
                       gpointer v_object)
{
	HeContrast * old;
#line 1 "../lib/Utils/Ensor/Contrast.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, HE_TYPE_CONTRAST));
#line 1 "../lib/Utils/Ensor/Contrast.vala"
	old = value->data[0].v_pointer;
#line 1 "../lib/Utils/Ensor/Contrast.vala"
	if (v_object) {
#line 1 "../lib/Utils/Ensor/Contrast.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, HE_TYPE_CONTRAST));
#line 1 "../lib/Utils/Ensor/Contrast.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1 "../lib/Utils/Ensor/Contrast.vala"
		value->data[0].v_pointer = v_object;
#line 1 "../lib/Utils/Ensor/Contrast.vala"
		he_contrast_ref (value->data[0].v_pointer);
#line 522 "Contrast.c"
	} else {
#line 1 "../lib/Utils/Ensor/Contrast.vala"
		value->data[0].v_pointer = NULL;
#line 526 "Contrast.c"
	}
#line 1 "../lib/Utils/Ensor/Contrast.vala"
	if (old) {
#line 1 "../lib/Utils/Ensor/Contrast.vala"
		he_contrast_unref (old);
#line 532 "Contrast.c"
	}
}

void
he_value_take_contrast (GValue* value,
                        gpointer v_object)
{
	HeContrast * old;
#line 1 "../lib/Utils/Ensor/Contrast.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, HE_TYPE_CONTRAST));
#line 1 "../lib/Utils/Ensor/Contrast.vala"
	old = value->data[0].v_pointer;
#line 1 "../lib/Utils/Ensor/Contrast.vala"
	if (v_object) {
#line 1 "../lib/Utils/Ensor/Contrast.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, HE_TYPE_CONTRAST));
#line 1 "../lib/Utils/Ensor/Contrast.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1 "../lib/Utils/Ensor/Contrast.vala"
		value->data[0].v_pointer = v_object;
#line 553 "Contrast.c"
	} else {
#line 1 "../lib/Utils/Ensor/Contrast.vala"
		value->data[0].v_pointer = NULL;
#line 557 "Contrast.c"
	}
#line 1 "../lib/Utils/Ensor/Contrast.vala"
	if (old) {
#line 1 "../lib/Utils/Ensor/Contrast.vala"
		he_contrast_unref (old);
#line 563 "Contrast.c"
	}
}

static void
he_contrast_class_init (HeContrastClass * klass,
                        gpointer klass_data)
{
#line 1 "../lib/Utils/Ensor/Contrast.vala"
	he_contrast_parent_class = g_type_class_peek_parent (klass);
#line 1 "../lib/Utils/Ensor/Contrast.vala"
	((HeContrastClass *) klass)->finalize = he_contrast_finalize;
#line 575 "Contrast.c"
}

static void
he_contrast_instance_init (HeContrast * self,
                           gpointer klass)
{
#line 1 "../lib/Utils/Ensor/Contrast.vala"
	self->ref_count = 1;
#line 584 "Contrast.c"
}

static void
he_contrast_finalize (HeContrast * obj)
{
	HeContrast * self;
#line 1 "../lib/Utils/Ensor/Contrast.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_CONTRAST, HeContrast);
#line 1 "../lib/Utils/Ensor/Contrast.vala"
	g_signal_handlers_destroy (self);
#line 595 "Contrast.c"
}

static GType
he_contrast_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { he_value_contrast_init, he_value_contrast_free_value, he_value_contrast_copy_value, he_value_contrast_peek_pointer, "p", he_value_contrast_collect_value, "p", he_value_contrast_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (HeContrastClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) he_contrast_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HeContrast), 0, (GInstanceInitFunc) he_contrast_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType he_contrast_type_id;
	he_contrast_type_id = g_type_register_fundamental (g_type_fundamental_next (), "HeContrast", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return he_contrast_type_id;
}

GType
he_contrast_get_type (void)
{
	static volatile gsize he_contrast_type_id__once = 0;
	if (g_once_init_enter (&he_contrast_type_id__once)) {
		GType he_contrast_type_id;
		he_contrast_type_id = he_contrast_get_type_once ();
		g_once_init_leave (&he_contrast_type_id__once, he_contrast_type_id);
	}
	return he_contrast_type_id__once;
}

gpointer
he_contrast_ref (gpointer instance)
{
	HeContrast * self;
	self = instance;
#line 1 "../lib/Utils/Ensor/Contrast.vala"
	g_atomic_int_inc (&self->ref_count);
#line 1 "../lib/Utils/Ensor/Contrast.vala"
	return instance;
#line 630 "Contrast.c"
}

void
he_contrast_unref (gpointer instance)
{
	HeContrast * self;
	self = instance;
#line 1 "../lib/Utils/Ensor/Contrast.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 1 "../lib/Utils/Ensor/Contrast.vala"
		HE_CONTRAST_GET_CLASS (self)->finalize (self);
#line 1 "../lib/Utils/Ensor/Contrast.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 644 "Contrast.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

