/* Content.c generated by valac 0.56.18, the Vala compiler
 * generated from Content.vala, do not modify */

/*
 * Copyright (c) 2023 Fyra Labs
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 */

#include "libhelium-1.h"
#include <glib.h>
#include <float.h>
#include <math.h>
#include <glib-object.h>
#include <string.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	HE_CONTENT_SCHEME_0_PROPERTY,
	HE_CONTENT_SCHEME_NUM_PROPERTIES
};
static GParamSpec* he_content_scheme_properties[HE_CONTENT_SCHEME_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

static gpointer he_content_scheme_parent_class = NULL;

static void _he_hct_color_free0_ (gpointer var);
static inline void _g_list_free__he_hct_color_free0_ (GList* self);
static GType he_content_scheme_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

/**
     * A theme in which the primary color does not shift.
     * Useful for content such as Album Art, Images, etc. suppling color for UI.
     */
static void
_he_hct_color_free0_ (gpointer var)
{
#line 25 "../lib/Utils/Ensor/Schemes/Content.vala"
	(var == NULL) ? NULL : (var = (he_hct_color_free (var), NULL));
#line 64 "Content.c"
}

static inline void
_g_list_free__he_hct_color_free0_ (GList* self)
{
#line 25 "../lib/Utils/Ensor/Schemes/Content.vala"
	g_list_free_full (self, (GDestroyNotify) _he_hct_color_free0_);
#line 72 "Content.c"
}

HeDynamicScheme*
he_content_scheme_generate (HeContentScheme* self,
                            HeHCTColor* hct,
                            gboolean is_dark,
                            gdouble contrast)
{
	HeHCTColor _tmp0_;
	HeHCTColor _tmp1_;
	HeHCTColor _tmp2_;
	HeTonalPalette* _tmp3_;
	HeTonalPalette* _tmp4_;
	HeHCTColor _tmp5_;
	HeHCTColor _tmp6_;
	HeHCTColor _tmp7_;
	HeTonalPalette* _tmp8_;
	HeTonalPalette* _tmp9_;
	HeHCTColor _tmp10_;
	HeTemperatureCache* _tmp11_;
	HeTemperatureCache* _tmp12_;
	GList* _tmp13_;
	GList* _tmp14_;
	gconstpointer _tmp15_;
	HeHCTColor _tmp16_;
	HeHCTColor _tmp17_ = {0};
	HeTonalPalette* _tmp18_;
	HeTonalPalette* _tmp19_;
	HeHCTColor _tmp20_;
	HeHCTColor _tmp21_;
	HeTonalPalette* _tmp22_;
	HeTonalPalette* _tmp23_;
	HeHCTColor _tmp24_;
	HeHCTColor _tmp25_;
	HeTonalPalette* _tmp26_;
	HeTonalPalette* _tmp27_;
	HeDynamicScheme* _tmp28_;
	HeDynamicScheme* _tmp29_;
	HeDynamicScheme* result;
#line 24 "../lib/Utils/Ensor/Schemes/Content.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 24 "../lib/Utils/Ensor/Schemes/Content.vala"
	g_return_val_if_fail (hct != NULL, NULL);
#line 25 "../lib/Utils/Ensor/Schemes/Content.vala"
	_tmp0_ = *hct;
#line 25 "../lib/Utils/Ensor/Schemes/Content.vala"
	_tmp1_ = *hct;
#line 25 "../lib/Utils/Ensor/Schemes/Content.vala"
	_tmp2_ = *hct;
#line 25 "../lib/Utils/Ensor/Schemes/Content.vala"
	_tmp3_ = he_tonal_palette_from_hue_and_chroma (_tmp1_.h, _tmp2_.c);
#line 25 "../lib/Utils/Ensor/Schemes/Content.vala"
	_tmp4_ = _tmp3_;
#line 25 "../lib/Utils/Ensor/Schemes/Content.vala"
	_tmp5_ = *hct;
#line 25 "../lib/Utils/Ensor/Schemes/Content.vala"
	_tmp6_ = *hct;
#line 25 "../lib/Utils/Ensor/Schemes/Content.vala"
	_tmp7_ = *hct;
#line 25 "../lib/Utils/Ensor/Schemes/Content.vala"
	_tmp8_ = he_tonal_palette_from_hue_and_chroma (_tmp5_.h, he_math_utils_max (_tmp6_.c - 32.0, _tmp7_.c * 0.5));
#line 25 "../lib/Utils/Ensor/Schemes/Content.vala"
	_tmp9_ = _tmp8_;
#line 25 "../lib/Utils/Ensor/Schemes/Content.vala"
	_tmp10_ = *hct;
#line 25 "../lib/Utils/Ensor/Schemes/Content.vala"
	_tmp11_ = he_temperature_cache_new (&_tmp10_);
#line 25 "../lib/Utils/Ensor/Schemes/Content.vala"
	_tmp12_ = _tmp11_;
#line 25 "../lib/Utils/Ensor/Schemes/Content.vala"
	_tmp13_ = he_temperature_cache_analogous (_tmp12_, 3, 6);
#line 25 "../lib/Utils/Ensor/Schemes/Content.vala"
	_tmp14_ = _tmp13_;
#line 25 "../lib/Utils/Ensor/Schemes/Content.vala"
	_tmp15_ = g_list_nth_data (_tmp14_, (guint) 1);
#line 25 "../lib/Utils/Ensor/Schemes/Content.vala"
	_tmp16_ = *((HeHCTColor*) _tmp15_);
#line 25 "../lib/Utils/Ensor/Schemes/Content.vala"
	he_fix_disliked (&_tmp16_, &_tmp17_);
#line 25 "../lib/Utils/Ensor/Schemes/Content.vala"
	_tmp18_ = he_tonal_palette_from_hct (&_tmp17_);
#line 25 "../lib/Utils/Ensor/Schemes/Content.vala"
	_tmp19_ = _tmp18_;
#line 25 "../lib/Utils/Ensor/Schemes/Content.vala"
	_tmp20_ = *hct;
#line 25 "../lib/Utils/Ensor/Schemes/Content.vala"
	_tmp21_ = *hct;
#line 25 "../lib/Utils/Ensor/Schemes/Content.vala"
	_tmp22_ = he_tonal_palette_from_hue_and_chroma (_tmp20_.h, _tmp21_.c / 8.0);
#line 25 "../lib/Utils/Ensor/Schemes/Content.vala"
	_tmp23_ = _tmp22_;
#line 25 "../lib/Utils/Ensor/Schemes/Content.vala"
	_tmp24_ = *hct;
#line 25 "../lib/Utils/Ensor/Schemes/Content.vala"
	_tmp25_ = *hct;
#line 25 "../lib/Utils/Ensor/Schemes/Content.vala"
	_tmp26_ = he_tonal_palette_from_hue_and_chroma (_tmp24_.h, (_tmp25_.c / 8.0) + 4.0);
#line 25 "../lib/Utils/Ensor/Schemes/Content.vala"
	_tmp27_ = _tmp26_;
#line 25 "../lib/Utils/Ensor/Schemes/Content.vala"
	_tmp28_ = he_dynamic_scheme_new (&_tmp0_, HE_SCHEME_VARIANT_CONTENT, is_dark, contrast, _tmp4_, _tmp9_, _tmp19_, _tmp23_, _tmp27_, NULL);
#line 25 "../lib/Utils/Ensor/Schemes/Content.vala"
	_tmp29_ = _tmp28_;
#line 25 "../lib/Utils/Ensor/Schemes/Content.vala"
	_g_object_unref0 (_tmp27_);
#line 25 "../lib/Utils/Ensor/Schemes/Content.vala"
	_g_object_unref0 (_tmp23_);
#line 25 "../lib/Utils/Ensor/Schemes/Content.vala"
	_g_object_unref0 (_tmp19_);
#line 25 "../lib/Utils/Ensor/Schemes/Content.vala"
	(_tmp14_ == NULL) ? NULL : (_tmp14_ = (_g_list_free__he_hct_color_free0_ (_tmp14_), NULL));
#line 25 "../lib/Utils/Ensor/Schemes/Content.vala"
	_g_object_unref0 (_tmp12_);
#line 25 "../lib/Utils/Ensor/Schemes/Content.vala"
	_g_object_unref0 (_tmp9_);
#line 25 "../lib/Utils/Ensor/Schemes/Content.vala"
	_g_object_unref0 (_tmp4_);
#line 25 "../lib/Utils/Ensor/Schemes/Content.vala"
	result = _tmp29_;
#line 25 "../lib/Utils/Ensor/Schemes/Content.vala"
	return result;
#line 194 "Content.c"
}

HeContentScheme*
he_content_scheme_construct (GType object_type)
{
	HeContentScheme * self = NULL;
#line 19 "../lib/Utils/Ensor/Schemes/Content.vala"
	self = (HeContentScheme*) g_object_new (object_type, NULL);
#line 19 "../lib/Utils/Ensor/Schemes/Content.vala"
	return self;
#line 205 "Content.c"
}

HeContentScheme*
he_content_scheme_new (void)
{
#line 19 "../lib/Utils/Ensor/Schemes/Content.vala"
	return he_content_scheme_construct (HE_TYPE_CONTENT_SCHEME);
#line 213 "Content.c"
}

static void
he_content_scheme_class_init (HeContentSchemeClass * klass,
                              gpointer klass_data)
{
#line 19 "../lib/Utils/Ensor/Schemes/Content.vala"
	he_content_scheme_parent_class = g_type_class_peek_parent (klass);
#line 222 "Content.c"
}

static void
he_content_scheme_instance_init (HeContentScheme * self,
                                 gpointer klass)
{
}

static GType
he_content_scheme_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HeContentSchemeClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) he_content_scheme_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HeContentScheme), 0, (GInstanceInitFunc) he_content_scheme_instance_init, NULL };
	GType he_content_scheme_type_id;
	he_content_scheme_type_id = g_type_register_static (G_TYPE_OBJECT, "HeContentScheme", &g_define_type_info, 0);
	return he_content_scheme_type_id;
}

GType
he_content_scheme_get_type (void)
{
	static volatile gsize he_content_scheme_type_id__once = 0;
	if (g_once_init_enter (&he_content_scheme_type_id__once)) {
		GType he_content_scheme_type_id;
		he_content_scheme_type_id = he_content_scheme_get_type_once ();
		g_once_init_leave (&he_content_scheme_type_id__once, he_content_scheme_type_id);
	}
	return he_content_scheme_type_id__once;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

