/* TemperatureCache.c generated by valac 0.56.18, the Vala compiler
 * generated from TemperatureCache.vala, do not modify */

/*
 * Copyright (c) 2024 Fyra Labs
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 */

#include "libhelium-1.h"
#include <gee.h>
#include <glib-object.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <string.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	HE_TEMPERATURE_CACHE_0_PROPERTY,
	HE_TEMPERATURE_CACHE_INPUT_PROPERTY,
	HE_TEMPERATURE_CACHE_NUM_PROPERTIES
};
static GParamSpec* he_temperature_cache_properties[HE_TEMPERATURE_CACHE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _he_hct_color_free0(var) ((var == NULL) ? NULL : (var = (he_hct_color_free (var), NULL)))
#define _g_free0(var) ((var == NULL) ? NULL : (var = (g_free (var), NULL)))

struct _HeTemperatureCachePrivate {
	HeHCTColor _input;
	GeeHashMap* temps_by_hct_cache;
	gdouble input_relative_temperature_cache;
};

static gint HeTemperatureCache_private_offset;
static gpointer he_temperature_cache_parent_class = NULL;

static gboolean _he_hct_color_equal (const HeHCTColor * s1,
                              const HeHCTColor * s2);
static gdouble* _double_dup (gdouble* self);
static GList* he_temperature_cache_get_hcts_by_hue (HeTemperatureCache* self);
static gint __lambda120_ (HeTemperatureCache* self,
                   HeHCTColor* a,
                   HeHCTColor* b);
static gint ___lambda120__gcompare_data_func (gconstpointer a,
                                       gconstpointer b,
                                       gpointer self);
static void _he_hct_color_free0_ (gpointer var);
static inline void _g_list_free__he_hct_color_free0_ (GList* self);
static HeHCTColor* he_temperature_cache_get_closest_hct (HeTemperatureCache* self,
                                                  gdouble hue);
static gdouble he_temperature_cache_relative_temperature (HeTemperatureCache* self,
                                                   HeHCTColor* hct);
static gdouble he_temperature_cache_calculate_temp (HeTemperatureCache* self,
                                             HeHCTColor* hct);
static void he_temperature_cache_finalize (GObject * obj);
static GType he_temperature_cache_get_type_once (void);
static void _vala_he_temperature_cache_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec);
static void _vala_he_temperature_cache_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
he_temperature_cache_get_instance_private (HeTemperatureCache* self)
{
	return G_STRUCT_MEMBER_P (self, HeTemperatureCache_private_offset);
}

void
he_temperature_cache_get_input (HeTemperatureCache* self,
                                HeHCTColor * result)
{
	HeHCTColor _tmp0_;
#line 22 "../lib/Utils/Ensor/TemperatureCache.vala"
	g_return_if_fail (self != NULL);
#line 22 "../lib/Utils/Ensor/TemperatureCache.vala"
	_tmp0_ = self->priv->_input;
#line 22 "../lib/Utils/Ensor/TemperatureCache.vala"
	*result = _tmp0_;
#line 22 "../lib/Utils/Ensor/TemperatureCache.vala"
	return;
#line 110 "TemperatureCache.c"
}

static gboolean
_he_hct_color_equal (const HeHCTColor * s1,
                     const HeHCTColor * s2)
{
#line 22 "../lib/Utils/Ensor/TemperatureCache.vala"
	if (s1 == s2) {
#line 22 "../lib/Utils/Ensor/TemperatureCache.vala"
		return TRUE;
#line 121 "TemperatureCache.c"
	}
#line 22 "../lib/Utils/Ensor/TemperatureCache.vala"
	if (s1 == NULL) {
#line 22 "../lib/Utils/Ensor/TemperatureCache.vala"
		return FALSE;
#line 127 "TemperatureCache.c"
	}
#line 22 "../lib/Utils/Ensor/TemperatureCache.vala"
	if (s2 == NULL) {
#line 22 "../lib/Utils/Ensor/TemperatureCache.vala"
		return FALSE;
#line 133 "TemperatureCache.c"
	}
#line 22 "../lib/Utils/Ensor/TemperatureCache.vala"
	if (s1->h != s2->h) {
#line 22 "../lib/Utils/Ensor/TemperatureCache.vala"
		return FALSE;
#line 139 "TemperatureCache.c"
	}
#line 22 "../lib/Utils/Ensor/TemperatureCache.vala"
	if (s1->c != s2->c) {
#line 22 "../lib/Utils/Ensor/TemperatureCache.vala"
		return FALSE;
#line 145 "TemperatureCache.c"
	}
#line 22 "../lib/Utils/Ensor/TemperatureCache.vala"
	if (s1->t != s2->t) {
#line 22 "../lib/Utils/Ensor/TemperatureCache.vala"
		return FALSE;
#line 151 "TemperatureCache.c"
	}
#line 22 "../lib/Utils/Ensor/TemperatureCache.vala"
	if (s1->a != s2->a) {
#line 22 "../lib/Utils/Ensor/TemperatureCache.vala"
		return FALSE;
#line 157 "TemperatureCache.c"
	}
#line 22 "../lib/Utils/Ensor/TemperatureCache.vala"
	return TRUE;
#line 161 "TemperatureCache.c"
}

void
he_temperature_cache_set_input (HeTemperatureCache* self,
                                HeHCTColor * value)
{
	HeHCTColor old_value;
#line 22 "../lib/Utils/Ensor/TemperatureCache.vala"
	g_return_if_fail (self != NULL);
#line 22 "../lib/Utils/Ensor/TemperatureCache.vala"
	he_temperature_cache_get_input (self, &old_value);
#line 22 "../lib/Utils/Ensor/TemperatureCache.vala"
	if (_he_hct_color_equal (value, &old_value) != TRUE) {
#line 175 "TemperatureCache.c"
		HeHCTColor _tmp0_;
#line 22 "../lib/Utils/Ensor/TemperatureCache.vala"
		_tmp0_ = *value;
#line 22 "../lib/Utils/Ensor/TemperatureCache.vala"
		self->priv->_input = _tmp0_;
#line 22 "../lib/Utils/Ensor/TemperatureCache.vala"
		g_object_notify_by_pspec ((GObject *) self, he_temperature_cache_properties[HE_TEMPERATURE_CACHE_INPUT_PROPERTY]);
#line 183 "TemperatureCache.c"
	}
}

static gdouble*
_double_dup (gdouble* self)
{
	gdouble* dup;
#line 23 "../lib/Utils/Ensor/TemperatureCache.vala"
	dup = g_new0 (gdouble, 1);
#line 23 "../lib/Utils/Ensor/TemperatureCache.vala"
	memcpy (dup, self, sizeof (gdouble));
#line 23 "../lib/Utils/Ensor/TemperatureCache.vala"
	return dup;
#line 197 "TemperatureCache.c"
}

HeTemperatureCache*
he_temperature_cache_construct (GType object_type,
                                HeHCTColor* input)
{
	HeTemperatureCache * self = NULL;
	HeHCTColor _tmp0_;
#line 26 "../lib/Utils/Ensor/TemperatureCache.vala"
	g_return_val_if_fail (input != NULL, NULL);
#line 26 "../lib/Utils/Ensor/TemperatureCache.vala"
	self = (HeTemperatureCache*) g_object_new (object_type, NULL);
#line 27 "../lib/Utils/Ensor/TemperatureCache.vala"
	_tmp0_ = *input;
#line 27 "../lib/Utils/Ensor/TemperatureCache.vala"
	he_temperature_cache_set_input (self, &_tmp0_);
#line 26 "../lib/Utils/Ensor/TemperatureCache.vala"
	return self;
#line 216 "TemperatureCache.c"
}

HeTemperatureCache*
he_temperature_cache_new (HeHCTColor* input)
{
#line 26 "../lib/Utils/Ensor/TemperatureCache.vala"
	return he_temperature_cache_construct (HE_TYPE_TEMPERATURE_CACHE, input);
#line 224 "TemperatureCache.c"
}

static gpointer
_he_hct_color_dup0 (gpointer self)
{
#line 32 "../lib/Utils/Ensor/TemperatureCache.vala"
	return self ? he_hct_color_dup (self) : NULL;
#line 232 "TemperatureCache.c"
}

static gint
__lambda120_ (HeTemperatureCache* self,
              HeHCTColor* a,
              HeHCTColor* b)
{
	HeHCTColor _tmp0_;
	HeHCTColor _tmp1_;
	gint result;
#line 33 "../lib/Utils/Ensor/TemperatureCache.vala"
	_tmp0_ = *a;
#line 33 "../lib/Utils/Ensor/TemperatureCache.vala"
	_tmp1_ = *b;
#line 33 "../lib/Utils/Ensor/TemperatureCache.vala"
	result = he_temperature_cache_diff_temps (self, &_tmp0_, &_tmp1_);
#line 33 "../lib/Utils/Ensor/TemperatureCache.vala"
	return result;
#line 251 "TemperatureCache.c"
}

static gint
___lambda120__gcompare_data_func (gconstpointer a,
                                  gconstpointer b,
                                  gpointer self)
{
	gint result;
	result = __lambda120_ ((HeTemperatureCache*) self, (HeHCTColor*) a, (HeHCTColor*) b);
#line 33 "../lib/Utils/Ensor/TemperatureCache.vala"
	return result;
#line 263 "TemperatureCache.c"
}

GList*
he_temperature_cache_get_hcts_by_temp (HeTemperatureCache* self)
{
	GList* hcts = NULL;
	GList* _tmp0_;
	HeHCTColor _tmp1_;
	HeHCTColor* _tmp2_;
	GList* result;
#line 30 "../lib/Utils/Ensor/TemperatureCache.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 31 "../lib/Utils/Ensor/TemperatureCache.vala"
	_tmp0_ = he_temperature_cache_get_hcts_by_hue (self);
#line 31 "../lib/Utils/Ensor/TemperatureCache.vala"
	hcts = _tmp0_;
#line 32 "../lib/Utils/Ensor/TemperatureCache.vala"
	_tmp1_ = self->priv->_input;
#line 32 "../lib/Utils/Ensor/TemperatureCache.vala"
	_tmp2_ = _he_hct_color_dup0 (&_tmp1_);
#line 32 "../lib/Utils/Ensor/TemperatureCache.vala"
	hcts = g_list_append (hcts, _tmp2_);
#line 33 "../lib/Utils/Ensor/TemperatureCache.vala"
	hcts = g_list_sort_with_data (hcts, ___lambda120__gcompare_data_func, self);
#line 35 "../lib/Utils/Ensor/TemperatureCache.vala"
	result = hcts;
#line 35 "../lib/Utils/Ensor/TemperatureCache.vala"
	return result;
#line 292 "TemperatureCache.c"
}

gint
he_temperature_cache_diff_temps (HeTemperatureCache* self,
                                 HeHCTColor* a,
                                 HeHCTColor* b)
{
	HeHCTColor _tmp0_;
	HeHCTColor _tmp1_;
	gint result;
#line 38 "../lib/Utils/Ensor/TemperatureCache.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 38 "../lib/Utils/Ensor/TemperatureCache.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 38 "../lib/Utils/Ensor/TemperatureCache.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 39 "../lib/Utils/Ensor/TemperatureCache.vala"
	_tmp0_ = *a;
#line 39 "../lib/Utils/Ensor/TemperatureCache.vala"
	_tmp1_ = *b;
#line 39 "../lib/Utils/Ensor/TemperatureCache.vala"
	result = ((gint) he_temperature_cache_get_temp (self, &_tmp0_)) - ((gint) he_temperature_cache_get_temp (self, &_tmp1_));
#line 39 "../lib/Utils/Ensor/TemperatureCache.vala"
	return result;
#line 317 "TemperatureCache.c"
}

static void
_he_hct_color_free0_ (gpointer var)
{
#line 43 "../lib/Utils/Ensor/TemperatureCache.vala"
	(var == NULL) ? NULL : (var = (he_hct_color_free (var), NULL));
#line 325 "TemperatureCache.c"
}

static inline void
_g_list_free__he_hct_color_free0_ (GList* self)
{
#line 43 "../lib/Utils/Ensor/TemperatureCache.vala"
	g_list_free_full (self, (GDestroyNotify) _he_hct_color_free0_);
#line 333 "TemperatureCache.c"
}

void
he_temperature_cache_get_warmest (HeTemperatureCache* self,
                                  HeHCTColor* result)
{
	GList* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
	gconstpointer _tmp3_;
	HeHCTColor _tmp4_;
#line 42 "../lib/Utils/Ensor/TemperatureCache.vala"
	g_return_if_fail (self != NULL);
#line 43 "../lib/Utils/Ensor/TemperatureCache.vala"
	_tmp0_ = he_temperature_cache_get_hcts_by_temp (self);
#line 43 "../lib/Utils/Ensor/TemperatureCache.vala"
	_tmp1_ = _tmp0_;
#line 43 "../lib/Utils/Ensor/TemperatureCache.vala"
	_tmp2_ = g_list_last (_tmp1_);
#line 43 "../lib/Utils/Ensor/TemperatureCache.vala"
	_tmp3_ = _tmp2_->data;
#line 43 "../lib/Utils/Ensor/TemperatureCache.vala"
	_tmp4_ = *((HeHCTColor*) _tmp3_);
#line 43 "../lib/Utils/Ensor/TemperatureCache.vala"
	(_tmp1_ == NULL) ? NULL : (_tmp1_ = (_g_list_free__he_hct_color_free0_ (_tmp1_), NULL));
#line 43 "../lib/Utils/Ensor/TemperatureCache.vala"
	*result = _tmp4_;
#line 43 "../lib/Utils/Ensor/TemperatureCache.vala"
	return;
#line 363 "TemperatureCache.c"
}

void
he_temperature_cache_get_coldest (HeTemperatureCache* self,
                                  HeHCTColor* result)
{
	GList* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
	gconstpointer _tmp3_;
	HeHCTColor _tmp4_;
#line 46 "../lib/Utils/Ensor/TemperatureCache.vala"
	g_return_if_fail (self != NULL);
#line 47 "../lib/Utils/Ensor/TemperatureCache.vala"
	_tmp0_ = he_temperature_cache_get_hcts_by_temp (self);
#line 47 "../lib/Utils/Ensor/TemperatureCache.vala"
	_tmp1_ = _tmp0_;
#line 47 "../lib/Utils/Ensor/TemperatureCache.vala"
	_tmp2_ = g_list_first (_tmp1_);
#line 47 "../lib/Utils/Ensor/TemperatureCache.vala"
	_tmp3_ = _tmp2_->data;
#line 47 "../lib/Utils/Ensor/TemperatureCache.vala"
	_tmp4_ = *((HeHCTColor*) _tmp3_);
#line 47 "../lib/Utils/Ensor/TemperatureCache.vala"
	(_tmp1_ == NULL) ? NULL : (_tmp1_ = (_g_list_free__he_hct_color_free0_ (_tmp1_), NULL));
#line 47 "../lib/Utils/Ensor/TemperatureCache.vala"
	*result = _tmp4_;
#line 47 "../lib/Utils/Ensor/TemperatureCache.vala"
	return;
#line 393 "TemperatureCache.c"
}

void
he_temperature_cache_get_complement (HeTemperatureCache* self,
                                     HeHCTColor* result)
{
	gdouble complement_hue = 0.0;
	HeHCTColor _tmp0_;
	HeHCTColor _tmp1_;
	HeHCTColor _tmp2_;
	HeHCTColor _tmp3_ = {0};
#line 50 "../lib/Utils/Ensor/TemperatureCache.vala"
	g_return_if_fail (self != NULL);
#line 51 "../lib/Utils/Ensor/TemperatureCache.vala"
	_tmp0_ = self->priv->_input;
#line 51 "../lib/Utils/Ensor/TemperatureCache.vala"
	complement_hue = fmod (_tmp0_.h + 180.0, 360.0);
#line 52 "../lib/Utils/Ensor/TemperatureCache.vala"
	_tmp1_ = self->priv->_input;
#line 52 "../lib/Utils/Ensor/TemperatureCache.vala"
	_tmp2_ = self->priv->_input;
#line 52 "../lib/Utils/Ensor/TemperatureCache.vala"
	he_from_params (complement_hue, _tmp1_.c, _tmp2_.t, &_tmp3_);
#line 52 "../lib/Utils/Ensor/TemperatureCache.vala"
	*result = _tmp3_;
#line 52 "../lib/Utils/Ensor/TemperatureCache.vala"
	return;
#line 421 "TemperatureCache.c"
}

GList*
he_temperature_cache_analogous (HeTemperatureCache* self,
                                gint count,
                                gint divisions)
{
	GList* analogous_colors = NULL;
	gdouble step = 0.0;
	GList* result;
#line 55 "../lib/Utils/Ensor/TemperatureCache.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 56 "../lib/Utils/Ensor/TemperatureCache.vala"
	analogous_colors = NULL;
#line 57 "../lib/Utils/Ensor/TemperatureCache.vala"
	step = 360.0 / divisions;
#line 438 "TemperatureCache.c"
	{
		gint i = 0;
#line 59 "../lib/Utils/Ensor/TemperatureCache.vala"
		i = 0;
#line 443 "TemperatureCache.c"
		{
			gboolean _tmp0_ = FALSE;
#line 59 "../lib/Utils/Ensor/TemperatureCache.vala"
			_tmp0_ = TRUE;
#line 59 "../lib/Utils/Ensor/TemperatureCache.vala"
			while (TRUE) {
#line 450 "TemperatureCache.c"
				gdouble hue = 0.0;
				HeHCTColor _tmp2_;
				HeHCTColor* closest_hct = NULL;
				HeHCTColor* _tmp3_;
				HeHCTColor* _tmp4_;
				HeHCTColor* _tmp5_;
#line 59 "../lib/Utils/Ensor/TemperatureCache.vala"
				if (!_tmp0_) {
#line 459 "TemperatureCache.c"
					gint _tmp1_;
#line 59 "../lib/Utils/Ensor/TemperatureCache.vala"
					_tmp1_ = i;
#line 59 "../lib/Utils/Ensor/TemperatureCache.vala"
					i = _tmp1_ + 1;
#line 465 "TemperatureCache.c"
				}
#line 59 "../lib/Utils/Ensor/TemperatureCache.vala"
				_tmp0_ = FALSE;
#line 59 "../lib/Utils/Ensor/TemperatureCache.vala"
				if (!(i < count)) {
#line 59 "../lib/Utils/Ensor/TemperatureCache.vala"
					break;
#line 473 "TemperatureCache.c"
				}
#line 60 "../lib/Utils/Ensor/TemperatureCache.vala"
				_tmp2_ = self->priv->_input;
#line 60 "../lib/Utils/Ensor/TemperatureCache.vala"
				hue = fmod (_tmp2_.h + (i * step), 360.0);
#line 61 "../lib/Utils/Ensor/TemperatureCache.vala"
				_tmp3_ = he_temperature_cache_get_closest_hct (self, hue);
#line 61 "../lib/Utils/Ensor/TemperatureCache.vala"
				closest_hct = _tmp3_;
#line 62 "../lib/Utils/Ensor/TemperatureCache.vala"
				_tmp4_ = closest_hct;
#line 62 "../lib/Utils/Ensor/TemperatureCache.vala"
				_tmp5_ = _he_hct_color_dup0 (_tmp4_);
#line 62 "../lib/Utils/Ensor/TemperatureCache.vala"
				analogous_colors = g_list_append (analogous_colors, _tmp5_);
#line 59 "../lib/Utils/Ensor/TemperatureCache.vala"
				_he_hct_color_free0 (closest_hct);
#line 491 "TemperatureCache.c"
			}
		}
	}
#line 65 "../lib/Utils/Ensor/TemperatureCache.vala"
	result = analogous_colors;
#line 65 "../lib/Utils/Ensor/TemperatureCache.vala"
	return result;
#line 499 "TemperatureCache.c"
}

static HeHCTColor*
he_temperature_cache_get_closest_hct (HeTemperatureCache* self,
                                      gdouble hue)
{
	HeHCTColor* closest_hct = NULL;
	gdouble min_diff = 0.0;
	GList* _tmp0_;
	HeHCTColor* result;
#line 67 "../lib/Utils/Ensor/TemperatureCache.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 68 "../lib/Utils/Ensor/TemperatureCache.vala"
	closest_hct = NULL;
#line 69 "../lib/Utils/Ensor/TemperatureCache.vala"
	min_diff = 360.0;
#line 71 "../lib/Utils/Ensor/TemperatureCache.vala"
	_tmp0_ = he_temperature_cache_get_hcts_by_hue (self);
#line 518 "TemperatureCache.c"
	{
		GList* hct_collection = NULL;
		GList* hct_it = NULL;
#line 71 "../lib/Utils/Ensor/TemperatureCache.vala"
		hct_collection = _tmp0_;
#line 71 "../lib/Utils/Ensor/TemperatureCache.vala"
		for (hct_it = hct_collection; hct_it != NULL; hct_it = hct_it->next) {
#line 526 "TemperatureCache.c"
			HeHCTColor hct = {0};
#line 71 "../lib/Utils/Ensor/TemperatureCache.vala"
			hct = *((HeHCTColor*) hct_it->data);
#line 530 "TemperatureCache.c"
			{
				gdouble diff = 0.0;
				HeHCTColor _tmp1_;
#line 72 "../lib/Utils/Ensor/TemperatureCache.vala"
				_tmp1_ = hct;
#line 72 "../lib/Utils/Ensor/TemperatureCache.vala"
				diff = fabs (_tmp1_.h - hue);
#line 73 "../lib/Utils/Ensor/TemperatureCache.vala"
				if (diff < min_diff) {
#line 540 "TemperatureCache.c"
					HeHCTColor _tmp2_;
					HeHCTColor* _tmp3_;
#line 74 "../lib/Utils/Ensor/TemperatureCache.vala"
					min_diff = diff;
#line 75 "../lib/Utils/Ensor/TemperatureCache.vala"
					_tmp2_ = hct;
#line 75 "../lib/Utils/Ensor/TemperatureCache.vala"
					_tmp3_ = _he_hct_color_dup0 (&_tmp2_);
#line 75 "../lib/Utils/Ensor/TemperatureCache.vala"
					_he_hct_color_free0 (closest_hct);
#line 75 "../lib/Utils/Ensor/TemperatureCache.vala"
					closest_hct = _tmp3_;
#line 553 "TemperatureCache.c"
				}
			}
		}
#line 71 "../lib/Utils/Ensor/TemperatureCache.vala"
		(hct_collection == NULL) ? NULL : (hct_collection = (_g_list_free__he_hct_color_free0_ (hct_collection), NULL));
#line 559 "TemperatureCache.c"
	}
#line 79 "../lib/Utils/Ensor/TemperatureCache.vala"
	result = closest_hct;
#line 79 "../lib/Utils/Ensor/TemperatureCache.vala"
	return result;
#line 565 "TemperatureCache.c"
}

gdouble
he_temperature_cache_get_input_relative_temperature (HeTemperatureCache* self)
{
	gdouble result;
#line 82 "../lib/Utils/Ensor/TemperatureCache.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 83 "../lib/Utils/Ensor/TemperatureCache.vala"
	if (self->priv->input_relative_temperature_cache < 0.0) {
#line 576 "TemperatureCache.c"
		HeHCTColor _tmp0_;
#line 84 "../lib/Utils/Ensor/TemperatureCache.vala"
		_tmp0_ = self->priv->_input;
#line 84 "../lib/Utils/Ensor/TemperatureCache.vala"
		self->priv->input_relative_temperature_cache = he_temperature_cache_relative_temperature (self, &_tmp0_);
#line 582 "TemperatureCache.c"
	}
#line 86 "../lib/Utils/Ensor/TemperatureCache.vala"
	result = self->priv->input_relative_temperature_cache;
#line 86 "../lib/Utils/Ensor/TemperatureCache.vala"
	return result;
#line 588 "TemperatureCache.c"
}

static gdouble
he_temperature_cache_relative_temperature (HeTemperatureCache* self,
                                           HeHCTColor* hct)
{
	gdouble coldest_temp = 0.0;
	HeHCTColor _tmp0_ = {0};
	gdouble warmest_temp = 0.0;
	HeHCTColor _tmp1_ = {0};
	gdouble range = 0.0;
	HeHCTColor _tmp2_;
	gdouble result;
#line 89 "../lib/Utils/Ensor/TemperatureCache.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 89 "../lib/Utils/Ensor/TemperatureCache.vala"
	g_return_val_if_fail (hct != NULL, 0.0);
#line 90 "../lib/Utils/Ensor/TemperatureCache.vala"
	he_temperature_cache_get_coldest (self, &_tmp0_);
#line 90 "../lib/Utils/Ensor/TemperatureCache.vala"
	coldest_temp = he_temperature_cache_get_temp (self, &_tmp0_);
#line 91 "../lib/Utils/Ensor/TemperatureCache.vala"
	he_temperature_cache_get_warmest (self, &_tmp1_);
#line 91 "../lib/Utils/Ensor/TemperatureCache.vala"
	warmest_temp = he_temperature_cache_get_temp (self, &_tmp1_);
#line 92 "../lib/Utils/Ensor/TemperatureCache.vala"
	range = warmest_temp - coldest_temp;
#line 93 "../lib/Utils/Ensor/TemperatureCache.vala"
	_tmp2_ = *hct;
#line 93 "../lib/Utils/Ensor/TemperatureCache.vala"
	result = (he_temperature_cache_get_temp (self, &_tmp2_) - coldest_temp) / range;
#line 93 "../lib/Utils/Ensor/TemperatureCache.vala"
	return result;
#line 622 "TemperatureCache.c"
}

gdouble
he_temperature_cache_get_temp (HeTemperatureCache* self,
                               HeHCTColor* hct)
{
	GeeHashMap* _tmp0_;
	HeHCTColor _tmp1_;
	GeeHashMap* _tmp6_;
	HeHCTColor _tmp7_;
	gpointer _tmp8_;
	gdouble* _tmp9_;
	gdouble _tmp10_;
	gdouble result;
#line 96 "../lib/Utils/Ensor/TemperatureCache.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 96 "../lib/Utils/Ensor/TemperatureCache.vala"
	g_return_val_if_fail (hct != NULL, 0.0);
#line 97 "../lib/Utils/Ensor/TemperatureCache.vala"
	_tmp0_ = self->priv->temps_by_hct_cache;
#line 97 "../lib/Utils/Ensor/TemperatureCache.vala"
	_tmp1_ = *hct;
#line 97 "../lib/Utils/Ensor/TemperatureCache.vala"
	if (!gee_abstract_map_has_key ((GeeAbstractMap*) _tmp0_, &_tmp1_)) {
#line 647 "TemperatureCache.c"
		GeeHashMap* _tmp2_;
		HeHCTColor _tmp3_;
		HeHCTColor _tmp4_;
		gdouble _tmp5_;
#line 98 "../lib/Utils/Ensor/TemperatureCache.vala"
		_tmp2_ = self->priv->temps_by_hct_cache;
#line 98 "../lib/Utils/Ensor/TemperatureCache.vala"
		_tmp3_ = *hct;
#line 98 "../lib/Utils/Ensor/TemperatureCache.vala"
		_tmp4_ = *hct;
#line 98 "../lib/Utils/Ensor/TemperatureCache.vala"
		_tmp5_ = he_temperature_cache_calculate_temp (self, &_tmp4_);
#line 98 "../lib/Utils/Ensor/TemperatureCache.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp2_, &_tmp3_, &_tmp5_);
#line 662 "TemperatureCache.c"
	}
#line 100 "../lib/Utils/Ensor/TemperatureCache.vala"
	_tmp6_ = self->priv->temps_by_hct_cache;
#line 100 "../lib/Utils/Ensor/TemperatureCache.vala"
	_tmp7_ = *hct;
#line 100 "../lib/Utils/Ensor/TemperatureCache.vala"
	_tmp8_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp6_, &_tmp7_);
#line 100 "../lib/Utils/Ensor/TemperatureCache.vala"
	_tmp9_ = (gdouble*) _tmp8_;
#line 100 "../lib/Utils/Ensor/TemperatureCache.vala"
	_tmp10_ = *_tmp9_;
#line 100 "../lib/Utils/Ensor/TemperatureCache.vala"
	_g_free0 (_tmp9_);
#line 100 "../lib/Utils/Ensor/TemperatureCache.vala"
	result = _tmp10_;
#line 100 "../lib/Utils/Ensor/TemperatureCache.vala"
	return result;
#line 680 "TemperatureCache.c"
}

static GList*
he_temperature_cache_get_hcts_by_hue (HeTemperatureCache* self)
{
	GList* hcts = NULL;
	GList* result;
#line 103 "../lib/Utils/Ensor/TemperatureCache.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 104 "../lib/Utils/Ensor/TemperatureCache.vala"
	hcts = NULL;
#line 692 "TemperatureCache.c"
	{
		gint hue = 0;
#line 105 "../lib/Utils/Ensor/TemperatureCache.vala"
		hue = 0;
#line 697 "TemperatureCache.c"
		{
			gboolean _tmp0_ = FALSE;
#line 105 "../lib/Utils/Ensor/TemperatureCache.vala"
			_tmp0_ = TRUE;
#line 105 "../lib/Utils/Ensor/TemperatureCache.vala"
			while (TRUE) {
#line 704 "TemperatureCache.c"
				HeHCTColor _tmp2_;
				HeHCTColor _tmp3_;
				HeHCTColor _tmp4_ = {0};
				HeHCTColor* _tmp5_;
#line 105 "../lib/Utils/Ensor/TemperatureCache.vala"
				if (!_tmp0_) {
#line 711 "TemperatureCache.c"
					gint _tmp1_;
#line 105 "../lib/Utils/Ensor/TemperatureCache.vala"
					_tmp1_ = hue;
#line 105 "../lib/Utils/Ensor/TemperatureCache.vala"
					hue = _tmp1_ + 1;
#line 717 "TemperatureCache.c"
				}
#line 105 "../lib/Utils/Ensor/TemperatureCache.vala"
				_tmp0_ = FALSE;
#line 105 "../lib/Utils/Ensor/TemperatureCache.vala"
				if (!(hue < 360)) {
#line 105 "../lib/Utils/Ensor/TemperatureCache.vala"
					break;
#line 725 "TemperatureCache.c"
				}
#line 106 "../lib/Utils/Ensor/TemperatureCache.vala"
				_tmp2_ = self->priv->_input;
#line 106 "../lib/Utils/Ensor/TemperatureCache.vala"
				_tmp3_ = self->priv->_input;
#line 106 "../lib/Utils/Ensor/TemperatureCache.vala"
				he_from_params ((gdouble) hue, _tmp2_.c, _tmp3_.t, &_tmp4_);
#line 106 "../lib/Utils/Ensor/TemperatureCache.vala"
				_tmp5_ = _he_hct_color_dup0 (&_tmp4_);
#line 106 "../lib/Utils/Ensor/TemperatureCache.vala"
				hcts = g_list_append (hcts, _tmp5_);
#line 737 "TemperatureCache.c"
			}
		}
	}
#line 108 "../lib/Utils/Ensor/TemperatureCache.vala"
	result = hcts;
#line 108 "../lib/Utils/Ensor/TemperatureCache.vala"
	return result;
#line 745 "TemperatureCache.c"
}

static gdouble
he_temperature_cache_calculate_temp (HeTemperatureCache* self,
                                     HeHCTColor* hct)
{
	HeLABColor lab = {0};
	HeHCTColor _tmp0_;
	HeLABColor _tmp1_ = {0};
	gdouble hue = 0.0;
	HeLABColor _tmp2_;
	HeLABColor _tmp3_;
	gdouble chroma = 0.0;
	HeLABColor _tmp4_;
	HeLABColor _tmp5_;
	HeLABColor _tmp6_;
	HeLABColor _tmp7_;
	gdouble result;
#line 111 "../lib/Utils/Ensor/TemperatureCache.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 111 "../lib/Utils/Ensor/TemperatureCache.vala"
	g_return_val_if_fail (hct != NULL, 0.0);
#line 112 "../lib/Utils/Ensor/TemperatureCache.vala"
	_tmp0_ = *hct;
#line 112 "../lib/Utils/Ensor/TemperatureCache.vala"
	he_lab_from_argb (_tmp0_.a, &_tmp1_);
#line 112 "../lib/Utils/Ensor/TemperatureCache.vala"
	lab = _tmp1_;
#line 113 "../lib/Utils/Ensor/TemperatureCache.vala"
	_tmp2_ = lab;
#line 113 "../lib/Utils/Ensor/TemperatureCache.vala"
	_tmp3_ = lab;
#line 113 "../lib/Utils/Ensor/TemperatureCache.vala"
	hue = (atan2 (_tmp2_.a, _tmp3_.l) * 180.0) / G_PI;
#line 114 "../lib/Utils/Ensor/TemperatureCache.vala"
	_tmp4_ = lab;
#line 114 "../lib/Utils/Ensor/TemperatureCache.vala"
	_tmp5_ = lab;
#line 114 "../lib/Utils/Ensor/TemperatureCache.vala"
	_tmp6_ = lab;
#line 114 "../lib/Utils/Ensor/TemperatureCache.vala"
	_tmp7_ = lab;
#line 114 "../lib/Utils/Ensor/TemperatureCache.vala"
	chroma = sqrt ((_tmp4_.l * _tmp5_.l) + (_tmp6_.a * _tmp7_.a));
#line 115 "../lib/Utils/Ensor/TemperatureCache.vala"
	result = (-0.5) + ((0.02 * pow (chroma, 1.07)) * cos (((hue - 50.0) * G_PI) / 180.0));
#line 115 "../lib/Utils/Ensor/TemperatureCache.vala"
	return result;
#line 794 "TemperatureCache.c"
}

static void
he_temperature_cache_class_init (HeTemperatureCacheClass * klass,
                                 gpointer klass_data)
{
#line 21 "../lib/Utils/Ensor/TemperatureCache.vala"
	he_temperature_cache_parent_class = g_type_class_peek_parent (klass);
#line 21 "../lib/Utils/Ensor/TemperatureCache.vala"
	g_type_class_adjust_private_offset (klass, &HeTemperatureCache_private_offset);
#line 21 "../lib/Utils/Ensor/TemperatureCache.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_he_temperature_cache_get_property;
#line 21 "../lib/Utils/Ensor/TemperatureCache.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_he_temperature_cache_set_property;
#line 21 "../lib/Utils/Ensor/TemperatureCache.vala"
	G_OBJECT_CLASS (klass)->finalize = he_temperature_cache_finalize;
#line 21 "../lib/Utils/Ensor/TemperatureCache.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_TEMPERATURE_CACHE_INPUT_PROPERTY, he_temperature_cache_properties[HE_TEMPERATURE_CACHE_INPUT_PROPERTY] = g_param_spec_boxed ("input", "input", "input", HE_TYPE_HCT_COLOR, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 813 "TemperatureCache.c"
}

static void
he_temperature_cache_instance_init (HeTemperatureCache * self,
                                    gpointer klass)
{
	GeeHashMap* _tmp0_;
#line 21 "../lib/Utils/Ensor/TemperatureCache.vala"
	self->priv = he_temperature_cache_get_instance_private (self);
#line 23 "../lib/Utils/Ensor/TemperatureCache.vala"
	_tmp0_ = gee_hash_map_new (HE_TYPE_HCT_COLOR, (GBoxedCopyFunc) he_hct_color_dup, (GDestroyNotify) he_hct_color_free, G_TYPE_DOUBLE, (GBoxedCopyFunc) _double_dup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 23 "../lib/Utils/Ensor/TemperatureCache.vala"
	self->priv->temps_by_hct_cache = _tmp0_;
#line 24 "../lib/Utils/Ensor/TemperatureCache.vala"
	self->priv->input_relative_temperature_cache = -1.0;
#line 829 "TemperatureCache.c"
}

static void
he_temperature_cache_finalize (GObject * obj)
{
	HeTemperatureCache * self;
#line 21 "../lib/Utils/Ensor/TemperatureCache.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_TEMPERATURE_CACHE, HeTemperatureCache);
#line 23 "../lib/Utils/Ensor/TemperatureCache.vala"
	_g_object_unref0 (self->priv->temps_by_hct_cache);
#line 21 "../lib/Utils/Ensor/TemperatureCache.vala"
	G_OBJECT_CLASS (he_temperature_cache_parent_class)->finalize (obj);
#line 842 "TemperatureCache.c"
}

static GType
he_temperature_cache_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HeTemperatureCacheClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) he_temperature_cache_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HeTemperatureCache), 0, (GInstanceInitFunc) he_temperature_cache_instance_init, NULL };
	GType he_temperature_cache_type_id;
	he_temperature_cache_type_id = g_type_register_static (G_TYPE_OBJECT, "HeTemperatureCache", &g_define_type_info, 0);
	HeTemperatureCache_private_offset = g_type_add_instance_private (he_temperature_cache_type_id, sizeof (HeTemperatureCachePrivate));
	return he_temperature_cache_type_id;
}

GType
he_temperature_cache_get_type (void)
{
	static volatile gsize he_temperature_cache_type_id__once = 0;
	if (g_once_init_enter (&he_temperature_cache_type_id__once)) {
		GType he_temperature_cache_type_id;
		he_temperature_cache_type_id = he_temperature_cache_get_type_once ();
		g_once_init_leave (&he_temperature_cache_type_id__once, he_temperature_cache_type_id);
	}
	return he_temperature_cache_type_id__once;
}

static void
_vala_he_temperature_cache_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec)
{
	HeTemperatureCache * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_TEMPERATURE_CACHE, HeTemperatureCache);
#line 21 "../lib/Utils/Ensor/TemperatureCache.vala"
	switch (property_id) {
#line 21 "../lib/Utils/Ensor/TemperatureCache.vala"
		case HE_TEMPERATURE_CACHE_INPUT_PROPERTY:
#line 879 "TemperatureCache.c"
		{
			HeHCTColor boxed;
#line 21 "../lib/Utils/Ensor/TemperatureCache.vala"
			he_temperature_cache_get_input (self, &boxed);
#line 21 "../lib/Utils/Ensor/TemperatureCache.vala"
			g_value_set_boxed (value, &boxed);
#line 886 "TemperatureCache.c"
		}
#line 21 "../lib/Utils/Ensor/TemperatureCache.vala"
		break;
#line 890 "TemperatureCache.c"
		default:
#line 21 "../lib/Utils/Ensor/TemperatureCache.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../lib/Utils/Ensor/TemperatureCache.vala"
		break;
#line 896 "TemperatureCache.c"
	}
}

static void
_vala_he_temperature_cache_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec)
{
	HeTemperatureCache * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_TEMPERATURE_CACHE, HeTemperatureCache);
#line 21 "../lib/Utils/Ensor/TemperatureCache.vala"
	switch (property_id) {
#line 21 "../lib/Utils/Ensor/TemperatureCache.vala"
		case HE_TEMPERATURE_CACHE_INPUT_PROPERTY:
#line 21 "../lib/Utils/Ensor/TemperatureCache.vala"
		he_temperature_cache_set_input (self, g_value_get_boxed (value));
#line 21 "../lib/Utils/Ensor/TemperatureCache.vala"
		break;
#line 916 "TemperatureCache.c"
		default:
#line 21 "../lib/Utils/Ensor/TemperatureCache.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../lib/Utils/Ensor/TemperatureCache.vala"
		break;
#line 922 "TemperatureCache.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

