/* AboutWindow.c generated by valac 0.56.18, the Vala compiler
 * generated from AboutWindow.vala, do not modify */

/*
 * Copyright (c) 2022 Fyra Labs
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 */

#include "libhelium-1.h"
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>
#include <glib-object.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	HE_ABOUT_WINDOW_0_PROPERTY,
	HE_ABOUT_WINDOW_COLOR_PROPERTY,
	HE_ABOUT_WINDOW_LICENSE_PROPERTY,
	HE_ABOUT_WINDOW_VERSION_PROPERTY,
	HE_ABOUT_WINDOW_APP_NAME_PROPERTY,
	HE_ABOUT_WINDOW_ICON_PROPERTY,
	HE_ABOUT_WINDOW_TRANSLATOR_NAMES_PROPERTY,
	HE_ABOUT_WINDOW_DEVELOPER_NAMES_PROPERTY,
	HE_ABOUT_WINDOW_COPYRIGHT_YEAR_PROPERTY,
	HE_ABOUT_WINDOW_APP_ID_PROPERTY,
	HE_ABOUT_WINDOW_TRANSLATE_URL_PROPERTY,
	HE_ABOUT_WINDOW_ISSUE_URL_PROPERTY,
	HE_ABOUT_WINDOW_MORE_INFO_URL_PROPERTY,
	HE_ABOUT_WINDOW_NUM_PROPERTIES
};
static GParamSpec* he_about_window_properties[HE_ABOUT_WINDOW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block3Data Block3Data;

struct _HeAboutWindowPrivate {
	GtkOverlay* window_overlay;
	GtkBox* about_box;
	GtkBox* content_box;
	GtkBox* button_box;
	GtkBox* info_box;
	GtkBox* title_box;
	GtkBox* text_box;
	GtkBox* developers_box;
	GtkBox* translators_box;
	GtkLabel* title_label;
	GtkLabel* license_label;
	GtkImage* icon_image;
	GtkScrolledWindow* developers_box_scroller;
	GtkScrolledWindow* translators_box_scroller;
	HeButton* translate_app_button;
	HeButton* report_button;
	HeButton* more_info_button;
	HeModifierBadge* version_badge;
	HeColors _color;
	HeAboutWindowLicenses _license;
	gchar** translators;
	gint translators_length1;
	gint _translators_size_;
	gchar** developers;
	gint developers_length1;
	gint _developers_size_;
	gint _copyright_year;
	gchar* _translate_url;
	gchar* _issue_url;
	gchar* _more_info_url;
	gchar* _app_id;
};

struct _Block3Data {
	int _ref_count_;
	HeAboutWindow* self;
	GtkUriLauncher* uri_launcher;
};

static gint HeAboutWindow_private_offset;
static gpointer he_about_window_parent_class = NULL;

static gchar** _vala_array_dup13 (gchar** self,
                           gssize length);
static void he_about_window_update_copyright (HeAboutWindow* self,
                                       gint year,
                                       gchar** developers,
                                       gint developers_length1);
static gchar** _vala_array_dup14 (gchar** self,
                           gssize length);
static GObject * he_about_window_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
static void _he_about_window___lambda124_ (Block3Data* _data3_);
static void __he_about_window___lambda124__gtk_button_clicked (GtkButton* _sender,
                                                        gpointer self);
static void _he_about_window___lambda125_ (Block3Data* _data3_);
static void __he_about_window___lambda125__gtk_button_clicked (GtkButton* _sender,
                                                        gpointer self);
static void _he_about_window___lambda126_ (Block3Data* _data3_);
static void __he_about_window___lambda126__gtk_button_clicked (GtkButton* _sender,
                                                        gpointer self);
static void _gtk_window_close_gtk_button_clicked (GtkButton* _sender,
                                           gpointer self);
static void he_about_window_finalize (GObject * obj);
static GType he_about_window_get_type_once (void);
static void _vala_he_about_window_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec);
static void _vala_he_about_window_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
he_about_window_get_instance_private (HeAboutWindow* self)
{
	return G_STRUCT_MEMBER_P (self, HeAboutWindow_private_offset);
}

/**
     * An enum of commonly used licenses to be used in AboutWindow.
     */
/**
         * Returns the license url for the license.
         */
gchar*
he_about_window_licenses_get_url (HeAboutWindowLicenses self)
{
	gchar* result;
#line 65 "../lib/Widgets/AboutWindow.vala"
	switch (self) {
#line 65 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_LICENSES_GPLV3:
#line 170 "AboutWindow.c"
		{
			gchar* _tmp0_;
#line 67 "../lib/Widgets/AboutWindow.vala"
			_tmp0_ = g_strdup ("https://choosealicense.com/licenses/gpl-3.0");
#line 67 "../lib/Widgets/AboutWindow.vala"
			result = _tmp0_;
#line 67 "../lib/Widgets/AboutWindow.vala"
			return result;
#line 179 "AboutWindow.c"
		}
#line 65 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_LICENSES_MIT:
#line 183 "AboutWindow.c"
		{
			gchar* _tmp1_;
#line 69 "../lib/Widgets/AboutWindow.vala"
			_tmp1_ = g_strdup ("https://choosealicense.com/licenses/mit");
#line 69 "../lib/Widgets/AboutWindow.vala"
			result = _tmp1_;
#line 69 "../lib/Widgets/AboutWindow.vala"
			return result;
#line 192 "AboutWindow.c"
		}
#line 65 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_LICENSES_MPLV2:
#line 196 "AboutWindow.c"
		{
			gchar* _tmp2_;
#line 71 "../lib/Widgets/AboutWindow.vala"
			_tmp2_ = g_strdup ("https://choosealicense.com/licenses/mpl-2.0");
#line 71 "../lib/Widgets/AboutWindow.vala"
			result = _tmp2_;
#line 71 "../lib/Widgets/AboutWindow.vala"
			return result;
#line 205 "AboutWindow.c"
		}
#line 65 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_LICENSES_UNLICENSE:
#line 209 "AboutWindow.c"
		{
			gchar* _tmp3_;
#line 73 "../lib/Widgets/AboutWindow.vala"
			_tmp3_ = g_strdup ("https://choosealicense.com/licenses/unlicense");
#line 73 "../lib/Widgets/AboutWindow.vala"
			result = _tmp3_;
#line 73 "../lib/Widgets/AboutWindow.vala"
			return result;
#line 218 "AboutWindow.c"
		}
#line 65 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_LICENSES_APACHEV2:
#line 222 "AboutWindow.c"
		{
			gchar* _tmp4_;
#line 75 "../lib/Widgets/AboutWindow.vala"
			_tmp4_ = g_strdup ("https://choosealicense.com/licenses/apache-2.0");
#line 75 "../lib/Widgets/AboutWindow.vala"
			result = _tmp4_;
#line 75 "../lib/Widgets/AboutWindow.vala"
			return result;
#line 231 "AboutWindow.c"
		}
#line 65 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_LICENSES_WTFPL:
#line 235 "AboutWindow.c"
		{
			gchar* _tmp5_;
#line 77 "../lib/Widgets/AboutWindow.vala"
			_tmp5_ = g_strdup ("https://choosealicense.com/licenses/wtfpl");
#line 77 "../lib/Widgets/AboutWindow.vala"
			result = _tmp5_;
#line 77 "../lib/Widgets/AboutWindow.vala"
			return result;
#line 244 "AboutWindow.c"
		}
#line 65 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_LICENSES_PROPRIETARY:
#line 248 "AboutWindow.c"
		{
			gchar* _tmp6_;
#line 79 "../lib/Widgets/AboutWindow.vala"
			_tmp6_ = g_strdup ("https://choosealicense.com/no-permission");
#line 79 "../lib/Widgets/AboutWindow.vala"
			result = _tmp6_;
#line 79 "../lib/Widgets/AboutWindow.vala"
			return result;
#line 257 "AboutWindow.c"
		}
		default:
		{
			gchar* _tmp7_;
#line 81 "../lib/Widgets/AboutWindow.vala"
			_tmp7_ = g_strdup ("about:blank");
#line 81 "../lib/Widgets/AboutWindow.vala"
			result = _tmp7_;
#line 81 "../lib/Widgets/AboutWindow.vala"
			return result;
#line 268 "AboutWindow.c"
		}
	}
}

/**
         * Returns the license name for the license.
         */
gchar*
he_about_window_licenses_get_name (HeAboutWindowLicenses self)
{
	gchar* result;
#line 89 "../lib/Widgets/AboutWindow.vala"
	switch (self) {
#line 89 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_LICENSES_GPLV3:
#line 284 "AboutWindow.c"
		{
			gchar* _tmp0_;
#line 91 "../lib/Widgets/AboutWindow.vala"
			_tmp0_ = g_strdup ("GPLv3");
#line 91 "../lib/Widgets/AboutWindow.vala"
			result = _tmp0_;
#line 91 "../lib/Widgets/AboutWindow.vala"
			return result;
#line 293 "AboutWindow.c"
		}
#line 89 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_LICENSES_MIT:
#line 297 "AboutWindow.c"
		{
			gchar* _tmp1_;
#line 93 "../lib/Widgets/AboutWindow.vala"
			_tmp1_ = g_strdup ("MIT");
#line 93 "../lib/Widgets/AboutWindow.vala"
			result = _tmp1_;
#line 93 "../lib/Widgets/AboutWindow.vala"
			return result;
#line 306 "AboutWindow.c"
		}
#line 89 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_LICENSES_MPLV2:
#line 310 "AboutWindow.c"
		{
			gchar* _tmp2_;
#line 95 "../lib/Widgets/AboutWindow.vala"
			_tmp2_ = g_strdup ("MPLv2");
#line 95 "../lib/Widgets/AboutWindow.vala"
			result = _tmp2_;
#line 95 "../lib/Widgets/AboutWindow.vala"
			return result;
#line 319 "AboutWindow.c"
		}
#line 89 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_LICENSES_UNLICENSE:
#line 323 "AboutWindow.c"
		{
			gchar* _tmp3_;
#line 97 "../lib/Widgets/AboutWindow.vala"
			_tmp3_ = g_strdup ("Unlicense");
#line 97 "../lib/Widgets/AboutWindow.vala"
			result = _tmp3_;
#line 97 "../lib/Widgets/AboutWindow.vala"
			return result;
#line 332 "AboutWindow.c"
		}
#line 89 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_LICENSES_APACHEV2:
#line 336 "AboutWindow.c"
		{
			gchar* _tmp4_;
#line 99 "../lib/Widgets/AboutWindow.vala"
			_tmp4_ = g_strdup ("Apache License v2");
#line 99 "../lib/Widgets/AboutWindow.vala"
			result = _tmp4_;
#line 99 "../lib/Widgets/AboutWindow.vala"
			return result;
#line 345 "AboutWindow.c"
		}
#line 89 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_LICENSES_WTFPL:
#line 349 "AboutWindow.c"
		{
			gchar* _tmp5_;
#line 101 "../lib/Widgets/AboutWindow.vala"
			_tmp5_ = g_strdup ("WTFPL");
#line 101 "../lib/Widgets/AboutWindow.vala"
			result = _tmp5_;
#line 101 "../lib/Widgets/AboutWindow.vala"
			return result;
#line 358 "AboutWindow.c"
		}
#line 89 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_LICENSES_PROPRIETARY:
#line 362 "AboutWindow.c"
		{
			gchar* _tmp6_;
#line 103 "../lib/Widgets/AboutWindow.vala"
			_tmp6_ = g_strdup ("a proprietary license");
#line 103 "../lib/Widgets/AboutWindow.vala"
			result = _tmp6_;
#line 103 "../lib/Widgets/AboutWindow.vala"
			return result;
#line 371 "AboutWindow.c"
		}
		default:
		{
			gchar* _tmp7_;
#line 105 "../lib/Widgets/AboutWindow.vala"
			_tmp7_ = g_strdup ("N/A");
#line 105 "../lib/Widgets/AboutWindow.vala"
			result = _tmp7_;
#line 105 "../lib/Widgets/AboutWindow.vala"
			return result;
#line 382 "AboutWindow.c"
		}
	}
}

static GType
he_about_window_licenses_get_type_once (void)
{
	static const GEnumValue values[] = {{HE_ABOUT_WINDOW_LICENSES_GPLV3, "HE_ABOUT_WINDOW_LICENSES_GPLV3", "gplv3"}, {HE_ABOUT_WINDOW_LICENSES_MIT, "HE_ABOUT_WINDOW_LICENSES_MIT", "mit"}, {HE_ABOUT_WINDOW_LICENSES_MPLV2, "HE_ABOUT_WINDOW_LICENSES_MPLV2", "mplv2"}, {HE_ABOUT_WINDOW_LICENSES_UNLICENSE, "HE_ABOUT_WINDOW_LICENSES_UNLICENSE", "unlicense"}, {HE_ABOUT_WINDOW_LICENSES_APACHEV2, "HE_ABOUT_WINDOW_LICENSES_APACHEV2", "apachev2"}, {HE_ABOUT_WINDOW_LICENSES_WTFPL, "HE_ABOUT_WINDOW_LICENSES_WTFPL", "wtfpl"}, {HE_ABOUT_WINDOW_LICENSES_PROPRIETARY, "HE_ABOUT_WINDOW_LICENSES_PROPRIETARY", "proprietary"}, {0, NULL, NULL}};
	GType he_about_window_licenses_type_id;
	he_about_window_licenses_type_id = g_enum_register_static ("HeAboutWindowLicenses", values);
	return he_about_window_licenses_type_id;
}

GType
he_about_window_licenses_get_type (void)
{
	static volatile gsize he_about_window_licenses_type_id__once = 0;
	if (g_once_init_enter (&he_about_window_licenses_type_id__once)) {
		GType he_about_window_licenses_type_id;
		he_about_window_licenses_type_id = he_about_window_licenses_get_type_once ();
		g_once_init_leave (&he_about_window_licenses_type_id__once, he_about_window_licenses_type_id);
	}
	return he_about_window_licenses_type_id__once;
}

HeColors
he_about_window_get_color (HeAboutWindow* self)
{
	HeColors result;
#line 116 "../lib/Widgets/AboutWindow.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 117 "../lib/Widgets/AboutWindow.vala"
	result = self->priv->_color;
#line 117 "../lib/Widgets/AboutWindow.vala"
	return result;
#line 418 "AboutWindow.c"
}

void
he_about_window_set_color (HeAboutWindow* self,
                           HeColors value)
{
	HeButton* _tmp0_;
	HeButton* _tmp1_;
	HeButton* _tmp2_;
	HeModifierBadge* _tmp3_;
#line 119 "../lib/Widgets/AboutWindow.vala"
	g_return_if_fail (self != NULL);
#line 120 "../lib/Widgets/AboutWindow.vala"
	self->priv->_color = value;
#line 121 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = self->priv->translate_app_button;
#line 121 "../lib/Widgets/AboutWindow.vala"
	he_button_set_color (_tmp0_, value);
#line 122 "../lib/Widgets/AboutWindow.vala"
	_tmp1_ = self->priv->report_button;
#line 122 "../lib/Widgets/AboutWindow.vala"
	he_button_set_color (_tmp1_, value);
#line 123 "../lib/Widgets/AboutWindow.vala"
	_tmp2_ = self->priv->more_info_button;
#line 123 "../lib/Widgets/AboutWindow.vala"
	he_button_set_color (_tmp2_, value);
#line 124 "../lib/Widgets/AboutWindow.vala"
	_tmp3_ = self->priv->version_badge;
#line 124 "../lib/Widgets/AboutWindow.vala"
	he_modifier_badge_set_color (_tmp3_, value);
#line 119 "../lib/Widgets/AboutWindow.vala"
	g_object_notify_by_pspec ((GObject *) self, he_about_window_properties[HE_ABOUT_WINDOW_COLOR_PROPERTY]);
#line 451 "AboutWindow.c"
}

HeAboutWindowLicenses
he_about_window_get_license (HeAboutWindow* self)
{
	HeAboutWindowLicenses result;
#line 134 "../lib/Widgets/AboutWindow.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 134 "../lib/Widgets/AboutWindow.vala"
	result = self->priv->_license;
#line 134 "../lib/Widgets/AboutWindow.vala"
	return result;
#line 464 "AboutWindow.c"
}

void
he_about_window_set_license (HeAboutWindow* self,
                             HeAboutWindowLicenses value)
{
	GtkLabel* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
#line 135 "../lib/Widgets/AboutWindow.vala"
	g_return_if_fail (self != NULL);
#line 136 "../lib/Widgets/AboutWindow.vala"
	self->priv->_license = value;
#line 137 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = self->priv->license_label;
#line 137 "../lib/Widgets/AboutWindow.vala"
	_tmp1_ = g_strdup_printf (_ ("This program is licensed under %s"), "<a href=\"%s\">%s</a>");
#line 137 "../lib/Widgets/AboutWindow.vala"
	_tmp2_ = _tmp1_;
#line 137 "../lib/Widgets/AboutWindow.vala"
	_tmp3_ = he_about_window_licenses_get_url (value);
#line 137 "../lib/Widgets/AboutWindow.vala"
	_tmp4_ = _tmp3_;
#line 137 "../lib/Widgets/AboutWindow.vala"
	_tmp5_ = he_about_window_licenses_get_name (value);
#line 137 "../lib/Widgets/AboutWindow.vala"
	_tmp6_ = _tmp5_;
#line 137 "../lib/Widgets/AboutWindow.vala"
	_tmp7_ = g_strdup_printf (_tmp2_, _tmp4_, _tmp6_);
#line 137 "../lib/Widgets/AboutWindow.vala"
	_tmp8_ = _tmp7_;
#line 137 "../lib/Widgets/AboutWindow.vala"
	gtk_label_set_markup (_tmp0_, _tmp8_);
#line 137 "../lib/Widgets/AboutWindow.vala"
	_g_free0 (_tmp8_);
#line 137 "../lib/Widgets/AboutWindow.vala"
	_g_free0 (_tmp6_);
#line 137 "../lib/Widgets/AboutWindow.vala"
	_g_free0 (_tmp4_);
#line 137 "../lib/Widgets/AboutWindow.vala"
	_g_free0 (_tmp2_);
#line 135 "../lib/Widgets/AboutWindow.vala"
	g_object_notify_by_pspec ((GObject *) self, he_about_window_properties[HE_ABOUT_WINDOW_LICENSE_PROPERTY]);
#line 514 "AboutWindow.c"
}

const gchar*
he_about_window_get_version (HeAboutWindow* self)
{
	const gchar* result;
	HeModifierBadge* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
#line 145 "../lib/Widgets/AboutWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 145 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = self->priv->version_badge;
#line 145 "../lib/Widgets/AboutWindow.vala"
	_tmp1_ = he_modifier_badge_get_label (_tmp0_);
#line 145 "../lib/Widgets/AboutWindow.vala"
	_tmp2_ = _tmp1_;
#line 145 "../lib/Widgets/AboutWindow.vala"
	result = _tmp2_;
#line 145 "../lib/Widgets/AboutWindow.vala"
	return result;
#line 536 "AboutWindow.c"
}

void
he_about_window_set_version (HeAboutWindow* self,
                             const gchar* value)
{
	HeModifierBadge* _tmp0_;
#line 146 "../lib/Widgets/AboutWindow.vala"
	g_return_if_fail (self != NULL);
#line 146 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = self->priv->version_badge;
#line 146 "../lib/Widgets/AboutWindow.vala"
	he_modifier_badge_set_label (_tmp0_, value);
#line 146 "../lib/Widgets/AboutWindow.vala"
	g_object_notify_by_pspec ((GObject *) self, he_about_window_properties[HE_ABOUT_WINDOW_VERSION_PROPERTY]);
#line 552 "AboutWindow.c"
}

const gchar*
he_about_window_get_app_name (HeAboutWindow* self)
{
	const gchar* result;
	GtkLabel* _tmp0_;
	const gchar* _tmp1_;
#line 153 "../lib/Widgets/AboutWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 153 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = self->priv->title_label;
#line 153 "../lib/Widgets/AboutWindow.vala"
	_tmp1_ = gtk_label_get_text (_tmp0_);
#line 153 "../lib/Widgets/AboutWindow.vala"
	result = _tmp1_;
#line 153 "../lib/Widgets/AboutWindow.vala"
	return result;
#line 571 "AboutWindow.c"
}

void
he_about_window_set_app_name (HeAboutWindow* self,
                              const gchar* value)
{
	GtkLabel* _tmp0_;
#line 154 "../lib/Widgets/AboutWindow.vala"
	g_return_if_fail (self != NULL);
#line 154 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = self->priv->title_label;
#line 154 "../lib/Widgets/AboutWindow.vala"
	gtk_label_set_text (_tmp0_, value);
#line 154 "../lib/Widgets/AboutWindow.vala"
	g_object_notify_by_pspec ((GObject *) self, he_about_window_properties[HE_ABOUT_WINDOW_APP_NAME_PROPERTY]);
#line 587 "AboutWindow.c"
}

const gchar*
he_about_window_get_icon (HeAboutWindow* self)
{
	const gchar* result;
	GtkImage* _tmp0_;
	const gchar* _tmp1_;
#line 161 "../lib/Widgets/AboutWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 161 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = self->priv->icon_image;
#line 161 "../lib/Widgets/AboutWindow.vala"
	_tmp1_ = gtk_image_get_icon_name (_tmp0_);
#line 161 "../lib/Widgets/AboutWindow.vala"
	result = _tmp1_;
#line 161 "../lib/Widgets/AboutWindow.vala"
	return result;
#line 606 "AboutWindow.c"
}

void
he_about_window_set_icon (HeAboutWindow* self,
                          const gchar* value)
{
	GtkImage* _tmp0_;
#line 162 "../lib/Widgets/AboutWindow.vala"
	g_return_if_fail (self != NULL);
#line 162 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = self->priv->icon_image;
#line 162 "../lib/Widgets/AboutWindow.vala"
	gtk_image_set_from_icon_name (_tmp0_, value);
#line 162 "../lib/Widgets/AboutWindow.vala"
	g_object_notify_by_pspec ((GObject *) self, he_about_window_properties[HE_ABOUT_WINDOW_ICON_PROPERTY]);
#line 622 "AboutWindow.c"
}

gchar**
he_about_window_get_translator_names (HeAboutWindow* self,
                                      gint* result_length1)
{
	gchar** result;
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar** _tmp1_;
	gint _tmp1__length1;
#line 170 "../lib/Widgets/AboutWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 170 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = self->priv->translators;
#line 170 "../lib/Widgets/AboutWindow.vala"
	_tmp0__length1 = self->priv->translators_length1;
#line 170 "../lib/Widgets/AboutWindow.vala"
	_tmp1_ = _tmp0_;
#line 170 "../lib/Widgets/AboutWindow.vala"
	_tmp1__length1 = _tmp0__length1;
#line 170 "../lib/Widgets/AboutWindow.vala"
	if (result_length1) {
#line 170 "../lib/Widgets/AboutWindow.vala"
		*result_length1 = _tmp1__length1;
#line 648 "AboutWindow.c"
	}
#line 170 "../lib/Widgets/AboutWindow.vala"
	result = _tmp1_;
#line 170 "../lib/Widgets/AboutWindow.vala"
	return result;
#line 654 "AboutWindow.c"
}

static gchar**
_vala_array_dup13 (gchar** self,
                   gssize length)
{
#line 172 "../lib/Widgets/AboutWindow.vala"
	if (length >= 0) {
#line 663 "AboutWindow.c"
		gchar** result;
		gssize i;
#line 172 "../lib/Widgets/AboutWindow.vala"
		result = g_new0 (gchar*, length + 1);
#line 172 "../lib/Widgets/AboutWindow.vala"
		for (i = 0; i < length; i++) {
#line 670 "AboutWindow.c"
			gchar* _tmp0_;
#line 172 "../lib/Widgets/AboutWindow.vala"
			_tmp0_ = g_strdup (self[i]);
#line 172 "../lib/Widgets/AboutWindow.vala"
			result[i] = _tmp0_;
#line 676 "AboutWindow.c"
		}
#line 172 "../lib/Widgets/AboutWindow.vala"
		return result;
#line 680 "AboutWindow.c"
	}
#line 172 "../lib/Widgets/AboutWindow.vala"
	return NULL;
#line 684 "AboutWindow.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 174 "../lib/Widgets/AboutWindow.vala"
	return self ? g_object_ref (self) : NULL;
#line 692 "AboutWindow.c"
}

void
he_about_window_set_translator_names (HeAboutWindow* self,
                                      gchar** value,
                                      gint value_length1)
{
	gchar** _tmp0_;
	gint _tmp0__length1;
	GtkWidget* first_child = NULL;
	GtkBox* _tmp1_;
	GtkWidget* _tmp2_;
	GtkWidget* _tmp3_;
	GtkBox* _tmp28_;
	gboolean _tmp29_;
	gboolean _tmp30_;
#line 171 "../lib/Widgets/AboutWindow.vala"
	g_return_if_fail (self != NULL);
#line 172 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = (value != NULL) ? _vala_array_dup13 (value, value_length1) : value;
#line 172 "../lib/Widgets/AboutWindow.vala"
	_tmp0__length1 = value_length1;
#line 172 "../lib/Widgets/AboutWindow.vala"
	self->priv->translators = (_vala_array_free (self->priv->translators, self->priv->translators_length1, (GDestroyNotify) g_free), NULL);
#line 172 "../lib/Widgets/AboutWindow.vala"
	self->priv->translators = _tmp0_;
#line 172 "../lib/Widgets/AboutWindow.vala"
	self->priv->translators_length1 = _tmp0__length1;
#line 172 "../lib/Widgets/AboutWindow.vala"
	self->priv->_translators_size_ = self->priv->translators_length1;
#line 174 "../lib/Widgets/AboutWindow.vala"
	_tmp1_ = self->priv->translators_box;
#line 174 "../lib/Widgets/AboutWindow.vala"
	_tmp2_ = gtk_widget_get_first_child ((GtkWidget*) _tmp1_);
#line 174 "../lib/Widgets/AboutWindow.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 174 "../lib/Widgets/AboutWindow.vala"
	first_child = _tmp3_;
#line 175 "../lib/Widgets/AboutWindow.vala"
	while (TRUE) {
#line 733 "AboutWindow.c"
		GtkWidget* _tmp4_;
		GtkBox* _tmp5_;
		GtkWidget* _tmp6_;
		GtkBox* _tmp7_;
		GtkWidget* _tmp8_;
		GtkWidget* _tmp9_;
#line 175 "../lib/Widgets/AboutWindow.vala"
		_tmp4_ = first_child;
#line 175 "../lib/Widgets/AboutWindow.vala"
		if (!(_tmp4_ != NULL)) {
#line 175 "../lib/Widgets/AboutWindow.vala"
			break;
#line 746 "AboutWindow.c"
		}
#line 176 "../lib/Widgets/AboutWindow.vala"
		_tmp5_ = self->priv->translators_box;
#line 176 "../lib/Widgets/AboutWindow.vala"
		_tmp6_ = first_child;
#line 176 "../lib/Widgets/AboutWindow.vala"
		gtk_box_remove (_tmp5_, _tmp6_);
#line 177 "../lib/Widgets/AboutWindow.vala"
		_tmp7_ = self->priv->translators_box;
#line 177 "../lib/Widgets/AboutWindow.vala"
		_tmp8_ = gtk_widget_get_first_child ((GtkWidget*) _tmp7_);
#line 177 "../lib/Widgets/AboutWindow.vala"
		_tmp9_ = _g_object_ref0 (_tmp8_);
#line 177 "../lib/Widgets/AboutWindow.vala"
		_g_object_unref0 (first_child);
#line 177 "../lib/Widgets/AboutWindow.vala"
		first_child = _tmp9_;
#line 764 "AboutWindow.c"
	}
	{
		gint i = 0;
#line 180 "../lib/Widgets/AboutWindow.vala"
		i = 0;
#line 770 "AboutWindow.c"
		{
			gboolean _tmp10_ = FALSE;
#line 180 "../lib/Widgets/AboutWindow.vala"
			_tmp10_ = TRUE;
#line 180 "../lib/Widgets/AboutWindow.vala"
			while (TRUE) {
#line 777 "AboutWindow.c"
				gchar** _tmp12_;
				gint _tmp12__length1;
				GtkLabel* translator_label = NULL;
				GtkLabel* _tmp13_;
				GtkLabel* _tmp14_;
				gchar* _tmp15_ = NULL;
				gchar** _tmp16_;
				gint _tmp16__length1;
				GtkLabel* _tmp23_;
				GtkLabel* _tmp24_;
				GtkBox* _tmp25_;
				GtkLabel* _tmp26_;
				GtkBox* _tmp27_;
#line 180 "../lib/Widgets/AboutWindow.vala"
				if (!_tmp10_) {
#line 793 "AboutWindow.c"
					gint _tmp11_;
#line 180 "../lib/Widgets/AboutWindow.vala"
					_tmp11_ = i;
#line 180 "../lib/Widgets/AboutWindow.vala"
					i = _tmp11_ + 1;
#line 799 "AboutWindow.c"
				}
#line 180 "../lib/Widgets/AboutWindow.vala"
				_tmp10_ = FALSE;
#line 180 "../lib/Widgets/AboutWindow.vala"
				_tmp12_ = self->priv->translators;
#line 180 "../lib/Widgets/AboutWindow.vala"
				_tmp12__length1 = self->priv->translators_length1;
#line 180 "../lib/Widgets/AboutWindow.vala"
				if (!(i < _tmp12__length1)) {
#line 180 "../lib/Widgets/AboutWindow.vala"
					break;
#line 811 "AboutWindow.c"
				}
#line 181 "../lib/Widgets/AboutWindow.vala"
				_tmp13_ = (GtkLabel*) gtk_label_new ("");
#line 181 "../lib/Widgets/AboutWindow.vala"
				g_object_ref_sink (_tmp13_);
#line 181 "../lib/Widgets/AboutWindow.vala"
				translator_label = _tmp13_;
#line 182 "../lib/Widgets/AboutWindow.vala"
				_tmp14_ = translator_label;
#line 182 "../lib/Widgets/AboutWindow.vala"
				gtk_label_set_xalign (_tmp14_, (gfloat) 0);
#line 183 "../lib/Widgets/AboutWindow.vala"
				_tmp16_ = self->priv->translators;
#line 183 "../lib/Widgets/AboutWindow.vala"
				_tmp16__length1 = self->priv->translators_length1;
#line 183 "../lib/Widgets/AboutWindow.vala"
				if (i < (_tmp16__length1 - 1)) {
#line 829 "AboutWindow.c"
					gchar** _tmp17_;
					gint _tmp17__length1;
					const gchar* _tmp18_;
					gchar* _tmp19_;
#line 183 "../lib/Widgets/AboutWindow.vala"
					_tmp17_ = self->priv->translators;
#line 183 "../lib/Widgets/AboutWindow.vala"
					_tmp17__length1 = self->priv->translators_length1;
#line 183 "../lib/Widgets/AboutWindow.vala"
					_tmp18_ = _tmp17_[i];
#line 183 "../lib/Widgets/AboutWindow.vala"
					_tmp19_ = g_strdup_printf ("%s", _tmp18_);
#line 183 "../lib/Widgets/AboutWindow.vala"
					_g_free0 (_tmp15_);
#line 183 "../lib/Widgets/AboutWindow.vala"
					_tmp15_ = _tmp19_;
#line 846 "AboutWindow.c"
				} else {
					gchar** _tmp20_;
					gint _tmp20__length1;
					const gchar* _tmp21_;
					gchar* _tmp22_;
#line 183 "../lib/Widgets/AboutWindow.vala"
					_tmp20_ = self->priv->translators;
#line 183 "../lib/Widgets/AboutWindow.vala"
					_tmp20__length1 = self->priv->translators_length1;
#line 183 "../lib/Widgets/AboutWindow.vala"
					_tmp21_ = _tmp20_[i];
#line 183 "../lib/Widgets/AboutWindow.vala"
					_tmp22_ = g_strdup (_tmp21_);
#line 183 "../lib/Widgets/AboutWindow.vala"
					_g_free0 (_tmp15_);
#line 183 "../lib/Widgets/AboutWindow.vala"
					_tmp15_ = _tmp22_;
#line 864 "AboutWindow.c"
				}
#line 183 "../lib/Widgets/AboutWindow.vala"
				_tmp23_ = translator_label;
#line 183 "../lib/Widgets/AboutWindow.vala"
				gtk_label_set_text (_tmp23_, _tmp15_);
#line 184 "../lib/Widgets/AboutWindow.vala"
				_tmp24_ = translator_label;
#line 184 "../lib/Widgets/AboutWindow.vala"
				gtk_widget_set_visible ((GtkWidget*) _tmp24_, TRUE);
#line 185 "../lib/Widgets/AboutWindow.vala"
				_tmp25_ = self->priv->translators_box;
#line 185 "../lib/Widgets/AboutWindow.vala"
				_tmp26_ = translator_label;
#line 185 "../lib/Widgets/AboutWindow.vala"
				gtk_box_append (_tmp25_, (GtkWidget*) _tmp26_);
#line 186 "../lib/Widgets/AboutWindow.vala"
				_tmp27_ = self->priv->translators_box;
#line 186 "../lib/Widgets/AboutWindow.vala"
				gtk_widget_set_visible ((GtkWidget*) _tmp27_, TRUE);
#line 180 "../lib/Widgets/AboutWindow.vala"
				_g_free0 (_tmp15_);
#line 180 "../lib/Widgets/AboutWindow.vala"
				_g_object_unref0 (translator_label);
#line 888 "AboutWindow.c"
			}
		}
	}
#line 189 "../lib/Widgets/AboutWindow.vala"
	_tmp28_ = self->priv->translators_box;
#line 189 "../lib/Widgets/AboutWindow.vala"
	_tmp29_ = gtk_widget_get_visible ((GtkWidget*) _tmp28_);
#line 189 "../lib/Widgets/AboutWindow.vala"
	_tmp30_ = _tmp29_;
#line 189 "../lib/Widgets/AboutWindow.vala"
	if (_tmp30_ == FALSE) {
#line 900 "AboutWindow.c"
		GtkScrolledWindow* _tmp31_;
#line 190 "../lib/Widgets/AboutWindow.vala"
		_tmp31_ = self->priv->translators_box_scroller;
#line 190 "../lib/Widgets/AboutWindow.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp31_, FALSE);
#line 906 "AboutWindow.c"
	} else {
		GtkScrolledWindow* _tmp32_;
#line 192 "../lib/Widgets/AboutWindow.vala"
		_tmp32_ = self->priv->translators_box_scroller;
#line 192 "../lib/Widgets/AboutWindow.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp32_, TRUE);
#line 913 "AboutWindow.c"
	}
#line 171 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (first_child);
#line 171 "../lib/Widgets/AboutWindow.vala"
	g_object_notify_by_pspec ((GObject *) self, he_about_window_properties[HE_ABOUT_WINDOW_TRANSLATOR_NAMES_PROPERTY]);
#line 919 "AboutWindow.c"
}

static void
he_about_window_update_copyright (HeAboutWindow* self,
                                  gint year,
                                  gchar** developers,
                                  gint developers_length1)
{
	GtkWidget* first_child = NULL;
	GtkBox* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
	GtkBox* _tmp25_;
	gboolean _tmp26_;
	gboolean _tmp27_;
#line 197 "../lib/Widgets/AboutWindow.vala"
	g_return_if_fail (self != NULL);
#line 199 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = self->priv->developers_box;
#line 199 "../lib/Widgets/AboutWindow.vala"
	_tmp1_ = gtk_widget_get_first_child ((GtkWidget*) _tmp0_);
#line 199 "../lib/Widgets/AboutWindow.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 199 "../lib/Widgets/AboutWindow.vala"
	first_child = _tmp2_;
#line 200 "../lib/Widgets/AboutWindow.vala"
	while (TRUE) {
#line 947 "AboutWindow.c"
		GtkWidget* _tmp3_;
		GtkBox* _tmp4_;
		GtkWidget* _tmp5_;
		GtkBox* _tmp6_;
		GtkWidget* _tmp7_;
		GtkWidget* _tmp8_;
#line 200 "../lib/Widgets/AboutWindow.vala"
		_tmp3_ = first_child;
#line 200 "../lib/Widgets/AboutWindow.vala"
		if (!(_tmp3_ != NULL)) {
#line 200 "../lib/Widgets/AboutWindow.vala"
			break;
#line 960 "AboutWindow.c"
		}
#line 201 "../lib/Widgets/AboutWindow.vala"
		_tmp4_ = self->priv->developers_box;
#line 201 "../lib/Widgets/AboutWindow.vala"
		_tmp5_ = first_child;
#line 201 "../lib/Widgets/AboutWindow.vala"
		gtk_box_remove (_tmp4_, _tmp5_);
#line 202 "../lib/Widgets/AboutWindow.vala"
		_tmp6_ = self->priv->developers_box;
#line 202 "../lib/Widgets/AboutWindow.vala"
		_tmp7_ = gtk_widget_get_first_child ((GtkWidget*) _tmp6_);
#line 202 "../lib/Widgets/AboutWindow.vala"
		_tmp8_ = _g_object_ref0 (_tmp7_);
#line 202 "../lib/Widgets/AboutWindow.vala"
		_g_object_unref0 (first_child);
#line 202 "../lib/Widgets/AboutWindow.vala"
		first_child = _tmp8_;
#line 978 "AboutWindow.c"
	}
	{
		gint i = 0;
#line 206 "../lib/Widgets/AboutWindow.vala"
		i = 0;
#line 984 "AboutWindow.c"
		{
			gboolean _tmp9_ = FALSE;
#line 206 "../lib/Widgets/AboutWindow.vala"
			_tmp9_ = TRUE;
#line 206 "../lib/Widgets/AboutWindow.vala"
			while (TRUE) {
#line 991 "AboutWindow.c"
				GtkLabel* developer_label = NULL;
				GtkLabel* _tmp11_;
				GtkLabel* _tmp12_;
				GtkLabel* _tmp21_;
				GtkBox* _tmp22_;
				GtkLabel* _tmp23_;
				GtkBox* _tmp24_;
#line 206 "../lib/Widgets/AboutWindow.vala"
				if (!_tmp9_) {
#line 1001 "AboutWindow.c"
					gint _tmp10_;
#line 206 "../lib/Widgets/AboutWindow.vala"
					_tmp10_ = i;
#line 206 "../lib/Widgets/AboutWindow.vala"
					i = _tmp10_ + 1;
#line 1007 "AboutWindow.c"
				}
#line 206 "../lib/Widgets/AboutWindow.vala"
				_tmp9_ = FALSE;
#line 206 "../lib/Widgets/AboutWindow.vala"
				if (!(i < developers_length1)) {
#line 206 "../lib/Widgets/AboutWindow.vala"
					break;
#line 1015 "AboutWindow.c"
				}
#line 207 "../lib/Widgets/AboutWindow.vala"
				_tmp11_ = (GtkLabel*) gtk_label_new ("");
#line 207 "../lib/Widgets/AboutWindow.vala"
				g_object_ref_sink (_tmp11_);
#line 207 "../lib/Widgets/AboutWindow.vala"
				developer_label = _tmp11_;
#line 208 "../lib/Widgets/AboutWindow.vala"
				_tmp12_ = developer_label;
#line 208 "../lib/Widgets/AboutWindow.vala"
				gtk_label_set_xalign (_tmp12_, (gfloat) 0);
#line 209 "../lib/Widgets/AboutWindow.vala"
				if (i == 0) {
#line 1029 "AboutWindow.c"
					gchar* _tmp13_ = NULL;
					GtkLabel* _tmp18_;
#line 210 "../lib/Widgets/AboutWindow.vala"
					if (year > 0) {
#line 1034 "AboutWindow.c"
						const gchar* _tmp14_;
						gchar* _tmp15_;
#line 211 "../lib/Widgets/AboutWindow.vala"
						_tmp14_ = developers[i];
#line 211 "../lib/Widgets/AboutWindow.vala"
						_tmp15_ = g_strdup_printf (_ ("Copyright © %i %s"), year, _tmp14_);
#line 211 "../lib/Widgets/AboutWindow.vala"
						_g_free0 (_tmp13_);
#line 211 "../lib/Widgets/AboutWindow.vala"
						_tmp13_ = _tmp15_;
#line 1045 "AboutWindow.c"
					} else {
						const gchar* _tmp16_;
						gchar* _tmp17_;
#line 212 "../lib/Widgets/AboutWindow.vala"
						_tmp16_ = developers[i];
#line 212 "../lib/Widgets/AboutWindow.vala"
						_tmp17_ = g_strdup_printf (_ ("Copyright © %s"), _tmp16_);
#line 212 "../lib/Widgets/AboutWindow.vala"
						_g_free0 (_tmp13_);
#line 212 "../lib/Widgets/AboutWindow.vala"
						_tmp13_ = _tmp17_;
#line 1057 "AboutWindow.c"
					}
#line 210 "../lib/Widgets/AboutWindow.vala"
					_tmp18_ = developer_label;
#line 210 "../lib/Widgets/AboutWindow.vala"
					gtk_label_set_text (_tmp18_, _tmp13_);
#line 209 "../lib/Widgets/AboutWindow.vala"
					_g_free0 (_tmp13_);
#line 1065 "AboutWindow.c"
				} else {
					GtkLabel* _tmp19_;
					const gchar* _tmp20_;
#line 214 "../lib/Widgets/AboutWindow.vala"
					_tmp19_ = developer_label;
#line 214 "../lib/Widgets/AboutWindow.vala"
					_tmp20_ = developers[i];
#line 214 "../lib/Widgets/AboutWindow.vala"
					gtk_label_set_text (_tmp19_, _tmp20_);
#line 1075 "AboutWindow.c"
				}
#line 216 "../lib/Widgets/AboutWindow.vala"
				_tmp21_ = developer_label;
#line 216 "../lib/Widgets/AboutWindow.vala"
				gtk_widget_set_visible ((GtkWidget*) _tmp21_, TRUE);
#line 217 "../lib/Widgets/AboutWindow.vala"
				_tmp22_ = self->priv->developers_box;
#line 217 "../lib/Widgets/AboutWindow.vala"
				_tmp23_ = developer_label;
#line 217 "../lib/Widgets/AboutWindow.vala"
				gtk_box_append (_tmp22_, (GtkWidget*) _tmp23_);
#line 218 "../lib/Widgets/AboutWindow.vala"
				_tmp24_ = self->priv->developers_box;
#line 218 "../lib/Widgets/AboutWindow.vala"
				gtk_widget_set_visible ((GtkWidget*) _tmp24_, TRUE);
#line 206 "../lib/Widgets/AboutWindow.vala"
				_g_object_unref0 (developer_label);
#line 1093 "AboutWindow.c"
			}
		}
	}
#line 221 "../lib/Widgets/AboutWindow.vala"
	_tmp25_ = self->priv->developers_box;
#line 221 "../lib/Widgets/AboutWindow.vala"
	_tmp26_ = gtk_widget_get_visible ((GtkWidget*) _tmp25_);
#line 221 "../lib/Widgets/AboutWindow.vala"
	_tmp27_ = _tmp26_;
#line 221 "../lib/Widgets/AboutWindow.vala"
	if (_tmp27_ == FALSE) {
#line 1105 "AboutWindow.c"
		GtkScrolledWindow* _tmp28_;
#line 222 "../lib/Widgets/AboutWindow.vala"
		_tmp28_ = self->priv->developers_box_scroller;
#line 222 "../lib/Widgets/AboutWindow.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp28_, FALSE);
#line 1111 "AboutWindow.c"
	} else {
		GtkScrolledWindow* _tmp29_;
#line 224 "../lib/Widgets/AboutWindow.vala"
		_tmp29_ = self->priv->developers_box_scroller;
#line 224 "../lib/Widgets/AboutWindow.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp29_, TRUE);
#line 1118 "AboutWindow.c"
	}
#line 197 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (first_child);
#line 1122 "AboutWindow.c"
}

gchar**
he_about_window_get_developer_names (HeAboutWindow* self,
                                     gint* result_length1)
{
	gchar** result;
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar** _tmp1_;
	gint _tmp1__length1;
#line 233 "../lib/Widgets/AboutWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 233 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = self->priv->developers;
#line 233 "../lib/Widgets/AboutWindow.vala"
	_tmp0__length1 = self->priv->developers_length1;
#line 233 "../lib/Widgets/AboutWindow.vala"
	_tmp1_ = _tmp0_;
#line 233 "../lib/Widgets/AboutWindow.vala"
	_tmp1__length1 = _tmp0__length1;
#line 233 "../lib/Widgets/AboutWindow.vala"
	if (result_length1) {
#line 233 "../lib/Widgets/AboutWindow.vala"
		*result_length1 = _tmp1__length1;
#line 1148 "AboutWindow.c"
	}
#line 233 "../lib/Widgets/AboutWindow.vala"
	result = _tmp1_;
#line 233 "../lib/Widgets/AboutWindow.vala"
	return result;
#line 1154 "AboutWindow.c"
}

static gchar**
_vala_array_dup14 (gchar** self,
                   gssize length)
{
#line 235 "../lib/Widgets/AboutWindow.vala"
	if (length >= 0) {
#line 1163 "AboutWindow.c"
		gchar** result;
		gssize i;
#line 235 "../lib/Widgets/AboutWindow.vala"
		result = g_new0 (gchar*, length + 1);
#line 235 "../lib/Widgets/AboutWindow.vala"
		for (i = 0; i < length; i++) {
#line 1170 "AboutWindow.c"
			gchar* _tmp0_;
#line 235 "../lib/Widgets/AboutWindow.vala"
			_tmp0_ = g_strdup (self[i]);
#line 235 "../lib/Widgets/AboutWindow.vala"
			result[i] = _tmp0_;
#line 1176 "AboutWindow.c"
		}
#line 235 "../lib/Widgets/AboutWindow.vala"
		return result;
#line 1180 "AboutWindow.c"
	}
#line 235 "../lib/Widgets/AboutWindow.vala"
	return NULL;
#line 1184 "AboutWindow.c"
}

void
he_about_window_set_developer_names (HeAboutWindow* self,
                                     gchar** value,
                                     gint value_length1)
{
	gchar** _tmp0_;
	gint _tmp0__length1;
	gint _tmp1_;
	gint _tmp2_;
#line 234 "../lib/Widgets/AboutWindow.vala"
	g_return_if_fail (self != NULL);
#line 235 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = (value != NULL) ? _vala_array_dup14 (value, value_length1) : value;
#line 235 "../lib/Widgets/AboutWindow.vala"
	_tmp0__length1 = value_length1;
#line 235 "../lib/Widgets/AboutWindow.vala"
	self->priv->developers = (_vala_array_free (self->priv->developers, self->priv->developers_length1, (GDestroyNotify) g_free), NULL);
#line 235 "../lib/Widgets/AboutWindow.vala"
	self->priv->developers = _tmp0_;
#line 235 "../lib/Widgets/AboutWindow.vala"
	self->priv->developers_length1 = _tmp0__length1;
#line 235 "../lib/Widgets/AboutWindow.vala"
	self->priv->_developers_size_ = self->priv->developers_length1;
#line 236 "../lib/Widgets/AboutWindow.vala"
	_tmp1_ = he_about_window_get_copyright_year (self);
#line 236 "../lib/Widgets/AboutWindow.vala"
	_tmp2_ = _tmp1_;
#line 236 "../lib/Widgets/AboutWindow.vala"
	he_about_window_update_copyright (self, _tmp2_, value, (gint) value_length1);
#line 234 "../lib/Widgets/AboutWindow.vala"
	g_object_notify_by_pspec ((GObject *) self, he_about_window_properties[HE_ABOUT_WINDOW_DEVELOPER_NAMES_PROPERTY]);
#line 1218 "AboutWindow.c"
}

gint
he_about_window_get_copyright_year (HeAboutWindow* self)
{
	gint result;
#line 245 "../lib/Widgets/AboutWindow.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 245 "../lib/Widgets/AboutWindow.vala"
	result = self->priv->_copyright_year;
#line 245 "../lib/Widgets/AboutWindow.vala"
	return result;
#line 1231 "AboutWindow.c"
}

void
he_about_window_set_copyright_year (HeAboutWindow* self,
                                    gint value)
{
	gchar** _tmp0_;
	gint _tmp0__length1;
#line 246 "../lib/Widgets/AboutWindow.vala"
	g_return_if_fail (self != NULL);
#line 247 "../lib/Widgets/AboutWindow.vala"
	self->priv->_copyright_year = value;
#line 248 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = self->priv->developers;
#line 248 "../lib/Widgets/AboutWindow.vala"
	_tmp0__length1 = self->priv->developers_length1;
#line 248 "../lib/Widgets/AboutWindow.vala"
	he_about_window_update_copyright (self, value, _tmp0_, (gint) _tmp0__length1);
#line 246 "../lib/Widgets/AboutWindow.vala"
	g_object_notify_by_pspec ((GObject *) self, he_about_window_properties[HE_ABOUT_WINDOW_COPYRIGHT_YEAR_PROPERTY]);
#line 1252 "AboutWindow.c"
}

const gchar*
he_about_window_get_app_id (HeAboutWindow* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 259 "../lib/Widgets/AboutWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 259 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = self->priv->_app_id;
#line 259 "../lib/Widgets/AboutWindow.vala"
	result = _tmp0_;
#line 259 "../lib/Widgets/AboutWindow.vala"
	return result;
#line 1268 "AboutWindow.c"
}

void
he_about_window_set_app_id (HeAboutWindow* self,
                            const gchar* value)
{
	gchar* old_value;
#line 259 "../lib/Widgets/AboutWindow.vala"
	g_return_if_fail (self != NULL);
#line 259 "../lib/Widgets/AboutWindow.vala"
	old_value = he_about_window_get_app_id (self);
#line 259 "../lib/Widgets/AboutWindow.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1282 "AboutWindow.c"
		gchar* _tmp0_;
#line 259 "../lib/Widgets/AboutWindow.vala"
		_tmp0_ = g_strdup (value);
#line 259 "../lib/Widgets/AboutWindow.vala"
		_g_free0 (self->priv->_app_id);
#line 259 "../lib/Widgets/AboutWindow.vala"
		self->priv->_app_id = _tmp0_;
#line 259 "../lib/Widgets/AboutWindow.vala"
		g_object_notify_by_pspec ((GObject *) self, he_about_window_properties[HE_ABOUT_WINDOW_APP_ID_PROPERTY]);
#line 1292 "AboutWindow.c"
	}
}

const gchar*
he_about_window_get_translate_url (HeAboutWindow* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 264 "../lib/Widgets/AboutWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 264 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = self->priv->_translate_url;
#line 264 "../lib/Widgets/AboutWindow.vala"
	result = _tmp0_;
#line 264 "../lib/Widgets/AboutWindow.vala"
	return result;
#line 1309 "AboutWindow.c"
}

void
he_about_window_set_translate_url (HeAboutWindow* self,
                                   const gchar* value)
{
	gchar* _tmp0_;
#line 265 "../lib/Widgets/AboutWindow.vala"
	g_return_if_fail (self != NULL);
#line 266 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = g_strdup (value);
#line 266 "../lib/Widgets/AboutWindow.vala"
	_g_free0 (self->priv->_translate_url);
#line 266 "../lib/Widgets/AboutWindow.vala"
	self->priv->_translate_url = _tmp0_;
#line 267 "../lib/Widgets/AboutWindow.vala"
	if (value != NULL) {
#line 1327 "AboutWindow.c"
		HeButton* _tmp1_;
#line 268 "../lib/Widgets/AboutWindow.vala"
		_tmp1_ = self->priv->translate_app_button;
#line 268 "../lib/Widgets/AboutWindow.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp1_, TRUE);
#line 1333 "AboutWindow.c"
	} else {
		HeButton* _tmp2_;
#line 270 "../lib/Widgets/AboutWindow.vala"
		_tmp2_ = self->priv->translate_app_button;
#line 270 "../lib/Widgets/AboutWindow.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp2_, FALSE);
#line 1340 "AboutWindow.c"
	}
#line 265 "../lib/Widgets/AboutWindow.vala"
	g_object_notify_by_pspec ((GObject *) self, he_about_window_properties[HE_ABOUT_WINDOW_TRANSLATE_URL_PROPERTY]);
#line 1344 "AboutWindow.c"
}

const gchar*
he_about_window_get_issue_url (HeAboutWindow* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 278 "../lib/Widgets/AboutWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 278 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = self->priv->_issue_url;
#line 278 "../lib/Widgets/AboutWindow.vala"
	result = _tmp0_;
#line 278 "../lib/Widgets/AboutWindow.vala"
	return result;
#line 1360 "AboutWindow.c"
}

void
he_about_window_set_issue_url (HeAboutWindow* self,
                               const gchar* value)
{
	gchar* _tmp0_;
#line 279 "../lib/Widgets/AboutWindow.vala"
	g_return_if_fail (self != NULL);
#line 280 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = g_strdup (value);
#line 280 "../lib/Widgets/AboutWindow.vala"
	_g_free0 (self->priv->_issue_url);
#line 280 "../lib/Widgets/AboutWindow.vala"
	self->priv->_issue_url = _tmp0_;
#line 281 "../lib/Widgets/AboutWindow.vala"
	if (value != NULL) {
#line 1378 "AboutWindow.c"
		HeButton* _tmp1_;
#line 282 "../lib/Widgets/AboutWindow.vala"
		_tmp1_ = self->priv->report_button;
#line 282 "../lib/Widgets/AboutWindow.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp1_, TRUE);
#line 1384 "AboutWindow.c"
	} else {
		HeButton* _tmp2_;
#line 284 "../lib/Widgets/AboutWindow.vala"
		_tmp2_ = self->priv->report_button;
#line 284 "../lib/Widgets/AboutWindow.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp2_, FALSE);
#line 1391 "AboutWindow.c"
	}
#line 279 "../lib/Widgets/AboutWindow.vala"
	g_object_notify_by_pspec ((GObject *) self, he_about_window_properties[HE_ABOUT_WINDOW_ISSUE_URL_PROPERTY]);
#line 1395 "AboutWindow.c"
}

const gchar*
he_about_window_get_more_info_url (HeAboutWindow* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 292 "../lib/Widgets/AboutWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 292 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = self->priv->_more_info_url;
#line 292 "../lib/Widgets/AboutWindow.vala"
	result = _tmp0_;
#line 292 "../lib/Widgets/AboutWindow.vala"
	return result;
#line 1411 "AboutWindow.c"
}

void
he_about_window_set_more_info_url (HeAboutWindow* self,
                                   const gchar* value)
{
	gchar* _tmp0_;
#line 293 "../lib/Widgets/AboutWindow.vala"
	g_return_if_fail (self != NULL);
#line 294 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = g_strdup (value);
#line 294 "../lib/Widgets/AboutWindow.vala"
	_g_free0 (self->priv->_more_info_url);
#line 294 "../lib/Widgets/AboutWindow.vala"
	self->priv->_more_info_url = _tmp0_;
#line 295 "../lib/Widgets/AboutWindow.vala"
	if (value != NULL) {
#line 1429 "AboutWindow.c"
		HeButton* _tmp1_;
#line 296 "../lib/Widgets/AboutWindow.vala"
		_tmp1_ = self->priv->more_info_button;
#line 296 "../lib/Widgets/AboutWindow.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp1_, TRUE);
#line 1435 "AboutWindow.c"
	} else {
		HeButton* _tmp2_;
#line 298 "../lib/Widgets/AboutWindow.vala"
		_tmp2_ = self->priv->more_info_button;
#line 298 "../lib/Widgets/AboutWindow.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp2_, FALSE);
#line 1442 "AboutWindow.c"
	}
#line 293 "../lib/Widgets/AboutWindow.vala"
	g_object_notify_by_pspec ((GObject *) self, he_about_window_properties[HE_ABOUT_WINDOW_MORE_INFO_URL_PROPERTY]);
#line 1446 "AboutWindow.c"
}

/**
     * Creates a new AboutWindow.
     * @param parent The parent window.
     * @param app_name Your application's name.
     * @param app_id Your application's reverse-domain name.
     * @param version Your application's version.
     * @param icon Your application's icon.
     * @param translate_url A URL where contributors can help translate the application.
     * @param issue_url A URL where users can report a problem with the application.
     * @param more_info_url A URL where users can get more information about the application.
     * @param translators Your application's translators.
     * @param developers Your application's developers.
     * @param copyright_year Your application's copyright year.
     * @param license Your application's license.
     * @param color The color of the AboutWindow.
     *
     * @since 1.0
     */
HeAboutWindow*
he_about_window_construct (GType object_type,
                           GtkWindow* parent,
                           const gchar* app_name,
                           const gchar* app_id,
                           const gchar* version,
                           const gchar* icon,
                           const gchar* translate_url,
                           const gchar* issue_url,
                           const gchar* more_info_url,
                           gchar** translators,
                           gint translators_length1,
                           gchar** developers,
                           gint developers_length1,
                           gint copyright_year,
                           HeAboutWindowLicenses license,
                           HeColors color)
{
	HeAboutWindow * self = NULL;
	gint _tmp0_ = 0;
#line 411 "../lib/Widgets/AboutWindow.vala"
	g_return_val_if_fail (parent != NULL, NULL);
#line 411 "../lib/Widgets/AboutWindow.vala"
	g_return_val_if_fail (app_name != NULL, NULL);
#line 411 "../lib/Widgets/AboutWindow.vala"
	g_return_val_if_fail (app_id != NULL, NULL);
#line 411 "../lib/Widgets/AboutWindow.vala"
	self = (HeAboutWindow*) he_window_construct (object_type);
#line 424 "../lib/Widgets/AboutWindow.vala"
	he_window_set_parent ((HeWindow*) self, parent);
#line 425 "../lib/Widgets/AboutWindow.vala"
	he_about_window_set_app_name (self, app_name);
#line 426 "../lib/Widgets/AboutWindow.vala"
	he_about_window_set_app_id (self, app_id);
#line 427 "../lib/Widgets/AboutWindow.vala"
	he_about_window_set_version (self, version);
#line 428 "../lib/Widgets/AboutWindow.vala"
	he_about_window_set_icon (self, icon);
#line 429 "../lib/Widgets/AboutWindow.vala"
	he_about_window_set_translate_url (self, translate_url);
#line 430 "../lib/Widgets/AboutWindow.vala"
	he_about_window_set_issue_url (self, issue_url);
#line 431 "../lib/Widgets/AboutWindow.vala"
	he_about_window_set_more_info_url (self, more_info_url);
#line 432 "../lib/Widgets/AboutWindow.vala"
	he_about_window_set_translator_names (self, translators, translators_length1);
#line 433 "../lib/Widgets/AboutWindow.vala"
	he_about_window_set_developer_names (self, developers, developers_length1);
#line 434 "../lib/Widgets/AboutWindow.vala"
	if (copyright_year != 0) {
#line 434 "../lib/Widgets/AboutWindow.vala"
		_tmp0_ = copyright_year;
#line 1519 "AboutWindow.c"
	} else {
#line 434 "../lib/Widgets/AboutWindow.vala"
		_tmp0_ = 69;
#line 1523 "AboutWindow.c"
	}
#line 434 "../lib/Widgets/AboutWindow.vala"
	he_about_window_set_copyright_year (self, _tmp0_);
#line 435 "../lib/Widgets/AboutWindow.vala"
	he_about_window_set_license (self, license);
#line 436 "../lib/Widgets/AboutWindow.vala"
	he_about_window_set_color (self, color);
#line 411 "../lib/Widgets/AboutWindow.vala"
	return self;
#line 1533 "AboutWindow.c"
}

HeAboutWindow*
he_about_window_new (GtkWindow* parent,
                     const gchar* app_name,
                     const gchar* app_id,
                     const gchar* version,
                     const gchar* icon,
                     const gchar* translate_url,
                     const gchar* issue_url,
                     const gchar* more_info_url,
                     gchar** translators,
                     gint translators_length1,
                     gchar** developers,
                     gint developers_length1,
                     gint copyright_year,
                     HeAboutWindowLicenses license,
                     HeColors color)
{
#line 411 "../lib/Widgets/AboutWindow.vala"
	return he_about_window_construct (HE_TYPE_ABOUT_WINDOW, parent, app_name, app_id, version, icon, translate_url, issue_url, more_info_url, translators, translators_length1, developers, developers_length1, copyright_year, license, color);
#line 1555 "AboutWindow.c"
}

static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
#line 303 "../lib/Widgets/AboutWindow.vala"
	g_atomic_int_inc (&_data3_->_ref_count_);
#line 303 "../lib/Widgets/AboutWindow.vala"
	return _data3_;
#line 1565 "AboutWindow.c"
}

static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
#line 303 "../lib/Widgets/AboutWindow.vala"
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
#line 1575 "AboutWindow.c"
		HeAboutWindow* self;
#line 303 "../lib/Widgets/AboutWindow.vala"
		self = _data3_->self;
#line 303 "../lib/Widgets/AboutWindow.vala"
		_g_object_unref0 (_data3_->uri_launcher);
#line 303 "../lib/Widgets/AboutWindow.vala"
		_g_object_unref0 (self);
#line 303 "../lib/Widgets/AboutWindow.vala"
		g_slice_free (Block3Data, _data3_);
#line 1585 "AboutWindow.c"
	}
}

static void
_he_about_window___lambda124_ (Block3Data* _data3_)
{
	HeAboutWindow* self;
	GtkUriLauncher* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	GtkUriLauncher* _tmp3_;
	GtkWindow* _tmp4_;
	GtkWindow* _tmp5_;
#line 369 "../lib/Widgets/AboutWindow.vala"
	self = _data3_->self;
#line 370 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = _data3_->uri_launcher;
#line 370 "../lib/Widgets/AboutWindow.vala"
	_tmp1_ = he_about_window_get_translate_url (self);
#line 370 "../lib/Widgets/AboutWindow.vala"
	_tmp2_ = _tmp1_;
#line 370 "../lib/Widgets/AboutWindow.vala"
	gtk_uri_launcher_set_uri (_tmp0_, _tmp2_);
#line 371 "../lib/Widgets/AboutWindow.vala"
	_tmp3_ = _data3_->uri_launcher;
#line 371 "../lib/Widgets/AboutWindow.vala"
	_tmp4_ = he_window_get_parent ((HeWindow*) self);
#line 371 "../lib/Widgets/AboutWindow.vala"
	_tmp5_ = _tmp4_;
#line 371 "../lib/Widgets/AboutWindow.vala"
	gtk_uri_launcher_launch (_tmp3_, _tmp5_, NULL, NULL, NULL);
#line 1617 "AboutWindow.c"
}

static void
__he_about_window___lambda124__gtk_button_clicked (GtkButton* _sender,
                                                   gpointer self)
{
#line 369 "../lib/Widgets/AboutWindow.vala"
	_he_about_window___lambda124_ (self);
#line 1626 "AboutWindow.c"
}

static void
_he_about_window___lambda125_ (Block3Data* _data3_)
{
	HeAboutWindow* self;
	GtkUriLauncher* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	GtkUriLauncher* _tmp3_;
	GtkWindow* _tmp4_;
	GtkWindow* _tmp5_;
#line 374 "../lib/Widgets/AboutWindow.vala"
	self = _data3_->self;
#line 375 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = _data3_->uri_launcher;
#line 375 "../lib/Widgets/AboutWindow.vala"
	_tmp1_ = he_about_window_get_issue_url (self);
#line 375 "../lib/Widgets/AboutWindow.vala"
	_tmp2_ = _tmp1_;
#line 375 "../lib/Widgets/AboutWindow.vala"
	gtk_uri_launcher_set_uri (_tmp0_, _tmp2_);
#line 376 "../lib/Widgets/AboutWindow.vala"
	_tmp3_ = _data3_->uri_launcher;
#line 376 "../lib/Widgets/AboutWindow.vala"
	_tmp4_ = he_window_get_parent ((HeWindow*) self);
#line 376 "../lib/Widgets/AboutWindow.vala"
	_tmp5_ = _tmp4_;
#line 376 "../lib/Widgets/AboutWindow.vala"
	gtk_uri_launcher_launch (_tmp3_, _tmp5_, NULL, NULL, NULL);
#line 1657 "AboutWindow.c"
}

static void
__he_about_window___lambda125__gtk_button_clicked (GtkButton* _sender,
                                                   gpointer self)
{
#line 374 "../lib/Widgets/AboutWindow.vala"
	_he_about_window___lambda125_ (self);
#line 1666 "AboutWindow.c"
}

static void
_he_about_window___lambda126_ (Block3Data* _data3_)
{
	HeAboutWindow* self;
	GtkUriLauncher* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	GtkUriLauncher* _tmp3_;
	GtkWindow* _tmp4_;
	GtkWindow* _tmp5_;
#line 379 "../lib/Widgets/AboutWindow.vala"
	self = _data3_->self;
#line 380 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = _data3_->uri_launcher;
#line 380 "../lib/Widgets/AboutWindow.vala"
	_tmp1_ = he_about_window_get_more_info_url (self);
#line 380 "../lib/Widgets/AboutWindow.vala"
	_tmp2_ = _tmp1_;
#line 380 "../lib/Widgets/AboutWindow.vala"
	gtk_uri_launcher_set_uri (_tmp0_, _tmp2_);
#line 381 "../lib/Widgets/AboutWindow.vala"
	_tmp3_ = _data3_->uri_launcher;
#line 381 "../lib/Widgets/AboutWindow.vala"
	_tmp4_ = he_window_get_parent ((HeWindow*) self);
#line 381 "../lib/Widgets/AboutWindow.vala"
	_tmp5_ = _tmp4_;
#line 381 "../lib/Widgets/AboutWindow.vala"
	gtk_uri_launcher_launch (_tmp3_, _tmp5_, NULL, NULL, NULL);
#line 1697 "AboutWindow.c"
}

static void
__he_about_window___lambda126__gtk_button_clicked (GtkButton* _sender,
                                                   gpointer self)
{
#line 379 "../lib/Widgets/AboutWindow.vala"
	_he_about_window___lambda126_ (self);
#line 1706 "AboutWindow.c"
}

static void
_gtk_window_close_gtk_button_clicked (GtkButton* _sender,
                                      gpointer self)
{
#line 384 "../lib/Widgets/AboutWindow.vala"
	gtk_window_close ((GtkWindow*) self);
#line 1715 "AboutWindow.c"
}

static GObject *
he_about_window_constructor (GType type,
                             guint n_construct_properties,
                             GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	HeAboutWindow * self;
	Block3Data* _data3_;
	HeButton* close_button = NULL;
	HeButton* _tmp0_;
	HeButton* _tmp1_;
	HeButton* _tmp2_;
	HeButton* _tmp3_;
	HeButton* _tmp4_;
	HeButton* _tmp5_;
	HeButton* _tmp6_;
	GtkOverlay* _tmp7_;
	HeButton* _tmp8_;
	GtkOverlay* _tmp9_;
	GtkBox* _tmp10_;
	GtkBox* _tmp11_;
	GtkBox* _tmp12_;
	GtkBox* _tmp13_;
	GtkBox* _tmp14_;
	GtkBox* _tmp15_;
	GtkImage* _tmp16_;
	GtkImage* _tmp17_;
	GtkImage* _tmp18_;
	GtkImage* _tmp19_;
	GtkBox* _tmp20_;
	GtkImage* _tmp21_;
	GtkBox* _tmp22_;
	GtkBox* _tmp23_;
	GtkBox* _tmp24_;
	GtkBox* _tmp25_;
	GtkBox* _tmp26_;
	GtkBox* _tmp27_;
	HeModifierBadge* _tmp28_;
	HeModifierBadge* _tmp29_;
	GtkLabel* _tmp30_;
	GtkBox* _tmp31_;
	GtkLabel* _tmp32_;
	GtkBox* _tmp33_;
	HeModifierBadge* _tmp34_;
	GtkBox* _tmp35_;
	GtkBox* _tmp36_;
	GtkBox* _tmp37_;
	GtkScrolledWindow* _tmp38_;
	GtkBox* _tmp39_;
	GtkScrolledWindow* _tmp40_;
	GtkBox* _tmp41_;
	GtkScrolledWindow* _tmp42_;
	GtkBox* _tmp43_;
	GtkBox* _tmp44_;
	GtkBox* _tmp45_;
	GtkScrolledWindow* _tmp46_;
	GtkBox* _tmp47_;
	GtkScrolledWindow* _tmp48_;
	GtkBox* _tmp49_;
	GtkScrolledWindow* _tmp50_;
	GtkLabel* _tmp51_;
	GtkLabel* _tmp52_;
	GtkBox* _tmp53_;
	GtkLabel* _tmp54_;
	HeButton* _tmp55_;
	HeButton* _tmp56_;
	HeButton* _tmp57_;
	GtkBox* _tmp58_;
	GtkBox* _tmp59_;
	GtkBox* _tmp60_;
	HeButton* _tmp61_;
	GtkBox* _tmp62_;
	HeButton* _tmp63_;
	GtkBox* _tmp64_;
	HeButton* _tmp65_;
	GtkUriLauncher* _tmp66_;
	HeButton* _tmp67_;
	HeButton* _tmp68_;
	HeButton* _tmp69_;
	HeButton* _tmp70_;
	GtkWindowHandle* window_handle = NULL;
	GtkWindowHandle* _tmp71_;
	GtkWindowHandle* _tmp72_;
	GtkOverlay* _tmp73_;
	GtkWindowHandle* _tmp74_;
#line 303 "../lib/Widgets/AboutWindow.vala"
	parent_class = G_OBJECT_CLASS (he_about_window_parent_class);
#line 303 "../lib/Widgets/AboutWindow.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 303 "../lib/Widgets/AboutWindow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_ABOUT_WINDOW, HeAboutWindow);
#line 303 "../lib/Widgets/AboutWindow.vala"
	_data3_ = g_slice_new0 (Block3Data);
#line 303 "../lib/Widgets/AboutWindow.vala"
	_data3_->_ref_count_ = 1;
#line 303 "../lib/Widgets/AboutWindow.vala"
	_data3_->self = g_object_ref (self);
#line 304 "../lib/Widgets/AboutWindow.vala"
	gtk_window_set_modal ((GtkWindow*) self, TRUE);
#line 305 "../lib/Widgets/AboutWindow.vala"
	gtk_window_set_resizable ((GtkWindow*) self, FALSE);
#line 307 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = he_button_new ("window-close-symbolic", "");
#line 307 "../lib/Widgets/AboutWindow.vala"
	g_object_ref_sink (_tmp0_);
#line 307 "../lib/Widgets/AboutWindow.vala"
	close_button = _tmp0_;
#line 308 "../lib/Widgets/AboutWindow.vala"
	_tmp1_ = close_button;
#line 308 "../lib/Widgets/AboutWindow.vala"
	he_button_set_is_disclosure (_tmp1_, TRUE);
#line 309 "../lib/Widgets/AboutWindow.vala"
	_tmp2_ = close_button;
#line 309 "../lib/Widgets/AboutWindow.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp2_, GTK_ALIGN_END);
#line 310 "../lib/Widgets/AboutWindow.vala"
	_tmp3_ = close_button;
#line 310 "../lib/Widgets/AboutWindow.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp3_, GTK_ALIGN_START);
#line 311 "../lib/Widgets/AboutWindow.vala"
	_tmp4_ = close_button;
#line 311 "../lib/Widgets/AboutWindow.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp4_, 24);
#line 312 "../lib/Widgets/AboutWindow.vala"
	_tmp5_ = close_button;
#line 312 "../lib/Widgets/AboutWindow.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp5_, 24);
#line 313 "../lib/Widgets/AboutWindow.vala"
	_tmp6_ = close_button;
#line 313 "../lib/Widgets/AboutWindow.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp6_, _ ("Close"));
#line 315 "../lib/Widgets/AboutWindow.vala"
	_tmp7_ = self->priv->window_overlay;
#line 315 "../lib/Widgets/AboutWindow.vala"
	_tmp8_ = close_button;
#line 315 "../lib/Widgets/AboutWindow.vala"
	gtk_overlay_add_overlay (_tmp7_, (GtkWidget*) _tmp8_);
#line 316 "../lib/Widgets/AboutWindow.vala"
	_tmp9_ = self->priv->window_overlay;
#line 316 "../lib/Widgets/AboutWindow.vala"
	_tmp10_ = self->priv->about_box;
#line 316 "../lib/Widgets/AboutWindow.vala"
	gtk_overlay_set_child (_tmp9_, (GtkWidget*) _tmp10_);
#line 318 "../lib/Widgets/AboutWindow.vala"
	_tmp11_ = self->priv->about_box;
#line 318 "../lib/Widgets/AboutWindow.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp11_, "dialog-content");
#line 319 "../lib/Widgets/AboutWindow.vala"
	_tmp12_ = self->priv->about_box;
#line 319 "../lib/Widgets/AboutWindow.vala"
	_tmp13_ = self->priv->content_box;
#line 319 "../lib/Widgets/AboutWindow.vala"
	gtk_box_append (_tmp12_, (GtkWidget*) _tmp13_);
#line 320 "../lib/Widgets/AboutWindow.vala"
	_tmp14_ = self->priv->about_box;
#line 320 "../lib/Widgets/AboutWindow.vala"
	_tmp15_ = self->priv->button_box;
#line 320 "../lib/Widgets/AboutWindow.vala"
	gtk_box_append (_tmp14_, (GtkWidget*) _tmp15_);
#line 322 "../lib/Widgets/AboutWindow.vala"
	_tmp16_ = self->priv->icon_image;
#line 322 "../lib/Widgets/AboutWindow.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp16_, GTK_ALIGN_START);
#line 323 "../lib/Widgets/AboutWindow.vala"
	_tmp17_ = self->priv->icon_image;
#line 323 "../lib/Widgets/AboutWindow.vala"
	gtk_image_set_pixel_size (_tmp17_, 128);
#line 324 "../lib/Widgets/AboutWindow.vala"
	_tmp18_ = self->priv->icon_image;
#line 324 "../lib/Widgets/AboutWindow.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp18_, 24);
#line 325 "../lib/Widgets/AboutWindow.vala"
	_tmp19_ = self->priv->icon_image;
#line 325 "../lib/Widgets/AboutWindow.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp19_, "icon-dropshadow");
#line 327 "../lib/Widgets/AboutWindow.vala"
	_tmp20_ = self->priv->content_box;
#line 327 "../lib/Widgets/AboutWindow.vala"
	_tmp21_ = self->priv->icon_image;
#line 327 "../lib/Widgets/AboutWindow.vala"
	gtk_box_append (_tmp20_, (GtkWidget*) _tmp21_);
#line 328 "../lib/Widgets/AboutWindow.vala"
	_tmp22_ = self->priv->content_box;
#line 328 "../lib/Widgets/AboutWindow.vala"
	_tmp23_ = self->priv->info_box;
#line 328 "../lib/Widgets/AboutWindow.vala"
	gtk_box_append (_tmp22_, (GtkWidget*) _tmp23_);
#line 330 "../lib/Widgets/AboutWindow.vala"
	_tmp24_ = self->priv->info_box;
#line 330 "../lib/Widgets/AboutWindow.vala"
	_tmp25_ = self->priv->title_box;
#line 330 "../lib/Widgets/AboutWindow.vala"
	gtk_box_append (_tmp24_, (GtkWidget*) _tmp25_);
#line 331 "../lib/Widgets/AboutWindow.vala"
	_tmp26_ = self->priv->info_box;
#line 331 "../lib/Widgets/AboutWindow.vala"
	_tmp27_ = self->priv->text_box;
#line 331 "../lib/Widgets/AboutWindow.vala"
	gtk_box_append (_tmp26_, (GtkWidget*) _tmp27_);
#line 333 "../lib/Widgets/AboutWindow.vala"
	_tmp28_ = self->priv->version_badge;
#line 333 "../lib/Widgets/AboutWindow.vala"
	he_modifier_badge_set_tinted (_tmp28_, TRUE);
#line 334 "../lib/Widgets/AboutWindow.vala"
	_tmp29_ = self->priv->version_badge;
#line 334 "../lib/Widgets/AboutWindow.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp29_, 24);
#line 335 "../lib/Widgets/AboutWindow.vala"
	_tmp30_ = self->priv->title_label;
#line 335 "../lib/Widgets/AboutWindow.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp30_, "display");
#line 336 "../lib/Widgets/AboutWindow.vala"
	_tmp31_ = self->priv->title_box;
#line 336 "../lib/Widgets/AboutWindow.vala"
	_tmp32_ = self->priv->title_label;
#line 336 "../lib/Widgets/AboutWindow.vala"
	gtk_box_append (_tmp31_, (GtkWidget*) _tmp32_);
#line 337 "../lib/Widgets/AboutWindow.vala"
	_tmp33_ = self->priv->title_box;
#line 337 "../lib/Widgets/AboutWindow.vala"
	_tmp34_ = self->priv->version_badge;
#line 337 "../lib/Widgets/AboutWindow.vala"
	gtk_box_append (_tmp33_, (GtkWidget*) _tmp34_);
#line 339 "../lib/Widgets/AboutWindow.vala"
	_tmp35_ = self->priv->developers_box;
#line 339 "../lib/Widgets/AboutWindow.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp35_, FALSE);
#line 340 "../lib/Widgets/AboutWindow.vala"
	_tmp36_ = self->priv->developers_box;
#line 340 "../lib/Widgets/AboutWindow.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp36_, GTK_ALIGN_START);
#line 341 "../lib/Widgets/AboutWindow.vala"
	_tmp37_ = self->priv->developers_box;
#line 341 "../lib/Widgets/AboutWindow.vala"
	gtk_widget_set_vexpand_set ((GtkWidget*) _tmp37_, TRUE);
#line 342 "../lib/Widgets/AboutWindow.vala"
	_tmp38_ = self->priv->developers_box_scroller;
#line 342 "../lib/Widgets/AboutWindow.vala"
	_tmp39_ = self->priv->developers_box;
#line 342 "../lib/Widgets/AboutWindow.vala"
	gtk_scrolled_window_set_child (_tmp38_, (GtkWidget*) _tmp39_);
#line 343 "../lib/Widgets/AboutWindow.vala"
	_tmp40_ = self->priv->developers_box_scroller;
#line 343 "../lib/Widgets/AboutWindow.vala"
	g_object_set (_tmp40_, "hscrollbar-policy", GTK_POLICY_NEVER, NULL);
#line 344 "../lib/Widgets/AboutWindow.vala"
	_tmp41_ = self->priv->text_box;
#line 344 "../lib/Widgets/AboutWindow.vala"
	_tmp42_ = self->priv->developers_box_scroller;
#line 344 "../lib/Widgets/AboutWindow.vala"
	gtk_box_append (_tmp41_, (GtkWidget*) _tmp42_);
#line 346 "../lib/Widgets/AboutWindow.vala"
	_tmp43_ = self->priv->translators_box;
#line 346 "../lib/Widgets/AboutWindow.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp43_, FALSE);
#line 347 "../lib/Widgets/AboutWindow.vala"
	_tmp44_ = self->priv->translators_box;
#line 347 "../lib/Widgets/AboutWindow.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp44_, GTK_ALIGN_START);
#line 348 "../lib/Widgets/AboutWindow.vala"
	_tmp45_ = self->priv->translators_box;
#line 348 "../lib/Widgets/AboutWindow.vala"
	gtk_widget_set_vexpand_set ((GtkWidget*) _tmp45_, TRUE);
#line 349 "../lib/Widgets/AboutWindow.vala"
	_tmp46_ = self->priv->translators_box_scroller;
#line 349 "../lib/Widgets/AboutWindow.vala"
	_tmp47_ = self->priv->translators_box;
#line 349 "../lib/Widgets/AboutWindow.vala"
	gtk_scrolled_window_set_child (_tmp46_, (GtkWidget*) _tmp47_);
#line 350 "../lib/Widgets/AboutWindow.vala"
	_tmp48_ = self->priv->translators_box_scroller;
#line 350 "../lib/Widgets/AboutWindow.vala"
	g_object_set (_tmp48_, "hscrollbar-policy", GTK_POLICY_NEVER, NULL);
#line 351 "../lib/Widgets/AboutWindow.vala"
	_tmp49_ = self->priv->text_box;
#line 351 "../lib/Widgets/AboutWindow.vala"
	_tmp50_ = self->priv->translators_box_scroller;
#line 351 "../lib/Widgets/AboutWindow.vala"
	gtk_box_append (_tmp49_, (GtkWidget*) _tmp50_);
#line 353 "../lib/Widgets/AboutWindow.vala"
	_tmp51_ = self->priv->license_label;
#line 353 "../lib/Widgets/AboutWindow.vala"
	gtk_label_set_xalign (_tmp51_, (gfloat) 0);
#line 354 "../lib/Widgets/AboutWindow.vala"
	_tmp52_ = self->priv->license_label;
#line 354 "../lib/Widgets/AboutWindow.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp52_, TRUE);
#line 355 "../lib/Widgets/AboutWindow.vala"
	_tmp53_ = self->priv->text_box;
#line 355 "../lib/Widgets/AboutWindow.vala"
	_tmp54_ = self->priv->license_label;
#line 355 "../lib/Widgets/AboutWindow.vala"
	gtk_box_append (_tmp53_, (GtkWidget*) _tmp54_);
#line 357 "../lib/Widgets/AboutWindow.vala"
	_tmp55_ = self->priv->translate_app_button;
#line 357 "../lib/Widgets/AboutWindow.vala"
	he_button_set_is_textual (_tmp55_, TRUE);
#line 358 "../lib/Widgets/AboutWindow.vala"
	_tmp56_ = self->priv->report_button;
#line 358 "../lib/Widgets/AboutWindow.vala"
	he_button_set_is_tint (_tmp56_, TRUE);
#line 359 "../lib/Widgets/AboutWindow.vala"
	_tmp57_ = self->priv->more_info_button;
#line 359 "../lib/Widgets/AboutWindow.vala"
	he_button_set_is_fill (_tmp57_, TRUE);
#line 361 "../lib/Widgets/AboutWindow.vala"
	_tmp58_ = self->priv->button_box;
#line 361 "../lib/Widgets/AboutWindow.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp58_, GTK_ALIGN_CENTER);
#line 362 "../lib/Widgets/AboutWindow.vala"
	_tmp59_ = self->priv->button_box;
#line 362 "../lib/Widgets/AboutWindow.vala"
	gtk_box_set_homogeneous (_tmp59_, TRUE);
#line 363 "../lib/Widgets/AboutWindow.vala"
	_tmp60_ = self->priv->button_box;
#line 363 "../lib/Widgets/AboutWindow.vala"
	_tmp61_ = self->priv->translate_app_button;
#line 363 "../lib/Widgets/AboutWindow.vala"
	gtk_box_append (_tmp60_, (GtkWidget*) _tmp61_);
#line 364 "../lib/Widgets/AboutWindow.vala"
	_tmp62_ = self->priv->button_box;
#line 364 "../lib/Widgets/AboutWindow.vala"
	_tmp63_ = self->priv->report_button;
#line 364 "../lib/Widgets/AboutWindow.vala"
	gtk_box_append (_tmp62_, (GtkWidget*) _tmp63_);
#line 365 "../lib/Widgets/AboutWindow.vala"
	_tmp64_ = self->priv->button_box;
#line 365 "../lib/Widgets/AboutWindow.vala"
	_tmp65_ = self->priv->more_info_button;
#line 365 "../lib/Widgets/AboutWindow.vala"
	gtk_box_append (_tmp64_, (GtkWidget*) _tmp65_);
#line 367 "../lib/Widgets/AboutWindow.vala"
	_tmp66_ = gtk_uri_launcher_new ("");
#line 367 "../lib/Widgets/AboutWindow.vala"
	_data3_->uri_launcher = _tmp66_;
#line 369 "../lib/Widgets/AboutWindow.vala"
	_tmp67_ = self->priv->translate_app_button;
#line 369 "../lib/Widgets/AboutWindow.vala"
	g_signal_connect_data ((GtkButton*) _tmp67_, "clicked", (GCallback) __he_about_window___lambda124__gtk_button_clicked, block3_data_ref (_data3_), (GClosureNotify) block3_data_unref, 0);
#line 374 "../lib/Widgets/AboutWindow.vala"
	_tmp68_ = self->priv->report_button;
#line 374 "../lib/Widgets/AboutWindow.vala"
	g_signal_connect_data ((GtkButton*) _tmp68_, "clicked", (GCallback) __he_about_window___lambda125__gtk_button_clicked, block3_data_ref (_data3_), (GClosureNotify) block3_data_unref, 0);
#line 379 "../lib/Widgets/AboutWindow.vala"
	_tmp69_ = self->priv->more_info_button;
#line 379 "../lib/Widgets/AboutWindow.vala"
	g_signal_connect_data ((GtkButton*) _tmp69_, "clicked", (GCallback) __he_about_window___lambda126__gtk_button_clicked, block3_data_ref (_data3_), (GClosureNotify) block3_data_unref, 0);
#line 384 "../lib/Widgets/AboutWindow.vala"
	_tmp70_ = close_button;
#line 384 "../lib/Widgets/AboutWindow.vala"
	g_signal_connect_object ((GtkButton*) _tmp70_, "clicked", (GCallback) _gtk_window_close_gtk_button_clicked, (GtkWindow*) self, 0);
#line 386 "../lib/Widgets/AboutWindow.vala"
	_tmp71_ = (GtkWindowHandle*) gtk_window_handle_new ();
#line 386 "../lib/Widgets/AboutWindow.vala"
	g_object_ref_sink (_tmp71_);
#line 386 "../lib/Widgets/AboutWindow.vala"
	window_handle = _tmp71_;
#line 387 "../lib/Widgets/AboutWindow.vala"
	_tmp72_ = window_handle;
#line 387 "../lib/Widgets/AboutWindow.vala"
	_tmp73_ = self->priv->window_overlay;
#line 387 "../lib/Widgets/AboutWindow.vala"
	gtk_window_handle_set_child (_tmp72_, (GtkWidget*) _tmp73_);
#line 389 "../lib/Widgets/AboutWindow.vala"
	_tmp74_ = window_handle;
#line 389 "../lib/Widgets/AboutWindow.vala"
	gtk_window_set_child ((GtkWindow*) self, (GtkWidget*) _tmp74_);
#line 390 "../lib/Widgets/AboutWindow.vala"
	gtk_widget_add_css_class ((GtkWidget*) self, "dialog-content");
#line 303 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (window_handle);
#line 303 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (close_button);
#line 303 "../lib/Widgets/AboutWindow.vala"
	block3_data_unref (_data3_);
#line 303 "../lib/Widgets/AboutWindow.vala"
	_data3_ = NULL;
#line 303 "../lib/Widgets/AboutWindow.vala"
	return obj;
#line 2098 "AboutWindow.c"
}

static void
he_about_window_class_init (HeAboutWindowClass * klass,
                            gpointer klass_data)
{
#line 23 "../lib/Widgets/AboutWindow.vala"
	he_about_window_parent_class = g_type_class_peek_parent (klass);
#line 23 "../lib/Widgets/AboutWindow.vala"
	g_type_class_adjust_private_offset (klass, &HeAboutWindow_private_offset);
#line 23 "../lib/Widgets/AboutWindow.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_he_about_window_get_property;
#line 23 "../lib/Widgets/AboutWindow.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_he_about_window_set_property;
#line 23 "../lib/Widgets/AboutWindow.vala"
	G_OBJECT_CLASS (klass)->constructor = he_about_window_constructor;
#line 23 "../lib/Widgets/AboutWindow.vala"
	G_OBJECT_CLASS (klass)->finalize = he_about_window_finalize;
#line 2117 "AboutWindow.c"
	/**
	     * The theme color of the AboutWindow.
	     */
#line 23 "../lib/Widgets/AboutWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_ABOUT_WINDOW_COLOR_PROPERTY, he_about_window_properties[HE_ABOUT_WINDOW_COLOR_PROPERTY] = g_param_spec_enum ("color", "color", "color", HE_TYPE_COLORS, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2123 "AboutWindow.c"
	/**
	     * The license shown in the AboutWindow.
	     */
#line 23 "../lib/Widgets/AboutWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_ABOUT_WINDOW_LICENSE_PROPERTY, he_about_window_properties[HE_ABOUT_WINDOW_LICENSE_PROPERTY] = g_param_spec_enum ("license", "license", "license", HE_ABOUT_WINDOW_TYPE_LICENSES, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2129 "AboutWindow.c"
	/**
	     * The version shown in the AboutWindow.
	     */
#line 23 "../lib/Widgets/AboutWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_ABOUT_WINDOW_VERSION_PROPERTY, he_about_window_properties[HE_ABOUT_WINDOW_VERSION_PROPERTY] = g_param_spec_string ("version", "version", "version", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2135 "AboutWindow.c"
	/**
	     * The name of the application shown in the AboutWindow.
	     */
#line 23 "../lib/Widgets/AboutWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_ABOUT_WINDOW_APP_NAME_PROPERTY, he_about_window_properties[HE_ABOUT_WINDOW_APP_NAME_PROPERTY] = g_param_spec_string ("app-name", "app-name", "app-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2141 "AboutWindow.c"
	/**
	     *  The icon shown in the AboutWindow.
	     */
#line 23 "../lib/Widgets/AboutWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_ABOUT_WINDOW_ICON_PROPERTY, he_about_window_properties[HE_ABOUT_WINDOW_ICON_PROPERTY] = g_param_spec_string ("icon", "icon", "icon", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2147 "AboutWindow.c"
	/**
	     * The translators shown in the AboutWindow.
	     */
#line 23 "../lib/Widgets/AboutWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_ABOUT_WINDOW_TRANSLATOR_NAMES_PROPERTY, he_about_window_properties[HE_ABOUT_WINDOW_TRANSLATOR_NAMES_PROPERTY] = g_param_spec_boxed ("translator-names", "translator-names", "translator-names", G_TYPE_STRV, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2153 "AboutWindow.c"
	/**
	     * The developers shown in the AboutWindow.
	     */
#line 23 "../lib/Widgets/AboutWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_ABOUT_WINDOW_DEVELOPER_NAMES_PROPERTY, he_about_window_properties[HE_ABOUT_WINDOW_DEVELOPER_NAMES_PROPERTY] = g_param_spec_boxed ("developer-names", "developer-names", "developer-names", G_TYPE_STRV, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2159 "AboutWindow.c"
	/**
	     * The copyright year shown in the AboutWindow.
	     */
#line 23 "../lib/Widgets/AboutWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_ABOUT_WINDOW_COPYRIGHT_YEAR_PROPERTY, he_about_window_properties[HE_ABOUT_WINDOW_COPYRIGHT_YEAR_PROPERTY] = g_param_spec_int ("copyright-year", "copyright-year", "copyright-year", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2165 "AboutWindow.c"
	/**
	     * Your application's reverse-domain name.
	     */
#line 23 "../lib/Widgets/AboutWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_ABOUT_WINDOW_APP_ID_PROPERTY, he_about_window_properties[HE_ABOUT_WINDOW_APP_ID_PROPERTY] = g_param_spec_string ("app-id", "app-id", "app-id", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2171 "AboutWindow.c"
	/**
	     * A URL where contributors can help translate the application.
	     */
#line 23 "../lib/Widgets/AboutWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_ABOUT_WINDOW_TRANSLATE_URL_PROPERTY, he_about_window_properties[HE_ABOUT_WINDOW_TRANSLATE_URL_PROPERTY] = g_param_spec_string ("translate-url", "translate-url", "translate-url", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2177 "AboutWindow.c"
	/**
	     * A URL where users can report a problem with the application.
	     */
#line 23 "../lib/Widgets/AboutWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_ABOUT_WINDOW_ISSUE_URL_PROPERTY, he_about_window_properties[HE_ABOUT_WINDOW_ISSUE_URL_PROPERTY] = g_param_spec_string ("issue-url", "issue-url", "issue-url", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2183 "AboutWindow.c"
	/**
	     * A URL where users can get more information about the application.
	     */
#line 23 "../lib/Widgets/AboutWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_ABOUT_WINDOW_MORE_INFO_URL_PROPERTY, he_about_window_properties[HE_ABOUT_WINDOW_MORE_INFO_URL_PROPERTY] = g_param_spec_string ("more-info-url", "more-info-url", "more-info-url", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2189 "AboutWindow.c"
}

static void
he_about_window_instance_init (HeAboutWindow * self,
                               gpointer klass)
{
	GtkOverlay* _tmp0_;
	GtkBox* _tmp1_;
	GtkBox* _tmp2_;
	GtkBox* _tmp3_;
	GtkBox* _tmp4_;
	GtkBox* _tmp5_;
	GtkBox* _tmp6_;
	GtkBox* _tmp7_;
	GtkBox* _tmp8_;
	GtkLabel* _tmp9_;
	GtkLabel* _tmp10_;
	GtkImage* _tmp11_;
	GtkScrolledWindow* _tmp12_;
	GtkScrolledWindow* _tmp13_;
	HeButton* _tmp14_;
	HeButton* _tmp15_;
	HeButton* _tmp16_;
	HeModifierBadge* _tmp17_;
	gchar** _tmp18_;
	gchar** _tmp19_;
	gchar* _tmp20_;
#line 23 "../lib/Widgets/AboutWindow.vala"
	self->priv = he_about_window_get_instance_private (self);
#line 24 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = (GtkOverlay*) gtk_overlay_new ();
#line 24 "../lib/Widgets/AboutWindow.vala"
	g_object_ref_sink (_tmp0_);
#line 24 "../lib/Widgets/AboutWindow.vala"
	self->priv->window_overlay = _tmp0_;
#line 26 "../lib/Widgets/AboutWindow.vala"
	_tmp1_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 30);
#line 26 "../lib/Widgets/AboutWindow.vala"
	g_object_ref_sink (_tmp1_);
#line 26 "../lib/Widgets/AboutWindow.vala"
	self->priv->about_box = _tmp1_;
#line 27 "../lib/Widgets/AboutWindow.vala"
	_tmp2_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 18);
#line 27 "../lib/Widgets/AboutWindow.vala"
	g_object_ref_sink (_tmp2_);
#line 27 "../lib/Widgets/AboutWindow.vala"
	self->priv->content_box = _tmp2_;
#line 28 "../lib/Widgets/AboutWindow.vala"
	_tmp3_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 18);
#line 28 "../lib/Widgets/AboutWindow.vala"
	g_object_ref_sink (_tmp3_);
#line 28 "../lib/Widgets/AboutWindow.vala"
	self->priv->button_box = _tmp3_;
#line 29 "../lib/Widgets/AboutWindow.vala"
	_tmp4_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 12);
#line 29 "../lib/Widgets/AboutWindow.vala"
	g_object_ref_sink (_tmp4_);
#line 29 "../lib/Widgets/AboutWindow.vala"
	self->priv->info_box = _tmp4_;
#line 30 "../lib/Widgets/AboutWindow.vala"
	_tmp5_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 18);
#line 30 "../lib/Widgets/AboutWindow.vala"
	g_object_ref_sink (_tmp5_);
#line 30 "../lib/Widgets/AboutWindow.vala"
	self->priv->title_box = _tmp5_;
#line 31 "../lib/Widgets/AboutWindow.vala"
	_tmp6_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 6);
#line 31 "../lib/Widgets/AboutWindow.vala"
	g_object_ref_sink (_tmp6_);
#line 31 "../lib/Widgets/AboutWindow.vala"
	self->priv->text_box = _tmp6_;
#line 32 "../lib/Widgets/AboutWindow.vala"
	_tmp7_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 6);
#line 32 "../lib/Widgets/AboutWindow.vala"
	g_object_ref_sink (_tmp7_);
#line 32 "../lib/Widgets/AboutWindow.vala"
	self->priv->developers_box = _tmp7_;
#line 33 "../lib/Widgets/AboutWindow.vala"
	_tmp8_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 6);
#line 33 "../lib/Widgets/AboutWindow.vala"
	g_object_ref_sink (_tmp8_);
#line 33 "../lib/Widgets/AboutWindow.vala"
	self->priv->translators_box = _tmp8_;
#line 35 "../lib/Widgets/AboutWindow.vala"
	_tmp9_ = (GtkLabel*) gtk_label_new (NULL);
#line 35 "../lib/Widgets/AboutWindow.vala"
	g_object_ref_sink (_tmp9_);
#line 35 "../lib/Widgets/AboutWindow.vala"
	self->priv->title_label = _tmp9_;
#line 36 "../lib/Widgets/AboutWindow.vala"
	_tmp10_ = (GtkLabel*) gtk_label_new (NULL);
#line 36 "../lib/Widgets/AboutWindow.vala"
	g_object_ref_sink (_tmp10_);
#line 36 "../lib/Widgets/AboutWindow.vala"
	self->priv->license_label = _tmp10_;
#line 38 "../lib/Widgets/AboutWindow.vala"
	_tmp11_ = (GtkImage*) gtk_image_new ();
#line 38 "../lib/Widgets/AboutWindow.vala"
	g_object_ref_sink (_tmp11_);
#line 38 "../lib/Widgets/AboutWindow.vala"
	self->priv->icon_image = _tmp11_;
#line 40 "../lib/Widgets/AboutWindow.vala"
	_tmp12_ = (GtkScrolledWindow*) gtk_scrolled_window_new ();
#line 40 "../lib/Widgets/AboutWindow.vala"
	g_object_ref_sink (_tmp12_);
#line 40 "../lib/Widgets/AboutWindow.vala"
	self->priv->developers_box_scroller = _tmp12_;
#line 41 "../lib/Widgets/AboutWindow.vala"
	_tmp13_ = (GtkScrolledWindow*) gtk_scrolled_window_new ();
#line 41 "../lib/Widgets/AboutWindow.vala"
	g_object_ref_sink (_tmp13_);
#line 41 "../lib/Widgets/AboutWindow.vala"
	self->priv->translators_box_scroller = _tmp13_;
#line 43 "../lib/Widgets/AboutWindow.vala"
	_tmp14_ = he_button_new (NULL, _ ("Translate App"));
#line 43 "../lib/Widgets/AboutWindow.vala"
	g_object_ref_sink (_tmp14_);
#line 43 "../lib/Widgets/AboutWindow.vala"
	self->priv->translate_app_button = _tmp14_;
#line 44 "../lib/Widgets/AboutWindow.vala"
	_tmp15_ = he_button_new (NULL, _ ("Report a Problem"));
#line 44 "../lib/Widgets/AboutWindow.vala"
	g_object_ref_sink (_tmp15_);
#line 44 "../lib/Widgets/AboutWindow.vala"
	self->priv->report_button = _tmp15_;
#line 45 "../lib/Widgets/AboutWindow.vala"
	_tmp16_ = he_button_new (NULL, _ ("More Info…"));
#line 45 "../lib/Widgets/AboutWindow.vala"
	g_object_ref_sink (_tmp16_);
#line 45 "../lib/Widgets/AboutWindow.vala"
	self->priv->more_info_button = _tmp16_;
#line 47 "../lib/Widgets/AboutWindow.vala"
	_tmp17_ = he_modifier_badge_new ("");
#line 47 "../lib/Widgets/AboutWindow.vala"
	g_object_ref_sink (_tmp17_);
#line 47 "../lib/Widgets/AboutWindow.vala"
	self->priv->version_badge = _tmp17_;
#line 110 "../lib/Widgets/AboutWindow.vala"
	self->priv->_color = HE_COLORS_PURPLE;
#line 129 "../lib/Widgets/AboutWindow.vala"
	self->priv->_license = HE_ABOUT_WINDOW_LICENSES_GPLV3;
#line 165 "../lib/Widgets/AboutWindow.vala"
	_tmp18_ = g_new0 (gchar*, 0 + 1);
#line 165 "../lib/Widgets/AboutWindow.vala"
	self->priv->translators = _tmp18_;
#line 165 "../lib/Widgets/AboutWindow.vala"
	self->priv->translators_length1 = 0;
#line 165 "../lib/Widgets/AboutWindow.vala"
	self->priv->_translators_size_ = self->priv->translators_length1;
#line 228 "../lib/Widgets/AboutWindow.vala"
	_tmp19_ = g_new0 (gchar*, 0 + 1);
#line 228 "../lib/Widgets/AboutWindow.vala"
	self->priv->developers = _tmp19_;
#line 228 "../lib/Widgets/AboutWindow.vala"
	self->priv->developers_length1 = 0;
#line 228 "../lib/Widgets/AboutWindow.vala"
	self->priv->_developers_size_ = self->priv->developers_length1;
#line 259 "../lib/Widgets/AboutWindow.vala"
	_tmp20_ = g_strdup ("");
#line 259 "../lib/Widgets/AboutWindow.vala"
	self->priv->_app_id = _tmp20_;
#line 2351 "AboutWindow.c"
}

static void
he_about_window_finalize (GObject * obj)
{
	HeAboutWindow * self;
#line 23 "../lib/Widgets/AboutWindow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_ABOUT_WINDOW, HeAboutWindow);
#line 24 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (self->priv->window_overlay);
#line 26 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (self->priv->about_box);
#line 27 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (self->priv->content_box);
#line 28 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (self->priv->button_box);
#line 29 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (self->priv->info_box);
#line 30 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (self->priv->title_box);
#line 31 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (self->priv->text_box);
#line 32 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (self->priv->developers_box);
#line 33 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (self->priv->translators_box);
#line 35 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (self->priv->title_label);
#line 36 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (self->priv->license_label);
#line 38 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (self->priv->icon_image);
#line 40 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (self->priv->developers_box_scroller);
#line 41 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (self->priv->translators_box_scroller);
#line 43 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (self->priv->translate_app_button);
#line 44 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (self->priv->report_button);
#line 45 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (self->priv->more_info_button);
#line 47 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (self->priv->version_badge);
#line 165 "../lib/Widgets/AboutWindow.vala"
	self->priv->translators = (_vala_array_free (self->priv->translators, self->priv->translators_length1, (GDestroyNotify) g_free), NULL);
#line 228 "../lib/Widgets/AboutWindow.vala"
	self->priv->developers = (_vala_array_free (self->priv->developers, self->priv->developers_length1, (GDestroyNotify) g_free), NULL);
#line 252 "../lib/Widgets/AboutWindow.vala"
	_g_free0 (self->priv->_translate_url);
#line 253 "../lib/Widgets/AboutWindow.vala"
	_g_free0 (self->priv->_issue_url);
#line 254 "../lib/Widgets/AboutWindow.vala"
	_g_free0 (self->priv->_more_info_url);
#line 259 "../lib/Widgets/AboutWindow.vala"
	_g_free0 (self->priv->_app_id);
#line 23 "../lib/Widgets/AboutWindow.vala"
	G_OBJECT_CLASS (he_about_window_parent_class)->finalize (obj);
#line 2410 "AboutWindow.c"
}

/**
 * An AboutWindow is a window that displays information about the application.
 */
static GType
he_about_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HeAboutWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) he_about_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HeAboutWindow), 0, (GInstanceInitFunc) he_about_window_instance_init, NULL };
	GType he_about_window_type_id;
	he_about_window_type_id = g_type_register_static (HE_TYPE_WINDOW, "HeAboutWindow", &g_define_type_info, 0);
	HeAboutWindow_private_offset = g_type_add_instance_private (he_about_window_type_id, sizeof (HeAboutWindowPrivate));
	return he_about_window_type_id;
}

GType
he_about_window_get_type (void)
{
	static volatile gsize he_about_window_type_id__once = 0;
	if (g_once_init_enter (&he_about_window_type_id__once)) {
		GType he_about_window_type_id;
		he_about_window_type_id = he_about_window_get_type_once ();
		g_once_init_leave (&he_about_window_type_id__once, he_about_window_type_id);
	}
	return he_about_window_type_id__once;
}

static void
_vala_he_about_window_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec)
{
	HeAboutWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_ABOUT_WINDOW, HeAboutWindow);
#line 23 "../lib/Widgets/AboutWindow.vala"
	switch (property_id) {
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_COLOR_PROPERTY:
#line 23 "../lib/Widgets/AboutWindow.vala"
		g_value_set_enum (value, he_about_window_get_color (self));
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_LICENSE_PROPERTY:
#line 23 "../lib/Widgets/AboutWindow.vala"
		g_value_set_enum (value, he_about_window_get_license (self));
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_VERSION_PROPERTY:
#line 23 "../lib/Widgets/AboutWindow.vala"
		g_value_set_string (value, he_about_window_get_version (self));
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_APP_NAME_PROPERTY:
#line 23 "../lib/Widgets/AboutWindow.vala"
		g_value_set_string (value, he_about_window_get_app_name (self));
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_ICON_PROPERTY:
#line 23 "../lib/Widgets/AboutWindow.vala"
		g_value_set_string (value, he_about_window_get_icon (self));
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_TRANSLATOR_NAMES_PROPERTY:
#line 2480 "AboutWindow.c"
		{
			int length;
#line 23 "../lib/Widgets/AboutWindow.vala"
			g_value_set_boxed (value, he_about_window_get_translator_names (self, &length));
#line 2485 "AboutWindow.c"
		}
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_DEVELOPER_NAMES_PROPERTY:
#line 2491 "AboutWindow.c"
		{
			int length;
#line 23 "../lib/Widgets/AboutWindow.vala"
			g_value_set_boxed (value, he_about_window_get_developer_names (self, &length));
#line 2496 "AboutWindow.c"
		}
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_COPYRIGHT_YEAR_PROPERTY:
#line 23 "../lib/Widgets/AboutWindow.vala"
		g_value_set_int (value, he_about_window_get_copyright_year (self));
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_APP_ID_PROPERTY:
#line 23 "../lib/Widgets/AboutWindow.vala"
		g_value_set_string (value, he_about_window_get_app_id (self));
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_TRANSLATE_URL_PROPERTY:
#line 23 "../lib/Widgets/AboutWindow.vala"
		g_value_set_string (value, he_about_window_get_translate_url (self));
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_ISSUE_URL_PROPERTY:
#line 23 "../lib/Widgets/AboutWindow.vala"
		g_value_set_string (value, he_about_window_get_issue_url (self));
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_MORE_INFO_URL_PROPERTY:
#line 23 "../lib/Widgets/AboutWindow.vala"
		g_value_set_string (value, he_about_window_get_more_info_url (self));
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 2530 "AboutWindow.c"
		default:
#line 23 "../lib/Widgets/AboutWindow.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 2536 "AboutWindow.c"
	}
}

static void
_vala_he_about_window_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec)
{
	HeAboutWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_ABOUT_WINDOW, HeAboutWindow);
#line 23 "../lib/Widgets/AboutWindow.vala"
	switch (property_id) {
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_COLOR_PROPERTY:
#line 23 "../lib/Widgets/AboutWindow.vala"
		he_about_window_set_color (self, g_value_get_enum (value));
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_LICENSE_PROPERTY:
#line 23 "../lib/Widgets/AboutWindow.vala"
		he_about_window_set_license (self, g_value_get_enum (value));
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_VERSION_PROPERTY:
#line 23 "../lib/Widgets/AboutWindow.vala"
		he_about_window_set_version (self, g_value_get_string (value));
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_APP_NAME_PROPERTY:
#line 23 "../lib/Widgets/AboutWindow.vala"
		he_about_window_set_app_name (self, g_value_get_string (value));
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_ICON_PROPERTY:
#line 23 "../lib/Widgets/AboutWindow.vala"
		he_about_window_set_icon (self, g_value_get_string (value));
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_TRANSLATOR_NAMES_PROPERTY:
#line 2582 "AboutWindow.c"
		{
			gpointer boxed;
#line 23 "../lib/Widgets/AboutWindow.vala"
			boxed = g_value_get_boxed (value);
#line 23 "../lib/Widgets/AboutWindow.vala"
			he_about_window_set_translator_names (self, boxed, (boxed == NULL) ? 0 : g_strv_length (boxed));
#line 2589 "AboutWindow.c"
		}
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_DEVELOPER_NAMES_PROPERTY:
#line 2595 "AboutWindow.c"
		{
			gpointer boxed;
#line 23 "../lib/Widgets/AboutWindow.vala"
			boxed = g_value_get_boxed (value);
#line 23 "../lib/Widgets/AboutWindow.vala"
			he_about_window_set_developer_names (self, boxed, (boxed == NULL) ? 0 : g_strv_length (boxed));
#line 2602 "AboutWindow.c"
		}
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_COPYRIGHT_YEAR_PROPERTY:
#line 23 "../lib/Widgets/AboutWindow.vala"
		he_about_window_set_copyright_year (self, g_value_get_int (value));
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_APP_ID_PROPERTY:
#line 23 "../lib/Widgets/AboutWindow.vala"
		he_about_window_set_app_id (self, g_value_get_string (value));
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_TRANSLATE_URL_PROPERTY:
#line 23 "../lib/Widgets/AboutWindow.vala"
		he_about_window_set_translate_url (self, g_value_get_string (value));
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_ISSUE_URL_PROPERTY:
#line 23 "../lib/Widgets/AboutWindow.vala"
		he_about_window_set_issue_url (self, g_value_get_string (value));
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_MORE_INFO_URL_PROPERTY:
#line 23 "../lib/Widgets/AboutWindow.vala"
		he_about_window_set_more_info_url (self, g_value_get_string (value));
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 2636 "AboutWindow.c"
		default:
#line 23 "../lib/Widgets/AboutWindow.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 2642 "AboutWindow.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

