/* Avatar.c generated by valac 0.56.18, the Vala compiler
 * generated from Avatar.vala, do not modify */

/*
 * Copyright (c) 2024 Fyra Labs
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 */

#include "libhelium-1.h"
#include <gdk/gdk.h>
#include <gsk/gsk.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>
#include <graphene-gobject.h>
#include <pango/pango.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	HE_AVATAR_0_PROPERTY,
	HE_AVATAR_SIZE_PROPERTY,
	HE_AVATAR_TEXT_PROPERTY,
	HE_AVATAR_STATUS_PROPERTY,
	HE_AVATAR_STATUS_COLOR_PROPERTY,
	HE_AVATAR_IMAGE_PROPERTY,
	HE_AVATAR_NUM_PROPERTIES
};
static GParamSpec* he_avatar_properties[HE_AVATAR_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _gsk_render_node_unref0(var) ((var == NULL) ? NULL : (var = (gsk_render_node_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_bytes_unref0(var) ((var == NULL) ? NULL : (var = (g_bytes_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define __vala_graphene_rect_t_free0(var) ((var == NULL) ? NULL : (var = (_vala_graphene_rect_t_free (var), NULL)))
#define __vala_PangoFontDescription_free0(var) ((var == NULL) ? NULL : (var = (_vala_PangoFontDescription_free (var), NULL)))

struct _HeAvatarPrivate {
	GdkTexture* texture;
	GskRenderNode* blur_node;
	gint _size;
	gchar* _text;
	gboolean _status;
	gchar* _status_color;
	gchar* _image;
};

static gint HeAvatar_private_offset;
static gpointer he_avatar_parent_class = NULL;

static void he_avatar_update_blur_node (HeAvatar* self);
static void he_avatar_notify_cb (HeAvatar* self,
                          GParamSpec* pspec);
static gchar* he_avatar_extract_initials (HeAvatar* self,
                                   const gchar* t);
static graphene_rect_t* _vala_graphene_rect_t_copy (graphene_rect_t* self);
static void _vala_graphene_rect_t_free (graphene_rect_t* self);
static void he_avatar_real_snapshot (GtkWidget* base,
                              GtkSnapshot* snapshot);
static void _vala_PangoFontDescription_free (PangoFontDescription* self);
static GObject * he_avatar_constructor (GType type,
                                 guint n_construct_properties,
                                 GObjectConstructParam * construct_properties);
static void _he_avatar_notify_cb_g_object_notify (GObject* _sender,
                                           GParamSpec* pspec,
                                           gpointer self);
static void he_avatar_finalize (GObject * obj);
static GType he_avatar_get_type_once (void);
static void _vala_he_avatar_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec);
static void _vala_he_avatar_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
he_avatar_get_instance_private (HeAvatar* self)
{
	return G_STRUCT_MEMBER_P (self, HeAvatar_private_offset);
}

static GType
he_avatar_status_color_get_type_once (void)
{
	static const GEnumValue values[] = {{HE_AVATAR_STATUS_COLOR_RED, "HE_AVATAR_STATUS_COLOR_RED", "red"}, {HE_AVATAR_STATUS_COLOR_GREEN, "HE_AVATAR_STATUS_COLOR_GREEN", "green"}, {HE_AVATAR_STATUS_COLOR_YELLOW, "HE_AVATAR_STATUS_COLOR_YELLOW", "yellow"}, {0, NULL, NULL}};
	GType he_avatar_status_color_type_id;
	he_avatar_status_color_type_id = g_enum_register_static ("HeAvatarStatusColor", values);
	return he_avatar_status_color_type_id;
}

GType
he_avatar_status_color_get_type (void)
{
	static volatile gsize he_avatar_status_color_type_id__once = 0;
	if (g_once_init_enter (&he_avatar_status_color_type_id__once)) {
		GType he_avatar_status_color_type_id;
		he_avatar_status_color_type_id = he_avatar_status_color_get_type_once ();
		g_once_init_leave (&he_avatar_status_color_type_id__once, he_avatar_status_color_type_id);
	}
	return he_avatar_status_color_type_id__once;
}

gint
he_avatar_get_size (HeAvatar* self)
{
	gint result;
#line 35 "../lib/Widgets/Avatar.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 35 "../lib/Widgets/Avatar.vala"
	result = self->priv->_size;
#line 35 "../lib/Widgets/Avatar.vala"
	return result;
#line 144 "Avatar.c"
}

void
he_avatar_set_size (HeAvatar* self,
                    gint value)
{
#line 36 "../lib/Widgets/Avatar.vala"
	g_return_if_fail (self != NULL);
#line 37 "../lib/Widgets/Avatar.vala"
	self->priv->_size = value;
#line 38 "../lib/Widgets/Avatar.vala"
	gtk_widget_set_size_request ((GtkWidget*) self, value, value);
#line 39 "../lib/Widgets/Avatar.vala"
	he_avatar_update_blur_node (self);
#line 40 "../lib/Widgets/Avatar.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 36 "../lib/Widgets/Avatar.vala"
	g_object_notify_by_pspec ((GObject *) self, he_avatar_properties[HE_AVATAR_SIZE_PROPERTY]);
#line 163 "Avatar.c"
}

const gchar*
he_avatar_get_text (HeAvatar* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 46 "../lib/Widgets/Avatar.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 46 "../lib/Widgets/Avatar.vala"
	_tmp0_ = self->priv->_text;
#line 46 "../lib/Widgets/Avatar.vala"
	result = _tmp0_;
#line 46 "../lib/Widgets/Avatar.vala"
	return result;
#line 179 "Avatar.c"
}

void
he_avatar_set_text (HeAvatar* self,
                    const gchar* value)
{
	gchar* _tmp0_;
#line 47 "../lib/Widgets/Avatar.vala"
	g_return_if_fail (self != NULL);
#line 48 "../lib/Widgets/Avatar.vala"
	_tmp0_ = g_strdup (value);
#line 48 "../lib/Widgets/Avatar.vala"
	_g_free0 (self->priv->_text);
#line 48 "../lib/Widgets/Avatar.vala"
	self->priv->_text = _tmp0_;
#line 49 "../lib/Widgets/Avatar.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 47 "../lib/Widgets/Avatar.vala"
	g_object_notify_by_pspec ((GObject *) self, he_avatar_properties[HE_AVATAR_TEXT_PROPERTY]);
#line 199 "Avatar.c"
}

gboolean
he_avatar_get_status (HeAvatar* self)
{
	gboolean result;
#line 55 "../lib/Widgets/Avatar.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 55 "../lib/Widgets/Avatar.vala"
	result = self->priv->_status;
#line 55 "../lib/Widgets/Avatar.vala"
	return result;
#line 212 "Avatar.c"
}

void
he_avatar_set_status (HeAvatar* self,
                      gboolean value)
{
#line 56 "../lib/Widgets/Avatar.vala"
	g_return_if_fail (self != NULL);
#line 57 "../lib/Widgets/Avatar.vala"
	self->priv->_status = value;
#line 58 "../lib/Widgets/Avatar.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 56 "../lib/Widgets/Avatar.vala"
	g_object_notify_by_pspec ((GObject *) self, he_avatar_properties[HE_AVATAR_STATUS_PROPERTY]);
#line 227 "Avatar.c"
}

HeAvatarStatusColor
he_avatar_get_status_color (HeAvatar* self)
{
	HeAvatarStatusColor result;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GQuark _tmp3_ = 0U;
#line 65 "../lib/Widgets/Avatar.vala"
	static GQuark _tmp2_label0 = 0;
#line 65 "../lib/Widgets/Avatar.vala"
	static GQuark _tmp2_label1 = 0;
#line 64 "../lib/Widgets/Avatar.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 65 "../lib/Widgets/Avatar.vala"
	_tmp0_ = self->priv->_status_color;
#line 65 "../lib/Widgets/Avatar.vala"
	_tmp1_ = _tmp0_;
#line 65 "../lib/Widgets/Avatar.vala"
	_tmp3_ = (NULL == _tmp1_) ? 0 : g_quark_from_string (_tmp1_);
#line 65 "../lib/Widgets/Avatar.vala"
	if (_tmp3_ == ((0 != _tmp2_label0) ? _tmp2_label0 : (_tmp2_label0 = g_quark_from_static_string ("red")))) {
#line 65 "../lib/Widgets/Avatar.vala"
		switch (0) {
#line 253 "Avatar.c"
			default:
			{
#line 67 "../lib/Widgets/Avatar.vala"
				result = HE_AVATAR_STATUS_COLOR_RED;
#line 67 "../lib/Widgets/Avatar.vala"
				return result;
#line 260 "Avatar.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label1) ? _tmp2_label1 : (_tmp2_label1 = g_quark_from_static_string ("yellow")))) {
#line 65 "../lib/Widgets/Avatar.vala"
		switch (0) {
#line 266 "Avatar.c"
			default:
			{
#line 69 "../lib/Widgets/Avatar.vala"
				result = HE_AVATAR_STATUS_COLOR_YELLOW;
#line 69 "../lib/Widgets/Avatar.vala"
				return result;
#line 273 "Avatar.c"
			}
		}
	} else {
#line 65 "../lib/Widgets/Avatar.vala"
		switch (0) {
#line 279 "Avatar.c"
			default:
			{
#line 71 "../lib/Widgets/Avatar.vala"
				result = HE_AVATAR_STATUS_COLOR_GREEN;
#line 71 "../lib/Widgets/Avatar.vala"
				return result;
#line 286 "Avatar.c"
			}
		}
	}
}

void
he_avatar_set_status_color (HeAvatar* self,
                            HeAvatarStatusColor value)
{
#line 74 "../lib/Widgets/Avatar.vala"
	g_return_if_fail (self != NULL);
#line 75 "../lib/Widgets/Avatar.vala"
	switch (value) {
#line 75 "../lib/Widgets/Avatar.vala"
		case HE_AVATAR_STATUS_COLOR_RED:
#line 302 "Avatar.c"
		{
			gchar* _tmp0_;
#line 77 "../lib/Widgets/Avatar.vala"
			_tmp0_ = g_strdup ("red");
#line 77 "../lib/Widgets/Avatar.vala"
			_g_free0 (self->priv->_status_color);
#line 77 "../lib/Widgets/Avatar.vala"
			self->priv->_status_color = _tmp0_;
#line 78 "../lib/Widgets/Avatar.vala"
			break;
#line 313 "Avatar.c"
		}
#line 75 "../lib/Widgets/Avatar.vala"
		case HE_AVATAR_STATUS_COLOR_YELLOW:
#line 317 "Avatar.c"
		{
			gchar* _tmp1_;
#line 80 "../lib/Widgets/Avatar.vala"
			_tmp1_ = g_strdup ("yellow");
#line 80 "../lib/Widgets/Avatar.vala"
			_g_free0 (self->priv->_status_color);
#line 80 "../lib/Widgets/Avatar.vala"
			self->priv->_status_color = _tmp1_;
#line 81 "../lib/Widgets/Avatar.vala"
			break;
#line 328 "Avatar.c"
		}
		default:
		{
			gchar* _tmp2_;
#line 83 "../lib/Widgets/Avatar.vala"
			_tmp2_ = g_strdup ("green");
#line 83 "../lib/Widgets/Avatar.vala"
			_g_free0 (self->priv->_status_color);
#line 83 "../lib/Widgets/Avatar.vala"
			self->priv->_status_color = _tmp2_;
#line 84 "../lib/Widgets/Avatar.vala"
			break;
#line 341 "Avatar.c"
		}
	}
#line 86 "../lib/Widgets/Avatar.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 74 "../lib/Widgets/Avatar.vala"
	g_object_notify_by_pspec ((GObject *) self, he_avatar_properties[HE_AVATAR_STATUS_COLOR_PROPERTY]);
#line 348 "Avatar.c"
}

const gchar*
he_avatar_get_image (HeAvatar* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 92 "../lib/Widgets/Avatar.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 92 "../lib/Widgets/Avatar.vala"
	_tmp0_ = self->priv->_image;
#line 92 "../lib/Widgets/Avatar.vala"
	result = _tmp0_;
#line 92 "../lib/Widgets/Avatar.vala"
	return result;
#line 364 "Avatar.c"
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1501 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1501 "glib-2.0.vapi"
	end = _tmp0_;
#line 1502 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1502 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1503 "glib-2.0.vapi"
		result = maxlen;
#line 1503 "glib-2.0.vapi"
		return result;
#line 387 "Avatar.c"
	} else {
		gchar* _tmp2_;
#line 1505 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1505 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1505 "glib-2.0.vapi"
		return result;
#line 396 "Avatar.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1512 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1514 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 415 "Avatar.c"
	} else {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 419 "Avatar.c"
	}
#line 1514 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1516 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 425 "Avatar.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1518 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1518 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1518 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 435 "Avatar.c"
	}
#line 1521 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1522 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1523 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 443 "Avatar.c"
	} else {
#line 1525 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 447 "Avatar.c"
	}
#line 1527 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1528 "glib-2.0.vapi"
		len = string_length - offset;
#line 453 "Avatar.c"
	}
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1531 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1531 "glib-2.0.vapi"
	result = _tmp3_;
#line 1531 "glib-2.0.vapi"
	return result;
#line 463 "Avatar.c"
}

void
he_avatar_set_image (HeAvatar* self,
                     const gchar* value)
{
	gchar* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 93 "../lib/Widgets/Avatar.vala"
	g_return_if_fail (self != NULL);
#line 94 "../lib/Widgets/Avatar.vala"
	_tmp0_ = g_strdup (value);
#line 94 "../lib/Widgets/Avatar.vala"
	_g_free0 (self->priv->_image);
#line 94 "../lib/Widgets/Avatar.vala"
	self->priv->_image = _tmp0_;
#line 95 "../lib/Widgets/Avatar.vala"
	if (value != NULL) {
#line 482 "Avatar.c"
		{
#line 97 "../lib/Widgets/Avatar.vala"
			if (g_str_has_prefix (value, "resource://")) {
#line 486 "Avatar.c"
				gchar* resource_path = NULL;
				gchar* _tmp1_;
				GBytes* bytes = NULL;
				const gchar* _tmp2_;
				GBytes* _tmp3_;
				GdkTexture* _tmp4_ = NULL;
				GBytes* _tmp5_;
				GdkTexture* _tmp6_;
				GdkTexture* _tmp7_;
#line 98 "../lib/Widgets/Avatar.vala"
				_tmp1_ = string_substring (value, (glong) 11, (glong) -1);
#line 98 "../lib/Widgets/Avatar.vala"
				resource_path = _tmp1_;
#line 99 "../lib/Widgets/Avatar.vala"
				_tmp2_ = resource_path;
#line 99 "../lib/Widgets/Avatar.vala"
				_tmp3_ = g_resources_lookup_data (_tmp2_, G_RESOURCE_LOOKUP_FLAGS_NONE, &_inner_error0_);
#line 99 "../lib/Widgets/Avatar.vala"
				bytes = _tmp3_;
#line 99 "../lib/Widgets/Avatar.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 99 "../lib/Widgets/Avatar.vala"
					_g_free0 (resource_path);
#line 510 "Avatar.c"
					goto __catch0_g_error;
				}
#line 100 "../lib/Widgets/Avatar.vala"
				_tmp5_ = bytes;
#line 100 "../lib/Widgets/Avatar.vala"
				_tmp6_ = gdk_texture_new_from_bytes (_tmp5_, &_inner_error0_);
#line 100 "../lib/Widgets/Avatar.vala"
				_tmp4_ = _tmp6_;
#line 100 "../lib/Widgets/Avatar.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 100 "../lib/Widgets/Avatar.vala"
					_g_bytes_unref0 (bytes);
#line 100 "../lib/Widgets/Avatar.vala"
					_g_free0 (resource_path);
#line 525 "Avatar.c"
					goto __catch0_g_error;
				}
#line 100 "../lib/Widgets/Avatar.vala"
				_tmp7_ = _tmp4_;
#line 100 "../lib/Widgets/Avatar.vala"
				_tmp4_ = NULL;
#line 100 "../lib/Widgets/Avatar.vala"
				_g_object_unref0 (self->priv->texture);
#line 100 "../lib/Widgets/Avatar.vala"
				self->priv->texture = _tmp7_;
#line 97 "../lib/Widgets/Avatar.vala"
				_g_object_unref0 (_tmp4_);
#line 97 "../lib/Widgets/Avatar.vala"
				_g_bytes_unref0 (bytes);
#line 97 "../lib/Widgets/Avatar.vala"
				_g_free0 (resource_path);
#line 542 "Avatar.c"
			} else {
#line 101 "../lib/Widgets/Avatar.vala"
				if (g_str_has_prefix (value, "file://")) {
#line 546 "Avatar.c"
					GFile* file = NULL;
					GFile* _tmp8_;
					GdkTexture* _tmp9_ = NULL;
					GFile* _tmp10_;
					GdkTexture* _tmp11_;
					GdkTexture* _tmp12_;
#line 102 "../lib/Widgets/Avatar.vala"
					_tmp8_ = g_file_new_for_uri (value);
#line 102 "../lib/Widgets/Avatar.vala"
					file = _tmp8_;
#line 103 "../lib/Widgets/Avatar.vala"
					_tmp10_ = file;
#line 103 "../lib/Widgets/Avatar.vala"
					_tmp11_ = gdk_texture_new_from_file (_tmp10_, &_inner_error0_);
#line 103 "../lib/Widgets/Avatar.vala"
					_tmp9_ = _tmp11_;
#line 103 "../lib/Widgets/Avatar.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 103 "../lib/Widgets/Avatar.vala"
						_g_object_unref0 (file);
#line 567 "Avatar.c"
						goto __catch0_g_error;
					}
#line 103 "../lib/Widgets/Avatar.vala"
					_tmp12_ = _tmp9_;
#line 103 "../lib/Widgets/Avatar.vala"
					_tmp9_ = NULL;
#line 103 "../lib/Widgets/Avatar.vala"
					_g_object_unref0 (self->priv->texture);
#line 103 "../lib/Widgets/Avatar.vala"
					self->priv->texture = _tmp12_;
#line 101 "../lib/Widgets/Avatar.vala"
					_g_object_unref0 (_tmp9_);
#line 101 "../lib/Widgets/Avatar.vala"
					_g_object_unref0 (file);
#line 582 "Avatar.c"
				} else {
					GFile* file = NULL;
					GFile* _tmp13_;
					GdkTexture* _tmp14_ = NULL;
					GFile* _tmp15_;
					GdkTexture* _tmp16_;
					GdkTexture* _tmp17_;
#line 105 "../lib/Widgets/Avatar.vala"
					_tmp13_ = g_file_new_for_path (value);
#line 105 "../lib/Widgets/Avatar.vala"
					file = _tmp13_;
#line 106 "../lib/Widgets/Avatar.vala"
					_tmp15_ = file;
#line 106 "../lib/Widgets/Avatar.vala"
					_tmp16_ = gdk_texture_new_from_file (_tmp15_, &_inner_error0_);
#line 106 "../lib/Widgets/Avatar.vala"
					_tmp14_ = _tmp16_;
#line 106 "../lib/Widgets/Avatar.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 106 "../lib/Widgets/Avatar.vala"
						_g_object_unref0 (file);
#line 604 "Avatar.c"
						goto __catch0_g_error;
					}
#line 106 "../lib/Widgets/Avatar.vala"
					_tmp17_ = _tmp14_;
#line 106 "../lib/Widgets/Avatar.vala"
					_tmp14_ = NULL;
#line 106 "../lib/Widgets/Avatar.vala"
					_g_object_unref0 (self->priv->texture);
#line 106 "../lib/Widgets/Avatar.vala"
					self->priv->texture = _tmp17_;
#line 101 "../lib/Widgets/Avatar.vala"
					_g_object_unref0 (_tmp14_);
#line 101 "../lib/Widgets/Avatar.vala"
					_g_object_unref0 (file);
#line 619 "Avatar.c"
				}
			}
#line 108 "../lib/Widgets/Avatar.vala"
			he_avatar_update_blur_node (self);
#line 624 "Avatar.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp18_;
			const gchar* _tmp19_;
#line 96 "../lib/Widgets/Avatar.vala"
			e = _inner_error0_;
#line 96 "../lib/Widgets/Avatar.vala"
			_inner_error0_ = NULL;
#line 110 "../lib/Widgets/Avatar.vala"
			_tmp18_ = e;
#line 110 "../lib/Widgets/Avatar.vala"
			_tmp19_ = _tmp18_->message;
#line 110 "../lib/Widgets/Avatar.vala"
			g_warning ("Avatar.vala:110: Failed to load image: %s", _tmp19_);
#line 111 "../lib/Widgets/Avatar.vala"
			_g_object_unref0 (self->priv->texture);
#line 111 "../lib/Widgets/Avatar.vala"
			self->priv->texture = NULL;
#line 112 "../lib/Widgets/Avatar.vala"
			_gsk_render_node_unref0 (self->priv->blur_node);
#line 112 "../lib/Widgets/Avatar.vala"
			self->priv->blur_node = NULL;
#line 96 "../lib/Widgets/Avatar.vala"
			_g_error_free0 (e);
#line 652 "Avatar.c"
		}
		__finally0:
#line 96 "../lib/Widgets/Avatar.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 96 "../lib/Widgets/Avatar.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 96 "../lib/Widgets/Avatar.vala"
			g_clear_error (&_inner_error0_);
#line 96 "../lib/Widgets/Avatar.vala"
			return;
#line 663 "Avatar.c"
		}
	} else {
#line 115 "../lib/Widgets/Avatar.vala"
		_g_object_unref0 (self->priv->texture);
#line 115 "../lib/Widgets/Avatar.vala"
		self->priv->texture = NULL;
#line 116 "../lib/Widgets/Avatar.vala"
		_gsk_render_node_unref0 (self->priv->blur_node);
#line 116 "../lib/Widgets/Avatar.vala"
		self->priv->blur_node = NULL;
#line 674 "Avatar.c"
	}
#line 118 "../lib/Widgets/Avatar.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 93 "../lib/Widgets/Avatar.vala"
	g_object_notify_by_pspec ((GObject *) self, he_avatar_properties[HE_AVATAR_IMAGE_PROPERTY]);
#line 680 "Avatar.c"
}

HeAvatar*
he_avatar_construct (GType object_type,
                     gint size,
                     const gchar* image,
                     const gchar* text,
                     gboolean status,
                     HeAvatarStatusColor* status_color)
{
	HeAvatar * self = NULL;
#line 123 "../lib/Widgets/Avatar.vala"
	self = (HeAvatar*) g_object_new (object_type, "size", size, "image", image, "text", text, "status", status, "status-color", status_color, NULL);
#line 122 "../lib/Widgets/Avatar.vala"
	return self;
#line 696 "Avatar.c"
}

HeAvatar*
he_avatar_new (gint size,
               const gchar* image,
               const gchar* text,
               gboolean status,
               HeAvatarStatusColor* status_color)
{
#line 122 "../lib/Widgets/Avatar.vala"
	return he_avatar_construct (HE_TYPE_AVATAR, size, image, text, status, status_color);
#line 708 "Avatar.c"
}

static void
he_avatar_notify_cb (HeAvatar* self,
                     GParamSpec* pspec)
{
#line 141 "../lib/Widgets/Avatar.vala"
	g_return_if_fail (self != NULL);
#line 141 "../lib/Widgets/Avatar.vala"
	g_return_if_fail (pspec != NULL);
#line 142 "../lib/Widgets/Avatar.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 721 "Avatar.c"
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result;
#line 1283 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1284 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1284 "glib-2.0.vapi"
	result = _tmp0_;
#line 1284 "glib-2.0.vapi"
	return result;
#line 738 "Avatar.c"
}

static gchar*
he_avatar_extract_initials (HeAvatar* self,
                            const gchar* t)
{
	gchar* ret = NULL;
	gchar* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* result;
#line 145 "../lib/Widgets/Avatar.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 145 "../lib/Widgets/Avatar.vala"
	g_return_val_if_fail (t != NULL, NULL);
#line 146 "../lib/Widgets/Avatar.vala"
	_tmp0_ = g_strdup ("");
#line 146 "../lib/Widgets/Avatar.vala"
	ret = _tmp0_;
#line 147 "../lib/Widgets/Avatar.vala"
	_tmp1_ = strlen (t);
#line 147 "../lib/Widgets/Avatar.vala"
	_tmp2_ = _tmp1_;
#line 147 "../lib/Widgets/Avatar.vala"
	if (_tmp2_ == 0) {
#line 770 "Avatar.c"
		gchar* _tmp3_;
#line 147 "../lib/Widgets/Avatar.vala"
		_tmp3_ = g_strdup ("");
#line 147 "../lib/Widgets/Avatar.vala"
		result = _tmp3_;
#line 147 "../lib/Widgets/Avatar.vala"
		_g_free0 (ret);
#line 147 "../lib/Widgets/Avatar.vala"
		return result;
#line 780 "Avatar.c"
	}
#line 148 "../lib/Widgets/Avatar.vala"
	_tmp4_ = ret;
#line 148 "../lib/Widgets/Avatar.vala"
	_tmp5_ = g_strdup_printf ("%c", string_get (t, (glong) 0));
#line 148 "../lib/Widgets/Avatar.vala"
	_tmp6_ = _tmp5_;
#line 148 "../lib/Widgets/Avatar.vala"
	_tmp7_ = g_utf8_strup (_tmp6_, (gssize) -1);
#line 148 "../lib/Widgets/Avatar.vala"
	_tmp8_ = _tmp7_;
#line 148 "../lib/Widgets/Avatar.vala"
	_tmp9_ = g_strconcat (_tmp4_, _tmp8_, NULL);
#line 148 "../lib/Widgets/Avatar.vala"
	_g_free0 (ret);
#line 148 "../lib/Widgets/Avatar.vala"
	ret = _tmp9_;
#line 148 "../lib/Widgets/Avatar.vala"
	_g_free0 (_tmp8_);
#line 148 "../lib/Widgets/Avatar.vala"
	_g_free0 (_tmp6_);
#line 802 "Avatar.c"
	{
		gint i = 0;
#line 149 "../lib/Widgets/Avatar.vala"
		i = 1;
#line 807 "Avatar.c"
		{
			gboolean _tmp10_ = FALSE;
#line 149 "../lib/Widgets/Avatar.vala"
			_tmp10_ = TRUE;
#line 149 "../lib/Widgets/Avatar.vala"
			while (TRUE) {
#line 814 "Avatar.c"
				gint _tmp12_;
				gint _tmp13_;
#line 149 "../lib/Widgets/Avatar.vala"
				if (!_tmp10_) {
#line 819 "Avatar.c"
					gint _tmp11_;
#line 149 "../lib/Widgets/Avatar.vala"
					_tmp11_ = i;
#line 149 "../lib/Widgets/Avatar.vala"
					i = _tmp11_ + 1;
#line 825 "Avatar.c"
				}
#line 149 "../lib/Widgets/Avatar.vala"
				_tmp10_ = FALSE;
#line 149 "../lib/Widgets/Avatar.vala"
				_tmp12_ = strlen (t);
#line 149 "../lib/Widgets/Avatar.vala"
				_tmp13_ = _tmp12_;
#line 149 "../lib/Widgets/Avatar.vala"
				if (!(i < (_tmp13_ - 1))) {
#line 149 "../lib/Widgets/Avatar.vala"
					break;
#line 837 "Avatar.c"
				}
#line 150 "../lib/Widgets/Avatar.vala"
				if (string_get (t, (glong) i) == ' ') {
#line 841 "Avatar.c"
					const gchar* _tmp14_;
					gchar* _tmp15_;
					gchar* _tmp16_;
					gchar* _tmp17_;
					gchar* _tmp18_;
					gchar* _tmp19_;
#line 151 "../lib/Widgets/Avatar.vala"
					_tmp14_ = ret;
#line 151 "../lib/Widgets/Avatar.vala"
					_tmp15_ = g_strdup_printf ("%c", string_get (t, (glong) (i + 1)));
#line 151 "../lib/Widgets/Avatar.vala"
					_tmp16_ = _tmp15_;
#line 151 "../lib/Widgets/Avatar.vala"
					_tmp17_ = g_utf8_strup (_tmp16_, (gssize) -1);
#line 151 "../lib/Widgets/Avatar.vala"
					_tmp18_ = _tmp17_;
#line 151 "../lib/Widgets/Avatar.vala"
					_tmp19_ = g_strconcat (_tmp14_, _tmp18_, NULL);
#line 151 "../lib/Widgets/Avatar.vala"
					_g_free0 (ret);
#line 151 "../lib/Widgets/Avatar.vala"
					ret = _tmp19_;
#line 151 "../lib/Widgets/Avatar.vala"
					_g_free0 (_tmp18_);
#line 151 "../lib/Widgets/Avatar.vala"
					_g_free0 (_tmp16_);
#line 868 "Avatar.c"
				}
			}
		}
	}
#line 152 "../lib/Widgets/Avatar.vala"
	result = ret;
#line 152 "../lib/Widgets/Avatar.vala"
	return result;
#line 877 "Avatar.c"
}

static graphene_rect_t*
_vala_graphene_rect_t_copy (graphene_rect_t* self)
{
#line 163 "../lib/Widgets/Avatar.vala"
	return g_boxed_copy (graphene_rect_get_type (), self);
#line 885 "Avatar.c"
}

static gpointer
__vala_graphene_rect_t_copy0 (gpointer self)
{
#line 163 "../lib/Widgets/Avatar.vala"
	return self ? _vala_graphene_rect_t_copy (self) : NULL;
#line 893 "Avatar.c"
}

static gpointer
_gsk_render_node_ref0 (gpointer self)
{
#line 168 "../lib/Widgets/Avatar.vala"
	return self ? gsk_render_node_ref (self) : NULL;
#line 901 "Avatar.c"
}

static void
_vala_graphene_rect_t_free (graphene_rect_t* self)
{
#line 155 "../lib/Widgets/Avatar.vala"
	g_boxed_free (graphene_rect_get_type (), self);
#line 909 "Avatar.c"
}

static void
he_avatar_update_blur_node (HeAvatar* self)
{
	GdkTexture* _tmp0_;
	gfloat expanded_size = 0.0F;
	graphene_rect_t* rect = NULL;
	graphene_rect_t _tmp1_ = {0};
	graphene_rect_t* _tmp2_;
	GskTextureNode* texture_node = NULL;
	GdkTexture* _tmp3_;
	graphene_rect_t* _tmp4_;
	graphene_rect_t _tmp5_;
	GskTextureNode* _tmp6_;
	gint _tmp7_ = 0;
	GskBlurNode* blur_effect = NULL;
	GskTextureNode* _tmp8_;
	GskBlurNode* _tmp9_;
	GskBlurNode* _tmp10_;
	GskRenderNode* _tmp11_;
#line 155 "../lib/Widgets/Avatar.vala"
	g_return_if_fail (self != NULL);
#line 156 "../lib/Widgets/Avatar.vala"
	_tmp0_ = self->priv->texture;
#line 156 "../lib/Widgets/Avatar.vala"
	if (_tmp0_ == NULL) {
#line 157 "../lib/Widgets/Avatar.vala"
		_gsk_render_node_unref0 (self->priv->blur_node);
#line 157 "../lib/Widgets/Avatar.vala"
		self->priv->blur_node = NULL;
#line 158 "../lib/Widgets/Avatar.vala"
		return;
#line 943 "Avatar.c"
	}
#line 162 "../lib/Widgets/Avatar.vala"
	expanded_size = self->priv->_size * 1.2f;
#line 163 "../lib/Widgets/Avatar.vala"
	memset (&_tmp1_, 0, sizeof (graphene_rect_t));
#line 163 "../lib/Widgets/Avatar.vala"
	_tmp2_ = __vala_graphene_rect_t_copy0 (graphene_rect_init (&_tmp1_, -(self->priv->_size * 0.1f), -(self->priv->_size * 0.1f), expanded_size, expanded_size));
#line 163 "../lib/Widgets/Avatar.vala"
	rect = _tmp2_;
#line 165 "../lib/Widgets/Avatar.vala"
	_tmp3_ = self->priv->texture;
#line 165 "../lib/Widgets/Avatar.vala"
	_tmp4_ = rect;
#line 165 "../lib/Widgets/Avatar.vala"
	_tmp5_ = *_tmp4_;
#line 165 "../lib/Widgets/Avatar.vala"
	_tmp6_ = (GskTextureNode*) gsk_texture_node_new (_tmp3_, &_tmp5_);
#line 165 "../lib/Widgets/Avatar.vala"
	texture_node = _tmp6_;
#line 166 "../lib/Widgets/Avatar.vala"
	if (self->priv->_size <= 32) {
#line 166 "../lib/Widgets/Avatar.vala"
		_tmp7_ = 0;
#line 967 "Avatar.c"
	} else {
#line 166 "../lib/Widgets/Avatar.vala"
		_tmp7_ = 20;
#line 971 "Avatar.c"
	}
#line 166 "../lib/Widgets/Avatar.vala"
	_tmp8_ = texture_node;
#line 166 "../lib/Widgets/Avatar.vala"
	_tmp9_ = (GskBlurNode*) gsk_blur_node_new ((GskRenderNode*) _tmp8_, (gfloat) _tmp7_);
#line 166 "../lib/Widgets/Avatar.vala"
	blur_effect = _tmp9_;
#line 168 "../lib/Widgets/Avatar.vala"
	_tmp10_ = blur_effect;
#line 168 "../lib/Widgets/Avatar.vala"
	_tmp11_ = _gsk_render_node_ref0 ((GskRenderNode*) _tmp10_);
#line 168 "../lib/Widgets/Avatar.vala"
	_gsk_render_node_unref0 (self->priv->blur_node);
#line 168 "../lib/Widgets/Avatar.vala"
	self->priv->blur_node = _tmp11_;
#line 155 "../lib/Widgets/Avatar.vala"
	_gsk_render_node_unref0 (blur_effect);
#line 155 "../lib/Widgets/Avatar.vala"
	_gsk_render_node_unref0 (texture_node);
#line 155 "../lib/Widgets/Avatar.vala"
	__vala_graphene_rect_t_free0 (rect);
#line 993 "Avatar.c"
}

static void
_vala_PangoFontDescription_free (PangoFontDescription* self)
{
#line 226 "../lib/Widgets/Avatar.vala"
	g_boxed_free (pango_font_description_get_type (), self);
#line 1001 "Avatar.c"
}

static void
he_avatar_real_snapshot (GtkWidget* base,
                         GtkSnapshot* snapshot)
{
	HeAvatar * self;
	gint width = 0;
	gint height = 0;
	graphene_rect_t* rect = NULL;
	graphene_rect_t _tmp0_ = {0};
	graphene_rect_t* _tmp1_;
	graphene_rect_t* blur_rect = NULL;
	graphene_rect_t _tmp2_ = {0};
	graphene_rect_t* _tmp3_;
	gboolean _tmp4_ = FALSE;
	GskRenderNode* _tmp5_;
	GdkTexture* _tmp27_;
	GdkRGBA border_color = {0};
	GdkRGBA _tmp55_ = {0};
	gint border_width = 0;
	GskRoundedRect rounded_rect = {0};
	graphene_rect_t* _tmp56_;
	graphene_size_t _tmp57_ = {0};
	graphene_size_t _tmp58_ = {0};
	graphene_size_t _tmp59_ = {0};
	graphene_size_t _tmp60_ = {0};
	graphene_size_t _tmp61_[4] = {0};
	GskRoundedRect _tmp62_ = {0};
	GskRoundedRect _tmp63_;
	gfloat _tmp64_[4] = {0};
	GdkRGBA _tmp65_;
	GdkRGBA _tmp66_;
	GdkRGBA _tmp67_;
	GdkRGBA _tmp68_;
	GdkRGBA _tmp69_[4] = {0};
#line 171 "../lib/Widgets/Avatar.vala"
	self = (HeAvatar*) base;
#line 171 "../lib/Widgets/Avatar.vala"
	g_return_if_fail (snapshot != NULL);
#line 172 "../lib/Widgets/Avatar.vala"
	width = gtk_widget_get_width ((GtkWidget*) self);
#line 173 "../lib/Widgets/Avatar.vala"
	height = gtk_widget_get_height ((GtkWidget*) self);
#line 175 "../lib/Widgets/Avatar.vala"
	memset (&_tmp0_, 0, sizeof (graphene_rect_t));
#line 175 "../lib/Widgets/Avatar.vala"
	_tmp1_ = __vala_graphene_rect_t_copy0 (graphene_rect_init (&_tmp0_, (gfloat) 0, (gfloat) 0, (gfloat) width, (gfloat) height));
#line 175 "../lib/Widgets/Avatar.vala"
	rect = _tmp1_;
#line 176 "../lib/Widgets/Avatar.vala"
	memset (&_tmp2_, 0, sizeof (graphene_rect_t));
#line 176 "../lib/Widgets/Avatar.vala"
	_tmp3_ = __vala_graphene_rect_t_copy0 (graphene_rect_init (&_tmp2_, (gfloat) -3, (gfloat) -3, (gfloat) (width + 6), (gfloat) (height + 6)));
#line 176 "../lib/Widgets/Avatar.vala"
	blur_rect = _tmp3_;
#line 179 "../lib/Widgets/Avatar.vala"
	_tmp5_ = self->priv->blur_node;
#line 179 "../lib/Widgets/Avatar.vala"
	if (_tmp5_ != NULL) {
#line 179 "../lib/Widgets/Avatar.vala"
		_tmp4_ = self->priv->_size > 32;
#line 1064 "Avatar.c"
	} else {
#line 179 "../lib/Widgets/Avatar.vala"
		_tmp4_ = FALSE;
#line 1068 "Avatar.c"
	}
#line 179 "../lib/Widgets/Avatar.vala"
	if (_tmp4_) {
#line 1072 "Avatar.c"
		GskRoundedRect rounded_rect = {0};
		graphene_rect_t* _tmp6_;
		graphene_size_t _tmp7_ = {0};
		graphene_size_t _tmp8_ = {0};
		graphene_size_t _tmp9_ = {0};
		graphene_size_t _tmp10_ = {0};
		graphene_size_t _tmp11_[4] = {0};
		GskRoundedRect _tmp12_ = {0};
		GskRoundedRect _tmp13_;
		GskRenderNode* _tmp14_;
#line 181 "../lib/Widgets/Avatar.vala"
		_tmp6_ = blur_rect;
#line 181 "../lib/Widgets/Avatar.vala"
		memset (&_tmp7_, 0, sizeof (graphene_size_t));
#line 181 "../lib/Widgets/Avatar.vala"
		_tmp7_.width = (gfloat) (width / 2);
#line 181 "../lib/Widgets/Avatar.vala"
		_tmp7_.height = (gfloat) (height / 2);
#line 181 "../lib/Widgets/Avatar.vala"
		memset (&_tmp8_, 0, sizeof (graphene_size_t));
#line 181 "../lib/Widgets/Avatar.vala"
		_tmp8_.width = (gfloat) (width / 2);
#line 181 "../lib/Widgets/Avatar.vala"
		_tmp8_.height = (gfloat) (height / 2);
#line 181 "../lib/Widgets/Avatar.vala"
		memset (&_tmp9_, 0, sizeof (graphene_size_t));
#line 181 "../lib/Widgets/Avatar.vala"
		_tmp9_.width = (gfloat) (width / 2);
#line 181 "../lib/Widgets/Avatar.vala"
		_tmp9_.height = (gfloat) (height / 2);
#line 181 "../lib/Widgets/Avatar.vala"
		memset (&_tmp10_, 0, sizeof (graphene_size_t));
#line 181 "../lib/Widgets/Avatar.vala"
		_tmp10_.width = (gfloat) (width / 2);
#line 181 "../lib/Widgets/Avatar.vala"
		_tmp10_.height = (gfloat) (height / 2);
#line 181 "../lib/Widgets/Avatar.vala"
		_tmp11_[0] = _tmp7_;
#line 181 "../lib/Widgets/Avatar.vala"
		_tmp11_[1] = _tmp8_;
#line 181 "../lib/Widgets/Avatar.vala"
		_tmp11_[2] = _tmp9_;
#line 181 "../lib/Widgets/Avatar.vala"
		_tmp11_[3] = _tmp10_;
#line 181 "../lib/Widgets/Avatar.vala"
		memset (&_tmp12_, 0, sizeof (GskRoundedRect));
#line 181 "../lib/Widgets/Avatar.vala"
		_tmp12_.bounds = *_tmp6_;
#line 181 "../lib/Widgets/Avatar.vala"
		memcpy (_tmp12_.corner, _tmp11_, 4 * sizeof (graphene_size_t));
#line 181 "../lib/Widgets/Avatar.vala"
		rounded_rect = _tmp12_;
#line 190 "../lib/Widgets/Avatar.vala"
		_tmp13_ = rounded_rect;
#line 190 "../lib/Widgets/Avatar.vala"
		gtk_snapshot_push_rounded_clip (snapshot, &_tmp13_);
#line 191 "../lib/Widgets/Avatar.vala"
		gtk_snapshot_push_opacity (snapshot, 0.25);
#line 192 "../lib/Widgets/Avatar.vala"
		_tmp14_ = self->priv->blur_node;
#line 192 "../lib/Widgets/Avatar.vala"
		gtk_snapshot_append_node (snapshot, _tmp14_);
#line 193 "../lib/Widgets/Avatar.vala"
		gtk_snapshot_pop (snapshot);
#line 194 "../lib/Widgets/Avatar.vala"
		gtk_snapshot_pop (snapshot);
#line 1139 "Avatar.c"
	} else {
		GskRoundedRect rounded_rect = {0};
		graphene_rect_t* _tmp15_;
		graphene_size_t _tmp16_ = {0};
		graphene_size_t _tmp17_ = {0};
		graphene_size_t _tmp18_ = {0};
		graphene_size_t _tmp19_ = {0};
		graphene_size_t _tmp20_[4] = {0};
		GskRoundedRect _tmp21_ = {0};
		GskRoundedRect _tmp22_;
		GdkRGBA color = {0};
		GdkRGBA _tmp23_ = {0};
		GdkRGBA _tmp24_;
		graphene_rect_t* _tmp25_;
		graphene_rect_t _tmp26_;
#line 197 "../lib/Widgets/Avatar.vala"
		_tmp15_ = rect;
#line 197 "../lib/Widgets/Avatar.vala"
		memset (&_tmp16_, 0, sizeof (graphene_size_t));
#line 197 "../lib/Widgets/Avatar.vala"
		_tmp16_.width = (gfloat) (width / 2);
#line 197 "../lib/Widgets/Avatar.vala"
		_tmp16_.height = (gfloat) (height / 2);
#line 197 "../lib/Widgets/Avatar.vala"
		memset (&_tmp17_, 0, sizeof (graphene_size_t));
#line 197 "../lib/Widgets/Avatar.vala"
		_tmp17_.width = (gfloat) (width / 2);
#line 197 "../lib/Widgets/Avatar.vala"
		_tmp17_.height = (gfloat) (height / 2);
#line 197 "../lib/Widgets/Avatar.vala"
		memset (&_tmp18_, 0, sizeof (graphene_size_t));
#line 197 "../lib/Widgets/Avatar.vala"
		_tmp18_.width = (gfloat) (width / 2);
#line 197 "../lib/Widgets/Avatar.vala"
		_tmp18_.height = (gfloat) (height / 2);
#line 197 "../lib/Widgets/Avatar.vala"
		memset (&_tmp19_, 0, sizeof (graphene_size_t));
#line 197 "../lib/Widgets/Avatar.vala"
		_tmp19_.width = (gfloat) (width / 2);
#line 197 "../lib/Widgets/Avatar.vala"
		_tmp19_.height = (gfloat) (height / 2);
#line 197 "../lib/Widgets/Avatar.vala"
		_tmp20_[0] = _tmp16_;
#line 197 "../lib/Widgets/Avatar.vala"
		_tmp20_[1] = _tmp17_;
#line 197 "../lib/Widgets/Avatar.vala"
		_tmp20_[2] = _tmp18_;
#line 197 "../lib/Widgets/Avatar.vala"
		_tmp20_[3] = _tmp19_;
#line 197 "../lib/Widgets/Avatar.vala"
		memset (&_tmp21_, 0, sizeof (GskRoundedRect));
#line 197 "../lib/Widgets/Avatar.vala"
		_tmp21_.bounds = *_tmp15_;
#line 197 "../lib/Widgets/Avatar.vala"
		memcpy (_tmp21_.corner, _tmp20_, 4 * sizeof (graphene_size_t));
#line 197 "../lib/Widgets/Avatar.vala"
		rounded_rect = _tmp21_;
#line 206 "../lib/Widgets/Avatar.vala"
		_tmp22_ = rounded_rect;
#line 206 "../lib/Widgets/Avatar.vala"
		gtk_snapshot_push_rounded_clip (snapshot, &_tmp22_);
#line 207 "../lib/Widgets/Avatar.vala"
		_tmp23_.red = (gfloat) 0.5;
#line 207 "../lib/Widgets/Avatar.vala"
		_tmp23_.green = (gfloat) 0.5;
#line 207 "../lib/Widgets/Avatar.vala"
		_tmp23_.blue = (gfloat) 0.5;
#line 207 "../lib/Widgets/Avatar.vala"
		_tmp23_.alpha = (gfloat) 0.8;
#line 207 "../lib/Widgets/Avatar.vala"
		color = _tmp23_;
#line 208 "../lib/Widgets/Avatar.vala"
		_tmp24_ = color;
#line 208 "../lib/Widgets/Avatar.vala"
		_tmp25_ = rect;
#line 208 "../lib/Widgets/Avatar.vala"
		_tmp26_ = *_tmp25_;
#line 208 "../lib/Widgets/Avatar.vala"
		gtk_snapshot_append_color (snapshot, &_tmp24_, &_tmp26_);
#line 209 "../lib/Widgets/Avatar.vala"
		gtk_snapshot_pop (snapshot);
#line 1221 "Avatar.c"
	}
#line 213 "../lib/Widgets/Avatar.vala"
	_tmp27_ = self->priv->texture;
#line 213 "../lib/Widgets/Avatar.vala"
	if (_tmp27_ != NULL) {
#line 1227 "Avatar.c"
		GskRoundedRect rounded_rect = {0};
		graphene_rect_t* _tmp28_;
		graphene_size_t _tmp29_ = {0};
		graphene_size_t _tmp30_ = {0};
		graphene_size_t _tmp31_ = {0};
		graphene_size_t _tmp32_ = {0};
		graphene_size_t _tmp33_[4] = {0};
		GskRoundedRect _tmp34_ = {0};
		GskRoundedRect _tmp35_;
		GdkTexture* _tmp36_;
		graphene_rect_t* _tmp37_;
		graphene_rect_t _tmp38_;
#line 214 "../lib/Widgets/Avatar.vala"
		_tmp28_ = rect;
#line 214 "../lib/Widgets/Avatar.vala"
		memset (&_tmp29_, 0, sizeof (graphene_size_t));
#line 214 "../lib/Widgets/Avatar.vala"
		_tmp29_.width = (gfloat) (width / 2);
#line 214 "../lib/Widgets/Avatar.vala"
		_tmp29_.height = (gfloat) (height / 2);
#line 214 "../lib/Widgets/Avatar.vala"
		memset (&_tmp30_, 0, sizeof (graphene_size_t));
#line 214 "../lib/Widgets/Avatar.vala"
		_tmp30_.width = (gfloat) (width / 2);
#line 214 "../lib/Widgets/Avatar.vala"
		_tmp30_.height = (gfloat) (height / 2);
#line 214 "../lib/Widgets/Avatar.vala"
		memset (&_tmp31_, 0, sizeof (graphene_size_t));
#line 214 "../lib/Widgets/Avatar.vala"
		_tmp31_.width = (gfloat) (width / 2);
#line 214 "../lib/Widgets/Avatar.vala"
		_tmp31_.height = (gfloat) (height / 2);
#line 214 "../lib/Widgets/Avatar.vala"
		memset (&_tmp32_, 0, sizeof (graphene_size_t));
#line 214 "../lib/Widgets/Avatar.vala"
		_tmp32_.width = (gfloat) (width / 2);
#line 214 "../lib/Widgets/Avatar.vala"
		_tmp32_.height = (gfloat) (height / 2);
#line 214 "../lib/Widgets/Avatar.vala"
		_tmp33_[0] = _tmp29_;
#line 214 "../lib/Widgets/Avatar.vala"
		_tmp33_[1] = _tmp30_;
#line 214 "../lib/Widgets/Avatar.vala"
		_tmp33_[2] = _tmp31_;
#line 214 "../lib/Widgets/Avatar.vala"
		_tmp33_[3] = _tmp32_;
#line 214 "../lib/Widgets/Avatar.vala"
		memset (&_tmp34_, 0, sizeof (GskRoundedRect));
#line 214 "../lib/Widgets/Avatar.vala"
		_tmp34_.bounds = *_tmp28_;
#line 214 "../lib/Widgets/Avatar.vala"
		memcpy (_tmp34_.corner, _tmp33_, 4 * sizeof (graphene_size_t));
#line 214 "../lib/Widgets/Avatar.vala"
		rounded_rect = _tmp34_;
#line 223 "../lib/Widgets/Avatar.vala"
		_tmp35_ = rounded_rect;
#line 223 "../lib/Widgets/Avatar.vala"
		gtk_snapshot_push_rounded_clip (snapshot, &_tmp35_);
#line 224 "../lib/Widgets/Avatar.vala"
		_tmp36_ = self->priv->texture;
#line 224 "../lib/Widgets/Avatar.vala"
		_tmp37_ = rect;
#line 224 "../lib/Widgets/Avatar.vala"
		_tmp38_ = *_tmp37_;
#line 224 "../lib/Widgets/Avatar.vala"
		gtk_snapshot_append_texture (snapshot, _tmp36_, &_tmp38_);
#line 225 "../lib/Widgets/Avatar.vala"
		gtk_snapshot_pop (snapshot);
#line 1296 "Avatar.c"
	} else {
		const gchar* _tmp39_;
#line 226 "../lib/Widgets/Avatar.vala"
		_tmp39_ = self->priv->_text;
#line 226 "../lib/Widgets/Avatar.vala"
		if (_tmp39_ != NULL) {
#line 1303 "Avatar.c"
			PangoLayout* layout = NULL;
			const gchar* _tmp40_;
			gchar* _tmp41_;
			gchar* _tmp42_;
			PangoLayout* _tmp43_;
			PangoLayout* _tmp44_;
			gint font_size = 0;
			PangoFontDescription* font_desc = NULL;
			PangoFontDescription* _tmp45_;
			PangoFontDescription* _tmp46_;
			PangoLayout* _tmp47_;
			PangoFontDescription* _tmp48_;
			gint text_width = 0;
			gint text_height = 0;
			PangoLayout* _tmp49_;
			gint _tmp50_ = 0;
			gint _tmp51_ = 0;
			graphene_point_t _tmp52_ = {0};
			PangoLayout* _tmp53_;
			GdkRGBA _tmp54_ = {0};
#line 227 "../lib/Widgets/Avatar.vala"
			_tmp40_ = self->priv->_text;
#line 227 "../lib/Widgets/Avatar.vala"
			_tmp41_ = he_avatar_extract_initials (self, _tmp40_);
#line 227 "../lib/Widgets/Avatar.vala"
			_tmp42_ = _tmp41_;
#line 227 "../lib/Widgets/Avatar.vala"
			_tmp43_ = gtk_widget_create_pango_layout ((GtkWidget*) self, _tmp42_);
#line 227 "../lib/Widgets/Avatar.vala"
			_tmp44_ = _tmp43_;
#line 227 "../lib/Widgets/Avatar.vala"
			_g_free0 (_tmp42_);
#line 227 "../lib/Widgets/Avatar.vala"
			layout = _tmp44_;
#line 228 "../lib/Widgets/Avatar.vala"
			font_size = (gint) (7.5 * (self->priv->_size / 16));
#line 229 "../lib/Widgets/Avatar.vala"
			_tmp45_ = pango_font_description_new ();
#line 229 "../lib/Widgets/Avatar.vala"
			font_desc = _tmp45_;
#line 230 "../lib/Widgets/Avatar.vala"
			_tmp46_ = font_desc;
#line 230 "../lib/Widgets/Avatar.vala"
			pango_font_description_set_size (_tmp46_, font_size * PANGO_SCALE);
#line 231 "../lib/Widgets/Avatar.vala"
			_tmp47_ = layout;
#line 231 "../lib/Widgets/Avatar.vala"
			_tmp48_ = font_desc;
#line 231 "../lib/Widgets/Avatar.vala"
			pango_layout_set_font_description (_tmp47_, _tmp48_);
#line 234 "../lib/Widgets/Avatar.vala"
			_tmp49_ = layout;
#line 234 "../lib/Widgets/Avatar.vala"
			pango_layout_get_pixel_size (_tmp49_, &_tmp50_, &_tmp51_);
#line 234 "../lib/Widgets/Avatar.vala"
			text_width = _tmp50_;
#line 234 "../lib/Widgets/Avatar.vala"
			text_height = _tmp51_;
#line 236 "../lib/Widgets/Avatar.vala"
			gtk_snapshot_save (snapshot);
#line 237 "../lib/Widgets/Avatar.vala"
			memset (&_tmp52_, 0, sizeof (graphene_point_t));
#line 237 "../lib/Widgets/Avatar.vala"
			_tmp52_.x = (gfloat) ((width - text_width) / 2);
#line 237 "../lib/Widgets/Avatar.vala"
			_tmp52_.y = (gfloat) ((height - text_height) / 2);
#line 237 "../lib/Widgets/Avatar.vala"
			gtk_snapshot_translate (snapshot, &_tmp52_);
#line 238 "../lib/Widgets/Avatar.vala"
			_tmp53_ = layout;
#line 238 "../lib/Widgets/Avatar.vala"
			_tmp54_.red = (gfloat) 1;
#line 238 "../lib/Widgets/Avatar.vala"
			_tmp54_.green = (gfloat) 1;
#line 238 "../lib/Widgets/Avatar.vala"
			_tmp54_.blue = (gfloat) 1;
#line 238 "../lib/Widgets/Avatar.vala"
			_tmp54_.alpha = (gfloat) 1;
#line 238 "../lib/Widgets/Avatar.vala"
			gtk_snapshot_append_layout (snapshot, _tmp53_, &_tmp54_);
#line 239 "../lib/Widgets/Avatar.vala"
			gtk_snapshot_restore (snapshot);
#line 226 "../lib/Widgets/Avatar.vala"
			__vala_PangoFontDescription_free0 (font_desc);
#line 226 "../lib/Widgets/Avatar.vala"
			_g_object_unref0 (layout);
#line 1390 "Avatar.c"
		}
	}
#line 243 "../lib/Widgets/Avatar.vala"
	_tmp55_.red = (gfloat) 0.45;
#line 243 "../lib/Widgets/Avatar.vala"
	_tmp55_.green = (gfloat) 0.45;
#line 243 "../lib/Widgets/Avatar.vala"
	_tmp55_.blue = (gfloat) 0.45;
#line 243 "../lib/Widgets/Avatar.vala"
	_tmp55_.alpha = (gfloat) 0.32;
#line 243 "../lib/Widgets/Avatar.vala"
	border_color = _tmp55_;
#line 244 "../lib/Widgets/Avatar.vala"
	border_width = 1;
#line 245 "../lib/Widgets/Avatar.vala"
	_tmp56_ = rect;
#line 245 "../lib/Widgets/Avatar.vala"
	memset (&_tmp57_, 0, sizeof (graphene_size_t));
#line 245 "../lib/Widgets/Avatar.vala"
	_tmp57_.width = (gfloat) (height / 2);
#line 245 "../lib/Widgets/Avatar.vala"
	_tmp57_.height = (gfloat) (height / 2);
#line 245 "../lib/Widgets/Avatar.vala"
	memset (&_tmp58_, 0, sizeof (graphene_size_t));
#line 245 "../lib/Widgets/Avatar.vala"
	_tmp58_.width = (gfloat) (height / 2);
#line 245 "../lib/Widgets/Avatar.vala"
	_tmp58_.height = (gfloat) (height / 2);
#line 245 "../lib/Widgets/Avatar.vala"
	memset (&_tmp59_, 0, sizeof (graphene_size_t));
#line 245 "../lib/Widgets/Avatar.vala"
	_tmp59_.width = (gfloat) (height / 2);
#line 245 "../lib/Widgets/Avatar.vala"
	_tmp59_.height = (gfloat) (height / 2);
#line 245 "../lib/Widgets/Avatar.vala"
	memset (&_tmp60_, 0, sizeof (graphene_size_t));
#line 245 "../lib/Widgets/Avatar.vala"
	_tmp60_.width = (gfloat) (height / 2);
#line 245 "../lib/Widgets/Avatar.vala"
	_tmp60_.height = (gfloat) (height / 2);
#line 245 "../lib/Widgets/Avatar.vala"
	_tmp61_[0] = _tmp57_;
#line 245 "../lib/Widgets/Avatar.vala"
	_tmp61_[1] = _tmp58_;
#line 245 "../lib/Widgets/Avatar.vala"
	_tmp61_[2] = _tmp59_;
#line 245 "../lib/Widgets/Avatar.vala"
	_tmp61_[3] = _tmp60_;
#line 245 "../lib/Widgets/Avatar.vala"
	memset (&_tmp62_, 0, sizeof (GskRoundedRect));
#line 245 "../lib/Widgets/Avatar.vala"
	_tmp62_.bounds = *_tmp56_;
#line 245 "../lib/Widgets/Avatar.vala"
	memcpy (_tmp62_.corner, _tmp61_, 4 * sizeof (graphene_size_t));
#line 245 "../lib/Widgets/Avatar.vala"
	rounded_rect = _tmp62_;
#line 249 "../lib/Widgets/Avatar.vala"
	_tmp63_ = rounded_rect;
#line 249 "../lib/Widgets/Avatar.vala"
	_tmp64_[0] = (gfloat) border_width;
#line 249 "../lib/Widgets/Avatar.vala"
	_tmp64_[1] = (gfloat) border_width;
#line 249 "../lib/Widgets/Avatar.vala"
	_tmp64_[2] = (gfloat) border_width;
#line 249 "../lib/Widgets/Avatar.vala"
	_tmp64_[3] = (gfloat) border_width;
#line 249 "../lib/Widgets/Avatar.vala"
	_tmp65_ = border_color;
#line 249 "../lib/Widgets/Avatar.vala"
	_tmp66_ = border_color;
#line 249 "../lib/Widgets/Avatar.vala"
	_tmp67_ = border_color;
#line 249 "../lib/Widgets/Avatar.vala"
	_tmp68_ = border_color;
#line 249 "../lib/Widgets/Avatar.vala"
	_tmp69_[0] = _tmp65_;
#line 249 "../lib/Widgets/Avatar.vala"
	_tmp69_[1] = _tmp66_;
#line 249 "../lib/Widgets/Avatar.vala"
	_tmp69_[2] = _tmp67_;
#line 249 "../lib/Widgets/Avatar.vala"
	_tmp69_[3] = _tmp68_;
#line 249 "../lib/Widgets/Avatar.vala"
	gtk_snapshot_append_border (snapshot, &_tmp63_, _tmp64_, _tmp69_);
#line 255 "../lib/Widgets/Avatar.vala"
	if (self->priv->_status) {
#line 1477 "Avatar.c"
		gint badge_size = 0;
		graphene_rect_t* badge_rect = NULL;
		graphene_rect_t _tmp70_ = {0};
		graphene_rect_t* _tmp71_;
		GdkRGBA badge_color = {0};
		const gchar* _tmp72_;
		const gchar* _tmp73_;
		GQuark _tmp75_ = 0U;
#line 265 "../lib/Widgets/Avatar.vala"
		static GQuark _tmp74_label0 = 0;
#line 265 "../lib/Widgets/Avatar.vala"
		static GQuark _tmp74_label1 = 0;
#line 1490 "Avatar.c"
		GdkRGBA _tmp79_;
		graphene_rect_t* _tmp80_;
		graphene_rect_t _tmp81_;
#line 256 "../lib/Widgets/Avatar.vala"
		badge_size = width / 4;
#line 257 "../lib/Widgets/Avatar.vala"
		memset (&_tmp70_, 0, sizeof (graphene_rect_t));
#line 257 "../lib/Widgets/Avatar.vala"
		_tmp71_ = __vala_graphene_rect_t_copy0 (graphene_rect_init (&_tmp70_, (gfloat) ((width - badge_size) - border_width), (gfloat) ((height - badge_size) - border_width), (gfloat) badge_size, (gfloat) badge_size));
#line 257 "../lib/Widgets/Avatar.vala"
		badge_rect = _tmp71_;
#line 265 "../lib/Widgets/Avatar.vala"
		_tmp72_ = self->priv->_status_color;
#line 265 "../lib/Widgets/Avatar.vala"
		_tmp73_ = _tmp72_;
#line 265 "../lib/Widgets/Avatar.vala"
		_tmp75_ = (NULL == _tmp73_) ? 0 : g_quark_from_string (_tmp73_);
#line 265 "../lib/Widgets/Avatar.vala"
		if (_tmp75_ == ((0 != _tmp74_label0) ? _tmp74_label0 : (_tmp74_label0 = g_quark_from_static_string ("red")))) {
#line 265 "../lib/Widgets/Avatar.vala"
			switch (0) {
#line 1512 "Avatar.c"
				default:
				{
					GdkRGBA _tmp76_ = {0};
#line 267 "../lib/Widgets/Avatar.vala"
					_tmp76_.red = (gfloat) 0.8588;
#line 267 "../lib/Widgets/Avatar.vala"
					_tmp76_.green = (gfloat) 0.1568;
#line 267 "../lib/Widgets/Avatar.vala"
					_tmp76_.blue = (gfloat) 0.3764;
#line 267 "../lib/Widgets/Avatar.vala"
					_tmp76_.alpha = (gfloat) 1;
#line 267 "../lib/Widgets/Avatar.vala"
					badge_color = _tmp76_;
#line 273 "../lib/Widgets/Avatar.vala"
					break;
#line 1528 "Avatar.c"
				}
			}
		} else if (_tmp75_ == ((0 != _tmp74_label1) ? _tmp74_label1 : (_tmp74_label1 = g_quark_from_static_string ("yellow")))) {
#line 265 "../lib/Widgets/Avatar.vala"
			switch (0) {
#line 1534 "Avatar.c"
				default:
				{
					GdkRGBA _tmp77_ = {0};
#line 275 "../lib/Widgets/Avatar.vala"
					_tmp77_.red = (gfloat) 0.8784;
#line 275 "../lib/Widgets/Avatar.vala"
					_tmp77_.green = (gfloat) 0.6313;
#line 275 "../lib/Widgets/Avatar.vala"
					_tmp77_.blue = (gfloat) 0.0039;
#line 275 "../lib/Widgets/Avatar.vala"
					_tmp77_.alpha = (gfloat) 1;
#line 275 "../lib/Widgets/Avatar.vala"
					badge_color = _tmp77_;
#line 281 "../lib/Widgets/Avatar.vala"
					break;
#line 1550 "Avatar.c"
				}
			}
		} else {
#line 265 "../lib/Widgets/Avatar.vala"
			switch (0) {
#line 1556 "Avatar.c"
				default:
				{
					GdkRGBA _tmp78_ = {0};
#line 283 "../lib/Widgets/Avatar.vala"
					_tmp78_.red = (gfloat) 0.2862;
#line 283 "../lib/Widgets/Avatar.vala"
					_tmp78_.green = (gfloat) 0.8156;
#line 283 "../lib/Widgets/Avatar.vala"
					_tmp78_.blue = (gfloat) 0.3686;
#line 283 "../lib/Widgets/Avatar.vala"
					_tmp78_.alpha = (gfloat) 1;
#line 283 "../lib/Widgets/Avatar.vala"
					badge_color = _tmp78_;
#line 289 "../lib/Widgets/Avatar.vala"
					break;
#line 1572 "Avatar.c"
				}
			}
		}
#line 292 "../lib/Widgets/Avatar.vala"
		_tmp79_ = badge_color;
#line 292 "../lib/Widgets/Avatar.vala"
		_tmp80_ = badge_rect;
#line 292 "../lib/Widgets/Avatar.vala"
		_tmp81_ = *_tmp80_;
#line 292 "../lib/Widgets/Avatar.vala"
		gtk_snapshot_append_color (snapshot, &_tmp79_, &_tmp81_);
#line 255 "../lib/Widgets/Avatar.vala"
		__vala_graphene_rect_t_free0 (badge_rect);
#line 1586 "Avatar.c"
	}
#line 171 "../lib/Widgets/Avatar.vala"
	__vala_graphene_rect_t_free0 (blur_rect);
#line 171 "../lib/Widgets/Avatar.vala"
	__vala_graphene_rect_t_free0 (rect);
#line 1592 "Avatar.c"
}

static void
_he_avatar_notify_cb_g_object_notify (GObject* _sender,
                                      GParamSpec* pspec,
                                      gpointer self)
{
#line 137 "../lib/Widgets/Avatar.vala"
	he_avatar_notify_cb ((HeAvatar*) self, pspec);
#line 1602 "Avatar.c"
}

static GObject *
he_avatar_constructor (GType type,
                       guint n_construct_properties,
                       GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	HeAvatar * self;
	gchar* _tmp0_;
#line 136 "../lib/Widgets/Avatar.vala"
	parent_class = G_OBJECT_CLASS (he_avatar_parent_class);
#line 136 "../lib/Widgets/Avatar.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 136 "../lib/Widgets/Avatar.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_AVATAR, HeAvatar);
#line 137 "../lib/Widgets/Avatar.vala"
	g_signal_connect_object ((GObject*) self, "notify", (GCallback) _he_avatar_notify_cb_g_object_notify, self, 0);
#line 138 "../lib/Widgets/Avatar.vala"
	_tmp0_ = g_strdup ("green");
#line 138 "../lib/Widgets/Avatar.vala"
	_g_free0 (self->priv->_status_color);
#line 138 "../lib/Widgets/Avatar.vala"
	self->priv->_status_color = _tmp0_;
#line 136 "../lib/Widgets/Avatar.vala"
	return obj;
#line 1630 "Avatar.c"
}

static void
he_avatar_class_init (HeAvatarClass * klass,
                      gpointer klass_data)
{
#line 23 "../lib/Widgets/Avatar.vala"
	he_avatar_parent_class = g_type_class_peek_parent (klass);
#line 23 "../lib/Widgets/Avatar.vala"
	g_type_class_adjust_private_offset (klass, &HeAvatar_private_offset);
#line 23 "../lib/Widgets/Avatar.vala"
	((GtkWidgetClass *) klass)->snapshot = (void (*) (GtkWidget*, GtkSnapshot*)) he_avatar_real_snapshot;
#line 23 "../lib/Widgets/Avatar.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_he_avatar_get_property;
#line 23 "../lib/Widgets/Avatar.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_he_avatar_set_property;
#line 23 "../lib/Widgets/Avatar.vala"
	G_OBJECT_CLASS (klass)->constructor = he_avatar_constructor;
#line 23 "../lib/Widgets/Avatar.vala"
	G_OBJECT_CLASS (klass)->finalize = he_avatar_finalize;
#line 23 "../lib/Widgets/Avatar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_AVATAR_SIZE_PROPERTY, he_avatar_properties[HE_AVATAR_SIZE_PROPERTY] = g_param_spec_int ("size", "size", "size", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "../lib/Widgets/Avatar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_AVATAR_TEXT_PROPERTY, he_avatar_properties[HE_AVATAR_TEXT_PROPERTY] = g_param_spec_string ("text", "text", "text", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "../lib/Widgets/Avatar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_AVATAR_STATUS_PROPERTY, he_avatar_properties[HE_AVATAR_STATUS_PROPERTY] = g_param_spec_boolean ("status", "status", "status", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "../lib/Widgets/Avatar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_AVATAR_STATUS_COLOR_PROPERTY, he_avatar_properties[HE_AVATAR_STATUS_COLOR_PROPERTY] = g_param_spec_enum ("status-color", "status-color", "status-color", HE_AVATAR_TYPE_STATUS_COLOR, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "../lib/Widgets/Avatar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_AVATAR_IMAGE_PROPERTY, he_avatar_properties[HE_AVATAR_IMAGE_PROPERTY] = g_param_spec_string ("image", "image", "image", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 133 "../lib/Widgets/Avatar.vala"
	gtk_widget_class_set_css_name (GTK_WIDGET_CLASS (klass), "avatar");
#line 1663 "Avatar.c"
}

static void
he_avatar_instance_init (HeAvatar * self,
                         gpointer klass)
{
#line 23 "../lib/Widgets/Avatar.vala"
	self->priv = he_avatar_get_instance_private (self);
#line 1672 "Avatar.c"
}

static void
he_avatar_finalize (GObject * obj)
{
	HeAvatar * self;
#line 23 "../lib/Widgets/Avatar.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_AVATAR, HeAvatar);
#line 24 "../lib/Widgets/Avatar.vala"
	_g_object_unref0 (self->priv->texture);
#line 25 "../lib/Widgets/Avatar.vala"
	_gsk_render_node_unref0 (self->priv->blur_node);
#line 44 "../lib/Widgets/Avatar.vala"
	_g_free0 (self->priv->_text);
#line 62 "../lib/Widgets/Avatar.vala"
	_g_free0 (self->priv->_status_color);
#line 90 "../lib/Widgets/Avatar.vala"
	_g_free0 (self->priv->_image);
#line 23 "../lib/Widgets/Avatar.vala"
	G_OBJECT_CLASS (he_avatar_parent_class)->finalize (obj);
#line 1693 "Avatar.c"
}

/**
 * An Avatar is a image representation of a person, or its initials. Shows their status using a badge.
 */
static GType
he_avatar_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HeAvatarClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) he_avatar_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HeAvatar), 0, (GInstanceInitFunc) he_avatar_instance_init, NULL };
	GType he_avatar_type_id;
	he_avatar_type_id = g_type_register_static (gtk_widget_get_type (), "HeAvatar", &g_define_type_info, 0);
	HeAvatar_private_offset = g_type_add_instance_private (he_avatar_type_id, sizeof (HeAvatarPrivate));
	return he_avatar_type_id;
}

GType
he_avatar_get_type (void)
{
	static volatile gsize he_avatar_type_id__once = 0;
	if (g_once_init_enter (&he_avatar_type_id__once)) {
		GType he_avatar_type_id;
		he_avatar_type_id = he_avatar_get_type_once ();
		g_once_init_leave (&he_avatar_type_id__once, he_avatar_type_id);
	}
	return he_avatar_type_id__once;
}

static void
_vala_he_avatar_get_property (GObject * object,
                              guint property_id,
                              GValue * value,
                              GParamSpec * pspec)
{
	HeAvatar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_AVATAR, HeAvatar);
#line 23 "../lib/Widgets/Avatar.vala"
	switch (property_id) {
#line 23 "../lib/Widgets/Avatar.vala"
		case HE_AVATAR_SIZE_PROPERTY:
#line 23 "../lib/Widgets/Avatar.vala"
		g_value_set_int (value, he_avatar_get_size (self));
#line 23 "../lib/Widgets/Avatar.vala"
		break;
#line 23 "../lib/Widgets/Avatar.vala"
		case HE_AVATAR_TEXT_PROPERTY:
#line 23 "../lib/Widgets/Avatar.vala"
		g_value_set_string (value, he_avatar_get_text (self));
#line 23 "../lib/Widgets/Avatar.vala"
		break;
#line 23 "../lib/Widgets/Avatar.vala"
		case HE_AVATAR_STATUS_PROPERTY:
#line 23 "../lib/Widgets/Avatar.vala"
		g_value_set_boolean (value, he_avatar_get_status (self));
#line 23 "../lib/Widgets/Avatar.vala"
		break;
#line 23 "../lib/Widgets/Avatar.vala"
		case HE_AVATAR_STATUS_COLOR_PROPERTY:
#line 23 "../lib/Widgets/Avatar.vala"
		g_value_set_enum (value, he_avatar_get_status_color (self));
#line 23 "../lib/Widgets/Avatar.vala"
		break;
#line 23 "../lib/Widgets/Avatar.vala"
		case HE_AVATAR_IMAGE_PROPERTY:
#line 23 "../lib/Widgets/Avatar.vala"
		g_value_set_string (value, he_avatar_get_image (self));
#line 23 "../lib/Widgets/Avatar.vala"
		break;
#line 1761 "Avatar.c"
		default:
#line 23 "../lib/Widgets/Avatar.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../lib/Widgets/Avatar.vala"
		break;
#line 1767 "Avatar.c"
	}
}

static void
_vala_he_avatar_set_property (GObject * object,
                              guint property_id,
                              const GValue * value,
                              GParamSpec * pspec)
{
	HeAvatar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_AVATAR, HeAvatar);
#line 23 "../lib/Widgets/Avatar.vala"
	switch (property_id) {
#line 23 "../lib/Widgets/Avatar.vala"
		case HE_AVATAR_SIZE_PROPERTY:
#line 23 "../lib/Widgets/Avatar.vala"
		he_avatar_set_size (self, g_value_get_int (value));
#line 23 "../lib/Widgets/Avatar.vala"
		break;
#line 23 "../lib/Widgets/Avatar.vala"
		case HE_AVATAR_TEXT_PROPERTY:
#line 23 "../lib/Widgets/Avatar.vala"
		he_avatar_set_text (self, g_value_get_string (value));
#line 23 "../lib/Widgets/Avatar.vala"
		break;
#line 23 "../lib/Widgets/Avatar.vala"
		case HE_AVATAR_STATUS_PROPERTY:
#line 23 "../lib/Widgets/Avatar.vala"
		he_avatar_set_status (self, g_value_get_boolean (value));
#line 23 "../lib/Widgets/Avatar.vala"
		break;
#line 23 "../lib/Widgets/Avatar.vala"
		case HE_AVATAR_STATUS_COLOR_PROPERTY:
#line 23 "../lib/Widgets/Avatar.vala"
		he_avatar_set_status_color (self, g_value_get_enum (value));
#line 23 "../lib/Widgets/Avatar.vala"
		break;
#line 23 "../lib/Widgets/Avatar.vala"
		case HE_AVATAR_IMAGE_PROPERTY:
#line 23 "../lib/Widgets/Avatar.vala"
		he_avatar_set_image (self, g_value_get_string (value));
#line 23 "../lib/Widgets/Avatar.vala"
		break;
#line 1811 "Avatar.c"
		default:
#line 23 "../lib/Widgets/Avatar.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../lib/Widgets/Avatar.vala"
		break;
#line 1817 "Avatar.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

