/* BottomBar.c generated by valac 0.56.18, the Vala compiler
 * generated from BottomBar.vala, do not modify */

/*
 * Copyright (c) 2022 Fyra Labs
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 */

#include "libhelium-1.h"
#include <gtk/gtk.h>
#include <gee.h>
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	HE_BOTTOM_BAR_0_PROPERTY,
	HE_BOTTOM_BAR_TITLE_PROPERTY,
	HE_BOTTOM_BAR_DESCRIPTION_PROPERTY,
	HE_BOTTOM_BAR_MENU_MODEL_PROPERTY,
	HE_BOTTOM_BAR_COLLAPSE_ACTIONS_PROPERTY,
	HE_BOTTOM_BAR_NUM_PROPERTIES
};
static GParamSpec* he_bottom_bar_properties[HE_BOTTOM_BAR_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _HeBottomBarPrivate {
	GtkBox* box;
	GtkBox* left_fmenu_box;
	GtkBox* right_fmenu_box;
	GtkBox* left_box;
	GtkBox* center_box;
	GtkBox* right_box;
	GtkLabel* title_label;
	GtkLabel* description_label;
	GtkMenuButton* menu;
	GtkMenuButton* fold_menu;
	GtkPopover* fmenu;
	GtkBox* fmenu_box;
	GtkBox* fmenu_box_l;
	GtkBox* fmenu_box_r;
	GtkSeparator* fmenu_separator;
	GtkImage* fmenu_image;
	GeeHashMap* button_to_mbutton;
	gboolean _collapse_actions;
};

static gint HeBottomBar_private_offset;
static gpointer he_bottom_bar_parent_class = NULL;
static GtkBuildableIface * he_bottom_bar_gtk_buildable_parent_iface = NULL;

static GtkWidget* he_bottom_bar_create_menu_button (HeBottomBar* self,
                                             GtkWidget* child);
static void he_bottom_bar_real_add_child (GtkBuildable* base,
                                   GtkBuilder* builder,
                                   GObject* child,
                                   const gchar* type);
static GObject * he_bottom_bar_constructor (GType type,
                                     guint n_construct_properties,
                                     GObjectConstructParam * construct_properties);
static void he_bottom_bar_finalize (GObject * obj);
static GType he_bottom_bar_get_type_once (void);
static void _vala_he_bottom_bar_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec);
static void _vala_he_bottom_bar_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
he_bottom_bar_get_instance_private (HeBottomBar* self)
{
	return G_STRUCT_MEMBER_P (self, HeBottomBar_private_offset);
}

/**
   * An enum to define the position of the bottom bar actions.
   */
static GType
he_bottom_bar_position_get_type_once (void)
{
	static const GEnumValue values[] = {{HE_BOTTOM_BAR_POSITION_LEFT, "HE_BOTTOM_BAR_POSITION_LEFT", "left"}, {HE_BOTTOM_BAR_POSITION_RIGHT, "HE_BOTTOM_BAR_POSITION_RIGHT", "right"}, {0, NULL, NULL}};
	GType he_bottom_bar_position_type_id;
	he_bottom_bar_position_type_id = g_enum_register_static ("HeBottomBarPosition", values);
	return he_bottom_bar_position_type_id;
}

GType
he_bottom_bar_position_get_type (void)
{
	static volatile gsize he_bottom_bar_position_type_id__once = 0;
	if (g_once_init_enter (&he_bottom_bar_position_type_id__once)) {
		GType he_bottom_bar_position_type_id;
		he_bottom_bar_position_type_id = he_bottom_bar_position_get_type_once ();
		g_once_init_leave (&he_bottom_bar_position_type_id__once, he_bottom_bar_position_type_id);
	}
	return he_bottom_bar_position_type_id__once;
}

const gchar*
he_bottom_bar_get_title (HeBottomBar* self)
{
	const gchar* result;
	GtkLabel* _tmp0_;
	const gchar* _tmp1_;
#line 52 "../lib/Widgets/BottomBar.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 52 "../lib/Widgets/BottomBar.vala"
	_tmp0_ = self->priv->title_label;
#line 52 "../lib/Widgets/BottomBar.vala"
	_tmp1_ = gtk_label_get_text (_tmp0_);
#line 52 "../lib/Widgets/BottomBar.vala"
	result = _tmp1_;
#line 52 "../lib/Widgets/BottomBar.vala"
	return result;
#line 146 "BottomBar.c"
}

void
he_bottom_bar_set_title (HeBottomBar* self,
                         const gchar* value)
{
	GtkLabel* _tmp0_;
#line 53 "../lib/Widgets/BottomBar.vala"
	g_return_if_fail (self != NULL);
#line 53 "../lib/Widgets/BottomBar.vala"
	_tmp0_ = self->priv->title_label;
#line 53 "../lib/Widgets/BottomBar.vala"
	gtk_label_set_text (_tmp0_, value);
#line 53 "../lib/Widgets/BottomBar.vala"
	g_object_notify_by_pspec ((GObject *) self, he_bottom_bar_properties[HE_BOTTOM_BAR_TITLE_PROPERTY]);
#line 162 "BottomBar.c"
}

const gchar*
he_bottom_bar_get_description (HeBottomBar* self)
{
	const gchar* result;
	GtkLabel* _tmp0_;
	const gchar* _tmp1_;
#line 60 "../lib/Widgets/BottomBar.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 60 "../lib/Widgets/BottomBar.vala"
	_tmp0_ = self->priv->description_label;
#line 60 "../lib/Widgets/BottomBar.vala"
	_tmp1_ = gtk_label_get_text (_tmp0_);
#line 60 "../lib/Widgets/BottomBar.vala"
	result = _tmp1_;
#line 60 "../lib/Widgets/BottomBar.vala"
	return result;
#line 181 "BottomBar.c"
}

void
he_bottom_bar_set_description (HeBottomBar* self,
                               const gchar* value)
{
	GtkLabel* _tmp0_;
#line 61 "../lib/Widgets/BottomBar.vala"
	g_return_if_fail (self != NULL);
#line 61 "../lib/Widgets/BottomBar.vala"
	_tmp0_ = self->priv->description_label;
#line 61 "../lib/Widgets/BottomBar.vala"
	gtk_label_set_text (_tmp0_, value);
#line 61 "../lib/Widgets/BottomBar.vala"
	g_object_notify_by_pspec ((GObject *) self, he_bottom_bar_properties[HE_BOTTOM_BAR_DESCRIPTION_PROPERTY]);
#line 197 "BottomBar.c"
}

GMenuModel*
he_bottom_bar_get_menu_model (HeBottomBar* self)
{
	GMenuModel* result;
	GtkMenuButton* _tmp0_;
	GMenuModel* _tmp1_;
#line 69 "../lib/Widgets/BottomBar.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 70 "../lib/Widgets/BottomBar.vala"
	_tmp0_ = self->priv->menu;
#line 70 "../lib/Widgets/BottomBar.vala"
	_tmp1_ = gtk_menu_button_get_menu_model (_tmp0_);
#line 70 "../lib/Widgets/BottomBar.vala"
	result = _tmp1_;
#line 70 "../lib/Widgets/BottomBar.vala"
	return result;
#line 216 "BottomBar.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 77 "../lib/Widgets/BottomBar.vala"
	return self ? g_object_ref (self) : NULL;
#line 224 "BottomBar.c"
}

void
he_bottom_bar_set_menu_model (HeBottomBar* self,
                              GMenuModel* value)
{
	GtkMenuButton* _tmp0_;
#line 72 "../lib/Widgets/BottomBar.vala"
	g_return_if_fail (self != NULL);
#line 73 "../lib/Widgets/BottomBar.vala"
	_tmp0_ = self->priv->menu;
#line 73 "../lib/Widgets/BottomBar.vala"
	gtk_menu_button_set_menu_model (_tmp0_, value);
#line 75 "../lib/Widgets/BottomBar.vala"
	if (value != NULL) {
#line 240 "BottomBar.c"
		GtkBox* _tmp1_;
		GtkBox* _tmp10_;
		GtkMenuButton* _tmp11_;
		GtkBox* menu_box = NULL;
		GtkBox* _tmp12_;
		GtkBox* _tmp13_;
		GtkLabel* _tmp14_;
		GtkBox* _tmp15_;
		GtkLabel* _tmp16_;
		GtkImage* menu_image = NULL;
		GtkImage* _tmp17_;
		GtkImage* _tmp18_;
		GtkImage* _tmp19_;
		GtkBox* menu_arrow_box = NULL;
		GtkBox* _tmp20_;
		GtkBox* _tmp21_;
		GtkBox* _tmp22_;
		GtkBox* _tmp23_;
		GtkImage* _tmp24_;
		GtkMenuButton* _tmp25_;
		GtkBox* _tmp26_;
		GtkMenuButton* _tmp27_;
		GtkMenuButton* _tmp28_;
		GtkMenuButton* _tmp29_;
		GtkMenuButton* _tmp30_;
#line 76 "../lib/Widgets/BottomBar.vala"
		_tmp1_ = self->priv->center_box;
#line 76 "../lib/Widgets/BottomBar.vala"
		if (_tmp1_ != NULL) {
#line 270 "BottomBar.c"
			GtkWidget* childs = NULL;
			GtkBox* _tmp2_;
			GtkWidget* _tmp3_;
			GtkWidget* _tmp4_;
#line 77 "../lib/Widgets/BottomBar.vala"
			_tmp2_ = self->priv->center_box;
#line 77 "../lib/Widgets/BottomBar.vala"
			_tmp3_ = gtk_widget_get_first_child ((GtkWidget*) _tmp2_);
#line 77 "../lib/Widgets/BottomBar.vala"
			_tmp4_ = _g_object_ref0 (_tmp3_);
#line 77 "../lib/Widgets/BottomBar.vala"
			childs = _tmp4_;
#line 78 "../lib/Widgets/BottomBar.vala"
			while (TRUE) {
#line 285 "BottomBar.c"
				GtkWidget* _tmp5_;
				GtkWidget* _tmp6_;
				GtkBox* _tmp7_;
				GtkWidget* _tmp8_;
				GtkWidget* _tmp9_;
#line 78 "../lib/Widgets/BottomBar.vala"
				_tmp5_ = childs;
#line 78 "../lib/Widgets/BottomBar.vala"
				if (!(_tmp5_ != NULL)) {
#line 78 "../lib/Widgets/BottomBar.vala"
					break;
#line 297 "BottomBar.c"
				}
#line 79 "../lib/Widgets/BottomBar.vala"
				_tmp6_ = childs;
#line 79 "../lib/Widgets/BottomBar.vala"
				gtk_widget_unparent (_tmp6_);
#line 80 "../lib/Widgets/BottomBar.vala"
				_tmp7_ = self->priv->center_box;
#line 80 "../lib/Widgets/BottomBar.vala"
				_tmp8_ = gtk_widget_get_first_child ((GtkWidget*) _tmp7_);
#line 80 "../lib/Widgets/BottomBar.vala"
				_tmp9_ = _g_object_ref0 (_tmp8_);
#line 80 "../lib/Widgets/BottomBar.vala"
				_g_object_unref0 (childs);
#line 80 "../lib/Widgets/BottomBar.vala"
				childs = _tmp9_;
#line 313 "BottomBar.c"
			}
#line 76 "../lib/Widgets/BottomBar.vala"
			_g_object_unref0 (childs);
#line 317 "BottomBar.c"
		}
#line 84 "../lib/Widgets/BottomBar.vala"
		_tmp10_ = self->priv->center_box;
#line 84 "../lib/Widgets/BottomBar.vala"
		_tmp11_ = self->priv->menu;
#line 84 "../lib/Widgets/BottomBar.vala"
		gtk_box_append (_tmp10_, (GtkWidget*) _tmp11_);
#line 86 "../lib/Widgets/BottomBar.vala"
		_tmp12_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 6);
#line 86 "../lib/Widgets/BottomBar.vala"
		g_object_ref_sink (_tmp12_);
#line 86 "../lib/Widgets/BottomBar.vala"
		menu_box = _tmp12_;
#line 87 "../lib/Widgets/BottomBar.vala"
		_tmp13_ = menu_box;
#line 87 "../lib/Widgets/BottomBar.vala"
		_tmp14_ = self->priv->title_label;
#line 87 "../lib/Widgets/BottomBar.vala"
		gtk_box_append (_tmp13_, (GtkWidget*) _tmp14_);
#line 88 "../lib/Widgets/BottomBar.vala"
		_tmp15_ = menu_box;
#line 88 "../lib/Widgets/BottomBar.vala"
		_tmp16_ = self->priv->description_label;
#line 88 "../lib/Widgets/BottomBar.vala"
		gtk_box_append (_tmp15_, (GtkWidget*) _tmp16_);
#line 90 "../lib/Widgets/BottomBar.vala"
		_tmp17_ = (GtkImage*) gtk_image_new ();
#line 90 "../lib/Widgets/BottomBar.vala"
		g_object_ref_sink (_tmp17_);
#line 90 "../lib/Widgets/BottomBar.vala"
		menu_image = _tmp17_;
#line 91 "../lib/Widgets/BottomBar.vala"
		_tmp18_ = menu_image;
#line 91 "../lib/Widgets/BottomBar.vala"
		gtk_image_set_from_icon_name (_tmp18_, "pan-up-symbolic");
#line 92 "../lib/Widgets/BottomBar.vala"
		_tmp19_ = menu_image;
#line 92 "../lib/Widgets/BottomBar.vala"
		gtk_image_set_pixel_size (_tmp19_, 10);
#line 94 "../lib/Widgets/BottomBar.vala"
		_tmp20_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 12);
#line 94 "../lib/Widgets/BottomBar.vala"
		g_object_ref_sink (_tmp20_);
#line 94 "../lib/Widgets/BottomBar.vala"
		menu_arrow_box = _tmp20_;
#line 95 "../lib/Widgets/BottomBar.vala"
		_tmp21_ = menu_arrow_box;
#line 95 "../lib/Widgets/BottomBar.vala"
		_tmp22_ = menu_box;
#line 95 "../lib/Widgets/BottomBar.vala"
		gtk_box_append (_tmp21_, (GtkWidget*) _tmp22_);
#line 96 "../lib/Widgets/BottomBar.vala"
		_tmp23_ = menu_arrow_box;
#line 96 "../lib/Widgets/BottomBar.vala"
		_tmp24_ = menu_image;
#line 96 "../lib/Widgets/BottomBar.vala"
		gtk_box_append (_tmp23_, (GtkWidget*) _tmp24_);
#line 98 "../lib/Widgets/BottomBar.vala"
		_tmp25_ = self->priv->menu;
#line 98 "../lib/Widgets/BottomBar.vala"
		_tmp26_ = menu_arrow_box;
#line 98 "../lib/Widgets/BottomBar.vala"
		gtk_menu_button_set_child (_tmp25_, (GtkWidget*) _tmp26_);
#line 99 "../lib/Widgets/BottomBar.vala"
		_tmp27_ = self->priv->menu;
#line 99 "../lib/Widgets/BottomBar.vala"
		gtk_menu_button_set_direction (_tmp27_, GTK_ARROW_UP);
#line 100 "../lib/Widgets/BottomBar.vala"
		_tmp28_ = self->priv->menu;
#line 100 "../lib/Widgets/BottomBar.vala"
		gtk_widget_set_halign ((GtkWidget*) _tmp28_, GTK_ALIGN_CENTER);
#line 101 "../lib/Widgets/BottomBar.vala"
		_tmp29_ = self->priv->menu;
#line 101 "../lib/Widgets/BottomBar.vala"
		gtk_widget_set_valign ((GtkWidget*) _tmp29_, GTK_ALIGN_CENTER);
#line 102 "../lib/Widgets/BottomBar.vala"
		_tmp30_ = self->priv->menu;
#line 102 "../lib/Widgets/BottomBar.vala"
		gtk_widget_add_css_class ((GtkWidget*) _tmp30_, "flat");
#line 75 "../lib/Widgets/BottomBar.vala"
		_g_object_unref0 (menu_arrow_box);
#line 75 "../lib/Widgets/BottomBar.vala"
		_g_object_unref0 (menu_image);
#line 75 "../lib/Widgets/BottomBar.vala"
		_g_object_unref0 (menu_box);
#line 403 "BottomBar.c"
	} else {
		GtkBox* _tmp31_;
		GtkMenuButton* _tmp32_;
		GtkBox* _tmp33_;
		GtkLabel* _tmp34_;
		GtkBox* _tmp35_;
		GtkLabel* _tmp36_;
#line 104 "../lib/Widgets/BottomBar.vala"
		_tmp31_ = self->priv->center_box;
#line 104 "../lib/Widgets/BottomBar.vala"
		_tmp32_ = self->priv->menu;
#line 104 "../lib/Widgets/BottomBar.vala"
		gtk_box_remove (_tmp31_, (GtkWidget*) _tmp32_);
#line 105 "../lib/Widgets/BottomBar.vala"
		_tmp33_ = self->priv->center_box;
#line 105 "../lib/Widgets/BottomBar.vala"
		_tmp34_ = self->priv->title_label;
#line 105 "../lib/Widgets/BottomBar.vala"
		gtk_box_append (_tmp33_, (GtkWidget*) _tmp34_);
#line 106 "../lib/Widgets/BottomBar.vala"
		_tmp35_ = self->priv->center_box;
#line 106 "../lib/Widgets/BottomBar.vala"
		_tmp36_ = self->priv->description_label;
#line 106 "../lib/Widgets/BottomBar.vala"
		gtk_box_append (_tmp35_, (GtkWidget*) _tmp36_);
#line 429 "BottomBar.c"
	}
#line 72 "../lib/Widgets/BottomBar.vala"
	g_object_notify_by_pspec ((GObject *) self, he_bottom_bar_properties[HE_BOTTOM_BAR_MENU_MODEL_PROPERTY]);
#line 433 "BottomBar.c"
}

static GtkWidget*
he_bottom_bar_create_menu_button (HeBottomBar* self,
                                  GtkWidget* child)
{
	HeButtonContent* child_content = NULL;
	HeButtonContent* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	HeButton* child_button = NULL;
	HeButton* _tmp3_;
	GtkWidget* result;
#line 111 "../lib/Widgets/BottomBar.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 111 "../lib/Widgets/BottomBar.vala"
	g_return_val_if_fail (child != NULL, NULL);
#line 112 "../lib/Widgets/BottomBar.vala"
	_tmp0_ = he_button_content_new ();
#line 112 "../lib/Widgets/BottomBar.vala"
	g_object_ref_sink (_tmp0_);
#line 112 "../lib/Widgets/BottomBar.vala"
	child_content = _tmp0_;
#line 113 "../lib/Widgets/BottomBar.vala"
	_tmp1_ = gtk_button_get_icon_name (G_TYPE_CHECK_INSTANCE_CAST (child, gtk_button_get_type (), GtkButton));
#line 113 "../lib/Widgets/BottomBar.vala"
	he_button_content_set_icon (child_content, _tmp1_);
#line 114 "../lib/Widgets/BottomBar.vala"
	_tmp2_ = gtk_widget_get_tooltip_text (child);
#line 114 "../lib/Widgets/BottomBar.vala"
	he_button_content_set_label (child_content, _tmp2_);
#line 116 "../lib/Widgets/BottomBar.vala"
	_tmp3_ = he_button_new (NULL, NULL);
#line 116 "../lib/Widgets/BottomBar.vala"
	g_object_ref_sink (_tmp3_);
#line 116 "../lib/Widgets/BottomBar.vala"
	child_button = _tmp3_;
#line 117 "../lib/Widgets/BottomBar.vala"
	he_button_set_is_textual (child_button, TRUE);
#line 118 "../lib/Widgets/BottomBar.vala"
	gtk_button_set_child ((GtkButton*) child_button, (GtkWidget*) child_content);
#line 120 "../lib/Widgets/BottomBar.vala"
	result = (GtkWidget*) child_button;
#line 120 "../lib/Widgets/BottomBar.vala"
	_g_object_unref0 (child_content);
#line 120 "../lib/Widgets/BottomBar.vala"
	return result;
#line 481 "BottomBar.c"
}

gboolean
he_bottom_bar_get_collapse_actions (HeBottomBar* self)
{
	gboolean result;
#line 128 "../lib/Widgets/BottomBar.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 128 "../lib/Widgets/BottomBar.vala"
	result = self->priv->_collapse_actions;
#line 128 "../lib/Widgets/BottomBar.vala"
	return result;
#line 494 "BottomBar.c"
}

void
he_bottom_bar_set_collapse_actions (HeBottomBar* self,
                                    gboolean value)
{
#line 129 "../lib/Widgets/BottomBar.vala"
	g_return_if_fail (self != NULL);
#line 131 "../lib/Widgets/BottomBar.vala"
	self->priv->_collapse_actions = value;
#line 133 "../lib/Widgets/BottomBar.vala"
	if (self->priv->_collapse_actions) {
#line 507 "BottomBar.c"
		GtkBox* _tmp0_;
		GtkBox* _tmp1_;
		GtkBox* _tmp2_;
		GtkBox* _tmp3_;
		GtkBox* _tmp4_;
		GtkBox* _tmp5_;
		GtkBox* _tmp6_;
		GtkBox* _tmp7_;
#line 134 "../lib/Widgets/BottomBar.vala"
		_tmp0_ = self->priv->box;
#line 134 "../lib/Widgets/BottomBar.vala"
		_tmp1_ = self->priv->left_box;
#line 134 "../lib/Widgets/BottomBar.vala"
		gtk_box_remove (_tmp0_, (GtkWidget*) _tmp1_);
#line 135 "../lib/Widgets/BottomBar.vala"
		_tmp2_ = self->priv->box;
#line 135 "../lib/Widgets/BottomBar.vala"
		_tmp3_ = self->priv->left_fmenu_box;
#line 135 "../lib/Widgets/BottomBar.vala"
		gtk_box_prepend (_tmp2_, (GtkWidget*) _tmp3_);
#line 137 "../lib/Widgets/BottomBar.vala"
		_tmp4_ = self->priv->box;
#line 137 "../lib/Widgets/BottomBar.vala"
		_tmp5_ = self->priv->right_box;
#line 137 "../lib/Widgets/BottomBar.vala"
		gtk_box_remove (_tmp4_, (GtkWidget*) _tmp5_);
#line 138 "../lib/Widgets/BottomBar.vala"
		_tmp6_ = self->priv->box;
#line 138 "../lib/Widgets/BottomBar.vala"
		_tmp7_ = self->priv->right_fmenu_box;
#line 138 "../lib/Widgets/BottomBar.vala"
		gtk_box_append (_tmp6_, (GtkWidget*) _tmp7_);
#line 540 "BottomBar.c"
	} else {
		GtkBox* _tmp8_;
		GtkBox* _tmp9_;
		GtkBox* _tmp10_;
		GtkBox* _tmp11_;
		GtkBox* _tmp12_;
		GtkBox* _tmp13_;
		GtkBox* _tmp14_;
		GtkBox* _tmp15_;
#line 140 "../lib/Widgets/BottomBar.vala"
		_tmp8_ = self->priv->box;
#line 140 "../lib/Widgets/BottomBar.vala"
		_tmp9_ = self->priv->left_fmenu_box;
#line 140 "../lib/Widgets/BottomBar.vala"
		gtk_box_remove (_tmp8_, (GtkWidget*) _tmp9_);
#line 141 "../lib/Widgets/BottomBar.vala"
		_tmp10_ = self->priv->box;
#line 141 "../lib/Widgets/BottomBar.vala"
		_tmp11_ = self->priv->left_box;
#line 141 "../lib/Widgets/BottomBar.vala"
		gtk_box_prepend (_tmp10_, (GtkWidget*) _tmp11_);
#line 143 "../lib/Widgets/BottomBar.vala"
		_tmp12_ = self->priv->box;
#line 143 "../lib/Widgets/BottomBar.vala"
		_tmp13_ = self->priv->right_fmenu_box;
#line 143 "../lib/Widgets/BottomBar.vala"
		gtk_box_remove (_tmp12_, (GtkWidget*) _tmp13_);
#line 144 "../lib/Widgets/BottomBar.vala"
		_tmp14_ = self->priv->box;
#line 144 "../lib/Widgets/BottomBar.vala"
		_tmp15_ = self->priv->right_box;
#line 144 "../lib/Widgets/BottomBar.vala"
		gtk_box_append (_tmp14_, (GtkWidget*) _tmp15_);
#line 574 "BottomBar.c"
	}
#line 129 "../lib/Widgets/BottomBar.vala"
	g_object_notify_by_pspec ((GObject *) self, he_bottom_bar_properties[HE_BOTTOM_BAR_COLLAPSE_ACTIONS_PROPERTY]);
#line 578 "BottomBar.c"
}

/**
   * Add a child to the bottombar, should only be used in the context of a UI or Blueprint file. There should be no need to use this method in code.
   */
static void
he_bottom_bar_real_add_child (GtkBuildable* base,
                              GtkBuilder* builder,
                              GObject* child,
                              const gchar* type)
{
	HeBottomBar * self;
#line 160 "../lib/Widgets/BottomBar.vala"
	self = (HeBottomBar*) base;
#line 160 "../lib/Widgets/BottomBar.vala"
	g_return_if_fail (builder != NULL);
#line 160 "../lib/Widgets/BottomBar.vala"
	g_return_if_fail (child != NULL);
#line 161 "../lib/Widgets/BottomBar.vala"
	if (g_strcmp0 (type, "left") == 0) {
#line 162 "../lib/Widgets/BottomBar.vala"
		he_bottom_bar_append_button (self, G_TYPE_CHECK_INSTANCE_CAST (child, HE_TYPE_BUTTON, HeButton), HE_BOTTOM_BAR_POSITION_LEFT);
#line 601 "BottomBar.c"
	} else {
#line 163 "../lib/Widgets/BottomBar.vala"
		if (g_strcmp0 (type, "right") == 0) {
#line 164 "../lib/Widgets/BottomBar.vala"
			he_bottom_bar_append_button (self, G_TYPE_CHECK_INSTANCE_CAST (child, HE_TYPE_BUTTON, HeButton), HE_BOTTOM_BAR_POSITION_RIGHT);
#line 607 "BottomBar.c"
		} else {
#line 166 "../lib/Widgets/BottomBar.vala"
			he_bottom_bar_append_button (self, G_TYPE_CHECK_INSTANCE_CAST (child, HE_TYPE_BUTTON, HeButton), HE_BOTTOM_BAR_POSITION_LEFT);
#line 611 "BottomBar.c"
		}
	}
}

/**
   * Create a new bottom bar.
   * @param title The title of the bottom bar.
   * @param description The description of the bottom bar.
   */
HeBottomBar*
he_bottom_bar_construct_with_details (GType object_type,
                                      const gchar* title,
                                      const gchar* description)
{
	HeBottomBar * self = NULL;
#line 175 "../lib/Widgets/BottomBar.vala"
	g_return_val_if_fail (title != NULL, NULL);
#line 175 "../lib/Widgets/BottomBar.vala"
	g_return_val_if_fail (description != NULL, NULL);
#line 176 "../lib/Widgets/BottomBar.vala"
	self = (HeBottomBar*) he_bin_construct (object_type);
#line 177 "../lib/Widgets/BottomBar.vala"
	he_bottom_bar_set_title (self, title);
#line 178 "../lib/Widgets/BottomBar.vala"
	he_bottom_bar_set_description (self, description);
#line 175 "../lib/Widgets/BottomBar.vala"
	return self;
#line 639 "BottomBar.c"
}

HeBottomBar*
he_bottom_bar_new_with_details (const gchar* title,
                                const gchar* description)
{
#line 175 "../lib/Widgets/BottomBar.vala"
	return he_bottom_bar_construct_with_details (HE_TYPE_BOTTOM_BAR, title, description);
#line 648 "BottomBar.c"
}

/**
   * Create a new bottom bar.
   */
HeBottomBar*
he_bottom_bar_construct (GType object_type)
{
	HeBottomBar * self = NULL;
#line 185 "../lib/Widgets/BottomBar.vala"
	self = (HeBottomBar*) he_bin_construct (object_type);
#line 184 "../lib/Widgets/BottomBar.vala"
	return self;
#line 662 "BottomBar.c"
}

HeBottomBar*
he_bottom_bar_new (void)
{
#line 184 "../lib/Widgets/BottomBar.vala"
	return he_bottom_bar_construct (HE_TYPE_BOTTOM_BAR);
#line 670 "BottomBar.c"
}

/**
   * Add an action to the bottom bar on the end of the bar.
   * @param icon The iconicbutton of the action.
   * @param position The position of the action.
   */
void
he_bottom_bar_append_button (HeBottomBar* self,
                             HeButton* icon,
                             HeBottomBarPosition position)
{
	GtkBox* _tmp0_ = NULL;
	GtkBox* box = NULL;
	GtkBox* _tmp3_;
	GtkBox* _tmp4_ = NULL;
	GtkBox* fmenu_box = NULL;
	GtkBox* _tmp7_;
	GtkWidget* menu_button = NULL;
	GtkWidget* _tmp8_;
	GtkBox* _tmp9_;
	GeeHashMap* _tmp10_;
#line 233 "../lib/Widgets/BottomBar.vala"
	g_return_if_fail (self != NULL);
#line 233 "../lib/Widgets/BottomBar.vala"
	g_return_if_fail (icon != NULL);
#line 234 "../lib/Widgets/BottomBar.vala"
	if (position == HE_BOTTOM_BAR_POSITION_LEFT) {
#line 699 "BottomBar.c"
		GtkBox* _tmp1_;
#line 234 "../lib/Widgets/BottomBar.vala"
		_tmp1_ = self->priv->left_box;
#line 234 "../lib/Widgets/BottomBar.vala"
		_tmp0_ = _tmp1_;
#line 705 "BottomBar.c"
	} else {
		GtkBox* _tmp2_;
#line 234 "../lib/Widgets/BottomBar.vala"
		_tmp2_ = self->priv->right_box;
#line 234 "../lib/Widgets/BottomBar.vala"
		_tmp0_ = _tmp2_;
#line 712 "BottomBar.c"
	}
#line 234 "../lib/Widgets/BottomBar.vala"
	_tmp3_ = _g_object_ref0 (_tmp0_);
#line 234 "../lib/Widgets/BottomBar.vala"
	box = _tmp3_;
#line 235 "../lib/Widgets/BottomBar.vala"
	if (position == HE_BOTTOM_BAR_POSITION_LEFT) {
#line 720 "BottomBar.c"
		GtkBox* _tmp5_;
#line 235 "../lib/Widgets/BottomBar.vala"
		_tmp5_ = self->priv->fmenu_box_l;
#line 235 "../lib/Widgets/BottomBar.vala"
		_tmp4_ = _tmp5_;
#line 726 "BottomBar.c"
	} else {
		GtkBox* _tmp6_;
#line 235 "../lib/Widgets/BottomBar.vala"
		_tmp6_ = self->priv->fmenu_box_r;
#line 235 "../lib/Widgets/BottomBar.vala"
		_tmp4_ = _tmp6_;
#line 733 "BottomBar.c"
	}
#line 235 "../lib/Widgets/BottomBar.vala"
	_tmp7_ = _g_object_ref0 (_tmp4_);
#line 235 "../lib/Widgets/BottomBar.vala"
	fmenu_box = _tmp7_;
#line 237 "../lib/Widgets/BottomBar.vala"
	_tmp8_ = he_bottom_bar_create_menu_button (self, (GtkWidget*) icon);
#line 237 "../lib/Widgets/BottomBar.vala"
	menu_button = _tmp8_;
#line 239 "../lib/Widgets/BottomBar.vala"
	_tmp9_ = box;
#line 239 "../lib/Widgets/BottomBar.vala"
	gtk_box_append (_tmp9_, (GtkWidget*) icon);
#line 240 "../lib/Widgets/BottomBar.vala"
	gtk_box_append (fmenu_box, menu_button);
#line 242 "../lib/Widgets/BottomBar.vala"
	_tmp10_ = self->priv->button_to_mbutton;
#line 242 "../lib/Widgets/BottomBar.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp10_, (GtkWidget*) icon, menu_button);
#line 233 "../lib/Widgets/BottomBar.vala"
	_g_object_unref0 (menu_button);
#line 233 "../lib/Widgets/BottomBar.vala"
	_g_object_unref0 (fmenu_box);
#line 233 "../lib/Widgets/BottomBar.vala"
	_g_object_unref0 (box);
#line 759 "BottomBar.c"
}

/**
   * Add an action to the bottom bar on the start of the bar.
   * @param icon The iconicbutton of the action.
   * @param position The position of the action.
   */
void
he_bottom_bar_prepend_button (HeBottomBar* self,
                              HeButton* icon,
                              HeBottomBarPosition position)
{
	GtkBox* _tmp0_ = NULL;
	GtkBox* box = NULL;
	GtkBox* _tmp3_;
	GtkBox* _tmp4_ = NULL;
	GtkBox* fmenu_box = NULL;
	GtkBox* _tmp7_;
	GtkWidget* menu_button = NULL;
	GtkWidget* _tmp8_;
	GtkBox* _tmp9_;
	GeeHashMap* _tmp10_;
#line 250 "../lib/Widgets/BottomBar.vala"
	g_return_if_fail (self != NULL);
#line 250 "../lib/Widgets/BottomBar.vala"
	g_return_if_fail (icon != NULL);
#line 251 "../lib/Widgets/BottomBar.vala"
	if (position == HE_BOTTOM_BAR_POSITION_LEFT) {
#line 788 "BottomBar.c"
		GtkBox* _tmp1_;
#line 251 "../lib/Widgets/BottomBar.vala"
		_tmp1_ = self->priv->left_box;
#line 251 "../lib/Widgets/BottomBar.vala"
		_tmp0_ = _tmp1_;
#line 794 "BottomBar.c"
	} else {
		GtkBox* _tmp2_;
#line 251 "../lib/Widgets/BottomBar.vala"
		_tmp2_ = self->priv->right_box;
#line 251 "../lib/Widgets/BottomBar.vala"
		_tmp0_ = _tmp2_;
#line 801 "BottomBar.c"
	}
#line 251 "../lib/Widgets/BottomBar.vala"
	_tmp3_ = _g_object_ref0 (_tmp0_);
#line 251 "../lib/Widgets/BottomBar.vala"
	box = _tmp3_;
#line 252 "../lib/Widgets/BottomBar.vala"
	if (position == HE_BOTTOM_BAR_POSITION_LEFT) {
#line 809 "BottomBar.c"
		GtkBox* _tmp5_;
#line 252 "../lib/Widgets/BottomBar.vala"
		_tmp5_ = self->priv->fmenu_box_l;
#line 252 "../lib/Widgets/BottomBar.vala"
		_tmp4_ = _tmp5_;
#line 815 "BottomBar.c"
	} else {
		GtkBox* _tmp6_;
#line 252 "../lib/Widgets/BottomBar.vala"
		_tmp6_ = self->priv->fmenu_box_r;
#line 252 "../lib/Widgets/BottomBar.vala"
		_tmp4_ = _tmp6_;
#line 822 "BottomBar.c"
	}
#line 252 "../lib/Widgets/BottomBar.vala"
	_tmp7_ = _g_object_ref0 (_tmp4_);
#line 252 "../lib/Widgets/BottomBar.vala"
	fmenu_box = _tmp7_;
#line 254 "../lib/Widgets/BottomBar.vala"
	_tmp8_ = he_bottom_bar_create_menu_button (self, (GtkWidget*) icon);
#line 254 "../lib/Widgets/BottomBar.vala"
	menu_button = _tmp8_;
#line 256 "../lib/Widgets/BottomBar.vala"
	_tmp9_ = box;
#line 256 "../lib/Widgets/BottomBar.vala"
	gtk_box_prepend (_tmp9_, (GtkWidget*) icon);
#line 257 "../lib/Widgets/BottomBar.vala"
	gtk_box_prepend (fmenu_box, menu_button);
#line 259 "../lib/Widgets/BottomBar.vala"
	_tmp10_ = self->priv->button_to_mbutton;
#line 259 "../lib/Widgets/BottomBar.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp10_, (GtkWidget*) icon, menu_button);
#line 250 "../lib/Widgets/BottomBar.vala"
	_g_object_unref0 (menu_button);
#line 250 "../lib/Widgets/BottomBar.vala"
	_g_object_unref0 (fmenu_box);
#line 250 "../lib/Widgets/BottomBar.vala"
	_g_object_unref0 (box);
#line 848 "BottomBar.c"
}

/**
   * Remove an action of the bottom bar.
   * @param icon The iconicbutton of the action.
   * @param position The position of the action.
   */
void
he_bottom_bar_remove_button (HeBottomBar* self,
                             HeButton* icon,
                             HeBottomBarPosition position)
{
	GtkBox* _tmp0_ = NULL;
	GtkBox* box = NULL;
	GtkBox* _tmp3_;
	GtkBox* _tmp4_ = NULL;
	GtkBox* fmenu_box = NULL;
	GtkBox* _tmp7_;
	GtkBox* _tmp8_;
	GeeHashMap* _tmp9_;
	gpointer _tmp10_;
	GtkWidget* _tmp11_;
	GeeHashMap* _tmp12_;
#line 267 "../lib/Widgets/BottomBar.vala"
	g_return_if_fail (self != NULL);
#line 267 "../lib/Widgets/BottomBar.vala"
	g_return_if_fail (icon != NULL);
#line 268 "../lib/Widgets/BottomBar.vala"
	if (position == HE_BOTTOM_BAR_POSITION_LEFT) {
#line 878 "BottomBar.c"
		GtkBox* _tmp1_;
#line 268 "../lib/Widgets/BottomBar.vala"
		_tmp1_ = self->priv->left_box;
#line 268 "../lib/Widgets/BottomBar.vala"
		_tmp0_ = _tmp1_;
#line 884 "BottomBar.c"
	} else {
		GtkBox* _tmp2_;
#line 268 "../lib/Widgets/BottomBar.vala"
		_tmp2_ = self->priv->right_box;
#line 268 "../lib/Widgets/BottomBar.vala"
		_tmp0_ = _tmp2_;
#line 891 "BottomBar.c"
	}
#line 268 "../lib/Widgets/BottomBar.vala"
	_tmp3_ = _g_object_ref0 (_tmp0_);
#line 268 "../lib/Widgets/BottomBar.vala"
	box = _tmp3_;
#line 269 "../lib/Widgets/BottomBar.vala"
	if (position == HE_BOTTOM_BAR_POSITION_LEFT) {
#line 899 "BottomBar.c"
		GtkBox* _tmp5_;
#line 269 "../lib/Widgets/BottomBar.vala"
		_tmp5_ = self->priv->fmenu_box_l;
#line 269 "../lib/Widgets/BottomBar.vala"
		_tmp4_ = _tmp5_;
#line 905 "BottomBar.c"
	} else {
		GtkBox* _tmp6_;
#line 269 "../lib/Widgets/BottomBar.vala"
		_tmp6_ = self->priv->fmenu_box_r;
#line 269 "../lib/Widgets/BottomBar.vala"
		_tmp4_ = _tmp6_;
#line 912 "BottomBar.c"
	}
#line 269 "../lib/Widgets/BottomBar.vala"
	_tmp7_ = _g_object_ref0 (_tmp4_);
#line 269 "../lib/Widgets/BottomBar.vala"
	fmenu_box = _tmp7_;
#line 271 "../lib/Widgets/BottomBar.vala"
	_tmp8_ = box;
#line 271 "../lib/Widgets/BottomBar.vala"
	gtk_box_remove (_tmp8_, (GtkWidget*) icon);
#line 272 "../lib/Widgets/BottomBar.vala"
	_tmp9_ = self->priv->button_to_mbutton;
#line 272 "../lib/Widgets/BottomBar.vala"
	_tmp10_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp9_, (GtkWidget*) icon);
#line 272 "../lib/Widgets/BottomBar.vala"
	_tmp11_ = (GtkWidget*) _tmp10_;
#line 272 "../lib/Widgets/BottomBar.vala"
	gtk_box_remove (fmenu_box, _tmp11_);
#line 272 "../lib/Widgets/BottomBar.vala"
	_g_object_unref0 (_tmp11_);
#line 273 "../lib/Widgets/BottomBar.vala"
	_tmp12_ = self->priv->button_to_mbutton;
#line 273 "../lib/Widgets/BottomBar.vala"
	gee_abstract_map_unset ((GeeAbstractMap*) _tmp12_, (GtkWidget*) icon, NULL);
#line 267 "../lib/Widgets/BottomBar.vala"
	_g_object_unref0 (fmenu_box);
#line 267 "../lib/Widgets/BottomBar.vala"
	_g_object_unref0 (box);
#line 940 "BottomBar.c"
}

/**
   * Insert an action after another action.
   * @param icon The iconicbutton of the action.
   * @param after The iconicbutton of the action after which the action is.
   * @param position The position of the action.
   */
void
he_bottom_bar_insert_button_after (HeBottomBar* self,
                                   HeButton* icon,
                                   HeButton* after,
                                   HeBottomBarPosition position)
{
	GtkBox* _tmp0_ = NULL;
	GtkBox* box = NULL;
	GtkBox* _tmp3_;
	GtkBox* _tmp4_ = NULL;
	GtkBox* fmenu_box = NULL;
	GtkBox* _tmp7_;
	GtkWidget* menu_button = NULL;
	GtkWidget* _tmp8_;
	GtkBox* _tmp9_;
	GeeHashMap* _tmp10_;
	gpointer _tmp11_;
	GtkWidget* _tmp12_;
	GeeHashMap* _tmp13_;
#line 282 "../lib/Widgets/BottomBar.vala"
	g_return_if_fail (self != NULL);
#line 282 "../lib/Widgets/BottomBar.vala"
	g_return_if_fail (icon != NULL);
#line 282 "../lib/Widgets/BottomBar.vala"
	g_return_if_fail (after != NULL);
#line 283 "../lib/Widgets/BottomBar.vala"
	if (position == HE_BOTTOM_BAR_POSITION_LEFT) {
#line 976 "BottomBar.c"
		GtkBox* _tmp1_;
#line 283 "../lib/Widgets/BottomBar.vala"
		_tmp1_ = self->priv->left_box;
#line 283 "../lib/Widgets/BottomBar.vala"
		_tmp0_ = _tmp1_;
#line 982 "BottomBar.c"
	} else {
		GtkBox* _tmp2_;
#line 283 "../lib/Widgets/BottomBar.vala"
		_tmp2_ = self->priv->right_box;
#line 283 "../lib/Widgets/BottomBar.vala"
		_tmp0_ = _tmp2_;
#line 989 "BottomBar.c"
	}
#line 283 "../lib/Widgets/BottomBar.vala"
	_tmp3_ = _g_object_ref0 (_tmp0_);
#line 283 "../lib/Widgets/BottomBar.vala"
	box = _tmp3_;
#line 284 "../lib/Widgets/BottomBar.vala"
	if (position == HE_BOTTOM_BAR_POSITION_LEFT) {
#line 997 "BottomBar.c"
		GtkBox* _tmp5_;
#line 284 "../lib/Widgets/BottomBar.vala"
		_tmp5_ = self->priv->fmenu_box_l;
#line 284 "../lib/Widgets/BottomBar.vala"
		_tmp4_ = _tmp5_;
#line 1003 "BottomBar.c"
	} else {
		GtkBox* _tmp6_;
#line 284 "../lib/Widgets/BottomBar.vala"
		_tmp6_ = self->priv->fmenu_box_r;
#line 284 "../lib/Widgets/BottomBar.vala"
		_tmp4_ = _tmp6_;
#line 1010 "BottomBar.c"
	}
#line 284 "../lib/Widgets/BottomBar.vala"
	_tmp7_ = _g_object_ref0 (_tmp4_);
#line 284 "../lib/Widgets/BottomBar.vala"
	fmenu_box = _tmp7_;
#line 286 "../lib/Widgets/BottomBar.vala"
	_tmp8_ = he_bottom_bar_create_menu_button (self, (GtkWidget*) icon);
#line 286 "../lib/Widgets/BottomBar.vala"
	menu_button = _tmp8_;
#line 288 "../lib/Widgets/BottomBar.vala"
	_tmp9_ = box;
#line 288 "../lib/Widgets/BottomBar.vala"
	gtk_box_insert_child_after (_tmp9_, (GtkWidget*) icon, (GtkWidget*) after);
#line 289 "../lib/Widgets/BottomBar.vala"
	_tmp10_ = self->priv->button_to_mbutton;
#line 289 "../lib/Widgets/BottomBar.vala"
	_tmp11_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp10_, (GtkWidget*) after);
#line 289 "../lib/Widgets/BottomBar.vala"
	_tmp12_ = (GtkWidget*) _tmp11_;
#line 289 "../lib/Widgets/BottomBar.vala"
	gtk_box_insert_child_after (fmenu_box, menu_button, _tmp12_);
#line 289 "../lib/Widgets/BottomBar.vala"
	_g_object_unref0 (_tmp12_);
#line 291 "../lib/Widgets/BottomBar.vala"
	_tmp13_ = self->priv->button_to_mbutton;
#line 291 "../lib/Widgets/BottomBar.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp13_, (GtkWidget*) icon, menu_button);
#line 282 "../lib/Widgets/BottomBar.vala"
	_g_object_unref0 (menu_button);
#line 282 "../lib/Widgets/BottomBar.vala"
	_g_object_unref0 (fmenu_box);
#line 282 "../lib/Widgets/BottomBar.vala"
	_g_object_unref0 (box);
#line 1044 "BottomBar.c"
}

/**
   * Reorder an action based on another action.
   * @param icon The iconicbutton of the action.
   * @param sibling The iconicbutton of the action after which the action is.
   * @param position The position of the action.
   *
   * @since 1.0
   */
void
he_bottom_bar_reorder_button_after (HeBottomBar* self,
                                    HeButton* icon,
                                    HeButton* sibling,
                                    HeBottomBarPosition position)
{
	GtkBox* _tmp0_ = NULL;
	GtkBox* box = NULL;
	GtkBox* _tmp3_;
	GtkBox* _tmp4_ = NULL;
	GtkBox* fmenu_box = NULL;
	GtkBox* _tmp7_;
	GtkWidget* _tmp8_;
	GtkWidget* _tmp9_;
	GtkBox* _tmp10_;
	GeeHashMap* _tmp11_;
	gpointer _tmp12_;
	GtkWidget* _tmp13_;
	GeeHashMap* _tmp14_;
	gpointer _tmp15_;
	GtkWidget* _tmp16_;
#line 302 "../lib/Widgets/BottomBar.vala"
	g_return_if_fail (self != NULL);
#line 302 "../lib/Widgets/BottomBar.vala"
	g_return_if_fail (icon != NULL);
#line 302 "../lib/Widgets/BottomBar.vala"
	g_return_if_fail (sibling != NULL);
#line 303 "../lib/Widgets/BottomBar.vala"
	if (position == HE_BOTTOM_BAR_POSITION_LEFT) {
#line 1084 "BottomBar.c"
		GtkBox* _tmp1_;
#line 303 "../lib/Widgets/BottomBar.vala"
		_tmp1_ = self->priv->left_box;
#line 303 "../lib/Widgets/BottomBar.vala"
		_tmp0_ = _tmp1_;
#line 1090 "BottomBar.c"
	} else {
		GtkBox* _tmp2_;
#line 303 "../lib/Widgets/BottomBar.vala"
		_tmp2_ = self->priv->right_box;
#line 303 "../lib/Widgets/BottomBar.vala"
		_tmp0_ = _tmp2_;
#line 1097 "BottomBar.c"
	}
#line 303 "../lib/Widgets/BottomBar.vala"
	_tmp3_ = _g_object_ref0 (_tmp0_);
#line 303 "../lib/Widgets/BottomBar.vala"
	box = _tmp3_;
#line 304 "../lib/Widgets/BottomBar.vala"
	if (position == HE_BOTTOM_BAR_POSITION_LEFT) {
#line 1105 "BottomBar.c"
		GtkBox* _tmp5_;
#line 304 "../lib/Widgets/BottomBar.vala"
		_tmp5_ = self->priv->fmenu_box_l;
#line 304 "../lib/Widgets/BottomBar.vala"
		_tmp4_ = _tmp5_;
#line 1111 "BottomBar.c"
	} else {
		GtkBox* _tmp6_;
#line 304 "../lib/Widgets/BottomBar.vala"
		_tmp6_ = self->priv->fmenu_box_r;
#line 304 "../lib/Widgets/BottomBar.vala"
		_tmp4_ = _tmp6_;
#line 1118 "BottomBar.c"
	}
#line 304 "../lib/Widgets/BottomBar.vala"
	_tmp7_ = _g_object_ref0 (_tmp4_);
#line 304 "../lib/Widgets/BottomBar.vala"
	fmenu_box = _tmp7_;
#line 306 "../lib/Widgets/BottomBar.vala"
	_tmp8_ = he_bottom_bar_create_menu_button (self, (GtkWidget*) icon);
#line 306 "../lib/Widgets/BottomBar.vala"
	_tmp9_ = _tmp8_;
#line 306 "../lib/Widgets/BottomBar.vala"
	_g_object_unref0 (_tmp9_);
#line 308 "../lib/Widgets/BottomBar.vala"
	_tmp10_ = box;
#line 308 "../lib/Widgets/BottomBar.vala"
	gtk_box_reorder_child_after (_tmp10_, (GtkWidget*) icon, (GtkWidget*) sibling);
#line 309 "../lib/Widgets/BottomBar.vala"
	_tmp11_ = self->priv->button_to_mbutton;
#line 309 "../lib/Widgets/BottomBar.vala"
	_tmp12_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp11_, (GtkWidget*) icon);
#line 309 "../lib/Widgets/BottomBar.vala"
	_tmp13_ = (GtkWidget*) _tmp12_;
#line 309 "../lib/Widgets/BottomBar.vala"
	_tmp14_ = self->priv->button_to_mbutton;
#line 309 "../lib/Widgets/BottomBar.vala"
	_tmp15_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp14_, (GtkWidget*) sibling);
#line 309 "../lib/Widgets/BottomBar.vala"
	_tmp16_ = (GtkWidget*) _tmp15_;
#line 309 "../lib/Widgets/BottomBar.vala"
	gtk_box_reorder_child_after (fmenu_box, _tmp13_, _tmp16_);
#line 309 "../lib/Widgets/BottomBar.vala"
	_g_object_unref0 (_tmp16_);
#line 309 "../lib/Widgets/BottomBar.vala"
	_g_object_unref0 (_tmp13_);
#line 302 "../lib/Widgets/BottomBar.vala"
	_g_object_unref0 (fmenu_box);
#line 302 "../lib/Widgets/BottomBar.vala"
	_g_object_unref0 (box);
#line 1156 "BottomBar.c"
}

static GObject *
he_bottom_bar_constructor (GType type,
                           guint n_construct_properties,
                           GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	HeBottomBar * self;
	GtkLabel* _tmp0_;
	GtkLabel* _tmp1_;
	GtkBox* _tmp2_;
	GtkBox* _tmp3_;
	GtkBox* _tmp4_;
	GtkBox* _tmp5_;
	GtkBox* _tmp6_;
	GtkLabel* _tmp7_;
	GtkBox* _tmp8_;
	GtkLabel* _tmp9_;
	GtkBox* _tmp10_;
	GtkBox* _tmp11_;
	GtkBox* _tmp12_;
	GtkBox* _tmp13_;
	GtkBox* _tmp14_;
	GtkBox* _tmp15_;
	GtkMenuButton* _tmp16_;
	GtkMenuButton* _tmp17_;
	GtkMenuButton* _tmp18_;
	GtkMenuButton* _tmp19_;
	GtkImage* _tmp20_;
	GtkImage* _tmp21_;
	GtkMenuButton* _tmp22_;
	GtkImage* _tmp23_;
	GtkBox* _tmp24_;
	GtkBox* _tmp25_;
	GtkBox* _tmp26_;
	GtkSeparator* _tmp27_;
	GtkBox* _tmp28_;
	GtkBox* _tmp29_;
	GtkPopover* _tmp30_;
	GtkBox* _tmp31_;
	GtkMenuButton* _tmp32_;
	GtkPopover* _tmp33_;
	GtkBox* _tmp34_;
	GtkMenuButton* _tmp35_;
	GtkBox* _tmp36_;
#line 192 "../lib/Widgets/BottomBar.vala"
	parent_class = G_OBJECT_CLASS (he_bottom_bar_parent_class);
#line 192 "../lib/Widgets/BottomBar.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 192 "../lib/Widgets/BottomBar.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_BOTTOM_BAR, HeBottomBar);
#line 193 "../lib/Widgets/BottomBar.vala"
	_tmp0_ = self->priv->title_label;
#line 193 "../lib/Widgets/BottomBar.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp0_, "title");
#line 194 "../lib/Widgets/BottomBar.vala"
	_tmp1_ = self->priv->description_label;
#line 194 "../lib/Widgets/BottomBar.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp1_, "dim-label");
#line 195 "../lib/Widgets/BottomBar.vala"
	gtk_widget_add_css_class ((GtkWidget*) self, "bottom-bar");
#line 197 "../lib/Widgets/BottomBar.vala"
	_tmp2_ = self->priv->center_box;
#line 197 "../lib/Widgets/BottomBar.vala"
	gtk_box_set_homogeneous (_tmp2_, TRUE);
#line 198 "../lib/Widgets/BottomBar.vala"
	_tmp3_ = self->priv->center_box;
#line 198 "../lib/Widgets/BottomBar.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp3_, TRUE);
#line 199 "../lib/Widgets/BottomBar.vala"
	_tmp4_ = self->priv->center_box;
#line 199 "../lib/Widgets/BottomBar.vala"
	_tmp5_ = self->priv->center_box;
#line 199 "../lib/Widgets/BottomBar.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp5_, 18);
#line 199 "../lib/Widgets/BottomBar.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp4_, 18);
#line 200 "../lib/Widgets/BottomBar.vala"
	_tmp6_ = self->priv->center_box;
#line 200 "../lib/Widgets/BottomBar.vala"
	_tmp7_ = self->priv->title_label;
#line 200 "../lib/Widgets/BottomBar.vala"
	gtk_box_append (_tmp6_, (GtkWidget*) _tmp7_);
#line 201 "../lib/Widgets/BottomBar.vala"
	_tmp8_ = self->priv->center_box;
#line 201 "../lib/Widgets/BottomBar.vala"
	_tmp9_ = self->priv->description_label;
#line 201 "../lib/Widgets/BottomBar.vala"
	gtk_box_append (_tmp8_, (GtkWidget*) _tmp9_);
#line 203 "../lib/Widgets/BottomBar.vala"
	_tmp10_ = self->priv->box;
#line 203 "../lib/Widgets/BottomBar.vala"
	_tmp11_ = self->priv->left_box;
#line 203 "../lib/Widgets/BottomBar.vala"
	gtk_box_append (_tmp10_, (GtkWidget*) _tmp11_);
#line 204 "../lib/Widgets/BottomBar.vala"
	_tmp12_ = self->priv->box;
#line 204 "../lib/Widgets/BottomBar.vala"
	_tmp13_ = self->priv->center_box;
#line 204 "../lib/Widgets/BottomBar.vala"
	gtk_box_append (_tmp12_, (GtkWidget*) _tmp13_);
#line 205 "../lib/Widgets/BottomBar.vala"
	_tmp14_ = self->priv->box;
#line 205 "../lib/Widgets/BottomBar.vala"
	_tmp15_ = self->priv->right_box;
#line 205 "../lib/Widgets/BottomBar.vala"
	gtk_box_append (_tmp14_, (GtkWidget*) _tmp15_);
#line 207 "../lib/Widgets/BottomBar.vala"
	_tmp16_ = self->priv->fold_menu;
#line 207 "../lib/Widgets/BottomBar.vala"
	gtk_menu_button_set_direction (_tmp16_, GTK_ARROW_UP);
#line 208 "../lib/Widgets/BottomBar.vala"
	_tmp17_ = self->priv->fold_menu;
#line 208 "../lib/Widgets/BottomBar.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp17_, GTK_ALIGN_CENTER);
#line 209 "../lib/Widgets/BottomBar.vala"
	_tmp18_ = self->priv->fold_menu;
#line 209 "../lib/Widgets/BottomBar.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp18_, GTK_ALIGN_CENTER);
#line 210 "../lib/Widgets/BottomBar.vala"
	_tmp19_ = self->priv->fold_menu;
#line 210 "../lib/Widgets/BottomBar.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp19_, "flat");
#line 212 "../lib/Widgets/BottomBar.vala"
	_tmp20_ = self->priv->fmenu_image;
#line 212 "../lib/Widgets/BottomBar.vala"
	gtk_image_set_from_icon_name (_tmp20_, "view-more-symbolic");
#line 213 "../lib/Widgets/BottomBar.vala"
	_tmp21_ = self->priv->fmenu_image;
#line 213 "../lib/Widgets/BottomBar.vala"
	gtk_image_set_pixel_size (_tmp21_, 16);
#line 214 "../lib/Widgets/BottomBar.vala"
	_tmp22_ = self->priv->fold_menu;
#line 214 "../lib/Widgets/BottomBar.vala"
	_tmp23_ = self->priv->fmenu_image;
#line 214 "../lib/Widgets/BottomBar.vala"
	gtk_menu_button_set_child (_tmp22_, (GtkWidget*) _tmp23_);
#line 216 "../lib/Widgets/BottomBar.vala"
	_tmp24_ = self->priv->fmenu_box;
#line 216 "../lib/Widgets/BottomBar.vala"
	_tmp25_ = self->priv->fmenu_box_l;
#line 216 "../lib/Widgets/BottomBar.vala"
	gtk_box_append (_tmp24_, (GtkWidget*) _tmp25_);
#line 217 "../lib/Widgets/BottomBar.vala"
	_tmp26_ = self->priv->fmenu_box;
#line 217 "../lib/Widgets/BottomBar.vala"
	_tmp27_ = self->priv->fmenu_separator;
#line 217 "../lib/Widgets/BottomBar.vala"
	gtk_box_append (_tmp26_, (GtkWidget*) _tmp27_);
#line 218 "../lib/Widgets/BottomBar.vala"
	_tmp28_ = self->priv->fmenu_box;
#line 218 "../lib/Widgets/BottomBar.vala"
	_tmp29_ = self->priv->fmenu_box_r;
#line 218 "../lib/Widgets/BottomBar.vala"
	gtk_box_append (_tmp28_, (GtkWidget*) _tmp29_);
#line 220 "../lib/Widgets/BottomBar.vala"
	_tmp30_ = self->priv->fmenu;
#line 220 "../lib/Widgets/BottomBar.vala"
	_tmp31_ = self->priv->fmenu_box;
#line 220 "../lib/Widgets/BottomBar.vala"
	gtk_popover_set_child (_tmp30_, (GtkWidget*) _tmp31_);
#line 221 "../lib/Widgets/BottomBar.vala"
	_tmp32_ = self->priv->fold_menu;
#line 221 "../lib/Widgets/BottomBar.vala"
	_tmp33_ = self->priv->fmenu;
#line 221 "../lib/Widgets/BottomBar.vala"
	gtk_menu_button_set_popover (_tmp32_, (GtkWidget*) _tmp33_);
#line 223 "../lib/Widgets/BottomBar.vala"
	_tmp34_ = self->priv->left_fmenu_box;
#line 223 "../lib/Widgets/BottomBar.vala"
	_tmp35_ = self->priv->fold_menu;
#line 223 "../lib/Widgets/BottomBar.vala"
	gtk_box_append (_tmp34_, (GtkWidget*) _tmp35_);
#line 225 "../lib/Widgets/BottomBar.vala"
	_tmp36_ = self->priv->box;
#line 225 "../lib/Widgets/BottomBar.vala"
	gtk_widget_set_parent ((GtkWidget*) _tmp36_, (GtkWidget*) self);
#line 192 "../lib/Widgets/BottomBar.vala"
	return obj;
#line 1338 "BottomBar.c"
}

static void
he_bottom_bar_class_init (HeBottomBarClass * klass,
                          gpointer klass_data)
{
#line 25 "../lib/Widgets/BottomBar.vala"
	he_bottom_bar_parent_class = g_type_class_peek_parent (klass);
#line 25 "../lib/Widgets/BottomBar.vala"
	g_type_class_adjust_private_offset (klass, &HeBottomBar_private_offset);
#line 25 "../lib/Widgets/BottomBar.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_he_bottom_bar_get_property;
#line 25 "../lib/Widgets/BottomBar.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_he_bottom_bar_set_property;
#line 25 "../lib/Widgets/BottomBar.vala"
	G_OBJECT_CLASS (klass)->constructor = he_bottom_bar_constructor;
#line 25 "../lib/Widgets/BottomBar.vala"
	G_OBJECT_CLASS (klass)->finalize = he_bottom_bar_finalize;
#line 1357 "BottomBar.c"
	/**
	   * The title of the bottom bar.
	   */
#line 25 "../lib/Widgets/BottomBar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_BOTTOM_BAR_TITLE_PROPERTY, he_bottom_bar_properties[HE_BOTTOM_BAR_TITLE_PROPERTY] = g_param_spec_string ("title", "title", "title", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1363 "BottomBar.c"
	/**
	   * The description of the bottom bar.
	   */
#line 25 "../lib/Widgets/BottomBar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_BOTTOM_BAR_DESCRIPTION_PROPERTY, he_bottom_bar_properties[HE_BOTTOM_BAR_DESCRIPTION_PROPERTY] = g_param_spec_string ("description", "description", "description", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1369 "BottomBar.c"
	/**
	   * The menu_model of the bottom bar.
	   * If a menu_model is set, show it on the center widget of the bottom bar.
	   */
#line 25 "../lib/Widgets/BottomBar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_BOTTOM_BAR_MENU_MODEL_PROPERTY, he_bottom_bar_properties[HE_BOTTOM_BAR_MENU_MODEL_PROPERTY] = g_param_spec_object ("menu-model", "menu-model", "menu-model", g_menu_model_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1376 "BottomBar.c"
	/**
	   * Whether to collapse actions into a menu.
	   */
#line 25 "../lib/Widgets/BottomBar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_BOTTOM_BAR_COLLAPSE_ACTIONS_PROPERTY, he_bottom_bar_properties[HE_BOTTOM_BAR_COLLAPSE_ACTIONS_PROPERTY] = g_param_spec_boolean ("collapse-actions", "collapse-actions", "collapse-actions", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 189 "../lib/Widgets/BottomBar.vala"
	gtk_widget_class_set_layout_manager_type (GTK_WIDGET_CLASS (klass), gtk_box_layout_get_type ());
#line 1384 "BottomBar.c"
}

static void
he_bottom_bar_gtk_buildable_interface_init (GtkBuildableIface * iface,
                                            gpointer iface_data)
{
#line 25 "../lib/Widgets/BottomBar.vala"
	he_bottom_bar_gtk_buildable_parent_iface = g_type_interface_peek_parent (iface);
#line 25 "../lib/Widgets/BottomBar.vala"
	iface->add_child = (void (*) (GtkBuildable*, GtkBuilder*, GObject*, const gchar*)) he_bottom_bar_real_add_child;
#line 1395 "BottomBar.c"
}

static void
he_bottom_bar_instance_init (HeBottomBar * self,
                             gpointer klass)
{
	GtkBox* _tmp0_;
	GtkBox* _tmp1_;
	GtkBox* _tmp2_;
	GtkBox* _tmp3_;
	GtkBox* _tmp4_;
	GtkBox* _tmp5_;
	GtkLabel* _tmp6_;
	GtkLabel* _tmp7_;
	GtkMenuButton* _tmp8_;
	GtkMenuButton* _tmp9_;
	GtkPopover* _tmp10_;
	GtkBox* _tmp11_;
	GtkBox* _tmp12_;
	GtkBox* _tmp13_;
	GtkSeparator* _tmp14_;
	GtkImage* _tmp15_;
	GeeHashMap* _tmp16_;
#line 25 "../lib/Widgets/BottomBar.vala"
	self->priv = he_bottom_bar_get_instance_private (self);
#line 26 "../lib/Widgets/BottomBar.vala"
	_tmp0_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
#line 26 "../lib/Widgets/BottomBar.vala"
	g_object_ref_sink (_tmp0_);
#line 26 "../lib/Widgets/BottomBar.vala"
	self->priv->box = _tmp0_;
#line 27 "../lib/Widgets/BottomBar.vala"
	_tmp1_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 18);
#line 27 "../lib/Widgets/BottomBar.vala"
	g_object_ref_sink (_tmp1_);
#line 27 "../lib/Widgets/BottomBar.vala"
	self->priv->left_fmenu_box = _tmp1_;
#line 28 "../lib/Widgets/BottomBar.vala"
	_tmp2_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 18);
#line 28 "../lib/Widgets/BottomBar.vala"
	g_object_ref_sink (_tmp2_);
#line 28 "../lib/Widgets/BottomBar.vala"
	self->priv->right_fmenu_box = _tmp2_;
#line 30 "../lib/Widgets/BottomBar.vala"
	_tmp3_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 18);
#line 30 "../lib/Widgets/BottomBar.vala"
	g_object_ref_sink (_tmp3_);
#line 30 "../lib/Widgets/BottomBar.vala"
	self->priv->left_box = _tmp3_;
#line 31 "../lib/Widgets/BottomBar.vala"
	_tmp4_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 31 "../lib/Widgets/BottomBar.vala"
	g_object_ref_sink (_tmp4_);
#line 31 "../lib/Widgets/BottomBar.vala"
	self->priv->center_box = _tmp4_;
#line 32 "../lib/Widgets/BottomBar.vala"
	_tmp5_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 18);
#line 32 "../lib/Widgets/BottomBar.vala"
	g_object_ref_sink (_tmp5_);
#line 32 "../lib/Widgets/BottomBar.vala"
	self->priv->right_box = _tmp5_;
#line 34 "../lib/Widgets/BottomBar.vala"
	_tmp6_ = (GtkLabel*) gtk_label_new ("");
#line 34 "../lib/Widgets/BottomBar.vala"
	g_object_ref_sink (_tmp6_);
#line 34 "../lib/Widgets/BottomBar.vala"
	self->priv->title_label = _tmp6_;
#line 35 "../lib/Widgets/BottomBar.vala"
	_tmp7_ = (GtkLabel*) gtk_label_new ("");
#line 35 "../lib/Widgets/BottomBar.vala"
	g_object_ref_sink (_tmp7_);
#line 35 "../lib/Widgets/BottomBar.vala"
	self->priv->description_label = _tmp7_;
#line 37 "../lib/Widgets/BottomBar.vala"
	_tmp8_ = (GtkMenuButton*) gtk_menu_button_new ();
#line 37 "../lib/Widgets/BottomBar.vala"
	g_object_ref_sink (_tmp8_);
#line 37 "../lib/Widgets/BottomBar.vala"
	self->priv->menu = _tmp8_;
#line 38 "../lib/Widgets/BottomBar.vala"
	_tmp9_ = (GtkMenuButton*) gtk_menu_button_new ();
#line 38 "../lib/Widgets/BottomBar.vala"
	g_object_ref_sink (_tmp9_);
#line 38 "../lib/Widgets/BottomBar.vala"
	self->priv->fold_menu = _tmp9_;
#line 40 "../lib/Widgets/BottomBar.vala"
	_tmp10_ = (GtkPopover*) gtk_popover_new ();
#line 40 "../lib/Widgets/BottomBar.vala"
	g_object_ref_sink (_tmp10_);
#line 40 "../lib/Widgets/BottomBar.vala"
	self->priv->fmenu = _tmp10_;
#line 41 "../lib/Widgets/BottomBar.vala"
	_tmp11_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 6);
#line 41 "../lib/Widgets/BottomBar.vala"
	g_object_ref_sink (_tmp11_);
#line 41 "../lib/Widgets/BottomBar.vala"
	self->priv->fmenu_box = _tmp11_;
#line 42 "../lib/Widgets/BottomBar.vala"
	_tmp12_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 6);
#line 42 "../lib/Widgets/BottomBar.vala"
	g_object_ref_sink (_tmp12_);
#line 42 "../lib/Widgets/BottomBar.vala"
	self->priv->fmenu_box_l = _tmp12_;
#line 43 "../lib/Widgets/BottomBar.vala"
	_tmp13_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 6);
#line 43 "../lib/Widgets/BottomBar.vala"
	g_object_ref_sink (_tmp13_);
#line 43 "../lib/Widgets/BottomBar.vala"
	self->priv->fmenu_box_r = _tmp13_;
#line 44 "../lib/Widgets/BottomBar.vala"
	_tmp14_ = (GtkSeparator*) gtk_separator_new (GTK_ORIENTATION_HORIZONTAL);
#line 44 "../lib/Widgets/BottomBar.vala"
	g_object_ref_sink (_tmp14_);
#line 44 "../lib/Widgets/BottomBar.vala"
	self->priv->fmenu_separator = _tmp14_;
#line 45 "../lib/Widgets/BottomBar.vala"
	_tmp15_ = (GtkImage*) gtk_image_new ();
#line 45 "../lib/Widgets/BottomBar.vala"
	g_object_ref_sink (_tmp15_);
#line 45 "../lib/Widgets/BottomBar.vala"
	self->priv->fmenu_image = _tmp15_;
#line 46 "../lib/Widgets/BottomBar.vala"
	_tmp16_ = gee_hash_map_new (gtk_widget_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, gtk_widget_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 46 "../lib/Widgets/BottomBar.vala"
	self->priv->button_to_mbutton = _tmp16_;
#line 1521 "BottomBar.c"
}

static void
he_bottom_bar_finalize (GObject * obj)
{
	HeBottomBar * self;
#line 25 "../lib/Widgets/BottomBar.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_BOTTOM_BAR, HeBottomBar);
#line 26 "../lib/Widgets/BottomBar.vala"
	_g_object_unref0 (self->priv->box);
#line 27 "../lib/Widgets/BottomBar.vala"
	_g_object_unref0 (self->priv->left_fmenu_box);
#line 28 "../lib/Widgets/BottomBar.vala"
	_g_object_unref0 (self->priv->right_fmenu_box);
#line 30 "../lib/Widgets/BottomBar.vala"
	_g_object_unref0 (self->priv->left_box);
#line 31 "../lib/Widgets/BottomBar.vala"
	_g_object_unref0 (self->priv->center_box);
#line 32 "../lib/Widgets/BottomBar.vala"
	_g_object_unref0 (self->priv->right_box);
#line 34 "../lib/Widgets/BottomBar.vala"
	_g_object_unref0 (self->priv->title_label);
#line 35 "../lib/Widgets/BottomBar.vala"
	_g_object_unref0 (self->priv->description_label);
#line 37 "../lib/Widgets/BottomBar.vala"
	_g_object_unref0 (self->priv->menu);
#line 38 "../lib/Widgets/BottomBar.vala"
	_g_object_unref0 (self->priv->fold_menu);
#line 40 "../lib/Widgets/BottomBar.vala"
	_g_object_unref0 (self->priv->fmenu);
#line 41 "../lib/Widgets/BottomBar.vala"
	_g_object_unref0 (self->priv->fmenu_box);
#line 42 "../lib/Widgets/BottomBar.vala"
	_g_object_unref0 (self->priv->fmenu_box_l);
#line 43 "../lib/Widgets/BottomBar.vala"
	_g_object_unref0 (self->priv->fmenu_box_r);
#line 44 "../lib/Widgets/BottomBar.vala"
	_g_object_unref0 (self->priv->fmenu_separator);
#line 45 "../lib/Widgets/BottomBar.vala"
	_g_object_unref0 (self->priv->fmenu_image);
#line 46 "../lib/Widgets/BottomBar.vala"
	_g_object_unref0 (self->priv->button_to_mbutton);
#line 25 "../lib/Widgets/BottomBar.vala"
	G_OBJECT_CLASS (he_bottom_bar_parent_class)->finalize (obj);
#line 1566 "BottomBar.c"
}

/**
 * A BottomBar is a toolbar made to make actions on content more visible.
 * It may have up to 5 actions on each side.
 * It has title and description labels, which can be part of a menu's label.
 */
static GType
he_bottom_bar_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HeBottomBarClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) he_bottom_bar_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HeBottomBar), 0, (GInstanceInitFunc) he_bottom_bar_instance_init, NULL };
	static const GInterfaceInfo gtk_buildable_info = { (GInterfaceInitFunc) he_bottom_bar_gtk_buildable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType he_bottom_bar_type_id;
	he_bottom_bar_type_id = g_type_register_static (HE_TYPE_BIN, "HeBottomBar", &g_define_type_info, 0);
	g_type_add_interface_static (he_bottom_bar_type_id, gtk_buildable_get_type (), &gtk_buildable_info);
	HeBottomBar_private_offset = g_type_add_instance_private (he_bottom_bar_type_id, sizeof (HeBottomBarPrivate));
	return he_bottom_bar_type_id;
}

GType
he_bottom_bar_get_type (void)
{
	static volatile gsize he_bottom_bar_type_id__once = 0;
	if (g_once_init_enter (&he_bottom_bar_type_id__once)) {
		GType he_bottom_bar_type_id;
		he_bottom_bar_type_id = he_bottom_bar_get_type_once ();
		g_once_init_leave (&he_bottom_bar_type_id__once, he_bottom_bar_type_id);
	}
	return he_bottom_bar_type_id__once;
}

static void
_vala_he_bottom_bar_get_property (GObject * object,
                                  guint property_id,
                                  GValue * value,
                                  GParamSpec * pspec)
{
	HeBottomBar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_BOTTOM_BAR, HeBottomBar);
#line 25 "../lib/Widgets/BottomBar.vala"
	switch (property_id) {
#line 25 "../lib/Widgets/BottomBar.vala"
		case HE_BOTTOM_BAR_TITLE_PROPERTY:
#line 25 "../lib/Widgets/BottomBar.vala"
		g_value_set_string (value, he_bottom_bar_get_title (self));
#line 25 "../lib/Widgets/BottomBar.vala"
		break;
#line 25 "../lib/Widgets/BottomBar.vala"
		case HE_BOTTOM_BAR_DESCRIPTION_PROPERTY:
#line 25 "../lib/Widgets/BottomBar.vala"
		g_value_set_string (value, he_bottom_bar_get_description (self));
#line 25 "../lib/Widgets/BottomBar.vala"
		break;
#line 25 "../lib/Widgets/BottomBar.vala"
		case HE_BOTTOM_BAR_MENU_MODEL_PROPERTY:
#line 25 "../lib/Widgets/BottomBar.vala"
		g_value_set_object (value, he_bottom_bar_get_menu_model (self));
#line 25 "../lib/Widgets/BottomBar.vala"
		break;
#line 25 "../lib/Widgets/BottomBar.vala"
		case HE_BOTTOM_BAR_COLLAPSE_ACTIONS_PROPERTY:
#line 25 "../lib/Widgets/BottomBar.vala"
		g_value_set_boolean (value, he_bottom_bar_get_collapse_actions (self));
#line 25 "../lib/Widgets/BottomBar.vala"
		break;
#line 1632 "BottomBar.c"
		default:
#line 25 "../lib/Widgets/BottomBar.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 25 "../lib/Widgets/BottomBar.vala"
		break;
#line 1638 "BottomBar.c"
	}
}

static void
_vala_he_bottom_bar_set_property (GObject * object,
                                  guint property_id,
                                  const GValue * value,
                                  GParamSpec * pspec)
{
	HeBottomBar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_BOTTOM_BAR, HeBottomBar);
#line 25 "../lib/Widgets/BottomBar.vala"
	switch (property_id) {
#line 25 "../lib/Widgets/BottomBar.vala"
		case HE_BOTTOM_BAR_TITLE_PROPERTY:
#line 25 "../lib/Widgets/BottomBar.vala"
		he_bottom_bar_set_title (self, g_value_get_string (value));
#line 25 "../lib/Widgets/BottomBar.vala"
		break;
#line 25 "../lib/Widgets/BottomBar.vala"
		case HE_BOTTOM_BAR_DESCRIPTION_PROPERTY:
#line 25 "../lib/Widgets/BottomBar.vala"
		he_bottom_bar_set_description (self, g_value_get_string (value));
#line 25 "../lib/Widgets/BottomBar.vala"
		break;
#line 25 "../lib/Widgets/BottomBar.vala"
		case HE_BOTTOM_BAR_MENU_MODEL_PROPERTY:
#line 25 "../lib/Widgets/BottomBar.vala"
		he_bottom_bar_set_menu_model (self, g_value_get_object (value));
#line 25 "../lib/Widgets/BottomBar.vala"
		break;
#line 25 "../lib/Widgets/BottomBar.vala"
		case HE_BOTTOM_BAR_COLLAPSE_ACTIONS_PROPERTY:
#line 25 "../lib/Widgets/BottomBar.vala"
		he_bottom_bar_set_collapse_actions (self, g_value_get_boolean (value));
#line 25 "../lib/Widgets/BottomBar.vala"
		break;
#line 1676 "BottomBar.c"
		default:
#line 25 "../lib/Widgets/BottomBar.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 25 "../lib/Widgets/BottomBar.vala"
		break;
#line 1682 "BottomBar.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

