/* BottomSheet.c generated by valac 0.56.18, the Vala compiler
 * generated from BottomSheet.vala, do not modify */

/*
 * Copyright (c) 2024 Fyra Labs
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 */

#include "libhelium-1.h"
#include <gtk/gtk.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>
#include <gdk/gdk.h>
#include <gsk/gsk.h>
#include <graphene-gobject.h>

#define HE_BOTTOM_SHEET_TOP_MARGIN 42
#define HE_BOTTOM_SHEET_MINIMUM_HEIGHT 300
#define HE_BOTTOM_SHEET_DEFAULT_HEIGHT 440
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	HE_BOTTOM_SHEET_0_PROPERTY,
	HE_BOTTOM_SHEET_SHEET_PROPERTY,
	HE_BOTTOM_SHEET_SHEET_STACK_PROPERTY,
	HE_BOTTOM_SHEET_BUTTON_PROPERTY,
	HE_BOTTOM_SHEET_TITLE_PROPERTY,
	HE_BOTTOM_SHEET_SHOW_SHEET_PROPERTY,
	HE_BOTTOM_SHEET_MODAL_PROPERTY,
	HE_BOTTOM_SHEET_SHOW_HANDLE_PROPERTY,
	HE_BOTTOM_SHEET_PREFERRED_SHEET_HEIGHT_PROPERTY,
	HE_BOTTOM_SHEET_NUM_PROPERTIES
};
static GParamSpec* he_bottom_sheet_properties[HE_BOTTOM_SHEET_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_source_unref0(var) ((var == NULL) ? NULL : (var = (g_source_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _gsk_transform_unref0(var) ((var == NULL) ? NULL : (var = (gsk_transform_unref (var), NULL)))
typedef struct _HeCallbackAnimationTarget HeCallbackAnimationTarget;
typedef struct _HeCallbackAnimationTargetClass HeCallbackAnimationTargetClass;
enum  {
	HE_BOTTOM_SHEET_HIDDEN_SIGNAL,
	HE_BOTTOM_SHEET_NUM_SIGNALS
};
static guint he_bottom_sheet_signals[HE_BOTTOM_SHEET_NUM_SIGNALS] = {0};

struct _HeBottomSheetPrivate {
	GtkWidget* dimming;
	GtkWidget* handle;
	GtkBox* sheet_bin;
	GtkLabel* title_label;
	HeSpringAnimation* show_animation;
	GtkWindowHandle* handle_wh;
	GSource* resize_timeout;
	gboolean dragging;
	gdouble initial_y;
	gint initial_height;
	gint target_height;
	gint update_interval;
	GtkWidget* _sheet;
	GtkStack* _sheet_stack;
	GtkWidget* _button;
	gchar* _title;
	gboolean _show_sheet;
	gboolean _modal;
	gboolean _show_handle;
	gint _preferred_sheet_height;
};

static gint HeBottomSheet_private_offset;
static gpointer he_bottom_sheet_parent_class = NULL;

static void he_bottom_sheet_close_sheet (HeBottomSheet* self);
static void he_bottom_sheet_update_refresh_rate (HeBottomSheet* self);
static void he_bottom_sheet_on_drag_begin (HeBottomSheet* self,
                                    GtkGestureDrag* gesture,
                                    gdouble x,
                                    gdouble y);
static void he_bottom_sheet_on_drag_update (HeBottomSheet* self,
                                     GtkGestureDrag* gesture,
                                     gdouble offset_x,
                                     gdouble offset_y);
static gboolean ____lambda127_ (HeBottomSheet* self);
static gboolean _____lambda127__gsource_func (gpointer self);
static void he_bottom_sheet_on_drag_end (HeBottomSheet* self,
                                  GtkGestureDrag* gesture,
                                  gdouble offset_x,
                                  gdouble offset_y);
static void he_bottom_sheet_real_dispose (GObject* base);
static gboolean he_bottom_sheet_real_contains (GtkWidget* base,
                                        gdouble x,
                                        gdouble y);
static void he_bottom_sheet_real_measure (GtkWidget* base,
                                   GtkOrientation orientation,
                                   gint for_size,
                                   gint* min,
                                   gint* nat,
                                   gint* min_baseline,
                                   gint* nat_baseline);
static void he_bottom_sheet_real_size_allocate (GtkWidget* base,
                                         gint width,
                                         gint height,
                                         gint baseline);
static GObject * he_bottom_sheet_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties);
static void _he_bottom_sheet_on_drag_begin_gtk_gesture_drag_drag_begin (GtkGestureDrag* _sender,
                                                                 gdouble start_x,
                                                                 gdouble start_y,
                                                                 gpointer self);
static void _he_bottom_sheet_on_drag_update_gtk_gesture_drag_drag_update (GtkGestureDrag* _sender,
                                                                   gdouble offset_x,
                                                                   gdouble offset_y,
                                                                   gpointer self);
static void _he_bottom_sheet_on_drag_end_gtk_gesture_drag_drag_end (GtkGestureDrag* _sender,
                                                             gdouble offset_x,
                                                             gdouble offset_y,
                                                             gpointer self);
static void _he_bottom_sheet___lambda128_ (HeBottomSheet* self);
static void __he_bottom_sheet___lambda128__gtk_button_clicked (GtkButton* _sender,
                                                        gpointer self);
static void _he_bottom_sheet_close_sheet_gtk_gesture_end (GtkGesture* _sender,
                                                   GdkEventSequence* sequence,
                                                   gpointer self);
static void _he_bottom_sheet___lambda129_ (HeBottomSheet* self,
                                    gdouble value);
static void __he_bottom_sheet___lambda129__he_animation_target_func (gdouble value,
                                                              gpointer self);
static void _he_bottom_sheet___lambda130_ (HeBottomSheet* self);
static void __he_bottom_sheet___lambda130__he_animation_done (HeAnimation* _sender,
                                                       gpointer self);
static void he_bottom_sheet_finalize (GObject * obj);
static GType he_bottom_sheet_get_type_once (void);
static void _vala_he_bottom_sheet_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec);
static void _vala_he_bottom_sheet_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
he_bottom_sheet_get_instance_private (HeBottomSheet* self)
{
	return G_STRUCT_MEMBER_P (self, HeBottomSheet_private_offset);
}

GtkWidget*
he_bottom_sheet_get_sheet (HeBottomSheet* self)
{
	GtkWidget* result;
	GtkWidget* _tmp0_;
#line 59 "../lib/Widgets/BottomSheet.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 59 "../lib/Widgets/BottomSheet.vala"
	_tmp0_ = self->priv->_sheet;
#line 59 "../lib/Widgets/BottomSheet.vala"
	result = _tmp0_;
#line 59 "../lib/Widgets/BottomSheet.vala"
	return result;
#line 190 "BottomSheet.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 64 "../lib/Widgets/BottomSheet.vala"
	return self ? g_object_ref (self) : NULL;
#line 198 "BottomSheet.c"
}

void
he_bottom_sheet_set_sheet (HeBottomSheet* self,
                           GtkWidget* value)
{
	GtkWidget* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
	GtkWidget* _tmp3_;
	GtkWidget* _tmp4_;
	GtkBox* _tmp5_;
	GtkWidget* _tmp6_;
	GtkWidget* _tmp7_;
#line 60 "../lib/Widgets/BottomSheet.vala"
	g_return_if_fail (self != NULL);
#line 61 "../lib/Widgets/BottomSheet.vala"
	_tmp0_ = he_bottom_sheet_get_sheet (self);
#line 61 "../lib/Widgets/BottomSheet.vala"
	_tmp1_ = _tmp0_;
#line 61 "../lib/Widgets/BottomSheet.vala"
	if (_tmp1_ == value) {
#line 62 "../lib/Widgets/BottomSheet.vala"
		return;
#line 223 "BottomSheet.c"
	}
#line 64 "../lib/Widgets/BottomSheet.vala"
	_tmp2_ = _g_object_ref0 (value);
#line 64 "../lib/Widgets/BottomSheet.vala"
	_g_object_unref0 (self->priv->_sheet);
#line 64 "../lib/Widgets/BottomSheet.vala"
	self->priv->_sheet = _tmp2_;
#line 66 "../lib/Widgets/BottomSheet.vala"
	_tmp3_ = he_bottom_sheet_get_sheet (self);
#line 66 "../lib/Widgets/BottomSheet.vala"
	_tmp4_ = _tmp3_;
#line 66 "../lib/Widgets/BottomSheet.vala"
	gtk_widget_unparent (_tmp4_);
#line 67 "../lib/Widgets/BottomSheet.vala"
	_tmp5_ = self->priv->sheet_bin;
#line 67 "../lib/Widgets/BottomSheet.vala"
	_tmp6_ = he_bottom_sheet_get_sheet (self);
#line 67 "../lib/Widgets/BottomSheet.vala"
	_tmp7_ = _tmp6_;
#line 67 "../lib/Widgets/BottomSheet.vala"
	gtk_box_append (_tmp5_, _tmp7_);
#line 60 "../lib/Widgets/BottomSheet.vala"
	g_object_notify_by_pspec ((GObject *) self, he_bottom_sheet_properties[HE_BOTTOM_SHEET_SHEET_PROPERTY]);
#line 247 "BottomSheet.c"
}

GtkStack*
he_bottom_sheet_get_sheet_stack (HeBottomSheet* self)
{
	GtkStack* result;
	GtkStack* _tmp0_;
#line 76 "../lib/Widgets/BottomSheet.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 76 "../lib/Widgets/BottomSheet.vala"
	_tmp0_ = self->priv->_sheet_stack;
#line 76 "../lib/Widgets/BottomSheet.vala"
	result = _tmp0_;
#line 76 "../lib/Widgets/BottomSheet.vala"
	return result;
#line 263 "BottomSheet.c"
}

void
he_bottom_sheet_set_sheet_stack (HeBottomSheet* self,
                                 GtkStack* value)
{
	GtkStack* _tmp0_;
	GtkStack* _tmp1_;
	GtkStack* _tmp2_;
	GtkStack* _tmp3_;
	GtkStack* _tmp4_;
	GtkBox* _tmp5_;
	GtkStack* _tmp6_;
	GtkStack* _tmp7_;
#line 77 "../lib/Widgets/BottomSheet.vala"
	g_return_if_fail (self != NULL);
#line 78 "../lib/Widgets/BottomSheet.vala"
	_tmp0_ = he_bottom_sheet_get_sheet_stack (self);
#line 78 "../lib/Widgets/BottomSheet.vala"
	_tmp1_ = _tmp0_;
#line 78 "../lib/Widgets/BottomSheet.vala"
	if (_tmp1_ == value) {
#line 79 "../lib/Widgets/BottomSheet.vala"
		return;
#line 288 "BottomSheet.c"
	}
#line 81 "../lib/Widgets/BottomSheet.vala"
	_tmp2_ = _g_object_ref0 (value);
#line 81 "../lib/Widgets/BottomSheet.vala"
	_g_object_unref0 (self->priv->_sheet_stack);
#line 81 "../lib/Widgets/BottomSheet.vala"
	self->priv->_sheet_stack = _tmp2_;
#line 83 "../lib/Widgets/BottomSheet.vala"
	_tmp3_ = he_bottom_sheet_get_sheet_stack (self);
#line 83 "../lib/Widgets/BottomSheet.vala"
	_tmp4_ = _tmp3_;
#line 83 "../lib/Widgets/BottomSheet.vala"
	gtk_widget_unparent ((GtkWidget*) _tmp4_);
#line 84 "../lib/Widgets/BottomSheet.vala"
	_tmp5_ = self->priv->sheet_bin;
#line 84 "../lib/Widgets/BottomSheet.vala"
	_tmp6_ = he_bottom_sheet_get_sheet_stack (self);
#line 84 "../lib/Widgets/BottomSheet.vala"
	_tmp7_ = _tmp6_;
#line 84 "../lib/Widgets/BottomSheet.vala"
	gtk_box_append (_tmp5_, (GtkWidget*) _tmp7_);
#line 85 "../lib/Widgets/BottomSheet.vala"
	if (value != NULL) {
#line 312 "BottomSheet.c"
		HeButton* _tmp8_;
#line 86 "../lib/Widgets/BottomSheet.vala"
		_tmp8_ = self->back_button;
#line 86 "../lib/Widgets/BottomSheet.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp8_, TRUE);
#line 318 "BottomSheet.c"
	} else {
		HeButton* _tmp9_;
#line 88 "../lib/Widgets/BottomSheet.vala"
		_tmp9_ = self->back_button;
#line 88 "../lib/Widgets/BottomSheet.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp9_, FALSE);
#line 325 "BottomSheet.c"
	}
#line 77 "../lib/Widgets/BottomSheet.vala"
	g_object_notify_by_pspec ((GObject *) self, he_bottom_sheet_properties[HE_BOTTOM_SHEET_SHEET_STACK_PROPERTY]);
#line 329 "BottomSheet.c"
}

GtkWidget*
he_bottom_sheet_get_button (HeBottomSheet* self)
{
	GtkWidget* result;
	GtkWidget* _tmp0_;
#line 98 "../lib/Widgets/BottomSheet.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 98 "../lib/Widgets/BottomSheet.vala"
	_tmp0_ = self->priv->_button;
#line 98 "../lib/Widgets/BottomSheet.vala"
	result = _tmp0_;
#line 98 "../lib/Widgets/BottomSheet.vala"
	return result;
#line 345 "BottomSheet.c"
}

void
he_bottom_sheet_set_button (HeBottomSheet* self,
                            GtkWidget* value)
{
	GtkWidget* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
	GtkWidget* _tmp3_;
	GtkWidget* _tmp4_;
	GtkBox* _tmp5_;
	GtkWidget* _tmp6_;
	GtkWidget* _tmp7_;
#line 99 "../lib/Widgets/BottomSheet.vala"
	g_return_if_fail (self != NULL);
#line 100 "../lib/Widgets/BottomSheet.vala"
	_tmp0_ = he_bottom_sheet_get_button (self);
#line 100 "../lib/Widgets/BottomSheet.vala"
	_tmp1_ = _tmp0_;
#line 100 "../lib/Widgets/BottomSheet.vala"
	if (_tmp1_ == value) {
#line 101 "../lib/Widgets/BottomSheet.vala"
		return;
#line 370 "BottomSheet.c"
	}
#line 103 "../lib/Widgets/BottomSheet.vala"
	_tmp2_ = _g_object_ref0 (value);
#line 103 "../lib/Widgets/BottomSheet.vala"
	_g_object_unref0 (self->priv->_button);
#line 103 "../lib/Widgets/BottomSheet.vala"
	self->priv->_button = _tmp2_;
#line 105 "../lib/Widgets/BottomSheet.vala"
	_tmp3_ = he_bottom_sheet_get_button (self);
#line 105 "../lib/Widgets/BottomSheet.vala"
	_tmp4_ = _tmp3_;
#line 105 "../lib/Widgets/BottomSheet.vala"
	gtk_widget_unparent (_tmp4_);
#line 106 "../lib/Widgets/BottomSheet.vala"
	_tmp5_ = self->priv->sheet_bin;
#line 106 "../lib/Widgets/BottomSheet.vala"
	_tmp6_ = he_bottom_sheet_get_button (self);
#line 106 "../lib/Widgets/BottomSheet.vala"
	_tmp7_ = _tmp6_;
#line 106 "../lib/Widgets/BottomSheet.vala"
	gtk_box_append (_tmp5_, _tmp7_);
#line 99 "../lib/Widgets/BottomSheet.vala"
	g_object_notify_by_pspec ((GObject *) self, he_bottom_sheet_properties[HE_BOTTOM_SHEET_BUTTON_PROPERTY]);
#line 394 "BottomSheet.c"
}

const gchar*
he_bottom_sheet_get_title (HeBottomSheet* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 115 "../lib/Widgets/BottomSheet.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 115 "../lib/Widgets/BottomSheet.vala"
	_tmp0_ = self->priv->_title;
#line 115 "../lib/Widgets/BottomSheet.vala"
	result = _tmp0_;
#line 115 "../lib/Widgets/BottomSheet.vala"
	return result;
#line 410 "BottomSheet.c"
}

void
he_bottom_sheet_set_title (HeBottomSheet* self,
                           const gchar* value)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	GtkLabel* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
#line 116 "../lib/Widgets/BottomSheet.vala"
	g_return_if_fail (self != NULL);
#line 117 "../lib/Widgets/BottomSheet.vala"
	_tmp0_ = he_bottom_sheet_get_title (self);
#line 117 "../lib/Widgets/BottomSheet.vala"
	_tmp1_ = _tmp0_;
#line 117 "../lib/Widgets/BottomSheet.vala"
	if (g_strcmp0 (_tmp1_, value) == 0) {
#line 118 "../lib/Widgets/BottomSheet.vala"
		return;
#line 433 "BottomSheet.c"
	}
#line 120 "../lib/Widgets/BottomSheet.vala"
	_tmp2_ = g_strdup (value);
#line 120 "../lib/Widgets/BottomSheet.vala"
	_g_free0 (self->priv->_title);
#line 120 "../lib/Widgets/BottomSheet.vala"
	self->priv->_title = _tmp2_;
#line 122 "../lib/Widgets/BottomSheet.vala"
	_tmp3_ = self->priv->title_label;
#line 122 "../lib/Widgets/BottomSheet.vala"
	_tmp4_ = he_bottom_sheet_get_title (self);
#line 122 "../lib/Widgets/BottomSheet.vala"
	_tmp5_ = _tmp4_;
#line 122 "../lib/Widgets/BottomSheet.vala"
	gtk_label_set_label (_tmp3_, _tmp5_);
#line 116 "../lib/Widgets/BottomSheet.vala"
	g_object_notify_by_pspec ((GObject *) self, he_bottom_sheet_properties[HE_BOTTOM_SHEET_TITLE_PROPERTY]);
#line 451 "BottomSheet.c"
}

gboolean
he_bottom_sheet_get_show_sheet (HeBottomSheet* self)
{
	gboolean result;
#line 131 "../lib/Widgets/BottomSheet.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 131 "../lib/Widgets/BottomSheet.vala"
	result = self->priv->_show_sheet;
#line 131 "../lib/Widgets/BottomSheet.vala"
	return result;
#line 464 "BottomSheet.c"
}

void
he_bottom_sheet_set_show_sheet (HeBottomSheet* self,
                                gboolean value)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	HeSpringAnimation* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	HeSpringAnimation* _tmp5_;
	HeSpringAnimation* _tmp6_;
	gdouble _tmp7_;
	gdouble _tmp8_;
	gint _tmp9_ = 0;
	gboolean _tmp10_;
	gboolean _tmp11_;
	HeSpringAnimation* _tmp12_;
	HeSpringAnimation* _tmp13_;
#line 132 "../lib/Widgets/BottomSheet.vala"
	g_return_if_fail (self != NULL);
#line 133 "../lib/Widgets/BottomSheet.vala"
	_tmp0_ = he_bottom_sheet_get_show_sheet (self);
#line 133 "../lib/Widgets/BottomSheet.vala"
	_tmp1_ = _tmp0_;
#line 133 "../lib/Widgets/BottomSheet.vala"
	if (_tmp1_ == value) {
#line 134 "../lib/Widgets/BottomSheet.vala"
		return;
#line 495 "BottomSheet.c"
	}
#line 136 "../lib/Widgets/BottomSheet.vala"
	self->priv->_show_sheet = value;
#line 138 "../lib/Widgets/BottomSheet.vala"
	_tmp2_ = self->priv->show_animation;
#line 138 "../lib/Widgets/BottomSheet.vala"
	_tmp3_ = he_bottom_sheet_get_show_sheet (self);
#line 138 "../lib/Widgets/BottomSheet.vala"
	_tmp4_ = _tmp3_;
#line 138 "../lib/Widgets/BottomSheet.vala"
	he_spring_animation_set_latch (_tmp2_, !_tmp4_);
#line 139 "../lib/Widgets/BottomSheet.vala"
	_tmp5_ = self->priv->show_animation;
#line 139 "../lib/Widgets/BottomSheet.vala"
	_tmp6_ = self->priv->show_animation;
#line 139 "../lib/Widgets/BottomSheet.vala"
	_tmp7_ = he_animation_get_avalue ((HeAnimation*) _tmp6_);
#line 139 "../lib/Widgets/BottomSheet.vala"
	_tmp8_ = _tmp7_;
#line 139 "../lib/Widgets/BottomSheet.vala"
	he_spring_animation_set_value_from (_tmp5_, _tmp8_);
#line 140 "../lib/Widgets/BottomSheet.vala"
	_tmp10_ = he_bottom_sheet_get_show_sheet (self);
#line 140 "../lib/Widgets/BottomSheet.vala"
	_tmp11_ = _tmp10_;
#line 140 "../lib/Widgets/BottomSheet.vala"
	if (_tmp11_) {
#line 140 "../lib/Widgets/BottomSheet.vala"
		_tmp9_ = 1;
#line 525 "BottomSheet.c"
	} else {
#line 140 "../lib/Widgets/BottomSheet.vala"
		_tmp9_ = 0;
#line 529 "BottomSheet.c"
	}
#line 140 "../lib/Widgets/BottomSheet.vala"
	_tmp12_ = self->priv->show_animation;
#line 140 "../lib/Widgets/BottomSheet.vala"
	he_spring_animation_set_value_to (_tmp12_, (gdouble) _tmp9_);
#line 141 "../lib/Widgets/BottomSheet.vala"
	_tmp13_ = self->priv->show_animation;
#line 141 "../lib/Widgets/BottomSheet.vala"
	he_animation_play ((HeAnimation*) _tmp13_);
#line 132 "../lib/Widgets/BottomSheet.vala"
	g_object_notify_by_pspec ((GObject *) self, he_bottom_sheet_properties[HE_BOTTOM_SHEET_SHOW_SHEET_PROPERTY]);
#line 541 "BottomSheet.c"
}

gboolean
he_bottom_sheet_get_modal (HeBottomSheet* self)
{
	gboolean result;
#line 150 "../lib/Widgets/BottomSheet.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 150 "../lib/Widgets/BottomSheet.vala"
	result = self->priv->_modal;
#line 150 "../lib/Widgets/BottomSheet.vala"
	return result;
#line 554 "BottomSheet.c"
}

void
he_bottom_sheet_set_modal (HeBottomSheet* self,
                           gboolean value)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 151 "../lib/Widgets/BottomSheet.vala"
	g_return_if_fail (self != NULL);
#line 152 "../lib/Widgets/BottomSheet.vala"
	_tmp0_ = he_bottom_sheet_get_modal (self);
#line 152 "../lib/Widgets/BottomSheet.vala"
	_tmp1_ = _tmp0_;
#line 152 "../lib/Widgets/BottomSheet.vala"
	if (_tmp1_ == value) {
#line 153 "../lib/Widgets/BottomSheet.vala"
		return;
#line 573 "BottomSheet.c"
	}
#line 155 "../lib/Widgets/BottomSheet.vala"
	self->priv->_modal = value;
#line 157 "../lib/Widgets/BottomSheet.vala"
	if (value) {
#line 579 "BottomSheet.c"
		GtkWidget* _tmp2_;
#line 158 "../lib/Widgets/BottomSheet.vala"
		_tmp2_ = self->priv->dimming;
#line 158 "../lib/Widgets/BottomSheet.vala"
		gtk_widget_add_css_class (_tmp2_, "dimming");
#line 585 "BottomSheet.c"
	} else {
		GtkWidget* _tmp3_;
#line 160 "../lib/Widgets/BottomSheet.vala"
		_tmp3_ = self->priv->dimming;
#line 160 "../lib/Widgets/BottomSheet.vala"
		gtk_widget_remove_css_class (_tmp3_, "dimming");
#line 592 "BottomSheet.c"
	}
#line 151 "../lib/Widgets/BottomSheet.vala"
	g_object_notify_by_pspec ((GObject *) self, he_bottom_sheet_properties[HE_BOTTOM_SHEET_MODAL_PROPERTY]);
#line 596 "BottomSheet.c"
}

gboolean
he_bottom_sheet_get_show_handle (HeBottomSheet* self)
{
	gboolean result;
#line 171 "../lib/Widgets/BottomSheet.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 171 "../lib/Widgets/BottomSheet.vala"
	result = self->priv->_show_handle;
#line 171 "../lib/Widgets/BottomSheet.vala"
	return result;
#line 609 "BottomSheet.c"
}

void
he_bottom_sheet_set_show_handle (HeBottomSheet* self,
                                 gboolean value)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	GtkWidget* _tmp2_;
#line 172 "../lib/Widgets/BottomSheet.vala"
	g_return_if_fail (self != NULL);
#line 173 "../lib/Widgets/BottomSheet.vala"
	_tmp0_ = he_bottom_sheet_get_show_handle (self);
#line 173 "../lib/Widgets/BottomSheet.vala"
	_tmp1_ = _tmp0_;
#line 173 "../lib/Widgets/BottomSheet.vala"
	if (_tmp1_ == value) {
#line 174 "../lib/Widgets/BottomSheet.vala"
		return;
#line 629 "BottomSheet.c"
	}
#line 176 "../lib/Widgets/BottomSheet.vala"
	self->priv->_show_handle = value;
#line 177 "../lib/Widgets/BottomSheet.vala"
	_tmp2_ = self->priv->handle;
#line 177 "../lib/Widgets/BottomSheet.vala"
	gtk_widget_set_visible (_tmp2_, value);
#line 179 "../lib/Widgets/BottomSheet.vala"
	if (value) {
#line 639 "BottomSheet.c"
		GtkWindowHandle* _tmp3_;
#line 180 "../lib/Widgets/BottomSheet.vala"
		_tmp3_ = self->priv->handle_wh;
#line 180 "../lib/Widgets/BottomSheet.vala"
		gtk_widget_set_margin_top ((GtkWidget*) _tmp3_, 0);
#line 645 "BottomSheet.c"
	} else {
		GtkWindowHandle* _tmp4_;
#line 182 "../lib/Widgets/BottomSheet.vala"
		_tmp4_ = self->priv->handle_wh;
#line 182 "../lib/Widgets/BottomSheet.vala"
		gtk_widget_set_margin_top ((GtkWidget*) _tmp4_, 24);
#line 652 "BottomSheet.c"
	}
#line 172 "../lib/Widgets/BottomSheet.vala"
	g_object_notify_by_pspec ((GObject *) self, he_bottom_sheet_properties[HE_BOTTOM_SHEET_SHOW_HANDLE_PROPERTY]);
#line 656 "BottomSheet.c"
}

gint
he_bottom_sheet_get_preferred_sheet_height (HeBottomSheet* self)
{
	gint result;
#line 193 "../lib/Widgets/BottomSheet.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 193 "../lib/Widgets/BottomSheet.vala"
	result = self->priv->_preferred_sheet_height;
#line 193 "../lib/Widgets/BottomSheet.vala"
	return result;
#line 669 "BottomSheet.c"
}

void
he_bottom_sheet_set_preferred_sheet_height (HeBottomSheet* self,
                                            gint value)
{
	gint _tmp0_;
	gint _tmp1_;
	HeSpringAnimation* _tmp2_;
	gdouble _tmp3_;
	gdouble _tmp4_;
#line 194 "../lib/Widgets/BottomSheet.vala"
	g_return_if_fail (self != NULL);
#line 195 "../lib/Widgets/BottomSheet.vala"
	_tmp0_ = he_bottom_sheet_get_preferred_sheet_height (self);
#line 195 "../lib/Widgets/BottomSheet.vala"
	_tmp1_ = _tmp0_;
#line 195 "../lib/Widgets/BottomSheet.vala"
	if (_tmp1_ == value) {
#line 196 "../lib/Widgets/BottomSheet.vala"
		return;
#line 691 "BottomSheet.c"
	}
#line 198 "../lib/Widgets/BottomSheet.vala"
	self->priv->_preferred_sheet_height = value;
#line 201 "../lib/Widgets/BottomSheet.vala"
	_tmp2_ = self->priv->show_animation;
#line 201 "../lib/Widgets/BottomSheet.vala"
	_tmp3_ = he_animation_get_avalue ((HeAnimation*) _tmp2_);
#line 201 "../lib/Widgets/BottomSheet.vala"
	_tmp4_ = _tmp3_;
#line 201 "../lib/Widgets/BottomSheet.vala"
	if (_tmp4_ > ((gdouble) 0)) {
#line 202 "../lib/Widgets/BottomSheet.vala"
		gtk_widget_queue_allocate ((GtkWidget*) self);
#line 705 "BottomSheet.c"
	}
#line 194 "../lib/Widgets/BottomSheet.vala"
	g_object_notify_by_pspec ((GObject *) self, he_bottom_sheet_properties[HE_BOTTOM_SHEET_PREFERRED_SHEET_HEIGHT_PROPERTY]);
#line 709 "BottomSheet.c"
}

static void
he_bottom_sheet_close_sheet (HeBottomSheet* self)
{
#line 293 "../lib/Widgets/BottomSheet.vala"
	g_return_if_fail (self != NULL);
#line 294 "../lib/Widgets/BottomSheet.vala"
	he_bottom_sheet_set_show_sheet (self, FALSE);
#line 719 "BottomSheet.c"
}

static void
he_bottom_sheet_update_refresh_rate (HeBottomSheet* self)
{
	GdkMonitor* monitor = NULL;
	GdkDisplay* _tmp0_;
	GtkNative* _tmp1_;
	GdkSurface* _tmp2_;
	GdkMonitor* _tmp3_;
	GdkMonitor* _tmp4_;
	GdkMonitor* _tmp5_;
#line 297 "../lib/Widgets/BottomSheet.vala"
	g_return_if_fail (self != NULL);
#line 298 "../lib/Widgets/BottomSheet.vala"
	_tmp0_ = gtk_widget_get_display ((GtkWidget*) self);
#line 298 "../lib/Widgets/BottomSheet.vala"
	_tmp1_ = gtk_widget_get_native ((GtkWidget*) self);
#line 298 "../lib/Widgets/BottomSheet.vala"
	_tmp2_ = gtk_native_get_surface (_tmp1_);
#line 298 "../lib/Widgets/BottomSheet.vala"
	_tmp3_ = gdk_display_get_monitor_at_surface (_tmp0_, _tmp2_);
#line 298 "../lib/Widgets/BottomSheet.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 298 "../lib/Widgets/BottomSheet.vala"
	monitor = _tmp4_;
#line 299 "../lib/Widgets/BottomSheet.vala"
	_tmp5_ = monitor;
#line 299 "../lib/Widgets/BottomSheet.vala"
	if (_tmp5_ != NULL) {
#line 750 "BottomSheet.c"
		gint refresh_rate = 0;
		GdkMonitor* _tmp6_;
#line 300 "../lib/Widgets/BottomSheet.vala"
		_tmp6_ = monitor;
#line 300 "../lib/Widgets/BottomSheet.vala"
		refresh_rate = gdk_monitor_get_refresh_rate (_tmp6_);
#line 301 "../lib/Widgets/BottomSheet.vala"
		if (refresh_rate > 0) {
#line 302 "../lib/Widgets/BottomSheet.vala"
			self->priv->update_interval = (gint) (1000 / (refresh_rate / 1000));
#line 761 "BottomSheet.c"
		}
	}
#line 297 "../lib/Widgets/BottomSheet.vala"
	_g_object_unref0 (monitor);
#line 766 "BottomSheet.c"
}

static void
he_bottom_sheet_on_drag_begin (HeBottomSheet* self,
                               GtkGestureDrag* gesture,
                               gdouble x,
                               gdouble y)
{
	gint _tmp0_;
	gint _tmp1_;
#line 307 "../lib/Widgets/BottomSheet.vala"
	g_return_if_fail (self != NULL);
#line 307 "../lib/Widgets/BottomSheet.vala"
	g_return_if_fail (gesture != NULL);
#line 308 "../lib/Widgets/BottomSheet.vala"
	self->priv->dragging = TRUE;
#line 309 "../lib/Widgets/BottomSheet.vala"
	self->priv->initial_y = y;
#line 310 "../lib/Widgets/BottomSheet.vala"
	_tmp0_ = he_bottom_sheet_get_preferred_sheet_height (self);
#line 310 "../lib/Widgets/BottomSheet.vala"
	_tmp1_ = _tmp0_;
#line 310 "../lib/Widgets/BottomSheet.vala"
	self->priv->initial_height = _tmp1_;
#line 791 "BottomSheet.c"
}

static gboolean
____lambda127_ (HeBottomSheet* self)
{
	gint _tmp0_;
	gint _tmp1_;
	gboolean result;
#line 328 "../lib/Widgets/BottomSheet.vala"
	_tmp0_ = he_bottom_sheet_get_preferred_sheet_height (self);
#line 328 "../lib/Widgets/BottomSheet.vala"
	_tmp1_ = _tmp0_;
#line 328 "../lib/Widgets/BottomSheet.vala"
	if (fabs ((gdouble) (_tmp1_ - self->priv->target_height)) > ((gdouble) 1)) {
#line 806 "BottomSheet.c"
		gint _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
#line 329 "../lib/Widgets/BottomSheet.vala"
		_tmp2_ = he_bottom_sheet_get_preferred_sheet_height (self);
#line 329 "../lib/Widgets/BottomSheet.vala"
		_tmp3_ = _tmp2_;
#line 329 "../lib/Widgets/BottomSheet.vala"
		_tmp4_ = he_bottom_sheet_get_preferred_sheet_height (self);
#line 329 "../lib/Widgets/BottomSheet.vala"
		_tmp5_ = _tmp4_;
#line 329 "../lib/Widgets/BottomSheet.vala"
		he_bottom_sheet_set_preferred_sheet_height (self, _tmp3_ + ((self->priv->target_height - _tmp5_) / 4));
#line 821 "BottomSheet.c"
	} else {
#line 331 "../lib/Widgets/BottomSheet.vala"
		he_bottom_sheet_set_preferred_sheet_height (self, self->priv->target_height);
#line 334 "../lib/Widgets/BottomSheet.vala"
		_g_source_unref0 (self->priv->resize_timeout);
#line 334 "../lib/Widgets/BottomSheet.vala"
		self->priv->resize_timeout = NULL;
#line 335 "../lib/Widgets/BottomSheet.vala"
		result = FALSE;
#line 335 "../lib/Widgets/BottomSheet.vala"
		return result;
#line 833 "BottomSheet.c"
	}
#line 339 "../lib/Widgets/BottomSheet.vala"
	result = TRUE;
#line 339 "../lib/Widgets/BottomSheet.vala"
	return result;
#line 839 "BottomSheet.c"
}

static gboolean
_____lambda127__gsource_func (gpointer self)
{
	gboolean result;
	result = ____lambda127_ ((HeBottomSheet*) self);
#line 326 "../lib/Widgets/BottomSheet.vala"
	return result;
#line 849 "BottomSheet.c"
}

static void
he_bottom_sheet_on_drag_update (HeBottomSheet* self,
                                GtkGestureDrag* gesture,
                                gdouble offset_x,
                                gdouble offset_y)
{
#line 313 "../lib/Widgets/BottomSheet.vala"
	g_return_if_fail (self != NULL);
#line 313 "../lib/Widgets/BottomSheet.vala"
	g_return_if_fail (gesture != NULL);
#line 314 "../lib/Widgets/BottomSheet.vala"
	if (self->priv->dragging) {
#line 864 "BottomSheet.c"
		GSource* _tmp0_;
#line 316 "../lib/Widgets/BottomSheet.vala"
		self->priv->target_height = self->priv->initial_height - ((gint) offset_y);
#line 319 "../lib/Widgets/BottomSheet.vala"
		self->priv->target_height = MAX (self->priv->target_height, 0);
#line 322 "../lib/Widgets/BottomSheet.vala"
		_tmp0_ = self->priv->resize_timeout;
#line 322 "../lib/Widgets/BottomSheet.vala"
		if (_tmp0_ == NULL) {
#line 874 "BottomSheet.c"
			GSource* _tmp1_;
			GSource* _tmp2_;
			GSource* _tmp3_;
			GMainContext* _tmp4_;
#line 323 "../lib/Widgets/BottomSheet.vala"
			he_bottom_sheet_update_refresh_rate (self);
#line 325 "../lib/Widgets/BottomSheet.vala"
			_tmp1_ = g_timeout_source_new ((guint) self->priv->update_interval);
#line 325 "../lib/Widgets/BottomSheet.vala"
			_g_source_unref0 (self->priv->resize_timeout);
#line 325 "../lib/Widgets/BottomSheet.vala"
			self->priv->resize_timeout = _tmp1_;
#line 326 "../lib/Widgets/BottomSheet.vala"
			_tmp2_ = self->priv->resize_timeout;
#line 326 "../lib/Widgets/BottomSheet.vala"
			g_source_set_callback (_tmp2_, _____lambda127__gsource_func, g_object_ref (self), g_object_unref);
#line 341 "../lib/Widgets/BottomSheet.vala"
			_tmp3_ = self->priv->resize_timeout;
#line 341 "../lib/Widgets/BottomSheet.vala"
			_tmp4_ = g_main_context_default ();
#line 341 "../lib/Widgets/BottomSheet.vala"
			g_source_attach (_tmp3_, _tmp4_);
#line 897 "BottomSheet.c"
		}
	}
}

static void
he_bottom_sheet_on_drag_end (HeBottomSheet* self,
                             GtkGestureDrag* gesture,
                             gdouble offset_x,
                             gdouble offset_y)
{
	gint _tmp0_;
	gint _tmp1_;
	GSource* _tmp2_;
#line 346 "../lib/Widgets/BottomSheet.vala"
	g_return_if_fail (self != NULL);
#line 346 "../lib/Widgets/BottomSheet.vala"
	g_return_if_fail (gesture != NULL);
#line 347 "../lib/Widgets/BottomSheet.vala"
	self->priv->dragging = FALSE;
#line 348 "../lib/Widgets/BottomSheet.vala"
	self->priv->initial_height = 0;
#line 351 "../lib/Widgets/BottomSheet.vala"
	_tmp0_ = he_bottom_sheet_get_preferred_sheet_height (self);
#line 351 "../lib/Widgets/BottomSheet.vala"
	_tmp1_ = _tmp0_;
#line 351 "../lib/Widgets/BottomSheet.vala"
	if (_tmp1_ <= HE_BOTTOM_SHEET_MINIMUM_HEIGHT) {
#line 352 "../lib/Widgets/BottomSheet.vala"
		he_bottom_sheet_close_sheet (self);
#line 353 "../lib/Widgets/BottomSheet.vala"
		he_bottom_sheet_set_preferred_sheet_height (self, HE_BOTTOM_SHEET_DEFAULT_HEIGHT);
#line 929 "BottomSheet.c"
	}
#line 357 "../lib/Widgets/BottomSheet.vala"
	_tmp2_ = self->priv->resize_timeout;
#line 357 "../lib/Widgets/BottomSheet.vala"
	if (_tmp2_ != NULL) {
#line 935 "BottomSheet.c"
		GSource* _tmp3_;
#line 358 "../lib/Widgets/BottomSheet.vala"
		_tmp3_ = self->priv->resize_timeout;
#line 358 "../lib/Widgets/BottomSheet.vala"
		g_source_destroy (_tmp3_);
#line 359 "../lib/Widgets/BottomSheet.vala"
		_g_source_unref0 (self->priv->resize_timeout);
#line 359 "../lib/Widgets/BottomSheet.vala"
		self->priv->resize_timeout = NULL;
#line 945 "BottomSheet.c"
	}
}

static void
he_bottom_sheet_real_dispose (GObject* base)
{
	HeBottomSheet * self;
	GtkWidget* _tmp0_;
	GtkBox* _tmp2_;
#line 363 "../lib/Widgets/BottomSheet.vala"
	self = (HeBottomSheet*) base;
#line 364 "../lib/Widgets/BottomSheet.vala"
	_tmp0_ = self->priv->dimming;
#line 364 "../lib/Widgets/BottomSheet.vala"
	if (_tmp0_ != NULL) {
#line 961 "BottomSheet.c"
		GtkWidget* _tmp1_;
#line 365 "../lib/Widgets/BottomSheet.vala"
		_tmp1_ = self->priv->dimming;
#line 365 "../lib/Widgets/BottomSheet.vala"
		gtk_widget_unparent (_tmp1_);
#line 366 "../lib/Widgets/BottomSheet.vala"
		_g_object_unref0 (self->priv->dimming);
#line 366 "../lib/Widgets/BottomSheet.vala"
		self->priv->dimming = NULL;
#line 971 "BottomSheet.c"
	}
#line 369 "../lib/Widgets/BottomSheet.vala"
	_tmp2_ = self->priv->sheet_bin;
#line 369 "../lib/Widgets/BottomSheet.vala"
	if (_tmp2_ != NULL) {
#line 977 "BottomSheet.c"
		GtkBox* _tmp3_;
#line 370 "../lib/Widgets/BottomSheet.vala"
		_tmp3_ = self->priv->sheet_bin;
#line 370 "../lib/Widgets/BottomSheet.vala"
		gtk_widget_unparent ((GtkWidget*) _tmp3_);
#line 371 "../lib/Widgets/BottomSheet.vala"
		_g_object_unref0 (self->priv->sheet_bin);
#line 371 "../lib/Widgets/BottomSheet.vala"
		self->priv->sheet_bin = NULL;
#line 987 "BottomSheet.c"
	}
#line 374 "../lib/Widgets/BottomSheet.vala"
	G_OBJECT_CLASS (he_bottom_sheet_parent_class)->dispose ((GObject*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
#line 991 "BottomSheet.c"
}

static gboolean
he_bottom_sheet_real_contains (GtkWidget* base,
                               gdouble x,
                               gdouble y)
{
	HeBottomSheet * self;
	gboolean result;
#line 377 "../lib/Widgets/BottomSheet.vala"
	self = (HeBottomSheet*) base;
#line 378 "../lib/Widgets/BottomSheet.vala"
	result = FALSE;
#line 378 "../lib/Widgets/BottomSheet.vala"
	return result;
#line 1007 "BottomSheet.c"
}

static void
he_bottom_sheet_real_measure (GtkWidget* base,
                              GtkOrientation orientation,
                              gint for_size,
                              gint* min,
                              gint* nat,
                              gint* min_baseline,
                              gint* nat_baseline)
{
	HeBottomSheet * self;
	gint _vala_min = 0;
	gint _vala_nat = 0;
	gint _vala_min_baseline = 0;
	gint _vala_nat_baseline = 0;
	gint sheet_min = 0;
	gint sheet_nat = 0;
	gint dimming_min = 0;
	gint dimming_nat = 0;
	gint handle_min = 0;
	gint handle_nat = 0;
	GtkBox* _tmp0_;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	GtkWidget* _tmp3_;
	gint _tmp4_ = 0;
	gint _tmp5_ = 0;
	GtkWidget* _tmp6_;
#line 381 "../lib/Widgets/BottomSheet.vala"
	self = (HeBottomSheet*) base;
#line 390 "../lib/Widgets/BottomSheet.vala"
	_vala_nat = 0;
#line 390 "../lib/Widgets/BottomSheet.vala"
	_vala_min = _vala_nat;
#line 392 "../lib/Widgets/BottomSheet.vala"
	_tmp0_ = self->priv->sheet_bin;
#line 392 "../lib/Widgets/BottomSheet.vala"
	gtk_widget_measure ((GtkWidget*) _tmp0_, orientation, for_size, &_tmp1_, &_tmp2_, NULL, NULL);
#line 392 "../lib/Widgets/BottomSheet.vala"
	sheet_min = _tmp1_;
#line 392 "../lib/Widgets/BottomSheet.vala"
	sheet_nat = _tmp2_;
#line 393 "../lib/Widgets/BottomSheet.vala"
	_tmp3_ = self->priv->dimming;
#line 393 "../lib/Widgets/BottomSheet.vala"
	gtk_widget_measure (_tmp3_, orientation, for_size, &_tmp4_, &_tmp5_, NULL, NULL);
#line 393 "../lib/Widgets/BottomSheet.vala"
	dimming_min = _tmp4_;
#line 393 "../lib/Widgets/BottomSheet.vala"
	dimming_nat = _tmp5_;
#line 395 "../lib/Widgets/BottomSheet.vala"
	_tmp6_ = self->priv->handle;
#line 395 "../lib/Widgets/BottomSheet.vala"
	if (_tmp6_ != NULL) {
#line 1063 "BottomSheet.c"
		GtkWidget* _tmp7_;
		gint _tmp8_ = 0;
		gint _tmp9_ = 0;
#line 396 "../lib/Widgets/BottomSheet.vala"
		_tmp7_ = self->priv->handle;
#line 396 "../lib/Widgets/BottomSheet.vala"
		gtk_widget_measure (_tmp7_, orientation, for_size, &_tmp8_, &_tmp9_, NULL, NULL);
#line 396 "../lib/Widgets/BottomSheet.vala"
		handle_min = _tmp8_;
#line 396 "../lib/Widgets/BottomSheet.vala"
		handle_nat = _tmp9_;
#line 1075 "BottomSheet.c"
	}
#line 399 "../lib/Widgets/BottomSheet.vala"
	if (orientation == GTK_ORIENTATION_HORIZONTAL) {
#line 400 "../lib/Widgets/BottomSheet.vala"
		_vala_min = MAX (dimming_min, sheet_min);
#line 401 "../lib/Widgets/BottomSheet.vala"
		_vala_nat = MAX (dimming_nat, sheet_nat);
#line 1083 "BottomSheet.c"
	} else {
#line 403 "../lib/Widgets/BottomSheet.vala"
		_vala_min = MAX (dimming_min, sheet_min + HE_BOTTOM_SHEET_TOP_MARGIN);
#line 404 "../lib/Widgets/BottomSheet.vala"
		_vala_nat = MAX (dimming_nat, sheet_nat + HE_BOTTOM_SHEET_TOP_MARGIN);
#line 1089 "BottomSheet.c"
	}
#line 406 "../lib/Widgets/BottomSheet.vala"
	_vala_nat_baseline = -1;
#line 406 "../lib/Widgets/BottomSheet.vala"
	_vala_min_baseline = _vala_nat_baseline;
#line 381 "../lib/Widgets/BottomSheet.vala"
	if (min) {
#line 381 "../lib/Widgets/BottomSheet.vala"
		*min = _vala_min;
#line 1099 "BottomSheet.c"
	}
#line 381 "../lib/Widgets/BottomSheet.vala"
	if (nat) {
#line 381 "../lib/Widgets/BottomSheet.vala"
		*nat = _vala_nat;
#line 1105 "BottomSheet.c"
	}
#line 381 "../lib/Widgets/BottomSheet.vala"
	if (min_baseline) {
#line 381 "../lib/Widgets/BottomSheet.vala"
		*min_baseline = _vala_min_baseline;
#line 1111 "BottomSheet.c"
	}
#line 381 "../lib/Widgets/BottomSheet.vala"
	if (nat_baseline) {
#line 381 "../lib/Widgets/BottomSheet.vala"
		*nat_baseline = _vala_nat_baseline;
#line 1117 "BottomSheet.c"
	}
}

static gpointer
_gsk_transform_ref0 (gpointer self)
{
#line 435 "../lib/Widgets/BottomSheet.vala"
	return self ? gsk_transform_ref (self) : NULL;
#line 1126 "BottomSheet.c"
}

static void
he_bottom_sheet_real_size_allocate (GtkWidget* base,
                                    gint width,
                                    gint height,
                                    gint baseline)
{
	HeBottomSheet * self;
	GtkBox* _tmp0_;
	GtkWidget* _tmp1_;
	gint sheet_height = 0;
	gint _tmp2_;
	gint _tmp3_;
	gint offset_rounded = 0;
	HeSpringAnimation* _tmp9_;
	gdouble _tmp10_;
	gdouble _tmp11_;
	GskTransform* t = NULL;
	GskTransform* _tmp12_;
	GtkWidget* _tmp39_;
#line 409 "../lib/Widgets/BottomSheet.vala"
	self = (HeBottomSheet*) base;
#line 410 "../lib/Widgets/BottomSheet.vala"
	_tmp0_ = self->priv->sheet_bin;
#line 410 "../lib/Widgets/BottomSheet.vala"
	if (!gtk_widget_get_child_visible ((GtkWidget*) _tmp0_)) {
#line 411 "../lib/Widgets/BottomSheet.vala"
		return;
#line 1156 "BottomSheet.c"
	}
#line 413 "../lib/Widgets/BottomSheet.vala"
	_tmp1_ = self->priv->dimming;
#line 413 "../lib/Widgets/BottomSheet.vala"
	gtk_widget_allocate (_tmp1_, width, height, baseline, NULL);
#line 417 "../lib/Widgets/BottomSheet.vala"
	_tmp2_ = he_bottom_sheet_get_preferred_sheet_height (self);
#line 417 "../lib/Widgets/BottomSheet.vala"
	_tmp3_ = _tmp2_;
#line 417 "../lib/Widgets/BottomSheet.vala"
	if (_tmp3_ < 0) {
#line 1168 "BottomSheet.c"
		GtkBox* _tmp4_;
		gint _tmp5_ = 0;
#line 418 "../lib/Widgets/BottomSheet.vala"
		_tmp4_ = self->priv->sheet_bin;
#line 418 "../lib/Widgets/BottomSheet.vala"
		gtk_widget_measure ((GtkWidget*) _tmp4_, GTK_ORIENTATION_VERTICAL, -1, NULL, &_tmp5_, NULL, NULL);
#line 418 "../lib/Widgets/BottomSheet.vala"
		sheet_height = _tmp5_;
#line 1177 "BottomSheet.c"
	} else {
		GtkBox* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
#line 420 "../lib/Widgets/BottomSheet.vala"
		_tmp6_ = self->priv->sheet_bin;
#line 420 "../lib/Widgets/BottomSheet.vala"
		gtk_widget_measure ((GtkWidget*) _tmp6_, GTK_ORIENTATION_VERTICAL, -1, NULL, NULL, NULL, NULL);
#line 421 "../lib/Widgets/BottomSheet.vala"
		_tmp7_ = he_bottom_sheet_get_preferred_sheet_height (self);
#line 421 "../lib/Widgets/BottomSheet.vala"
		_tmp8_ = _tmp7_;
#line 421 "../lib/Widgets/BottomSheet.vala"
		sheet_height = _tmp8_;
#line 1192 "BottomSheet.c"
	}
#line 424 "../lib/Widgets/BottomSheet.vala"
	sheet_height = MAX (sheet_height, 0);
#line 425 "../lib/Widgets/BottomSheet.vala"
	sheet_height = MIN (sheet_height, height - HE_BOTTOM_SHEET_TOP_MARGIN);
#line 427 "../lib/Widgets/BottomSheet.vala"
	_tmp9_ = self->priv->show_animation;
#line 427 "../lib/Widgets/BottomSheet.vala"
	_tmp10_ = he_animation_get_avalue ((HeAnimation*) _tmp9_);
#line 427 "../lib/Widgets/BottomSheet.vala"
	_tmp11_ = _tmp10_;
#line 427 "../lib/Widgets/BottomSheet.vala"
	offset_rounded = (gint) round (_tmp11_ * sheet_height);
#line 429 "../lib/Widgets/BottomSheet.vala"
	_tmp12_ = gsk_transform_new ();
#line 429 "../lib/Widgets/BottomSheet.vala"
	t = _tmp12_;
#line 431 "../lib/Widgets/BottomSheet.vala"
	if (width <= 600) {
#line 1212 "BottomSheet.c"
		GtkBox* _tmp25_;
		GtkBox* _tmp26_;
		GtkWidget* _tmp27_;
		gboolean _tmp28_;
		gboolean _tmp29_;
#line 432 "../lib/Widgets/BottomSheet.vala"
		if (self->priv->dragging) {
#line 1220 "BottomSheet.c"
			GskTransform* _tmp13_;
			graphene_point_t _tmp14_ = {0};
			GskTransform* _tmp15_;
			GtkBox* _tmp16_;
			GskTransform* _tmp17_;
			GskTransform* _tmp18_;
#line 433 "../lib/Widgets/BottomSheet.vala"
			_tmp13_ = t;
#line 433 "../lib/Widgets/BottomSheet.vala"
			t = NULL;
#line 433 "../lib/Widgets/BottomSheet.vala"
			_tmp14_.x = (gfloat) 0;
#line 433 "../lib/Widgets/BottomSheet.vala"
			_tmp14_.y = (gfloat) (height - offset_rounded);
#line 433 "../lib/Widgets/BottomSheet.vala"
			_tmp15_ = gsk_transform_translate (_tmp13_, &_tmp14_);
#line 433 "../lib/Widgets/BottomSheet.vala"
			_gsk_transform_unref0 (t);
#line 433 "../lib/Widgets/BottomSheet.vala"
			t = _tmp15_;
#line 434 "../lib/Widgets/BottomSheet.vala"
			sheet_height = MAX (sheet_height, offset_rounded);
#line 435 "../lib/Widgets/BottomSheet.vala"
			_tmp16_ = self->priv->sheet_bin;
#line 435 "../lib/Widgets/BottomSheet.vala"
			_tmp17_ = t;
#line 435 "../lib/Widgets/BottomSheet.vala"
			_tmp18_ = _gsk_transform_ref0 (_tmp17_);
#line 435 "../lib/Widgets/BottomSheet.vala"
			gtk_widget_allocate ((GtkWidget*) _tmp16_, width, sheet_height, baseline, _tmp18_);
#line 1251 "BottomSheet.c"
		} else {
			GskTransform* _tmp19_;
			graphene_point_t _tmp20_ = {0};
			GskTransform* _tmp21_;
			GtkBox* _tmp22_;
			GskTransform* _tmp23_;
			GskTransform* _tmp24_;
#line 437 "../lib/Widgets/BottomSheet.vala"
			_tmp19_ = t;
#line 437 "../lib/Widgets/BottomSheet.vala"
			t = NULL;
#line 437 "../lib/Widgets/BottomSheet.vala"
			_tmp20_.x = (gfloat) 0;
#line 437 "../lib/Widgets/BottomSheet.vala"
			_tmp20_.y = (gfloat) (height - offset_rounded);
#line 437 "../lib/Widgets/BottomSheet.vala"
			_tmp21_ = gsk_transform_translate (_tmp19_, &_tmp20_);
#line 437 "../lib/Widgets/BottomSheet.vala"
			_gsk_transform_unref0 (t);
#line 437 "../lib/Widgets/BottomSheet.vala"
			t = _tmp21_;
#line 438 "../lib/Widgets/BottomSheet.vala"
			sheet_height = MAX (sheet_height, offset_rounded);
#line 439 "../lib/Widgets/BottomSheet.vala"
			_tmp22_ = self->priv->sheet_bin;
#line 439 "../lib/Widgets/BottomSheet.vala"
			_tmp23_ = t;
#line 439 "../lib/Widgets/BottomSheet.vala"
			_tmp24_ = _gsk_transform_ref0 (_tmp23_);
#line 439 "../lib/Widgets/BottomSheet.vala"
			gtk_widget_allocate ((GtkWidget*) _tmp22_, width, sheet_height, baseline, _tmp24_);
#line 1283 "BottomSheet.c"
		}
#line 441 "../lib/Widgets/BottomSheet.vala"
		_tmp25_ = self->priv->sheet_bin;
#line 441 "../lib/Widgets/BottomSheet.vala"
		gtk_widget_add_css_class ((GtkWidget*) _tmp25_, "bottom-sheet");
#line 442 "../lib/Widgets/BottomSheet.vala"
		_tmp26_ = self->priv->sheet_bin;
#line 442 "../lib/Widgets/BottomSheet.vala"
		gtk_widget_remove_css_class ((GtkWidget*) _tmp26_, "dialog-sheet");
#line 443 "../lib/Widgets/BottomSheet.vala"
		_tmp27_ = self->priv->handle;
#line 443 "../lib/Widgets/BottomSheet.vala"
		_tmp28_ = he_bottom_sheet_get_show_handle (self);
#line 443 "../lib/Widgets/BottomSheet.vala"
		_tmp29_ = _tmp28_;
#line 443 "../lib/Widgets/BottomSheet.vala"
		gtk_widget_set_visible (_tmp27_, _tmp29_);
#line 1301 "BottomSheet.c"
	} else {
		GtkBox* _tmp36_;
		GtkBox* _tmp37_;
		GtkWidget* _tmp38_;
#line 445 "../lib/Widgets/BottomSheet.vala"
		if (!self->priv->dragging) {
#line 1308 "BottomSheet.c"
			GskTransform* _tmp30_;
			graphene_point_t _tmp31_ = {0};
			GskTransform* _tmp32_;
			GtkBox* _tmp33_;
			GskTransform* _tmp34_;
			GskTransform* _tmp35_;
#line 446 "../lib/Widgets/BottomSheet.vala"
			_tmp30_ = t;
#line 446 "../lib/Widgets/BottomSheet.vala"
			t = NULL;
#line 446 "../lib/Widgets/BottomSheet.vala"
			_tmp31_.x = (gfloat) 0;
#line 446 "../lib/Widgets/BottomSheet.vala"
			_tmp31_.y = (gfloat) ((height - offset_rounded) / 2);
#line 446 "../lib/Widgets/BottomSheet.vala"
			_tmp32_ = gsk_transform_translate (_tmp30_, &_tmp31_);
#line 446 "../lib/Widgets/BottomSheet.vala"
			_gsk_transform_unref0 (t);
#line 446 "../lib/Widgets/BottomSheet.vala"
			t = _tmp32_;
#line 447 "../lib/Widgets/BottomSheet.vala"
			sheet_height = MAX (sheet_height, offset_rounded);
#line 448 "../lib/Widgets/BottomSheet.vala"
			_tmp33_ = self->priv->sheet_bin;
#line 448 "../lib/Widgets/BottomSheet.vala"
			_tmp34_ = t;
#line 448 "../lib/Widgets/BottomSheet.vala"
			_tmp35_ = _gsk_transform_ref0 (_tmp34_);
#line 448 "../lib/Widgets/BottomSheet.vala"
			gtk_widget_allocate ((GtkWidget*) _tmp33_, width, sheet_height, baseline, _tmp35_);
#line 1339 "BottomSheet.c"
		}
#line 450 "../lib/Widgets/BottomSheet.vala"
		_tmp36_ = self->priv->sheet_bin;
#line 450 "../lib/Widgets/BottomSheet.vala"
		gtk_widget_add_css_class ((GtkWidget*) _tmp36_, "dialog-sheet");
#line 451 "../lib/Widgets/BottomSheet.vala"
		_tmp37_ = self->priv->sheet_bin;
#line 451 "../lib/Widgets/BottomSheet.vala"
		gtk_widget_remove_css_class ((GtkWidget*) _tmp37_, "bottom-sheet");
#line 452 "../lib/Widgets/BottomSheet.vala"
		_tmp38_ = self->priv->handle;
#line 452 "../lib/Widgets/BottomSheet.vala"
		gtk_widget_set_visible (_tmp38_, FALSE);
#line 1353 "BottomSheet.c"
	}
#line 455 "../lib/Widgets/BottomSheet.vala"
	_tmp39_ = self->priv->handle;
#line 455 "../lib/Widgets/BottomSheet.vala"
	if (_tmp39_ != NULL) {
#line 1359 "BottomSheet.c"
		gint handle_width = 0;
		gint handle_height = 0;
		gint handle_x = 0;
		GtkWidget* _tmp40_;
		gint _tmp41_ = 0;
		GtkWidget* _tmp42_;
		gint _tmp43_ = 0;
		GskTransform* t2 = NULL;
		GskTransform* _tmp44_;
		GskTransform* _tmp45_;
		graphene_point_t _tmp46_ = {0};
		GskTransform* _tmp47_;
		GtkWidget* _tmp48_;
		GskTransform* _tmp49_;
		GskTransform* _tmp50_;
#line 456 "../lib/Widgets/BottomSheet.vala"
		handle_width = 0;
#line 456 "../lib/Widgets/BottomSheet.vala"
		handle_height = 0;
#line 458 "../lib/Widgets/BottomSheet.vala"
		_tmp40_ = self->priv->handle;
#line 458 "../lib/Widgets/BottomSheet.vala"
		gtk_widget_measure (_tmp40_, GTK_ORIENTATION_HORIZONTAL, -1, NULL, &_tmp41_, NULL, NULL);
#line 458 "../lib/Widgets/BottomSheet.vala"
		handle_width = _tmp41_;
#line 459 "../lib/Widgets/BottomSheet.vala"
		_tmp42_ = self->priv->handle;
#line 459 "../lib/Widgets/BottomSheet.vala"
		gtk_widget_measure (_tmp42_, GTK_ORIENTATION_VERTICAL, -1, NULL, &_tmp43_, NULL, NULL);
#line 459 "../lib/Widgets/BottomSheet.vala"
		handle_height = _tmp43_;
#line 461 "../lib/Widgets/BottomSheet.vala"
		handle_width = (gint) fmin ((gdouble) handle_width, (gdouble) width);
#line 462 "../lib/Widgets/BottomSheet.vala"
		handle_height = (gint) fmin ((gdouble) handle_height, (gdouble) height);
#line 464 "../lib/Widgets/BottomSheet.vala"
		handle_x = (gint) round ((gdouble) (((width - handle_width) - 36) / 2));
#line 466 "../lib/Widgets/BottomSheet.vala"
		_tmp44_ = gsk_transform_new ();
#line 466 "../lib/Widgets/BottomSheet.vala"
		t2 = _tmp44_;
#line 468 "../lib/Widgets/BottomSheet.vala"
		_tmp45_ = t2;
#line 468 "../lib/Widgets/BottomSheet.vala"
		t2 = NULL;
#line 468 "../lib/Widgets/BottomSheet.vala"
		_tmp46_.x = (gfloat) handle_x;
#line 468 "../lib/Widgets/BottomSheet.vala"
		_tmp46_.y = (gfloat) 0;
#line 468 "../lib/Widgets/BottomSheet.vala"
		_tmp47_ = gsk_transform_translate (_tmp45_, &_tmp46_);
#line 468 "../lib/Widgets/BottomSheet.vala"
		_gsk_transform_unref0 (t2);
#line 468 "../lib/Widgets/BottomSheet.vala"
		t2 = _tmp47_;
#line 470 "../lib/Widgets/BottomSheet.vala"
		_tmp48_ = self->priv->handle;
#line 470 "../lib/Widgets/BottomSheet.vala"
		_tmp49_ = t2;
#line 470 "../lib/Widgets/BottomSheet.vala"
		_tmp50_ = _gsk_transform_ref0 (_tmp49_);
#line 470 "../lib/Widgets/BottomSheet.vala"
		gtk_widget_allocate (_tmp48_, handle_width, handle_height, baseline, _tmp50_);
#line 455 "../lib/Widgets/BottomSheet.vala"
		_gsk_transform_unref0 (t2);
#line 1425 "BottomSheet.c"
	}
#line 409 "../lib/Widgets/BottomSheet.vala"
	_gsk_transform_unref0 (t);
#line 1429 "BottomSheet.c"
}

HeBottomSheet*
he_bottom_sheet_construct (GType object_type)
{
	HeBottomSheet * self = NULL;
#line 25 "../lib/Widgets/BottomSheet.vala"
	self = (HeBottomSheet*) g_object_new (object_type, NULL);
#line 25 "../lib/Widgets/BottomSheet.vala"
	return self;
#line 1440 "BottomSheet.c"
}

HeBottomSheet*
he_bottom_sheet_new (void)
{
#line 25 "../lib/Widgets/BottomSheet.vala"
	return he_bottom_sheet_construct (HE_TYPE_BOTTOM_SHEET);
#line 1448 "BottomSheet.c"
}

static void
_he_bottom_sheet_on_drag_begin_gtk_gesture_drag_drag_begin (GtkGestureDrag* _sender,
                                                            gdouble start_x,
                                                            gdouble start_y,
                                                            gpointer self)
{
#line 225 "../lib/Widgets/BottomSheet.vala"
	he_bottom_sheet_on_drag_begin ((HeBottomSheet*) self, _sender, start_x, start_y);
#line 1459 "BottomSheet.c"
}

static void
_he_bottom_sheet_on_drag_update_gtk_gesture_drag_drag_update (GtkGestureDrag* _sender,
                                                              gdouble offset_x,
                                                              gdouble offset_y,
                                                              gpointer self)
{
#line 226 "../lib/Widgets/BottomSheet.vala"
	he_bottom_sheet_on_drag_update ((HeBottomSheet*) self, _sender, offset_x, offset_y);
#line 1470 "BottomSheet.c"
}

static void
_he_bottom_sheet_on_drag_end_gtk_gesture_drag_drag_end (GtkGestureDrag* _sender,
                                                        gdouble offset_x,
                                                        gdouble offset_y,
                                                        gpointer self)
{
#line 227 "../lib/Widgets/BottomSheet.vala"
	he_bottom_sheet_on_drag_end ((HeBottomSheet*) self, _sender, offset_x, offset_y);
#line 1481 "BottomSheet.c"
}

static void
_he_bottom_sheet___lambda128_ (HeBottomSheet* self)
{
#line 241 "../lib/Widgets/BottomSheet.vala"
	he_bottom_sheet_set_show_sheet (self, FALSE);
#line 1489 "BottomSheet.c"
}

static void
__he_bottom_sheet___lambda128__gtk_button_clicked (GtkButton* _sender,
                                                   gpointer self)
{
#line 240 "../lib/Widgets/BottomSheet.vala"
	_he_bottom_sheet___lambda128_ ((HeBottomSheet*) self);
#line 1498 "BottomSheet.c"
}

static void
_he_bottom_sheet_close_sheet_gtk_gesture_end (GtkGesture* _sender,
                                              GdkEventSequence* sequence,
                                              gpointer self)
{
#line 263 "../lib/Widgets/BottomSheet.vala"
	he_bottom_sheet_close_sheet ((HeBottomSheet*) self);
#line 1508 "BottomSheet.c"
}

static void
_he_bottom_sheet___lambda129_ (HeBottomSheet* self,
                               gdouble value)
{
	GtkWidget* _tmp0_;
	GtkWidget* _tmp1_;
	GtkBox* _tmp2_;
#line 272 "../lib/Widgets/BottomSheet.vala"
	_tmp0_ = self->priv->dimming;
#line 272 "../lib/Widgets/BottomSheet.vala"
	gtk_widget_set_opacity (_tmp0_, CLAMP (value, (gdouble) 0, (gdouble) 1));
#line 273 "../lib/Widgets/BottomSheet.vala"
	_tmp1_ = self->priv->dimming;
#line 273 "../lib/Widgets/BottomSheet.vala"
	gtk_widget_set_child_visible (_tmp1_, value > ((gdouble) 0));
#line 274 "../lib/Widgets/BottomSheet.vala"
	_tmp2_ = self->priv->sheet_bin;
#line 274 "../lib/Widgets/BottomSheet.vala"
	gtk_widget_set_child_visible ((GtkWidget*) _tmp2_, value > ((gdouble) 0));
#line 275 "../lib/Widgets/BottomSheet.vala"
	gtk_widget_queue_allocate ((GtkWidget*) self);
#line 1532 "BottomSheet.c"
}

static void
__he_bottom_sheet___lambda129__he_animation_target_func (gdouble value,
                                                         gpointer self)
{
#line 266 "../lib/Widgets/BottomSheet.vala"
	_he_bottom_sheet___lambda129_ ((HeBottomSheet*) self, value);
#line 1541 "BottomSheet.c"
}

static void
_he_bottom_sheet___lambda130_ (HeBottomSheet* self)
{
	HeSpringAnimation* _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
#line 278 "../lib/Widgets/BottomSheet.vala"
	gtk_widget_queue_allocate ((GtkWidget*) self);
#line 280 "../lib/Widgets/BottomSheet.vala"
	_tmp0_ = self->priv->show_animation;
#line 280 "../lib/Widgets/BottomSheet.vala"
	_tmp1_ = he_animation_get_avalue ((HeAnimation*) _tmp0_);
#line 280 "../lib/Widgets/BottomSheet.vala"
	_tmp2_ = _tmp1_;
#line 280 "../lib/Widgets/BottomSheet.vala"
	if (_tmp2_ < 0.5) {
#line 1560 "BottomSheet.c"
		GtkWidget* _tmp3_;
		GtkBox* _tmp4_;
#line 281 "../lib/Widgets/BottomSheet.vala"
		_tmp3_ = self->priv->dimming;
#line 281 "../lib/Widgets/BottomSheet.vala"
		gtk_widget_set_child_visible (_tmp3_, FALSE);
#line 282 "../lib/Widgets/BottomSheet.vala"
		_tmp4_ = self->priv->sheet_bin;
#line 282 "../lib/Widgets/BottomSheet.vala"
		gtk_widget_set_child_visible ((GtkWidget*) _tmp4_, FALSE);
#line 284 "../lib/Widgets/BottomSheet.vala"
		g_signal_emit (self, he_bottom_sheet_signals[HE_BOTTOM_SHEET_HIDDEN_SIGNAL], 0);
#line 1573 "BottomSheet.c"
	}
}

static void
__he_bottom_sheet___lambda130__he_animation_done (HeAnimation* _sender,
                                                  gpointer self)
{
#line 277 "../lib/Widgets/BottomSheet.vala"
	_he_bottom_sheet___lambda130_ ((HeBottomSheet*) self);
#line 1583 "BottomSheet.c"
}

static GObject *
he_bottom_sheet_constructor (GType type,
                             guint n_construct_properties,
                             GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	HeBottomSheet * self;
	HeBin* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
	GtkWidget* _tmp3_;
	GtkWidget* _tmp4_;
	GtkBox* _tmp5_;
	GtkBox* _tmp6_;
	GtkBox* _tmp7_;
	GtkBox* _tmp8_;
	HeBin* _tmp9_;
	GtkWidget* _tmp10_;
	GtkWidget* _tmp11_;
	GtkWidget* _tmp12_;
	GtkGestureDrag* gesture_drag = NULL;
	GtkGestureDrag* _tmp13_;
	GtkWidget* _tmp14_;
	GtkGestureDrag* _tmp15_;
	GtkEventController* _tmp16_;
	GtkGestureDrag* _tmp17_;
	GtkGestureDrag* _tmp18_;
	GtkGestureDrag* _tmp19_;
	GtkLabel* _tmp20_;
	GtkLabel* _tmp21_;
	GtkLabel* _tmp22_;
	GtkLabel* _tmp23_;
	GtkLabel* _tmp24_;
	GtkLabel* _tmp25_;
	HeButton* close_button = NULL;
	HeButton* _tmp26_;
	HeButton* _tmp27_;
	HeButton* _tmp28_;
	HeButton* _tmp29_;
	HeButton* _tmp30_;
	HeButton* _tmp31_;
	HeButton* _tmp32_;
	HeButton* _tmp33_;
	HeButton* _tmp34_;
	HeButton* _tmp35_;
	GtkBox* title_box = NULL;
	GtkBox* _tmp36_;
	GtkBox* _tmp37_;
	HeButton* _tmp38_;
	GtkBox* _tmp39_;
	GtkLabel* _tmp40_;
	GtkBox* _tmp41_;
	HeButton* _tmp42_;
	GtkWindowHandle* _tmp43_;
	GtkWindowHandle* _tmp44_;
	GtkWindowHandle* _tmp45_;
	GtkBox* _tmp46_;
	GtkBox* _tmp47_;
	GtkWindowHandle* _tmp48_;
	GtkBox* _tmp49_;
	GtkWidget* _tmp50_;
	GtkGestureClick* click_gesture = NULL;
	GtkGestureClick* _tmp51_;
	GtkGestureClick* _tmp52_;
	GtkWidget* _tmp53_;
	GtkGestureClick* _tmp54_;
	GtkEventController* _tmp55_;
	HeSpringParams* _tmp56_;
	HeCallbackAnimationTarget* _tmp57_;
	HeSpringAnimation* _tmp58_;
	HeSpringAnimation* _tmp59_;
	HeSpringAnimation* _tmp60_;
#line 206 "../lib/Widgets/BottomSheet.vala"
	parent_class = G_OBJECT_CLASS (he_bottom_sheet_parent_class);
#line 206 "../lib/Widgets/BottomSheet.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 206 "../lib/Widgets/BottomSheet.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_BOTTOM_SHEET, HeBottomSheet);
#line 207 "../lib/Widgets/BottomSheet.vala"
	_tmp0_ = he_bin_new ();
#line 207 "../lib/Widgets/BottomSheet.vala"
	g_object_ref_sink (_tmp0_);
#line 207 "../lib/Widgets/BottomSheet.vala"
	_g_object_unref0 (self->priv->dimming);
#line 207 "../lib/Widgets/BottomSheet.vala"
	self->priv->dimming = (GtkWidget*) _tmp0_;
#line 208 "../lib/Widgets/BottomSheet.vala"
	_tmp1_ = self->priv->dimming;
#line 208 "../lib/Widgets/BottomSheet.vala"
	gtk_widget_set_opacity (_tmp1_, (gdouble) 0);
#line 209 "../lib/Widgets/BottomSheet.vala"
	_tmp2_ = self->priv->dimming;
#line 209 "../lib/Widgets/BottomSheet.vala"
	gtk_widget_set_child_visible (_tmp2_, FALSE);
#line 210 "../lib/Widgets/BottomSheet.vala"
	_tmp3_ = self->priv->dimming;
#line 210 "../lib/Widgets/BottomSheet.vala"
	gtk_widget_add_css_class (_tmp3_, "dimming");
#line 211 "../lib/Widgets/BottomSheet.vala"
	_tmp4_ = self->priv->dimming;
#line 211 "../lib/Widgets/BottomSheet.vala"
	gtk_widget_set_parent (_tmp4_, (GtkWidget*) self);
#line 213 "../lib/Widgets/BottomSheet.vala"
	_tmp5_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 213 "../lib/Widgets/BottomSheet.vala"
	g_object_ref_sink (_tmp5_);
#line 213 "../lib/Widgets/BottomSheet.vala"
	_g_object_unref0 (self->priv->sheet_bin);
#line 213 "../lib/Widgets/BottomSheet.vala"
	self->priv->sheet_bin = _tmp5_;
#line 214 "../lib/Widgets/BottomSheet.vala"
	_tmp6_ = self->priv->sheet_bin;
#line 214 "../lib/Widgets/BottomSheet.vala"
	gtk_widget_set_child_visible ((GtkWidget*) _tmp6_, FALSE);
#line 215 "../lib/Widgets/BottomSheet.vala"
	_tmp7_ = self->priv->sheet_bin;
#line 215 "../lib/Widgets/BottomSheet.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp7_, GTK_ALIGN_CENTER);
#line 216 "../lib/Widgets/BottomSheet.vala"
	_tmp8_ = self->priv->sheet_bin;
#line 216 "../lib/Widgets/BottomSheet.vala"
	gtk_widget_set_parent ((GtkWidget*) _tmp8_, (GtkWidget*) self);
#line 218 "../lib/Widgets/BottomSheet.vala"
	_tmp9_ = he_bin_new ();
#line 218 "../lib/Widgets/BottomSheet.vala"
	g_object_ref_sink (_tmp9_);
#line 218 "../lib/Widgets/BottomSheet.vala"
	_g_object_unref0 (self->priv->handle);
#line 218 "../lib/Widgets/BottomSheet.vala"
	self->priv->handle = (GtkWidget*) _tmp9_;
#line 219 "../lib/Widgets/BottomSheet.vala"
	_tmp10_ = self->priv->handle;
#line 219 "../lib/Widgets/BottomSheet.vala"
	gtk_widget_set_visible (_tmp10_, FALSE);
#line 220 "../lib/Widgets/BottomSheet.vala"
	_tmp11_ = self->priv->handle;
#line 220 "../lib/Widgets/BottomSheet.vala"
	gtk_widget_add_css_class (_tmp11_, "drag-handle");
#line 221 "../lib/Widgets/BottomSheet.vala"
	_tmp12_ = self->priv->handle;
#line 221 "../lib/Widgets/BottomSheet.vala"
	gtk_widget_add_css_class (_tmp12_, "large-radius");
#line 223 "../lib/Widgets/BottomSheet.vala"
	_tmp13_ = (GtkGestureDrag*) gtk_gesture_drag_new ();
#line 223 "../lib/Widgets/BottomSheet.vala"
	gesture_drag = _tmp13_;
#line 224 "../lib/Widgets/BottomSheet.vala"
	_tmp14_ = self->priv->handle;
#line 224 "../lib/Widgets/BottomSheet.vala"
	_tmp15_ = gesture_drag;
#line 224 "../lib/Widgets/BottomSheet.vala"
	_tmp16_ = _g_object_ref0 ((GtkEventController*) _tmp15_);
#line 224 "../lib/Widgets/BottomSheet.vala"
	gtk_widget_add_controller (_tmp14_, _tmp16_);
#line 225 "../lib/Widgets/BottomSheet.vala"
	_tmp17_ = gesture_drag;
#line 225 "../lib/Widgets/BottomSheet.vala"
	g_signal_connect_object (_tmp17_, "drag-begin", (GCallback) _he_bottom_sheet_on_drag_begin_gtk_gesture_drag_drag_begin, self, 0);
#line 226 "../lib/Widgets/BottomSheet.vala"
	_tmp18_ = gesture_drag;
#line 226 "../lib/Widgets/BottomSheet.vala"
	g_signal_connect_object (_tmp18_, "drag-update", (GCallback) _he_bottom_sheet_on_drag_update_gtk_gesture_drag_drag_update, self, 0);
#line 227 "../lib/Widgets/BottomSheet.vala"
	_tmp19_ = gesture_drag;
#line 227 "../lib/Widgets/BottomSheet.vala"
	g_signal_connect_object (_tmp19_, "drag-end", (GCallback) _he_bottom_sheet_on_drag_end_gtk_gesture_drag_drag_end, self, 0);
#line 229 "../lib/Widgets/BottomSheet.vala"
	_tmp20_ = (GtkLabel*) gtk_label_new ("");
#line 229 "../lib/Widgets/BottomSheet.vala"
	g_object_ref_sink (_tmp20_);
#line 229 "../lib/Widgets/BottomSheet.vala"
	_g_object_unref0 (self->priv->title_label);
#line 229 "../lib/Widgets/BottomSheet.vala"
	self->priv->title_label = _tmp20_;
#line 230 "../lib/Widgets/BottomSheet.vala"
	_tmp21_ = self->priv->title_label;
#line 230 "../lib/Widgets/BottomSheet.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp21_, 6);
#line 231 "../lib/Widgets/BottomSheet.vala"
	_tmp22_ = self->priv->title_label;
#line 231 "../lib/Widgets/BottomSheet.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp22_, GTK_ALIGN_START);
#line 232 "../lib/Widgets/BottomSheet.vala"
	_tmp23_ = self->priv->title_label;
#line 232 "../lib/Widgets/BottomSheet.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp23_, GTK_ALIGN_CENTER);
#line 233 "../lib/Widgets/BottomSheet.vala"
	_tmp24_ = self->priv->title_label;
#line 233 "../lib/Widgets/BottomSheet.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp24_, TRUE);
#line 234 "../lib/Widgets/BottomSheet.vala"
	_tmp25_ = self->priv->title_label;
#line 234 "../lib/Widgets/BottomSheet.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp25_, "view-subtitle");
#line 236 "../lib/Widgets/BottomSheet.vala"
	_tmp26_ = he_button_new ("window-close-symbolic", "");
#line 236 "../lib/Widgets/BottomSheet.vala"
	g_object_ref_sink (_tmp26_);
#line 236 "../lib/Widgets/BottomSheet.vala"
	close_button = _tmp26_;
#line 237 "../lib/Widgets/BottomSheet.vala"
	_tmp27_ = close_button;
#line 237 "../lib/Widgets/BottomSheet.vala"
	he_button_set_is_disclosure (_tmp27_, TRUE);
#line 238 "../lib/Widgets/BottomSheet.vala"
	_tmp28_ = close_button;
#line 238 "../lib/Widgets/BottomSheet.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp28_, GTK_ALIGN_START);
#line 239 "../lib/Widgets/BottomSheet.vala"
	_tmp29_ = close_button;
#line 239 "../lib/Widgets/BottomSheet.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp29_, GTK_ALIGN_END);
#line 240 "../lib/Widgets/BottomSheet.vala"
	_tmp30_ = close_button;
#line 240 "../lib/Widgets/BottomSheet.vala"
	g_signal_connect_object ((GtkButton*) _tmp30_, "clicked", (GCallback) __he_bottom_sheet___lambda128__gtk_button_clicked, self, 0);
#line 244 "../lib/Widgets/BottomSheet.vala"
	_tmp31_ = he_button_new ("pan-start-symbolic", "");
#line 244 "../lib/Widgets/BottomSheet.vala"
	g_object_ref_sink (_tmp31_);
#line 244 "../lib/Widgets/BottomSheet.vala"
	_g_object_unref0 (self->back_button);
#line 244 "../lib/Widgets/BottomSheet.vala"
	self->back_button = _tmp31_;
#line 245 "../lib/Widgets/BottomSheet.vala"
	_tmp32_ = self->back_button;
#line 245 "../lib/Widgets/BottomSheet.vala"
	he_button_set_is_disclosure (_tmp32_, TRUE);
#line 246 "../lib/Widgets/BottomSheet.vala"
	_tmp33_ = self->back_button;
#line 246 "../lib/Widgets/BottomSheet.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp33_, FALSE);
#line 247 "../lib/Widgets/BottomSheet.vala"
	_tmp34_ = self->back_button;
#line 247 "../lib/Widgets/BottomSheet.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp34_, GTK_ALIGN_START);
#line 248 "../lib/Widgets/BottomSheet.vala"
	_tmp35_ = self->back_button;
#line 248 "../lib/Widgets/BottomSheet.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp35_, GTK_ALIGN_START);
#line 250 "../lib/Widgets/BottomSheet.vala"
	_tmp36_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
#line 250 "../lib/Widgets/BottomSheet.vala"
	g_object_ref_sink (_tmp36_);
#line 250 "../lib/Widgets/BottomSheet.vala"
	title_box = _tmp36_;
#line 251 "../lib/Widgets/BottomSheet.vala"
	_tmp37_ = title_box;
#line 251 "../lib/Widgets/BottomSheet.vala"
	_tmp38_ = self->back_button;
#line 251 "../lib/Widgets/BottomSheet.vala"
	gtk_box_append (_tmp37_, (GtkWidget*) _tmp38_);
#line 252 "../lib/Widgets/BottomSheet.vala"
	_tmp39_ = title_box;
#line 252 "../lib/Widgets/BottomSheet.vala"
	_tmp40_ = self->priv->title_label;
#line 252 "../lib/Widgets/BottomSheet.vala"
	gtk_box_append (_tmp39_, (GtkWidget*) _tmp40_);
#line 253 "../lib/Widgets/BottomSheet.vala"
	_tmp41_ = title_box;
#line 253 "../lib/Widgets/BottomSheet.vala"
	_tmp42_ = close_button;
#line 253 "../lib/Widgets/BottomSheet.vala"
	gtk_box_append (_tmp41_, (GtkWidget*) _tmp42_);
#line 255 "../lib/Widgets/BottomSheet.vala"
	_tmp43_ = (GtkWindowHandle*) gtk_window_handle_new ();
#line 255 "../lib/Widgets/BottomSheet.vala"
	g_object_ref_sink (_tmp43_);
#line 255 "../lib/Widgets/BottomSheet.vala"
	_g_object_unref0 (self->priv->handle_wh);
#line 255 "../lib/Widgets/BottomSheet.vala"
	self->priv->handle_wh = _tmp43_;
#line 256 "../lib/Widgets/BottomSheet.vala"
	_tmp44_ = self->priv->handle_wh;
#line 256 "../lib/Widgets/BottomSheet.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp44_, "drag-handle-container");
#line 257 "../lib/Widgets/BottomSheet.vala"
	_tmp45_ = self->priv->handle_wh;
#line 257 "../lib/Widgets/BottomSheet.vala"
	_tmp46_ = title_box;
#line 257 "../lib/Widgets/BottomSheet.vala"
	gtk_window_handle_set_child (_tmp45_, (GtkWidget*) _tmp46_);
#line 259 "../lib/Widgets/BottomSheet.vala"
	_tmp47_ = self->priv->sheet_bin;
#line 259 "../lib/Widgets/BottomSheet.vala"
	_tmp48_ = self->priv->handle_wh;
#line 259 "../lib/Widgets/BottomSheet.vala"
	gtk_box_prepend (_tmp47_, (GtkWidget*) _tmp48_);
#line 260 "../lib/Widgets/BottomSheet.vala"
	_tmp49_ = self->priv->sheet_bin;
#line 260 "../lib/Widgets/BottomSheet.vala"
	_tmp50_ = self->priv->handle;
#line 260 "../lib/Widgets/BottomSheet.vala"
	gtk_box_prepend (_tmp49_, _tmp50_);
#line 262 "../lib/Widgets/BottomSheet.vala"
	_tmp51_ = (GtkGestureClick*) gtk_gesture_click_new ();
#line 262 "../lib/Widgets/BottomSheet.vala"
	click_gesture = _tmp51_;
#line 263 "../lib/Widgets/BottomSheet.vala"
	_tmp52_ = click_gesture;
#line 263 "../lib/Widgets/BottomSheet.vala"
	g_signal_connect_object ((GtkGesture*) _tmp52_, "end", (GCallback) _he_bottom_sheet_close_sheet_gtk_gesture_end, self, 0);
#line 264 "../lib/Widgets/BottomSheet.vala"
	_tmp53_ = self->priv->dimming;
#line 264 "../lib/Widgets/BottomSheet.vala"
	_tmp54_ = click_gesture;
#line 264 "../lib/Widgets/BottomSheet.vala"
	_tmp55_ = _g_object_ref0 ((GtkEventController*) _tmp54_);
#line 264 "../lib/Widgets/BottomSheet.vala"
	gtk_widget_add_controller (_tmp53_, _tmp55_);
#line 266 "../lib/Widgets/BottomSheet.vala"
	_tmp56_ = he_spring_params_new (0.9, (gdouble) 1, (gdouble) 200);
#line 266 "../lib/Widgets/BottomSheet.vala"
	_tmp57_ = he_callback_animation_target_new (__he_bottom_sheet___lambda129__he_animation_target_func, g_object_ref (self), g_object_unref);
#line 266 "../lib/Widgets/BottomSheet.vala"
	_tmp58_ = he_spring_animation_new ((GtkWidget*) self, (gdouble) 0, (gdouble) 1, _tmp56_, (HeAnimationTarget*) _tmp57_);
#line 266 "../lib/Widgets/BottomSheet.vala"
	_g_object_unref0 (self->priv->show_animation);
#line 266 "../lib/Widgets/BottomSheet.vala"
	self->priv->show_animation = _tmp58_;
#line 277 "../lib/Widgets/BottomSheet.vala"
	_tmp59_ = self->priv->show_animation;
#line 277 "../lib/Widgets/BottomSheet.vala"
	g_signal_connect_object ((HeAnimation*) _tmp59_, "done", (GCallback) __he_bottom_sheet___lambda130__he_animation_done, self, 0);
#line 287 "../lib/Widgets/BottomSheet.vala"
	_tmp60_ = self->priv->show_animation;
#line 287 "../lib/Widgets/BottomSheet.vala"
	he_spring_animation_set_epsilon (_tmp60_, 0.001);
#line 289 "../lib/Widgets/BottomSheet.vala"
	he_bottom_sheet_set_show_handle (self, TRUE);
#line 290 "../lib/Widgets/BottomSheet.vala"
	he_bottom_sheet_set_modal (self, TRUE);
#line 206 "../lib/Widgets/BottomSheet.vala"
	_g_object_unref0 (click_gesture);
#line 206 "../lib/Widgets/BottomSheet.vala"
	_g_object_unref0 (title_box);
#line 206 "../lib/Widgets/BottomSheet.vala"
	_g_object_unref0 (close_button);
#line 206 "../lib/Widgets/BottomSheet.vala"
	_g_object_unref0 (gesture_drag);
#line 206 "../lib/Widgets/BottomSheet.vala"
	return obj;
#line 1929 "BottomSheet.c"
}

static void
he_bottom_sheet_class_init (HeBottomSheetClass * klass,
                            gpointer klass_data)
{
#line 25 "../lib/Widgets/BottomSheet.vala"
	he_bottom_sheet_parent_class = g_type_class_peek_parent (klass);
#line 25 "../lib/Widgets/BottomSheet.vala"
	g_type_class_adjust_private_offset (klass, &HeBottomSheet_private_offset);
#line 25 "../lib/Widgets/BottomSheet.vala"
	((GObjectClass *) klass)->dispose = (void (*) (GObject*)) he_bottom_sheet_real_dispose;
#line 25 "../lib/Widgets/BottomSheet.vala"
	((GtkWidgetClass *) klass)->contains = (gboolean (*) (GtkWidget*, gdouble, gdouble)) he_bottom_sheet_real_contains;
#line 25 "../lib/Widgets/BottomSheet.vala"
	((GtkWidgetClass *) klass)->measure = (void (*) (GtkWidget*, GtkOrientation, gint, gint*, gint*, gint*, gint*)) he_bottom_sheet_real_measure;
#line 25 "../lib/Widgets/BottomSheet.vala"
	((GtkWidgetClass *) klass)->size_allocate = (void (*) (GtkWidget*, gint, gint, gint)) he_bottom_sheet_real_size_allocate;
#line 25 "../lib/Widgets/BottomSheet.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_he_bottom_sheet_get_property;
#line 25 "../lib/Widgets/BottomSheet.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_he_bottom_sheet_set_property;
#line 25 "../lib/Widgets/BottomSheet.vala"
	G_OBJECT_CLASS (klass)->constructor = he_bottom_sheet_constructor;
#line 25 "../lib/Widgets/BottomSheet.vala"
	G_OBJECT_CLASS (klass)->finalize = he_bottom_sheet_finalize;
#line 25 "../lib/Widgets/BottomSheet.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_BOTTOM_SHEET_SHEET_PROPERTY, he_bottom_sheet_properties[HE_BOTTOM_SHEET_SHEET_PROPERTY] = g_param_spec_object ("sheet", "sheet", "sheet", gtk_widget_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../lib/Widgets/BottomSheet.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_BOTTOM_SHEET_SHEET_STACK_PROPERTY, he_bottom_sheet_properties[HE_BOTTOM_SHEET_SHEET_STACK_PROPERTY] = g_param_spec_object ("sheet-stack", "sheet-stack", "sheet-stack", gtk_stack_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../lib/Widgets/BottomSheet.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_BOTTOM_SHEET_BUTTON_PROPERTY, he_bottom_sheet_properties[HE_BOTTOM_SHEET_BUTTON_PROPERTY] = g_param_spec_object ("button", "button", "button", gtk_widget_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../lib/Widgets/BottomSheet.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_BOTTOM_SHEET_TITLE_PROPERTY, he_bottom_sheet_properties[HE_BOTTOM_SHEET_TITLE_PROPERTY] = g_param_spec_string ("title", "title", "title", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../lib/Widgets/BottomSheet.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_BOTTOM_SHEET_SHOW_SHEET_PROPERTY, he_bottom_sheet_properties[HE_BOTTOM_SHEET_SHOW_SHEET_PROPERTY] = g_param_spec_boolean ("show-sheet", "show-sheet", "show-sheet", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../lib/Widgets/BottomSheet.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_BOTTOM_SHEET_MODAL_PROPERTY, he_bottom_sheet_properties[HE_BOTTOM_SHEET_MODAL_PROPERTY] = g_param_spec_boolean ("modal", "modal", "modal", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../lib/Widgets/BottomSheet.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_BOTTOM_SHEET_SHOW_HANDLE_PROPERTY, he_bottom_sheet_properties[HE_BOTTOM_SHEET_SHOW_HANDLE_PROPERTY] = g_param_spec_boolean ("show-handle", "show-handle", "show-handle", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../lib/Widgets/BottomSheet.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_BOTTOM_SHEET_PREFERRED_SHEET_HEIGHT_PROPERTY, he_bottom_sheet_properties[HE_BOTTOM_SHEET_PREFERRED_SHEET_HEIGHT_PROPERTY] = g_param_spec_int ("preferred-sheet-height", "preferred-sheet-height", "preferred-sheet-height", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1972 "BottomSheet.c"
	/**
	     * The hidden signal fires when the sheet is hidden.
	     */
#line 25 "../lib/Widgets/BottomSheet.vala"
	he_bottom_sheet_signals[HE_BOTTOM_SHEET_HIDDEN_SIGNAL] = g_signal_new ("hidden", HE_TYPE_BOTTOM_SHEET, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1978 "BottomSheet.c"
}

static void
he_bottom_sheet_instance_init (HeBottomSheet * self,
                               gpointer klass)
{
#line 25 "../lib/Widgets/BottomSheet.vala"
	self->priv = he_bottom_sheet_get_instance_private (self);
#line 43 "../lib/Widgets/BottomSheet.vala"
	self->priv->dragging = FALSE;
#line 44 "../lib/Widgets/BottomSheet.vala"
	self->priv->initial_y = (gdouble) 0;
#line 45 "../lib/Widgets/BottomSheet.vala"
	self->priv->initial_height = 0;
#line 46 "../lib/Widgets/BottomSheet.vala"
	self->priv->target_height = 0;
#line 47 "../lib/Widgets/BottomSheet.vala"
	self->priv->update_interval = 16;
#line 1997 "BottomSheet.c"
}

static void
he_bottom_sheet_finalize (GObject * obj)
{
	HeBottomSheet * self;
#line 25 "../lib/Widgets/BottomSheet.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_BOTTOM_SHEET, HeBottomSheet);
#line 35 "../lib/Widgets/BottomSheet.vala"
	_g_object_unref0 (self->priv->dimming);
#line 36 "../lib/Widgets/BottomSheet.vala"
	_g_object_unref0 (self->priv->handle);
#line 37 "../lib/Widgets/BottomSheet.vala"
	_g_object_unref0 (self->priv->sheet_bin);
#line 38 "../lib/Widgets/BottomSheet.vala"
	_g_object_unref0 (self->priv->title_label);
#line 39 "../lib/Widgets/BottomSheet.vala"
	_g_object_unref0 (self->priv->show_animation);
#line 40 "../lib/Widgets/BottomSheet.vala"
	_g_object_unref0 (self->priv->handle_wh);
#line 41 "../lib/Widgets/BottomSheet.vala"
	_g_source_unref0 (self->priv->resize_timeout);
#line 52 "../lib/Widgets/BottomSheet.vala"
	_g_object_unref0 (self->back_button);
#line 57 "../lib/Widgets/BottomSheet.vala"
	_g_object_unref0 (self->priv->_sheet);
#line 74 "../lib/Widgets/BottomSheet.vala"
	_g_object_unref0 (self->priv->_sheet_stack);
#line 96 "../lib/Widgets/BottomSheet.vala"
	_g_object_unref0 (self->priv->_button);
#line 113 "../lib/Widgets/BottomSheet.vala"
	_g_free0 (self->priv->_title);
#line 25 "../lib/Widgets/BottomSheet.vala"
	G_OBJECT_CLASS (he_bottom_sheet_parent_class)->finalize (obj);
#line 2032 "BottomSheet.c"
}

/**
 * A BottomSheet is a UI component made to showcase accessory actions.
 * It may have an action button.
 * It has a title label and contents.
 */
static GType
he_bottom_sheet_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HeBottomSheetClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) he_bottom_sheet_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HeBottomSheet), 0, (GInstanceInitFunc) he_bottom_sheet_instance_init, NULL };
	GType he_bottom_sheet_type_id;
	he_bottom_sheet_type_id = g_type_register_static (gtk_widget_get_type (), "HeBottomSheet", &g_define_type_info, 0);
	HeBottomSheet_private_offset = g_type_add_instance_private (he_bottom_sheet_type_id, sizeof (HeBottomSheetPrivate));
	return he_bottom_sheet_type_id;
}

GType
he_bottom_sheet_get_type (void)
{
	static volatile gsize he_bottom_sheet_type_id__once = 0;
	if (g_once_init_enter (&he_bottom_sheet_type_id__once)) {
		GType he_bottom_sheet_type_id;
		he_bottom_sheet_type_id = he_bottom_sheet_get_type_once ();
		g_once_init_leave (&he_bottom_sheet_type_id__once, he_bottom_sheet_type_id);
	}
	return he_bottom_sheet_type_id__once;
}

static void
_vala_he_bottom_sheet_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec)
{
	HeBottomSheet * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_BOTTOM_SHEET, HeBottomSheet);
#line 25 "../lib/Widgets/BottomSheet.vala"
	switch (property_id) {
#line 25 "../lib/Widgets/BottomSheet.vala"
		case HE_BOTTOM_SHEET_SHEET_PROPERTY:
#line 25 "../lib/Widgets/BottomSheet.vala"
		g_value_set_object (value, he_bottom_sheet_get_sheet (self));
#line 25 "../lib/Widgets/BottomSheet.vala"
		break;
#line 25 "../lib/Widgets/BottomSheet.vala"
		case HE_BOTTOM_SHEET_SHEET_STACK_PROPERTY:
#line 25 "../lib/Widgets/BottomSheet.vala"
		g_value_set_object (value, he_bottom_sheet_get_sheet_stack (self));
#line 25 "../lib/Widgets/BottomSheet.vala"
		break;
#line 25 "../lib/Widgets/BottomSheet.vala"
		case HE_BOTTOM_SHEET_BUTTON_PROPERTY:
#line 25 "../lib/Widgets/BottomSheet.vala"
		g_value_set_object (value, he_bottom_sheet_get_button (self));
#line 25 "../lib/Widgets/BottomSheet.vala"
		break;
#line 25 "../lib/Widgets/BottomSheet.vala"
		case HE_BOTTOM_SHEET_TITLE_PROPERTY:
#line 25 "../lib/Widgets/BottomSheet.vala"
		g_value_set_string (value, he_bottom_sheet_get_title (self));
#line 25 "../lib/Widgets/BottomSheet.vala"
		break;
#line 25 "../lib/Widgets/BottomSheet.vala"
		case HE_BOTTOM_SHEET_SHOW_SHEET_PROPERTY:
#line 25 "../lib/Widgets/BottomSheet.vala"
		g_value_set_boolean (value, he_bottom_sheet_get_show_sheet (self));
#line 25 "../lib/Widgets/BottomSheet.vala"
		break;
#line 25 "../lib/Widgets/BottomSheet.vala"
		case HE_BOTTOM_SHEET_MODAL_PROPERTY:
#line 25 "../lib/Widgets/BottomSheet.vala"
		g_value_set_boolean (value, he_bottom_sheet_get_modal (self));
#line 25 "../lib/Widgets/BottomSheet.vala"
		break;
#line 25 "../lib/Widgets/BottomSheet.vala"
		case HE_BOTTOM_SHEET_SHOW_HANDLE_PROPERTY:
#line 25 "../lib/Widgets/BottomSheet.vala"
		g_value_set_boolean (value, he_bottom_sheet_get_show_handle (self));
#line 25 "../lib/Widgets/BottomSheet.vala"
		break;
#line 25 "../lib/Widgets/BottomSheet.vala"
		case HE_BOTTOM_SHEET_PREFERRED_SHEET_HEIGHT_PROPERTY:
#line 25 "../lib/Widgets/BottomSheet.vala"
		g_value_set_int (value, he_bottom_sheet_get_preferred_sheet_height (self));
#line 25 "../lib/Widgets/BottomSheet.vala"
		break;
#line 2120 "BottomSheet.c"
		default:
#line 25 "../lib/Widgets/BottomSheet.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 25 "../lib/Widgets/BottomSheet.vala"
		break;
#line 2126 "BottomSheet.c"
	}
}

static void
_vala_he_bottom_sheet_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec)
{
	HeBottomSheet * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_BOTTOM_SHEET, HeBottomSheet);
#line 25 "../lib/Widgets/BottomSheet.vala"
	switch (property_id) {
#line 25 "../lib/Widgets/BottomSheet.vala"
		case HE_BOTTOM_SHEET_SHEET_PROPERTY:
#line 25 "../lib/Widgets/BottomSheet.vala"
		he_bottom_sheet_set_sheet (self, g_value_get_object (value));
#line 25 "../lib/Widgets/BottomSheet.vala"
		break;
#line 25 "../lib/Widgets/BottomSheet.vala"
		case HE_BOTTOM_SHEET_SHEET_STACK_PROPERTY:
#line 25 "../lib/Widgets/BottomSheet.vala"
		he_bottom_sheet_set_sheet_stack (self, g_value_get_object (value));
#line 25 "../lib/Widgets/BottomSheet.vala"
		break;
#line 25 "../lib/Widgets/BottomSheet.vala"
		case HE_BOTTOM_SHEET_BUTTON_PROPERTY:
#line 25 "../lib/Widgets/BottomSheet.vala"
		he_bottom_sheet_set_button (self, g_value_get_object (value));
#line 25 "../lib/Widgets/BottomSheet.vala"
		break;
#line 25 "../lib/Widgets/BottomSheet.vala"
		case HE_BOTTOM_SHEET_TITLE_PROPERTY:
#line 25 "../lib/Widgets/BottomSheet.vala"
		he_bottom_sheet_set_title (self, g_value_get_string (value));
#line 25 "../lib/Widgets/BottomSheet.vala"
		break;
#line 25 "../lib/Widgets/BottomSheet.vala"
		case HE_BOTTOM_SHEET_SHOW_SHEET_PROPERTY:
#line 25 "../lib/Widgets/BottomSheet.vala"
		he_bottom_sheet_set_show_sheet (self, g_value_get_boolean (value));
#line 25 "../lib/Widgets/BottomSheet.vala"
		break;
#line 25 "../lib/Widgets/BottomSheet.vala"
		case HE_BOTTOM_SHEET_MODAL_PROPERTY:
#line 25 "../lib/Widgets/BottomSheet.vala"
		he_bottom_sheet_set_modal (self, g_value_get_boolean (value));
#line 25 "../lib/Widgets/BottomSheet.vala"
		break;
#line 25 "../lib/Widgets/BottomSheet.vala"
		case HE_BOTTOM_SHEET_SHOW_HANDLE_PROPERTY:
#line 25 "../lib/Widgets/BottomSheet.vala"
		he_bottom_sheet_set_show_handle (self, g_value_get_boolean (value));
#line 25 "../lib/Widgets/BottomSheet.vala"
		break;
#line 25 "../lib/Widgets/BottomSheet.vala"
		case HE_BOTTOM_SHEET_PREFERRED_SHEET_HEIGHT_PROPERTY:
#line 25 "../lib/Widgets/BottomSheet.vala"
		he_bottom_sheet_set_preferred_sheet_height (self, g_value_get_int (value));
#line 25 "../lib/Widgets/BottomSheet.vala"
		break;
#line 2188 "BottomSheet.c"
		default:
#line 25 "../lib/Widgets/BottomSheet.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 25 "../lib/Widgets/BottomSheet.vala"
		break;
#line 2194 "BottomSheet.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

