/* DatePicker.c generated by valac 0.56.18, the Vala compiler
 * generated from DatePicker.vala, do not modify */

/*
 * Copyright (c) 2022-2023 Fyra Labs
 * Copyright (c) 2014–2021 elementary, Inc. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include "libhelium-1.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define HE_TYPE_CALENDAR_WIDGET (he_calendar_widget_get_type ())
#define HE_CALENDAR_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), HE_TYPE_CALENDAR_WIDGET, HeCalendarWidget))
#define HE_CALENDAR_WIDGET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), HE_TYPE_CALENDAR_WIDGET, HeCalendarWidgetClass))
#define HE_IS_CALENDAR_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), HE_TYPE_CALENDAR_WIDGET))
#define HE_IS_CALENDAR_WIDGET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), HE_TYPE_CALENDAR_WIDGET))
#define HE_CALENDAR_WIDGET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), HE_TYPE_CALENDAR_WIDGET, HeCalendarWidgetClass))

typedef struct _HeCalendarWidget HeCalendarWidget;
typedef struct _HeCalendarWidgetClass HeCalendarWidgetClass;
enum  {
	HE_DATE_PICKER_0_PROPERTY,
	HE_DATE_PICKER_FORMAT_PROPERTY,
	HE_DATE_PICKER_DATE_PROPERTY,
	HE_DATE_PICKER_NUM_PROPERTIES
};
static GParamSpec* he_date_picker_properties[HE_DATE_PICKER_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block5Data Block5Data;
typedef struct _HeCalendarWidgetPrivate HeCalendarWidgetPrivate;
enum  {
	HE_CALENDAR_WIDGET_0_PROPERTY,
	HE_CALENDAR_WIDGET_DAY_PROPERTY,
	HE_CALENDAR_WIDGET_MONTH_PROPERTY,
	HE_CALENDAR_WIDGET_YEAR_PROPERTY,
	HE_CALENDAR_WIDGET_NUM_PROPERTIES
};
static GParamSpec* he_calendar_widget_properties[HE_CALENDAR_WIDGET_NUM_PROPERTIES];
typedef struct _Block6Data Block6Data;
typedef struct _Block7Data Block7Data;
enum  {
	HE_CALENDAR_WIDGET_DAY_SELECTED_SIGNAL,
	HE_CALENDAR_WIDGET_NUM_SIGNALS
};
static guint he_calendar_widget_signals[HE_CALENDAR_WIDGET_NUM_SIGNALS] = {0};

struct _HeDatePickerPrivate {
	gchar* _format;
	GDateTime* _date;
	HeCalendarWidget* calendar;
};

struct _Block5Data {
	int _ref_count_;
	HeDatePicker* self;
	GtkPopover* popover;
};

struct _HeCalendarWidget {
	HeBin parent_instance;
	HeCalendarWidgetPrivate * priv;
};

struct _HeCalendarWidgetClass {
	HeBinClass parent_class;
};

struct _HeCalendarWidgetPrivate {
	GtkGrid* calendar_grid;
	HeButton* header_label;
	HeButton* left_arrow;
	HeButton* right_arrow;
	gboolean showing_days;
	gint _day;
	gint _month;
	gint _year;
	gint _curr_day;
	gchar** month_names;
	gint month_names_length1;
	gint _month_names_size_;
	gint* days_in_month;
	gint days_in_month_length1;
	gint _days_in_month_size_;
};

struct _Block6Data {
	int _ref_count_;
	HeCalendarWidget* self;
	HeButton* day_label;
};

struct _Block7Data {
	int _ref_count_;
	HeCalendarWidget* self;
	gint month_index;
};

static gint HeDatePicker_private_offset;
static gpointer he_date_picker_parent_class = NULL;
static gint HeCalendarWidget_private_offset;
static gpointer he_calendar_widget_parent_class = NULL;

VALA_EXTERN GType he_calendar_widget_get_type (void) G_GNUC_CONST ;
static GObject * he_date_picker_constructor (GType type,
                                      guint n_construct_properties,
                                      GObjectConstructParam * construct_properties);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
VALA_EXTERN HeCalendarWidget* he_calendar_widget_new (void);
VALA_EXTERN HeCalendarWidget* he_calendar_widget_construct (GType object_type);
VALA_EXTERN void he_calendar_widget_set_day (HeCalendarWidget* self,
                                 gint value);
VALA_EXTERN void he_calendar_widget_set_month (HeCalendarWidget* self,
                                   gint value);
VALA_EXTERN void he_calendar_widget_set_year (HeCalendarWidget* self,
                                  gint value);
static void _he_date_picker___lambda139_ (Block5Data* _data5_);
static void __he_date_picker___lambda139__gtk_entry_icon_release (GtkEntry* _sender,
                                                           GtkEntryIconPosition icon_pos,
                                                           gpointer self);
static void _he_date_picker___lambda140_ (HeDatePicker* self,
                                   gint day,
                                   gint month,
                                   gint year);
static void __he_date_picker___lambda140__he_calendar_widget_day_selected (HeCalendarWidget* _sender,
                                                                    gint day,
                                                                    gint month,
                                                                    gint year,
                                                                    gpointer self);
static void _he_date_picker___lambda141_ (HeDatePicker* self);
VALA_EXTERN void he_calendar_widget_select_day (HeCalendarWidget* self,
                                    GDateTime* date);
static void __he_date_picker___lambda141__g_object_notify (GObject* _sender,
                                                    GParamSpec* pspec,
                                                    gpointer self);
static void he_date_picker_finalize (GObject * obj);
static GType he_date_picker_get_type_once (void);
static void _vala_he_date_picker_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec);
static void _vala_he_date_picker_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec);
VALA_EXTERN gint he_calendar_widget_get_day (HeCalendarWidget* self);
VALA_EXTERN gint he_calendar_widget_get_month (HeCalendarWidget* self);
VALA_EXTERN gint he_calendar_widget_get_year (HeCalendarWidget* self);
static gint he_calendar_widget_get_curr_day (HeCalendarWidget* self);
static void he_calendar_widget_set_curr_day (HeCalendarWidget* self,
                                      gint value);
static void he_calendar_widget_toggle_view (HeCalendarWidget* self);
static void he_calendar_widget_update_calendar_grid (HeCalendarWidget* self);
static void he_calendar_widget_change_month (HeCalendarWidget* self,
                                      gint delta);
static gboolean he_calendar_widget_is_leap_year (HeCalendarWidget* self,
                                          gint year);
static void he_calendar_widget_make_weekday_labels (HeCalendarWidget* self);
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
static void _________lambda134_ (Block6Data* _data6_);
static void __________lambda134__gtk_button_clicked (GtkButton* _sender,
                                              gpointer self);
static Block7Data* block7_data_ref (Block7Data* _data7_);
static void block7_data_unref (void * _userdata_);
static void _________lambda135_ (Block7Data* _data7_);
static void he_calendar_widget_select_month (HeCalendarWidget* self,
                                      gint month_index);
static void __________lambda135__gtk_button_clicked (GtkButton* _sender,
                                              gpointer self);
VALA_EXTERN gchar* he_calendar_widget_get_day_of_week_string (HeCalendarWidget* self,
                                                  gint day_index);
static void g_cclosure_user_marshal_VOID__INT_INT_INT (GClosure * closure,
                                                GValue * return_value,
                                                guint n_param_values,
                                                const GValue * param_values,
                                                gpointer invocation_hint,
                                                gpointer marshal_data);
static GObject * he_calendar_widget_constructor (GType type,
                                          guint n_construct_properties,
                                          GObjectConstructParam * construct_properties);
static void _he_calendar_widget___lambda136_ (HeCalendarWidget* self);
static void __he_calendar_widget___lambda136__gtk_button_clicked (GtkButton* _sender,
                                                           gpointer self);
static void _he_calendar_widget___lambda137_ (HeCalendarWidget* self);
static void __he_calendar_widget___lambda137__gtk_button_clicked (GtkButton* _sender,
                                                           gpointer self);
static void _he_calendar_widget___lambda138_ (HeCalendarWidget* self);
static void __he_calendar_widget___lambda138__gtk_button_clicked (GtkButton* _sender,
                                                           gpointer self);
static void he_calendar_widget_finalize (GObject * obj);
static GType he_calendar_widget_get_type_once (void);
static void _vala_he_calendar_widget_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec);
static void _vala_he_calendar_widget_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
he_date_picker_get_instance_private (HeDatePicker* self)
{
	return G_STRUCT_MEMBER_P (self, HeDatePicker_private_offset);
}

const gchar*
he_date_picker_get_format (HeDatePicker* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 23 "../lib/Widgets/DatePicker.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 23 "../lib/Widgets/DatePicker.vala"
	_tmp0_ = self->priv->_format;
#line 23 "../lib/Widgets/DatePicker.vala"
	result = _tmp0_;
#line 23 "../lib/Widgets/DatePicker.vala"
	return result;
#line 263 "DatePicker.c"
}

static void
he_date_picker_set_format (HeDatePicker* self,
                           const gchar* value)
{
	gchar* old_value;
#line 23 "../lib/Widgets/DatePicker.vala"
	g_return_if_fail (self != NULL);
#line 23 "../lib/Widgets/DatePicker.vala"
	old_value = he_date_picker_get_format (self);
#line 23 "../lib/Widgets/DatePicker.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 277 "DatePicker.c"
		gchar* _tmp0_;
#line 23 "../lib/Widgets/DatePicker.vala"
		_tmp0_ = g_strdup (value);
#line 23 "../lib/Widgets/DatePicker.vala"
		_g_free0 (self->priv->_format);
#line 23 "../lib/Widgets/DatePicker.vala"
		self->priv->_format = _tmp0_;
#line 23 "../lib/Widgets/DatePicker.vala"
		g_object_notify_by_pspec ((GObject *) self, he_date_picker_properties[HE_DATE_PICKER_FORMAT_PROPERTY]);
#line 287 "DatePicker.c"
	}
}

GDateTime*
he_date_picker_get_date (HeDatePicker* self)
{
	GDateTime* result;
	GDateTime* _tmp0_;
#line 27 "../lib/Widgets/DatePicker.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 27 "../lib/Widgets/DatePicker.vala"
	_tmp0_ = self->priv->_date;
#line 27 "../lib/Widgets/DatePicker.vala"
	result = _tmp0_;
#line 27 "../lib/Widgets/DatePicker.vala"
	return result;
#line 304 "DatePicker.c"
}

static gpointer
_g_date_time_ref0 (gpointer self)
{
#line 27 "../lib/Widgets/DatePicker.vala"
	return self ? g_date_time_ref (self) : NULL;
#line 312 "DatePicker.c"
}

void
he_date_picker_set_date (HeDatePicker* self,
                         GDateTime* value)
{
	GDateTime* old_value;
#line 27 "../lib/Widgets/DatePicker.vala"
	g_return_if_fail (self != NULL);
#line 27 "../lib/Widgets/DatePicker.vala"
	old_value = he_date_picker_get_date (self);
#line 27 "../lib/Widgets/DatePicker.vala"
	if (old_value != value) {
#line 326 "DatePicker.c"
		GDateTime* _tmp0_;
#line 27 "../lib/Widgets/DatePicker.vala"
		_tmp0_ = _g_date_time_ref0 (value);
#line 27 "../lib/Widgets/DatePicker.vala"
		_g_date_time_unref0 (self->priv->_date);
#line 27 "../lib/Widgets/DatePicker.vala"
		self->priv->_date = _tmp0_;
#line 27 "../lib/Widgets/DatePicker.vala"
		g_object_notify_by_pspec ((GObject *) self, he_date_picker_properties[HE_DATE_PICKER_DATE_PROPERTY]);
#line 336 "DatePicker.c"
	}
}

/**
     *  Creates this widget with a predetermined date format.
     */
HeDatePicker*
he_date_picker_construct_with_format (GType object_type,
                                      const gchar* format)
{
	HeDatePicker * self = NULL;
#line 34 "../lib/Widgets/DatePicker.vala"
	g_return_val_if_fail (format != NULL, NULL);
#line 35 "../lib/Widgets/DatePicker.vala"
	self = (HeDatePicker*) g_object_new (object_type, "format", format, NULL);
#line 34 "../lib/Widgets/DatePicker.vala"
	return self;
#line 354 "DatePicker.c"
}

HeDatePicker*
he_date_picker_new_with_format (const gchar* format)
{
#line 34 "../lib/Widgets/DatePicker.vala"
	return he_date_picker_construct_with_format (HE_TYPE_DATE_PICKER, format);
#line 362 "DatePicker.c"
}

HeDatePicker*
he_date_picker_construct (GType object_type)
{
	HeDatePicker * self = NULL;
#line 19 "../lib/Widgets/DatePicker.vala"
	self = (HeDatePicker*) g_object_new (object_type, NULL);
#line 19 "../lib/Widgets/DatePicker.vala"
	return self;
#line 373 "DatePicker.c"
}

HeDatePicker*
he_date_picker_new (void)
{
#line 19 "../lib/Widgets/DatePicker.vala"
	return he_date_picker_construct (HE_TYPE_DATE_PICKER);
#line 381 "DatePicker.c"
}

static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
#line 38 "../lib/Widgets/DatePicker.vala"
	g_atomic_int_inc (&_data5_->_ref_count_);
#line 38 "../lib/Widgets/DatePicker.vala"
	return _data5_;
#line 391 "DatePicker.c"
}

static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
#line 38 "../lib/Widgets/DatePicker.vala"
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
#line 401 "DatePicker.c"
		HeDatePicker* self;
#line 38 "../lib/Widgets/DatePicker.vala"
		self = _data5_->self;
#line 38 "../lib/Widgets/DatePicker.vala"
		_g_object_unref0 (_data5_->popover);
#line 38 "../lib/Widgets/DatePicker.vala"
		_g_object_unref0 (self);
#line 38 "../lib/Widgets/DatePicker.vala"
		g_slice_free (Block5Data, _data5_);
#line 411 "DatePicker.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 44 "../lib/Widgets/DatePicker.vala"
	return self ? g_object_ref (self) : NULL;
#line 420 "DatePicker.c"
}

static void
_he_date_picker___lambda139_ (Block5Data* _data5_)
{
	HeDatePicker* self;
	GtkPopover* _tmp0_;
#line 64 "../lib/Widgets/DatePicker.vala"
	self = _data5_->self;
#line 65 "../lib/Widgets/DatePicker.vala"
	_tmp0_ = _data5_->popover;
#line 65 "../lib/Widgets/DatePicker.vala"
	gtk_popover_popup (_tmp0_);
#line 434 "DatePicker.c"
}

static void
__he_date_picker___lambda139__gtk_entry_icon_release (GtkEntry* _sender,
                                                      GtkEntryIconPosition icon_pos,
                                                      gpointer self)
{
#line 64 "../lib/Widgets/DatePicker.vala"
	_he_date_picker___lambda139_ (self);
#line 444 "DatePicker.c"
}

static void
_he_date_picker___lambda140_ (HeDatePicker* self,
                              gint day,
                              gint month,
                              gint year)
{
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
#line 69 "../lib/Widgets/DatePicker.vala"
	_tmp0_ = g_date_time_new_local (year, month + 1, day, 0, 0, (gdouble) 0);
#line 69 "../lib/Widgets/DatePicker.vala"
	_tmp1_ = _tmp0_;
#line 69 "../lib/Widgets/DatePicker.vala"
	he_date_picker_set_date (self, _tmp1_);
#line 69 "../lib/Widgets/DatePicker.vala"
	_g_date_time_unref0 (_tmp1_);
#line 463 "DatePicker.c"
}

static void
__he_date_picker___lambda140__he_calendar_widget_day_selected (HeCalendarWidget* _sender,
                                                               gint day,
                                                               gint month,
                                                               gint year,
                                                               gpointer self)
{
#line 68 "../lib/Widgets/DatePicker.vala"
	_he_date_picker___lambda140_ ((HeDatePicker*) self, day, month, year);
#line 475 "DatePicker.c"
}

static void
_he_date_picker___lambda141_ (HeDatePicker* self)
{
	GDateTime* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	HeCalendarWidget* _tmp4_;
	GDateTime* _tmp5_;
#line 74 "../lib/Widgets/DatePicker.vala"
	_tmp0_ = self->priv->_date;
#line 74 "../lib/Widgets/DatePicker.vala"
	_tmp1_ = self->priv->_format;
#line 74 "../lib/Widgets/DatePicker.vala"
	_tmp2_ = g_date_time_format (_tmp0_, _tmp1_);
#line 74 "../lib/Widgets/DatePicker.vala"
	_tmp3_ = _tmp2_;
#line 74 "../lib/Widgets/DatePicker.vala"
	gtk_editable_set_text ((GtkEditable*) self, _tmp3_);
#line 74 "../lib/Widgets/DatePicker.vala"
	_g_free0 (_tmp3_);
#line 75 "../lib/Widgets/DatePicker.vala"
	_tmp4_ = self->priv->calendar;
#line 75 "../lib/Widgets/DatePicker.vala"
	_tmp5_ = self->priv->_date;
#line 75 "../lib/Widgets/DatePicker.vala"
	he_calendar_widget_select_day (_tmp4_, _tmp5_);
#line 505 "DatePicker.c"
}

static void
__he_date_picker___lambda141__g_object_notify (GObject* _sender,
                                               GParamSpec* pspec,
                                               gpointer self)
{
#line 73 "../lib/Widgets/DatePicker.vala"
	_he_date_picker___lambda141_ ((HeDatePicker*) self);
#line 515 "DatePicker.c"
}

static GObject *
he_date_picker_constructor (GType type,
                            guint n_construct_properties,
                            GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	HeDatePicker * self;
	Block5Data* _data5_;
	const gchar* _tmp0_;
	HeCalendarWidget* _tmp1_;
	HeCalendarWidget* _tmp2_;
	GtkWidget* _tmp3_;
	GtkPopover* _tmp4_ = NULL;
	GtkPopover* _tmp5_;
	GtkPopover* _tmp6_;
	GDateTime* _tmp7_;
	GDateTime* _tmp8_;
	HeCalendarWidget* _tmp9_;
	GDateTime* _tmp10_;
	HeCalendarWidget* _tmp11_;
	GDateTime* _tmp12_;
	HeCalendarWidget* _tmp13_;
	GDateTime* _tmp14_;
	GThemedIcon* _tmp15_;
	GThemedIcon* _tmp16_;
	HeCalendarWidget* _tmp17_;
	GDateTime* _tmp18_;
	const gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
#line 38 "../lib/Widgets/DatePicker.vala"
	parent_class = G_OBJECT_CLASS (he_date_picker_parent_class);
#line 38 "../lib/Widgets/DatePicker.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 38 "../lib/Widgets/DatePicker.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_DATE_PICKER, HeDatePicker);
#line 38 "../lib/Widgets/DatePicker.vala"
	_data5_ = g_slice_new0 (Block5Data);
#line 38 "../lib/Widgets/DatePicker.vala"
	_data5_->_ref_count_ = 1;
#line 38 "../lib/Widgets/DatePicker.vala"
	_data5_->self = g_object_ref (self);
#line 39 "../lib/Widgets/DatePicker.vala"
	_tmp0_ = self->priv->_format;
#line 39 "../lib/Widgets/DatePicker.vala"
	if (_tmp0_ == NULL) {
#line 40 "../lib/Widgets/DatePicker.vala"
		he_date_picker_set_format (self, "%x");
#line 567 "DatePicker.c"
	}
#line 42 "../lib/Widgets/DatePicker.vala"
	_tmp1_ = he_calendar_widget_new ();
#line 42 "../lib/Widgets/DatePicker.vala"
	g_object_ref_sink (_tmp1_);
#line 42 "../lib/Widgets/DatePicker.vala"
	_g_object_unref0 (self->priv->calendar);
#line 42 "../lib/Widgets/DatePicker.vala"
	self->priv->calendar = _tmp1_;
#line 44 "../lib/Widgets/DatePicker.vala"
	_tmp2_ = self->priv->calendar;
#line 44 "../lib/Widgets/DatePicker.vala"
	_tmp3_ = _g_object_ref0 ((GtkWidget*) _tmp2_);
#line 44 "../lib/Widgets/DatePicker.vala"
	_tmp4_ = (GtkPopover*) gtk_popover_new ();
#line 44 "../lib/Widgets/DatePicker.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp4_, GTK_ALIGN_END);
#line 44 "../lib/Widgets/DatePicker.vala"
	gtk_popover_set_autohide (_tmp4_, TRUE);
#line 44 "../lib/Widgets/DatePicker.vala"
	gtk_popover_set_child (_tmp4_, _tmp3_);
#line 44 "../lib/Widgets/DatePicker.vala"
	_g_object_unref0 (_tmp3_);
#line 44 "../lib/Widgets/DatePicker.vala"
	gtk_popover_set_has_arrow (_tmp4_, FALSE);
#line 44 "../lib/Widgets/DatePicker.vala"
	gtk_popover_set_position (_tmp4_, GTK_POS_BOTTOM);
#line 44 "../lib/Widgets/DatePicker.vala"
	g_object_ref_sink (_tmp4_);
#line 44 "../lib/Widgets/DatePicker.vala"
	_data5_->popover = _tmp4_;
#line 51 "../lib/Widgets/DatePicker.vala"
	_tmp5_ = _data5_->popover;
#line 51 "../lib/Widgets/DatePicker.vala"
	gtk_widget_set_parent ((GtkWidget*) _tmp5_, (GtkWidget*) self);
#line 52 "../lib/Widgets/DatePicker.vala"
	_tmp6_ = _data5_->popover;
#line 52 "../lib/Widgets/DatePicker.vala"
	gtk_popover_set_has_arrow (_tmp6_, FALSE);
#line 54 "../lib/Widgets/DatePicker.vala"
	_tmp7_ = g_date_time_new_now_local ();
#line 54 "../lib/Widgets/DatePicker.vala"
	_tmp8_ = _tmp7_;
#line 54 "../lib/Widgets/DatePicker.vala"
	he_date_picker_set_date (self, _tmp8_);
#line 54 "../lib/Widgets/DatePicker.vala"
	_g_date_time_unref0 (_tmp8_);
#line 56 "../lib/Widgets/DatePicker.vala"
	_tmp9_ = self->priv->calendar;
#line 56 "../lib/Widgets/DatePicker.vala"
	_tmp10_ = self->priv->_date;
#line 56 "../lib/Widgets/DatePicker.vala"
	he_calendar_widget_set_day (_tmp9_, g_date_time_get_day_of_month (_tmp10_));
#line 57 "../lib/Widgets/DatePicker.vala"
	_tmp11_ = self->priv->calendar;
#line 57 "../lib/Widgets/DatePicker.vala"
	_tmp12_ = self->priv->_date;
#line 57 "../lib/Widgets/DatePicker.vala"
	he_calendar_widget_set_month (_tmp11_, g_date_time_get_month (_tmp12_) - 1);
#line 58 "../lib/Widgets/DatePicker.vala"
	_tmp13_ = self->priv->calendar;
#line 58 "../lib/Widgets/DatePicker.vala"
	_tmp14_ = self->priv->_date;
#line 58 "../lib/Widgets/DatePicker.vala"
	he_calendar_widget_set_year (_tmp13_, g_date_time_get_year (_tmp14_));
#line 60 "../lib/Widgets/DatePicker.vala"
	gtk_editable_set_editable ((GtkEditable*) self, FALSE);
#line 61 "../lib/Widgets/DatePicker.vala"
	gtk_editable_set_width_chars ((GtkEditable*) self, 11);
#line 62 "../lib/Widgets/DatePicker.vala"
	_tmp15_ = (GThemedIcon*) g_themed_icon_new_with_default_fallbacks ("office-calendar-symbolic");
#line 62 "../lib/Widgets/DatePicker.vala"
	_tmp16_ = _tmp15_;
#line 62 "../lib/Widgets/DatePicker.vala"
	g_object_set ((GtkEntry*) self, "secondary-icon-gicon", (GIcon*) _tmp16_, NULL);
#line 62 "../lib/Widgets/DatePicker.vala"
	_g_object_unref0 (_tmp16_);
#line 64 "../lib/Widgets/DatePicker.vala"
	g_signal_connect_data ((GtkEntry*) self, "icon-release", (GCallback) __he_date_picker___lambda139__gtk_entry_icon_release, block5_data_ref (_data5_), (GClosureNotify) block5_data_unref, 0);
#line 68 "../lib/Widgets/DatePicker.vala"
	_tmp17_ = self->priv->calendar;
#line 68 "../lib/Widgets/DatePicker.vala"
	g_signal_connect_object (_tmp17_, "day-selected", (GCallback) __he_date_picker___lambda140__he_calendar_widget_day_selected, self, 0);
#line 72 "../lib/Widgets/DatePicker.vala"
	_tmp18_ = self->priv->_date;
#line 72 "../lib/Widgets/DatePicker.vala"
	_tmp19_ = self->priv->_format;
#line 72 "../lib/Widgets/DatePicker.vala"
	_tmp20_ = g_date_time_format (_tmp18_, _tmp19_);
#line 72 "../lib/Widgets/DatePicker.vala"
	_tmp21_ = _tmp20_;
#line 72 "../lib/Widgets/DatePicker.vala"
	gtk_editable_set_text ((GtkEditable*) self, _tmp21_);
#line 72 "../lib/Widgets/DatePicker.vala"
	_g_free0 (_tmp21_);
#line 73 "../lib/Widgets/DatePicker.vala"
	g_signal_connect_object ((GObject*) self, "notify::date", (GCallback) __he_date_picker___lambda141__g_object_notify, self, 0);
#line 78 "../lib/Widgets/DatePicker.vala"
	gtk_widget_add_css_class ((GtkWidget*) self, "text-field");
#line 38 "../lib/Widgets/DatePicker.vala"
	block5_data_unref (_data5_);
#line 38 "../lib/Widgets/DatePicker.vala"
	_data5_ = NULL;
#line 38 "../lib/Widgets/DatePicker.vala"
	return obj;
#line 673 "DatePicker.c"
}

static void
he_date_picker_class_init (HeDatePickerClass * klass,
                           gpointer klass_data)
{
#line 19 "../lib/Widgets/DatePicker.vala"
	he_date_picker_parent_class = g_type_class_peek_parent (klass);
#line 19 "../lib/Widgets/DatePicker.vala"
	g_type_class_adjust_private_offset (klass, &HeDatePicker_private_offset);
#line 19 "../lib/Widgets/DatePicker.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_he_date_picker_get_property;
#line 19 "../lib/Widgets/DatePicker.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_he_date_picker_set_property;
#line 19 "../lib/Widgets/DatePicker.vala"
	G_OBJECT_CLASS (klass)->constructor = he_date_picker_constructor;
#line 19 "../lib/Widgets/DatePicker.vala"
	G_OBJECT_CLASS (klass)->finalize = he_date_picker_finalize;
#line 692 "DatePicker.c"
	/**
	     *  The string format of how to display the date.
	     */
#line 19 "../lib/Widgets/DatePicker.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_DATE_PICKER_FORMAT_PROPERTY, he_date_picker_properties[HE_DATE_PICKER_FORMAT_PROPERTY] = g_param_spec_string ("format", "format", "format", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 698 "DatePicker.c"
	/**
	     *  The date to be used.
	     */
#line 19 "../lib/Widgets/DatePicker.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_DATE_PICKER_DATE_PROPERTY, he_date_picker_properties[HE_DATE_PICKER_DATE_PROPERTY] = g_param_spec_boxed ("date", "date", "date", G_TYPE_DATE_TIME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 704 "DatePicker.c"
}

static void
he_date_picker_instance_init (HeDatePicker * self,
                              gpointer klass)
{
#line 19 "../lib/Widgets/DatePicker.vala"
	self->priv = he_date_picker_get_instance_private (self);
#line 713 "DatePicker.c"
}

static void
he_date_picker_finalize (GObject * obj)
{
	HeDatePicker * self;
#line 19 "../lib/Widgets/DatePicker.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_DATE_PICKER, HeDatePicker);
#line 23 "../lib/Widgets/DatePicker.vala"
	_g_free0 (self->priv->_format);
#line 27 "../lib/Widgets/DatePicker.vala"
	_g_date_time_unref0 (self->priv->_date);
#line 29 "../lib/Widgets/DatePicker.vala"
	_g_object_unref0 (self->priv->calendar);
#line 19 "../lib/Widgets/DatePicker.vala"
	G_OBJECT_CLASS (he_date_picker_parent_class)->finalize (obj);
#line 730 "DatePicker.c"
}

static GType
he_date_picker_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HeDatePickerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) he_date_picker_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HeDatePicker), 0, (GInstanceInitFunc) he_date_picker_instance_init, NULL };
	GType he_date_picker_type_id;
	he_date_picker_type_id = g_type_register_static (gtk_entry_get_type (), "HeDatePicker", &g_define_type_info, 0);
	HeDatePicker_private_offset = g_type_add_instance_private (he_date_picker_type_id, sizeof (HeDatePickerPrivate));
	return he_date_picker_type_id;
}

GType
he_date_picker_get_type (void)
{
	static volatile gsize he_date_picker_type_id__once = 0;
	if (g_once_init_enter (&he_date_picker_type_id__once)) {
		GType he_date_picker_type_id;
		he_date_picker_type_id = he_date_picker_get_type_once ();
		g_once_init_leave (&he_date_picker_type_id__once, he_date_picker_type_id);
	}
	return he_date_picker_type_id__once;
}

static void
_vala_he_date_picker_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec)
{
	HeDatePicker * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_DATE_PICKER, HeDatePicker);
#line 19 "../lib/Widgets/DatePicker.vala"
	switch (property_id) {
#line 19 "../lib/Widgets/DatePicker.vala"
		case HE_DATE_PICKER_FORMAT_PROPERTY:
#line 19 "../lib/Widgets/DatePicker.vala"
		g_value_set_string (value, he_date_picker_get_format (self));
#line 19 "../lib/Widgets/DatePicker.vala"
		break;
#line 19 "../lib/Widgets/DatePicker.vala"
		case HE_DATE_PICKER_DATE_PROPERTY:
#line 19 "../lib/Widgets/DatePicker.vala"
		g_value_set_boxed (value, he_date_picker_get_date (self));
#line 19 "../lib/Widgets/DatePicker.vala"
		break;
#line 777 "DatePicker.c"
		default:
#line 19 "../lib/Widgets/DatePicker.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 19 "../lib/Widgets/DatePicker.vala"
		break;
#line 783 "DatePicker.c"
	}
}

static void
_vala_he_date_picker_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec)
{
	HeDatePicker * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_DATE_PICKER, HeDatePicker);
#line 19 "../lib/Widgets/DatePicker.vala"
	switch (property_id) {
#line 19 "../lib/Widgets/DatePicker.vala"
		case HE_DATE_PICKER_FORMAT_PROPERTY:
#line 19 "../lib/Widgets/DatePicker.vala"
		he_date_picker_set_format (self, g_value_get_string (value));
#line 19 "../lib/Widgets/DatePicker.vala"
		break;
#line 19 "../lib/Widgets/DatePicker.vala"
		case HE_DATE_PICKER_DATE_PROPERTY:
#line 19 "../lib/Widgets/DatePicker.vala"
		he_date_picker_set_date (self, g_value_get_boxed (value));
#line 19 "../lib/Widgets/DatePicker.vala"
		break;
#line 809 "DatePicker.c"
		default:
#line 19 "../lib/Widgets/DatePicker.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 19 "../lib/Widgets/DatePicker.vala"
		break;
#line 815 "DatePicker.c"
	}
}

static inline gpointer
he_calendar_widget_get_instance_private (HeCalendarWidget* self)
{
	return G_STRUCT_MEMBER_P (self, HeCalendarWidget_private_offset);
}

gint
he_calendar_widget_get_day (HeCalendarWidget* self)
{
	gint result;
#line 89 "../lib/Widgets/DatePicker.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 89 "../lib/Widgets/DatePicker.vala"
	result = self->priv->_day;
#line 89 "../lib/Widgets/DatePicker.vala"
	return result;
#line 835 "DatePicker.c"
}

void
he_calendar_widget_set_day (HeCalendarWidget* self,
                            gint value)
{
	gint old_value;
#line 89 "../lib/Widgets/DatePicker.vala"
	g_return_if_fail (self != NULL);
#line 89 "../lib/Widgets/DatePicker.vala"
	old_value = he_calendar_widget_get_day (self);
#line 89 "../lib/Widgets/DatePicker.vala"
	if (old_value != value) {
#line 89 "../lib/Widgets/DatePicker.vala"
		self->priv->_day = value;
#line 89 "../lib/Widgets/DatePicker.vala"
		g_object_notify_by_pspec ((GObject *) self, he_calendar_widget_properties[HE_CALENDAR_WIDGET_DAY_PROPERTY]);
#line 853 "DatePicker.c"
	}
}

gint
he_calendar_widget_get_month (HeCalendarWidget* self)
{
	gint result;
#line 90 "../lib/Widgets/DatePicker.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 90 "../lib/Widgets/DatePicker.vala"
	result = self->priv->_month;
#line 90 "../lib/Widgets/DatePicker.vala"
	return result;
#line 867 "DatePicker.c"
}

void
he_calendar_widget_set_month (HeCalendarWidget* self,
                              gint value)
{
	gint old_value;
#line 90 "../lib/Widgets/DatePicker.vala"
	g_return_if_fail (self != NULL);
#line 90 "../lib/Widgets/DatePicker.vala"
	old_value = he_calendar_widget_get_month (self);
#line 90 "../lib/Widgets/DatePicker.vala"
	if (old_value != value) {
#line 90 "../lib/Widgets/DatePicker.vala"
		self->priv->_month = value;
#line 90 "../lib/Widgets/DatePicker.vala"
		g_object_notify_by_pspec ((GObject *) self, he_calendar_widget_properties[HE_CALENDAR_WIDGET_MONTH_PROPERTY]);
#line 885 "DatePicker.c"
	}
}

gint
he_calendar_widget_get_year (HeCalendarWidget* self)
{
	gint result;
#line 91 "../lib/Widgets/DatePicker.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 91 "../lib/Widgets/DatePicker.vala"
	result = self->priv->_year;
#line 91 "../lib/Widgets/DatePicker.vala"
	return result;
#line 899 "DatePicker.c"
}

void
he_calendar_widget_set_year (HeCalendarWidget* self,
                             gint value)
{
	gint old_value;
#line 91 "../lib/Widgets/DatePicker.vala"
	g_return_if_fail (self != NULL);
#line 91 "../lib/Widgets/DatePicker.vala"
	old_value = he_calendar_widget_get_year (self);
#line 91 "../lib/Widgets/DatePicker.vala"
	if (old_value != value) {
#line 91 "../lib/Widgets/DatePicker.vala"
		self->priv->_year = value;
#line 91 "../lib/Widgets/DatePicker.vala"
		g_object_notify_by_pspec ((GObject *) self, he_calendar_widget_properties[HE_CALENDAR_WIDGET_YEAR_PROPERTY]);
#line 917 "DatePicker.c"
	}
}

static gint
he_calendar_widget_get_curr_day (HeCalendarWidget* self)
{
	gint result;
#line 93 "../lib/Widgets/DatePicker.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 93 "../lib/Widgets/DatePicker.vala"
	result = self->priv->_curr_day;
#line 93 "../lib/Widgets/DatePicker.vala"
	return result;
#line 931 "DatePicker.c"
}

static void
he_calendar_widget_set_curr_day (HeCalendarWidget* self,
                                 gint value)
{
#line 93 "../lib/Widgets/DatePicker.vala"
	g_return_if_fail (self != NULL);
#line 93 "../lib/Widgets/DatePicker.vala"
	self->priv->_curr_day = value;
#line 942 "DatePicker.c"
}

static void
he_calendar_widget_toggle_view (HeCalendarWidget* self)
{
#line 168 "../lib/Widgets/DatePicker.vala"
	g_return_if_fail (self != NULL);
#line 169 "../lib/Widgets/DatePicker.vala"
	self->priv->showing_days = !self->priv->showing_days;
#line 170 "../lib/Widgets/DatePicker.vala"
	he_calendar_widget_update_calendar_grid (self);
#line 954 "DatePicker.c"
}

static void
he_calendar_widget_change_month (HeCalendarWidget* self,
                                 gint delta)
{
	gint _tmp0_;
	gint _tmp1_;
	HeButton* _tmp5_;
	gchar** _tmp6_;
	gint _tmp6__length1;
	gint _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gint _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
#line 173 "../lib/Widgets/DatePicker.vala"
	g_return_if_fail (self != NULL);
#line 174 "../lib/Widgets/DatePicker.vala"
	_tmp0_ = self->priv->_month;
#line 174 "../lib/Widgets/DatePicker.vala"
	he_calendar_widget_set_month (self, _tmp0_ + delta);
#line 175 "../lib/Widgets/DatePicker.vala"
	_tmp1_ = self->priv->_month;
#line 175 "../lib/Widgets/DatePicker.vala"
	if (_tmp1_ < 0) {
#line 985 "DatePicker.c"
		gint _tmp2_;
#line 176 "../lib/Widgets/DatePicker.vala"
		he_calendar_widget_set_month (self, 11);
#line 177 "../lib/Widgets/DatePicker.vala"
		_tmp2_ = self->priv->_year;
#line 177 "../lib/Widgets/DatePicker.vala"
		he_calendar_widget_set_year (self, _tmp2_ - 1);
#line 993 "DatePicker.c"
	} else {
		gint _tmp3_;
#line 178 "../lib/Widgets/DatePicker.vala"
		_tmp3_ = self->priv->_month;
#line 178 "../lib/Widgets/DatePicker.vala"
		if (_tmp3_ > 11) {
#line 1000 "DatePicker.c"
			gint _tmp4_;
#line 179 "../lib/Widgets/DatePicker.vala"
			he_calendar_widget_set_month (self, 0);
#line 180 "../lib/Widgets/DatePicker.vala"
			_tmp4_ = self->priv->_year;
#line 180 "../lib/Widgets/DatePicker.vala"
			he_calendar_widget_set_year (self, _tmp4_ + 1);
#line 1008 "DatePicker.c"
		}
	}
#line 182 "../lib/Widgets/DatePicker.vala"
	_tmp5_ = self->priv->header_label;
#line 182 "../lib/Widgets/DatePicker.vala"
	_tmp6_ = self->priv->month_names;
#line 182 "../lib/Widgets/DatePicker.vala"
	_tmp6__length1 = self->priv->month_names_length1;
#line 182 "../lib/Widgets/DatePicker.vala"
	_tmp7_ = self->priv->_month;
#line 182 "../lib/Widgets/DatePicker.vala"
	_tmp8_ = _tmp6_[_tmp7_];
#line 182 "../lib/Widgets/DatePicker.vala"
	_tmp9_ = g_strconcat (_tmp8_, " ", NULL);
#line 182 "../lib/Widgets/DatePicker.vala"
	_tmp10_ = _tmp9_;
#line 182 "../lib/Widgets/DatePicker.vala"
	_tmp11_ = self->priv->_year;
#line 182 "../lib/Widgets/DatePicker.vala"
	_tmp12_ = g_strdup_printf ("%i", _tmp11_);
#line 182 "../lib/Widgets/DatePicker.vala"
	_tmp13_ = _tmp12_;
#line 182 "../lib/Widgets/DatePicker.vala"
	_tmp14_ = g_strconcat (_tmp10_, _tmp13_, NULL);
#line 182 "../lib/Widgets/DatePicker.vala"
	_tmp15_ = _tmp14_;
#line 182 "../lib/Widgets/DatePicker.vala"
	gtk_button_set_label ((GtkButton*) _tmp5_, _tmp15_);
#line 182 "../lib/Widgets/DatePicker.vala"
	_g_free0 (_tmp15_);
#line 182 "../lib/Widgets/DatePicker.vala"
	_g_free0 (_tmp13_);
#line 182 "../lib/Widgets/DatePicker.vala"
	_g_free0 (_tmp10_);
#line 183 "../lib/Widgets/DatePicker.vala"
	he_calendar_widget_update_calendar_grid (self);
#line 1045 "DatePicker.c"
}

static Block6Data*
block6_data_ref (Block6Data* _data6_)
{
#line 200 "../lib/Widgets/DatePicker.vala"
	g_atomic_int_inc (&_data6_->_ref_count_);
#line 200 "../lib/Widgets/DatePicker.vala"
	return _data6_;
#line 1055 "DatePicker.c"
}

static void
block6_data_unref (void * _userdata_)
{
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
#line 200 "../lib/Widgets/DatePicker.vala"
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
#line 1065 "DatePicker.c"
		HeCalendarWidget* self;
#line 200 "../lib/Widgets/DatePicker.vala"
		self = _data6_->self;
#line 200 "../lib/Widgets/DatePicker.vala"
		_g_object_unref0 (_data6_->day_label);
#line 200 "../lib/Widgets/DatePicker.vala"
		_g_object_unref0 (self);
#line 200 "../lib/Widgets/DatePicker.vala"
		g_slice_free (Block6Data, _data6_);
#line 1075 "DatePicker.c"
	}
}

static void
_________lambda134_ (Block6Data* _data6_)
{
	HeCalendarWidget* self;
	HeButton* _tmp0_;
	const gchar* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 212 "../lib/Widgets/DatePicker.vala"
	self = _data6_->self;
#line 212 "../lib/Widgets/DatePicker.vala"
	_tmp0_ = _data6_->day_label;
#line 212 "../lib/Widgets/DatePicker.vala"
	_tmp1_ = gtk_button_get_label ((GtkButton*) _tmp0_);
#line 212 "../lib/Widgets/DatePicker.vala"
	_tmp2_ = self->priv->_month;
#line 212 "../lib/Widgets/DatePicker.vala"
	_tmp3_ = self->priv->_year;
#line 212 "../lib/Widgets/DatePicker.vala"
	g_signal_emit (self, he_calendar_widget_signals[HE_CALENDAR_WIDGET_DAY_SELECTED_SIGNAL], 0, atoi (_tmp1_), _tmp2_, _tmp3_);
#line 1099 "DatePicker.c"
}

static void
__________lambda134__gtk_button_clicked (GtkButton* _sender,
                                         gpointer self)
{
#line 212 "../lib/Widgets/DatePicker.vala"
	_________lambda134_ (self);
#line 1108 "DatePicker.c"
}

static Block7Data*
block7_data_ref (Block7Data* _data7_)
{
#line 227 "../lib/Widgets/DatePicker.vala"
	g_atomic_int_inc (&_data7_->_ref_count_);
#line 227 "../lib/Widgets/DatePicker.vala"
	return _data7_;
#line 1118 "DatePicker.c"
}

static void
block7_data_unref (void * _userdata_)
{
	Block7Data* _data7_;
	_data7_ = (Block7Data*) _userdata_;
#line 227 "../lib/Widgets/DatePicker.vala"
	if (g_atomic_int_dec_and_test (&_data7_->_ref_count_)) {
#line 1128 "DatePicker.c"
		HeCalendarWidget* self;
#line 227 "../lib/Widgets/DatePicker.vala"
		self = _data7_->self;
#line 227 "../lib/Widgets/DatePicker.vala"
		_g_object_unref0 (self);
#line 227 "../lib/Widgets/DatePicker.vala"
		g_slice_free (Block7Data, _data7_);
#line 1136 "DatePicker.c"
	}
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1501 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1501 "glib-2.0.vapi"
	end = _tmp0_;
#line 1502 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1502 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1503 "glib-2.0.vapi"
		result = maxlen;
#line 1503 "glib-2.0.vapi"
		return result;
#line 1160 "DatePicker.c"
	} else {
		gchar* _tmp2_;
#line 1505 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1505 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1505 "glib-2.0.vapi"
		return result;
#line 1169 "DatePicker.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1512 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1514 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 1188 "DatePicker.c"
	} else {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 1192 "DatePicker.c"
	}
#line 1514 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1516 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 1198 "DatePicker.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1518 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1518 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1518 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 1208 "DatePicker.c"
	}
#line 1521 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1522 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1523 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 1216 "DatePicker.c"
	} else {
#line 1525 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 1220 "DatePicker.c"
	}
#line 1527 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1528 "glib-2.0.vapi"
		len = string_length - offset;
#line 1226 "DatePicker.c"
	}
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1531 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1531 "glib-2.0.vapi"
	result = _tmp3_;
#line 1531 "glib-2.0.vapi"
	return result;
#line 1236 "DatePicker.c"
}

static void
_________lambda135_ (Block7Data* _data7_)
{
	HeCalendarWidget* self;
#line 241 "../lib/Widgets/DatePicker.vala"
	self = _data7_->self;
#line 241 "../lib/Widgets/DatePicker.vala"
	he_calendar_widget_select_month (self, _data7_->month_index);
#line 1247 "DatePicker.c"
}

static void
__________lambda135__gtk_button_clicked (GtkButton* _sender,
                                         gpointer self)
{
#line 241 "../lib/Widgets/DatePicker.vala"
	_________lambda135_ (self);
#line 1256 "DatePicker.c"
}

static void
he_calendar_widget_update_calendar_grid (HeCalendarWidget* self)
{
#line 186 "../lib/Widgets/DatePicker.vala"
	g_return_if_fail (self != NULL);
#line 1264 "DatePicker.c"
	{
		gboolean _tmp0_ = FALSE;
#line 187 "../lib/Widgets/DatePicker.vala"
		_tmp0_ = TRUE;
#line 187 "../lib/Widgets/DatePicker.vala"
		while (TRUE) {
#line 1271 "DatePicker.c"
			GtkGrid* _tmp3_;
			GtkGrid* _tmp4_;
			GtkWidget* _tmp5_;
#line 187 "../lib/Widgets/DatePicker.vala"
			if (!_tmp0_) {
#line 1277 "DatePicker.c"
				GtkGrid* _tmp1_;
				GtkWidget* _tmp2_;
#line 189 "../lib/Widgets/DatePicker.vala"
				_tmp1_ = self->priv->calendar_grid;
#line 189 "../lib/Widgets/DatePicker.vala"
				_tmp2_ = gtk_widget_get_last_child ((GtkWidget*) _tmp1_);
#line 189 "../lib/Widgets/DatePicker.vala"
				if (!(_tmp2_ != NULL)) {
#line 189 "../lib/Widgets/DatePicker.vala"
					break;
#line 1288 "DatePicker.c"
				}
			}
#line 187 "../lib/Widgets/DatePicker.vala"
			_tmp0_ = FALSE;
#line 188 "../lib/Widgets/DatePicker.vala"
			_tmp3_ = self->priv->calendar_grid;
#line 188 "../lib/Widgets/DatePicker.vala"
			_tmp4_ = self->priv->calendar_grid;
#line 188 "../lib/Widgets/DatePicker.vala"
			_tmp5_ = gtk_widget_get_last_child ((GtkWidget*) _tmp4_);
#line 188 "../lib/Widgets/DatePicker.vala"
			gtk_grid_remove (_tmp3_, _tmp5_);
#line 1301 "DatePicker.c"
		}
	}
#line 191 "../lib/Widgets/DatePicker.vala"
	if (self->priv->showing_days) {
#line 1306 "DatePicker.c"
		gint days = 0;
		gint* _tmp6_;
		gint _tmp6__length1;
		gint _tmp7_;
		gint _tmp8_;
		gboolean _tmp9_ = FALSE;
#line 192 "../lib/Widgets/DatePicker.vala"
		_tmp6_ = self->priv->days_in_month;
#line 192 "../lib/Widgets/DatePicker.vala"
		_tmp6__length1 = self->priv->days_in_month_length1;
#line 192 "../lib/Widgets/DatePicker.vala"
		_tmp7_ = self->priv->_month;
#line 192 "../lib/Widgets/DatePicker.vala"
		_tmp8_ = _tmp6_[_tmp7_];
#line 192 "../lib/Widgets/DatePicker.vala"
		days = _tmp8_;
#line 193 "../lib/Widgets/DatePicker.vala"
		if (self->priv->_month == 1) {
#line 1325 "DatePicker.c"
			gint _tmp10_;
#line 193 "../lib/Widgets/DatePicker.vala"
			_tmp10_ = self->priv->_year;
#line 193 "../lib/Widgets/DatePicker.vala"
			_tmp9_ = he_calendar_widget_is_leap_year (self, _tmp10_);
#line 1331 "DatePicker.c"
		} else {
#line 193 "../lib/Widgets/DatePicker.vala"
			_tmp9_ = FALSE;
#line 1335 "DatePicker.c"
		}
#line 193 "../lib/Widgets/DatePicker.vala"
		if (_tmp9_) {
#line 194 "../lib/Widgets/DatePicker.vala"
			days = 29;
#line 1341 "DatePicker.c"
		}
#line 197 "../lib/Widgets/DatePicker.vala"
		he_calendar_widget_make_weekday_labels (self);
#line 1345 "DatePicker.c"
		{
			gint i = 0;
#line 199 "../lib/Widgets/DatePicker.vala"
			i = 0;
#line 1350 "DatePicker.c"
			{
				gboolean _tmp11_ = FALSE;
#line 199 "../lib/Widgets/DatePicker.vala"
				_tmp11_ = TRUE;
#line 199 "../lib/Widgets/DatePicker.vala"
				while (TRUE) {
#line 199 "../lib/Widgets/DatePicker.vala"
					if (!_tmp11_) {
#line 1359 "DatePicker.c"
						gint _tmp12_;
#line 199 "../lib/Widgets/DatePicker.vala"
						_tmp12_ = i;
#line 199 "../lib/Widgets/DatePicker.vala"
						i = _tmp12_ + 1;
#line 1365 "DatePicker.c"
					}
#line 199 "../lib/Widgets/DatePicker.vala"
					_tmp11_ = FALSE;
#line 199 "../lib/Widgets/DatePicker.vala"
					if (!(i < 6)) {
#line 199 "../lib/Widgets/DatePicker.vala"
						break;
#line 1373 "DatePicker.c"
					}
					{
						gint j = 0;
#line 200 "../lib/Widgets/DatePicker.vala"
						j = 0;
#line 1379 "DatePicker.c"
						{
							gboolean _tmp13_ = FALSE;
#line 200 "../lib/Widgets/DatePicker.vala"
							_tmp13_ = TRUE;
#line 200 "../lib/Widgets/DatePicker.vala"
							while (TRUE) {
#line 1386 "DatePicker.c"
								Block6Data* _data6_;
								gint day = 0;
								gchar* _tmp15_;
								gchar* _tmp16_;
								HeButton* _tmp17_ = NULL;
								HeButton* _tmp18_;
								HeButton* _tmp19_;
								HeButton* _tmp20_;
								HeButton* _tmp21_;
								HeButton* _tmp22_;
								gint _tmp23_;
								GtkGrid* _tmp28_;
								HeButton* _tmp29_;
#line 200 "../lib/Widgets/DatePicker.vala"
								_data6_ = g_slice_new0 (Block6Data);
#line 200 "../lib/Widgets/DatePicker.vala"
								_data6_->_ref_count_ = 1;
#line 200 "../lib/Widgets/DatePicker.vala"
								_data6_->self = g_object_ref (self);
#line 200 "../lib/Widgets/DatePicker.vala"
								if (!_tmp13_) {
#line 1408 "DatePicker.c"
									gint _tmp14_;
#line 200 "../lib/Widgets/DatePicker.vala"
									_tmp14_ = j;
#line 200 "../lib/Widgets/DatePicker.vala"
									j = _tmp14_ + 1;
#line 1414 "DatePicker.c"
								}
#line 200 "../lib/Widgets/DatePicker.vala"
								_tmp13_ = FALSE;
#line 200 "../lib/Widgets/DatePicker.vala"
								if (!(j < 7)) {
#line 200 "../lib/Widgets/DatePicker.vala"
									block6_data_unref (_data6_);
#line 200 "../lib/Widgets/DatePicker.vala"
									_data6_ = NULL;
#line 200 "../lib/Widgets/DatePicker.vala"
									break;
#line 1426 "DatePicker.c"
								}
#line 201 "../lib/Widgets/DatePicker.vala"
								day = ((i * 7) + j) + 1;
#line 202 "../lib/Widgets/DatePicker.vala"
								if (day > days) {
#line 202 "../lib/Widgets/DatePicker.vala"
									block6_data_unref (_data6_);
#line 202 "../lib/Widgets/DatePicker.vala"
									_data6_ = NULL;
#line 202 "../lib/Widgets/DatePicker.vala"
									break;
#line 1438 "DatePicker.c"
								}
#line 204 "../lib/Widgets/DatePicker.vala"
								_tmp15_ = g_strdup_printf ("%i", day);
#line 204 "../lib/Widgets/DatePicker.vala"
								_tmp16_ = _tmp15_;
#line 204 "../lib/Widgets/DatePicker.vala"
								_tmp17_ = he_button_new (NULL, _tmp16_);
#line 204 "../lib/Widgets/DatePicker.vala"
								gtk_widget_set_halign ((GtkWidget*) _tmp17_, GTK_ALIGN_CENTER);
#line 204 "../lib/Widgets/DatePicker.vala"
								gtk_widget_set_valign ((GtkWidget*) _tmp17_, GTK_ALIGN_CENTER);
#line 204 "../lib/Widgets/DatePicker.vala"
								he_button_set_is_textual (_tmp17_, TRUE);
#line 204 "../lib/Widgets/DatePicker.vala"
								g_object_ref_sink (_tmp17_);
#line 204 "../lib/Widgets/DatePicker.vala"
								_tmp18_ = _tmp17_;
#line 204 "../lib/Widgets/DatePicker.vala"
								_g_free0 (_tmp16_);
#line 204 "../lib/Widgets/DatePicker.vala"
								_data6_->day_label = _tmp18_;
#line 209 "../lib/Widgets/DatePicker.vala"
								_tmp19_ = _data6_->day_label;
#line 209 "../lib/Widgets/DatePicker.vala"
								gtk_widget_add_css_class ((GtkWidget*) _tmp19_, "numeric");
#line 210 "../lib/Widgets/DatePicker.vala"
								_tmp20_ = _data6_->day_label;
#line 210 "../lib/Widgets/DatePicker.vala"
								gtk_widget_add_css_class ((GtkWidget*) _tmp20_, "circular");
#line 211 "../lib/Widgets/DatePicker.vala"
								_tmp21_ = _data6_->day_label;
#line 211 "../lib/Widgets/DatePicker.vala"
								gtk_widget_remove_css_class ((GtkWidget*) _tmp21_, "textual-button");
#line 212 "../lib/Widgets/DatePicker.vala"
								_tmp22_ = _data6_->day_label;
#line 212 "../lib/Widgets/DatePicker.vala"
								g_signal_connect_data ((GtkButton*) _tmp22_, "clicked", (GCallback) __________lambda134__gtk_button_clicked, block6_data_ref (_data6_), (GClosureNotify) block6_data_unref, 0);
#line 214 "../lib/Widgets/DatePicker.vala"
								_tmp23_ = self->priv->_curr_day;
#line 214 "../lib/Widgets/DatePicker.vala"
								if (day == _tmp23_) {
#line 1480 "DatePicker.c"
									HeButton* _tmp24_;
									HeButton* _tmp25_;
#line 215 "../lib/Widgets/DatePicker.vala"
									_tmp24_ = _data6_->day_label;
#line 215 "../lib/Widgets/DatePicker.vala"
									gtk_widget_add_css_class ((GtkWidget*) _tmp24_, "day");
#line 216 "../lib/Widgets/DatePicker.vala"
									_tmp25_ = _data6_->day_label;
#line 216 "../lib/Widgets/DatePicker.vala"
									gtk_widget_remove_css_class ((GtkWidget*) _tmp25_, "flat");
#line 1491 "DatePicker.c"
								} else {
									HeButton* _tmp26_;
									HeButton* _tmp27_;
#line 218 "../lib/Widgets/DatePicker.vala"
									_tmp26_ = _data6_->day_label;
#line 218 "../lib/Widgets/DatePicker.vala"
									gtk_widget_remove_css_class ((GtkWidget*) _tmp26_, "day");
#line 219 "../lib/Widgets/DatePicker.vala"
									_tmp27_ = _data6_->day_label;
#line 219 "../lib/Widgets/DatePicker.vala"
									gtk_widget_add_css_class ((GtkWidget*) _tmp27_, "flat");
#line 1503 "DatePicker.c"
								}
#line 222 "../lib/Widgets/DatePicker.vala"
								_tmp28_ = self->priv->calendar_grid;
#line 222 "../lib/Widgets/DatePicker.vala"
								_tmp29_ = _data6_->day_label;
#line 222 "../lib/Widgets/DatePicker.vala"
								gtk_grid_attach (_tmp28_, (GtkWidget*) _tmp29_, j, i + 1, 1, 1);
#line 200 "../lib/Widgets/DatePicker.vala"
								block6_data_unref (_data6_);
#line 200 "../lib/Widgets/DatePicker.vala"
								_data6_ = NULL;
#line 1515 "DatePicker.c"
							}
						}
					}
				}
			}
		}
	} else {
		{
			gint i = 0;
#line 226 "../lib/Widgets/DatePicker.vala"
			i = 0;
#line 1527 "DatePicker.c"
			{
				gboolean _tmp30_ = FALSE;
#line 226 "../lib/Widgets/DatePicker.vala"
				_tmp30_ = TRUE;
#line 226 "../lib/Widgets/DatePicker.vala"
				while (TRUE) {
#line 226 "../lib/Widgets/DatePicker.vala"
					if (!_tmp30_) {
#line 1536 "DatePicker.c"
						gint _tmp31_;
#line 226 "../lib/Widgets/DatePicker.vala"
						_tmp31_ = i;
#line 226 "../lib/Widgets/DatePicker.vala"
						i = _tmp31_ + 1;
#line 1542 "DatePicker.c"
					}
#line 226 "../lib/Widgets/DatePicker.vala"
					_tmp30_ = FALSE;
#line 226 "../lib/Widgets/DatePicker.vala"
					if (!(i < 3)) {
#line 226 "../lib/Widgets/DatePicker.vala"
						break;
#line 1550 "DatePicker.c"
					}
					{
						gint j = 0;
#line 227 "../lib/Widgets/DatePicker.vala"
						j = 0;
#line 1556 "DatePicker.c"
						{
							gboolean _tmp32_ = FALSE;
#line 227 "../lib/Widgets/DatePicker.vala"
							_tmp32_ = TRUE;
#line 227 "../lib/Widgets/DatePicker.vala"
							while (TRUE) {
#line 1563 "DatePicker.c"
								Block7Data* _data7_;
								HeButton* month_label = NULL;
								gchar** _tmp34_;
								gint _tmp34__length1;
								const gchar* _tmp35_;
								gchar* _tmp36_;
								gchar* _tmp37_;
								HeButton* _tmp38_ = NULL;
								HeButton* _tmp39_;
								HeButton* _tmp40_;
								HeButton* _tmp41_;
								HeButton* _tmp42_;
								HeButton* _tmp43_;
								GtkGrid* _tmp44_;
								HeButton* _tmp45_;
#line 227 "../lib/Widgets/DatePicker.vala"
								_data7_ = g_slice_new0 (Block7Data);
#line 227 "../lib/Widgets/DatePicker.vala"
								_data7_->_ref_count_ = 1;
#line 227 "../lib/Widgets/DatePicker.vala"
								_data7_->self = g_object_ref (self);
#line 227 "../lib/Widgets/DatePicker.vala"
								if (!_tmp32_) {
#line 1587 "DatePicker.c"
									gint _tmp33_;
#line 227 "../lib/Widgets/DatePicker.vala"
									_tmp33_ = j;
#line 227 "../lib/Widgets/DatePicker.vala"
									j = _tmp33_ + 1;
#line 1593 "DatePicker.c"
								}
#line 227 "../lib/Widgets/DatePicker.vala"
								_tmp32_ = FALSE;
#line 227 "../lib/Widgets/DatePicker.vala"
								if (!(j < 4)) {
#line 227 "../lib/Widgets/DatePicker.vala"
									block7_data_unref (_data7_);
#line 227 "../lib/Widgets/DatePicker.vala"
									_data7_ = NULL;
#line 227 "../lib/Widgets/DatePicker.vala"
									break;
#line 1605 "DatePicker.c"
								}
#line 228 "../lib/Widgets/DatePicker.vala"
								_data7_->month_index = (i * 4) + j;
#line 230 "../lib/Widgets/DatePicker.vala"
								_tmp34_ = self->priv->month_names;
#line 230 "../lib/Widgets/DatePicker.vala"
								_tmp34__length1 = self->priv->month_names_length1;
#line 230 "../lib/Widgets/DatePicker.vala"
								_tmp35_ = _tmp34_[_data7_->month_index];
#line 230 "../lib/Widgets/DatePicker.vala"
								_tmp36_ = string_substring (_tmp35_, (glong) 0, (glong) 3);
#line 230 "../lib/Widgets/DatePicker.vala"
								_tmp37_ = _tmp36_;
#line 230 "../lib/Widgets/DatePicker.vala"
								_tmp38_ = he_button_new (NULL, _tmp37_);
#line 230 "../lib/Widgets/DatePicker.vala"
								gtk_widget_set_halign ((GtkWidget*) _tmp38_, GTK_ALIGN_CENTER);
#line 230 "../lib/Widgets/DatePicker.vala"
								gtk_widget_set_valign ((GtkWidget*) _tmp38_, GTK_ALIGN_CENTER);
#line 230 "../lib/Widgets/DatePicker.vala"
								he_button_set_is_textual (_tmp38_, TRUE);
#line 230 "../lib/Widgets/DatePicker.vala"
								gtk_widget_set_hexpand ((GtkWidget*) _tmp38_, TRUE);
#line 230 "../lib/Widgets/DatePicker.vala"
								g_object_set ((GtkWidget*) _tmp38_, "width-request", 42, NULL);
#line 230 "../lib/Widgets/DatePicker.vala"
								g_object_set ((GtkWidget*) _tmp38_, "height-request", 42, NULL);
#line 230 "../lib/Widgets/DatePicker.vala"
								g_object_ref_sink (_tmp38_);
#line 230 "../lib/Widgets/DatePicker.vala"
								_tmp39_ = _tmp38_;
#line 230 "../lib/Widgets/DatePicker.vala"
								_g_free0 (_tmp37_);
#line 230 "../lib/Widgets/DatePicker.vala"
								month_label = _tmp39_;
#line 238 "../lib/Widgets/DatePicker.vala"
								_tmp40_ = month_label;
#line 238 "../lib/Widgets/DatePicker.vala"
								gtk_widget_add_css_class ((GtkWidget*) _tmp40_, "cb-subtitle");
#line 239 "../lib/Widgets/DatePicker.vala"
								_tmp41_ = month_label;
#line 239 "../lib/Widgets/DatePicker.vala"
								gtk_widget_add_css_class ((GtkWidget*) _tmp41_, "flat");
#line 240 "../lib/Widgets/DatePicker.vala"
								_tmp42_ = month_label;
#line 240 "../lib/Widgets/DatePicker.vala"
								gtk_widget_add_css_class ((GtkWidget*) _tmp42_, "circular");
#line 241 "../lib/Widgets/DatePicker.vala"
								_tmp43_ = month_label;
#line 241 "../lib/Widgets/DatePicker.vala"
								g_signal_connect_data ((GtkButton*) _tmp43_, "clicked", (GCallback) __________lambda135__gtk_button_clicked, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
#line 243 "../lib/Widgets/DatePicker.vala"
								_tmp44_ = self->priv->calendar_grid;
#line 243 "../lib/Widgets/DatePicker.vala"
								_tmp45_ = month_label;
#line 243 "../lib/Widgets/DatePicker.vala"
								gtk_grid_attach (_tmp44_, (GtkWidget*) _tmp45_, j, i, 1, 1);
#line 227 "../lib/Widgets/DatePicker.vala"
								_g_object_unref0 (month_label);
#line 227 "../lib/Widgets/DatePicker.vala"
								block7_data_unref (_data7_);
#line 227 "../lib/Widgets/DatePicker.vala"
								_data7_ = NULL;
#line 1669 "DatePicker.c"
							}
						}
					}
				}
			}
		}
	}
}

static void
he_calendar_widget_make_weekday_labels (HeCalendarWidget* self)
{
#line 249 "../lib/Widgets/DatePicker.vala"
	g_return_if_fail (self != NULL);
#line 1684 "DatePicker.c"
	{
		gint i = 0;
#line 250 "../lib/Widgets/DatePicker.vala"
		i = 0;
#line 1689 "DatePicker.c"
		{
			gboolean _tmp0_ = FALSE;
#line 250 "../lib/Widgets/DatePicker.vala"
			_tmp0_ = TRUE;
#line 250 "../lib/Widgets/DatePicker.vala"
			while (TRUE) {
#line 1696 "DatePicker.c"
				GtkLabel* label = NULL;
				gchar* _tmp2_;
				gchar* _tmp3_;
				GtkLabel* _tmp4_;
				GtkLabel* _tmp5_;
				GtkLabel* _tmp6_;
				GtkLabel* _tmp7_;
				GtkLabel* _tmp8_;
				GtkLabel* _tmp9_;
				GtkLabel* _tmp10_;
				GtkLabel* _tmp11_;
				GtkGrid* _tmp12_;
				GtkLabel* _tmp13_;
#line 250 "../lib/Widgets/DatePicker.vala"
				if (!_tmp0_) {
#line 1712 "DatePicker.c"
					gint _tmp1_;
#line 250 "../lib/Widgets/DatePicker.vala"
					_tmp1_ = i;
#line 250 "../lib/Widgets/DatePicker.vala"
					i = _tmp1_ + 1;
#line 1718 "DatePicker.c"
				}
#line 250 "../lib/Widgets/DatePicker.vala"
				_tmp0_ = FALSE;
#line 250 "../lib/Widgets/DatePicker.vala"
				if (!(i < 7)) {
#line 250 "../lib/Widgets/DatePicker.vala"
					break;
#line 1726 "DatePicker.c"
				}
#line 251 "../lib/Widgets/DatePicker.vala"
				_tmp2_ = he_calendar_widget_get_day_of_week_string (self, i);
#line 251 "../lib/Widgets/DatePicker.vala"
				_tmp3_ = _tmp2_;
#line 251 "../lib/Widgets/DatePicker.vala"
				_tmp4_ = (GtkLabel*) gtk_label_new (_tmp3_);
#line 251 "../lib/Widgets/DatePicker.vala"
				g_object_ref_sink (_tmp4_);
#line 251 "../lib/Widgets/DatePicker.vala"
				_tmp5_ = _tmp4_;
#line 251 "../lib/Widgets/DatePicker.vala"
				_g_free0 (_tmp3_);
#line 251 "../lib/Widgets/DatePicker.vala"
				label = _tmp5_;
#line 252 "../lib/Widgets/DatePicker.vala"
				_tmp6_ = label;
#line 252 "../lib/Widgets/DatePicker.vala"
				gtk_widget_set_halign ((GtkWidget*) _tmp6_, GTK_ALIGN_START);
#line 253 "../lib/Widgets/DatePicker.vala"
				_tmp7_ = label;
#line 253 "../lib/Widgets/DatePicker.vala"
				gtk_widget_set_size_request ((GtkWidget*) _tmp7_, -1, 20);
#line 254 "../lib/Widgets/DatePicker.vala"
				_tmp8_ = label;
#line 254 "../lib/Widgets/DatePicker.vala"
				gtk_widget_add_css_class ((GtkWidget*) _tmp8_, "caption");
#line 255 "../lib/Widgets/DatePicker.vala"
				_tmp9_ = label;
#line 255 "../lib/Widgets/DatePicker.vala"
				gtk_widget_add_css_class ((GtkWidget*) _tmp9_, "numeric");
#line 256 "../lib/Widgets/DatePicker.vala"
				_tmp10_ = label;
#line 256 "../lib/Widgets/DatePicker.vala"
				gtk_widget_add_css_class ((GtkWidget*) _tmp10_, "dim-label");
#line 257 "../lib/Widgets/DatePicker.vala"
				_tmp11_ = label;
#line 257 "../lib/Widgets/DatePicker.vala"
				gtk_label_set_width_chars (_tmp11_, 5);
#line 258 "../lib/Widgets/DatePicker.vala"
				_tmp12_ = self->priv->calendar_grid;
#line 258 "../lib/Widgets/DatePicker.vala"
				_tmp13_ = label;
#line 258 "../lib/Widgets/DatePicker.vala"
				gtk_grid_attach (_tmp12_, (GtkWidget*) _tmp13_, i % 7, 0, 1, 1);
#line 250 "../lib/Widgets/DatePicker.vala"
				_g_object_unref0 (label);
#line 1774 "DatePicker.c"
			}
		}
	}
}

gchar*
he_calendar_widget_get_day_of_week_string (HeCalendarWidget* self,
                                           gint day_index)
{
	GDateTime* sample = NULL;
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	GTimeZone* _tmp2_;
	GDateTime* _tmp3_;
	GDateTime* _tmp4_;
	GDateTime* day_date = NULL;
	GDateTime* _tmp5_;
	gchar* _tmp6_;
	gchar* result;
#line 262 "../lib/Widgets/DatePicker.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 264 "../lib/Widgets/DatePicker.vala"
	_tmp0_ = g_date_time_new_now_local ();
#line 264 "../lib/Widgets/DatePicker.vala"
	_tmp1_ = _tmp0_;
#line 264 "../lib/Widgets/DatePicker.vala"
	_tmp2_ = g_date_time_get_timezone (_tmp1_);
#line 264 "../lib/Widgets/DatePicker.vala"
	_tmp3_ = g_date_time_new (_tmp2_, 2022, 6, 6, 0, 0, (gdouble) 0);
#line 264 "../lib/Widgets/DatePicker.vala"
	_tmp4_ = _tmp3_;
#line 264 "../lib/Widgets/DatePicker.vala"
	_g_date_time_unref0 (_tmp1_);
#line 264 "../lib/Widgets/DatePicker.vala"
	sample = _tmp4_;
#line 265 "../lib/Widgets/DatePicker.vala"
	_tmp5_ = g_date_time_add_days (sample, day_index);
#line 265 "../lib/Widgets/DatePicker.vala"
	day_date = _tmp5_;
#line 266 "../lib/Widgets/DatePicker.vala"
	_tmp6_ = g_date_time_format (day_date, "%a");
#line 266 "../lib/Widgets/DatePicker.vala"
	result = _tmp6_;
#line 266 "../lib/Widgets/DatePicker.vala"
	_g_date_time_unref0 (day_date);
#line 266 "../lib/Widgets/DatePicker.vala"
	_g_date_time_unref0 (sample);
#line 266 "../lib/Widgets/DatePicker.vala"
	return result;
#line 1824 "DatePicker.c"
}

void
he_calendar_widget_select_day (HeCalendarWidget* self,
                               GDateTime* date)
{
#line 269 "../lib/Widgets/DatePicker.vala"
	g_return_if_fail (self != NULL);
#line 269 "../lib/Widgets/DatePicker.vala"
	g_return_if_fail (date != NULL);
#line 270 "../lib/Widgets/DatePicker.vala"
	he_calendar_widget_set_curr_day (self, g_date_time_get_day_of_month (date));
#line 271 "../lib/Widgets/DatePicker.vala"
	he_calendar_widget_update_calendar_grid (self);
#line 1839 "DatePicker.c"
}

static void
he_calendar_widget_select_month (HeCalendarWidget* self,
                                 gint month_index)
{
	HeButton* _tmp0_;
	gchar** _tmp1_;
	gint _tmp1__length1;
	gint _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gint _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
#line 274 "../lib/Widgets/DatePicker.vala"
	g_return_if_fail (self != NULL);
#line 275 "../lib/Widgets/DatePicker.vala"
	he_calendar_widget_set_month (self, month_index);
#line 276 "../lib/Widgets/DatePicker.vala"
	self->priv->showing_days = TRUE;
#line 277 "../lib/Widgets/DatePicker.vala"
	_tmp0_ = self->priv->header_label;
#line 277 "../lib/Widgets/DatePicker.vala"
	_tmp1_ = self->priv->month_names;
#line 277 "../lib/Widgets/DatePicker.vala"
	_tmp1__length1 = self->priv->month_names_length1;
#line 277 "../lib/Widgets/DatePicker.vala"
	_tmp2_ = self->priv->_month;
#line 277 "../lib/Widgets/DatePicker.vala"
	_tmp3_ = _tmp1_[_tmp2_];
#line 277 "../lib/Widgets/DatePicker.vala"
	_tmp4_ = g_strconcat (_tmp3_, " ", NULL);
#line 277 "../lib/Widgets/DatePicker.vala"
	_tmp5_ = _tmp4_;
#line 277 "../lib/Widgets/DatePicker.vala"
	_tmp6_ = self->priv->_year;
#line 277 "../lib/Widgets/DatePicker.vala"
	_tmp7_ = g_strdup_printf ("%i", _tmp6_);
#line 277 "../lib/Widgets/DatePicker.vala"
	_tmp8_ = _tmp7_;
#line 277 "../lib/Widgets/DatePicker.vala"
	_tmp9_ = g_strconcat (_tmp5_, _tmp8_, NULL);
#line 277 "../lib/Widgets/DatePicker.vala"
	_tmp10_ = _tmp9_;
#line 277 "../lib/Widgets/DatePicker.vala"
	gtk_button_set_label ((GtkButton*) _tmp0_, _tmp10_);
#line 277 "../lib/Widgets/DatePicker.vala"
	_g_free0 (_tmp10_);
#line 277 "../lib/Widgets/DatePicker.vala"
	_g_free0 (_tmp8_);
#line 277 "../lib/Widgets/DatePicker.vala"
	_g_free0 (_tmp5_);
#line 278 "../lib/Widgets/DatePicker.vala"
	he_calendar_widget_update_calendar_grid (self);
#line 1898 "DatePicker.c"
}

static gboolean
he_calendar_widget_is_leap_year (HeCalendarWidget* self,
                                 gint year)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean result;
#line 281 "../lib/Widgets/DatePicker.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 282 "../lib/Widgets/DatePicker.vala"
	if ((year % 4) == 0) {
#line 282 "../lib/Widgets/DatePicker.vala"
		_tmp1_ = (year % 100) != 0;
#line 1914 "DatePicker.c"
	} else {
#line 282 "../lib/Widgets/DatePicker.vala"
		_tmp1_ = FALSE;
#line 1918 "DatePicker.c"
	}
#line 282 "../lib/Widgets/DatePicker.vala"
	if (_tmp1_) {
#line 282 "../lib/Widgets/DatePicker.vala"
		_tmp0_ = TRUE;
#line 1924 "DatePicker.c"
	} else {
#line 282 "../lib/Widgets/DatePicker.vala"
		_tmp0_ = (year % 400) == 0;
#line 1928 "DatePicker.c"
	}
#line 282 "../lib/Widgets/DatePicker.vala"
	result = _tmp0_;
#line 282 "../lib/Widgets/DatePicker.vala"
	return result;
#line 1934 "DatePicker.c"
}

static void
g_cclosure_user_marshal_VOID__INT_INT_INT (GClosure * closure,
                                           GValue * return_value,
                                           guint n_param_values,
                                           const GValue * param_values,
                                           gpointer invocation_hint,
                                           gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__INT_INT_INT) (gpointer data1, gint arg_1, gint arg_2, gint arg_3, gpointer data2);
	register GMarshalFunc_VOID__INT_INT_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 82 "../lib/Widgets/DatePicker.vala"
	g_return_if_fail (n_param_values == 4);
#line 82 "../lib/Widgets/DatePicker.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 82 "../lib/Widgets/DatePicker.vala"
		data1 = closure->data;
#line 82 "../lib/Widgets/DatePicker.vala"
		data2 = param_values->data[0].v_pointer;
#line 1959 "DatePicker.c"
	} else {
#line 82 "../lib/Widgets/DatePicker.vala"
		data1 = param_values->data[0].v_pointer;
#line 82 "../lib/Widgets/DatePicker.vala"
		data2 = closure->data;
#line 1965 "DatePicker.c"
	}
#line 82 "../lib/Widgets/DatePicker.vala"
	callback = (GMarshalFunc_VOID__INT_INT_INT) (marshal_data ? marshal_data : cc->callback);
#line 82 "../lib/Widgets/DatePicker.vala"
	callback (data1, g_value_get_int (param_values + 1), g_value_get_int (param_values + 2), g_value_get_int (param_values + 3), data2);
#line 1971 "DatePicker.c"
}

HeCalendarWidget*
he_calendar_widget_construct (GType object_type)
{
	HeCalendarWidget * self = NULL;
#line 82 "../lib/Widgets/DatePicker.vala"
	self = (HeCalendarWidget*) he_bin_construct (object_type);
#line 82 "../lib/Widgets/DatePicker.vala"
	return self;
#line 1982 "DatePicker.c"
}

HeCalendarWidget*
he_calendar_widget_new (void)
{
#line 82 "../lib/Widgets/DatePicker.vala"
	return he_calendar_widget_construct (HE_TYPE_CALENDAR_WIDGET);
#line 1990 "DatePicker.c"
}

static void
_he_calendar_widget___lambda136_ (HeCalendarWidget* self)
{
#line 125 "../lib/Widgets/DatePicker.vala"
	he_calendar_widget_toggle_view (self);
#line 1998 "DatePicker.c"
}

static void
__he_calendar_widget___lambda136__gtk_button_clicked (GtkButton* _sender,
                                                      gpointer self)
{
#line 125 "../lib/Widgets/DatePicker.vala"
	_he_calendar_widget___lambda136_ ((HeCalendarWidget*) self);
#line 2007 "DatePicker.c"
}

static void
_he_calendar_widget___lambda137_ (HeCalendarWidget* self)
{
#line 132 "../lib/Widgets/DatePicker.vala"
	he_calendar_widget_change_month (self, -1);
#line 2015 "DatePicker.c"
}

static void
__he_calendar_widget___lambda137__gtk_button_clicked (GtkButton* _sender,
                                                      gpointer self)
{
#line 132 "../lib/Widgets/DatePicker.vala"
	_he_calendar_widget___lambda137_ ((HeCalendarWidget*) self);
#line 2024 "DatePicker.c"
}

static void
_he_calendar_widget___lambda138_ (HeCalendarWidget* self)
{
#line 140 "../lib/Widgets/DatePicker.vala"
	he_calendar_widget_change_month (self, 1);
#line 2032 "DatePicker.c"
}

static void
__he_calendar_widget___lambda138__gtk_button_clicked (GtkButton* _sender,
                                                      gpointer self)
{
#line 140 "../lib/Widgets/DatePicker.vala"
	_he_calendar_widget___lambda138_ ((HeCalendarWidget*) self);
#line 2041 "DatePicker.c"
}

static GObject *
he_calendar_widget_constructor (GType type,
                                guint n_construct_properties,
                                GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	HeCalendarWidget * self;
	GDateTime* date = NULL;
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
	GDateTime* _tmp3_;
	GDateTime* _tmp4_;
	gint _tmp5_ = 0;
	GtkBox* main_box = NULL;
	GtkBox* _tmp6_ = NULL;
	GtkBox* header_box = NULL;
	GtkBox* _tmp7_;
	gchar** _tmp8_;
	gint _tmp8__length1;
	gint _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gint _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	HeButton* _tmp19_ = NULL;
	HeButton* _tmp20_;
	GtkWidget* _tmp21_;
	HeButton* _tmp26_;
	HeButton* _tmp27_;
	gchar* _tmp28_;
	HeButton* _tmp29_ = NULL;
	HeButton* _tmp30_;
	gchar* _tmp31_;
	HeButton* _tmp32_ = NULL;
	HeButton* _tmp33_;
	GtkBox* _tmp34_;
	HeButton* _tmp35_;
	GtkBox* _tmp36_;
	HeButton* _tmp37_;
	GtkBox* _tmp38_;
	HeButton* _tmp39_;
	GtkBox* _tmp40_;
	GtkBox* _tmp41_;
	HeDivider* divider = NULL;
	HeDivider* _tmp42_;
	GtkBox* _tmp43_;
	HeDivider* _tmp44_;
	GtkGrid* _tmp45_ = NULL;
	GtkBox* _tmp46_;
	GtkGrid* _tmp47_;
	GtkBox* _tmp48_;
#line 98 "../lib/Widgets/DatePicker.vala"
	parent_class = G_OBJECT_CLASS (he_calendar_widget_parent_class);
#line 98 "../lib/Widgets/DatePicker.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 98 "../lib/Widgets/DatePicker.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_CALENDAR_WIDGET, HeCalendarWidget);
#line 99 "../lib/Widgets/DatePicker.vala"
	_tmp0_ = g_date_time_new_now_local ();
#line 99 "../lib/Widgets/DatePicker.vala"
	date = _tmp0_;
#line 100 "../lib/Widgets/DatePicker.vala"
	_tmp1_ = date;
#line 100 "../lib/Widgets/DatePicker.vala"
	he_calendar_widget_set_day (self, g_date_time_get_day_of_month (_tmp1_));
#line 101 "../lib/Widgets/DatePicker.vala"
	_tmp2_ = date;
#line 101 "../lib/Widgets/DatePicker.vala"
	he_calendar_widget_set_month (self, g_date_time_get_month (_tmp2_) - 1);
#line 102 "../lib/Widgets/DatePicker.vala"
	_tmp3_ = date;
#line 102 "../lib/Widgets/DatePicker.vala"
	he_calendar_widget_set_year (self, g_date_time_get_year (_tmp3_));
#line 103 "../lib/Widgets/DatePicker.vala"
	_tmp4_ = date;
#line 103 "../lib/Widgets/DatePicker.vala"
	he_calendar_widget_set_curr_day (self, g_date_time_get_day_of_month (_tmp4_));
#line 106 "../lib/Widgets/DatePicker.vala"
	_tmp5_ = 18;
#line 105 "../lib/Widgets/DatePicker.vala"
	_tmp6_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 6);
#line 105 "../lib/Widgets/DatePicker.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp6_, _tmp5_);
#line 105 "../lib/Widgets/DatePicker.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp6_, _tmp5_);
#line 105 "../lib/Widgets/DatePicker.vala"
	g_object_ref_sink (_tmp6_);
#line 105 "../lib/Widgets/DatePicker.vala"
	main_box = _tmp6_;
#line 110 "../lib/Widgets/DatePicker.vala"
	_tmp7_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 6);
#line 110 "../lib/Widgets/DatePicker.vala"
	g_object_ref_sink (_tmp7_);
#line 110 "../lib/Widgets/DatePicker.vala"
	header_box = _tmp7_;
#line 112 "../lib/Widgets/DatePicker.vala"
	_tmp8_ = self->priv->month_names;
#line 112 "../lib/Widgets/DatePicker.vala"
	_tmp8__length1 = self->priv->month_names_length1;
#line 112 "../lib/Widgets/DatePicker.vala"
	_tmp9_ = self->priv->_month;
#line 112 "../lib/Widgets/DatePicker.vala"
	_tmp10_ = _tmp8_[_tmp9_];
#line 112 "../lib/Widgets/DatePicker.vala"
	_tmp11_ = g_strconcat (_tmp10_, " ", NULL);
#line 112 "../lib/Widgets/DatePicker.vala"
	_tmp12_ = _tmp11_;
#line 112 "../lib/Widgets/DatePicker.vala"
	_tmp13_ = self->priv->_year;
#line 112 "../lib/Widgets/DatePicker.vala"
	_tmp14_ = g_strdup_printf ("%i", _tmp13_);
#line 112 "../lib/Widgets/DatePicker.vala"
	_tmp15_ = _tmp14_;
#line 112 "../lib/Widgets/DatePicker.vala"
	_tmp16_ = g_strconcat (_tmp12_, _tmp15_, NULL);
#line 112 "../lib/Widgets/DatePicker.vala"
	_tmp17_ = _tmp16_;
#line 112 "../lib/Widgets/DatePicker.vala"
	_tmp18_ = g_strdup (_ ("Select Month"));
#line 112 "../lib/Widgets/DatePicker.vala"
	_tmp19_ = he_button_new ("", _tmp17_);
#line 112 "../lib/Widgets/DatePicker.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp19_, GTK_ALIGN_START);
#line 112 "../lib/Widgets/DatePicker.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp19_, GTK_ALIGN_CENTER);
#line 112 "../lib/Widgets/DatePicker.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp19_, TRUE);
#line 112 "../lib/Widgets/DatePicker.vala"
	he_button_set_is_textual (_tmp19_, TRUE);
#line 112 "../lib/Widgets/DatePicker.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp19_, 18);
#line 112 "../lib/Widgets/DatePicker.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp19_, _tmp18_);
#line 112 "../lib/Widgets/DatePicker.vala"
	_g_free0 (_tmp18_);
#line 112 "../lib/Widgets/DatePicker.vala"
	g_object_ref_sink (_tmp19_);
#line 112 "../lib/Widgets/DatePicker.vala"
	_g_object_unref0 (self->priv->header_label);
#line 112 "../lib/Widgets/DatePicker.vala"
	self->priv->header_label = _tmp19_;
#line 112 "../lib/Widgets/DatePicker.vala"
	_g_free0 (_tmp17_);
#line 112 "../lib/Widgets/DatePicker.vala"
	_g_free0 (_tmp15_);
#line 112 "../lib/Widgets/DatePicker.vala"
	_g_free0 (_tmp12_);
#line 120 "../lib/Widgets/DatePicker.vala"
	_tmp20_ = self->priv->header_label;
#line 120 "../lib/Widgets/DatePicker.vala"
	_tmp21_ = gtk_widget_get_first_child ((GtkWidget*) _tmp20_);
#line 120 "../lib/Widgets/DatePicker.vala"
	if (G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, gtk_label_get_type (), GtkLabel) != NULL) {
#line 2204 "DatePicker.c"
		HeButton* _tmp22_;
		GtkWidget* _tmp23_;
		HeButton* _tmp24_;
		GtkWidget* _tmp25_;
#line 121 "../lib/Widgets/DatePicker.vala"
		_tmp22_ = self->priv->header_label;
#line 121 "../lib/Widgets/DatePicker.vala"
		_tmp23_ = gtk_widget_get_first_child ((GtkWidget*) _tmp22_);
#line 121 "../lib/Widgets/DatePicker.vala"
		gtk_label_set_width_chars (G_TYPE_CHECK_INSTANCE_CAST (_tmp23_, gtk_label_get_type (), GtkLabel), 14);
#line 122 "../lib/Widgets/DatePicker.vala"
		_tmp24_ = self->priv->header_label;
#line 122 "../lib/Widgets/DatePicker.vala"
		_tmp25_ = gtk_widget_get_first_child ((GtkWidget*) _tmp24_);
#line 122 "../lib/Widgets/DatePicker.vala"
		gtk_widget_add_css_class ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (_tmp25_, gtk_label_get_type (), GtkLabel), "cb-title");
#line 2221 "DatePicker.c"
	}
#line 124 "../lib/Widgets/DatePicker.vala"
	_tmp26_ = self->priv->header_label;
#line 124 "../lib/Widgets/DatePicker.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp26_, "flat");
#line 125 "../lib/Widgets/DatePicker.vala"
	_tmp27_ = self->priv->header_label;
#line 125 "../lib/Widgets/DatePicker.vala"
	g_signal_connect_object ((GtkButton*) _tmp27_, "clicked", (GCallback) __he_calendar_widget___lambda136__gtk_button_clicked, self, 0);
#line 127 "../lib/Widgets/DatePicker.vala"
	_tmp28_ = g_strdup (_ ("Previous Month"));
#line 127 "../lib/Widgets/DatePicker.vala"
	_tmp29_ = he_button_new ("go-previous-symbolic", "");
#line 127 "../lib/Widgets/DatePicker.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp29_, GTK_ALIGN_END);
#line 127 "../lib/Widgets/DatePicker.vala"
	he_button_set_is_disclosure (_tmp29_, TRUE);
#line 127 "../lib/Widgets/DatePicker.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp29_, _tmp28_);
#line 127 "../lib/Widgets/DatePicker.vala"
	_g_free0 (_tmp28_);
#line 127 "../lib/Widgets/DatePicker.vala"
	g_object_ref_sink (_tmp29_);
#line 127 "../lib/Widgets/DatePicker.vala"
	_g_object_unref0 (self->priv->left_arrow);
#line 127 "../lib/Widgets/DatePicker.vala"
	self->priv->left_arrow = _tmp29_;
#line 132 "../lib/Widgets/DatePicker.vala"
	_tmp30_ = self->priv->left_arrow;
#line 132 "../lib/Widgets/DatePicker.vala"
	g_signal_connect_object ((GtkButton*) _tmp30_, "clicked", (GCallback) __he_calendar_widget___lambda137__gtk_button_clicked, self, 0);
#line 134 "../lib/Widgets/DatePicker.vala"
	_tmp31_ = g_strdup (_ ("Next Month"));
#line 134 "../lib/Widgets/DatePicker.vala"
	_tmp32_ = he_button_new ("go-next-symbolic", "");
#line 134 "../lib/Widgets/DatePicker.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp32_, GTK_ALIGN_END);
#line 134 "../lib/Widgets/DatePicker.vala"
	he_button_set_is_disclosure (_tmp32_, TRUE);
#line 134 "../lib/Widgets/DatePicker.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp32_, 18);
#line 134 "../lib/Widgets/DatePicker.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp32_, _tmp31_);
#line 134 "../lib/Widgets/DatePicker.vala"
	_g_free0 (_tmp31_);
#line 134 "../lib/Widgets/DatePicker.vala"
	g_object_ref_sink (_tmp32_);
#line 134 "../lib/Widgets/DatePicker.vala"
	_g_object_unref0 (self->priv->right_arrow);
#line 134 "../lib/Widgets/DatePicker.vala"
	self->priv->right_arrow = _tmp32_;
#line 140 "../lib/Widgets/DatePicker.vala"
	_tmp33_ = self->priv->right_arrow;
#line 140 "../lib/Widgets/DatePicker.vala"
	g_signal_connect_object ((GtkButton*) _tmp33_, "clicked", (GCallback) __he_calendar_widget___lambda138__gtk_button_clicked, self, 0);
#line 142 "../lib/Widgets/DatePicker.vala"
	_tmp34_ = header_box;
#line 142 "../lib/Widgets/DatePicker.vala"
	_tmp35_ = self->priv->header_label;
#line 142 "../lib/Widgets/DatePicker.vala"
	gtk_box_append (_tmp34_, (GtkWidget*) _tmp35_);
#line 143 "../lib/Widgets/DatePicker.vala"
	_tmp36_ = header_box;
#line 143 "../lib/Widgets/DatePicker.vala"
	_tmp37_ = self->priv->left_arrow;
#line 143 "../lib/Widgets/DatePicker.vala"
	gtk_box_append (_tmp36_, (GtkWidget*) _tmp37_);
#line 144 "../lib/Widgets/DatePicker.vala"
	_tmp38_ = header_box;
#line 144 "../lib/Widgets/DatePicker.vala"
	_tmp39_ = self->priv->right_arrow;
#line 144 "../lib/Widgets/DatePicker.vala"
	gtk_box_append (_tmp38_, (GtkWidget*) _tmp39_);
#line 145 "../lib/Widgets/DatePicker.vala"
	_tmp40_ = main_box;
#line 145 "../lib/Widgets/DatePicker.vala"
	_tmp41_ = header_box;
#line 145 "../lib/Widgets/DatePicker.vala"
	gtk_box_append (_tmp40_, (GtkWidget*) _tmp41_);
#line 147 "../lib/Widgets/DatePicker.vala"
	_tmp42_ = he_divider_new ();
#line 147 "../lib/Widgets/DatePicker.vala"
	g_object_ref_sink (_tmp42_);
#line 147 "../lib/Widgets/DatePicker.vala"
	divider = _tmp42_;
#line 148 "../lib/Widgets/DatePicker.vala"
	_tmp43_ = main_box;
#line 148 "../lib/Widgets/DatePicker.vala"
	_tmp44_ = divider;
#line 148 "../lib/Widgets/DatePicker.vala"
	gtk_box_append (_tmp43_, (GtkWidget*) _tmp44_);
#line 151 "../lib/Widgets/DatePicker.vala"
	_tmp45_ = (GtkGrid*) gtk_grid_new ();
#line 151 "../lib/Widgets/DatePicker.vala"
	gtk_grid_set_row_homogeneous (_tmp45_, TRUE);
#line 151 "../lib/Widgets/DatePicker.vala"
	gtk_grid_set_column_homogeneous (_tmp45_, TRUE);
#line 151 "../lib/Widgets/DatePicker.vala"
	g_object_set ((GtkWidget*) _tmp45_, "width-request", 150, NULL);
#line 151 "../lib/Widgets/DatePicker.vala"
	g_object_set ((GtkWidget*) _tmp45_, "height-request", 240, NULL);
#line 151 "../lib/Widgets/DatePicker.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp45_, 18);
#line 151 "../lib/Widgets/DatePicker.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp45_, 18);
#line 151 "../lib/Widgets/DatePicker.vala"
	g_object_ref_sink (_tmp45_);
#line 151 "../lib/Widgets/DatePicker.vala"
	_g_object_unref0 (self->priv->calendar_grid);
#line 151 "../lib/Widgets/DatePicker.vala"
	self->priv->calendar_grid = _tmp45_;
#line 159 "../lib/Widgets/DatePicker.vala"
	_tmp46_ = main_box;
#line 159 "../lib/Widgets/DatePicker.vala"
	_tmp47_ = self->priv->calendar_grid;
#line 159 "../lib/Widgets/DatePicker.vala"
	gtk_box_append (_tmp46_, (GtkWidget*) _tmp47_);
#line 161 "../lib/Widgets/DatePicker.vala"
	self->priv->showing_days = TRUE;
#line 162 "../lib/Widgets/DatePicker.vala"
	he_calendar_widget_update_calendar_grid (self);
#line 163 "../lib/Widgets/DatePicker.vala"
	_tmp48_ = main_box;
#line 163 "../lib/Widgets/DatePicker.vala"
	he_bin_set_child ((HeBin*) self, (GtkWidget*) _tmp48_);
#line 165 "../lib/Widgets/DatePicker.vala"
	gtk_widget_add_css_class ((GtkWidget*) self, "calendar");
#line 98 "../lib/Widgets/DatePicker.vala"
	_g_object_unref0 (divider);
#line 98 "../lib/Widgets/DatePicker.vala"
	_g_object_unref0 (header_box);
#line 98 "../lib/Widgets/DatePicker.vala"
	_g_object_unref0 (main_box);
#line 98 "../lib/Widgets/DatePicker.vala"
	_g_date_time_unref0 (date);
#line 98 "../lib/Widgets/DatePicker.vala"
	return obj;
#line 2359 "DatePicker.c"
}

static void
he_calendar_widget_class_init (HeCalendarWidgetClass * klass,
                               gpointer klass_data)
{
#line 82 "../lib/Widgets/DatePicker.vala"
	he_calendar_widget_parent_class = g_type_class_peek_parent (klass);
#line 82 "../lib/Widgets/DatePicker.vala"
	g_type_class_adjust_private_offset (klass, &HeCalendarWidget_private_offset);
#line 82 "../lib/Widgets/DatePicker.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_he_calendar_widget_get_property;
#line 82 "../lib/Widgets/DatePicker.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_he_calendar_widget_set_property;
#line 82 "../lib/Widgets/DatePicker.vala"
	G_OBJECT_CLASS (klass)->constructor = he_calendar_widget_constructor;
#line 82 "../lib/Widgets/DatePicker.vala"
	G_OBJECT_CLASS (klass)->finalize = he_calendar_widget_finalize;
#line 82 "../lib/Widgets/DatePicker.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_CALENDAR_WIDGET_DAY_PROPERTY, he_calendar_widget_properties[HE_CALENDAR_WIDGET_DAY_PROPERTY] = g_param_spec_int ("day", "day", "day", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 82 "../lib/Widgets/DatePicker.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_CALENDAR_WIDGET_MONTH_PROPERTY, he_calendar_widget_properties[HE_CALENDAR_WIDGET_MONTH_PROPERTY] = g_param_spec_int ("month", "month", "month", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 82 "../lib/Widgets/DatePicker.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_CALENDAR_WIDGET_YEAR_PROPERTY, he_calendar_widget_properties[HE_CALENDAR_WIDGET_YEAR_PROPERTY] = g_param_spec_int ("year", "year", "year", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 82 "../lib/Widgets/DatePicker.vala"
	he_calendar_widget_signals[HE_CALENDAR_WIDGET_DAY_SELECTED_SIGNAL] = g_signal_new ("day-selected", HE_TYPE_CALENDAR_WIDGET, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT_INT_INT, G_TYPE_NONE, 3, G_TYPE_INT, G_TYPE_INT, G_TYPE_INT);
#line 2386 "DatePicker.c"
}

static void
he_calendar_widget_instance_init (HeCalendarWidget * self,
                                  gpointer klass)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar** _tmp12_;
	gint* _tmp13_;
#line 82 "../lib/Widgets/DatePicker.vala"
	self->priv = he_calendar_widget_get_instance_private (self);
#line 95 "../lib/Widgets/DatePicker.vala"
	_tmp0_ = g_strdup (_ ("January"));
#line 95 "../lib/Widgets/DatePicker.vala"
	_tmp1_ = g_strdup (_ ("February"));
#line 95 "../lib/Widgets/DatePicker.vala"
	_tmp2_ = g_strdup (_ ("March"));
#line 95 "../lib/Widgets/DatePicker.vala"
	_tmp3_ = g_strdup (_ ("April"));
#line 95 "../lib/Widgets/DatePicker.vala"
	_tmp4_ = g_strdup (_ ("May"));
#line 95 "../lib/Widgets/DatePicker.vala"
	_tmp5_ = g_strdup (_ ("June"));
#line 95 "../lib/Widgets/DatePicker.vala"
	_tmp6_ = g_strdup (_ ("July"));
#line 95 "../lib/Widgets/DatePicker.vala"
	_tmp7_ = g_strdup (_ ("August"));
#line 95 "../lib/Widgets/DatePicker.vala"
	_tmp8_ = g_strdup (_ ("September"));
#line 95 "../lib/Widgets/DatePicker.vala"
	_tmp9_ = g_strdup (_ ("October"));
#line 95 "../lib/Widgets/DatePicker.vala"
	_tmp10_ = g_strdup (_ ("November"));
#line 95 "../lib/Widgets/DatePicker.vala"
	_tmp11_ = g_strdup (_ ("December"));
#line 95 "../lib/Widgets/DatePicker.vala"
	_tmp12_ = g_new0 (gchar*, 12 + 1);
#line 95 "../lib/Widgets/DatePicker.vala"
	_tmp12_[0] = _tmp0_;
#line 95 "../lib/Widgets/DatePicker.vala"
	_tmp12_[1] = _tmp1_;
#line 95 "../lib/Widgets/DatePicker.vala"
	_tmp12_[2] = _tmp2_;
#line 95 "../lib/Widgets/DatePicker.vala"
	_tmp12_[3] = _tmp3_;
#line 95 "../lib/Widgets/DatePicker.vala"
	_tmp12_[4] = _tmp4_;
#line 95 "../lib/Widgets/DatePicker.vala"
	_tmp12_[5] = _tmp5_;
#line 95 "../lib/Widgets/DatePicker.vala"
	_tmp12_[6] = _tmp6_;
#line 95 "../lib/Widgets/DatePicker.vala"
	_tmp12_[7] = _tmp7_;
#line 95 "../lib/Widgets/DatePicker.vala"
	_tmp12_[8] = _tmp8_;
#line 95 "../lib/Widgets/DatePicker.vala"
	_tmp12_[9] = _tmp9_;
#line 95 "../lib/Widgets/DatePicker.vala"
	_tmp12_[10] = _tmp10_;
#line 95 "../lib/Widgets/DatePicker.vala"
	_tmp12_[11] = _tmp11_;
#line 95 "../lib/Widgets/DatePicker.vala"
	self->priv->month_names = _tmp12_;
#line 95 "../lib/Widgets/DatePicker.vala"
	self->priv->month_names_length1 = 12;
#line 95 "../lib/Widgets/DatePicker.vala"
	self->priv->_month_names_size_ = self->priv->month_names_length1;
#line 96 "../lib/Widgets/DatePicker.vala"
	_tmp13_ = g_new0 (gint, 12);
#line 96 "../lib/Widgets/DatePicker.vala"
	_tmp13_[0] = 31;
#line 96 "../lib/Widgets/DatePicker.vala"
	_tmp13_[1] = 28;
#line 96 "../lib/Widgets/DatePicker.vala"
	_tmp13_[2] = 31;
#line 96 "../lib/Widgets/DatePicker.vala"
	_tmp13_[3] = 30;
#line 96 "../lib/Widgets/DatePicker.vala"
	_tmp13_[4] = 31;
#line 96 "../lib/Widgets/DatePicker.vala"
	_tmp13_[5] = 30;
#line 96 "../lib/Widgets/DatePicker.vala"
	_tmp13_[6] = 31;
#line 96 "../lib/Widgets/DatePicker.vala"
	_tmp13_[7] = 31;
#line 96 "../lib/Widgets/DatePicker.vala"
	_tmp13_[8] = 30;
#line 96 "../lib/Widgets/DatePicker.vala"
	_tmp13_[9] = 31;
#line 96 "../lib/Widgets/DatePicker.vala"
	_tmp13_[10] = 30;
#line 96 "../lib/Widgets/DatePicker.vala"
	_tmp13_[11] = 31;
#line 96 "../lib/Widgets/DatePicker.vala"
	self->priv->days_in_month = _tmp13_;
#line 96 "../lib/Widgets/DatePicker.vala"
	self->priv->days_in_month_length1 = 12;
#line 96 "../lib/Widgets/DatePicker.vala"
	self->priv->_days_in_month_size_ = self->priv->days_in_month_length1;
#line 2497 "DatePicker.c"
}

static void
he_calendar_widget_finalize (GObject * obj)
{
	HeCalendarWidget * self;
#line 82 "../lib/Widgets/DatePicker.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_CALENDAR_WIDGET, HeCalendarWidget);
#line 83 "../lib/Widgets/DatePicker.vala"
	_g_object_unref0 (self->priv->calendar_grid);
#line 84 "../lib/Widgets/DatePicker.vala"
	_g_object_unref0 (self->priv->header_label);
#line 85 "../lib/Widgets/DatePicker.vala"
	_g_object_unref0 (self->priv->left_arrow);
#line 86 "../lib/Widgets/DatePicker.vala"
	_g_object_unref0 (self->priv->right_arrow);
#line 95 "../lib/Widgets/DatePicker.vala"
	self->priv->month_names = (_vala_array_free (self->priv->month_names, self->priv->month_names_length1, (GDestroyNotify) g_free), NULL);
#line 96 "../lib/Widgets/DatePicker.vala"
	self->priv->days_in_month = (g_free (self->priv->days_in_month), NULL);
#line 82 "../lib/Widgets/DatePicker.vala"
	G_OBJECT_CLASS (he_calendar_widget_parent_class)->finalize (obj);
#line 2520 "DatePicker.c"
}

static GType
he_calendar_widget_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HeCalendarWidgetClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) he_calendar_widget_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HeCalendarWidget), 0, (GInstanceInitFunc) he_calendar_widget_instance_init, NULL };
	GType he_calendar_widget_type_id;
	he_calendar_widget_type_id = g_type_register_static (HE_TYPE_BIN, "HeCalendarWidget", &g_define_type_info, 0);
	HeCalendarWidget_private_offset = g_type_add_instance_private (he_calendar_widget_type_id, sizeof (HeCalendarWidgetPrivate));
	return he_calendar_widget_type_id;
}

GType
he_calendar_widget_get_type (void)
{
	static volatile gsize he_calendar_widget_type_id__once = 0;
	if (g_once_init_enter (&he_calendar_widget_type_id__once)) {
		GType he_calendar_widget_type_id;
		he_calendar_widget_type_id = he_calendar_widget_get_type_once ();
		g_once_init_leave (&he_calendar_widget_type_id__once, he_calendar_widget_type_id);
	}
	return he_calendar_widget_type_id__once;
}

static void
_vala_he_calendar_widget_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec)
{
	HeCalendarWidget * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_CALENDAR_WIDGET, HeCalendarWidget);
#line 82 "../lib/Widgets/DatePicker.vala"
	switch (property_id) {
#line 82 "../lib/Widgets/DatePicker.vala"
		case HE_CALENDAR_WIDGET_DAY_PROPERTY:
#line 82 "../lib/Widgets/DatePicker.vala"
		g_value_set_int (value, he_calendar_widget_get_day (self));
#line 82 "../lib/Widgets/DatePicker.vala"
		break;
#line 82 "../lib/Widgets/DatePicker.vala"
		case HE_CALENDAR_WIDGET_MONTH_PROPERTY:
#line 82 "../lib/Widgets/DatePicker.vala"
		g_value_set_int (value, he_calendar_widget_get_month (self));
#line 82 "../lib/Widgets/DatePicker.vala"
		break;
#line 82 "../lib/Widgets/DatePicker.vala"
		case HE_CALENDAR_WIDGET_YEAR_PROPERTY:
#line 82 "../lib/Widgets/DatePicker.vala"
		g_value_set_int (value, he_calendar_widget_get_year (self));
#line 82 "../lib/Widgets/DatePicker.vala"
		break;
#line 2573 "DatePicker.c"
		default:
#line 82 "../lib/Widgets/DatePicker.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 82 "../lib/Widgets/DatePicker.vala"
		break;
#line 2579 "DatePicker.c"
	}
}

static void
_vala_he_calendar_widget_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec)
{
	HeCalendarWidget * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_CALENDAR_WIDGET, HeCalendarWidget);
#line 82 "../lib/Widgets/DatePicker.vala"
	switch (property_id) {
#line 82 "../lib/Widgets/DatePicker.vala"
		case HE_CALENDAR_WIDGET_DAY_PROPERTY:
#line 82 "../lib/Widgets/DatePicker.vala"
		he_calendar_widget_set_day (self, g_value_get_int (value));
#line 82 "../lib/Widgets/DatePicker.vala"
		break;
#line 82 "../lib/Widgets/DatePicker.vala"
		case HE_CALENDAR_WIDGET_MONTH_PROPERTY:
#line 82 "../lib/Widgets/DatePicker.vala"
		he_calendar_widget_set_month (self, g_value_get_int (value));
#line 82 "../lib/Widgets/DatePicker.vala"
		break;
#line 82 "../lib/Widgets/DatePicker.vala"
		case HE_CALENDAR_WIDGET_YEAR_PROPERTY:
#line 82 "../lib/Widgets/DatePicker.vala"
		he_calendar_widget_set_year (self, g_value_get_int (value));
#line 82 "../lib/Widgets/DatePicker.vala"
		break;
#line 2611 "DatePicker.c"
		default:
#line 82 "../lib/Widgets/DatePicker.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 82 "../lib/Widgets/DatePicker.vala"
		break;
#line 2617 "DatePicker.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

