/* ViewDual.c generated by valac 0.56.18, the Vala compiler
 * generated from ViewDual.vala, do not modify */

/*
 * Copyright (c) 2024 Fyra Labs
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 */

#include "libhelium-1.h"
#include <gtk/gtk.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>
#include <gsk/gsk.h>
#include <graphene-gobject.h>

#define HE_VIEW_DUAL_MIDDLE_SPACING 24.0
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	HE_VIEW_DUAL_0_PROPERTY,
	HE_VIEW_DUAL_ORIENTATION_PROPERTY,
	HE_VIEW_DUAL_SHOW_HANDLE_PROPERTY,
	HE_VIEW_DUAL_CHILD_START_PROPERTY,
	HE_VIEW_DUAL_CHILD_END_PROPERTY,
	HE_VIEW_DUAL_NUM_PROPERTIES
};
static GParamSpec* he_view_dual_properties[HE_VIEW_DUAL_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_source_unref0(var) ((var == NULL) ? NULL : (var = (g_source_unref (var), NULL)))
#define _gsk_transform_unref0(var) ((var == NULL) ? NULL : (var = (gsk_transform_unref (var), NULL)))

struct _HeViewDualPrivate {
	GtkWidget* handle;
	GtkGestureDrag* drag_gesture;
	GtkWidget* base_bin;
	GtkBox* child_start_bin;
	GtkBox* child_end_bin;
	GtkBox* handle_bin;
	GSource* resize_timeout;
	gboolean dragging;
	gdouble initial_xy;
	gdouble initial_pos;
	gdouble target_pos;
	gint update_interval;
	gdouble* snap_values;
	gint snap_values_length1;
	gint _snap_values_size_;
	gdouble snap_threshold;
	GtkOrientation _orientation;
	gboolean _show_handle;
	GtkWidget* _child_start;
	GtkWidget* _child_end;
	gdouble _handle_position;
};

static gint HeViewDual_private_offset;
static gpointer he_view_dual_parent_class = NULL;
static GtkBuildableIface * he_view_dual_gtk_buildable_parent_iface = NULL;

static void he_view_dual_update_handle_look (HeViewDual* self);
static gdouble he_view_dual_get_handle_position (HeViewDual* self);
static void he_view_dual_set_handle_position (HeViewDual* self,
                                       gdouble value);
static void he_view_dual_real_add_child (GtkBuildable* base,
                                  GtkBuilder* builder,
                                  GObject* child,
                                  const gchar* type);
static void he_view_dual_update_refresh_rate (HeViewDual* self);
static void he_view_dual_on_drag_begin (HeViewDual* self,
                                 GtkGestureDrag* gesture,
                                 gdouble x,
                                 gdouble y);
static gdouble he_view_dual_snap_to_nearest (HeViewDual* self,
                                      gdouble value);
static gdouble he_view_dual_lerp (HeViewDual* self,
                           gdouble start,
                           gdouble end,
                           gdouble t);
static void he_view_dual_on_drag_update (HeViewDual* self,
                                  GtkGestureDrag* gesture,
                                  gdouble offset_x,
                                  gdouble offset_y);
static gboolean ____lambda195_ (HeViewDual* self);
static gboolean _____lambda195__gsource_func (gpointer self);
static void he_view_dual_on_drag_end (HeViewDual* self,
                               GtkGestureDrag* gesture,
                               gdouble offset_x,
                               gdouble offset_y);
static void he_view_dual_real_dispose (GObject* base);
static gboolean he_view_dual_real_contains (GtkWidget* base,
                                     gdouble x,
                                     gdouble y);
static void he_view_dual_real_measure (GtkWidget* base,
                                GtkOrientation orientation,
                                gint for_size,
                                gint* min,
                                gint* nat,
                                gint* min_baseline,
                                gint* nat_baseline);
static void he_view_dual_real_size_allocate (GtkWidget* base,
                                      gint width,
                                      gint height,
                                      gint baseline);
static GObject * he_view_dual_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties);
static void _he_view_dual_on_drag_begin_gtk_gesture_drag_drag_begin (GtkGestureDrag* _sender,
                                                              gdouble start_x,
                                                              gdouble start_y,
                                                              gpointer self);
static void _he_view_dual_on_drag_update_gtk_gesture_drag_drag_update (GtkGestureDrag* _sender,
                                                                gdouble offset_x,
                                                                gdouble offset_y,
                                                                gpointer self);
static void _he_view_dual_on_drag_end_gtk_gesture_drag_drag_end (GtkGestureDrag* _sender,
                                                          gdouble offset_x,
                                                          gdouble offset_y,
                                                          gpointer self);
static void he_view_dual_finalize (GObject * obj);
static GType he_view_dual_get_type_once (void);
static void _vala_he_view_dual_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec);
static void _vala_he_view_dual_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
he_view_dual_get_instance_private (HeViewDual* self)
{
	return G_STRUCT_MEMBER_P (self, HeViewDual_private_offset);
}

GtkOrientation
he_view_dual_get_orientation (HeViewDual* self)
{
	GtkOrientation result;
#line 47 "../lib/Widgets/ViewDual.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 47 "../lib/Widgets/ViewDual.vala"
	result = self->priv->_orientation;
#line 47 "../lib/Widgets/ViewDual.vala"
	return result;
#line 175 "ViewDual.c"
}

void
he_view_dual_set_orientation (HeViewDual* self,
                              GtkOrientation value)
{
#line 48 "../lib/Widgets/ViewDual.vala"
	g_return_if_fail (self != NULL);
#line 49 "../lib/Widgets/ViewDual.vala"
	self->priv->_orientation = value;
#line 50 "../lib/Widgets/ViewDual.vala"
	he_view_dual_update_handle_look (self);
#line 51 "../lib/Widgets/ViewDual.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 48 "../lib/Widgets/ViewDual.vala"
	g_object_notify_by_pspec ((GObject *) self, he_view_dual_properties[HE_VIEW_DUAL_ORIENTATION_PROPERTY]);
#line 192 "ViewDual.c"
}

gboolean
he_view_dual_get_show_handle (HeViewDual* self)
{
	gboolean result;
#line 60 "../lib/Widgets/ViewDual.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 60 "../lib/Widgets/ViewDual.vala"
	result = self->priv->_show_handle;
#line 60 "../lib/Widgets/ViewDual.vala"
	return result;
#line 205 "ViewDual.c"
}

void
he_view_dual_set_show_handle (HeViewDual* self,
                              gboolean value)
{
	GtkWidget* _tmp0_;
#line 61 "../lib/Widgets/ViewDual.vala"
	g_return_if_fail (self != NULL);
#line 62 "../lib/Widgets/ViewDual.vala"
	self->priv->_show_handle = value;
#line 63 "../lib/Widgets/ViewDual.vala"
	_tmp0_ = self->priv->handle;
#line 63 "../lib/Widgets/ViewDual.vala"
	gtk_widget_set_visible (_tmp0_, self->priv->_show_handle);
#line 61 "../lib/Widgets/ViewDual.vala"
	g_object_notify_by_pspec ((GObject *) self, he_view_dual_properties[HE_VIEW_DUAL_SHOW_HANDLE_PROPERTY]);
#line 223 "ViewDual.c"
}

GtkWidget*
he_view_dual_get_child_start (HeViewDual* self)
{
	GtkWidget* result;
	GtkWidget* _tmp0_;
#line 72 "../lib/Widgets/ViewDual.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 72 "../lib/Widgets/ViewDual.vala"
	_tmp0_ = self->priv->_child_start;
#line 72 "../lib/Widgets/ViewDual.vala"
	result = _tmp0_;
#line 72 "../lib/Widgets/ViewDual.vala"
	return result;
#line 239 "ViewDual.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 77 "../lib/Widgets/ViewDual.vala"
	return self ? g_object_ref (self) : NULL;
#line 247 "ViewDual.c"
}

void
he_view_dual_set_child_start (HeViewDual* self,
                              GtkWidget* value)
{
	GtkWidget* _tmp0_;
	GtkWidget* _tmp2_;
	GtkWidget* _tmp3_;
#line 73 "../lib/Widgets/ViewDual.vala"
	g_return_if_fail (self != NULL);
#line 74 "../lib/Widgets/ViewDual.vala"
	_tmp0_ = self->priv->_child_start;
#line 74 "../lib/Widgets/ViewDual.vala"
	if (_tmp0_ != NULL) {
#line 263 "ViewDual.c"
		GtkWidget* _tmp1_;
#line 75 "../lib/Widgets/ViewDual.vala"
		_tmp1_ = self->priv->_child_start;
#line 75 "../lib/Widgets/ViewDual.vala"
		gtk_widget_unparent (_tmp1_);
#line 269 "ViewDual.c"
	}
#line 77 "../lib/Widgets/ViewDual.vala"
	_tmp2_ = _g_object_ref0 (value);
#line 77 "../lib/Widgets/ViewDual.vala"
	_g_object_unref0 (self->priv->_child_start);
#line 77 "../lib/Widgets/ViewDual.vala"
	self->priv->_child_start = _tmp2_;
#line 78 "../lib/Widgets/ViewDual.vala"
	_tmp3_ = self->priv->_child_start;
#line 78 "../lib/Widgets/ViewDual.vala"
	if (_tmp3_ != NULL) {
#line 281 "ViewDual.c"
		GtkBox* _tmp4_;
		GtkWidget* _tmp5_;
#line 79 "../lib/Widgets/ViewDual.vala"
		_tmp4_ = self->priv->child_start_bin;
#line 79 "../lib/Widgets/ViewDual.vala"
		_tmp5_ = self->priv->_child_start;
#line 79 "../lib/Widgets/ViewDual.vala"
		gtk_box_append (_tmp4_, _tmp5_);
#line 290 "ViewDual.c"
	}
#line 73 "../lib/Widgets/ViewDual.vala"
	g_object_notify_by_pspec ((GObject *) self, he_view_dual_properties[HE_VIEW_DUAL_CHILD_START_PROPERTY]);
#line 294 "ViewDual.c"
}

GtkWidget*
he_view_dual_get_child_end (HeViewDual* self)
{
	GtkWidget* result;
	GtkWidget* _tmp0_;
#line 89 "../lib/Widgets/ViewDual.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 89 "../lib/Widgets/ViewDual.vala"
	_tmp0_ = self->priv->_child_end;
#line 89 "../lib/Widgets/ViewDual.vala"
	result = _tmp0_;
#line 89 "../lib/Widgets/ViewDual.vala"
	return result;
#line 310 "ViewDual.c"
}

void
he_view_dual_set_child_end (HeViewDual* self,
                            GtkWidget* value)
{
	GtkWidget* _tmp0_;
	GtkWidget* _tmp2_;
	GtkWidget* _tmp3_;
#line 90 "../lib/Widgets/ViewDual.vala"
	g_return_if_fail (self != NULL);
#line 91 "../lib/Widgets/ViewDual.vala"
	_tmp0_ = self->priv->_child_end;
#line 91 "../lib/Widgets/ViewDual.vala"
	if (_tmp0_ != NULL) {
#line 326 "ViewDual.c"
		GtkWidget* _tmp1_;
#line 92 "../lib/Widgets/ViewDual.vala"
		_tmp1_ = self->priv->_child_end;
#line 92 "../lib/Widgets/ViewDual.vala"
		gtk_widget_unparent (_tmp1_);
#line 332 "ViewDual.c"
	}
#line 94 "../lib/Widgets/ViewDual.vala"
	_tmp2_ = _g_object_ref0 (value);
#line 94 "../lib/Widgets/ViewDual.vala"
	_g_object_unref0 (self->priv->_child_end);
#line 94 "../lib/Widgets/ViewDual.vala"
	self->priv->_child_end = _tmp2_;
#line 95 "../lib/Widgets/ViewDual.vala"
	_tmp3_ = self->priv->_child_end;
#line 95 "../lib/Widgets/ViewDual.vala"
	if (_tmp3_ != NULL) {
#line 344 "ViewDual.c"
		GtkBox* _tmp4_;
		GtkWidget* _tmp5_;
#line 96 "../lib/Widgets/ViewDual.vala"
		_tmp4_ = self->priv->child_end_bin;
#line 96 "../lib/Widgets/ViewDual.vala"
		_tmp5_ = self->priv->_child_end;
#line 96 "../lib/Widgets/ViewDual.vala"
		gtk_box_append (_tmp4_, _tmp5_);
#line 353 "ViewDual.c"
	}
#line 90 "../lib/Widgets/ViewDual.vala"
	g_object_notify_by_pspec ((GObject *) self, he_view_dual_properties[HE_VIEW_DUAL_CHILD_END_PROPERTY]);
#line 357 "ViewDual.c"
}

static gdouble
he_view_dual_get_handle_position (HeViewDual* self)
{
	gdouble result;
#line 103 "../lib/Widgets/ViewDual.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 103 "../lib/Widgets/ViewDual.vala"
	result = self->priv->_handle_position;
#line 103 "../lib/Widgets/ViewDual.vala"
	return result;
#line 370 "ViewDual.c"
}

static void
he_view_dual_set_handle_position (HeViewDual* self,
                                  gdouble value)
{
#line 104 "../lib/Widgets/ViewDual.vala"
	g_return_if_fail (self != NULL);
#line 105 "../lib/Widgets/ViewDual.vala"
	if (self->priv->_handle_position == value) {
#line 105 "../lib/Widgets/ViewDual.vala"
		return;
#line 383 "ViewDual.c"
	}
#line 106 "../lib/Widgets/ViewDual.vala"
	self->priv->_handle_position = value;
#line 107 "../lib/Widgets/ViewDual.vala"
	gtk_widget_queue_allocate ((GtkWidget*) self);
#line 389 "ViewDual.c"
}

/**
     * Add a child to the widget, should only be used in the context of a UI or Blueprint file. There should be no need to use this method in code.
     */
static void
he_view_dual_real_add_child (GtkBuildable* base,
                             GtkBuilder* builder,
                             GObject* child,
                             const gchar* type)
{
	HeViewDual * self;
#line 114 "../lib/Widgets/ViewDual.vala"
	self = (HeViewDual*) base;
#line 114 "../lib/Widgets/ViewDual.vala"
	g_return_if_fail (builder != NULL);
#line 114 "../lib/Widgets/ViewDual.vala"
	g_return_if_fail (child != NULL);
#line 115 "../lib/Widgets/ViewDual.vala"
	if (g_strcmp0 (type, "start") == 0) {
#line 410 "ViewDual.c"
		GtkWidget* _tmp0_;
		GtkBox* _tmp1_;
#line 116 "../lib/Widgets/ViewDual.vala"
		_tmp0_ = self->priv->_child_start;
#line 116 "../lib/Widgets/ViewDual.vala"
		gtk_widget_unparent (_tmp0_);
#line 117 "../lib/Widgets/ViewDual.vala"
		_tmp1_ = self->priv->child_start_bin;
#line 117 "../lib/Widgets/ViewDual.vala"
		gtk_box_append (_tmp1_, G_TYPE_CHECK_INSTANCE_CAST (child, gtk_widget_get_type (), GtkWidget));
#line 421 "ViewDual.c"
	} else {
#line 118 "../lib/Widgets/ViewDual.vala"
		if (g_strcmp0 (type, "end") == 0) {
#line 425 "ViewDual.c"
			GtkWidget* _tmp2_;
			GtkBox* _tmp3_;
#line 119 "../lib/Widgets/ViewDual.vala"
			_tmp2_ = self->priv->_child_end;
#line 119 "../lib/Widgets/ViewDual.vala"
			gtk_widget_unparent (_tmp2_);
#line 120 "../lib/Widgets/ViewDual.vala"
			_tmp3_ = self->priv->child_end_bin;
#line 120 "../lib/Widgets/ViewDual.vala"
			gtk_box_append (_tmp3_, G_TYPE_CHECK_INSTANCE_CAST (child, gtk_widget_get_type (), GtkWidget));
#line 436 "ViewDual.c"
		} else {
			GtkWidget* _tmp4_;
			GtkBox* _tmp5_;
#line 122 "../lib/Widgets/ViewDual.vala"
			_tmp4_ = self->priv->_child_start;
#line 122 "../lib/Widgets/ViewDual.vala"
			gtk_widget_unparent (_tmp4_);
#line 123 "../lib/Widgets/ViewDual.vala"
			_tmp5_ = self->priv->child_start_bin;
#line 123 "../lib/Widgets/ViewDual.vala"
			gtk_box_append (_tmp5_, G_TYPE_CHECK_INSTANCE_CAST (child, gtk_widget_get_type (), GtkWidget));
#line 448 "ViewDual.c"
		}
	}
}

HeViewDual*
he_view_dual_construct (GType object_type,
                        GtkOrientation orientation,
                        gboolean show_handle)
{
	HeViewDual * self = NULL;
#line 127 "../lib/Widgets/ViewDual.vala"
	self = (HeViewDual*) g_object_new (object_type, NULL);
#line 128 "../lib/Widgets/ViewDual.vala"
	he_view_dual_set_orientation (self, orientation);
#line 129 "../lib/Widgets/ViewDual.vala"
	he_view_dual_set_handle_position (self, 1.0);
#line 130 "../lib/Widgets/ViewDual.vala"
	he_view_dual_set_show_handle (self, show_handle);
#line 127 "../lib/Widgets/ViewDual.vala"
	return self;
#line 469 "ViewDual.c"
}

HeViewDual*
he_view_dual_new (GtkOrientation orientation,
                  gboolean show_handle)
{
#line 127 "../lib/Widgets/ViewDual.vala"
	return he_view_dual_construct (HE_TYPE_VIEW_DUAL, orientation, show_handle);
#line 478 "ViewDual.c"
}

static void
he_view_dual_update_handle_look (HeViewDual* self)
{
	GtkOrientation _tmp0_;
	GtkOrientation _tmp1_;
#line 160 "../lib/Widgets/ViewDual.vala"
	g_return_if_fail (self != NULL);
#line 161 "../lib/Widgets/ViewDual.vala"
	_tmp0_ = he_view_dual_get_orientation (self);
#line 161 "../lib/Widgets/ViewDual.vala"
	_tmp1_ = _tmp0_;
#line 161 "../lib/Widgets/ViewDual.vala"
	if (_tmp1_ == GTK_ORIENTATION_HORIZONTAL) {
#line 494 "ViewDual.c"
		GtkWidget* _tmp2_;
		GtkWidget* _tmp3_;
		GtkBox* _tmp4_;
		GtkBox* _tmp5_;
#line 162 "../lib/Widgets/ViewDual.vala"
		_tmp2_ = self->priv->handle;
#line 162 "../lib/Widgets/ViewDual.vala"
		gtk_widget_add_css_class (_tmp2_, "drag-handle-vertical");
#line 163 "../lib/Widgets/ViewDual.vala"
		_tmp3_ = self->priv->handle;
#line 163 "../lib/Widgets/ViewDual.vala"
		gtk_widget_remove_css_class (_tmp3_, "drag-handle");
#line 164 "../lib/Widgets/ViewDual.vala"
		_tmp4_ = self->priv->handle_bin;
#line 164 "../lib/Widgets/ViewDual.vala"
		gtk_widget_add_css_class ((GtkWidget*) _tmp4_, "drag-handle-container-vertical");
#line 165 "../lib/Widgets/ViewDual.vala"
		_tmp5_ = self->priv->handle_bin;
#line 165 "../lib/Widgets/ViewDual.vala"
		gtk_widget_remove_css_class ((GtkWidget*) _tmp5_, "drag-handle-container");
#line 515 "ViewDual.c"
	} else {
		GtkWidget* _tmp6_;
		GtkWidget* _tmp7_;
		GtkBox* _tmp8_;
		GtkBox* _tmp9_;
#line 167 "../lib/Widgets/ViewDual.vala"
		_tmp6_ = self->priv->handle;
#line 167 "../lib/Widgets/ViewDual.vala"
		gtk_widget_add_css_class (_tmp6_, "drag-handle");
#line 168 "../lib/Widgets/ViewDual.vala"
		_tmp7_ = self->priv->handle;
#line 168 "../lib/Widgets/ViewDual.vala"
		gtk_widget_remove_css_class (_tmp7_, "drag-handle-vertical");
#line 169 "../lib/Widgets/ViewDual.vala"
		_tmp8_ = self->priv->handle_bin;
#line 169 "../lib/Widgets/ViewDual.vala"
		gtk_widget_add_css_class ((GtkWidget*) _tmp8_, "drag-handle-container");
#line 170 "../lib/Widgets/ViewDual.vala"
		_tmp9_ = self->priv->handle_bin;
#line 170 "../lib/Widgets/ViewDual.vala"
		gtk_widget_remove_css_class ((GtkWidget*) _tmp9_, "drag-handle-container-vertical");
#line 537 "ViewDual.c"
	}
}

static void
he_view_dual_update_refresh_rate (HeViewDual* self)
{
	GdkMonitor* monitor = NULL;
	GdkDisplay* _tmp0_;
	GtkNative* _tmp1_;
	GdkSurface* _tmp2_;
	GdkMonitor* _tmp3_;
	GdkMonitor* _tmp4_;
	GdkMonitor* _tmp5_;
#line 174 "../lib/Widgets/ViewDual.vala"
	g_return_if_fail (self != NULL);
#line 175 "../lib/Widgets/ViewDual.vala"
	_tmp0_ = gtk_widget_get_display ((GtkWidget*) self);
#line 175 "../lib/Widgets/ViewDual.vala"
	_tmp1_ = gtk_widget_get_native ((GtkWidget*) self);
#line 175 "../lib/Widgets/ViewDual.vala"
	_tmp2_ = gtk_native_get_surface (_tmp1_);
#line 175 "../lib/Widgets/ViewDual.vala"
	_tmp3_ = gdk_display_get_monitor_at_surface (_tmp0_, _tmp2_);
#line 175 "../lib/Widgets/ViewDual.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 175 "../lib/Widgets/ViewDual.vala"
	monitor = _tmp4_;
#line 176 "../lib/Widgets/ViewDual.vala"
	_tmp5_ = monitor;
#line 176 "../lib/Widgets/ViewDual.vala"
	if (_tmp5_ != NULL) {
#line 569 "ViewDual.c"
		gint refresh_rate = 0;
		GdkMonitor* _tmp6_;
#line 177 "../lib/Widgets/ViewDual.vala"
		_tmp6_ = monitor;
#line 177 "../lib/Widgets/ViewDual.vala"
		refresh_rate = gdk_monitor_get_refresh_rate (_tmp6_);
#line 178 "../lib/Widgets/ViewDual.vala"
		if (refresh_rate > 0) {
#line 179 "../lib/Widgets/ViewDual.vala"
			self->priv->update_interval = (gint) (1000 / (refresh_rate / 1000));
#line 580 "ViewDual.c"
		}
	}
#line 174 "../lib/Widgets/ViewDual.vala"
	_g_object_unref0 (monitor);
#line 585 "ViewDual.c"
}

static void
he_view_dual_on_drag_begin (HeViewDual* self,
                            GtkGestureDrag* gesture,
                            gdouble x,
                            gdouble y)
{
	gdouble _tmp0_ = 0.0;
	GtkOrientation _tmp1_;
	GtkOrientation _tmp2_;
	gdouble _tmp3_;
	gdouble _tmp4_;
#line 184 "../lib/Widgets/ViewDual.vala"
	g_return_if_fail (self != NULL);
#line 184 "../lib/Widgets/ViewDual.vala"
	g_return_if_fail (gesture != NULL);
#line 185 "../lib/Widgets/ViewDual.vala"
	self->priv->dragging = TRUE;
#line 186 "../lib/Widgets/ViewDual.vala"
	_tmp1_ = he_view_dual_get_orientation (self);
#line 186 "../lib/Widgets/ViewDual.vala"
	_tmp2_ = _tmp1_;
#line 186 "../lib/Widgets/ViewDual.vala"
	if (_tmp2_ == GTK_ORIENTATION_HORIZONTAL) {
#line 186 "../lib/Widgets/ViewDual.vala"
		_tmp0_ = x;
#line 613 "ViewDual.c"
	} else {
#line 186 "../lib/Widgets/ViewDual.vala"
		_tmp0_ = y;
#line 617 "ViewDual.c"
	}
#line 186 "../lib/Widgets/ViewDual.vala"
	self->priv->initial_xy = _tmp0_;
#line 187 "../lib/Widgets/ViewDual.vala"
	_tmp3_ = he_view_dual_get_handle_position (self);
#line 187 "../lib/Widgets/ViewDual.vala"
	_tmp4_ = _tmp3_;
#line 187 "../lib/Widgets/ViewDual.vala"
	self->priv->initial_pos = _tmp4_;
#line 627 "ViewDual.c"
}

static gdouble
he_view_dual_snap_to_nearest (HeViewDual* self,
                              gdouble value)
{
	gdouble closest_snap = 0.0;
	gdouble min_distance = 0.0;
	gdouble* _tmp0_;
	gint _tmp0__length1;
	gdouble result;
#line 190 "../lib/Widgets/ViewDual.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 191 "../lib/Widgets/ViewDual.vala"
	closest_snap = value;
#line 192 "../lib/Widgets/ViewDual.vala"
	min_distance = DBL_MAX;
#line 194 "../lib/Widgets/ViewDual.vala"
	_tmp0_ = self->priv->snap_values;
#line 194 "../lib/Widgets/ViewDual.vala"
	_tmp0__length1 = self->priv->snap_values_length1;
#line 649 "ViewDual.c"
	{
		gdouble* snap_collection = NULL;
		gint snap_collection_length1 = 0;
		gint _snap_collection_size_ = 0;
		gint snap_it = 0;
#line 194 "../lib/Widgets/ViewDual.vala"
		snap_collection = _tmp0_;
#line 194 "../lib/Widgets/ViewDual.vala"
		snap_collection_length1 = _tmp0__length1;
#line 194 "../lib/Widgets/ViewDual.vala"
		for (snap_it = 0; snap_it < snap_collection_length1; snap_it = snap_it + 1) {
#line 661 "ViewDual.c"
			gdouble snap = 0.0;
#line 194 "../lib/Widgets/ViewDual.vala"
			snap = snap_collection[snap_it];
#line 665 "ViewDual.c"
			{
				gdouble distance = 0.0;
#line 195 "../lib/Widgets/ViewDual.vala"
				distance = fabs (value - snap);
#line 196 "../lib/Widgets/ViewDual.vala"
				if (distance < min_distance) {
#line 197 "../lib/Widgets/ViewDual.vala"
					min_distance = distance;
#line 198 "../lib/Widgets/ViewDual.vala"
					if (distance < self->priv->snap_threshold) {
#line 199 "../lib/Widgets/ViewDual.vala"
						closest_snap = snap;
#line 678 "ViewDual.c"
					}
				}
			}
		}
	}
#line 204 "../lib/Widgets/ViewDual.vala"
	result = closest_snap;
#line 204 "../lib/Widgets/ViewDual.vala"
	return result;
#line 688 "ViewDual.c"
}

static gdouble
he_view_dual_lerp (HeViewDual* self,
                   gdouble start,
                   gdouble end,
                   gdouble t)
{
	gdouble result;
#line 207 "../lib/Widgets/ViewDual.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 208 "../lib/Widgets/ViewDual.vala"
	result = start + ((end - start) * t);
#line 208 "../lib/Widgets/ViewDual.vala"
	return result;
#line 704 "ViewDual.c"
}

static gboolean
____lambda195_ (HeViewDual* self)
{
	gdouble lerp_amount = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gboolean result;
#line 230 "../lib/Widgets/ViewDual.vala"
	lerp_amount = 0.05;
#line 231 "../lib/Widgets/ViewDual.vala"
	_tmp0_ = he_view_dual_get_handle_position (self);
#line 231 "../lib/Widgets/ViewDual.vala"
	_tmp1_ = _tmp0_;
#line 231 "../lib/Widgets/ViewDual.vala"
	if (fabs (self->priv->target_pos - _tmp1_) > 0.01) {
#line 722 "ViewDual.c"
		gdouble _tmp2_;
		gdouble _tmp3_;
#line 232 "../lib/Widgets/ViewDual.vala"
		_tmp2_ = he_view_dual_get_handle_position (self);
#line 232 "../lib/Widgets/ViewDual.vala"
		_tmp3_ = _tmp2_;
#line 232 "../lib/Widgets/ViewDual.vala"
		he_view_dual_set_handle_position (self, he_view_dual_lerp (self, _tmp3_, self->priv->target_pos, lerp_amount));
#line 233 "../lib/Widgets/ViewDual.vala"
		gtk_widget_queue_allocate ((GtkWidget*) self);
#line 234 "../lib/Widgets/ViewDual.vala"
		result = TRUE;
#line 234 "../lib/Widgets/ViewDual.vala"
		return result;
#line 737 "ViewDual.c"
	} else {
#line 236 "../lib/Widgets/ViewDual.vala"
		he_view_dual_set_handle_position (self, self->priv->target_pos);
#line 237 "../lib/Widgets/ViewDual.vala"
		_g_source_unref0 (self->priv->resize_timeout);
#line 237 "../lib/Widgets/ViewDual.vala"
		self->priv->resize_timeout = NULL;
#line 238 "../lib/Widgets/ViewDual.vala"
		gtk_widget_queue_allocate ((GtkWidget*) self);
#line 239 "../lib/Widgets/ViewDual.vala"
		result = FALSE;
#line 239 "../lib/Widgets/ViewDual.vala"
		return result;
#line 751 "ViewDual.c"
	}
}

static gboolean
_____lambda195__gsource_func (gpointer self)
{
	gboolean result;
	result = ____lambda195_ ((HeViewDual*) self);
#line 228 "../lib/Widgets/ViewDual.vala"
	return result;
#line 762 "ViewDual.c"
}

static void
he_view_dual_on_drag_update (HeViewDual* self,
                             GtkGestureDrag* gesture,
                             gdouble offset_x,
                             gdouble offset_y)
{
#line 211 "../lib/Widgets/ViewDual.vala"
	g_return_if_fail (self != NULL);
#line 211 "../lib/Widgets/ViewDual.vala"
	g_return_if_fail (gesture != NULL);
#line 212 "../lib/Widgets/ViewDual.vala"
	if (self->priv->dragging) {
#line 777 "ViewDual.c"
		GtkOrientation _tmp0_;
		GtkOrientation _tmp1_;
		GSource* _tmp2_;
#line 213 "../lib/Widgets/ViewDual.vala"
		_tmp0_ = he_view_dual_get_orientation (self);
#line 213 "../lib/Widgets/ViewDual.vala"
		_tmp1_ = _tmp0_;
#line 213 "../lib/Widgets/ViewDual.vala"
		if (_tmp1_ == GTK_ORIENTATION_HORIZONTAL) {
#line 214 "../lib/Widgets/ViewDual.vala"
			self->priv->target_pos = self->priv->initial_pos + offset_x;
#line 789 "ViewDual.c"
		} else {
#line 216 "../lib/Widgets/ViewDual.vala"
			self->priv->target_pos = self->priv->initial_pos + offset_y;
#line 793 "ViewDual.c"
		}
#line 220 "../lib/Widgets/ViewDual.vala"
		self->priv->target_pos = CLAMP (self->priv->target_pos, 0.6, 1.5);
#line 223 "../lib/Widgets/ViewDual.vala"
		self->priv->target_pos = he_view_dual_snap_to_nearest (self, self->priv->target_pos);
#line 225 "../lib/Widgets/ViewDual.vala"
		_tmp2_ = self->priv->resize_timeout;
#line 225 "../lib/Widgets/ViewDual.vala"
		if (_tmp2_ == NULL) {
#line 803 "ViewDual.c"
			GSource* _tmp3_;
			GSource* _tmp4_;
			GSource* _tmp5_;
			GMainContext* _tmp6_;
#line 226 "../lib/Widgets/ViewDual.vala"
			he_view_dual_update_refresh_rate (self);
#line 227 "../lib/Widgets/ViewDual.vala"
			_tmp3_ = g_timeout_source_new ((guint) self->priv->update_interval);
#line 227 "../lib/Widgets/ViewDual.vala"
			_g_source_unref0 (self->priv->resize_timeout);
#line 227 "../lib/Widgets/ViewDual.vala"
			self->priv->resize_timeout = _tmp3_;
#line 228 "../lib/Widgets/ViewDual.vala"
			_tmp4_ = self->priv->resize_timeout;
#line 228 "../lib/Widgets/ViewDual.vala"
			g_source_set_callback (_tmp4_, _____lambda195__gsource_func, g_object_ref (self), g_object_unref);
#line 242 "../lib/Widgets/ViewDual.vala"
			_tmp5_ = self->priv->resize_timeout;
#line 242 "../lib/Widgets/ViewDual.vala"
			_tmp6_ = g_main_context_default ();
#line 242 "../lib/Widgets/ViewDual.vala"
			g_source_attach (_tmp5_, _tmp6_);
#line 826 "ViewDual.c"
		}
	}
}

static void
he_view_dual_on_drag_end (HeViewDual* self,
                          GtkGestureDrag* gesture,
                          gdouble offset_x,
                          gdouble offset_y)
{
	GSource* _tmp0_;
#line 247 "../lib/Widgets/ViewDual.vala"
	g_return_if_fail (self != NULL);
#line 247 "../lib/Widgets/ViewDual.vala"
	g_return_if_fail (gesture != NULL);
#line 248 "../lib/Widgets/ViewDual.vala"
	self->priv->dragging = FALSE;
#line 249 "../lib/Widgets/ViewDual.vala"
	self->priv->initial_pos = (gdouble) 0;
#line 250 "../lib/Widgets/ViewDual.vala"
	_tmp0_ = self->priv->resize_timeout;
#line 250 "../lib/Widgets/ViewDual.vala"
	if (_tmp0_ != NULL) {
#line 850 "ViewDual.c"
		GSource* _tmp1_;
#line 251 "../lib/Widgets/ViewDual.vala"
		_tmp1_ = self->priv->resize_timeout;
#line 251 "../lib/Widgets/ViewDual.vala"
		g_source_destroy (_tmp1_);
#line 252 "../lib/Widgets/ViewDual.vala"
		_g_source_unref0 (self->priv->resize_timeout);
#line 252 "../lib/Widgets/ViewDual.vala"
		self->priv->resize_timeout = NULL;
#line 860 "ViewDual.c"
	}
}

static void
he_view_dual_real_dispose (GObject* base)
{
	HeViewDual * self;
	GtkBox* _tmp0_;
	GtkBox* _tmp2_;
	GtkBox* _tmp4_;
	GtkWidget* _tmp6_;
#line 256 "../lib/Widgets/ViewDual.vala"
	self = (HeViewDual*) base;
#line 257 "../lib/Widgets/ViewDual.vala"
	_tmp0_ = self->priv->child_end_bin;
#line 257 "../lib/Widgets/ViewDual.vala"
	if (_tmp0_ != NULL) {
#line 878 "ViewDual.c"
		GtkBox* _tmp1_;
#line 258 "../lib/Widgets/ViewDual.vala"
		_tmp1_ = self->priv->child_end_bin;
#line 258 "../lib/Widgets/ViewDual.vala"
		gtk_widget_unparent ((GtkWidget*) _tmp1_);
#line 884 "ViewDual.c"
	}
#line 260 "../lib/Widgets/ViewDual.vala"
	_tmp2_ = self->priv->child_start_bin;
#line 260 "../lib/Widgets/ViewDual.vala"
	if (_tmp2_ != NULL) {
#line 890 "ViewDual.c"
		GtkBox* _tmp3_;
#line 261 "../lib/Widgets/ViewDual.vala"
		_tmp3_ = self->priv->child_start_bin;
#line 261 "../lib/Widgets/ViewDual.vala"
		gtk_widget_unparent ((GtkWidget*) _tmp3_);
#line 896 "ViewDual.c"
	}
#line 263 "../lib/Widgets/ViewDual.vala"
	_tmp4_ = self->priv->handle_bin;
#line 263 "../lib/Widgets/ViewDual.vala"
	if (_tmp4_ != NULL) {
#line 902 "ViewDual.c"
		GtkBox* _tmp5_;
#line 264 "../lib/Widgets/ViewDual.vala"
		_tmp5_ = self->priv->handle_bin;
#line 264 "../lib/Widgets/ViewDual.vala"
		gtk_widget_unparent ((GtkWidget*) _tmp5_);
#line 908 "ViewDual.c"
	}
#line 266 "../lib/Widgets/ViewDual.vala"
	_tmp6_ = self->priv->base_bin;
#line 266 "../lib/Widgets/ViewDual.vala"
	if (_tmp6_ != NULL) {
#line 914 "ViewDual.c"
		GtkWidget* _tmp7_;
#line 267 "../lib/Widgets/ViewDual.vala"
		_tmp7_ = self->priv->base_bin;
#line 267 "../lib/Widgets/ViewDual.vala"
		gtk_widget_unparent (_tmp7_);
#line 920 "ViewDual.c"
	}
#line 269 "../lib/Widgets/ViewDual.vala"
	G_OBJECT_CLASS (he_view_dual_parent_class)->dispose ((GObject*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
#line 924 "ViewDual.c"
}

static gboolean
he_view_dual_real_contains (GtkWidget* base,
                            gdouble x,
                            gdouble y)
{
	HeViewDual * self;
	gboolean result;
#line 272 "../lib/Widgets/ViewDual.vala"
	self = (HeViewDual*) base;
#line 273 "../lib/Widgets/ViewDual.vala"
	result = FALSE;
#line 273 "../lib/Widgets/ViewDual.vala"
	return result;
#line 940 "ViewDual.c"
}

static void
he_view_dual_real_measure (GtkWidget* base,
                           GtkOrientation orientation,
                           gint for_size,
                           gint* min,
                           gint* nat,
                           gint* min_baseline,
                           gint* nat_baseline)
{
	HeViewDual * self;
	gint _vala_min = 0;
	gint _vala_nat = 0;
	gint _vala_min_baseline = 0;
	gint _vala_nat_baseline = 0;
	gint csmin = 0;
	gint cemin = 0;
	gint handle_min = 0;
	gint base_bin_min = 0;
	GtkBox* _tmp0_;
	gint _tmp1_ = 0;
	GtkBox* _tmp2_;
	gint _tmp3_ = 0;
	GtkWidget* _tmp4_;
	gint _tmp5_ = 0;
	GtkWidget* _tmp6_;
	gint _tmp7_ = 0;
#line 276 "../lib/Widgets/ViewDual.vala"
	self = (HeViewDual*) base;
#line 278 "../lib/Widgets/ViewDual.vala"
	_vala_nat = 0;
#line 278 "../lib/Widgets/ViewDual.vala"
	_vala_min = _vala_nat;
#line 280 "../lib/Widgets/ViewDual.vala"
	_tmp0_ = self->priv->child_start_bin;
#line 280 "../lib/Widgets/ViewDual.vala"
	gtk_widget_measure ((GtkWidget*) _tmp0_, orientation, for_size, &_tmp1_, NULL, NULL, NULL);
#line 280 "../lib/Widgets/ViewDual.vala"
	csmin = _tmp1_;
#line 281 "../lib/Widgets/ViewDual.vala"
	_tmp2_ = self->priv->child_end_bin;
#line 281 "../lib/Widgets/ViewDual.vala"
	gtk_widget_measure ((GtkWidget*) _tmp2_, orientation, for_size, &_tmp3_, NULL, NULL, NULL);
#line 281 "../lib/Widgets/ViewDual.vala"
	cemin = _tmp3_;
#line 282 "../lib/Widgets/ViewDual.vala"
	_tmp4_ = self->priv->handle;
#line 282 "../lib/Widgets/ViewDual.vala"
	gtk_widget_measure (_tmp4_, orientation, for_size, &_tmp5_, NULL, NULL, NULL);
#line 282 "../lib/Widgets/ViewDual.vala"
	handle_min = _tmp5_;
#line 283 "../lib/Widgets/ViewDual.vala"
	_tmp6_ = self->priv->base_bin;
#line 283 "../lib/Widgets/ViewDual.vala"
	gtk_widget_measure (_tmp6_, orientation, for_size, &_tmp7_, NULL, NULL, NULL);
#line 283 "../lib/Widgets/ViewDual.vala"
	base_bin_min = _tmp7_;
#line 285 "../lib/Widgets/ViewDual.vala"
	if (orientation == GTK_ORIENTATION_HORIZONTAL) {
#line 286 "../lib/Widgets/ViewDual.vala"
		_vala_min = MAX (base_bin_min, (csmin + cemin) + handle_min);
#line 1003 "ViewDual.c"
	} else {
#line 288 "../lib/Widgets/ViewDual.vala"
		_vala_min = MAX (base_bin_min, (csmin + cemin) + handle_min);
#line 1007 "ViewDual.c"
	}
#line 291 "../lib/Widgets/ViewDual.vala"
	_vala_min_baseline = -1;
#line 292 "../lib/Widgets/ViewDual.vala"
	_vala_nat_baseline = -1;
#line 276 "../lib/Widgets/ViewDual.vala"
	if (min) {
#line 276 "../lib/Widgets/ViewDual.vala"
		*min = _vala_min;
#line 1017 "ViewDual.c"
	}
#line 276 "../lib/Widgets/ViewDual.vala"
	if (nat) {
#line 276 "../lib/Widgets/ViewDual.vala"
		*nat = _vala_nat;
#line 1023 "ViewDual.c"
	}
#line 276 "../lib/Widgets/ViewDual.vala"
	if (min_baseline) {
#line 276 "../lib/Widgets/ViewDual.vala"
		*min_baseline = _vala_min_baseline;
#line 1029 "ViewDual.c"
	}
#line 276 "../lib/Widgets/ViewDual.vala"
	if (nat_baseline) {
#line 276 "../lib/Widgets/ViewDual.vala"
		*nat_baseline = _vala_nat_baseline;
#line 1035 "ViewDual.c"
	}
}

static gpointer
_gsk_transform_ref0 (gpointer self)
{
#line 315 "../lib/Widgets/ViewDual.vala"
	return self ? gsk_transform_ref (self) : NULL;
#line 1044 "ViewDual.c"
}

static void
he_view_dual_real_size_allocate (GtkWidget* base,
                                 gint width,
                                 gint height,
                                 gint baseline)
{
	HeViewDual * self;
	GtkWidget* _tmp0_;
	gint child_start_min = 0;
	gint child_end_min = 0;
	GtkBox* _tmp1_;
	GtkOrientation _tmp2_;
	GtkOrientation _tmp3_;
	gint _tmp4_ = 0;
	GtkBox* _tmp5_;
	GtkOrientation _tmp6_;
	GtkOrientation _tmp7_;
	gint _tmp8_ = 0;
	gint handle_width = 0;
	gint handle_height = 0;
	gint offset_rounded_x = 0;
	gdouble _tmp9_;
	gdouble _tmp10_;
	gint offset_rounded_y = 0;
	gdouble _tmp11_;
	gdouble _tmp12_;
	GskTransform* ts = NULL;
	GskTransform* _tmp13_;
	GskTransform* te = NULL;
	GskTransform* _tmp14_;
	GskTransform* th = NULL;
	GskTransform* _tmp15_;
	GtkOrientation _tmp16_;
	GtkOrientation _tmp17_;
	GtkBox* _tmp54_;
#line 295 "../lib/Widgets/ViewDual.vala"
	self = (HeViewDual*) base;
#line 296 "../lib/Widgets/ViewDual.vala"
	_tmp0_ = self->priv->base_bin;
#line 296 "../lib/Widgets/ViewDual.vala"
	gtk_widget_allocate (_tmp0_, width, height, -1, NULL);
#line 300 "../lib/Widgets/ViewDual.vala"
	_tmp1_ = self->priv->child_start_bin;
#line 300 "../lib/Widgets/ViewDual.vala"
	_tmp2_ = he_view_dual_get_orientation (self);
#line 300 "../lib/Widgets/ViewDual.vala"
	_tmp3_ = _tmp2_;
#line 300 "../lib/Widgets/ViewDual.vala"
	gtk_widget_measure ((GtkWidget*) _tmp1_, _tmp3_, width, &_tmp4_, NULL, NULL, NULL);
#line 300 "../lib/Widgets/ViewDual.vala"
	child_start_min = _tmp4_;
#line 301 "../lib/Widgets/ViewDual.vala"
	_tmp5_ = self->priv->child_end_bin;
#line 301 "../lib/Widgets/ViewDual.vala"
	_tmp6_ = he_view_dual_get_orientation (self);
#line 301 "../lib/Widgets/ViewDual.vala"
	_tmp7_ = _tmp6_;
#line 301 "../lib/Widgets/ViewDual.vala"
	gtk_widget_measure ((GtkWidget*) _tmp5_, _tmp7_, width, &_tmp8_, NULL, NULL, NULL);
#line 301 "../lib/Widgets/ViewDual.vala"
	child_end_min = _tmp8_;
#line 303 "../lib/Widgets/ViewDual.vala"
	handle_width = 0;
#line 303 "../lib/Widgets/ViewDual.vala"
	handle_height = 0;
#line 305 "../lib/Widgets/ViewDual.vala"
	_tmp9_ = he_view_dual_get_handle_position (self);
#line 305 "../lib/Widgets/ViewDual.vala"
	_tmp10_ = _tmp9_;
#line 305 "../lib/Widgets/ViewDual.vala"
	offset_rounded_x = (gint) round (_tmp10_ * width);
#line 306 "../lib/Widgets/ViewDual.vala"
	_tmp11_ = he_view_dual_get_handle_position (self);
#line 306 "../lib/Widgets/ViewDual.vala"
	_tmp12_ = _tmp11_;
#line 306 "../lib/Widgets/ViewDual.vala"
	offset_rounded_y = (gint) round (_tmp12_ * height);
#line 308 "../lib/Widgets/ViewDual.vala"
	_tmp13_ = gsk_transform_new ();
#line 308 "../lib/Widgets/ViewDual.vala"
	ts = _tmp13_;
#line 309 "../lib/Widgets/ViewDual.vala"
	_tmp14_ = gsk_transform_new ();
#line 309 "../lib/Widgets/ViewDual.vala"
	te = _tmp14_;
#line 310 "../lib/Widgets/ViewDual.vala"
	_tmp15_ = gsk_transform_new ();
#line 310 "../lib/Widgets/ViewDual.vala"
	th = _tmp15_;
#line 312 "../lib/Widgets/ViewDual.vala"
	_tmp16_ = he_view_dual_get_orientation (self);
#line 312 "../lib/Widgets/ViewDual.vala"
	_tmp17_ = _tmp16_;
#line 312 "../lib/Widgets/ViewDual.vala"
	if (_tmp17_ == GTK_ORIENTATION_HORIZONTAL) {
#line 1142 "ViewDual.c"
		GskTransform* _tmp18_;
		graphene_point_t _tmp19_ = {0};
		GskTransform* _tmp20_;
		GskTransform* _tmp21_;
		graphene_point_t _tmp22_ = {0};
		GskTransform* _tmp23_;
		GtkBox* _tmp24_;
		gdouble _tmp25_;
		gdouble _tmp26_;
		GskTransform* _tmp27_;
		GskTransform* _tmp28_;
		GtkBox* _tmp29_;
		gdouble _tmp30_;
		gdouble _tmp31_;
		gdouble _tmp32_;
		gdouble _tmp33_;
		GskTransform* _tmp34_;
		GskTransform* _tmp35_;
#line 313 "../lib/Widgets/ViewDual.vala"
		_tmp18_ = ts;
#line 313 "../lib/Widgets/ViewDual.vala"
		ts = NULL;
#line 313 "../lib/Widgets/ViewDual.vala"
		_tmp19_.x = (gfloat) 0;
#line 313 "../lib/Widgets/ViewDual.vala"
		_tmp19_.y = (gfloat) 0;
#line 313 "../lib/Widgets/ViewDual.vala"
		_tmp20_ = gsk_transform_translate (_tmp18_, &_tmp19_);
#line 313 "../lib/Widgets/ViewDual.vala"
		_gsk_transform_unref0 (ts);
#line 313 "../lib/Widgets/ViewDual.vala"
		ts = _tmp20_;
#line 314 "../lib/Widgets/ViewDual.vala"
		_tmp21_ = te;
#line 314 "../lib/Widgets/ViewDual.vala"
		te = NULL;
#line 314 "../lib/Widgets/ViewDual.vala"
		_tmp22_.x = (gfloat) ((offset_rounded_x / 2) + ((gint) HE_VIEW_DUAL_MIDDLE_SPACING));
#line 314 "../lib/Widgets/ViewDual.vala"
		_tmp22_.y = (gfloat) 0;
#line 314 "../lib/Widgets/ViewDual.vala"
		_tmp23_ = gsk_transform_translate (_tmp21_, &_tmp22_);
#line 314 "../lib/Widgets/ViewDual.vala"
		_gsk_transform_unref0 (te);
#line 314 "../lib/Widgets/ViewDual.vala"
		te = _tmp23_;
#line 315 "../lib/Widgets/ViewDual.vala"
		_tmp24_ = self->priv->child_start_bin;
#line 315 "../lib/Widgets/ViewDual.vala"
		_tmp25_ = he_view_dual_get_handle_position (self);
#line 315 "../lib/Widgets/ViewDual.vala"
		_tmp26_ = _tmp25_;
#line 315 "../lib/Widgets/ViewDual.vala"
		_tmp27_ = ts;
#line 315 "../lib/Widgets/ViewDual.vala"
		_tmp28_ = _gsk_transform_ref0 (_tmp27_);
#line 315 "../lib/Widgets/ViewDual.vala"
		gtk_widget_allocate ((GtkWidget*) _tmp24_, (gint) ((width / 2) * _tmp26_), height, -1, _tmp28_);
#line 316 "../lib/Widgets/ViewDual.vala"
		_tmp29_ = self->priv->child_end_bin;
#line 316 "../lib/Widgets/ViewDual.vala"
		_tmp30_ = he_view_dual_get_handle_position (self);
#line 316 "../lib/Widgets/ViewDual.vala"
		_tmp31_ = _tmp30_;
#line 316 "../lib/Widgets/ViewDual.vala"
		_tmp32_ = he_view_dual_get_handle_position (self);
#line 316 "../lib/Widgets/ViewDual.vala"
		_tmp33_ = _tmp32_;
#line 316 "../lib/Widgets/ViewDual.vala"
		_tmp34_ = te;
#line 316 "../lib/Widgets/ViewDual.vala"
		_tmp35_ = _gsk_transform_ref0 (_tmp34_);
#line 316 "../lib/Widgets/ViewDual.vala"
		gtk_widget_allocate ((GtkWidget*) _tmp29_, ((gint) ((width / _tmp31_) * _tmp33_)) - ((offset_rounded_x / 2) + ((gint) HE_VIEW_DUAL_MIDDLE_SPACING)), height, -1, _tmp35_);
#line 1217 "ViewDual.c"
	} else {
		GskTransform* _tmp36_;
		graphene_point_t _tmp37_ = {0};
		GskTransform* _tmp38_;
		GskTransform* _tmp39_;
		graphene_point_t _tmp40_ = {0};
		GskTransform* _tmp41_;
		GtkBox* _tmp42_;
		gdouble _tmp43_;
		gdouble _tmp44_;
		GskTransform* _tmp45_;
		GskTransform* _tmp46_;
		GtkBox* _tmp47_;
		gdouble _tmp48_;
		gdouble _tmp49_;
		gdouble _tmp50_;
		gdouble _tmp51_;
		GskTransform* _tmp52_;
		GskTransform* _tmp53_;
#line 318 "../lib/Widgets/ViewDual.vala"
		_tmp36_ = ts;
#line 318 "../lib/Widgets/ViewDual.vala"
		ts = NULL;
#line 318 "../lib/Widgets/ViewDual.vala"
		_tmp37_.x = (gfloat) 0;
#line 318 "../lib/Widgets/ViewDual.vala"
		_tmp37_.y = (gfloat) 0;
#line 318 "../lib/Widgets/ViewDual.vala"
		_tmp38_ = gsk_transform_translate (_tmp36_, &_tmp37_);
#line 318 "../lib/Widgets/ViewDual.vala"
		_gsk_transform_unref0 (ts);
#line 318 "../lib/Widgets/ViewDual.vala"
		ts = _tmp38_;
#line 319 "../lib/Widgets/ViewDual.vala"
		_tmp39_ = te;
#line 319 "../lib/Widgets/ViewDual.vala"
		te = NULL;
#line 319 "../lib/Widgets/ViewDual.vala"
		_tmp40_.x = (gfloat) 0;
#line 319 "../lib/Widgets/ViewDual.vala"
		_tmp40_.y = (gfloat) ((offset_rounded_y / 2) + ((gint) HE_VIEW_DUAL_MIDDLE_SPACING));
#line 319 "../lib/Widgets/ViewDual.vala"
		_tmp41_ = gsk_transform_translate (_tmp39_, &_tmp40_);
#line 319 "../lib/Widgets/ViewDual.vala"
		_gsk_transform_unref0 (te);
#line 319 "../lib/Widgets/ViewDual.vala"
		te = _tmp41_;
#line 320 "../lib/Widgets/ViewDual.vala"
		_tmp42_ = self->priv->child_start_bin;
#line 320 "../lib/Widgets/ViewDual.vala"
		_tmp43_ = he_view_dual_get_handle_position (self);
#line 320 "../lib/Widgets/ViewDual.vala"
		_tmp44_ = _tmp43_;
#line 320 "../lib/Widgets/ViewDual.vala"
		_tmp45_ = ts;
#line 320 "../lib/Widgets/ViewDual.vala"
		_tmp46_ = _gsk_transform_ref0 (_tmp45_);
#line 320 "../lib/Widgets/ViewDual.vala"
		gtk_widget_allocate ((GtkWidget*) _tmp42_, width, (gint) ((height / 2) * _tmp44_), -1, _tmp46_);
#line 321 "../lib/Widgets/ViewDual.vala"
		_tmp47_ = self->priv->child_end_bin;
#line 321 "../lib/Widgets/ViewDual.vala"
		_tmp48_ = he_view_dual_get_handle_position (self);
#line 321 "../lib/Widgets/ViewDual.vala"
		_tmp49_ = _tmp48_;
#line 321 "../lib/Widgets/ViewDual.vala"
		_tmp50_ = he_view_dual_get_handle_position (self);
#line 321 "../lib/Widgets/ViewDual.vala"
		_tmp51_ = _tmp50_;
#line 321 "../lib/Widgets/ViewDual.vala"
		_tmp52_ = te;
#line 321 "../lib/Widgets/ViewDual.vala"
		_tmp53_ = _gsk_transform_ref0 (_tmp52_);
#line 321 "../lib/Widgets/ViewDual.vala"
		gtk_widget_allocate ((GtkWidget*) _tmp47_, width, ((gint) ((height / _tmp49_) * _tmp51_)) - ((offset_rounded_y / 2) + ((gint) HE_VIEW_DUAL_MIDDLE_SPACING)), -1, _tmp53_);
#line 1293 "ViewDual.c"
	}
#line 324 "../lib/Widgets/ViewDual.vala"
	_tmp54_ = self->priv->handle_bin;
#line 324 "../lib/Widgets/ViewDual.vala"
	if (_tmp54_ != NULL) {
#line 1299 "ViewDual.c"
		GtkBox* _tmp55_;
		gint _tmp56_ = 0;
		GtkBox* _tmp57_;
		gint _tmp58_ = 0;
		GtkOrientation _tmp59_;
		GtkOrientation _tmp60_;
#line 325 "../lib/Widgets/ViewDual.vala"
		_tmp55_ = self->priv->handle_bin;
#line 325 "../lib/Widgets/ViewDual.vala"
		gtk_widget_measure ((GtkWidget*) _tmp55_, GTK_ORIENTATION_HORIZONTAL, -1, NULL, &_tmp56_, NULL, NULL);
#line 325 "../lib/Widgets/ViewDual.vala"
		handle_width = _tmp56_;
#line 326 "../lib/Widgets/ViewDual.vala"
		_tmp57_ = self->priv->handle_bin;
#line 326 "../lib/Widgets/ViewDual.vala"
		gtk_widget_measure ((GtkWidget*) _tmp57_, GTK_ORIENTATION_VERTICAL, -1, NULL, &_tmp58_, NULL, NULL);
#line 326 "../lib/Widgets/ViewDual.vala"
		handle_height = _tmp58_;
#line 328 "../lib/Widgets/ViewDual.vala"
		_tmp59_ = he_view_dual_get_orientation (self);
#line 328 "../lib/Widgets/ViewDual.vala"
		_tmp60_ = _tmp59_;
#line 328 "../lib/Widgets/ViewDual.vala"
		if (_tmp60_ == GTK_ORIENTATION_HORIZONTAL) {
#line 1324 "ViewDual.c"
			GskTransform* _tmp61_;
			graphene_point_t _tmp62_ = {0};
			GskTransform* _tmp63_;
			GtkBox* _tmp64_;
			GskTransform* _tmp65_;
			GskTransform* _tmp66_;
#line 329 "../lib/Widgets/ViewDual.vala"
			_tmp61_ = th;
#line 329 "../lib/Widgets/ViewDual.vala"
			th = NULL;
#line 329 "../lib/Widgets/ViewDual.vala"
			_tmp62_.x = (gfloat) (offset_rounded_x / 2);
#line 329 "../lib/Widgets/ViewDual.vala"
			_tmp62_.y = (gfloat) (height / 2);
#line 329 "../lib/Widgets/ViewDual.vala"
			_tmp63_ = gsk_transform_translate (_tmp61_, &_tmp62_);
#line 329 "../lib/Widgets/ViewDual.vala"
			_gsk_transform_unref0 (th);
#line 329 "../lib/Widgets/ViewDual.vala"
			th = _tmp63_;
#line 330 "../lib/Widgets/ViewDual.vala"
			_tmp64_ = self->priv->handle_bin;
#line 330 "../lib/Widgets/ViewDual.vala"
			_tmp65_ = th;
#line 330 "../lib/Widgets/ViewDual.vala"
			_tmp66_ = _gsk_transform_ref0 (_tmp65_);
#line 330 "../lib/Widgets/ViewDual.vala"
			gtk_widget_allocate ((GtkWidget*) _tmp64_, handle_width, handle_height, -1, _tmp66_);
#line 1353 "ViewDual.c"
		} else {
			GskTransform* _tmp67_;
			graphene_point_t _tmp68_ = {0};
			GskTransform* _tmp69_;
			GtkBox* _tmp70_;
			GskTransform* _tmp71_;
			GskTransform* _tmp72_;
#line 332 "../lib/Widgets/ViewDual.vala"
			_tmp67_ = th;
#line 332 "../lib/Widgets/ViewDual.vala"
			th = NULL;
#line 332 "../lib/Widgets/ViewDual.vala"
			_tmp68_.x = (gfloat) (width / 2);
#line 332 "../lib/Widgets/ViewDual.vala"
			_tmp68_.y = (gfloat) (offset_rounded_y / 2);
#line 332 "../lib/Widgets/ViewDual.vala"
			_tmp69_ = gsk_transform_translate (_tmp67_, &_tmp68_);
#line 332 "../lib/Widgets/ViewDual.vala"
			_gsk_transform_unref0 (th);
#line 332 "../lib/Widgets/ViewDual.vala"
			th = _tmp69_;
#line 333 "../lib/Widgets/ViewDual.vala"
			_tmp70_ = self->priv->handle_bin;
#line 333 "../lib/Widgets/ViewDual.vala"
			_tmp71_ = th;
#line 333 "../lib/Widgets/ViewDual.vala"
			_tmp72_ = _gsk_transform_ref0 (_tmp71_);
#line 333 "../lib/Widgets/ViewDual.vala"
			gtk_widget_allocate ((GtkWidget*) _tmp70_, handle_width, handle_height, -1, _tmp72_);
#line 1383 "ViewDual.c"
		}
	}
#line 295 "../lib/Widgets/ViewDual.vala"
	_gsk_transform_unref0 (th);
#line 295 "../lib/Widgets/ViewDual.vala"
	_gsk_transform_unref0 (te);
#line 295 "../lib/Widgets/ViewDual.vala"
	_gsk_transform_unref0 (ts);
#line 1392 "ViewDual.c"
}

static void
_he_view_dual_on_drag_begin_gtk_gesture_drag_drag_begin (GtkGestureDrag* _sender,
                                                         gdouble start_x,
                                                         gdouble start_y,
                                                         gpointer self)
{
#line 147 "../lib/Widgets/ViewDual.vala"
	he_view_dual_on_drag_begin ((HeViewDual*) self, _sender, start_x, start_y);
#line 1403 "ViewDual.c"
}

static void
_he_view_dual_on_drag_update_gtk_gesture_drag_drag_update (GtkGestureDrag* _sender,
                                                           gdouble offset_x,
                                                           gdouble offset_y,
                                                           gpointer self)
{
#line 148 "../lib/Widgets/ViewDual.vala"
	he_view_dual_on_drag_update ((HeViewDual*) self, _sender, offset_x, offset_y);
#line 1414 "ViewDual.c"
}

static void
_he_view_dual_on_drag_end_gtk_gesture_drag_drag_end (GtkGestureDrag* _sender,
                                                     gdouble offset_x,
                                                     gdouble offset_y,
                                                     gpointer self)
{
#line 149 "../lib/Widgets/ViewDual.vala"
	he_view_dual_on_drag_end ((HeViewDual*) self, _sender, offset_x, offset_y);
#line 1425 "ViewDual.c"
}

static GObject *
he_view_dual_constructor (GType type,
                          guint n_construct_properties,
                          GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	HeViewDual * self;
	HeBin* _tmp0_;
	GtkWidget* _tmp1_;
	GtkBox* _tmp2_;
	GtkBox* _tmp3_;
	GtkWidget* _tmp4_;
	HeBin* _tmp5_;
	GtkWidget* _tmp6_;
	GtkGestureDrag* _tmp7_;
	GtkGestureDrag* _tmp8_;
	GtkGestureDrag* _tmp9_;
	GtkGestureDrag* _tmp10_;
	GtkWidget* _tmp11_;
	GtkGestureDrag* _tmp12_;
	GtkEventController* _tmp13_;
	GtkBox* _tmp14_;
	GtkBox* _tmp15_;
	GtkWidget* _tmp16_;
	GtkBox* _tmp17_;
	GtkWidget* _tmp18_;
	GtkBox* _tmp19_;
	GtkBox* _tmp20_;
	GtkWidget* _tmp21_;
#line 133 "../lib/Widgets/ViewDual.vala"
	parent_class = G_OBJECT_CLASS (he_view_dual_parent_class);
#line 133 "../lib/Widgets/ViewDual.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 133 "../lib/Widgets/ViewDual.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_VIEW_DUAL, HeViewDual);
#line 134 "../lib/Widgets/ViewDual.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) self, 8);
#line 134 "../lib/Widgets/ViewDual.vala"
	gtk_widget_set_margin_end ((GtkWidget*) self, 8);
#line 134 "../lib/Widgets/ViewDual.vala"
	gtk_widget_set_margin_start ((GtkWidget*) self, 8);
#line 136 "../lib/Widgets/ViewDual.vala"
	_tmp0_ = he_bin_new ();
#line 136 "../lib/Widgets/ViewDual.vala"
	g_object_ref_sink (_tmp0_);
#line 136 "../lib/Widgets/ViewDual.vala"
	_g_object_unref0 (self->priv->base_bin);
#line 136 "../lib/Widgets/ViewDual.vala"
	self->priv->base_bin = (GtkWidget*) _tmp0_;
#line 137 "../lib/Widgets/ViewDual.vala"
	_tmp1_ = self->priv->base_bin;
#line 137 "../lib/Widgets/ViewDual.vala"
	gtk_widget_set_parent (_tmp1_, (GtkWidget*) self);
#line 139 "../lib/Widgets/ViewDual.vala"
	_tmp2_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 139 "../lib/Widgets/ViewDual.vala"
	g_object_ref_sink (_tmp2_);
#line 139 "../lib/Widgets/ViewDual.vala"
	_g_object_unref0 (self->priv->child_start_bin);
#line 139 "../lib/Widgets/ViewDual.vala"
	self->priv->child_start_bin = _tmp2_;
#line 140 "../lib/Widgets/ViewDual.vala"
	_tmp3_ = self->priv->child_start_bin;
#line 140 "../lib/Widgets/ViewDual.vala"
	_tmp4_ = self->priv->base_bin;
#line 140 "../lib/Widgets/ViewDual.vala"
	gtk_widget_set_parent ((GtkWidget*) _tmp3_, _tmp4_);
#line 142 "../lib/Widgets/ViewDual.vala"
	_tmp5_ = he_bin_new ();
#line 142 "../lib/Widgets/ViewDual.vala"
	g_object_ref_sink (_tmp5_);
#line 142 "../lib/Widgets/ViewDual.vala"
	_g_object_unref0 (self->priv->handle);
#line 142 "../lib/Widgets/ViewDual.vala"
	self->priv->handle = (GtkWidget*) _tmp5_;
#line 143 "../lib/Widgets/ViewDual.vala"
	_tmp6_ = self->priv->handle;
#line 143 "../lib/Widgets/ViewDual.vala"
	gtk_widget_add_css_class (_tmp6_, "circle-radius");
#line 144 "../lib/Widgets/ViewDual.vala"
	he_view_dual_update_handle_look (self);
#line 146 "../lib/Widgets/ViewDual.vala"
	_tmp7_ = (GtkGestureDrag*) gtk_gesture_drag_new ();
#line 146 "../lib/Widgets/ViewDual.vala"
	_g_object_unref0 (self->priv->drag_gesture);
#line 146 "../lib/Widgets/ViewDual.vala"
	self->priv->drag_gesture = _tmp7_;
#line 147 "../lib/Widgets/ViewDual.vala"
	_tmp8_ = self->priv->drag_gesture;
#line 147 "../lib/Widgets/ViewDual.vala"
	g_signal_connect_object (_tmp8_, "drag-begin", (GCallback) _he_view_dual_on_drag_begin_gtk_gesture_drag_drag_begin, self, 0);
#line 148 "../lib/Widgets/ViewDual.vala"
	_tmp9_ = self->priv->drag_gesture;
#line 148 "../lib/Widgets/ViewDual.vala"
	g_signal_connect_object (_tmp9_, "drag-update", (GCallback) _he_view_dual_on_drag_update_gtk_gesture_drag_drag_update, self, 0);
#line 149 "../lib/Widgets/ViewDual.vala"
	_tmp10_ = self->priv->drag_gesture;
#line 149 "../lib/Widgets/ViewDual.vala"
	g_signal_connect_object (_tmp10_, "drag-end", (GCallback) _he_view_dual_on_drag_end_gtk_gesture_drag_drag_end, self, 0);
#line 150 "../lib/Widgets/ViewDual.vala"
	_tmp11_ = self->priv->handle;
#line 150 "../lib/Widgets/ViewDual.vala"
	_tmp12_ = self->priv->drag_gesture;
#line 150 "../lib/Widgets/ViewDual.vala"
	_tmp13_ = _g_object_ref0 ((GtkEventController*) _tmp12_);
#line 150 "../lib/Widgets/ViewDual.vala"
	gtk_widget_add_controller (_tmp11_, _tmp13_);
#line 152 "../lib/Widgets/ViewDual.vala"
	_tmp14_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 152 "../lib/Widgets/ViewDual.vala"
	g_object_ref_sink (_tmp14_);
#line 152 "../lib/Widgets/ViewDual.vala"
	_g_object_unref0 (self->priv->handle_bin);
#line 152 "../lib/Widgets/ViewDual.vala"
	self->priv->handle_bin = _tmp14_;
#line 153 "../lib/Widgets/ViewDual.vala"
	_tmp15_ = self->priv->handle_bin;
#line 153 "../lib/Widgets/ViewDual.vala"
	_tmp16_ = self->priv->base_bin;
#line 153 "../lib/Widgets/ViewDual.vala"
	gtk_widget_set_parent ((GtkWidget*) _tmp15_, _tmp16_);
#line 154 "../lib/Widgets/ViewDual.vala"
	_tmp17_ = self->priv->handle_bin;
#line 154 "../lib/Widgets/ViewDual.vala"
	_tmp18_ = self->priv->handle;
#line 154 "../lib/Widgets/ViewDual.vala"
	gtk_box_append (_tmp17_, _tmp18_);
#line 156 "../lib/Widgets/ViewDual.vala"
	_tmp19_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 156 "../lib/Widgets/ViewDual.vala"
	g_object_ref_sink (_tmp19_);
#line 156 "../lib/Widgets/ViewDual.vala"
	_g_object_unref0 (self->priv->child_end_bin);
#line 156 "../lib/Widgets/ViewDual.vala"
	self->priv->child_end_bin = _tmp19_;
#line 157 "../lib/Widgets/ViewDual.vala"
	_tmp20_ = self->priv->child_end_bin;
#line 157 "../lib/Widgets/ViewDual.vala"
	_tmp21_ = self->priv->base_bin;
#line 157 "../lib/Widgets/ViewDual.vala"
	gtk_widget_set_parent ((GtkWidget*) _tmp20_, _tmp21_);
#line 133 "../lib/Widgets/ViewDual.vala"
	return obj;
#line 1572 "ViewDual.c"
}

static void
he_view_dual_class_init (HeViewDualClass * klass,
                         gpointer klass_data)
{
#line 23 "../lib/Widgets/ViewDual.vala"
	he_view_dual_parent_class = g_type_class_peek_parent (klass);
#line 23 "../lib/Widgets/ViewDual.vala"
	g_type_class_adjust_private_offset (klass, &HeViewDual_private_offset);
#line 23 "../lib/Widgets/ViewDual.vala"
	((GObjectClass *) klass)->dispose = (void (*) (GObject*)) he_view_dual_real_dispose;
#line 23 "../lib/Widgets/ViewDual.vala"
	((GtkWidgetClass *) klass)->contains = (gboolean (*) (GtkWidget*, gdouble, gdouble)) he_view_dual_real_contains;
#line 23 "../lib/Widgets/ViewDual.vala"
	((GtkWidgetClass *) klass)->measure = (void (*) (GtkWidget*, GtkOrientation, gint, gint*, gint*, gint*, gint*)) he_view_dual_real_measure;
#line 23 "../lib/Widgets/ViewDual.vala"
	((GtkWidgetClass *) klass)->size_allocate = (void (*) (GtkWidget*, gint, gint, gint)) he_view_dual_real_size_allocate;
#line 23 "../lib/Widgets/ViewDual.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_he_view_dual_get_property;
#line 23 "../lib/Widgets/ViewDual.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_he_view_dual_set_property;
#line 23 "../lib/Widgets/ViewDual.vala"
	G_OBJECT_CLASS (klass)->constructor = he_view_dual_constructor;
#line 23 "../lib/Widgets/ViewDual.vala"
	G_OBJECT_CLASS (klass)->finalize = he_view_dual_finalize;
#line 23 "../lib/Widgets/ViewDual.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_VIEW_DUAL_ORIENTATION_PROPERTY, he_view_dual_properties[HE_VIEW_DUAL_ORIENTATION_PROPERTY] = g_param_spec_enum ("orientation", "orientation", "orientation", gtk_orientation_get_type (), 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "../lib/Widgets/ViewDual.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_VIEW_DUAL_SHOW_HANDLE_PROPERTY, he_view_dual_properties[HE_VIEW_DUAL_SHOW_HANDLE_PROPERTY] = g_param_spec_boolean ("show-handle", "show-handle", "show-handle", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "../lib/Widgets/ViewDual.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_VIEW_DUAL_CHILD_START_PROPERTY, he_view_dual_properties[HE_VIEW_DUAL_CHILD_START_PROPERTY] = g_param_spec_object ("child-start", "child-start", "child-start", gtk_widget_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "../lib/Widgets/ViewDual.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_VIEW_DUAL_CHILD_END_PROPERTY, he_view_dual_properties[HE_VIEW_DUAL_CHILD_END_PROPERTY] = g_param_spec_object ("child-end", "child-end", "child-end", gtk_widget_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1607 "ViewDual.c"
}

static void
he_view_dual_gtk_buildable_interface_init (GtkBuildableIface * iface,
                                           gpointer iface_data)
{
#line 23 "../lib/Widgets/ViewDual.vala"
	he_view_dual_gtk_buildable_parent_iface = g_type_interface_peek_parent (iface);
#line 23 "../lib/Widgets/ViewDual.vala"
	iface->add_child = (void (*) (GtkBuildable*, GtkBuilder*, GObject*, const gchar*)) he_view_dual_real_add_child;
#line 1618 "ViewDual.c"
}

static void
he_view_dual_instance_init (HeViewDual * self,
                            gpointer klass)
{
	gdouble* _tmp0_;
#line 23 "../lib/Widgets/ViewDual.vala"
	self->priv = he_view_dual_get_instance_private (self);
#line 34 "../lib/Widgets/ViewDual.vala"
	self->priv->dragging = FALSE;
#line 35 "../lib/Widgets/ViewDual.vala"
	self->priv->initial_xy = (gdouble) 0;
#line 36 "../lib/Widgets/ViewDual.vala"
	self->priv->initial_pos = (gdouble) 0;
#line 37 "../lib/Widgets/ViewDual.vala"
	self->priv->target_pos = (gdouble) 0;
#line 38 "../lib/Widgets/ViewDual.vala"
	self->priv->update_interval = 16;
#line 39 "../lib/Widgets/ViewDual.vala"
	_tmp0_ = g_new0 (gdouble, 3);
#line 39 "../lib/Widgets/ViewDual.vala"
	_tmp0_[0] = 0.66;
#line 39 "../lib/Widgets/ViewDual.vala"
	_tmp0_[1] = 1.0;
#line 39 "../lib/Widgets/ViewDual.vala"
	_tmp0_[2] = 1.44;
#line 39 "../lib/Widgets/ViewDual.vala"
	self->priv->snap_values = _tmp0_;
#line 39 "../lib/Widgets/ViewDual.vala"
	self->priv->snap_values_length1 = 3;
#line 39 "../lib/Widgets/ViewDual.vala"
	self->priv->_snap_values_size_ = self->priv->snap_values_length1;
#line 40 "../lib/Widgets/ViewDual.vala"
	self->priv->snap_threshold = 0.1;
#line 1654 "ViewDual.c"
}

static void
he_view_dual_finalize (GObject * obj)
{
	HeViewDual * self;
#line 23 "../lib/Widgets/ViewDual.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_VIEW_DUAL, HeViewDual);
#line 26 "../lib/Widgets/ViewDual.vala"
	_g_object_unref0 (self->priv->handle);
#line 27 "../lib/Widgets/ViewDual.vala"
	_g_object_unref0 (self->priv->drag_gesture);
#line 28 "../lib/Widgets/ViewDual.vala"
	_g_object_unref0 (self->priv->base_bin);
#line 29 "../lib/Widgets/ViewDual.vala"
	_g_object_unref0 (self->priv->child_start_bin);
#line 30 "../lib/Widgets/ViewDual.vala"
	_g_object_unref0 (self->priv->child_end_bin);
#line 31 "../lib/Widgets/ViewDual.vala"
	_g_object_unref0 (self->priv->handle_bin);
#line 32 "../lib/Widgets/ViewDual.vala"
	_g_source_unref0 (self->priv->resize_timeout);
#line 39 "../lib/Widgets/ViewDual.vala"
	self->priv->snap_values = (g_free (self->priv->snap_values), NULL);
#line 70 "../lib/Widgets/ViewDual.vala"
	_g_object_unref0 (self->priv->_child_start);
#line 87 "../lib/Widgets/ViewDual.vala"
	_g_object_unref0 (self->priv->_child_end);
#line 23 "../lib/Widgets/ViewDual.vala"
	G_OBJECT_CLASS (he_view_dual_parent_class)->finalize (obj);
#line 1685 "ViewDual.c"
}

/**
 * A ViewDual is a view that displays two views side by side.
 */
static GType
he_view_dual_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HeViewDualClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) he_view_dual_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HeViewDual), 0, (GInstanceInitFunc) he_view_dual_instance_init, NULL };
	static const GInterfaceInfo gtk_buildable_info = { (GInterfaceInitFunc) he_view_dual_gtk_buildable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType he_view_dual_type_id;
	he_view_dual_type_id = g_type_register_static (gtk_widget_get_type (), "HeViewDual", &g_define_type_info, 0);
	g_type_add_interface_static (he_view_dual_type_id, gtk_buildable_get_type (), &gtk_buildable_info);
	HeViewDual_private_offset = g_type_add_instance_private (he_view_dual_type_id, sizeof (HeViewDualPrivate));
	return he_view_dual_type_id;
}

GType
he_view_dual_get_type (void)
{
	static volatile gsize he_view_dual_type_id__once = 0;
	if (g_once_init_enter (&he_view_dual_type_id__once)) {
		GType he_view_dual_type_id;
		he_view_dual_type_id = he_view_dual_get_type_once ();
		g_once_init_leave (&he_view_dual_type_id__once, he_view_dual_type_id);
	}
	return he_view_dual_type_id__once;
}

static void
_vala_he_view_dual_get_property (GObject * object,
                                 guint property_id,
                                 GValue * value,
                                 GParamSpec * pspec)
{
	HeViewDual * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_VIEW_DUAL, HeViewDual);
#line 23 "../lib/Widgets/ViewDual.vala"
	switch (property_id) {
#line 23 "../lib/Widgets/ViewDual.vala"
		case HE_VIEW_DUAL_ORIENTATION_PROPERTY:
#line 23 "../lib/Widgets/ViewDual.vala"
		g_value_set_enum (value, he_view_dual_get_orientation (self));
#line 23 "../lib/Widgets/ViewDual.vala"
		break;
#line 23 "../lib/Widgets/ViewDual.vala"
		case HE_VIEW_DUAL_SHOW_HANDLE_PROPERTY:
#line 23 "../lib/Widgets/ViewDual.vala"
		g_value_set_boolean (value, he_view_dual_get_show_handle (self));
#line 23 "../lib/Widgets/ViewDual.vala"
		break;
#line 23 "../lib/Widgets/ViewDual.vala"
		case HE_VIEW_DUAL_CHILD_START_PROPERTY:
#line 23 "../lib/Widgets/ViewDual.vala"
		g_value_set_object (value, he_view_dual_get_child_start (self));
#line 23 "../lib/Widgets/ViewDual.vala"
		break;
#line 23 "../lib/Widgets/ViewDual.vala"
		case HE_VIEW_DUAL_CHILD_END_PROPERTY:
#line 23 "../lib/Widgets/ViewDual.vala"
		g_value_set_object (value, he_view_dual_get_child_end (self));
#line 23 "../lib/Widgets/ViewDual.vala"
		break;
#line 1749 "ViewDual.c"
		default:
#line 23 "../lib/Widgets/ViewDual.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../lib/Widgets/ViewDual.vala"
		break;
#line 1755 "ViewDual.c"
	}
}

static void
_vala_he_view_dual_set_property (GObject * object,
                                 guint property_id,
                                 const GValue * value,
                                 GParamSpec * pspec)
{
	HeViewDual * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_VIEW_DUAL, HeViewDual);
#line 23 "../lib/Widgets/ViewDual.vala"
	switch (property_id) {
#line 23 "../lib/Widgets/ViewDual.vala"
		case HE_VIEW_DUAL_ORIENTATION_PROPERTY:
#line 23 "../lib/Widgets/ViewDual.vala"
		he_view_dual_set_orientation (self, g_value_get_enum (value));
#line 23 "../lib/Widgets/ViewDual.vala"
		break;
#line 23 "../lib/Widgets/ViewDual.vala"
		case HE_VIEW_DUAL_SHOW_HANDLE_PROPERTY:
#line 23 "../lib/Widgets/ViewDual.vala"
		he_view_dual_set_show_handle (self, g_value_get_boolean (value));
#line 23 "../lib/Widgets/ViewDual.vala"
		break;
#line 23 "../lib/Widgets/ViewDual.vala"
		case HE_VIEW_DUAL_CHILD_START_PROPERTY:
#line 23 "../lib/Widgets/ViewDual.vala"
		he_view_dual_set_child_start (self, g_value_get_object (value));
#line 23 "../lib/Widgets/ViewDual.vala"
		break;
#line 23 "../lib/Widgets/ViewDual.vala"
		case HE_VIEW_DUAL_CHILD_END_PROPERTY:
#line 23 "../lib/Widgets/ViewDual.vala"
		he_view_dual_set_child_end (self, g_value_get_object (value));
#line 23 "../lib/Widgets/ViewDual.vala"
		break;
#line 1793 "ViewDual.c"
		default:
#line 23 "../lib/Widgets/ViewDual.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../lib/Widgets/ViewDual.vala"
		break;
#line 1799 "ViewDual.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

