/* TimePicker.c generated by valac 0.56.18, the Vala compiler
 * generated from TimePicker.vala, do not modify */

/*
 * Copyright (c) 2022-2024 Fyra Labs
 * Copyright (c) 2014–2021 elementary, Inc. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include "libhelium-1.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <graphene-gobject.h>
#include <cairo-gobject.h>
#include <glib/gi18n-lib.h>

#define HE_TIME_PICKER_CLOCK_WIDGET_SIZE 256.0
#define HE_TIME_PICKER_CLOCK_WIDGET_CENTER (HE_TIME_PICKER_CLOCK_WIDGET_SIZE / 2)
#define HE_TIME_PICKER_CLOCK_WIDGET_RADIUS ((HE_TIME_PICKER_CLOCK_WIDGET_SIZE / 2) - 10.0)
#define HE_TIME_PICKER_CLOCK_WIDGET_SELECTION_CIRCLE_RADIUS 24.0
#define HE_TIME_PICKER_CLOCK_WIDGET_INNER_RADIUS ((HE_TIME_PICKER_CLOCK_WIDGET_RADIUS - HE_TIME_PICKER_CLOCK_WIDGET_SELECTION_CIRCLE_RADIUS) - 30.0)
#define HE_TIME_PICKER_CLOCK_WIDGET_OUTER_RADIUS (HE_TIME_PICKER_CLOCK_WIDGET_RADIUS - HE_TIME_PICKER_CLOCK_WIDGET_SELECTION_CIRCLE_RADIUS)
#define HE_TIME_PICKER_CLOCK_WIDGET_HAND_LINE_WIDTH 2.0
#define HE_TIME_PICKER_CLOCK_WIDGET_HAND_CENTER_WIDTH 4.0
#define HE_TIME_PICKER_CLOCK_WIDGET_FONT_FAMILY "Manrope"
#define HE_TIME_PICKER_CLOCK_WIDGET_HOUR_FONT_SIZE 20
#define HE_TIME_PICKER_CLOCK_WIDGET_MINUTE_FONT_SIZE 18
#define HE_TIME_PICKER_CLOCK_WIDGET_HALF_DAY 12
#define HE_TIME_PICKER_CLOCK_WIDGET_FULL_DAY 24
#define HE_TIME_PICKER_CLOCK_WIDGET_MINUTES 60
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define HE_TIME_PICKER_TYPE_CLOCK_WIDGET (he_time_picker_clock_widget_get_type ())
#define HE_TIME_PICKER_CLOCK_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), HE_TIME_PICKER_TYPE_CLOCK_WIDGET, HeTimePickerClockWidget))
#define HE_TIME_PICKER_CLOCK_WIDGET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), HE_TIME_PICKER_TYPE_CLOCK_WIDGET, HeTimePickerClockWidgetClass))
#define HE_TIME_PICKER_IS_CLOCK_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), HE_TIME_PICKER_TYPE_CLOCK_WIDGET))
#define HE_TIME_PICKER_IS_CLOCK_WIDGET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), HE_TIME_PICKER_TYPE_CLOCK_WIDGET))
#define HE_TIME_PICKER_CLOCK_WIDGET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), HE_TIME_PICKER_TYPE_CLOCK_WIDGET, HeTimePickerClockWidgetClass))

typedef struct _HeTimePickerClockWidget HeTimePickerClockWidget;
typedef struct _HeTimePickerClockWidgetClass HeTimePickerClockWidgetClass;
enum  {
	HE_TIME_PICKER_0_PROPERTY,
	HE_TIME_PICKER_FORMAT_12_PROPERTY,
	HE_TIME_PICKER_FORMAT_24_PROPERTY,
	HE_TIME_PICKER_TIME_PROPERTY,
	HE_TIME_PICKER_NUM_PROPERTIES
};
static GParamSpec* he_time_picker_properties[HE_TIME_PICKER_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _HeTimePickerClockWidgetPrivate HeTimePickerClockWidgetPrivate;
enum  {
	HE_TIME_PICKER_CLOCK_WIDGET_0_PROPERTY,
	HE_TIME_PICKER_CLOCK_WIDGET_SELECTING_HOUR_PROPERTY,
	HE_TIME_PICKER_CLOCK_WIDGET_IS_MILITARY_MODE_PROPERTY,
	HE_TIME_PICKER_CLOCK_WIDGET_ACCENT_COLOR_PROPERTY,
	HE_TIME_PICKER_CLOCK_WIDGET_HOUR_PROPERTY,
	HE_TIME_PICKER_CLOCK_WIDGET_MINUTE_PROPERTY,
	HE_TIME_PICKER_CLOCK_WIDGET_NUM_PROPERTIES
};
static GParamSpec* he_time_picker_clock_widget_properties[HE_TIME_PICKER_CLOCK_WIDGET_NUM_PROPERTIES];
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))
typedef struct _Block14Data Block14Data;
enum  {
	HE_TIME_PICKER_CLOCK_WIDGET_TIME_SELECTED_SIGNAL,
	HE_TIME_PICKER_CLOCK_WIDGET_NUM_SIGNALS
};
static guint he_time_picker_clock_widget_signals[HE_TIME_PICKER_CLOCK_WIDGET_NUM_SIGNALS] = {0};
enum  {
	HE_TIME_PICKER_TIME_CHANGED_SIGNAL,
	HE_TIME_PICKER_NUM_SIGNALS
};
static guint he_time_picker_signals[HE_TIME_PICKER_NUM_SIGNALS] = {0};

struct _HeTimePickerPrivate {
	gchar* _format_12;
	gchar* _format_24;
	GDateTime* _time;
	gboolean changing_time;
	gchar* old_string;
	GtkBox* am_pm_box;
	GtkPopover* popover;
	GtkSpinButton* hours_spinbutton;
	GtkSpinButton* minutes_spinbutton;
	GtkToggleButton* am_togglebutton;
	GtkToggleButton* pm_togglebutton;
	HeTimePickerClockWidget* clock;
};

struct _HeTimePickerClockWidget {
	GtkWidget parent_instance;
	HeTimePickerClockWidgetPrivate * priv;
};

struct _HeTimePickerClockWidgetClass {
	GtkWidgetClass parent_class;
};

struct _HeTimePickerClockWidgetPrivate {
	gboolean _selecting_hour;
	gboolean _is_military_mode;
	gint selected_hour;
	gint selected_minute;
	gdouble last_angle;
	gboolean is_dark;
	HeDesktop* desktop;
	GdkRGBA _accent_color;
};

struct _Block14Data {
	int _ref_count_;
	HeTimePickerClockWidget* self;
	GtkGestureDrag* drag_gesture;
};

static gint HeTimePicker_private_offset;
static gpointer he_time_picker_parent_class = NULL;
static gint HeTimePickerClockWidget_private_offset;
static gpointer he_time_picker_clock_widget_parent_class = NULL;

static GType he_time_picker_clock_widget_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static void he_time_picker_update_text (HeTimePicker* self,
                                 gboolean no_signal);
static void he_time_picker_clock_widget_set_hour (HeTimePickerClockWidget* self,
                                           gint value);
static void he_time_picker_clock_widget_set_minute (HeTimePickerClockWidget* self,
                                             gint value);
static gboolean he_time_picker_is_clock_format_12h (void);
static void he_time_picker_update_am_pm (HeTimePicker* self,
                                  gint hours);
static void he_time_picker_update_time (HeTimePicker* self,
                                 gboolean is_hour);
static void he_time_picker_on_icon_press (HeTimePicker* self,
                                   GtkEntryIconPosition position);
static void he_time_picker_clock_widget_set_is_military_mode (HeTimePickerClockWidget* self,
                                                       gboolean value);
static void he_time_picker_is_unfocused (HeTimePicker* self);
static void he_time_picker_parse_time (HeTimePicker* self,
                                const gchar* timestr);
static gint* _int_dup (gint* self);
static gboolean _int_equal (const gint * s1,
                     const gint * s2);
static gboolean he_time_picker_clock_widget_get_selecting_hour (HeTimePickerClockWidget* self);
static void he_time_picker_clock_widget_set_selecting_hour (HeTimePickerClockWidget* self,
                                                     gboolean value);
static gboolean he_time_picker_clock_widget_get_is_military_mode (HeTimePickerClockWidget* self);
static void he_time_picker_clock_widget_get_accent_color (HeTimePickerClockWidget* self,
                                                   GdkRGBA * result);
static void he_time_picker_clock_widget_set_accent_color (HeTimePickerClockWidget* self,
                                                   GdkRGBA * value);
static gint he_time_picker_clock_widget_get_hour (HeTimePickerClockWidget* self);
static gint he_time_picker_clock_widget_get_minute (HeTimePickerClockWidget* self);
static void g_cclosure_user_marshal_VOID__INT_INT (GClosure * closure,
                                            GValue * return_value,
                                            guint n_param_values,
                                            const GValue * param_values,
                                            gpointer invocation_hint,
                                            gpointer marshal_data);
static HeTimePickerClockWidget* he_time_picker_clock_widget_new (void);
static HeTimePickerClockWidget* he_time_picker_clock_widget_construct (GType object_type);
static void he_time_picker_clock_widget_update_style_manager (HeTimePickerClockWidget* self);
static void _he_time_picker_clock_widget_update_style_manager_g_object_notify (GObject* _sender,
                                                                        GParamSpec* pspec,
                                                                        gpointer self);
static void he_time_picker_clock_widget_real_dispose (GObject* base);
static void he_time_picker_clock_widget_reset_to_hour_selection (HeTimePickerClockWidget* self);
static void he_time_picker_clock_widget_real_snapshot (GtkWidget* base,
                                                GtkSnapshot* snapshot);
static gdouble he_time_picker_clock_widget_get_hour_angle (HeTimePickerClockWidget* self);
static gdouble he_time_picker_clock_widget_get_minute_angle (HeTimePickerClockWidget* self);
static gdouble he_time_picker_clock_widget_get_hand_radius (HeTimePickerClockWidget* self,
                                                     gdouble base_radius);
static void he_time_picker_clock_widget_emit_time_selected (HeTimePickerClockWidget* self);
static void he_time_picker_clock_widget_update_selection (HeTimePickerClockWidget* self,
                                                   gdouble x,
                                                   gdouble y);
static gdouble he_time_picker_clock_widget_get_angle_from_coords (HeTimePickerClockWidget* self,
                                                           gdouble x,
                                                           gdouble y);
static GObject * he_time_picker_clock_widget_constructor (GType type,
                                                   guint n_construct_properties,
                                                   GObjectConstructParam * construct_properties);
static Block14Data* block14_data_ref (Block14Data* _data14_);
static void block14_data_unref (void * _userdata_);
static void _he_time_picker_clock_widget___lambda176_ (HeTimePickerClockWidget* self,
                                                gint n_press,
                                                gdouble x,
                                                gdouble y);
static void __he_time_picker_clock_widget___lambda176__gtk_gesture_click_pressed (GtkGestureClick* _sender,
                                                                           gint n_press,
                                                                           gdouble x,
                                                                           gdouble y,
                                                                           gpointer self);
static void _he_time_picker_clock_widget___lambda177_ (HeTimePickerClockWidget* self);
static void __he_time_picker_clock_widget___lambda177__gtk_gesture_click_released (GtkGestureClick* _sender,
                                                                            gint n_press,
                                                                            gdouble x,
                                                                            gdouble y,
                                                                            gpointer self);
static void _he_time_picker_clock_widget___lambda178_ (Block14Data* _data14_,
                                                gdouble offset_x,
                                                gdouble offset_y);
static void __he_time_picker_clock_widget___lambda178__gtk_gesture_drag_drag_update (GtkGestureDrag* _sender,
                                                                              gdouble offset_x,
                                                                              gdouble offset_y,
                                                                              gpointer self);
static void he_time_picker_clock_widget_finalize (GObject * obj);
static GType he_time_picker_clock_widget_get_type_once (void);
static void _vala_he_time_picker_clock_widget_get_property (GObject * object,
                                                     guint property_id,
                                                     GValue * value,
                                                     GParamSpec * pspec);
static void _vala_he_time_picker_clock_widget_set_property (GObject * object,
                                                     guint property_id,
                                                     const GValue * value,
                                                     GParamSpec * pspec);
static GObject * he_time_picker_constructor (GType type,
                                      guint n_construct_properties,
                                      GObjectConstructParam * construct_properties);
static void _he_time_picker_on_icon_press_gtk_entry_icon_release (GtkEntry* _sender,
                                                           GtkEntryIconPosition icon_pos,
                                                           gpointer self);
static void _he_time_picker___lambda179_ (HeTimePicker* self);
static void __he_time_picker___lambda179__gtk_spin_button_value_changed (GtkSpinButton* _sender,
                                                                  gpointer self);
static void _he_time_picker___lambda180_ (HeTimePicker* self);
static void __he_time_picker___lambda180__gtk_spin_button_value_changed (GtkSpinButton* _sender,
                                                                  gpointer self);
static gboolean _he_time_picker___lambda181_ (HeTimePicker* self);
static gboolean __he_time_picker___lambda181__gtk_spin_button_output (GtkSpinButton* _sender,
                                                               gpointer self);
static void _he_time_picker___lambda182_ (HeTimePicker* self,
                                   gint hour,
                                   gint minute);
static void __he_time_picker___lambda182__he_time_picker_clock_widget_time_selected (HeTimePickerClockWidget* _sender,
                                                                              gint hour,
                                                                              gint minute,
                                                                              gpointer self);
static void _he_time_picker___lambda183_ (HeTimePicker* self);
static void __he_time_picker___lambda183__gtk_event_controller_focus_leave (GtkEventControllerFocus* _sender,
                                                                     gpointer self);
static gboolean _he_time_picker___lambda184_ (HeTimePicker* self,
                                       gdouble dx,
                                       gdouble dy);
static gboolean __he_time_picker___lambda184__gtk_event_controller_scroll_scroll (GtkEventControllerScroll* _sender,
                                                                           gdouble dx,
                                                                           gdouble dy,
                                                                           gpointer self);
static void _he_time_picker_is_unfocused_gtk_entry_activate (GtkEntry* _sender,
                                                      gpointer self);
static void _he_time_picker___lambda185_ (HeTimePicker* self);
static void __he_time_picker___lambda185__gtk_button_clicked (GtkButton* _sender,
                                                       gpointer self);
static void _he_time_picker___lambda186_ (HeTimePicker* self);
static void __he_time_picker___lambda186__gtk_button_clicked (GtkButton* _sender,
                                                       gpointer self);
static void he_time_picker_finalize (GObject * obj);
static GType he_time_picker_get_type_once (void);
static void _vala_he_time_picker_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec);
static void _vala_he_time_picker_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
he_time_picker_get_instance_private (HeTimePicker* self)
{
	return G_STRUCT_MEMBER_P (self, HeTimePicker_private_offset);
}

const gchar*
he_time_picker_get_format_12 (HeTimePicker* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 28 "../lib/Widgets/TimePicker.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 28 "../lib/Widgets/TimePicker.vala"
	_tmp0_ = self->priv->_format_12;
#line 28 "../lib/Widgets/TimePicker.vala"
	result = _tmp0_;
#line 28 "../lib/Widgets/TimePicker.vala"
	return result;
#line 319 "TimePicker.c"
}

static void
he_time_picker_set_format_12 (HeTimePicker* self,
                              const gchar* value)
{
	gchar* old_value;
#line 28 "../lib/Widgets/TimePicker.vala"
	g_return_if_fail (self != NULL);
#line 28 "../lib/Widgets/TimePicker.vala"
	old_value = he_time_picker_get_format_12 (self);
#line 28 "../lib/Widgets/TimePicker.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 333 "TimePicker.c"
		gchar* _tmp0_;
#line 28 "../lib/Widgets/TimePicker.vala"
		_tmp0_ = g_strdup (value);
#line 28 "../lib/Widgets/TimePicker.vala"
		_g_free0 (self->priv->_format_12);
#line 28 "../lib/Widgets/TimePicker.vala"
		self->priv->_format_12 = _tmp0_;
#line 28 "../lib/Widgets/TimePicker.vala"
		g_object_notify_by_pspec ((GObject *) self, he_time_picker_properties[HE_TIME_PICKER_FORMAT_12_PROPERTY]);
#line 343 "TimePicker.c"
	}
}

const gchar*
he_time_picker_get_format_24 (HeTimePicker* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 33 "../lib/Widgets/TimePicker.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 33 "../lib/Widgets/TimePicker.vala"
	_tmp0_ = self->priv->_format_24;
#line 33 "../lib/Widgets/TimePicker.vala"
	result = _tmp0_;
#line 33 "../lib/Widgets/TimePicker.vala"
	return result;
#line 360 "TimePicker.c"
}

static void
he_time_picker_set_format_24 (HeTimePicker* self,
                              const gchar* value)
{
	gchar* old_value;
#line 33 "../lib/Widgets/TimePicker.vala"
	g_return_if_fail (self != NULL);
#line 33 "../lib/Widgets/TimePicker.vala"
	old_value = he_time_picker_get_format_24 (self);
#line 33 "../lib/Widgets/TimePicker.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 374 "TimePicker.c"
		gchar* _tmp0_;
#line 33 "../lib/Widgets/TimePicker.vala"
		_tmp0_ = g_strdup (value);
#line 33 "../lib/Widgets/TimePicker.vala"
		_g_free0 (self->priv->_format_24);
#line 33 "../lib/Widgets/TimePicker.vala"
		self->priv->_format_24 = _tmp0_;
#line 33 "../lib/Widgets/TimePicker.vala"
		g_object_notify_by_pspec ((GObject *) self, he_time_picker_properties[HE_TIME_PICKER_FORMAT_24_PROPERTY]);
#line 384 "TimePicker.c"
	}
}

GDateTime*
he_time_picker_get_time (HeTimePicker* self)
{
	GDateTime* result;
	GDateTime* _tmp0_;
	GDateTime* _tmp3_;
#line 37 "../lib/Widgets/TimePicker.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 38 "../lib/Widgets/TimePicker.vala"
	_tmp0_ = self->priv->_time;
#line 38 "../lib/Widgets/TimePicker.vala"
	if (_tmp0_ == NULL) {
#line 400 "TimePicker.c"
		GDateTime* _tmp1_;
		GDateTime* _tmp2_;
#line 39 "../lib/Widgets/TimePicker.vala"
		_tmp1_ = g_date_time_new_now_local ();
#line 39 "../lib/Widgets/TimePicker.vala"
		_tmp2_ = _tmp1_;
#line 39 "../lib/Widgets/TimePicker.vala"
		he_time_picker_set_time (self, _tmp2_);
#line 39 "../lib/Widgets/TimePicker.vala"
		_g_date_time_unref0 (_tmp2_);
#line 411 "TimePicker.c"
	}
#line 42 "../lib/Widgets/TimePicker.vala"
	_tmp3_ = self->priv->_time;
#line 42 "../lib/Widgets/TimePicker.vala"
	result = _tmp3_;
#line 42 "../lib/Widgets/TimePicker.vala"
	return result;
#line 419 "TimePicker.c"
}

static gpointer
_g_date_time_ref0 (gpointer self)
{
#line 46 "../lib/Widgets/TimePicker.vala"
	return self ? g_date_time_ref (self) : NULL;
#line 427 "TimePicker.c"
}

void
he_time_picker_set_time (HeTimePicker* self,
                         GDateTime* value)
{
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	HeTimePickerClockWidget* _tmp4_;
	GDateTime* _tmp5_;
	HeTimePickerClockWidget* _tmp6_;
	GDateTime* _tmp7_;
#line 45 "../lib/Widgets/TimePicker.vala"
	g_return_if_fail (self != NULL);
#line 46 "../lib/Widgets/TimePicker.vala"
	_tmp0_ = _g_date_time_ref0 (value);
#line 46 "../lib/Widgets/TimePicker.vala"
	_g_date_time_unref0 (self->priv->_time);
#line 46 "../lib/Widgets/TimePicker.vala"
	self->priv->_time = _tmp0_;
#line 47 "../lib/Widgets/TimePicker.vala"
	self->priv->changing_time = TRUE;
#line 49 "../lib/Widgets/TimePicker.vala"
	_tmp1_ = self->priv->_time;
#line 49 "../lib/Widgets/TimePicker.vala"
	if (g_date_time_get_hour (_tmp1_) >= 12) {
#line 454 "TimePicker.c"
		GtkToggleButton* _tmp2_;
#line 50 "../lib/Widgets/TimePicker.vala"
		_tmp2_ = self->priv->pm_togglebutton;
#line 50 "../lib/Widgets/TimePicker.vala"
		gtk_toggle_button_set_active (_tmp2_, TRUE);
#line 460 "TimePicker.c"
	} else {
		GtkToggleButton* _tmp3_;
#line 52 "../lib/Widgets/TimePicker.vala"
		_tmp3_ = self->priv->am_togglebutton;
#line 52 "../lib/Widgets/TimePicker.vala"
		gtk_toggle_button_set_active (_tmp3_, TRUE);
#line 467 "TimePicker.c"
	}
#line 55 "../lib/Widgets/TimePicker.vala"
	he_time_picker_update_text (self, TRUE);
#line 56 "../lib/Widgets/TimePicker.vala"
	_tmp4_ = self->priv->clock;
#line 56 "../lib/Widgets/TimePicker.vala"
	_tmp5_ = self->priv->_time;
#line 56 "../lib/Widgets/TimePicker.vala"
	he_time_picker_clock_widget_set_hour (_tmp4_, g_date_time_get_hour (_tmp5_));
#line 57 "../lib/Widgets/TimePicker.vala"
	_tmp6_ = self->priv->clock;
#line 57 "../lib/Widgets/TimePicker.vala"
	_tmp7_ = self->priv->_time;
#line 57 "../lib/Widgets/TimePicker.vala"
	he_time_picker_clock_widget_set_minute (_tmp6_, g_date_time_get_minute (_tmp7_));
#line 58 "../lib/Widgets/TimePicker.vala"
	self->priv->changing_time = FALSE;
#line 45 "../lib/Widgets/TimePicker.vala"
	g_object_notify_by_pspec ((GObject *) self, he_time_picker_properties[HE_TIME_PICKER_TIME_PROPERTY]);
#line 487 "TimePicker.c"
}

/**
     * Creates a new TimePicker widget with the given format strings.
     *
     * @param format_12 The string format of how to display the time when in 12h mode.
     * @param format_24 The string format of how to display the time when in 24h mode.
     */
HeTimePicker*
he_time_picker_construct_with_format (GType object_type,
                                      const gchar* format_12,
                                      const gchar* format_24)
{
	HeTimePicker * self = NULL;
#line 78 "../lib/Widgets/TimePicker.vala"
	g_return_val_if_fail (format_12 != NULL, NULL);
#line 78 "../lib/Widgets/TimePicker.vala"
	g_return_val_if_fail (format_24 != NULL, NULL);
#line 79 "../lib/Widgets/TimePicker.vala"
	self = (HeTimePicker*) g_object_new (object_type, "format-12", format_12, "format-24", format_24, NULL);
#line 78 "../lib/Widgets/TimePicker.vala"
	return self;
#line 510 "TimePicker.c"
}

HeTimePicker*
he_time_picker_new_with_format (const gchar* format_12,
                                const gchar* format_24)
{
#line 78 "../lib/Widgets/TimePicker.vala"
	return he_time_picker_construct_with_format (HE_TYPE_TIME_PICKER, format_12, format_24);
#line 519 "TimePicker.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1585 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1585 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1585 "glib-2.0.vapi"
	return result;
#line 538 "TimePicker.c"
}

static gboolean
he_time_picker_is_clock_format_12h (void)
{
	gchar* format = NULL;
	GSettings* h24_settings = NULL;
	GSettings* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gboolean result;
#line 228 "../lib/Widgets/TimePicker.vala"
	format = NULL;
#line 229 "../lib/Widgets/TimePicker.vala"
	_tmp0_ = g_settings_new ("org.gnome.desktop.interface");
#line 229 "../lib/Widgets/TimePicker.vala"
	h24_settings = _tmp0_;
#line 230 "../lib/Widgets/TimePicker.vala"
	_tmp1_ = g_settings_get_string (h24_settings, "clock-format");
#line 230 "../lib/Widgets/TimePicker.vala"
	_g_free0 (format);
#line 230 "../lib/Widgets/TimePicker.vala"
	format = _tmp1_;
#line 231 "../lib/Widgets/TimePicker.vala"
	_tmp2_ = format;
#line 231 "../lib/Widgets/TimePicker.vala"
	result = string_contains (_tmp2_, "12h");
#line 231 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (h24_settings);
#line 231 "../lib/Widgets/TimePicker.vala"
	_g_free0 (format);
#line 231 "../lib/Widgets/TimePicker.vala"
	return result;
#line 572 "TimePicker.c"
}

static void
he_time_picker_update_am_pm (HeTimePicker* self,
                             gint hours)
{
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
#line 234 "../lib/Widgets/TimePicker.vala"
	g_return_if_fail (self != NULL);
#line 235 "../lib/Widgets/TimePicker.vala"
	if (self->priv->changing_time) {
#line 236 "../lib/Widgets/TimePicker.vala"
		return;
#line 588 "TimePicker.c"
	}
#line 239 "../lib/Widgets/TimePicker.vala"
	_tmp0_ = self->priv->_time;
#line 239 "../lib/Widgets/TimePicker.vala"
	_tmp1_ = g_date_time_add_hours (_tmp0_, hours);
#line 239 "../lib/Widgets/TimePicker.vala"
	_tmp2_ = _tmp1_;
#line 239 "../lib/Widgets/TimePicker.vala"
	he_time_picker_set_time (self, _tmp2_);
#line 239 "../lib/Widgets/TimePicker.vala"
	_g_date_time_unref0 (_tmp2_);
#line 240 "../lib/Widgets/TimePicker.vala"
	g_signal_emit (self, he_time_picker_signals[HE_TIME_PICKER_TIME_CHANGED_SIGNAL], 0);
#line 242 "../lib/Widgets/TimePicker.vala"
	he_time_picker_update_text (self, TRUE);
#line 604 "TimePicker.c"
}

static void
he_time_picker_update_time (HeTimePicker* self,
                            gboolean is_hour)
{
#line 245 "../lib/Widgets/TimePicker.vala"
	g_return_if_fail (self != NULL);
#line 246 "../lib/Widgets/TimePicker.vala"
	if (self->priv->changing_time) {
#line 247 "../lib/Widgets/TimePicker.vala"
		return;
#line 617 "TimePicker.c"
	}
#line 250 "../lib/Widgets/TimePicker.vala"
	if (is_hour) {
#line 621 "TimePicker.c"
		gint new_hour = 0;
		GtkSpinButton* _tmp0_;
		GDateTime* _tmp1_;
		GDateTime* _tmp2_;
#line 251 "../lib/Widgets/TimePicker.vala"
		_tmp0_ = self->priv->hours_spinbutton;
#line 251 "../lib/Widgets/TimePicker.vala"
		_tmp1_ = he_time_picker_get_time (self);
#line 251 "../lib/Widgets/TimePicker.vala"
		_tmp2_ = _tmp1_;
#line 251 "../lib/Widgets/TimePicker.vala"
		new_hour = gtk_spin_button_get_value_as_int (_tmp0_) - g_date_time_get_hour (_tmp2_);
#line 253 "../lib/Widgets/TimePicker.vala"
		if (he_time_picker_is_clock_format_12h ()) {
#line 636 "TimePicker.c"
			gboolean _tmp3_ = FALSE;
			GtkSpinButton* _tmp4_;
#line 254 "../lib/Widgets/TimePicker.vala"
			_tmp4_ = self->priv->hours_spinbutton;
#line 254 "../lib/Widgets/TimePicker.vala"
			if (gtk_spin_button_get_value_as_int (_tmp4_) == 12) {
#line 643 "TimePicker.c"
				GtkToggleButton* _tmp5_;
				gboolean _tmp6_;
				gboolean _tmp7_;
#line 254 "../lib/Widgets/TimePicker.vala"
				_tmp5_ = self->priv->am_togglebutton;
#line 254 "../lib/Widgets/TimePicker.vala"
				_tmp6_ = gtk_toggle_button_get_active (_tmp5_);
#line 254 "../lib/Widgets/TimePicker.vala"
				_tmp7_ = _tmp6_;
#line 254 "../lib/Widgets/TimePicker.vala"
				_tmp3_ = _tmp7_;
#line 655 "TimePicker.c"
			} else {
#line 254 "../lib/Widgets/TimePicker.vala"
				_tmp3_ = FALSE;
#line 659 "TimePicker.c"
			}
#line 254 "../lib/Widgets/TimePicker.vala"
			_tmp3_ = TRUE;
#line 254 "../lib/Widgets/TimePicker.vala"
			if (_tmp3_) {
#line 665 "TimePicker.c"
				GDateTime* _tmp8_;
				GDateTime* _tmp9_;
				GDateTime* _tmp10_;
#line 255 "../lib/Widgets/TimePicker.vala"
				_tmp8_ = self->priv->_time;
#line 255 "../lib/Widgets/TimePicker.vala"
				_tmp9_ = self->priv->_time;
#line 255 "../lib/Widgets/TimePicker.vala"
				_tmp10_ = g_date_time_add_hours (_tmp8_, -g_date_time_get_hour (_tmp9_));
#line 255 "../lib/Widgets/TimePicker.vala"
				_g_date_time_unref0 (self->priv->_time);
#line 255 "../lib/Widgets/TimePicker.vala"
				self->priv->_time = _tmp10_;
#line 679 "TimePicker.c"
			} else {
				gboolean _tmp11_ = FALSE;
				GtkSpinButton* _tmp12_;
#line 256 "../lib/Widgets/TimePicker.vala"
				_tmp12_ = self->priv->hours_spinbutton;
#line 256 "../lib/Widgets/TimePicker.vala"
				if (gtk_spin_button_get_value_as_int (_tmp12_) < 12) {
#line 687 "TimePicker.c"
					GtkToggleButton* _tmp13_;
					gboolean _tmp14_;
					gboolean _tmp15_;
#line 256 "../lib/Widgets/TimePicker.vala"
					_tmp13_ = self->priv->am_togglebutton;
#line 256 "../lib/Widgets/TimePicker.vala"
					_tmp14_ = gtk_toggle_button_get_active (_tmp13_);
#line 256 "../lib/Widgets/TimePicker.vala"
					_tmp15_ = _tmp14_;
#line 256 "../lib/Widgets/TimePicker.vala"
					_tmp11_ = _tmp15_;
#line 699 "TimePicker.c"
				} else {
#line 256 "../lib/Widgets/TimePicker.vala"
					_tmp11_ = FALSE;
#line 703 "TimePicker.c"
				}
#line 256 "../lib/Widgets/TimePicker.vala"
				_tmp11_ = TRUE;
#line 256 "../lib/Widgets/TimePicker.vala"
				if (_tmp11_) {
#line 709 "TimePicker.c"
					GDateTime* _tmp16_;
					GDateTime* _tmp17_;
#line 257 "../lib/Widgets/TimePicker.vala"
					_tmp16_ = self->priv->_time;
#line 257 "../lib/Widgets/TimePicker.vala"
					_tmp17_ = g_date_time_add_hours (_tmp16_, new_hour);
#line 257 "../lib/Widgets/TimePicker.vala"
					_g_date_time_unref0 (self->priv->_time);
#line 257 "../lib/Widgets/TimePicker.vala"
					self->priv->_time = _tmp17_;
#line 720 "TimePicker.c"
				} else {
					gboolean _tmp18_ = FALSE;
					GtkSpinButton* _tmp19_;
#line 258 "../lib/Widgets/TimePicker.vala"
					_tmp19_ = self->priv->hours_spinbutton;
#line 258 "../lib/Widgets/TimePicker.vala"
					if (gtk_spin_button_get_value_as_int (_tmp19_) == 12) {
#line 728 "TimePicker.c"
						GtkToggleButton* _tmp20_;
						gboolean _tmp21_;
						gboolean _tmp22_;
#line 258 "../lib/Widgets/TimePicker.vala"
						_tmp20_ = self->priv->pm_togglebutton;
#line 258 "../lib/Widgets/TimePicker.vala"
						_tmp21_ = gtk_toggle_button_get_active (_tmp20_);
#line 258 "../lib/Widgets/TimePicker.vala"
						_tmp22_ = _tmp21_;
#line 258 "../lib/Widgets/TimePicker.vala"
						_tmp18_ = _tmp22_;
#line 740 "TimePicker.c"
					} else {
#line 258 "../lib/Widgets/TimePicker.vala"
						_tmp18_ = FALSE;
#line 744 "TimePicker.c"
					}
#line 258 "../lib/Widgets/TimePicker.vala"
					_tmp18_ = TRUE;
#line 258 "../lib/Widgets/TimePicker.vala"
					if (_tmp18_) {
#line 750 "TimePicker.c"
						GDateTime* _tmp23_;
						GDateTime* _tmp24_;
						GDateTime* _tmp25_;
#line 259 "../lib/Widgets/TimePicker.vala"
						_tmp23_ = self->priv->_time;
#line 259 "../lib/Widgets/TimePicker.vala"
						_tmp24_ = self->priv->_time;
#line 259 "../lib/Widgets/TimePicker.vala"
						_tmp25_ = g_date_time_add_hours (_tmp23_, (-g_date_time_get_hour (_tmp24_)) + 12);
#line 259 "../lib/Widgets/TimePicker.vala"
						_g_date_time_unref0 (self->priv->_time);
#line 259 "../lib/Widgets/TimePicker.vala"
						self->priv->_time = _tmp25_;
#line 764 "TimePicker.c"
					} else {
						gboolean _tmp26_ = FALSE;
						GtkSpinButton* _tmp27_;
#line 260 "../lib/Widgets/TimePicker.vala"
						_tmp27_ = self->priv->hours_spinbutton;
#line 260 "../lib/Widgets/TimePicker.vala"
						if (gtk_spin_button_get_value_as_int (_tmp27_) < 12) {
#line 772 "TimePicker.c"
							GtkToggleButton* _tmp28_;
							gboolean _tmp29_;
							gboolean _tmp30_;
#line 260 "../lib/Widgets/TimePicker.vala"
							_tmp28_ = self->priv->pm_togglebutton;
#line 260 "../lib/Widgets/TimePicker.vala"
							_tmp29_ = gtk_toggle_button_get_active (_tmp28_);
#line 260 "../lib/Widgets/TimePicker.vala"
							_tmp30_ = _tmp29_;
#line 260 "../lib/Widgets/TimePicker.vala"
							_tmp26_ = _tmp30_;
#line 784 "TimePicker.c"
						} else {
#line 260 "../lib/Widgets/TimePicker.vala"
							_tmp26_ = FALSE;
#line 788 "TimePicker.c"
						}
#line 260 "../lib/Widgets/TimePicker.vala"
						_tmp26_ = TRUE;
#line 260 "../lib/Widgets/TimePicker.vala"
						if (_tmp26_) {
#line 794 "TimePicker.c"
							GDateTime* _tmp31_;
							GDateTime* _tmp32_;
							GDateTime* _tmp33_;
							GDateTime* _tmp34_;
#line 261 "../lib/Widgets/TimePicker.vala"
							_tmp31_ = self->priv->_time;
#line 261 "../lib/Widgets/TimePicker.vala"
							_tmp32_ = g_date_time_add_hours (_tmp31_, new_hour + 12);
#line 261 "../lib/Widgets/TimePicker.vala"
							_g_date_time_unref0 (self->priv->_time);
#line 261 "../lib/Widgets/TimePicker.vala"
							self->priv->_time = _tmp32_;
#line 263 "../lib/Widgets/TimePicker.vala"
							_tmp33_ = he_time_picker_get_time (self);
#line 263 "../lib/Widgets/TimePicker.vala"
							_tmp34_ = _tmp33_;
#line 263 "../lib/Widgets/TimePicker.vala"
							if (g_date_time_get_hour (_tmp34_) <= 12) {
#line 813 "TimePicker.c"
								GDateTime* _tmp35_;
								GDateTime* _tmp36_;
#line 264 "../lib/Widgets/TimePicker.vala"
								_tmp35_ = self->priv->_time;
#line 264 "../lib/Widgets/TimePicker.vala"
								_tmp36_ = g_date_time_add_hours (_tmp35_, 12);
#line 264 "../lib/Widgets/TimePicker.vala"
								_g_date_time_unref0 (self->priv->_time);
#line 264 "../lib/Widgets/TimePicker.vala"
								self->priv->_time = _tmp36_;
#line 824 "TimePicker.c"
							}
						}
					}
				}
			}
		} else {
			GDateTime* _tmp37_;
			GDateTime* _tmp38_;
#line 268 "../lib/Widgets/TimePicker.vala"
			_tmp37_ = self->priv->_time;
#line 268 "../lib/Widgets/TimePicker.vala"
			_tmp38_ = g_date_time_add_hours (_tmp37_, new_hour);
#line 268 "../lib/Widgets/TimePicker.vala"
			_g_date_time_unref0 (self->priv->_time);
#line 268 "../lib/Widgets/TimePicker.vala"
			self->priv->_time = _tmp38_;
#line 841 "TimePicker.c"
		}
	} else {
		GDateTime* _tmp39_;
		GDateTime* _tmp40_;
		GtkSpinButton* _tmp41_;
		GDateTime* _tmp42_;
		GDateTime* _tmp43_;
		GDateTime* _tmp44_;
#line 271 "../lib/Widgets/TimePicker.vala"
		_tmp39_ = he_time_picker_get_time (self);
#line 271 "../lib/Widgets/TimePicker.vala"
		_tmp40_ = _tmp39_;
#line 271 "../lib/Widgets/TimePicker.vala"
		_tmp41_ = self->priv->minutes_spinbutton;
#line 271 "../lib/Widgets/TimePicker.vala"
		_tmp42_ = he_time_picker_get_time (self);
#line 271 "../lib/Widgets/TimePicker.vala"
		_tmp43_ = _tmp42_;
#line 271 "../lib/Widgets/TimePicker.vala"
		_tmp44_ = g_date_time_add_minutes (_tmp40_, gtk_spin_button_get_value_as_int (_tmp41_) - g_date_time_get_minute (_tmp43_));
#line 271 "../lib/Widgets/TimePicker.vala"
		_g_date_time_unref0 (self->priv->_time);
#line 271 "../lib/Widgets/TimePicker.vala"
		self->priv->_time = _tmp44_;
#line 866 "TimePicker.c"
	}
#line 274 "../lib/Widgets/TimePicker.vala"
	he_time_picker_update_text (self, FALSE);
#line 870 "TimePicker.c"
}

static void
he_time_picker_on_icon_press (HeTimePicker* self,
                              GtkEntryIconPosition position)
{
	gboolean _tmp0_ = FALSE;
	GtkSpinButton* _tmp29_;
	GDateTime* _tmp30_;
	GDateTime* _tmp31_;
	GtkPopover* _tmp32_;
#line 277 "../lib/Widgets/TimePicker.vala"
	g_return_if_fail (self != NULL);
#line 279 "../lib/Widgets/TimePicker.vala"
	he_time_picker_update_text (self, FALSE);
#line 280 "../lib/Widgets/TimePicker.vala"
	self->priv->changing_time = TRUE;
#line 282 "../lib/Widgets/TimePicker.vala"
	if (he_time_picker_is_clock_format_12h ()) {
#line 890 "TimePicker.c"
		GDateTime* _tmp1_;
		GDateTime* _tmp2_;
#line 282 "../lib/Widgets/TimePicker.vala"
		_tmp1_ = he_time_picker_get_time (self);
#line 282 "../lib/Widgets/TimePicker.vala"
		_tmp2_ = _tmp1_;
#line 282 "../lib/Widgets/TimePicker.vala"
		_tmp0_ = g_date_time_get_hour (_tmp2_) > 12;
#line 899 "TimePicker.c"
	} else {
#line 282 "../lib/Widgets/TimePicker.vala"
		_tmp0_ = FALSE;
#line 903 "TimePicker.c"
	}
#line 282 "../lib/Widgets/TimePicker.vala"
	if (_tmp0_) {
#line 907 "TimePicker.c"
		GtkSpinButton* _tmp3_;
		GDateTime* _tmp4_;
		GDateTime* _tmp5_;
#line 283 "../lib/Widgets/TimePicker.vala"
		_tmp3_ = self->priv->hours_spinbutton;
#line 283 "../lib/Widgets/TimePicker.vala"
		_tmp4_ = he_time_picker_get_time (self);
#line 283 "../lib/Widgets/TimePicker.vala"
		_tmp5_ = _tmp4_;
#line 283 "../lib/Widgets/TimePicker.vala"
		gtk_spin_button_set_value (_tmp3_, (gdouble) (g_date_time_get_hour (_tmp5_) - 12));
#line 919 "TimePicker.c"
	} else {
		GtkSpinButton* _tmp6_;
		GDateTime* _tmp7_;
		GDateTime* _tmp8_;
#line 285 "../lib/Widgets/TimePicker.vala"
		_tmp6_ = self->priv->hours_spinbutton;
#line 285 "../lib/Widgets/TimePicker.vala"
		_tmp7_ = he_time_picker_get_time (self);
#line 285 "../lib/Widgets/TimePicker.vala"
		_tmp8_ = _tmp7_;
#line 285 "../lib/Widgets/TimePicker.vala"
		gtk_spin_button_set_value (_tmp6_, (gdouble) g_date_time_get_hour (_tmp8_));
#line 932 "TimePicker.c"
	}
#line 288 "../lib/Widgets/TimePicker.vala"
	if (he_time_picker_is_clock_format_12h ()) {
#line 936 "TimePicker.c"
		GtkBox* _tmp9_;
		GDateTime* _tmp10_;
		GDateTime* _tmp11_;
		GtkSpinButton* _tmp21_;
		HeTimePickerClockWidget* _tmp22_;
#line 289 "../lib/Widgets/TimePicker.vala"
		_tmp9_ = self->priv->am_pm_box;
#line 289 "../lib/Widgets/TimePicker.vala"
		gtk_widget_show ((GtkWidget*) _tmp9_);
#line 291 "../lib/Widgets/TimePicker.vala"
		_tmp10_ = he_time_picker_get_time (self);
#line 291 "../lib/Widgets/TimePicker.vala"
		_tmp11_ = _tmp10_;
#line 291 "../lib/Widgets/TimePicker.vala"
		if (g_date_time_get_hour (_tmp11_) > 12) {
#line 952 "TimePicker.c"
			GtkSpinButton* _tmp12_;
			GDateTime* _tmp13_;
			GDateTime* _tmp14_;
#line 292 "../lib/Widgets/TimePicker.vala"
			_tmp12_ = self->priv->hours_spinbutton;
#line 292 "../lib/Widgets/TimePicker.vala"
			_tmp13_ = he_time_picker_get_time (self);
#line 292 "../lib/Widgets/TimePicker.vala"
			_tmp14_ = _tmp13_;
#line 292 "../lib/Widgets/TimePicker.vala"
			gtk_spin_button_set_value (_tmp12_, (gdouble) (g_date_time_get_hour (_tmp14_) - 12));
#line 964 "TimePicker.c"
		} else {
			GDateTime* _tmp15_;
			GDateTime* _tmp16_;
#line 293 "../lib/Widgets/TimePicker.vala"
			_tmp15_ = he_time_picker_get_time (self);
#line 293 "../lib/Widgets/TimePicker.vala"
			_tmp16_ = _tmp15_;
#line 293 "../lib/Widgets/TimePicker.vala"
			if (g_date_time_get_hour (_tmp16_) == 0) {
#line 974 "TimePicker.c"
				GtkSpinButton* _tmp17_;
#line 294 "../lib/Widgets/TimePicker.vala"
				_tmp17_ = self->priv->hours_spinbutton;
#line 294 "../lib/Widgets/TimePicker.vala"
				gtk_spin_button_set_value (_tmp17_, (gdouble) 12);
#line 980 "TimePicker.c"
			} else {
				GtkSpinButton* _tmp18_;
				GDateTime* _tmp19_;
				GDateTime* _tmp20_;
#line 296 "../lib/Widgets/TimePicker.vala"
				_tmp18_ = self->priv->hours_spinbutton;
#line 296 "../lib/Widgets/TimePicker.vala"
				_tmp19_ = he_time_picker_get_time (self);
#line 296 "../lib/Widgets/TimePicker.vala"
				_tmp20_ = _tmp19_;
#line 296 "../lib/Widgets/TimePicker.vala"
				gtk_spin_button_set_value (_tmp18_, (gdouble) g_date_time_get_hour (_tmp20_));
#line 993 "TimePicker.c"
			}
		}
#line 300 "../lib/Widgets/TimePicker.vala"
		_tmp21_ = self->priv->hours_spinbutton;
#line 300 "../lib/Widgets/TimePicker.vala"
		gtk_spin_button_set_range (_tmp21_, (gdouble) 1, (gdouble) 12);
#line 301 "../lib/Widgets/TimePicker.vala"
		_tmp22_ = self->priv->clock;
#line 301 "../lib/Widgets/TimePicker.vala"
		he_time_picker_clock_widget_set_is_military_mode (_tmp22_, FALSE);
#line 1004 "TimePicker.c"
	} else {
		GtkBox* _tmp23_;
		GtkSpinButton* _tmp24_;
		GDateTime* _tmp25_;
		GDateTime* _tmp26_;
		GtkSpinButton* _tmp27_;
		HeTimePickerClockWidget* _tmp28_;
#line 303 "../lib/Widgets/TimePicker.vala"
		_tmp23_ = self->priv->am_pm_box;
#line 303 "../lib/Widgets/TimePicker.vala"
		gtk_widget_hide ((GtkWidget*) _tmp23_);
#line 304 "../lib/Widgets/TimePicker.vala"
		_tmp24_ = self->priv->hours_spinbutton;
#line 304 "../lib/Widgets/TimePicker.vala"
		_tmp25_ = he_time_picker_get_time (self);
#line 304 "../lib/Widgets/TimePicker.vala"
		_tmp26_ = _tmp25_;
#line 304 "../lib/Widgets/TimePicker.vala"
		gtk_spin_button_set_value (_tmp24_, (gdouble) g_date_time_get_hour (_tmp26_));
#line 306 "../lib/Widgets/TimePicker.vala"
		_tmp27_ = self->priv->hours_spinbutton;
#line 306 "../lib/Widgets/TimePicker.vala"
		gtk_spin_button_set_range (_tmp27_, (gdouble) 0, (gdouble) 23);
#line 307 "../lib/Widgets/TimePicker.vala"
		_tmp28_ = self->priv->clock;
#line 307 "../lib/Widgets/TimePicker.vala"
		he_time_picker_clock_widget_set_is_military_mode (_tmp28_, TRUE);
#line 1032 "TimePicker.c"
	}
#line 310 "../lib/Widgets/TimePicker.vala"
	_tmp29_ = self->priv->minutes_spinbutton;
#line 310 "../lib/Widgets/TimePicker.vala"
	_tmp30_ = he_time_picker_get_time (self);
#line 310 "../lib/Widgets/TimePicker.vala"
	_tmp31_ = _tmp30_;
#line 310 "../lib/Widgets/TimePicker.vala"
	gtk_spin_button_set_value (_tmp29_, (gdouble) g_date_time_get_minute (_tmp31_));
#line 311 "../lib/Widgets/TimePicker.vala"
	self->priv->changing_time = FALSE;
#line 313 "../lib/Widgets/TimePicker.vala"
	_tmp32_ = self->priv->popover;
#line 313 "../lib/Widgets/TimePicker.vala"
	gtk_popover_popup (_tmp32_);
#line 1048 "TimePicker.c"
}

static void
he_time_picker_is_unfocused (HeTimePicker* self)
{
	gboolean _tmp0_ = FALSE;
	GtkPopover* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 316 "../lib/Widgets/TimePicker.vala"
	g_return_if_fail (self != NULL);
#line 317 "../lib/Widgets/TimePicker.vala"
	_tmp1_ = self->priv->popover;
#line 317 "../lib/Widgets/TimePicker.vala"
	_tmp2_ = gtk_widget_get_visible ((GtkWidget*) _tmp1_);
#line 317 "../lib/Widgets/TimePicker.vala"
	_tmp3_ = _tmp2_;
#line 317 "../lib/Widgets/TimePicker.vala"
	if (!_tmp3_) {
#line 1068 "TimePicker.c"
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
#line 317 "../lib/Widgets/TimePicker.vala"
		_tmp4_ = self->priv->old_string;
#line 317 "../lib/Widgets/TimePicker.vala"
		_tmp5_ = gtk_editable_get_text ((GtkEditable*) self);
#line 317 "../lib/Widgets/TimePicker.vala"
		_tmp6_ = _tmp5_;
#line 317 "../lib/Widgets/TimePicker.vala"
		_tmp0_ = g_utf8_collate (_tmp4_, _tmp6_) != 0;
#line 1080 "TimePicker.c"
	} else {
#line 317 "../lib/Widgets/TimePicker.vala"
		_tmp0_ = FALSE;
#line 1084 "TimePicker.c"
	}
#line 317 "../lib/Widgets/TimePicker.vala"
	if (_tmp0_) {
#line 1088 "TimePicker.c"
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		gchar* _tmp9_;
		const gchar* _tmp10_;
		const gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
#line 318 "../lib/Widgets/TimePicker.vala"
		_tmp7_ = gtk_editable_get_text ((GtkEditable*) self);
#line 318 "../lib/Widgets/TimePicker.vala"
		_tmp8_ = _tmp7_;
#line 318 "../lib/Widgets/TimePicker.vala"
		_tmp9_ = g_strdup (_tmp8_);
#line 318 "../lib/Widgets/TimePicker.vala"
		_g_free0 (self->priv->old_string);
#line 318 "../lib/Widgets/TimePicker.vala"
		self->priv->old_string = _tmp9_;
#line 319 "../lib/Widgets/TimePicker.vala"
		_tmp10_ = gtk_editable_get_text ((GtkEditable*) self);
#line 319 "../lib/Widgets/TimePicker.vala"
		_tmp11_ = _tmp10_;
#line 319 "../lib/Widgets/TimePicker.vala"
		_tmp12_ = g_strdup (_tmp11_);
#line 319 "../lib/Widgets/TimePicker.vala"
		_tmp13_ = _tmp12_;
#line 319 "../lib/Widgets/TimePicker.vala"
		he_time_picker_parse_time (self, _tmp13_);
#line 319 "../lib/Widgets/TimePicker.vala"
		_g_free0 (_tmp13_);
#line 1118 "TimePicker.c"
	}
}

static gchar*
string_to_utf8 (const gchar* self,
                gint* result_length1)
{
	gint string_length = 0;
	gint _tmp0_;
	gint _tmp1_;
	gchar* _result_ = NULL;
	gchar* _tmp2_;
	gint _result__length1;
	gint __result__size_;
	gint _tmp3_;
	gchar* _tmp4_;
	gint _tmp4__length1;
	gchar* result;
#line 1616 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1617 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1617 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1617 "glib-2.0.vapi"
	string_length = _tmp1_;
#line 1618 "glib-2.0.vapi"
	_tmp2_ = g_new0 (gchar, string_length + 1);
#line 1618 "glib-2.0.vapi"
	_result_ = _tmp2_;
#line 1618 "glib-2.0.vapi"
	_result__length1 = string_length + 1;
#line 1618 "glib-2.0.vapi"
	__result__size_ = _result__length1;
#line 1619 "glib-2.0.vapi"
	_tmp3_ = _result__length1;
#line 1619 "glib-2.0.vapi"
	_result__length1 = _tmp3_ - 1;
#line 1620 "glib-2.0.vapi"
	memcpy (_result_, self, (gsize) string_length);
#line 1621 "glib-2.0.vapi"
	_tmp4_ = _result_;
#line 1621 "glib-2.0.vapi"
	_tmp4__length1 = _result__length1;
#line 1621 "glib-2.0.vapi"
	if (result_length1) {
#line 1621 "glib-2.0.vapi"
		*result_length1 = _tmp4__length1;
#line 1167 "TimePicker.c"
	}
#line 1621 "glib-2.0.vapi"
	result = _tmp4_;
#line 1621 "glib-2.0.vapi"
	return result;
#line 1173 "TimePicker.c"
}

static gint*
_int_dup (gint* self)
{
	gint* dup;
#line 339 "../lib/Widgets/TimePicker.vala"
	dup = g_new0 (gint, 1);
#line 339 "../lib/Widgets/TimePicker.vala"
	memcpy (dup, self, sizeof (gint));
#line 339 "../lib/Widgets/TimePicker.vala"
	return dup;
#line 1186 "TimePicker.c"
}

static gpointer
__int_dup0 (gpointer self)
{
#line 339 "../lib/Widgets/TimePicker.vala"
	return self ? _int_dup (self) : NULL;
#line 1194 "TimePicker.c"
}

static gboolean
_int_equal (const gint * s1,
            const gint * s2)
{
#line 367 "../lib/Widgets/TimePicker.vala"
	if (s1 == s2) {
#line 367 "../lib/Widgets/TimePicker.vala"
		return TRUE;
#line 1205 "TimePicker.c"
	}
#line 367 "../lib/Widgets/TimePicker.vala"
	if (s1 == NULL) {
#line 367 "../lib/Widgets/TimePicker.vala"
		return FALSE;
#line 1211 "TimePicker.c"
	}
#line 367 "../lib/Widgets/TimePicker.vala"
	if (s2 == NULL) {
#line 367 "../lib/Widgets/TimePicker.vala"
		return FALSE;
#line 1217 "TimePicker.c"
	}
#line 367 "../lib/Widgets/TimePicker.vala"
	return (*s1) == (*s2);
#line 1221 "TimePicker.c"
}

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result;
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1535 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1535 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1535 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1536 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 1537 "glib-2.0.vapi"
		start = string_length + start;
#line 1248 "TimePicker.c"
	}
#line 1539 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 1540 "glib-2.0.vapi"
		end = string_length + end;
#line 1254 "TimePicker.c"
	}
#line 1542 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 1542 "glib-2.0.vapi"
		_tmp2_ = start <= string_length;
#line 1260 "TimePicker.c"
	} else {
#line 1542 "glib-2.0.vapi"
		_tmp2_ = FALSE;
#line 1264 "TimePicker.c"
	}
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp2_, NULL);
#line 1543 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 1543 "glib-2.0.vapi"
		_tmp3_ = end <= string_length;
#line 1272 "TimePicker.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp3_ = FALSE;
#line 1276 "TimePicker.c"
	}
#line 1543 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp3_, NULL);
#line 1544 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1545 "glib-2.0.vapi"
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1545 "glib-2.0.vapi"
	result = _tmp4_;
#line 1545 "glib-2.0.vapi"
	return result;
#line 1288 "TimePicker.c"
}

static void
he_time_picker_parse_time (HeTimePicker* self,
                           const gchar* timestr)
{
	gchar* current = NULL;
	gchar* _tmp0_;
	gboolean is_hours = FALSE;
	gboolean is_suffix = FALSE;
	gboolean has_suffix = FALSE;
	gint* hour = NULL;
	gint* minute = NULL;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gint _tmp3_ = 0;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gint _tmp5__length1;
	gboolean _tmp65_ = FALSE;
	gboolean _tmp66_ = FALSE;
	gint* _tmp71_;
	gboolean _tmp96_ = FALSE;
	gint* _tmp97_;
#line 323 "../lib/Widgets/TimePicker.vala"
	g_return_if_fail (self != NULL);
#line 323 "../lib/Widgets/TimePicker.vala"
	g_return_if_fail (timestr != NULL);
#line 324 "../lib/Widgets/TimePicker.vala"
	_tmp0_ = g_strdup ("");
#line 324 "../lib/Widgets/TimePicker.vala"
	current = _tmp0_;
#line 325 "../lib/Widgets/TimePicker.vala"
	is_hours = TRUE;
#line 326 "../lib/Widgets/TimePicker.vala"
	is_suffix = FALSE;
#line 327 "../lib/Widgets/TimePicker.vala"
	has_suffix = FALSE;
#line 329 "../lib/Widgets/TimePicker.vala"
	hour = NULL;
#line 330 "../lib/Widgets/TimePicker.vala"
	minute = NULL;
#line 331 "../lib/Widgets/TimePicker.vala"
	_tmp1_ = g_utf8_strdown (timestr, (gssize) -1);
#line 331 "../lib/Widgets/TimePicker.vala"
	_tmp2_ = _tmp1_;
#line 331 "../lib/Widgets/TimePicker.vala"
	_tmp4_ = string_to_utf8 (_tmp2_, &_tmp3_);
#line 331 "../lib/Widgets/TimePicker.vala"
	_tmp5_ = _tmp4_;
#line 331 "../lib/Widgets/TimePicker.vala"
	_tmp5__length1 = _tmp3_;
#line 331 "../lib/Widgets/TimePicker.vala"
	_g_free0 (_tmp2_);
#line 1343 "TimePicker.c"
	{
		gchar* c_collection = NULL;
		gint c_collection_length1 = 0;
		gint _c_collection_size_ = 0;
		gint c_it = 0;
#line 331 "../lib/Widgets/TimePicker.vala"
		c_collection = _tmp5_;
#line 331 "../lib/Widgets/TimePicker.vala"
		c_collection_length1 = _tmp5__length1;
#line 331 "../lib/Widgets/TimePicker.vala"
		for (c_it = 0; c_it < c_collection_length1; c_it = c_it + 1) {
#line 1355 "TimePicker.c"
			gchar c = '\0';
#line 331 "../lib/Widgets/TimePicker.vala"
			c = c_collection[c_it];
#line 1359 "TimePicker.c"
			{
#line 332 "../lib/Widgets/TimePicker.vala"
				if (g_ascii_isdigit (c)) {
#line 1363 "TimePicker.c"
					const gchar* _tmp6_;
					gchar* _tmp7_;
#line 333 "../lib/Widgets/TimePicker.vala"
					_tmp6_ = current;
#line 333 "../lib/Widgets/TimePicker.vala"
					_tmp7_ = g_strdup_printf ("%s%c", _tmp6_, (gint) c);
#line 333 "../lib/Widgets/TimePicker.vala"
					_g_free0 (current);
#line 333 "../lib/Widgets/TimePicker.vala"
					current = _tmp7_;
#line 1374 "TimePicker.c"
				} else {
					gboolean _tmp25_ = FALSE;
					gchar* _tmp26_;
					gchar* _tmp27_;
					gboolean _tmp28_;
#line 335 "../lib/Widgets/TimePicker.vala"
					if (!is_suffix) {
#line 1382 "TimePicker.c"
						const gchar* _tmp8_;
						gboolean _tmp17_ = FALSE;
						gchar* _tmp18_;
						gchar* _tmp19_;
						gboolean _tmp20_;
#line 336 "../lib/Widgets/TimePicker.vala"
						_tmp8_ = current;
#line 336 "../lib/Widgets/TimePicker.vala"
						if (g_strcmp0 (_tmp8_, "") != 0) {
#line 337 "../lib/Widgets/TimePicker.vala"
							if (is_hours) {
#line 1394 "TimePicker.c"
								const gchar* _tmp9_;
								gint _tmp10_;
								gint* _tmp11_;
								gchar* _tmp12_;
#line 338 "../lib/Widgets/TimePicker.vala"
								is_hours = FALSE;
#line 339 "../lib/Widgets/TimePicker.vala"
								_tmp9_ = current;
#line 339 "../lib/Widgets/TimePicker.vala"
								_tmp10_ = atoi (_tmp9_);
#line 339 "../lib/Widgets/TimePicker.vala"
								_tmp11_ = __int_dup0 (&_tmp10_);
#line 339 "../lib/Widgets/TimePicker.vala"
								_g_free0 (hour);
#line 339 "../lib/Widgets/TimePicker.vala"
								hour = _tmp11_;
#line 340 "../lib/Widgets/TimePicker.vala"
								_tmp12_ = g_strdup ("");
#line 340 "../lib/Widgets/TimePicker.vala"
								_g_free0 (current);
#line 340 "../lib/Widgets/TimePicker.vala"
								current = _tmp12_;
#line 1417 "TimePicker.c"
							} else {
								const gchar* _tmp13_;
								gint _tmp14_;
								gint* _tmp15_;
								gchar* _tmp16_;
#line 342 "../lib/Widgets/TimePicker.vala"
								_tmp13_ = current;
#line 342 "../lib/Widgets/TimePicker.vala"
								_tmp14_ = atoi (_tmp13_);
#line 342 "../lib/Widgets/TimePicker.vala"
								_tmp15_ = __int_dup0 (&_tmp14_);
#line 342 "../lib/Widgets/TimePicker.vala"
								_g_free0 (minute);
#line 342 "../lib/Widgets/TimePicker.vala"
								minute = _tmp15_;
#line 343 "../lib/Widgets/TimePicker.vala"
								_tmp16_ = g_strdup ("");
#line 343 "../lib/Widgets/TimePicker.vala"
								_g_free0 (current);
#line 343 "../lib/Widgets/TimePicker.vala"
								current = _tmp16_;
#line 1439 "TimePicker.c"
							}
						}
#line 347 "../lib/Widgets/TimePicker.vala"
						_tmp18_ = g_strdup_printf ("%c", c);
#line 347 "../lib/Widgets/TimePicker.vala"
						_tmp19_ = _tmp18_;
#line 347 "../lib/Widgets/TimePicker.vala"
						_tmp20_ = string_contains (_tmp19_, "a");
#line 347 "../lib/Widgets/TimePicker.vala"
						_g_free0 (_tmp19_);
#line 347 "../lib/Widgets/TimePicker.vala"
						if (_tmp20_) {
#line 347 "../lib/Widgets/TimePicker.vala"
							_tmp17_ = TRUE;
#line 1454 "TimePicker.c"
						} else {
							gchar* _tmp21_;
							gchar* _tmp22_;
#line 347 "../lib/Widgets/TimePicker.vala"
							_tmp21_ = g_strdup_printf ("%c", c);
#line 347 "../lib/Widgets/TimePicker.vala"
							_tmp22_ = _tmp21_;
#line 347 "../lib/Widgets/TimePicker.vala"
							_tmp17_ = string_contains (_tmp22_, "p");
#line 347 "../lib/Widgets/TimePicker.vala"
							_g_free0 (_tmp22_);
#line 1466 "TimePicker.c"
						}
#line 347 "../lib/Widgets/TimePicker.vala"
						if (_tmp17_) {
#line 1470 "TimePicker.c"
							const gchar* _tmp23_;
							gchar* _tmp24_;
#line 348 "../lib/Widgets/TimePicker.vala"
							is_suffix = TRUE;
#line 349 "../lib/Widgets/TimePicker.vala"
							_tmp23_ = current;
#line 349 "../lib/Widgets/TimePicker.vala"
							_tmp24_ = g_strdup_printf ("%s%c", _tmp23_, (gint) c);
#line 349 "../lib/Widgets/TimePicker.vala"
							_g_free0 (current);
#line 349 "../lib/Widgets/TimePicker.vala"
							current = _tmp24_;
#line 1483 "TimePicker.c"
						}
					}
#line 353 "../lib/Widgets/TimePicker.vala"
					_tmp26_ = g_strdup_printf ("%c", c);
#line 353 "../lib/Widgets/TimePicker.vala"
					_tmp27_ = _tmp26_;
#line 353 "../lib/Widgets/TimePicker.vala"
					_tmp28_ = string_contains (_tmp27_, "m");
#line 353 "../lib/Widgets/TimePicker.vala"
					_g_free0 (_tmp27_);
#line 353 "../lib/Widgets/TimePicker.vala"
					if (_tmp28_) {
#line 353 "../lib/Widgets/TimePicker.vala"
						_tmp25_ = is_suffix;
#line 1498 "TimePicker.c"
					} else {
#line 353 "../lib/Widgets/TimePicker.vala"
						_tmp25_ = FALSE;
#line 1502 "TimePicker.c"
					}
#line 353 "../lib/Widgets/TimePicker.vala"
					if (_tmp25_) {
#line 1506 "TimePicker.c"
						gint* _tmp29_;
						gboolean _tmp33_ = FALSE;
						const gchar* _tmp34_;
						gboolean _tmp50_ = FALSE;
						const gchar* _tmp51_;
						GDateTime* _tmp58_;
						GDateTime* _tmp59_;
						gint* _tmp60_;
						GDateTime* _tmp61_;
						GDateTime* _tmp62_;
						GDateTime* _tmp63_;
						GDateTime* _tmp64_;
#line 354 "../lib/Widgets/TimePicker.vala"
						_tmp29_ = hour;
#line 354 "../lib/Widgets/TimePicker.vala"
						if (_tmp29_ == NULL) {
#line 355 "../lib/Widgets/TimePicker.vala"
							c_collection = (g_free (c_collection), NULL);
#line 355 "../lib/Widgets/TimePicker.vala"
							_g_free0 (minute);
#line 355 "../lib/Widgets/TimePicker.vala"
							_g_free0 (hour);
#line 355 "../lib/Widgets/TimePicker.vala"
							_g_free0 (current);
#line 355 "../lib/Widgets/TimePicker.vala"
							return;
#line 1533 "TimePicker.c"
						} else {
							gint* _tmp30_;
#line 356 "../lib/Widgets/TimePicker.vala"
							_tmp30_ = minute;
#line 356 "../lib/Widgets/TimePicker.vala"
							if (_tmp30_ == NULL) {
#line 1540 "TimePicker.c"
								gint _tmp31_;
								gint* _tmp32_;
#line 357 "../lib/Widgets/TimePicker.vala"
								_tmp31_ = 0;
#line 357 "../lib/Widgets/TimePicker.vala"
								_tmp32_ = __int_dup0 (&_tmp31_);
#line 357 "../lib/Widgets/TimePicker.vala"
								_g_free0 (minute);
#line 357 "../lib/Widgets/TimePicker.vala"
								minute = _tmp32_;
#line 1551 "TimePicker.c"
							}
						}
#line 361 "../lib/Widgets/TimePicker.vala"
						_tmp34_ = current;
#line 361 "../lib/Widgets/TimePicker.vala"
						if (string_contains (_tmp34_, "a")) {
#line 361 "../lib/Widgets/TimePicker.vala"
							_tmp33_ = TRUE;
#line 1560 "TimePicker.c"
						} else {
							gint* _tmp35_;
#line 361 "../lib/Widgets/TimePicker.vala"
							_tmp35_ = hour;
#line 361 "../lib/Widgets/TimePicker.vala"
							_tmp33_ = (*_tmp35_) >= 12;
#line 1567 "TimePicker.c"
						}
#line 361 "../lib/Widgets/TimePicker.vala"
						if (_tmp33_) {
#line 1571 "TimePicker.c"
							GDateTime* _tmp36_;
							GDateTime* _tmp37_;
							gint* _tmp38_;
							GDateTime* _tmp39_;
							GDateTime* _tmp40_;
							GDateTime* _tmp41_;
							GDateTime* _tmp42_;
#line 362 "../lib/Widgets/TimePicker.vala"
							_tmp36_ = he_time_picker_get_time (self);
#line 362 "../lib/Widgets/TimePicker.vala"
							_tmp37_ = _tmp36_;
#line 362 "../lib/Widgets/TimePicker.vala"
							_tmp38_ = hour;
#line 362 "../lib/Widgets/TimePicker.vala"
							_tmp39_ = he_time_picker_get_time (self);
#line 362 "../lib/Widgets/TimePicker.vala"
							_tmp40_ = _tmp39_;
#line 362 "../lib/Widgets/TimePicker.vala"
							_tmp41_ = g_date_time_add_hours (_tmp37_, (*_tmp38_) - g_date_time_get_hour (_tmp40_));
#line 362 "../lib/Widgets/TimePicker.vala"
							_tmp42_ = _tmp41_;
#line 362 "../lib/Widgets/TimePicker.vala"
							he_time_picker_set_time (self, _tmp42_);
#line 362 "../lib/Widgets/TimePicker.vala"
							_g_date_time_unref0 (_tmp42_);
#line 1597 "TimePicker.c"
						} else {
							GDateTime* _tmp43_;
							GDateTime* _tmp44_;
							gint* _tmp45_;
							GDateTime* _tmp46_;
							GDateTime* _tmp47_;
							GDateTime* _tmp48_;
							GDateTime* _tmp49_;
#line 364 "../lib/Widgets/TimePicker.vala"
							_tmp43_ = he_time_picker_get_time (self);
#line 364 "../lib/Widgets/TimePicker.vala"
							_tmp44_ = _tmp43_;
#line 364 "../lib/Widgets/TimePicker.vala"
							_tmp45_ = hour;
#line 364 "../lib/Widgets/TimePicker.vala"
							_tmp46_ = he_time_picker_get_time (self);
#line 364 "../lib/Widgets/TimePicker.vala"
							_tmp47_ = _tmp46_;
#line 364 "../lib/Widgets/TimePicker.vala"
							_tmp48_ = g_date_time_add_hours (_tmp44_, ((*_tmp45_) + 12) - g_date_time_get_hour (_tmp47_));
#line 364 "../lib/Widgets/TimePicker.vala"
							_tmp49_ = _tmp48_;
#line 364 "../lib/Widgets/TimePicker.vala"
							he_time_picker_set_time (self, _tmp49_);
#line 364 "../lib/Widgets/TimePicker.vala"
							_g_date_time_unref0 (_tmp49_);
#line 1624 "TimePicker.c"
						}
#line 367 "../lib/Widgets/TimePicker.vala"
						_tmp51_ = current;
#line 367 "../lib/Widgets/TimePicker.vala"
						if (string_contains (_tmp51_, "a")) {
#line 1630 "TimePicker.c"
							gint* _tmp52_;
							gint _tmp53_;
#line 367 "../lib/Widgets/TimePicker.vala"
							_tmp52_ = hour;
#line 367 "../lib/Widgets/TimePicker.vala"
							_tmp53_ = 12;
#line 367 "../lib/Widgets/TimePicker.vala"
							_tmp50_ = _int_equal (_tmp52_, &_tmp53_) == TRUE;
#line 1639 "TimePicker.c"
						} else {
#line 367 "../lib/Widgets/TimePicker.vala"
							_tmp50_ = FALSE;
#line 1643 "TimePicker.c"
						}
#line 367 "../lib/Widgets/TimePicker.vala"
						if (_tmp50_) {
#line 1647 "TimePicker.c"
							GDateTime* _tmp54_;
							GDateTime* _tmp55_;
							GDateTime* _tmp56_;
							GDateTime* _tmp57_;
#line 368 "../lib/Widgets/TimePicker.vala"
							_tmp54_ = he_time_picker_get_time (self);
#line 368 "../lib/Widgets/TimePicker.vala"
							_tmp55_ = _tmp54_;
#line 368 "../lib/Widgets/TimePicker.vala"
							_tmp56_ = g_date_time_add_hours (_tmp55_, -12);
#line 368 "../lib/Widgets/TimePicker.vala"
							_tmp57_ = _tmp56_;
#line 368 "../lib/Widgets/TimePicker.vala"
							he_time_picker_set_time (self, _tmp57_);
#line 368 "../lib/Widgets/TimePicker.vala"
							_g_date_time_unref0 (_tmp57_);
#line 1664 "TimePicker.c"
						}
#line 371 "../lib/Widgets/TimePicker.vala"
						_tmp58_ = he_time_picker_get_time (self);
#line 371 "../lib/Widgets/TimePicker.vala"
						_tmp59_ = _tmp58_;
#line 371 "../lib/Widgets/TimePicker.vala"
						_tmp60_ = minute;
#line 371 "../lib/Widgets/TimePicker.vala"
						_tmp61_ = he_time_picker_get_time (self);
#line 371 "../lib/Widgets/TimePicker.vala"
						_tmp62_ = _tmp61_;
#line 371 "../lib/Widgets/TimePicker.vala"
						_tmp63_ = g_date_time_add_minutes (_tmp59_, (*_tmp60_) - g_date_time_get_minute (_tmp62_));
#line 371 "../lib/Widgets/TimePicker.vala"
						_tmp64_ = _tmp63_;
#line 371 "../lib/Widgets/TimePicker.vala"
						he_time_picker_set_time (self, _tmp64_);
#line 371 "../lib/Widgets/TimePicker.vala"
						_g_date_time_unref0 (_tmp64_);
#line 372 "../lib/Widgets/TimePicker.vala"
						has_suffix = TRUE;
#line 1686 "TimePicker.c"
					}
				}
			}
		}
#line 331 "../lib/Widgets/TimePicker.vala"
		c_collection = (g_free (c_collection), NULL);
#line 1693 "TimePicker.c"
	}
#line 377 "../lib/Widgets/TimePicker.vala"
	if (is_hours == FALSE) {
#line 377 "../lib/Widgets/TimePicker.vala"
		_tmp66_ = is_suffix == FALSE;
#line 1699 "TimePicker.c"
	} else {
#line 377 "../lib/Widgets/TimePicker.vala"
		_tmp66_ = FALSE;
#line 1703 "TimePicker.c"
	}
#line 377 "../lib/Widgets/TimePicker.vala"
	if (_tmp66_) {
#line 1707 "TimePicker.c"
		const gchar* _tmp67_;
#line 377 "../lib/Widgets/TimePicker.vala"
		_tmp67_ = current;
#line 377 "../lib/Widgets/TimePicker.vala"
		_tmp65_ = g_strcmp0 (_tmp67_, "") != 0;
#line 1713 "TimePicker.c"
	} else {
#line 377 "../lib/Widgets/TimePicker.vala"
		_tmp65_ = FALSE;
#line 1717 "TimePicker.c"
	}
#line 377 "../lib/Widgets/TimePicker.vala"
	if (_tmp65_) {
#line 1721 "TimePicker.c"
		const gchar* _tmp68_;
		gint _tmp69_;
		gint* _tmp70_;
#line 378 "../lib/Widgets/TimePicker.vala"
		_tmp68_ = current;
#line 378 "../lib/Widgets/TimePicker.vala"
		_tmp69_ = atoi (_tmp68_);
#line 378 "../lib/Widgets/TimePicker.vala"
		_tmp70_ = __int_dup0 (&_tmp69_);
#line 378 "../lib/Widgets/TimePicker.vala"
		_g_free0 (minute);
#line 378 "../lib/Widgets/TimePicker.vala"
		minute = _tmp70_;
#line 1735 "TimePicker.c"
	}
#line 381 "../lib/Widgets/TimePicker.vala"
	_tmp71_ = hour;
#line 381 "../lib/Widgets/TimePicker.vala"
	if (_tmp71_ == NULL) {
#line 1741 "TimePicker.c"
		const gchar* _tmp72_;
		gint _tmp73_;
		gint _tmp74_;
#line 382 "../lib/Widgets/TimePicker.vala"
		_tmp72_ = current;
#line 382 "../lib/Widgets/TimePicker.vala"
		_tmp73_ = strlen (_tmp72_);
#line 382 "../lib/Widgets/TimePicker.vala"
		_tmp74_ = _tmp73_;
#line 382 "../lib/Widgets/TimePicker.vala"
		if (_tmp74_ < 3) {
#line 1753 "TimePicker.c"
			const gchar* _tmp75_;
			gint _tmp76_;
			gint* _tmp77_;
			gint _tmp78_;
			gint* _tmp79_;
#line 383 "../lib/Widgets/TimePicker.vala"
			_tmp75_ = current;
#line 383 "../lib/Widgets/TimePicker.vala"
			_tmp76_ = atoi (_tmp75_);
#line 383 "../lib/Widgets/TimePicker.vala"
			_tmp77_ = __int_dup0 (&_tmp76_);
#line 383 "../lib/Widgets/TimePicker.vala"
			_g_free0 (hour);
#line 383 "../lib/Widgets/TimePicker.vala"
			hour = _tmp77_;
#line 384 "../lib/Widgets/TimePicker.vala"
			_tmp78_ = 0;
#line 384 "../lib/Widgets/TimePicker.vala"
			_tmp79_ = __int_dup0 (&_tmp78_);
#line 384 "../lib/Widgets/TimePicker.vala"
			_g_free0 (minute);
#line 384 "../lib/Widgets/TimePicker.vala"
			minute = _tmp79_;
#line 1777 "TimePicker.c"
		} else {
			const gchar* _tmp80_;
			gint _tmp81_;
			gint _tmp82_;
#line 385 "../lib/Widgets/TimePicker.vala"
			_tmp80_ = current;
#line 385 "../lib/Widgets/TimePicker.vala"
			_tmp81_ = strlen (_tmp80_);
#line 385 "../lib/Widgets/TimePicker.vala"
			_tmp82_ = _tmp81_;
#line 385 "../lib/Widgets/TimePicker.vala"
			if (_tmp82_ == 4) {
#line 1790 "TimePicker.c"
				const gchar* _tmp83_;
				gchar* _tmp84_;
				gchar* _tmp85_;
				gint _tmp86_;
				gint* _tmp87_;
				const gchar* _tmp88_;
				gchar* _tmp89_;
				gchar* _tmp90_;
				gint _tmp91_;
				gint* _tmp92_;
				gboolean _tmp93_ = FALSE;
				gint* _tmp94_;
#line 386 "../lib/Widgets/TimePicker.vala"
				_tmp83_ = current;
#line 386 "../lib/Widgets/TimePicker.vala"
				_tmp84_ = string_slice (_tmp83_, (glong) 0, (glong) 2);
#line 386 "../lib/Widgets/TimePicker.vala"
				_tmp85_ = _tmp84_;
#line 386 "../lib/Widgets/TimePicker.vala"
				_tmp86_ = atoi (_tmp85_);
#line 386 "../lib/Widgets/TimePicker.vala"
				_tmp87_ = __int_dup0 (&_tmp86_);
#line 386 "../lib/Widgets/TimePicker.vala"
				_g_free0 (hour);
#line 386 "../lib/Widgets/TimePicker.vala"
				hour = _tmp87_;
#line 386 "../lib/Widgets/TimePicker.vala"
				_g_free0 (_tmp85_);
#line 387 "../lib/Widgets/TimePicker.vala"
				_tmp88_ = current;
#line 387 "../lib/Widgets/TimePicker.vala"
				_tmp89_ = string_slice (_tmp88_, (glong) 2, (glong) 4);
#line 387 "../lib/Widgets/TimePicker.vala"
				_tmp90_ = _tmp89_;
#line 387 "../lib/Widgets/TimePicker.vala"
				_tmp91_ = atoi (_tmp90_);
#line 387 "../lib/Widgets/TimePicker.vala"
				_tmp92_ = __int_dup0 (&_tmp91_);
#line 387 "../lib/Widgets/TimePicker.vala"
				_g_free0 (minute);
#line 387 "../lib/Widgets/TimePicker.vala"
				minute = _tmp92_;
#line 387 "../lib/Widgets/TimePicker.vala"
				_g_free0 (_tmp90_);
#line 388 "../lib/Widgets/TimePicker.vala"
				_tmp94_ = hour;
#line 388 "../lib/Widgets/TimePicker.vala"
				if ((*_tmp94_) > 23) {
#line 388 "../lib/Widgets/TimePicker.vala"
					_tmp93_ = TRUE;
#line 1841 "TimePicker.c"
				} else {
					gint* _tmp95_;
#line 388 "../lib/Widgets/TimePicker.vala"
					_tmp95_ = minute;
#line 388 "../lib/Widgets/TimePicker.vala"
					_tmp93_ = (*_tmp95_) > 59;
#line 1848 "TimePicker.c"
				}
#line 388 "../lib/Widgets/TimePicker.vala"
				if (_tmp93_) {
#line 389 "../lib/Widgets/TimePicker.vala"
					_g_free0 (hour);
#line 389 "../lib/Widgets/TimePicker.vala"
					hour = NULL;
#line 390 "../lib/Widgets/TimePicker.vala"
					_g_free0 (minute);
#line 390 "../lib/Widgets/TimePicker.vala"
					minute = NULL;
#line 1860 "TimePicker.c"
				}
			}
		}
	}
#line 395 "../lib/Widgets/TimePicker.vala"
	_tmp97_ = hour;
#line 395 "../lib/Widgets/TimePicker.vala"
	if (_tmp97_ == NULL) {
#line 395 "../lib/Widgets/TimePicker.vala"
		_tmp96_ = TRUE;
#line 1871 "TimePicker.c"
	} else {
		gint* _tmp98_;
#line 395 "../lib/Widgets/TimePicker.vala"
		_tmp98_ = minute;
#line 395 "../lib/Widgets/TimePicker.vala"
		_tmp96_ = _tmp98_ == NULL;
#line 1878 "TimePicker.c"
	}
#line 395 "../lib/Widgets/TimePicker.vala"
	if (_tmp96_) {
#line 396 "../lib/Widgets/TimePicker.vala"
		he_time_picker_update_text (self, FALSE);
#line 397 "../lib/Widgets/TimePicker.vala"
		_g_free0 (minute);
#line 397 "../lib/Widgets/TimePicker.vala"
		_g_free0 (hour);
#line 397 "../lib/Widgets/TimePicker.vala"
		_g_free0 (current);
#line 397 "../lib/Widgets/TimePicker.vala"
		return;
#line 1892 "TimePicker.c"
	}
#line 400 "../lib/Widgets/TimePicker.vala"
	if (has_suffix == FALSE) {
#line 1896 "TimePicker.c"
		GDateTime* _tmp99_;
		GDateTime* _tmp100_;
		gint* _tmp101_;
		GDateTime* _tmp102_;
		GDateTime* _tmp103_;
		GDateTime* _tmp104_;
		GDateTime* _tmp105_;
		GDateTime* _tmp106_;
		GDateTime* _tmp107_;
		gint* _tmp108_;
		GDateTime* _tmp109_;
		GDateTime* _tmp110_;
		GDateTime* _tmp111_;
		GDateTime* _tmp112_;
#line 401 "../lib/Widgets/TimePicker.vala"
		_tmp99_ = he_time_picker_get_time (self);
#line 401 "../lib/Widgets/TimePicker.vala"
		_tmp100_ = _tmp99_;
#line 401 "../lib/Widgets/TimePicker.vala"
		_tmp101_ = hour;
#line 401 "../lib/Widgets/TimePicker.vala"
		_tmp102_ = he_time_picker_get_time (self);
#line 401 "../lib/Widgets/TimePicker.vala"
		_tmp103_ = _tmp102_;
#line 401 "../lib/Widgets/TimePicker.vala"
		_tmp104_ = g_date_time_add_hours (_tmp100_, (*_tmp101_) - g_date_time_get_hour (_tmp103_));
#line 401 "../lib/Widgets/TimePicker.vala"
		_tmp105_ = _tmp104_;
#line 401 "../lib/Widgets/TimePicker.vala"
		he_time_picker_set_time (self, _tmp105_);
#line 401 "../lib/Widgets/TimePicker.vala"
		_g_date_time_unref0 (_tmp105_);
#line 402 "../lib/Widgets/TimePicker.vala"
		_tmp106_ = he_time_picker_get_time (self);
#line 402 "../lib/Widgets/TimePicker.vala"
		_tmp107_ = _tmp106_;
#line 402 "../lib/Widgets/TimePicker.vala"
		_tmp108_ = minute;
#line 402 "../lib/Widgets/TimePicker.vala"
		_tmp109_ = he_time_picker_get_time (self);
#line 402 "../lib/Widgets/TimePicker.vala"
		_tmp110_ = _tmp109_;
#line 402 "../lib/Widgets/TimePicker.vala"
		_tmp111_ = g_date_time_add_minutes (_tmp107_, (*_tmp108_) - g_date_time_get_minute (_tmp110_));
#line 402 "../lib/Widgets/TimePicker.vala"
		_tmp112_ = _tmp111_;
#line 402 "../lib/Widgets/TimePicker.vala"
		he_time_picker_set_time (self, _tmp112_);
#line 402 "../lib/Widgets/TimePicker.vala"
		_g_date_time_unref0 (_tmp112_);
#line 1947 "TimePicker.c"
	}
#line 405 "../lib/Widgets/TimePicker.vala"
	he_time_picker_update_text (self, FALSE);
#line 323 "../lib/Widgets/TimePicker.vala"
	_g_free0 (minute);
#line 323 "../lib/Widgets/TimePicker.vala"
	_g_free0 (hour);
#line 323 "../lib/Widgets/TimePicker.vala"
	_g_free0 (current);
#line 1957 "TimePicker.c"
}

static void
he_time_picker_update_text (HeTimePicker* self,
                            gboolean no_signal)
{
	const gchar* _tmp10_;
	const gchar* _tmp11_;
	gchar* _tmp12_;
#line 408 "../lib/Widgets/TimePicker.vala"
	g_return_if_fail (self != NULL);
#line 409 "../lib/Widgets/TimePicker.vala"
	if (he_time_picker_is_clock_format_12h ()) {
#line 1971 "TimePicker.c"
		GDateTime* _tmp0_;
		GDateTime* _tmp1_;
		const gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
#line 410 "../lib/Widgets/TimePicker.vala"
		_tmp0_ = he_time_picker_get_time (self);
#line 410 "../lib/Widgets/TimePicker.vala"
		_tmp1_ = _tmp0_;
#line 410 "../lib/Widgets/TimePicker.vala"
		_tmp2_ = self->priv->_format_12;
#line 410 "../lib/Widgets/TimePicker.vala"
		_tmp3_ = g_date_time_format (_tmp1_, _tmp2_);
#line 410 "../lib/Widgets/TimePicker.vala"
		_tmp4_ = _tmp3_;
#line 410 "../lib/Widgets/TimePicker.vala"
		gtk_editable_set_text ((GtkEditable*) self, _tmp4_);
#line 410 "../lib/Widgets/TimePicker.vala"
		_g_free0 (_tmp4_);
#line 1991 "TimePicker.c"
	} else {
		GDateTime* _tmp5_;
		GDateTime* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
#line 412 "../lib/Widgets/TimePicker.vala"
		_tmp5_ = he_time_picker_get_time (self);
#line 412 "../lib/Widgets/TimePicker.vala"
		_tmp6_ = _tmp5_;
#line 412 "../lib/Widgets/TimePicker.vala"
		_tmp7_ = self->priv->_format_24;
#line 412 "../lib/Widgets/TimePicker.vala"
		_tmp8_ = g_date_time_format (_tmp6_, _tmp7_);
#line 412 "../lib/Widgets/TimePicker.vala"
		_tmp9_ = _tmp8_;
#line 412 "../lib/Widgets/TimePicker.vala"
		gtk_editable_set_text ((GtkEditable*) self, _tmp9_);
#line 412 "../lib/Widgets/TimePicker.vala"
		_g_free0 (_tmp9_);
#line 2012 "TimePicker.c"
	}
#line 415 "../lib/Widgets/TimePicker.vala"
	_tmp10_ = gtk_editable_get_text ((GtkEditable*) self);
#line 415 "../lib/Widgets/TimePicker.vala"
	_tmp11_ = _tmp10_;
#line 415 "../lib/Widgets/TimePicker.vala"
	_tmp12_ = g_strdup (_tmp11_);
#line 415 "../lib/Widgets/TimePicker.vala"
	_g_free0 (self->priv->old_string);
#line 415 "../lib/Widgets/TimePicker.vala"
	self->priv->old_string = _tmp12_;
#line 417 "../lib/Widgets/TimePicker.vala"
	if (no_signal == FALSE) {
#line 418 "../lib/Widgets/TimePicker.vala"
		g_signal_emit (self, he_time_picker_signals[HE_TIME_PICKER_TIME_CHANGED_SIGNAL], 0);
#line 2028 "TimePicker.c"
	}
}

HeTimePicker*
he_time_picker_construct (GType object_type)
{
	HeTimePicker * self = NULL;
#line 19 "../lib/Widgets/TimePicker.vala"
	self = (HeTimePicker*) g_object_new (object_type, NULL);
#line 19 "../lib/Widgets/TimePicker.vala"
	return self;
#line 2040 "TimePicker.c"
}

HeTimePicker*
he_time_picker_new (void)
{
#line 19 "../lib/Widgets/TimePicker.vala"
	return he_time_picker_construct (HE_TYPE_TIME_PICKER);
#line 2048 "TimePicker.c"
}

static inline gpointer
he_time_picker_clock_widget_get_instance_private (HeTimePickerClockWidget* self)
{
	return G_STRUCT_MEMBER_P (self, HeTimePickerClockWidget_private_offset);
}

static gboolean
he_time_picker_clock_widget_get_selecting_hour (HeTimePickerClockWidget* self)
{
	gboolean result;
#line 438 "../lib/Widgets/TimePicker.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 438 "../lib/Widgets/TimePicker.vala"
	result = self->priv->_selecting_hour;
#line 438 "../lib/Widgets/TimePicker.vala"
	return result;
#line 2067 "TimePicker.c"
}

static void
he_time_picker_clock_widget_set_selecting_hour (HeTimePickerClockWidget* self,
                                                gboolean value)
{
	gboolean old_value;
#line 438 "../lib/Widgets/TimePicker.vala"
	g_return_if_fail (self != NULL);
#line 438 "../lib/Widgets/TimePicker.vala"
	old_value = he_time_picker_clock_widget_get_selecting_hour (self);
#line 438 "../lib/Widgets/TimePicker.vala"
	if (old_value != value) {
#line 438 "../lib/Widgets/TimePicker.vala"
		self->priv->_selecting_hour = value;
#line 438 "../lib/Widgets/TimePicker.vala"
		g_object_notify_by_pspec ((GObject *) self, he_time_picker_clock_widget_properties[HE_TIME_PICKER_CLOCK_WIDGET_SELECTING_HOUR_PROPERTY]);
#line 2085 "TimePicker.c"
	}
}

static gboolean
he_time_picker_clock_widget_get_is_military_mode (HeTimePickerClockWidget* self)
{
	gboolean result;
#line 439 "../lib/Widgets/TimePicker.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 439 "../lib/Widgets/TimePicker.vala"
	result = self->priv->_is_military_mode;
#line 439 "../lib/Widgets/TimePicker.vala"
	return result;
#line 2099 "TimePicker.c"
}

static void
he_time_picker_clock_widget_set_is_military_mode (HeTimePickerClockWidget* self,
                                                  gboolean value)
{
	gboolean old_value;
#line 439 "../lib/Widgets/TimePicker.vala"
	g_return_if_fail (self != NULL);
#line 439 "../lib/Widgets/TimePicker.vala"
	old_value = he_time_picker_clock_widget_get_is_military_mode (self);
#line 439 "../lib/Widgets/TimePicker.vala"
	if (old_value != value) {
#line 439 "../lib/Widgets/TimePicker.vala"
		self->priv->_is_military_mode = value;
#line 439 "../lib/Widgets/TimePicker.vala"
		g_object_notify_by_pspec ((GObject *) self, he_time_picker_clock_widget_properties[HE_TIME_PICKER_CLOCK_WIDGET_IS_MILITARY_MODE_PROPERTY]);
#line 2117 "TimePicker.c"
	}
}

static void
he_time_picker_clock_widget_get_accent_color (HeTimePickerClockWidget* self,
                                              GdkRGBA * result)
{
	GdkRGBA _tmp0_;
#line 449 "../lib/Widgets/TimePicker.vala"
	g_return_if_fail (self != NULL);
#line 449 "../lib/Widgets/TimePicker.vala"
	_tmp0_ = self->priv->_accent_color;
#line 449 "../lib/Widgets/TimePicker.vala"
	*result = _tmp0_;
#line 449 "../lib/Widgets/TimePicker.vala"
	return;
#line 2134 "TimePicker.c"
}

static void
he_time_picker_clock_widget_set_accent_color (HeTimePickerClockWidget* self,
                                              GdkRGBA * value)
{
	GdkRGBA _tmp0_;
#line 450 "../lib/Widgets/TimePicker.vala"
	g_return_if_fail (self != NULL);
#line 450 "../lib/Widgets/TimePicker.vala"
	_tmp0_ = *value;
#line 450 "../lib/Widgets/TimePicker.vala"
	self->priv->_accent_color = _tmp0_;
#line 450 "../lib/Widgets/TimePicker.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 450 "../lib/Widgets/TimePicker.vala"
	g_object_notify_by_pspec ((GObject *) self, he_time_picker_clock_widget_properties[HE_TIME_PICKER_CLOCK_WIDGET_ACCENT_COLOR_PROPERTY]);
#line 2152 "TimePicker.c"
}

static gint
he_time_picker_clock_widget_get_hour (HeTimePickerClockWidget* self)
{
	gint result;
#line 454 "../lib/Widgets/TimePicker.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 454 "../lib/Widgets/TimePicker.vala"
	result = self->priv->selected_hour;
#line 454 "../lib/Widgets/TimePicker.vala"
	return result;
#line 2165 "TimePicker.c"
}

static void
he_time_picker_clock_widget_set_hour (HeTimePickerClockWidget* self,
                                      gint value)
{
	gint _tmp0_ = 0;
	gboolean _tmp1_;
	gint _tmp2_ = 0;
	gboolean _tmp3_;
#line 455 "../lib/Widgets/TimePicker.vala"
	g_return_if_fail (self != NULL);
#line 456 "../lib/Widgets/TimePicker.vala"
	_tmp1_ = self->priv->_is_military_mode;
#line 456 "../lib/Widgets/TimePicker.vala"
	if (_tmp1_) {
#line 456 "../lib/Widgets/TimePicker.vala"
		_tmp0_ = HE_TIME_PICKER_CLOCK_WIDGET_FULL_DAY;
#line 2184 "TimePicker.c"
	} else {
#line 456 "../lib/Widgets/TimePicker.vala"
		_tmp0_ = HE_TIME_PICKER_CLOCK_WIDGET_HALF_DAY;
#line 2188 "TimePicker.c"
	}
#line 456 "../lib/Widgets/TimePicker.vala"
	_tmp3_ = self->priv->_is_military_mode;
#line 456 "../lib/Widgets/TimePicker.vala"
	if (_tmp3_) {
#line 456 "../lib/Widgets/TimePicker.vala"
		_tmp2_ = HE_TIME_PICKER_CLOCK_WIDGET_FULL_DAY;
#line 2196 "TimePicker.c"
	} else {
#line 456 "../lib/Widgets/TimePicker.vala"
		_tmp2_ = HE_TIME_PICKER_CLOCK_WIDGET_HALF_DAY;
#line 2200 "TimePicker.c"
	}
#line 456 "../lib/Widgets/TimePicker.vala"
	self->priv->selected_hour = (((gint) ((value * _tmp0_) / (2 * G_PI))) + 3) % _tmp2_;
#line 457 "../lib/Widgets/TimePicker.vala"
	if (self->priv->selected_hour == 0) {
#line 2206 "TimePicker.c"
		gint _tmp4_ = 0;
		gboolean _tmp5_;
#line 457 "../lib/Widgets/TimePicker.vala"
		_tmp5_ = self->priv->_is_military_mode;
#line 457 "../lib/Widgets/TimePicker.vala"
		if (_tmp5_) {
#line 457 "../lib/Widgets/TimePicker.vala"
			_tmp4_ = HE_TIME_PICKER_CLOCK_WIDGET_FULL_DAY;
#line 2215 "TimePicker.c"
		} else {
#line 457 "../lib/Widgets/TimePicker.vala"
			_tmp4_ = HE_TIME_PICKER_CLOCK_WIDGET_HALF_DAY;
#line 2219 "TimePicker.c"
		}
#line 457 "../lib/Widgets/TimePicker.vala"
		self->priv->selected_hour = _tmp4_;
#line 2223 "TimePicker.c"
	}
#line 458 "../lib/Widgets/TimePicker.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 455 "../lib/Widgets/TimePicker.vala"
	g_object_notify_by_pspec ((GObject *) self, he_time_picker_clock_widget_properties[HE_TIME_PICKER_CLOCK_WIDGET_HOUR_PROPERTY]);
#line 2229 "TimePicker.c"
}

static gint
he_time_picker_clock_widget_get_minute (HeTimePickerClockWidget* self)
{
	gint result;
#line 463 "../lib/Widgets/TimePicker.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 463 "../lib/Widgets/TimePicker.vala"
	result = self->priv->selected_minute;
#line 463 "../lib/Widgets/TimePicker.vala"
	return result;
#line 2242 "TimePicker.c"
}

static void
he_time_picker_clock_widget_set_minute (HeTimePickerClockWidget* self,
                                        gint value)
{
#line 464 "../lib/Widgets/TimePicker.vala"
	g_return_if_fail (self != NULL);
#line 465 "../lib/Widgets/TimePicker.vala"
	self->priv->selected_minute = ((gint) round (((value * 30) / G_PI) + 15)) % HE_TIME_PICKER_CLOCK_WIDGET_MINUTES;
#line 466 "../lib/Widgets/TimePicker.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 464 "../lib/Widgets/TimePicker.vala"
	g_object_notify_by_pspec ((GObject *) self, he_time_picker_clock_widget_properties[HE_TIME_PICKER_CLOCK_WIDGET_MINUTE_PROPERTY]);
#line 2257 "TimePicker.c"
}

static void
g_cclosure_user_marshal_VOID__INT_INT (GClosure * closure,
                                       GValue * return_value,
                                       guint n_param_values,
                                       const GValue * param_values,
                                       gpointer invocation_hint,
                                       gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__INT_INT) (gpointer data1, gint arg_1, gint arg_2, gpointer data2);
	register GMarshalFunc_VOID__INT_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 422 "../lib/Widgets/TimePicker.vala"
	g_return_if_fail (n_param_values == 3);
#line 422 "../lib/Widgets/TimePicker.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 422 "../lib/Widgets/TimePicker.vala"
		data1 = closure->data;
#line 422 "../lib/Widgets/TimePicker.vala"
		data2 = param_values->data[0].v_pointer;
#line 2282 "TimePicker.c"
	} else {
#line 422 "../lib/Widgets/TimePicker.vala"
		data1 = param_values->data[0].v_pointer;
#line 422 "../lib/Widgets/TimePicker.vala"
		data2 = closure->data;
#line 2288 "TimePicker.c"
	}
#line 422 "../lib/Widgets/TimePicker.vala"
	callback = (GMarshalFunc_VOID__INT_INT) (marshal_data ? marshal_data : cc->callback);
#line 422 "../lib/Widgets/TimePicker.vala"
	callback (data1, g_value_get_int (param_values + 1), g_value_get_int (param_values + 2), data2);
#line 2294 "TimePicker.c"
}

static void
_he_time_picker_clock_widget_update_style_manager_g_object_notify (GObject* _sender,
                                                                   GParamSpec* pspec,
                                                                   gpointer self)
{
#line 476 "../lib/Widgets/TimePicker.vala"
	he_time_picker_clock_widget_update_style_manager ((HeTimePickerClockWidget*) self);
#line 2304 "TimePicker.c"
}

static HeTimePickerClockWidget*
he_time_picker_clock_widget_construct (GType object_type)
{
	HeTimePickerClockWidget * self = NULL;
	gboolean _tmp0_ = FALSE;
	HeDesktop* _tmp1_;
	HeDesktopColorScheme _tmp2_;
	HeDesktopColorScheme _tmp3_;
	HeDesktop* _tmp4_;
#line 472 "../lib/Widgets/TimePicker.vala"
	self = (HeTimePickerClockWidget*) g_object_new (object_type, NULL);
#line 473 "../lib/Widgets/TimePicker.vala"
	_tmp1_ = self->priv->desktop;
#line 473 "../lib/Widgets/TimePicker.vala"
	_tmp2_ = he_desktop_get_prefers_color_scheme (_tmp1_);
#line 473 "../lib/Widgets/TimePicker.vala"
	_tmp3_ = _tmp2_;
#line 473 "../lib/Widgets/TimePicker.vala"
	if (_tmp3_ == HE_DESKTOP_COLOR_SCHEME_DARK) {
#line 473 "../lib/Widgets/TimePicker.vala"
		_tmp0_ = TRUE;
#line 2328 "TimePicker.c"
	} else {
#line 473 "../lib/Widgets/TimePicker.vala"
		_tmp0_ = FALSE;
#line 2332 "TimePicker.c"
	}
#line 473 "../lib/Widgets/TimePicker.vala"
	self->priv->is_dark = _tmp0_;
#line 475 "../lib/Widgets/TimePicker.vala"
	he_time_picker_clock_widget_update_style_manager (self);
#line 476 "../lib/Widgets/TimePicker.vala"
	_tmp4_ = self->priv->desktop;
#line 476 "../lib/Widgets/TimePicker.vala"
	g_signal_connect_object ((GObject*) _tmp4_, "notify::accent-color", (GCallback) _he_time_picker_clock_widget_update_style_manager_g_object_notify, self, 0);
#line 472 "../lib/Widgets/TimePicker.vala"
	return self;
#line 2344 "TimePicker.c"
}

static HeTimePickerClockWidget*
he_time_picker_clock_widget_new (void)
{
#line 472 "../lib/Widgets/TimePicker.vala"
	return he_time_picker_clock_widget_construct (HE_TIME_PICKER_TYPE_CLOCK_WIDGET);
#line 2352 "TimePicker.c"
}

static void
he_time_picker_clock_widget_real_dispose (GObject* base)
{
	HeTimePickerClockWidget * self;
#line 509 "../lib/Widgets/TimePicker.vala"
	self = (HeTimePickerClockWidget*) base;
#line 510 "../lib/Widgets/TimePicker.vala"
	he_time_picker_clock_widget_reset_to_hour_selection (self);
#line 511 "../lib/Widgets/TimePicker.vala"
	G_OBJECT_CLASS (he_time_picker_clock_widget_parent_class)->dispose ((GObject*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
#line 2365 "TimePicker.c"
}

static void
he_time_picker_clock_widget_real_snapshot (GtkWidget* base,
                                           GtkSnapshot* snapshot)
{
	HeTimePickerClockWidget * self;
	graphene_rect_t rect = {0};
	cairo_t* cr = NULL;
	graphene_rect_t _tmp0_;
	cairo_t* _tmp1_;
	cairo_t* _tmp2_;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	cairo_t* _tmp6_;
	GdkRGBA _tmp7_ = {0};
	GdkRGBA _tmp8_;
	GdkRGBA _tmp9_ = {0};
	GdkRGBA _tmp10_;
	GdkRGBA _tmp11_ = {0};
	GdkRGBA _tmp12_;
	cairo_t* _tmp13_;
	cairo_t* _tmp14_;
	gdouble _tmp15_ = 0.0;
	gboolean _tmp16_;
	gdouble hand_angle = 0.0;
	gdouble hand_radius = 0.0;
	gdouble hand_x = 0.0;
	gdouble hand_y = 0.0;
	gdouble _tmp17_ = 0.0;
	gdouble _tmp18_ = 0.0;
	gdouble _tmp19_ = 0.0;
	cairo_t* _tmp20_;
	GdkRGBA _tmp21_ = {0};
	GdkRGBA _tmp22_;
	GdkRGBA _tmp23_ = {0};
	GdkRGBA _tmp24_;
	GdkRGBA _tmp25_ = {0};
	GdkRGBA _tmp26_;
	cairo_t* _tmp27_;
	cairo_t* _tmp28_;
	gdouble _tmp29_ = 0.0;
	gdouble _tmp30_ = 0.0;
	gdouble _tmp31_ = 0.0;
	cairo_t* _tmp32_;
	GdkRGBA _tmp33_ = {0};
	GdkRGBA _tmp34_;
	GdkRGBA _tmp35_ = {0};
	GdkRGBA _tmp36_;
	GdkRGBA _tmp37_ = {0};
	GdkRGBA _tmp38_;
	cairo_t* _tmp39_;
	cairo_t* _tmp40_;
	cairo_t* _tmp41_;
	cairo_t* _tmp42_;
	gdouble _tmp43_ = 0.0;
	gdouble _tmp44_ = 0.0;
	gdouble _tmp45_ = 0.0;
	cairo_t* _tmp46_;
	GdkRGBA _tmp47_ = {0};
	GdkRGBA _tmp48_;
	GdkRGBA _tmp49_ = {0};
	GdkRGBA _tmp50_;
	GdkRGBA _tmp51_ = {0};
	GdkRGBA _tmp52_;
	cairo_t* _tmp53_;
	cairo_t* _tmp54_;
	gboolean _tmp55_;
	gboolean _tmp91_;
#line 514 "../lib/Widgets/TimePicker.vala"
	self = (HeTimePickerClockWidget*) base;
#line 514 "../lib/Widgets/TimePicker.vala"
	g_return_if_fail (snapshot != NULL);
#line 515 "../lib/Widgets/TimePicker.vala"
	memset (&rect, 0, sizeof (graphene_rect_t));
#line 516 "../lib/Widgets/TimePicker.vala"
	graphene_rect_init (&rect, (gfloat) 0, (gfloat) 0, (gfloat) HE_TIME_PICKER_CLOCK_WIDGET_SIZE, (gfloat) HE_TIME_PICKER_CLOCK_WIDGET_SIZE);
#line 517 "../lib/Widgets/TimePicker.vala"
	_tmp0_ = rect;
#line 517 "../lib/Widgets/TimePicker.vala"
	_tmp1_ = gtk_snapshot_append_cairo (snapshot, &_tmp0_);
#line 517 "../lib/Widgets/TimePicker.vala"
	cr = _tmp1_;
#line 520 "../lib/Widgets/TimePicker.vala"
	_tmp2_ = cr;
#line 520 "../lib/Widgets/TimePicker.vala"
	cairo_select_font_face (_tmp2_, HE_TIME_PICKER_CLOCK_WIDGET_FONT_FAMILY, CAIRO_FONT_SLANT_NORMAL, CAIRO_FONT_WEIGHT_NORMAL);
#line 523 "../lib/Widgets/TimePicker.vala"
	if (self->priv->is_dark) {
#line 523 "../lib/Widgets/TimePicker.vala"
		_tmp3_ = 0.92;
#line 2458 "TimePicker.c"
	} else {
#line 523 "../lib/Widgets/TimePicker.vala"
		_tmp3_ = 0.17;
#line 2462 "TimePicker.c"
	}
#line 523 "../lib/Widgets/TimePicker.vala"
	if (self->priv->is_dark) {
#line 523 "../lib/Widgets/TimePicker.vala"
		_tmp4_ = 0.92;
#line 2468 "TimePicker.c"
	} else {
#line 523 "../lib/Widgets/TimePicker.vala"
		_tmp4_ = 0.17;
#line 2472 "TimePicker.c"
	}
#line 523 "../lib/Widgets/TimePicker.vala"
	if (self->priv->is_dark) {
#line 523 "../lib/Widgets/TimePicker.vala"
		_tmp5_ = 0.92;
#line 2478 "TimePicker.c"
	} else {
#line 523 "../lib/Widgets/TimePicker.vala"
		_tmp5_ = 0.17;
#line 2482 "TimePicker.c"
	}
#line 523 "../lib/Widgets/TimePicker.vala"
	_tmp6_ = cr;
#line 523 "../lib/Widgets/TimePicker.vala"
	he_time_picker_clock_widget_get_accent_color (self, &_tmp7_);
#line 523 "../lib/Widgets/TimePicker.vala"
	_tmp8_ = _tmp7_;
#line 523 "../lib/Widgets/TimePicker.vala"
	he_time_picker_clock_widget_get_accent_color (self, &_tmp9_);
#line 523 "../lib/Widgets/TimePicker.vala"
	_tmp10_ = _tmp9_;
#line 523 "../lib/Widgets/TimePicker.vala"
	he_time_picker_clock_widget_get_accent_color (self, &_tmp11_);
#line 523 "../lib/Widgets/TimePicker.vala"
	_tmp12_ = _tmp11_;
#line 523 "../lib/Widgets/TimePicker.vala"
	cairo_set_source_rgba (_tmp6_, _tmp3_ * _tmp8_.red, _tmp4_ * _tmp10_.green, _tmp5_ * _tmp12_.blue, 0.08);
#line 524 "../lib/Widgets/TimePicker.vala"
	_tmp13_ = cr;
#line 524 "../lib/Widgets/TimePicker.vala"
	cairo_arc (_tmp13_, HE_TIME_PICKER_CLOCK_WIDGET_CENTER, HE_TIME_PICKER_CLOCK_WIDGET_CENTER, HE_TIME_PICKER_CLOCK_WIDGET_RADIUS, (gdouble) 0, 2 * G_PI);
#line 525 "../lib/Widgets/TimePicker.vala"
	_tmp14_ = cr;
#line 525 "../lib/Widgets/TimePicker.vala"
	cairo_fill (_tmp14_);
#line 528 "../lib/Widgets/TimePicker.vala"
	_tmp16_ = self->priv->_selecting_hour;
#line 528 "../lib/Widgets/TimePicker.vala"
	if (_tmp16_) {
#line 528 "../lib/Widgets/TimePicker.vala"
		_tmp15_ = he_time_picker_clock_widget_get_hour_angle (self);
#line 2514 "TimePicker.c"
	} else {
#line 528 "../lib/Widgets/TimePicker.vala"
		_tmp15_ = he_time_picker_clock_widget_get_minute_angle (self);
#line 2518 "TimePicker.c"
	}
#line 528 "../lib/Widgets/TimePicker.vala"
	hand_angle = _tmp15_;
#line 529 "../lib/Widgets/TimePicker.vala"
	hand_radius = he_time_picker_clock_widget_get_hand_radius (self, HE_TIME_PICKER_CLOCK_WIDGET_RADIUS);
#line 530 "../lib/Widgets/TimePicker.vala"
	hand_x = HE_TIME_PICKER_CLOCK_WIDGET_CENTER + (hand_radius * cos (hand_angle));
#line 531 "../lib/Widgets/TimePicker.vala"
	hand_y = HE_TIME_PICKER_CLOCK_WIDGET_CENTER + (hand_radius * sin (hand_angle));
#line 532 "../lib/Widgets/TimePicker.vala"
	if (self->priv->is_dark) {
#line 532 "../lib/Widgets/TimePicker.vala"
		_tmp17_ = 0.50;
#line 2532 "TimePicker.c"
	} else {
#line 532 "../lib/Widgets/TimePicker.vala"
		_tmp17_ = 0.50;
#line 2536 "TimePicker.c"
	}
#line 532 "../lib/Widgets/TimePicker.vala"
	if (self->priv->is_dark) {
#line 532 "../lib/Widgets/TimePicker.vala"
		_tmp18_ = 0.50;
#line 2542 "TimePicker.c"
	} else {
#line 532 "../lib/Widgets/TimePicker.vala"
		_tmp18_ = 0.50;
#line 2546 "TimePicker.c"
	}
#line 532 "../lib/Widgets/TimePicker.vala"
	if (self->priv->is_dark) {
#line 532 "../lib/Widgets/TimePicker.vala"
		_tmp19_ = 0.50;
#line 2552 "TimePicker.c"
	} else {
#line 532 "../lib/Widgets/TimePicker.vala"
		_tmp19_ = 0.50;
#line 2556 "TimePicker.c"
	}
#line 532 "../lib/Widgets/TimePicker.vala"
	_tmp20_ = cr;
#line 532 "../lib/Widgets/TimePicker.vala"
	he_time_picker_clock_widget_get_accent_color (self, &_tmp21_);
#line 532 "../lib/Widgets/TimePicker.vala"
	_tmp22_ = _tmp21_;
#line 532 "../lib/Widgets/TimePicker.vala"
	he_time_picker_clock_widget_get_accent_color (self, &_tmp23_);
#line 532 "../lib/Widgets/TimePicker.vala"
	_tmp24_ = _tmp23_;
#line 532 "../lib/Widgets/TimePicker.vala"
	he_time_picker_clock_widget_get_accent_color (self, &_tmp25_);
#line 532 "../lib/Widgets/TimePicker.vala"
	_tmp26_ = _tmp25_;
#line 532 "../lib/Widgets/TimePicker.vala"
	cairo_set_source_rgba (_tmp20_, _tmp17_ * _tmp22_.red, _tmp18_ * _tmp24_.green, _tmp19_ * _tmp26_.blue, (gdouble) 1);
#line 533 "../lib/Widgets/TimePicker.vala"
	_tmp27_ = cr;
#line 533 "../lib/Widgets/TimePicker.vala"
	cairo_arc (_tmp27_, HE_TIME_PICKER_CLOCK_WIDGET_CENTER, HE_TIME_PICKER_CLOCK_WIDGET_CENTER, HE_TIME_PICKER_CLOCK_WIDGET_HAND_CENTER_WIDTH, (gdouble) 0, 2 * G_PI);
#line 534 "../lib/Widgets/TimePicker.vala"
	_tmp28_ = cr;
#line 534 "../lib/Widgets/TimePicker.vala"
	cairo_fill_preserve (_tmp28_);
#line 535 "../lib/Widgets/TimePicker.vala"
	if (self->priv->is_dark) {
#line 535 "../lib/Widgets/TimePicker.vala"
		_tmp29_ = 0.50;
#line 2586 "TimePicker.c"
	} else {
#line 535 "../lib/Widgets/TimePicker.vala"
		_tmp29_ = 0.50;
#line 2590 "TimePicker.c"
	}
#line 535 "../lib/Widgets/TimePicker.vala"
	if (self->priv->is_dark) {
#line 535 "../lib/Widgets/TimePicker.vala"
		_tmp30_ = 0.50;
#line 2596 "TimePicker.c"
	} else {
#line 535 "../lib/Widgets/TimePicker.vala"
		_tmp30_ = 0.50;
#line 2600 "TimePicker.c"
	}
#line 535 "../lib/Widgets/TimePicker.vala"
	if (self->priv->is_dark) {
#line 535 "../lib/Widgets/TimePicker.vala"
		_tmp31_ = 0.50;
#line 2606 "TimePicker.c"
	} else {
#line 535 "../lib/Widgets/TimePicker.vala"
		_tmp31_ = 0.50;
#line 2610 "TimePicker.c"
	}
#line 535 "../lib/Widgets/TimePicker.vala"
	_tmp32_ = cr;
#line 535 "../lib/Widgets/TimePicker.vala"
	he_time_picker_clock_widget_get_accent_color (self, &_tmp33_);
#line 535 "../lib/Widgets/TimePicker.vala"
	_tmp34_ = _tmp33_;
#line 535 "../lib/Widgets/TimePicker.vala"
	he_time_picker_clock_widget_get_accent_color (self, &_tmp35_);
#line 535 "../lib/Widgets/TimePicker.vala"
	_tmp36_ = _tmp35_;
#line 535 "../lib/Widgets/TimePicker.vala"
	he_time_picker_clock_widget_get_accent_color (self, &_tmp37_);
#line 535 "../lib/Widgets/TimePicker.vala"
	_tmp38_ = _tmp37_;
#line 535 "../lib/Widgets/TimePicker.vala"
	cairo_set_source_rgba (_tmp32_, _tmp29_ * _tmp34_.red, _tmp30_ * _tmp36_.green, _tmp31_ * _tmp38_.blue, (gdouble) 1);
#line 536 "../lib/Widgets/TimePicker.vala"
	_tmp39_ = cr;
#line 536 "../lib/Widgets/TimePicker.vala"
	cairo_set_line_width (_tmp39_, HE_TIME_PICKER_CLOCK_WIDGET_HAND_LINE_WIDTH);
#line 537 "../lib/Widgets/TimePicker.vala"
	_tmp40_ = cr;
#line 537 "../lib/Widgets/TimePicker.vala"
	cairo_move_to (_tmp40_, HE_TIME_PICKER_CLOCK_WIDGET_CENTER, HE_TIME_PICKER_CLOCK_WIDGET_CENTER);
#line 538 "../lib/Widgets/TimePicker.vala"
	_tmp41_ = cr;
#line 538 "../lib/Widgets/TimePicker.vala"
	cairo_line_to (_tmp41_, hand_x, hand_y);
#line 539 "../lib/Widgets/TimePicker.vala"
	_tmp42_ = cr;
#line 539 "../lib/Widgets/TimePicker.vala"
	cairo_stroke (_tmp42_);
#line 540 "../lib/Widgets/TimePicker.vala"
	if (self->priv->is_dark) {
#line 540 "../lib/Widgets/TimePicker.vala"
		_tmp43_ = 0.50;
#line 2648 "TimePicker.c"
	} else {
#line 540 "../lib/Widgets/TimePicker.vala"
		_tmp43_ = 0.50;
#line 2652 "TimePicker.c"
	}
#line 540 "../lib/Widgets/TimePicker.vala"
	if (self->priv->is_dark) {
#line 540 "../lib/Widgets/TimePicker.vala"
		_tmp44_ = 0.50;
#line 2658 "TimePicker.c"
	} else {
#line 540 "../lib/Widgets/TimePicker.vala"
		_tmp44_ = 0.50;
#line 2662 "TimePicker.c"
	}
#line 540 "../lib/Widgets/TimePicker.vala"
	if (self->priv->is_dark) {
#line 540 "../lib/Widgets/TimePicker.vala"
		_tmp45_ = 0.50;
#line 2668 "TimePicker.c"
	} else {
#line 540 "../lib/Widgets/TimePicker.vala"
		_tmp45_ = 0.50;
#line 2672 "TimePicker.c"
	}
#line 540 "../lib/Widgets/TimePicker.vala"
	_tmp46_ = cr;
#line 540 "../lib/Widgets/TimePicker.vala"
	he_time_picker_clock_widget_get_accent_color (self, &_tmp47_);
#line 540 "../lib/Widgets/TimePicker.vala"
	_tmp48_ = _tmp47_;
#line 540 "../lib/Widgets/TimePicker.vala"
	he_time_picker_clock_widget_get_accent_color (self, &_tmp49_);
#line 540 "../lib/Widgets/TimePicker.vala"
	_tmp50_ = _tmp49_;
#line 540 "../lib/Widgets/TimePicker.vala"
	he_time_picker_clock_widget_get_accent_color (self, &_tmp51_);
#line 540 "../lib/Widgets/TimePicker.vala"
	_tmp52_ = _tmp51_;
#line 540 "../lib/Widgets/TimePicker.vala"
	cairo_set_source_rgba (_tmp46_, _tmp43_ * _tmp48_.red, _tmp44_ * _tmp50_.green, _tmp45_ * _tmp52_.blue, (gdouble) 1);
#line 541 "../lib/Widgets/TimePicker.vala"
	_tmp53_ = cr;
#line 541 "../lib/Widgets/TimePicker.vala"
	cairo_arc (_tmp53_, hand_x, hand_y, HE_TIME_PICKER_CLOCK_WIDGET_SELECTION_CIRCLE_RADIUS, (gdouble) 0, 2 * G_PI);
#line 542 "../lib/Widgets/TimePicker.vala"
	_tmp54_ = cr;
#line 542 "../lib/Widgets/TimePicker.vala"
	cairo_fill (_tmp54_);
#line 545 "../lib/Widgets/TimePicker.vala"
	_tmp55_ = self->priv->_selecting_hour;
#line 545 "../lib/Widgets/TimePicker.vala"
	if (!_tmp55_) {
#line 2702 "TimePicker.c"
		{
			gint i = 0;
#line 546 "../lib/Widgets/TimePicker.vala"
			i = 0;
#line 2707 "TimePicker.c"
			{
				gboolean _tmp56_ = FALSE;
#line 546 "../lib/Widgets/TimePicker.vala"
				_tmp56_ = TRUE;
#line 546 "../lib/Widgets/TimePicker.vala"
				while (TRUE) {
#line 2714 "TimePicker.c"
					gdouble minute_angle = 0.0;
					gdouble minute_x = 0.0;
					gdouble minute_y = 0.0;
					gdouble selection_angle = 0.0;
					gdouble label_angle = 0.0;
					gboolean is_selected = FALSE;
#line 546 "../lib/Widgets/TimePicker.vala"
					if (!_tmp56_) {
#line 546 "../lib/Widgets/TimePicker.vala"
						i += 5;
#line 2725 "TimePicker.c"
					}
#line 546 "../lib/Widgets/TimePicker.vala"
					_tmp56_ = FALSE;
#line 546 "../lib/Widgets/TimePicker.vala"
					if (!(i < HE_TIME_PICKER_CLOCK_WIDGET_MINUTES)) {
#line 546 "../lib/Widgets/TimePicker.vala"
						break;
#line 2733 "TimePicker.c"
					}
#line 547 "../lib/Widgets/TimePicker.vala"
					minute_angle = ((i - 15) * (2 * G_PI)) / HE_TIME_PICKER_CLOCK_WIDGET_MINUTES;
#line 548 "../lib/Widgets/TimePicker.vala"
					minute_x = HE_TIME_PICKER_CLOCK_WIDGET_CENTER + (HE_TIME_PICKER_CLOCK_WIDGET_OUTER_RADIUS * cos (minute_angle));
#line 549 "../lib/Widgets/TimePicker.vala"
					minute_y = HE_TIME_PICKER_CLOCK_WIDGET_CENTER + (HE_TIME_PICKER_CLOCK_WIDGET_OUTER_RADIUS * sin (minute_angle));
#line 551 "../lib/Widgets/TimePicker.vala"
					selection_angle = he_time_picker_clock_widget_get_minute_angle (self);
#line 552 "../lib/Widgets/TimePicker.vala"
					if (selection_angle < ((-G_PI) / 2)) {
#line 553 "../lib/Widgets/TimePicker.vala"
						selection_angle += 2 * G_PI;
#line 2747 "TimePicker.c"
					}
#line 555 "../lib/Widgets/TimePicker.vala"
					label_angle = minute_angle;
#line 556 "../lib/Widgets/TimePicker.vala"
					if (label_angle < ((-G_PI) / 2)) {
#line 557 "../lib/Widgets/TimePicker.vala"
						label_angle += 2 * G_PI;
#line 2755 "TimePicker.c"
					}
#line 560 "../lib/Widgets/TimePicker.vala"
					is_selected = fabs (selection_angle - label_angle) < (G_PI / HE_TIME_PICKER_CLOCK_WIDGET_MINUTES);
#line 562 "../lib/Widgets/TimePicker.vala"
					if (is_selected) {
#line 2761 "TimePicker.c"
						gdouble _tmp57_ = 0.0;
						gdouble _tmp60_ = 0.0;
						gdouble _tmp63_ = 0.0;
						cairo_t* _tmp66_;
						cairo_t* _tmp67_;
						cairo_t* _tmp71_;
						gchar* _tmp72_;
						gchar* _tmp73_;
#line 563 "../lib/Widgets/TimePicker.vala"
						if (self->priv->is_dark) {
#line 2772 "TimePicker.c"
							GdkRGBA _tmp58_ = {0};
							GdkRGBA _tmp59_;
#line 563 "../lib/Widgets/TimePicker.vala"
							he_time_picker_clock_widget_get_accent_color (self, &_tmp58_);
#line 563 "../lib/Widgets/TimePicker.vala"
							_tmp59_ = _tmp58_;
#line 563 "../lib/Widgets/TimePicker.vala"
							_tmp57_ = 0.20 * _tmp59_.red;
#line 2781 "TimePicker.c"
						} else {
#line 563 "../lib/Widgets/TimePicker.vala"
							_tmp57_ = 1.0;
#line 2785 "TimePicker.c"
						}
#line 563 "../lib/Widgets/TimePicker.vala"
						if (self->priv->is_dark) {
#line 2789 "TimePicker.c"
							GdkRGBA _tmp61_ = {0};
							GdkRGBA _tmp62_;
#line 563 "../lib/Widgets/TimePicker.vala"
							he_time_picker_clock_widget_get_accent_color (self, &_tmp61_);
#line 563 "../lib/Widgets/TimePicker.vala"
							_tmp62_ = _tmp61_;
#line 563 "../lib/Widgets/TimePicker.vala"
							_tmp60_ = 0.20 * _tmp62_.green;
#line 2798 "TimePicker.c"
						} else {
#line 563 "../lib/Widgets/TimePicker.vala"
							_tmp60_ = 1.0;
#line 2802 "TimePicker.c"
						}
#line 563 "../lib/Widgets/TimePicker.vala"
						if (self->priv->is_dark) {
#line 2806 "TimePicker.c"
							GdkRGBA _tmp64_ = {0};
							GdkRGBA _tmp65_;
#line 563 "../lib/Widgets/TimePicker.vala"
							he_time_picker_clock_widget_get_accent_color (self, &_tmp64_);
#line 563 "../lib/Widgets/TimePicker.vala"
							_tmp65_ = _tmp64_;
#line 563 "../lib/Widgets/TimePicker.vala"
							_tmp63_ = 0.20 * _tmp65_.blue;
#line 2815 "TimePicker.c"
						} else {
#line 563 "../lib/Widgets/TimePicker.vala"
							_tmp63_ = 1.0;
#line 2819 "TimePicker.c"
						}
#line 563 "../lib/Widgets/TimePicker.vala"
						_tmp66_ = cr;
#line 563 "../lib/Widgets/TimePicker.vala"
						cairo_set_source_rgba (_tmp66_, _tmp57_, _tmp60_, _tmp63_, (gdouble) 1);
#line 564 "../lib/Widgets/TimePicker.vala"
						_tmp67_ = cr;
#line 564 "../lib/Widgets/TimePicker.vala"
						cairo_set_font_size (_tmp67_, (gdouble) HE_TIME_PICKER_CLOCK_WIDGET_MINUTE_FONT_SIZE);
#line 566 "../lib/Widgets/TimePicker.vala"
						if (i >= 6) {
#line 2831 "TimePicker.c"
							cairo_t* _tmp68_;
#line 567 "../lib/Widgets/TimePicker.vala"
							_tmp68_ = cr;
#line 567 "../lib/Widgets/TimePicker.vala"
							cairo_move_to (_tmp68_, minute_x - (18 / 2.0), minute_y + (16 / 2.0));
#line 2837 "TimePicker.c"
						} else {
#line 568 "../lib/Widgets/TimePicker.vala"
							if (i == 1) {
#line 2841 "TimePicker.c"
								cairo_t* _tmp69_;
#line 569 "../lib/Widgets/TimePicker.vala"
								_tmp69_ = cr;
#line 569 "../lib/Widgets/TimePicker.vala"
								cairo_move_to (_tmp69_, minute_x - (6 / 2.0), minute_y + (16 / 2.0));
#line 2847 "TimePicker.c"
							} else {
								cairo_t* _tmp70_;
#line 571 "../lib/Widgets/TimePicker.vala"
								_tmp70_ = cr;
#line 571 "../lib/Widgets/TimePicker.vala"
								cairo_move_to (_tmp70_, minute_x - (10 / 2.0), minute_y + (16 / 2.0));
#line 2854 "TimePicker.c"
							}
						}
#line 573 "../lib/Widgets/TimePicker.vala"
						_tmp71_ = cr;
#line 573 "../lib/Widgets/TimePicker.vala"
						_tmp72_ = g_strdup_printf ("%i", i);
#line 573 "../lib/Widgets/TimePicker.vala"
						_tmp73_ = _tmp72_;
#line 573 "../lib/Widgets/TimePicker.vala"
						cairo_show_text (_tmp71_, _tmp73_);
#line 573 "../lib/Widgets/TimePicker.vala"
						_g_free0 (_tmp73_);
#line 2867 "TimePicker.c"
					} else {
						gdouble _tmp74_ = 0.0;
						gdouble _tmp75_ = 0.0;
						gdouble _tmp76_ = 0.0;
						cairo_t* _tmp77_;
						GdkRGBA _tmp78_ = {0};
						GdkRGBA _tmp79_;
						GdkRGBA _tmp80_ = {0};
						GdkRGBA _tmp81_;
						GdkRGBA _tmp82_ = {0};
						GdkRGBA _tmp83_;
						cairo_t* _tmp84_;
						cairo_t* _tmp88_;
						gchar* _tmp89_;
						gchar* _tmp90_;
#line 575 "../lib/Widgets/TimePicker.vala"
						if (self->priv->is_dark) {
#line 575 "../lib/Widgets/TimePicker.vala"
							_tmp74_ = 0.99;
#line 2887 "TimePicker.c"
						} else {
#line 575 "../lib/Widgets/TimePicker.vala"
							_tmp74_ = 0.10;
#line 2891 "TimePicker.c"
						}
#line 575 "../lib/Widgets/TimePicker.vala"
						if (self->priv->is_dark) {
#line 575 "../lib/Widgets/TimePicker.vala"
							_tmp75_ = 0.99;
#line 2897 "TimePicker.c"
						} else {
#line 575 "../lib/Widgets/TimePicker.vala"
							_tmp75_ = 0.10;
#line 2901 "TimePicker.c"
						}
#line 575 "../lib/Widgets/TimePicker.vala"
						if (self->priv->is_dark) {
#line 575 "../lib/Widgets/TimePicker.vala"
							_tmp76_ = 0.99;
#line 2907 "TimePicker.c"
						} else {
#line 575 "../lib/Widgets/TimePicker.vala"
							_tmp76_ = 0.10;
#line 2911 "TimePicker.c"
						}
#line 575 "../lib/Widgets/TimePicker.vala"
						_tmp77_ = cr;
#line 575 "../lib/Widgets/TimePicker.vala"
						he_time_picker_clock_widget_get_accent_color (self, &_tmp78_);
#line 575 "../lib/Widgets/TimePicker.vala"
						_tmp79_ = _tmp78_;
#line 575 "../lib/Widgets/TimePicker.vala"
						he_time_picker_clock_widget_get_accent_color (self, &_tmp80_);
#line 575 "../lib/Widgets/TimePicker.vala"
						_tmp81_ = _tmp80_;
#line 575 "../lib/Widgets/TimePicker.vala"
						he_time_picker_clock_widget_get_accent_color (self, &_tmp82_);
#line 575 "../lib/Widgets/TimePicker.vala"
						_tmp83_ = _tmp82_;
#line 575 "../lib/Widgets/TimePicker.vala"
						cairo_set_source_rgba (_tmp77_, _tmp74_ * _tmp79_.red, _tmp75_ * _tmp81_.green, _tmp76_ * _tmp83_.blue, (gdouble) 1);
#line 576 "../lib/Widgets/TimePicker.vala"
						_tmp84_ = cr;
#line 576 "../lib/Widgets/TimePicker.vala"
						cairo_set_font_size (_tmp84_, (gdouble) HE_TIME_PICKER_CLOCK_WIDGET_MINUTE_FONT_SIZE);
#line 578 "../lib/Widgets/TimePicker.vala"
						if (i >= 6) {
#line 2935 "TimePicker.c"
							cairo_t* _tmp85_;
#line 579 "../lib/Widgets/TimePicker.vala"
							_tmp85_ = cr;
#line 579 "../lib/Widgets/TimePicker.vala"
							cairo_move_to (_tmp85_, minute_x - (18 / 2.0), minute_y + (16 / 2.0));
#line 2941 "TimePicker.c"
						} else {
#line 580 "../lib/Widgets/TimePicker.vala"
							if (i == 1) {
#line 2945 "TimePicker.c"
								cairo_t* _tmp86_;
#line 581 "../lib/Widgets/TimePicker.vala"
								_tmp86_ = cr;
#line 581 "../lib/Widgets/TimePicker.vala"
								cairo_move_to (_tmp86_, minute_x - (6 / 2.0), minute_y + (16 / 2.0));
#line 2951 "TimePicker.c"
							} else {
								cairo_t* _tmp87_;
#line 583 "../lib/Widgets/TimePicker.vala"
								_tmp87_ = cr;
#line 583 "../lib/Widgets/TimePicker.vala"
								cairo_move_to (_tmp87_, minute_x - (10 / 2.0), minute_y + (16 / 2.0));
#line 2958 "TimePicker.c"
							}
						}
#line 585 "../lib/Widgets/TimePicker.vala"
						_tmp88_ = cr;
#line 585 "../lib/Widgets/TimePicker.vala"
						_tmp89_ = g_strdup_printf ("%i", i);
#line 585 "../lib/Widgets/TimePicker.vala"
						_tmp90_ = _tmp89_;
#line 585 "../lib/Widgets/TimePicker.vala"
						cairo_show_text (_tmp88_, _tmp90_);
#line 585 "../lib/Widgets/TimePicker.vala"
						_g_free0 (_tmp90_);
#line 2971 "TimePicker.c"
					}
				}
			}
		}
	}
#line 591 "../lib/Widgets/TimePicker.vala"
	_tmp91_ = self->priv->_selecting_hour;
#line 591 "../lib/Widgets/TimePicker.vala"
	if (_tmp91_) {
#line 2981 "TimePicker.c"
		gint _tmp92_ = 0;
		gboolean _tmp93_;
		gint hour_count = 0;
#line 592 "../lib/Widgets/TimePicker.vala"
		_tmp93_ = self->priv->_is_military_mode;
#line 592 "../lib/Widgets/TimePicker.vala"
		if (_tmp93_) {
#line 592 "../lib/Widgets/TimePicker.vala"
			_tmp92_ = HE_TIME_PICKER_CLOCK_WIDGET_FULL_DAY;
#line 2991 "TimePicker.c"
		} else {
#line 592 "../lib/Widgets/TimePicker.vala"
			_tmp92_ = HE_TIME_PICKER_CLOCK_WIDGET_HALF_DAY;
#line 2995 "TimePicker.c"
		}
#line 592 "../lib/Widgets/TimePicker.vala"
		hour_count = _tmp92_;
#line 2999 "TimePicker.c"
		{
			gint i = 0;
#line 594 "../lib/Widgets/TimePicker.vala"
			i = 1;
#line 3004 "TimePicker.c"
			{
				gboolean _tmp94_ = FALSE;
#line 594 "../lib/Widgets/TimePicker.vala"
				_tmp94_ = TRUE;
#line 594 "../lib/Widgets/TimePicker.vala"
				while (TRUE) {
#line 3011 "TimePicker.c"
					gdouble hour_angle = 0.0;
					gdouble _tmp96_ = 0.0;
					gboolean _tmp97_ = FALSE;
					gdouble label_radius = 0.0;
					gdouble label_x = 0.0;
					gdouble label_y = 0.0;
					gdouble selection_angle = 0.0;
					gdouble label_angle = 0.0;
					gboolean is_selected = FALSE;
#line 594 "../lib/Widgets/TimePicker.vala"
					if (!_tmp94_) {
#line 3023 "TimePicker.c"
						gint _tmp95_;
#line 594 "../lib/Widgets/TimePicker.vala"
						_tmp95_ = i;
#line 594 "../lib/Widgets/TimePicker.vala"
						i = _tmp95_ + 1;
#line 3029 "TimePicker.c"
					}
#line 594 "../lib/Widgets/TimePicker.vala"
					_tmp94_ = FALSE;
#line 594 "../lib/Widgets/TimePicker.vala"
					if (!(i <= hour_count)) {
#line 594 "../lib/Widgets/TimePicker.vala"
						break;
#line 3037 "TimePicker.c"
					}
#line 595 "../lib/Widgets/TimePicker.vala"
					hour_angle = ((i - 3) * G_PI) / (HE_TIME_PICKER_CLOCK_WIDGET_HALF_DAY / 2);
#line 596 "../lib/Widgets/TimePicker.vala"
					if (i > HE_TIME_PICKER_CLOCK_WIDGET_HALF_DAY) {
#line 3043 "TimePicker.c"
						gboolean _tmp98_;
#line 596 "../lib/Widgets/TimePicker.vala"
						_tmp98_ = self->priv->_is_military_mode;
#line 596 "../lib/Widgets/TimePicker.vala"
						_tmp97_ = _tmp98_;
#line 3049 "TimePicker.c"
					} else {
#line 596 "../lib/Widgets/TimePicker.vala"
						_tmp97_ = FALSE;
#line 3053 "TimePicker.c"
					}
#line 596 "../lib/Widgets/TimePicker.vala"
					if (_tmp97_) {
#line 596 "../lib/Widgets/TimePicker.vala"
						_tmp96_ = HE_TIME_PICKER_CLOCK_WIDGET_INNER_RADIUS;
#line 3059 "TimePicker.c"
					} else {
#line 596 "../lib/Widgets/TimePicker.vala"
						_tmp96_ = HE_TIME_PICKER_CLOCK_WIDGET_OUTER_RADIUS;
#line 3063 "TimePicker.c"
					}
#line 596 "../lib/Widgets/TimePicker.vala"
					label_radius = _tmp96_;
#line 597 "../lib/Widgets/TimePicker.vala"
					label_x = HE_TIME_PICKER_CLOCK_WIDGET_CENTER + (label_radius * cos (hour_angle));
#line 598 "../lib/Widgets/TimePicker.vala"
					label_y = HE_TIME_PICKER_CLOCK_WIDGET_CENTER + (label_radius * sin (hour_angle));
#line 600 "../lib/Widgets/TimePicker.vala"
					selection_angle = he_time_picker_clock_widget_get_hour_angle (self);
#line 601 "../lib/Widgets/TimePicker.vala"
					if (selection_angle < ((-G_PI) / 2)) {
#line 602 "../lib/Widgets/TimePicker.vala"
						selection_angle += 2 * G_PI;
#line 3077 "TimePicker.c"
					}
#line 604 "../lib/Widgets/TimePicker.vala"
					label_angle = hour_angle;
#line 605 "../lib/Widgets/TimePicker.vala"
					if (label_angle < ((-G_PI) / 2)) {
#line 606 "../lib/Widgets/TimePicker.vala"
						label_angle += 2 * G_PI;
#line 3085 "TimePicker.c"
					}
#line 609 "../lib/Widgets/TimePicker.vala"
					is_selected = fabs (selection_angle - label_angle) < (G_PI / HE_TIME_PICKER_CLOCK_WIDGET_HALF_DAY);
#line 611 "../lib/Widgets/TimePicker.vala"
					if (is_selected) {
#line 3091 "TimePicker.c"
						gdouble _tmp99_ = 0.0;
						gdouble _tmp102_ = 0.0;
						gdouble _tmp105_ = 0.0;
						cairo_t* _tmp108_;
						gint _tmp114_ = 0;
						cairo_t* _tmp116_;
						gchar* _tmp117_;
						gchar* _tmp118_;
#line 612 "../lib/Widgets/TimePicker.vala"
						if (self->priv->is_dark) {
#line 3102 "TimePicker.c"
							GdkRGBA _tmp100_ = {0};
							GdkRGBA _tmp101_;
#line 612 "../lib/Widgets/TimePicker.vala"
							he_time_picker_clock_widget_get_accent_color (self, &_tmp100_);
#line 612 "../lib/Widgets/TimePicker.vala"
							_tmp101_ = _tmp100_;
#line 612 "../lib/Widgets/TimePicker.vala"
							_tmp99_ = 0.20 * _tmp101_.red;
#line 3111 "TimePicker.c"
						} else {
#line 612 "../lib/Widgets/TimePicker.vala"
							_tmp99_ = 1.0;
#line 3115 "TimePicker.c"
						}
#line 612 "../lib/Widgets/TimePicker.vala"
						if (self->priv->is_dark) {
#line 3119 "TimePicker.c"
							GdkRGBA _tmp103_ = {0};
							GdkRGBA _tmp104_;
#line 612 "../lib/Widgets/TimePicker.vala"
							he_time_picker_clock_widget_get_accent_color (self, &_tmp103_);
#line 612 "../lib/Widgets/TimePicker.vala"
							_tmp104_ = _tmp103_;
#line 612 "../lib/Widgets/TimePicker.vala"
							_tmp102_ = 0.20 * _tmp104_.green;
#line 3128 "TimePicker.c"
						} else {
#line 612 "../lib/Widgets/TimePicker.vala"
							_tmp102_ = 1.0;
#line 3132 "TimePicker.c"
						}
#line 612 "../lib/Widgets/TimePicker.vala"
						if (self->priv->is_dark) {
#line 3136 "TimePicker.c"
							GdkRGBA _tmp106_ = {0};
							GdkRGBA _tmp107_;
#line 612 "../lib/Widgets/TimePicker.vala"
							he_time_picker_clock_widget_get_accent_color (self, &_tmp106_);
#line 612 "../lib/Widgets/TimePicker.vala"
							_tmp107_ = _tmp106_;
#line 612 "../lib/Widgets/TimePicker.vala"
							_tmp105_ = 0.20 * _tmp107_.blue;
#line 3145 "TimePicker.c"
						} else {
#line 612 "../lib/Widgets/TimePicker.vala"
							_tmp105_ = 1.0;
#line 3149 "TimePicker.c"
						}
#line 612 "../lib/Widgets/TimePicker.vala"
						_tmp108_ = cr;
#line 612 "../lib/Widgets/TimePicker.vala"
						cairo_set_source_rgba (_tmp108_, _tmp99_, _tmp102_, _tmp105_, (gdouble) 1);
#line 613 "../lib/Widgets/TimePicker.vala"
						if (i >= 10) {
#line 3157 "TimePicker.c"
							cairo_t* _tmp109_;
#line 614 "../lib/Widgets/TimePicker.vala"
							_tmp109_ = cr;
#line 614 "../lib/Widgets/TimePicker.vala"
							cairo_move_to (_tmp109_, label_x - (18 / 2.0), label_y + (16 / 2.0));
#line 3163 "TimePicker.c"
						} else {
#line 615 "../lib/Widgets/TimePicker.vala"
							if (i == 1) {
#line 3167 "TimePicker.c"
								cairo_t* _tmp110_;
#line 616 "../lib/Widgets/TimePicker.vala"
								_tmp110_ = cr;
#line 616 "../lib/Widgets/TimePicker.vala"
								cairo_move_to (_tmp110_, label_x - (6 / 2.0), label_y + (16 / 2.0));
#line 3173 "TimePicker.c"
							} else {
								cairo_t* _tmp111_;
#line 618 "../lib/Widgets/TimePicker.vala"
								_tmp111_ = cr;
#line 618 "../lib/Widgets/TimePicker.vala"
								cairo_move_to (_tmp111_, label_x - (10 / 2.0), label_y + (16 / 2.0));
#line 3180 "TimePicker.c"
							}
						}
#line 621 "../lib/Widgets/TimePicker.vala"
						if (i <= HE_TIME_PICKER_CLOCK_WIDGET_HALF_DAY) {
#line 3185 "TimePicker.c"
							cairo_t* _tmp112_;
#line 622 "../lib/Widgets/TimePicker.vala"
							_tmp112_ = cr;
#line 622 "../lib/Widgets/TimePicker.vala"
							cairo_set_font_size (_tmp112_, (gdouble) HE_TIME_PICKER_CLOCK_WIDGET_HOUR_FONT_SIZE);
#line 3191 "TimePicker.c"
						} else {
							cairo_t* _tmp113_;
#line 624 "../lib/Widgets/TimePicker.vala"
							_tmp113_ = cr;
#line 624 "../lib/Widgets/TimePicker.vala"
							cairo_set_font_size (_tmp113_, (gdouble) HE_TIME_PICKER_CLOCK_WIDGET_MINUTE_FONT_SIZE);
#line 3198 "TimePicker.c"
						}
#line 630 "../lib/Widgets/TimePicker.vala"
						if (i > HE_TIME_PICKER_CLOCK_WIDGET_HALF_DAY) {
#line 3202 "TimePicker.c"
							gint _tmp115_ = 0;
#line 630 "../lib/Widgets/TimePicker.vala"
							if (i == 24) {
#line 630 "../lib/Widgets/TimePicker.vala"
								_tmp115_ = 0;
#line 3208 "TimePicker.c"
							} else {
#line 630 "../lib/Widgets/TimePicker.vala"
								_tmp115_ = i;
#line 3212 "TimePicker.c"
							}
#line 630 "../lib/Widgets/TimePicker.vala"
							_tmp114_ = _tmp115_;
#line 3216 "TimePicker.c"
						} else {
#line 630 "../lib/Widgets/TimePicker.vala"
							_tmp114_ = i;
#line 3220 "TimePicker.c"
						}
#line 630 "../lib/Widgets/TimePicker.vala"
						_tmp116_ = cr;
#line 630 "../lib/Widgets/TimePicker.vala"
						_tmp117_ = g_strdup_printf ("%i", _tmp114_);
#line 630 "../lib/Widgets/TimePicker.vala"
						_tmp118_ = _tmp117_;
#line 630 "../lib/Widgets/TimePicker.vala"
						cairo_show_text (_tmp116_, _tmp118_);
#line 630 "../lib/Widgets/TimePicker.vala"
						_g_free0 (_tmp118_);
#line 3232 "TimePicker.c"
					} else {
						gdouble _tmp119_ = 0.0;
						gdouble _tmp120_ = 0.0;
						gdouble _tmp121_ = 0.0;
						cairo_t* _tmp122_;
						GdkRGBA _tmp123_ = {0};
						GdkRGBA _tmp124_;
						GdkRGBA _tmp125_ = {0};
						GdkRGBA _tmp126_;
						GdkRGBA _tmp127_ = {0};
						GdkRGBA _tmp128_;
						gint _tmp134_ = 0;
						cairo_t* _tmp136_;
						gchar* _tmp137_;
						gchar* _tmp138_;
#line 632 "../lib/Widgets/TimePicker.vala"
						if (self->priv->is_dark) {
#line 632 "../lib/Widgets/TimePicker.vala"
							_tmp119_ = 0.99;
#line 3252 "TimePicker.c"
						} else {
#line 632 "../lib/Widgets/TimePicker.vala"
							_tmp119_ = 0.10;
#line 3256 "TimePicker.c"
						}
#line 632 "../lib/Widgets/TimePicker.vala"
						if (self->priv->is_dark) {
#line 632 "../lib/Widgets/TimePicker.vala"
							_tmp120_ = 0.99;
#line 3262 "TimePicker.c"
						} else {
#line 632 "../lib/Widgets/TimePicker.vala"
							_tmp120_ = 0.10;
#line 3266 "TimePicker.c"
						}
#line 632 "../lib/Widgets/TimePicker.vala"
						if (self->priv->is_dark) {
#line 632 "../lib/Widgets/TimePicker.vala"
							_tmp121_ = 0.99;
#line 3272 "TimePicker.c"
						} else {
#line 632 "../lib/Widgets/TimePicker.vala"
							_tmp121_ = 0.10;
#line 3276 "TimePicker.c"
						}
#line 632 "../lib/Widgets/TimePicker.vala"
						_tmp122_ = cr;
#line 632 "../lib/Widgets/TimePicker.vala"
						he_time_picker_clock_widget_get_accent_color (self, &_tmp123_);
#line 632 "../lib/Widgets/TimePicker.vala"
						_tmp124_ = _tmp123_;
#line 632 "../lib/Widgets/TimePicker.vala"
						he_time_picker_clock_widget_get_accent_color (self, &_tmp125_);
#line 632 "../lib/Widgets/TimePicker.vala"
						_tmp126_ = _tmp125_;
#line 632 "../lib/Widgets/TimePicker.vala"
						he_time_picker_clock_widget_get_accent_color (self, &_tmp127_);
#line 632 "../lib/Widgets/TimePicker.vala"
						_tmp128_ = _tmp127_;
#line 632 "../lib/Widgets/TimePicker.vala"
						cairo_set_source_rgba (_tmp122_, _tmp119_ * _tmp124_.red, _tmp120_ * _tmp126_.green, _tmp121_ * _tmp128_.blue, (gdouble) 1);
#line 633 "../lib/Widgets/TimePicker.vala"
						if (i >= 10) {
#line 3296 "TimePicker.c"
							cairo_t* _tmp129_;
#line 634 "../lib/Widgets/TimePicker.vala"
							_tmp129_ = cr;
#line 634 "../lib/Widgets/TimePicker.vala"
							cairo_move_to (_tmp129_, label_x - (18 / 2.0), label_y + (16 / 2.0));
#line 3302 "TimePicker.c"
						} else {
#line 635 "../lib/Widgets/TimePicker.vala"
							if (i == 1) {
#line 3306 "TimePicker.c"
								cairo_t* _tmp130_;
#line 636 "../lib/Widgets/TimePicker.vala"
								_tmp130_ = cr;
#line 636 "../lib/Widgets/TimePicker.vala"
								cairo_move_to (_tmp130_, label_x - (6 / 2.0), label_y + (16 / 2.0));
#line 3312 "TimePicker.c"
							} else {
								cairo_t* _tmp131_;
#line 638 "../lib/Widgets/TimePicker.vala"
								_tmp131_ = cr;
#line 638 "../lib/Widgets/TimePicker.vala"
								cairo_move_to (_tmp131_, label_x - (10 / 2.0), label_y + (16 / 2.0));
#line 3319 "TimePicker.c"
							}
						}
#line 641 "../lib/Widgets/TimePicker.vala"
						if (i <= HE_TIME_PICKER_CLOCK_WIDGET_HALF_DAY) {
#line 3324 "TimePicker.c"
							cairo_t* _tmp132_;
#line 642 "../lib/Widgets/TimePicker.vala"
							_tmp132_ = cr;
#line 642 "../lib/Widgets/TimePicker.vala"
							cairo_set_font_size (_tmp132_, (gdouble) HE_TIME_PICKER_CLOCK_WIDGET_HOUR_FONT_SIZE);
#line 3330 "TimePicker.c"
						} else {
							cairo_t* _tmp133_;
#line 644 "../lib/Widgets/TimePicker.vala"
							_tmp133_ = cr;
#line 644 "../lib/Widgets/TimePicker.vala"
							cairo_set_font_size (_tmp133_, (gdouble) HE_TIME_PICKER_CLOCK_WIDGET_MINUTE_FONT_SIZE);
#line 3337 "TimePicker.c"
						}
#line 650 "../lib/Widgets/TimePicker.vala"
						if (i > HE_TIME_PICKER_CLOCK_WIDGET_HALF_DAY) {
#line 3341 "TimePicker.c"
							gint _tmp135_ = 0;
#line 650 "../lib/Widgets/TimePicker.vala"
							if (i == 24) {
#line 650 "../lib/Widgets/TimePicker.vala"
								_tmp135_ = 0;
#line 3347 "TimePicker.c"
							} else {
#line 650 "../lib/Widgets/TimePicker.vala"
								_tmp135_ = i;
#line 3351 "TimePicker.c"
							}
#line 650 "../lib/Widgets/TimePicker.vala"
							_tmp134_ = _tmp135_;
#line 3355 "TimePicker.c"
						} else {
#line 650 "../lib/Widgets/TimePicker.vala"
							_tmp134_ = i;
#line 3359 "TimePicker.c"
						}
#line 650 "../lib/Widgets/TimePicker.vala"
						_tmp136_ = cr;
#line 650 "../lib/Widgets/TimePicker.vala"
						_tmp137_ = g_strdup_printf ("%i", _tmp134_);
#line 650 "../lib/Widgets/TimePicker.vala"
						_tmp138_ = _tmp137_;
#line 650 "../lib/Widgets/TimePicker.vala"
						cairo_show_text (_tmp136_, _tmp138_);
#line 650 "../lib/Widgets/TimePicker.vala"
						_g_free0 (_tmp138_);
#line 3371 "TimePicker.c"
					}
				}
			}
		}
	}
#line 514 "../lib/Widgets/TimePicker.vala"
	_cairo_destroy0 (cr);
#line 3379 "TimePicker.c"
}

static void
he_time_picker_clock_widget_update_style_manager (HeTimePickerClockWidget* self)
{
	HeDesktop* _tmp0_;
	HeRGBColor* _tmp1_;
	HeRGBColor* _tmp2_;
#line 656 "../lib/Widgets/TimePicker.vala"
	g_return_if_fail (self != NULL);
#line 657 "../lib/Widgets/TimePicker.vala"
	_tmp0_ = self->priv->desktop;
#line 657 "../lib/Widgets/TimePicker.vala"
	_tmp1_ = he_desktop_get_accent_color (_tmp0_);
#line 657 "../lib/Widgets/TimePicker.vala"
	_tmp2_ = _tmp1_;
#line 657 "../lib/Widgets/TimePicker.vala"
	if (_tmp2_ != NULL) {
#line 3398 "TimePicker.c"
		HeDesktop* _tmp3_;
		HeRGBColor* _tmp4_;
		HeRGBColor* _tmp5_;
		HeDesktop* _tmp6_;
		HeRGBColor* _tmp7_;
		HeRGBColor* _tmp8_;
		HeDesktop* _tmp9_;
		HeRGBColor* _tmp10_;
		HeRGBColor* _tmp11_;
		GdkRGBA _tmp12_ = {0};
#line 658 "../lib/Widgets/TimePicker.vala"
		_tmp3_ = self->priv->desktop;
#line 658 "../lib/Widgets/TimePicker.vala"
		_tmp4_ = he_desktop_get_accent_color (_tmp3_);
#line 658 "../lib/Widgets/TimePicker.vala"
		_tmp5_ = _tmp4_;
#line 658 "../lib/Widgets/TimePicker.vala"
		_tmp6_ = self->priv->desktop;
#line 658 "../lib/Widgets/TimePicker.vala"
		_tmp7_ = he_desktop_get_accent_color (_tmp6_);
#line 658 "../lib/Widgets/TimePicker.vala"
		_tmp8_ = _tmp7_;
#line 658 "../lib/Widgets/TimePicker.vala"
		_tmp9_ = self->priv->desktop;
#line 658 "../lib/Widgets/TimePicker.vala"
		_tmp10_ = he_desktop_get_accent_color (_tmp9_);
#line 658 "../lib/Widgets/TimePicker.vala"
		_tmp11_ = _tmp10_;
#line 658 "../lib/Widgets/TimePicker.vala"
		_tmp12_.red = (gfloat) (*_tmp5_).r;
#line 658 "../lib/Widgets/TimePicker.vala"
		_tmp12_.green = (gfloat) (*_tmp8_).g;
#line 658 "../lib/Widgets/TimePicker.vala"
		_tmp12_.blue = (gfloat) (*_tmp11_).b;
#line 658 "../lib/Widgets/TimePicker.vala"
		_tmp12_.alpha = (gfloat) 1;
#line 658 "../lib/Widgets/TimePicker.vala"
		he_time_picker_clock_widget_set_accent_color (self, &_tmp12_);
#line 3437 "TimePicker.c"
	}
}

static void
he_time_picker_clock_widget_emit_time_selected (HeTimePickerClockWidget* self)
{
#line 667 "../lib/Widgets/TimePicker.vala"
	g_return_if_fail (self != NULL);
#line 668 "../lib/Widgets/TimePicker.vala"
	g_signal_emit (self, he_time_picker_clock_widget_signals[HE_TIME_PICKER_CLOCK_WIDGET_TIME_SELECTED_SIGNAL], 0, self->priv->selected_hour, self->priv->selected_minute);
#line 3448 "TimePicker.c"
}

static void
he_time_picker_clock_widget_reset_to_hour_selection (HeTimePickerClockWidget* self)
{
#line 671 "../lib/Widgets/TimePicker.vala"
	g_return_if_fail (self != NULL);
#line 672 "../lib/Widgets/TimePicker.vala"
	he_time_picker_clock_widget_set_selecting_hour (self, TRUE);
#line 673 "../lib/Widgets/TimePicker.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 3460 "TimePicker.c"
}

static gdouble
he_time_picker_clock_widget_get_hour_angle (HeTimePickerClockWidget* self)
{
	gdouble hour = 0.0;
	gdouble angle = 0.0;
	gdouble result;
#line 676 "../lib/Widgets/TimePicker.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 677 "../lib/Widgets/TimePicker.vala"
	hour = (gdouble) (self->priv->selected_hour % HE_TIME_PICKER_CLOCK_WIDGET_HALF_DAY);
#line 678 "../lib/Widgets/TimePicker.vala"
	if (hour == ((gdouble) 0)) {
#line 678 "../lib/Widgets/TimePicker.vala"
		hour = (gdouble) HE_TIME_PICKER_CLOCK_WIDGET_HALF_DAY;
#line 3477 "TimePicker.c"
	}
#line 679 "../lib/Widgets/TimePicker.vala"
	angle = (hour * ((2 * G_PI) / HE_TIME_PICKER_CLOCK_WIDGET_HALF_DAY)) - (G_PI / 2);
#line 680 "../lib/Widgets/TimePicker.vala"
	result = angle;
#line 680 "../lib/Widgets/TimePicker.vala"
	return result;
#line 3485 "TimePicker.c"
}

static gdouble
he_time_picker_clock_widget_get_minute_angle (HeTimePickerClockWidget* self)
{
	gdouble result;
#line 683 "../lib/Widgets/TimePicker.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 684 "../lib/Widgets/TimePicker.vala"
	result = ((self->priv->selected_minute % HE_TIME_PICKER_CLOCK_WIDGET_MINUTES) * ((2 * G_PI) / HE_TIME_PICKER_CLOCK_WIDGET_MINUTES)) - (G_PI / 2);
#line 684 "../lib/Widgets/TimePicker.vala"
	return result;
#line 3498 "TimePicker.c"
}

static gdouble
he_time_picker_clock_widget_get_hand_radius (HeTimePickerClockWidget* self,
                                             gdouble base_radius)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_;
	gdouble result;
#line 687 "../lib/Widgets/TimePicker.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 688 "../lib/Widgets/TimePicker.vala"
	_tmp2_ = self->priv->_selecting_hour;
#line 688 "../lib/Widgets/TimePicker.vala"
	if (_tmp2_) {
#line 3515 "TimePicker.c"
		gboolean _tmp3_;
#line 688 "../lib/Widgets/TimePicker.vala"
		_tmp3_ = self->priv->_is_military_mode;
#line 688 "../lib/Widgets/TimePicker.vala"
		_tmp1_ = _tmp3_;
#line 3521 "TimePicker.c"
	} else {
#line 688 "../lib/Widgets/TimePicker.vala"
		_tmp1_ = FALSE;
#line 3525 "TimePicker.c"
	}
#line 688 "../lib/Widgets/TimePicker.vala"
	if (_tmp1_) {
#line 688 "../lib/Widgets/TimePicker.vala"
		_tmp0_ = self->priv->selected_hour > HE_TIME_PICKER_CLOCK_WIDGET_HALF_DAY;
#line 3531 "TimePicker.c"
	} else {
#line 688 "../lib/Widgets/TimePicker.vala"
		_tmp0_ = FALSE;
#line 3535 "TimePicker.c"
	}
#line 688 "../lib/Widgets/TimePicker.vala"
	if (_tmp0_) {
#line 689 "../lib/Widgets/TimePicker.vala"
		result = HE_TIME_PICKER_CLOCK_WIDGET_INNER_RADIUS;
#line 689 "../lib/Widgets/TimePicker.vala"
		return result;
#line 3543 "TimePicker.c"
	} else {
#line 691 "../lib/Widgets/TimePicker.vala"
		result = HE_TIME_PICKER_CLOCK_WIDGET_OUTER_RADIUS;
#line 691 "../lib/Widgets/TimePicker.vala"
		return result;
#line 3549 "TimePicker.c"
	}
}

static void
he_time_picker_clock_widget_update_selection (HeTimePickerClockWidget* self,
                                              gdouble x,
                                              gdouble y)
{
	gdouble dx = 0.0;
	gdouble dy = 0.0;
	gdouble distance = 0.0;
	gdouble angle = 0.0;
	gboolean _tmp0_;
#line 695 "../lib/Widgets/TimePicker.vala"
	g_return_if_fail (self != NULL);
#line 696 "../lib/Widgets/TimePicker.vala"
	dx = x - HE_TIME_PICKER_CLOCK_WIDGET_CENTER;
#line 697 "../lib/Widgets/TimePicker.vala"
	dy = y - HE_TIME_PICKER_CLOCK_WIDGET_CENTER;
#line 699 "../lib/Widgets/TimePicker.vala"
	distance = sqrt ((dx * dx) + (dy * dy));
#line 700 "../lib/Widgets/TimePicker.vala"
	angle = atan2 (dy, dx) + (G_PI / 2);
#line 701 "../lib/Widgets/TimePicker.vala"
	if (angle < ((gdouble) 0)) {
#line 702 "../lib/Widgets/TimePicker.vala"
		angle += 2 * G_PI;
#line 3577 "TimePicker.c"
	}
#line 705 "../lib/Widgets/TimePicker.vala"
	_tmp0_ = self->priv->_selecting_hour;
#line 705 "../lib/Widgets/TimePicker.vala"
	if (_tmp0_) {
#line 3583 "TimePicker.c"
		gint temp_hour = 0;
		gboolean _tmp1_;
#line 706 "../lib/Widgets/TimePicker.vala"
		temp_hour = (gint) round ((angle * HE_TIME_PICKER_CLOCK_WIDGET_HALF_DAY) / (2 * G_PI));
#line 707 "../lib/Widgets/TimePicker.vala"
		if (temp_hour <= 0) {
#line 707 "../lib/Widgets/TimePicker.vala"
			temp_hour += HE_TIME_PICKER_CLOCK_WIDGET_HALF_DAY;
#line 3592 "TimePicker.c"
		}
#line 708 "../lib/Widgets/TimePicker.vala"
		_tmp1_ = self->priv->_is_military_mode;
#line 708 "../lib/Widgets/TimePicker.vala"
		if (_tmp1_) {
#line 709 "../lib/Widgets/TimePicker.vala"
			if (distance < HE_TIME_PICKER_CLOCK_WIDGET_INNER_RADIUS) {
#line 710 "../lib/Widgets/TimePicker.vala"
				temp_hour += HE_TIME_PICKER_CLOCK_WIDGET_HALF_DAY;
#line 3602 "TimePicker.c"
			}
		}
#line 713 "../lib/Widgets/TimePicker.vala"
		self->priv->selected_hour = temp_hour;
#line 3607 "TimePicker.c"
	} else {
#line 715 "../lib/Widgets/TimePicker.vala"
		self->priv->selected_minute = ((gint) round ((angle * HE_TIME_PICKER_CLOCK_WIDGET_MINUTES) / (2 * G_PI))) % HE_TIME_PICKER_CLOCK_WIDGET_MINUTES;
#line 716 "../lib/Widgets/TimePicker.vala"
		if (self->priv->selected_minute < 0) {
#line 716 "../lib/Widgets/TimePicker.vala"
			self->priv->selected_minute = self->priv->selected_minute + HE_TIME_PICKER_CLOCK_WIDGET_MINUTES;
#line 3615 "TimePicker.c"
		}
	}
#line 719 "../lib/Widgets/TimePicker.vala"
	self->priv->last_angle = angle;
#line 721 "../lib/Widgets/TimePicker.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 3622 "TimePicker.c"
}

static gdouble
he_time_picker_clock_widget_get_angle_from_coords (HeTimePickerClockWidget* self,
                                                   gdouble x,
                                                   gdouble y)
{
	gdouble angle = 0.0;
	gdouble result;
#line 724 "../lib/Widgets/TimePicker.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 725 "../lib/Widgets/TimePicker.vala"
	angle = atan2 (y - HE_TIME_PICKER_CLOCK_WIDGET_CENTER, x - HE_TIME_PICKER_CLOCK_WIDGET_CENTER);
#line 726 "../lib/Widgets/TimePicker.vala"
	if (angle < ((-G_PI) / 2)) {
#line 727 "../lib/Widgets/TimePicker.vala"
		angle += 2 * G_PI;
#line 3640 "TimePicker.c"
	}
#line 730 "../lib/Widgets/TimePicker.vala"
	result = angle;
#line 730 "../lib/Widgets/TimePicker.vala"
	return result;
#line 3646 "TimePicker.c"
}

static Block14Data*
block14_data_ref (Block14Data* _data14_)
{
#line 479 "../lib/Widgets/TimePicker.vala"
	g_atomic_int_inc (&_data14_->_ref_count_);
#line 479 "../lib/Widgets/TimePicker.vala"
	return _data14_;
#line 3656 "TimePicker.c"
}

static void
block14_data_unref (void * _userdata_)
{
	Block14Data* _data14_;
	_data14_ = (Block14Data*) _userdata_;
#line 479 "../lib/Widgets/TimePicker.vala"
	if (g_atomic_int_dec_and_test (&_data14_->_ref_count_)) {
#line 3666 "TimePicker.c"
		HeTimePickerClockWidget* self;
#line 479 "../lib/Widgets/TimePicker.vala"
		self = _data14_->self;
#line 479 "../lib/Widgets/TimePicker.vala"
		_g_object_unref0 (_data14_->drag_gesture);
#line 479 "../lib/Widgets/TimePicker.vala"
		_g_object_unref0 (self);
#line 479 "../lib/Widgets/TimePicker.vala"
		g_slice_free (Block14Data, _data14_);
#line 3676 "TimePicker.c"
	}
}

static void
_he_time_picker_clock_widget___lambda176_ (HeTimePickerClockWidget* self,
                                           gint n_press,
                                           gdouble x,
                                           gdouble y)
{
#line 482 "../lib/Widgets/TimePicker.vala"
	self->priv->last_angle = he_time_picker_clock_widget_get_angle_from_coords (self, x, y);
#line 3688 "TimePicker.c"
}

static void
__he_time_picker_clock_widget___lambda176__gtk_gesture_click_pressed (GtkGestureClick* _sender,
                                                                      gint n_press,
                                                                      gdouble x,
                                                                      gdouble y,
                                                                      gpointer self)
{
#line 481 "../lib/Widgets/TimePicker.vala"
	_he_time_picker_clock_widget___lambda176_ ((HeTimePickerClockWidget*) self, n_press, x, y);
#line 3700 "TimePicker.c"
}

static void
_he_time_picker_clock_widget___lambda177_ (HeTimePickerClockWidget* self)
{
	gboolean _tmp0_;
#line 485 "../lib/Widgets/TimePicker.vala"
	_tmp0_ = self->priv->_selecting_hour;
#line 485 "../lib/Widgets/TimePicker.vala"
	if (_tmp0_) {
#line 486 "../lib/Widgets/TimePicker.vala"
		he_time_picker_clock_widget_set_selecting_hour (self, FALSE);
#line 487 "../lib/Widgets/TimePicker.vala"
		gtk_widget_queue_draw ((GtkWidget*) self);
#line 3715 "TimePicker.c"
	} else {
#line 489 "../lib/Widgets/TimePicker.vala"
		he_time_picker_clock_widget_emit_time_selected (self);
#line 490 "../lib/Widgets/TimePicker.vala"
		he_time_picker_clock_widget_reset_to_hour_selection (self);
#line 3721 "TimePicker.c"
	}
}

static void
__he_time_picker_clock_widget___lambda177__gtk_gesture_click_released (GtkGestureClick* _sender,
                                                                       gint n_press,
                                                                       gdouble x,
                                                                       gdouble y,
                                                                       gpointer self)
{
#line 484 "../lib/Widgets/TimePicker.vala"
	_he_time_picker_clock_widget___lambda177_ ((HeTimePickerClockWidget*) self);
#line 3734 "TimePicker.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 493 "../lib/Widgets/TimePicker.vala"
	return self ? g_object_ref (self) : NULL;
#line 3742 "TimePicker.c"
}

static void
_he_time_picker_clock_widget___lambda178_ (Block14Data* _data14_,
                                           gdouble offset_x,
                                           gdouble offset_y)
{
	HeTimePickerClockWidget* self;
	gdouble x = 0.0;
	gdouble y = 0.0;
	GtkGestureDrag* _tmp0_;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
#line 496 "../lib/Widgets/TimePicker.vala"
	self = _data14_->self;
#line 498 "../lib/Widgets/TimePicker.vala"
	_tmp0_ = _data14_->drag_gesture;
#line 498 "../lib/Widgets/TimePicker.vala"
	gtk_gesture_get_bounding_box_center ((GtkGesture*) _tmp0_, &_tmp1_, &_tmp2_);
#line 498 "../lib/Widgets/TimePicker.vala"
	x = _tmp1_;
#line 498 "../lib/Widgets/TimePicker.vala"
	y = _tmp2_;
#line 499 "../lib/Widgets/TimePicker.vala"
	he_time_picker_clock_widget_update_selection (self, x, y);
#line 3768 "TimePicker.c"
}

static void
__he_time_picker_clock_widget___lambda178__gtk_gesture_drag_drag_update (GtkGestureDrag* _sender,
                                                                         gdouble offset_x,
                                                                         gdouble offset_y,
                                                                         gpointer self)
{
#line 496 "../lib/Widgets/TimePicker.vala"
	_he_time_picker_clock_widget___lambda178_ (self, offset_x, offset_y);
#line 3779 "TimePicker.c"
}

static GObject *
he_time_picker_clock_widget_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	HeTimePickerClockWidget * self;
	Block14Data* _data14_;
	GtkGestureClick* click_gesture = NULL;
	GtkGestureClick* _tmp0_;
	GtkGestureClick* _tmp1_;
	GtkGestureClick* _tmp2_;
	GtkGestureClick* _tmp3_;
	GtkEventController* _tmp4_;
	GtkGestureDrag* _tmp5_;
	GtkGestureDrag* _tmp6_;
	GtkGestureDrag* _tmp7_;
	GtkEventController* _tmp8_;
#line 479 "../lib/Widgets/TimePicker.vala"
	parent_class = G_OBJECT_CLASS (he_time_picker_clock_widget_parent_class);
#line 479 "../lib/Widgets/TimePicker.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 479 "../lib/Widgets/TimePicker.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TIME_PICKER_TYPE_CLOCK_WIDGET, HeTimePickerClockWidget);
#line 479 "../lib/Widgets/TimePicker.vala"
	_data14_ = g_slice_new0 (Block14Data);
#line 479 "../lib/Widgets/TimePicker.vala"
	_data14_->_ref_count_ = 1;
#line 479 "../lib/Widgets/TimePicker.vala"
	_data14_->self = g_object_ref (self);
#line 480 "../lib/Widgets/TimePicker.vala"
	_tmp0_ = (GtkGestureClick*) gtk_gesture_click_new ();
#line 480 "../lib/Widgets/TimePicker.vala"
	click_gesture = _tmp0_;
#line 481 "../lib/Widgets/TimePicker.vala"
	_tmp1_ = click_gesture;
#line 481 "../lib/Widgets/TimePicker.vala"
	g_signal_connect_object (_tmp1_, "pressed", (GCallback) __he_time_picker_clock_widget___lambda176__gtk_gesture_click_pressed, self, 0);
#line 484 "../lib/Widgets/TimePicker.vala"
	_tmp2_ = click_gesture;
#line 484 "../lib/Widgets/TimePicker.vala"
	g_signal_connect_object (_tmp2_, "released", (GCallback) __he_time_picker_clock_widget___lambda177__gtk_gesture_click_released, self, 0);
#line 493 "../lib/Widgets/TimePicker.vala"
	_tmp3_ = click_gesture;
#line 493 "../lib/Widgets/TimePicker.vala"
	_tmp4_ = _g_object_ref0 ((GtkEventController*) _tmp3_);
#line 493 "../lib/Widgets/TimePicker.vala"
	gtk_widget_add_controller ((GtkWidget*) self, _tmp4_);
#line 495 "../lib/Widgets/TimePicker.vala"
	_tmp5_ = (GtkGestureDrag*) gtk_gesture_drag_new ();
#line 495 "../lib/Widgets/TimePicker.vala"
	_data14_->drag_gesture = _tmp5_;
#line 496 "../lib/Widgets/TimePicker.vala"
	_tmp6_ = _data14_->drag_gesture;
#line 496 "../lib/Widgets/TimePicker.vala"
	g_signal_connect_data (_tmp6_, "drag-update", (GCallback) __he_time_picker_clock_widget___lambda178__gtk_gesture_drag_drag_update, block14_data_ref (_data14_), (GClosureNotify) block14_data_unref, 0);
#line 501 "../lib/Widgets/TimePicker.vala"
	_tmp7_ = _data14_->drag_gesture;
#line 501 "../lib/Widgets/TimePicker.vala"
	_tmp8_ = _g_object_ref0 ((GtkEventController*) _tmp7_);
#line 501 "../lib/Widgets/TimePicker.vala"
	gtk_widget_add_controller ((GtkWidget*) self, _tmp8_);
#line 503 "../lib/Widgets/TimePicker.vala"
	gtk_widget_set_hexpand ((GtkWidget*) self, TRUE);
#line 504 "../lib/Widgets/TimePicker.vala"
	gtk_widget_set_vexpand ((GtkWidget*) self, TRUE);
#line 505 "../lib/Widgets/TimePicker.vala"
	g_object_set ((GtkWidget*) self, "width-request", (gint) HE_TIME_PICKER_CLOCK_WIDGET_SIZE, NULL);
#line 506 "../lib/Widgets/TimePicker.vala"
	g_object_set ((GtkWidget*) self, "height-request", (gint) HE_TIME_PICKER_CLOCK_WIDGET_SIZE, NULL);
#line 479 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (click_gesture);
#line 479 "../lib/Widgets/TimePicker.vala"
	block14_data_unref (_data14_);
#line 479 "../lib/Widgets/TimePicker.vala"
	_data14_ = NULL;
#line 479 "../lib/Widgets/TimePicker.vala"
	return obj;
#line 3861 "TimePicker.c"
}

static void
he_time_picker_clock_widget_class_init (HeTimePickerClockWidgetClass * klass,
                                        gpointer klass_data)
{
#line 422 "../lib/Widgets/TimePicker.vala"
	he_time_picker_clock_widget_parent_class = g_type_class_peek_parent (klass);
#line 422 "../lib/Widgets/TimePicker.vala"
	g_type_class_adjust_private_offset (klass, &HeTimePickerClockWidget_private_offset);
#line 422 "../lib/Widgets/TimePicker.vala"
	((GObjectClass *) klass)->dispose = (void (*) (GObject*)) he_time_picker_clock_widget_real_dispose;
#line 422 "../lib/Widgets/TimePicker.vala"
	((GtkWidgetClass *) klass)->snapshot = (void (*) (GtkWidget*, GtkSnapshot*)) he_time_picker_clock_widget_real_snapshot;
#line 422 "../lib/Widgets/TimePicker.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_he_time_picker_clock_widget_get_property;
#line 422 "../lib/Widgets/TimePicker.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_he_time_picker_clock_widget_set_property;
#line 422 "../lib/Widgets/TimePicker.vala"
	G_OBJECT_CLASS (klass)->constructor = he_time_picker_clock_widget_constructor;
#line 422 "../lib/Widgets/TimePicker.vala"
	G_OBJECT_CLASS (klass)->finalize = he_time_picker_clock_widget_finalize;
#line 422 "../lib/Widgets/TimePicker.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_TIME_PICKER_CLOCK_WIDGET_SELECTING_HOUR_PROPERTY, he_time_picker_clock_widget_properties[HE_TIME_PICKER_CLOCK_WIDGET_SELECTING_HOUR_PROPERTY] = g_param_spec_boolean ("selecting-hour", "selecting-hour", "selecting-hour", TRUE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 422 "../lib/Widgets/TimePicker.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_TIME_PICKER_CLOCK_WIDGET_IS_MILITARY_MODE_PROPERTY, he_time_picker_clock_widget_properties[HE_TIME_PICKER_CLOCK_WIDGET_IS_MILITARY_MODE_PROPERTY] = g_param_spec_boolean ("is-military-mode", "is-military-mode", "is-military-mode", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 422 "../lib/Widgets/TimePicker.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_TIME_PICKER_CLOCK_WIDGET_ACCENT_COLOR_PROPERTY, he_time_picker_clock_widget_properties[HE_TIME_PICKER_CLOCK_WIDGET_ACCENT_COLOR_PROPERTY] = g_param_spec_boxed ("accent-color", "accent-color", "accent-color", gdk_rgba_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 422 "../lib/Widgets/TimePicker.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_TIME_PICKER_CLOCK_WIDGET_HOUR_PROPERTY, he_time_picker_clock_widget_properties[HE_TIME_PICKER_CLOCK_WIDGET_HOUR_PROPERTY] = g_param_spec_int ("hour", "hour", "hour", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 422 "../lib/Widgets/TimePicker.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_TIME_PICKER_CLOCK_WIDGET_MINUTE_PROPERTY, he_time_picker_clock_widget_properties[HE_TIME_PICKER_CLOCK_WIDGET_MINUTE_PROPERTY] = g_param_spec_int ("minute", "minute", "minute", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 422 "../lib/Widgets/TimePicker.vala"
	he_time_picker_clock_widget_signals[HE_TIME_PICKER_CLOCK_WIDGET_TIME_SELECTED_SIGNAL] = g_signal_new ("time-selected", HE_TIME_PICKER_TYPE_CLOCK_WIDGET, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT_INT, G_TYPE_NONE, 2, G_TYPE_INT, G_TYPE_INT);
#line 3896 "TimePicker.c"
}

static void
he_time_picker_clock_widget_instance_init (HeTimePickerClockWidget * self,
                                           gpointer klass)
{
	HeDesktop* _tmp0_;
#line 422 "../lib/Widgets/TimePicker.vala"
	self->priv = he_time_picker_clock_widget_get_instance_private (self);
#line 438 "../lib/Widgets/TimePicker.vala"
	self->priv->_selecting_hour = TRUE;
#line 439 "../lib/Widgets/TimePicker.vala"
	self->priv->_is_military_mode = FALSE;
#line 441 "../lib/Widgets/TimePicker.vala"
	self->priv->selected_hour = 0;
#line 442 "../lib/Widgets/TimePicker.vala"
	self->priv->selected_minute = 0;
#line 443 "../lib/Widgets/TimePicker.vala"
	self->priv->last_angle = 0.0;
#line 444 "../lib/Widgets/TimePicker.vala"
	self->priv->is_dark = FALSE;
#line 446 "../lib/Widgets/TimePicker.vala"
	_tmp0_ = he_desktop_new ();
#line 446 "../lib/Widgets/TimePicker.vala"
	self->priv->desktop = _tmp0_;
#line 447 "../lib/Widgets/TimePicker.vala"
	self->priv->_accent_color = (GdkRGBA) {(gfloat) 1, (gfloat) 1, (gfloat) 1, (gfloat) 1};
#line 3924 "TimePicker.c"
}

static void
he_time_picker_clock_widget_finalize (GObject * obj)
{
	HeTimePickerClockWidget * self;
#line 422 "../lib/Widgets/TimePicker.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TIME_PICKER_TYPE_CLOCK_WIDGET, HeTimePickerClockWidget);
#line 446 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (self->priv->desktop);
#line 422 "../lib/Widgets/TimePicker.vala"
	G_OBJECT_CLASS (he_time_picker_clock_widget_parent_class)->finalize (obj);
#line 3937 "TimePicker.c"
}

static GType
he_time_picker_clock_widget_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HeTimePickerClockWidgetClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) he_time_picker_clock_widget_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HeTimePickerClockWidget), 0, (GInstanceInitFunc) he_time_picker_clock_widget_instance_init, NULL };
	GType he_time_picker_clock_widget_type_id;
	he_time_picker_clock_widget_type_id = g_type_register_static (gtk_widget_get_type (), "HeTimePickerClockWidget", &g_define_type_info, 0);
	HeTimePickerClockWidget_private_offset = g_type_add_instance_private (he_time_picker_clock_widget_type_id, sizeof (HeTimePickerClockWidgetPrivate));
	return he_time_picker_clock_widget_type_id;
}

static GType
he_time_picker_clock_widget_get_type (void)
{
	static volatile gsize he_time_picker_clock_widget_type_id__once = 0;
	if (g_once_init_enter (&he_time_picker_clock_widget_type_id__once)) {
		GType he_time_picker_clock_widget_type_id;
		he_time_picker_clock_widget_type_id = he_time_picker_clock_widget_get_type_once ();
		g_once_init_leave (&he_time_picker_clock_widget_type_id__once, he_time_picker_clock_widget_type_id);
	}
	return he_time_picker_clock_widget_type_id__once;
}

static void
_vala_he_time_picker_clock_widget_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec)
{
	HeTimePickerClockWidget * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TIME_PICKER_TYPE_CLOCK_WIDGET, HeTimePickerClockWidget);
#line 422 "../lib/Widgets/TimePicker.vala"
	switch (property_id) {
#line 422 "../lib/Widgets/TimePicker.vala"
		case HE_TIME_PICKER_CLOCK_WIDGET_SELECTING_HOUR_PROPERTY:
#line 422 "../lib/Widgets/TimePicker.vala"
		g_value_set_boolean (value, he_time_picker_clock_widget_get_selecting_hour (self));
#line 422 "../lib/Widgets/TimePicker.vala"
		break;
#line 422 "../lib/Widgets/TimePicker.vala"
		case HE_TIME_PICKER_CLOCK_WIDGET_IS_MILITARY_MODE_PROPERTY:
#line 422 "../lib/Widgets/TimePicker.vala"
		g_value_set_boolean (value, he_time_picker_clock_widget_get_is_military_mode (self));
#line 422 "../lib/Widgets/TimePicker.vala"
		break;
#line 422 "../lib/Widgets/TimePicker.vala"
		case HE_TIME_PICKER_CLOCK_WIDGET_ACCENT_COLOR_PROPERTY:
#line 3986 "TimePicker.c"
		{
			GdkRGBA boxed;
#line 422 "../lib/Widgets/TimePicker.vala"
			he_time_picker_clock_widget_get_accent_color (self, &boxed);
#line 422 "../lib/Widgets/TimePicker.vala"
			g_value_set_boxed (value, &boxed);
#line 3993 "TimePicker.c"
		}
#line 422 "../lib/Widgets/TimePicker.vala"
		break;
#line 422 "../lib/Widgets/TimePicker.vala"
		case HE_TIME_PICKER_CLOCK_WIDGET_HOUR_PROPERTY:
#line 422 "../lib/Widgets/TimePicker.vala"
		g_value_set_int (value, he_time_picker_clock_widget_get_hour (self));
#line 422 "../lib/Widgets/TimePicker.vala"
		break;
#line 422 "../lib/Widgets/TimePicker.vala"
		case HE_TIME_PICKER_CLOCK_WIDGET_MINUTE_PROPERTY:
#line 422 "../lib/Widgets/TimePicker.vala"
		g_value_set_int (value, he_time_picker_clock_widget_get_minute (self));
#line 422 "../lib/Widgets/TimePicker.vala"
		break;
#line 4009 "TimePicker.c"
		default:
#line 422 "../lib/Widgets/TimePicker.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 422 "../lib/Widgets/TimePicker.vala"
		break;
#line 4015 "TimePicker.c"
	}
}

static void
_vala_he_time_picker_clock_widget_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec)
{
	HeTimePickerClockWidget * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TIME_PICKER_TYPE_CLOCK_WIDGET, HeTimePickerClockWidget);
#line 422 "../lib/Widgets/TimePicker.vala"
	switch (property_id) {
#line 422 "../lib/Widgets/TimePicker.vala"
		case HE_TIME_PICKER_CLOCK_WIDGET_SELECTING_HOUR_PROPERTY:
#line 422 "../lib/Widgets/TimePicker.vala"
		he_time_picker_clock_widget_set_selecting_hour (self, g_value_get_boolean (value));
#line 422 "../lib/Widgets/TimePicker.vala"
		break;
#line 422 "../lib/Widgets/TimePicker.vala"
		case HE_TIME_PICKER_CLOCK_WIDGET_IS_MILITARY_MODE_PROPERTY:
#line 422 "../lib/Widgets/TimePicker.vala"
		he_time_picker_clock_widget_set_is_military_mode (self, g_value_get_boolean (value));
#line 422 "../lib/Widgets/TimePicker.vala"
		break;
#line 422 "../lib/Widgets/TimePicker.vala"
		case HE_TIME_PICKER_CLOCK_WIDGET_ACCENT_COLOR_PROPERTY:
#line 422 "../lib/Widgets/TimePicker.vala"
		he_time_picker_clock_widget_set_accent_color (self, g_value_get_boxed (value));
#line 422 "../lib/Widgets/TimePicker.vala"
		break;
#line 422 "../lib/Widgets/TimePicker.vala"
		case HE_TIME_PICKER_CLOCK_WIDGET_HOUR_PROPERTY:
#line 422 "../lib/Widgets/TimePicker.vala"
		he_time_picker_clock_widget_set_hour (self, g_value_get_int (value));
#line 422 "../lib/Widgets/TimePicker.vala"
		break;
#line 422 "../lib/Widgets/TimePicker.vala"
		case HE_TIME_PICKER_CLOCK_WIDGET_MINUTE_PROPERTY:
#line 422 "../lib/Widgets/TimePicker.vala"
		he_time_picker_clock_widget_set_minute (self, g_value_get_int (value));
#line 422 "../lib/Widgets/TimePicker.vala"
		break;
#line 4059 "TimePicker.c"
		default:
#line 422 "../lib/Widgets/TimePicker.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 422 "../lib/Widgets/TimePicker.vala"
		break;
#line 4065 "TimePicker.c"
	}
}

static void
_he_time_picker_on_icon_press_gtk_entry_icon_release (GtkEntry* _sender,
                                                      GtkEntryIconPosition icon_pos,
                                                      gpointer self)
{
#line 93 "../lib/Widgets/TimePicker.vala"
	he_time_picker_on_icon_press ((HeTimePicker*) self, icon_pos);
#line 4076 "TimePicker.c"
}

static void
_he_time_picker___lambda179_ (HeTimePicker* self)
{
#line 123 "../lib/Widgets/TimePicker.vala"
	he_time_picker_update_time (self, TRUE);
#line 4084 "TimePicker.c"
}

static void
__he_time_picker___lambda179__gtk_spin_button_value_changed (GtkSpinButton* _sender,
                                                             gpointer self)
{
#line 123 "../lib/Widgets/TimePicker.vala"
	_he_time_picker___lambda179_ ((HeTimePicker*) self);
#line 4093 "TimePicker.c"
}

static void
_he_time_picker___lambda180_ (HeTimePicker* self)
{
#line 130 "../lib/Widgets/TimePicker.vala"
	he_time_picker_update_time (self, FALSE);
#line 4101 "TimePicker.c"
}

static void
__he_time_picker___lambda180__gtk_spin_button_value_changed (GtkSpinButton* _sender,
                                                             gpointer self)
{
#line 130 "../lib/Widgets/TimePicker.vala"
	_he_time_picker___lambda180_ ((HeTimePicker*) self);
#line 4110 "TimePicker.c"
}

static gchar*
double_to_string (gdouble self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint _tmp1__length1;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* result;
#line 997 "glib-2.0.vapi"
	_tmp0_ = g_new0 (gchar, G_ASCII_DTOSTR_BUF_SIZE);
#line 997 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 997 "glib-2.0.vapi"
	_tmp1__length1 = G_ASCII_DTOSTR_BUF_SIZE;
#line 997 "glib-2.0.vapi"
	_tmp2_ = g_ascii_dtostr (_tmp1_, (gint) G_ASCII_DTOSTR_BUF_SIZE, self);
#line 997 "glib-2.0.vapi"
	_tmp3_ = g_strdup (_tmp2_);
#line 997 "glib-2.0.vapi"
	_tmp4_ = _tmp3_;
#line 997 "glib-2.0.vapi"
	_tmp1_ = (g_free (_tmp1_), NULL);
#line 997 "glib-2.0.vapi"
	result = _tmp4_;
#line 997 "glib-2.0.vapi"
	return result;
#line 4141 "TimePicker.c"
}

static gboolean
_he_time_picker___lambda181_ (HeTimePicker* self)
{
	gdouble val = 0.0;
	GtkSpinButton* _tmp0_;
	gboolean result;
#line 133 "../lib/Widgets/TimePicker.vala"
	_tmp0_ = self->priv->minutes_spinbutton;
#line 133 "../lib/Widgets/TimePicker.vala"
	val = gtk_spin_button_get_value (_tmp0_);
#line 134 "../lib/Widgets/TimePicker.vala"
	if (val < ((gdouble) 10)) {
#line 4156 "TimePicker.c"
		GtkSpinButton* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
#line 135 "../lib/Widgets/TimePicker.vala"
		_tmp1_ = self->priv->minutes_spinbutton;
#line 135 "../lib/Widgets/TimePicker.vala"
		_tmp2_ = double_to_string (val);
#line 135 "../lib/Widgets/TimePicker.vala"
		_tmp3_ = _tmp2_;
#line 135 "../lib/Widgets/TimePicker.vala"
		_tmp4_ = g_strconcat ("0", _tmp3_, NULL);
#line 135 "../lib/Widgets/TimePicker.vala"
		_tmp5_ = _tmp4_;
#line 135 "../lib/Widgets/TimePicker.vala"
		gtk_editable_set_text ((GtkEditable*) _tmp1_, _tmp5_);
#line 135 "../lib/Widgets/TimePicker.vala"
		_g_free0 (_tmp5_);
#line 135 "../lib/Widgets/TimePicker.vala"
		_g_free0 (_tmp3_);
#line 136 "../lib/Widgets/TimePicker.vala"
		result = TRUE;
#line 136 "../lib/Widgets/TimePicker.vala"
		return result;
#line 4182 "TimePicker.c"
	}
#line 139 "../lib/Widgets/TimePicker.vala"
	result = FALSE;
#line 139 "../lib/Widgets/TimePicker.vala"
	return result;
#line 4188 "TimePicker.c"
}

static gboolean
__he_time_picker___lambda181__gtk_spin_button_output (GtkSpinButton* _sender,
                                                      gpointer self)
{
	gboolean result;
	result = _he_time_picker___lambda181_ ((HeTimePicker*) self);
#line 132 "../lib/Widgets/TimePicker.vala"
	return result;
#line 4199 "TimePicker.c"
}

static void
_he_time_picker___lambda182_ (HeTimePicker* self,
                              gint hour,
                              gint minute)
{
	GtkSpinButton* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 157 "../lib/Widgets/TimePicker.vala"
	_tmp0_ = self->priv->hours_spinbutton;
#line 157 "../lib/Widgets/TimePicker.vala"
	_tmp1_ = g_strdup_printf ("%i", hour);
#line 157 "../lib/Widgets/TimePicker.vala"
	_tmp2_ = _tmp1_;
#line 157 "../lib/Widgets/TimePicker.vala"
	gtk_editable_set_text ((GtkEditable*) _tmp0_, _tmp2_);
#line 157 "../lib/Widgets/TimePicker.vala"
	_g_free0 (_tmp2_);
#line 158 "../lib/Widgets/TimePicker.vala"
	if (minute < 10) {
#line 4222 "TimePicker.c"
		GtkSpinButton* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
#line 159 "../lib/Widgets/TimePicker.vala"
		_tmp3_ = self->priv->minutes_spinbutton;
#line 159 "../lib/Widgets/TimePicker.vala"
		_tmp4_ = g_strdup_printf ("%i", minute);
#line 159 "../lib/Widgets/TimePicker.vala"
		_tmp5_ = _tmp4_;
#line 159 "../lib/Widgets/TimePicker.vala"
		_tmp6_ = g_strconcat ("0", _tmp5_, NULL);
#line 159 "../lib/Widgets/TimePicker.vala"
		_tmp7_ = _tmp6_;
#line 159 "../lib/Widgets/TimePicker.vala"
		gtk_editable_set_text ((GtkEditable*) _tmp3_, _tmp7_);
#line 159 "../lib/Widgets/TimePicker.vala"
		_g_free0 (_tmp7_);
#line 159 "../lib/Widgets/TimePicker.vala"
		_g_free0 (_tmp5_);
#line 4244 "TimePicker.c"
	} else {
		GtkSpinButton* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 161 "../lib/Widgets/TimePicker.vala"
		_tmp8_ = self->priv->minutes_spinbutton;
#line 161 "../lib/Widgets/TimePicker.vala"
		_tmp9_ = g_strdup_printf ("%i", minute);
#line 161 "../lib/Widgets/TimePicker.vala"
		_tmp10_ = _tmp9_;
#line 161 "../lib/Widgets/TimePicker.vala"
		gtk_editable_set_text ((GtkEditable*) _tmp8_, _tmp10_);
#line 161 "../lib/Widgets/TimePicker.vala"
		_g_free0 (_tmp10_);
#line 4259 "TimePicker.c"
	}
#line 164 "../lib/Widgets/TimePicker.vala"
	g_signal_emit (self, he_time_picker_signals[HE_TIME_PICKER_TIME_CHANGED_SIGNAL], 0);
#line 165 "../lib/Widgets/TimePicker.vala"
	he_time_picker_update_time (self, TRUE);
#line 166 "../lib/Widgets/TimePicker.vala"
	he_time_picker_update_time (self, FALSE);
#line 4267 "TimePicker.c"
}

static void
__he_time_picker___lambda182__he_time_picker_clock_widget_time_selected (HeTimePickerClockWidget* _sender,
                                                                         gint hour,
                                                                         gint minute,
                                                                         gpointer self)
{
#line 156 "../lib/Widgets/TimePicker.vala"
	_he_time_picker___lambda182_ ((HeTimePicker*) self, hour, minute);
#line 4278 "TimePicker.c"
}

static void
_he_time_picker___lambda183_ (HeTimePicker* self)
{
#line 197 "../lib/Widgets/TimePicker.vala"
	he_time_picker_is_unfocused (self);
#line 4286 "TimePicker.c"
}

static void
__he_time_picker___lambda183__gtk_event_controller_focus_leave (GtkEventControllerFocus* _sender,
                                                                gpointer self)
{
#line 196 "../lib/Widgets/TimePicker.vala"
	_he_time_picker___lambda183_ ((HeTimePicker*) self);
#line 4295 "TimePicker.c"
}

static gboolean
_he_time_picker___lambda184_ (HeTimePicker* self,
                              gdouble dx,
                              gdouble dy)
{
	gdouble _tmp0_ = 0.0;
	gdouble largest = 0.0;
	gboolean result;
#line 201 "../lib/Widgets/TimePicker.vala"
	if (fabs (dx) > fabs (dy)) {
#line 201 "../lib/Widgets/TimePicker.vala"
		_tmp0_ = dx;
#line 4310 "TimePicker.c"
	} else {
#line 201 "../lib/Widgets/TimePicker.vala"
		_tmp0_ = dy;
#line 4314 "TimePicker.c"
	}
#line 201 "../lib/Widgets/TimePicker.vala"
	largest = _tmp0_;
#line 202 "../lib/Widgets/TimePicker.vala"
	if (largest < ((gdouble) 0)) {
#line 4320 "TimePicker.c"
		GDateTime* _tmp1_;
		GDateTime* _tmp2_;
#line 203 "../lib/Widgets/TimePicker.vala"
		_tmp1_ = self->priv->_time;
#line 203 "../lib/Widgets/TimePicker.vala"
		_tmp2_ = g_date_time_add_minutes (_tmp1_, 1);
#line 203 "../lib/Widgets/TimePicker.vala"
		_g_date_time_unref0 (self->priv->_time);
#line 203 "../lib/Widgets/TimePicker.vala"
		self->priv->_time = _tmp2_;
#line 4331 "TimePicker.c"
	} else {
		GDateTime* _tmp3_;
		GDateTime* _tmp4_;
#line 205 "../lib/Widgets/TimePicker.vala"
		_tmp3_ = self->priv->_time;
#line 205 "../lib/Widgets/TimePicker.vala"
		_tmp4_ = g_date_time_add_minutes (_tmp3_, -1);
#line 205 "../lib/Widgets/TimePicker.vala"
		_g_date_time_unref0 (self->priv->_time);
#line 205 "../lib/Widgets/TimePicker.vala"
		self->priv->_time = _tmp4_;
#line 4343 "TimePicker.c"
	}
#line 208 "../lib/Widgets/TimePicker.vala"
	he_time_picker_update_text (self, FALSE);
#line 209 "../lib/Widgets/TimePicker.vala"
	result = FALSE;
#line 209 "../lib/Widgets/TimePicker.vala"
	return result;
#line 4351 "TimePicker.c"
}

static gboolean
__he_time_picker___lambda184__gtk_event_controller_scroll_scroll (GtkEventControllerScroll* _sender,
                                                                  gdouble dx,
                                                                  gdouble dy,
                                                                  gpointer self)
{
	gboolean result;
	result = _he_time_picker___lambda184_ ((HeTimePicker*) self, dx, dy);
#line 200 "../lib/Widgets/TimePicker.vala"
	return result;
#line 4364 "TimePicker.c"
}

static void
_he_time_picker_is_unfocused_gtk_entry_activate (GtkEntry* _sender,
                                                 gpointer self)
{
#line 212 "../lib/Widgets/TimePicker.vala"
	he_time_picker_is_unfocused ((HeTimePicker*) self);
#line 4373 "TimePicker.c"
}

static void
_he_time_picker___lambda185_ (HeTimePicker* self)
{
#line 215 "../lib/Widgets/TimePicker.vala"
	he_time_picker_update_am_pm (self, -12);
#line 4381 "TimePicker.c"
}

static void
__he_time_picker___lambda185__gtk_button_clicked (GtkButton* _sender,
                                                  gpointer self)
{
#line 214 "../lib/Widgets/TimePicker.vala"
	_he_time_picker___lambda185_ ((HeTimePicker*) self);
#line 4390 "TimePicker.c"
}

static void
_he_time_picker___lambda186_ (HeTimePicker* self)
{
#line 219 "../lib/Widgets/TimePicker.vala"
	he_time_picker_update_am_pm (self, 12);
#line 4398 "TimePicker.c"
}

static void
__he_time_picker___lambda186__gtk_button_clicked (GtkButton* _sender,
                                                  gpointer self)
{
#line 218 "../lib/Widgets/TimePicker.vala"
	_he_time_picker___lambda186_ ((HeTimePicker*) self);
#line 4407 "TimePicker.c"
}

static GObject *
he_time_picker_constructor (GType type,
                            guint n_construct_properties,
                            GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	HeTimePicker * self;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GThemedIcon* _tmp2_;
	GThemedIcon* _tmp3_;
	GtkToggleButton* _tmp4_ = NULL;
	GtkToggleButton* _tmp5_;
	GtkToggleButton* _tmp6_;
	GtkToggleButton* _tmp7_ = NULL;
	GtkBox* _tmp8_ = NULL;
	GtkBox* _tmp9_;
	GtkBox* _tmp10_;
	GtkToggleButton* _tmp11_;
	GtkBox* _tmp12_;
	GtkToggleButton* _tmp13_;
	GtkSpinButton* _tmp18_;
	GtkSpinButton* _tmp19_;
	GtkSpinButton* _tmp20_;
	GtkSpinButton* _tmp21_;
	GtkSpinButton* _tmp22_;
	GtkSpinButton* _tmp23_;
	GtkSpinButton* _tmp24_;
	GtkSpinButton* _tmp25_;
	GtkSpinButton* _tmp26_;
	GtkSpinButton* _tmp27_;
	GtkSpinButton* _tmp28_;
	GtkSpinButton* _tmp29_;
	GtkLabel* separation_label = NULL;
	GtkLabel* _tmp30_;
	GtkLabel* _tmp31_;
	GtkBox* pop_grid_top = NULL;
	GtkBox* _tmp32_ = NULL;
	GtkBox* _tmp33_;
	GtkSpinButton* _tmp34_;
	GtkBox* _tmp35_;
	GtkLabel* _tmp36_;
	GtkBox* _tmp37_;
	GtkSpinButton* _tmp38_;
	GtkBox* _tmp39_;
	GtkBox* _tmp40_;
	HeTimePickerClockWidget* _tmp41_;
	HeTimePickerClockWidget* _tmp42_;
	GtkBox* pop_grid_middle = NULL;
	GtkBox* _tmp43_ = NULL;
	GtkBox* _tmp44_;
	HeTimePickerClockWidget* _tmp45_;
	GtkBox* pop_grid = NULL;
	GtkBox* _tmp46_;
	GtkBox* _tmp47_;
	GtkBox* _tmp48_;
	GtkBox* _tmp49_;
	GtkBox* _tmp50_;
	GtkBox* _tmp51_;
	GtkWidget* _tmp52_;
	GtkPopover* _tmp53_ = NULL;
	GtkPopover* _tmp54_;
	GtkPopover* _tmp55_;
	GtkEventControllerFocus* focus_controller = NULL;
	GtkEventControllerFocus* _tmp56_;
	GtkEventControllerScroll* scroll_controller = NULL;
	GtkEventControllerScroll* _tmp57_;
	GtkEventControllerFocus* _tmp58_;
	GtkEventController* _tmp59_;
	GtkEventControllerScroll* _tmp60_;
	GtkEventController* _tmp61_;
	GtkEventControllerFocus* _tmp62_;
	GtkEventControllerScroll* _tmp63_;
	GtkToggleButton* _tmp64_;
	GtkToggleButton* _tmp65_;
#line 82 "../lib/Widgets/TimePicker.vala"
	parent_class = G_OBJECT_CLASS (he_time_picker_parent_class);
#line 82 "../lib/Widgets/TimePicker.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 82 "../lib/Widgets/TimePicker.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_TIME_PICKER, HeTimePicker);
#line 83 "../lib/Widgets/TimePicker.vala"
	_tmp0_ = self->priv->_format_12;
#line 83 "../lib/Widgets/TimePicker.vala"
	if (_tmp0_ == NULL) {
#line 84 "../lib/Widgets/TimePicker.vala"
		he_time_picker_set_format_12 (self, _ ("%-l:%M %p"));
#line 4498 "TimePicker.c"
	}
#line 87 "../lib/Widgets/TimePicker.vala"
	_tmp1_ = self->priv->_format_24;
#line 87 "../lib/Widgets/TimePicker.vala"
	if (_tmp1_ == NULL) {
#line 88 "../lib/Widgets/TimePicker.vala"
		he_time_picker_set_format_24 (self, _ ("%H:%M"));
#line 4506 "TimePicker.c"
	}
#line 91 "../lib/Widgets/TimePicker.vala"
	gtk_editable_set_width_chars ((GtkEditable*) self, 8);
#line 92 "../lib/Widgets/TimePicker.vala"
	_tmp2_ = (GThemedIcon*) g_themed_icon_new_with_default_fallbacks ("clock-symbolic");
#line 92 "../lib/Widgets/TimePicker.vala"
	_tmp3_ = _tmp2_;
#line 92 "../lib/Widgets/TimePicker.vala"
	g_object_set ((GtkEntry*) self, "secondary-icon-gicon", (GIcon*) _tmp3_, NULL);
#line 92 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (_tmp3_);
#line 93 "../lib/Widgets/TimePicker.vala"
	g_signal_connect_object ((GtkEntry*) self, "icon-release", (GCallback) _he_time_picker_on_icon_press_gtk_entry_icon_release, self, 0);
#line 95 "../lib/Widgets/TimePicker.vala"
	_tmp4_ = (GtkToggleButton*) gtk_toggle_button_new_with_label (_ ("AM"));
#line 95 "../lib/Widgets/TimePicker.vala"
	gtk_widget_set_vexpand ((GtkWidget*) _tmp4_, TRUE);
#line 95 "../lib/Widgets/TimePicker.vala"
	g_object_ref_sink (_tmp4_);
#line 95 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (self->priv->am_togglebutton);
#line 95 "../lib/Widgets/TimePicker.vala"
	self->priv->am_togglebutton = _tmp4_;
#line 98 "../lib/Widgets/TimePicker.vala"
	_tmp5_ = self->priv->am_togglebutton;
#line 98 "../lib/Widgets/TimePicker.vala"
	_tmp6_ = _g_object_ref0 (_tmp5_);
#line 98 "../lib/Widgets/TimePicker.vala"
	_tmp7_ = (GtkToggleButton*) gtk_toggle_button_new_with_label (_ ("PM"));
#line 98 "../lib/Widgets/TimePicker.vala"
	gtk_toggle_button_set_group (_tmp7_, _tmp6_);
#line 98 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (_tmp6_);
#line 98 "../lib/Widgets/TimePicker.vala"
	gtk_widget_set_vexpand ((GtkWidget*) _tmp7_, TRUE);
#line 98 "../lib/Widgets/TimePicker.vala"
	g_object_ref_sink (_tmp7_);
#line 98 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (self->priv->pm_togglebutton);
#line 98 "../lib/Widgets/TimePicker.vala"
	self->priv->pm_togglebutton = _tmp7_;
#line 103 "../lib/Widgets/TimePicker.vala"
	_tmp8_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 103 "../lib/Widgets/TimePicker.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp8_, GTK_ALIGN_START);
#line 103 "../lib/Widgets/TimePicker.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp8_, 16);
#line 103 "../lib/Widgets/TimePicker.vala"
	g_object_ref_sink (_tmp8_);
#line 103 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (self->priv->am_pm_box);
#line 103 "../lib/Widgets/TimePicker.vala"
	self->priv->am_pm_box = _tmp8_;
#line 107 "../lib/Widgets/TimePicker.vala"
	_tmp9_ = self->priv->am_pm_box;
#line 107 "../lib/Widgets/TimePicker.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp9_, "segmented-button");
#line 108 "../lib/Widgets/TimePicker.vala"
	_tmp10_ = self->priv->am_pm_box;
#line 108 "../lib/Widgets/TimePicker.vala"
	_tmp11_ = self->priv->am_togglebutton;
#line 108 "../lib/Widgets/TimePicker.vala"
	gtk_box_append (_tmp10_, (GtkWidget*) _tmp11_);
#line 109 "../lib/Widgets/TimePicker.vala"
	_tmp12_ = self->priv->am_pm_box;
#line 109 "../lib/Widgets/TimePicker.vala"
	_tmp13_ = self->priv->pm_togglebutton;
#line 109 "../lib/Widgets/TimePicker.vala"
	gtk_box_append (_tmp12_, (GtkWidget*) _tmp13_);
#line 111 "../lib/Widgets/TimePicker.vala"
	if (he_time_picker_is_clock_format_12h ()) {
#line 4578 "TimePicker.c"
		GtkSpinButton* _tmp14_;
		HeTimePickerClockWidget* _tmp15_;
#line 112 "../lib/Widgets/TimePicker.vala"
		_tmp14_ = (GtkSpinButton*) gtk_spin_button_new_with_range ((gdouble) 1, (gdouble) 12, (gdouble) 1);
#line 112 "../lib/Widgets/TimePicker.vala"
		g_object_ref_sink (_tmp14_);
#line 112 "../lib/Widgets/TimePicker.vala"
		_g_object_unref0 (self->priv->hours_spinbutton);
#line 112 "../lib/Widgets/TimePicker.vala"
		self->priv->hours_spinbutton = _tmp14_;
#line 113 "../lib/Widgets/TimePicker.vala"
		_tmp15_ = self->priv->clock;
#line 113 "../lib/Widgets/TimePicker.vala"
		he_time_picker_clock_widget_set_is_military_mode (_tmp15_, FALSE);
#line 4593 "TimePicker.c"
	} else {
		GtkSpinButton* _tmp16_;
		HeTimePickerClockWidget* _tmp17_;
#line 115 "../lib/Widgets/TimePicker.vala"
		_tmp16_ = (GtkSpinButton*) gtk_spin_button_new_with_range ((gdouble) 0, (gdouble) 23, (gdouble) 1);
#line 115 "../lib/Widgets/TimePicker.vala"
		g_object_ref_sink (_tmp16_);
#line 115 "../lib/Widgets/TimePicker.vala"
		_g_object_unref0 (self->priv->hours_spinbutton);
#line 115 "../lib/Widgets/TimePicker.vala"
		self->priv->hours_spinbutton = _tmp16_;
#line 116 "../lib/Widgets/TimePicker.vala"
		_tmp17_ = self->priv->clock;
#line 116 "../lib/Widgets/TimePicker.vala"
		he_time_picker_clock_widget_set_is_military_mode (_tmp17_, TRUE);
#line 4609 "TimePicker.c"
	}
#line 119 "../lib/Widgets/TimePicker.vala"
	_tmp18_ = self->priv->hours_spinbutton;
#line 119 "../lib/Widgets/TimePicker.vala"
	gtk_orientable_set_orientation ((GtkOrientable*) _tmp18_, GTK_ORIENTATION_VERTICAL);
#line 120 "../lib/Widgets/TimePicker.vala"
	_tmp19_ = self->priv->hours_spinbutton;
#line 120 "../lib/Widgets/TimePicker.vala"
	gtk_spin_button_set_wrap (_tmp19_, TRUE);
#line 121 "../lib/Widgets/TimePicker.vala"
	_tmp20_ = self->priv->hours_spinbutton;
#line 121 "../lib/Widgets/TimePicker.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp20_, "display");
#line 122 "../lib/Widgets/TimePicker.vala"
	_tmp21_ = self->priv->hours_spinbutton;
#line 122 "../lib/Widgets/TimePicker.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp21_, "flat");
#line 123 "../lib/Widgets/TimePicker.vala"
	_tmp22_ = self->priv->hours_spinbutton;
#line 123 "../lib/Widgets/TimePicker.vala"
	g_signal_connect_object (_tmp22_, "value-changed", (GCallback) __he_time_picker___lambda179__gtk_spin_button_value_changed, self, 0);
#line 125 "../lib/Widgets/TimePicker.vala"
	_tmp23_ = (GtkSpinButton*) gtk_spin_button_new_with_range ((gdouble) 0, (gdouble) 59, (gdouble) 1);
#line 125 "../lib/Widgets/TimePicker.vala"
	g_object_ref_sink (_tmp23_);
#line 125 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (self->priv->minutes_spinbutton);
#line 125 "../lib/Widgets/TimePicker.vala"
	self->priv->minutes_spinbutton = _tmp23_;
#line 126 "../lib/Widgets/TimePicker.vala"
	_tmp24_ = self->priv->minutes_spinbutton;
#line 126 "../lib/Widgets/TimePicker.vala"
	gtk_orientable_set_orientation ((GtkOrientable*) _tmp24_, GTK_ORIENTATION_VERTICAL);
#line 127 "../lib/Widgets/TimePicker.vala"
	_tmp25_ = self->priv->minutes_spinbutton;
#line 127 "../lib/Widgets/TimePicker.vala"
	gtk_spin_button_set_wrap (_tmp25_, TRUE);
#line 128 "../lib/Widgets/TimePicker.vala"
	_tmp26_ = self->priv->minutes_spinbutton;
#line 128 "../lib/Widgets/TimePicker.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp26_, "display");
#line 129 "../lib/Widgets/TimePicker.vala"
	_tmp27_ = self->priv->minutes_spinbutton;
#line 129 "../lib/Widgets/TimePicker.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp27_, "flat");
#line 130 "../lib/Widgets/TimePicker.vala"
	_tmp28_ = self->priv->minutes_spinbutton;
#line 130 "../lib/Widgets/TimePicker.vala"
	g_signal_connect_object (_tmp28_, "value-changed", (GCallback) __he_time_picker___lambda180__gtk_spin_button_value_changed, self, 0);
#line 132 "../lib/Widgets/TimePicker.vala"
	_tmp29_ = self->priv->minutes_spinbutton;
#line 132 "../lib/Widgets/TimePicker.vala"
	g_signal_connect_object (_tmp29_, "output", (GCallback) __he_time_picker___lambda181__gtk_spin_button_output, self, 0);
#line 142 "../lib/Widgets/TimePicker.vala"
	_tmp30_ = (GtkLabel*) gtk_label_new (":");
#line 142 "../lib/Widgets/TimePicker.vala"
	g_object_ref_sink (_tmp30_);
#line 142 "../lib/Widgets/TimePicker.vala"
	separation_label = _tmp30_;
#line 143 "../lib/Widgets/TimePicker.vala"
	_tmp31_ = separation_label;
#line 143 "../lib/Widgets/TimePicker.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp31_, "display");
#line 145 "../lib/Widgets/TimePicker.vala"
	_tmp32_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 6);
#line 145 "../lib/Widgets/TimePicker.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp32_, 12);
#line 145 "../lib/Widgets/TimePicker.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp32_, 12);
#line 145 "../lib/Widgets/TimePicker.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp32_, 12);
#line 145 "../lib/Widgets/TimePicker.vala"
	g_object_ref_sink (_tmp32_);
#line 145 "../lib/Widgets/TimePicker.vala"
	pop_grid_top = _tmp32_;
#line 150 "../lib/Widgets/TimePicker.vala"
	_tmp33_ = pop_grid_top;
#line 150 "../lib/Widgets/TimePicker.vala"
	_tmp34_ = self->priv->hours_spinbutton;
#line 150 "../lib/Widgets/TimePicker.vala"
	gtk_box_append (_tmp33_, (GtkWidget*) _tmp34_);
#line 151 "../lib/Widgets/TimePicker.vala"
	_tmp35_ = pop_grid_top;
#line 151 "../lib/Widgets/TimePicker.vala"
	_tmp36_ = separation_label;
#line 151 "../lib/Widgets/TimePicker.vala"
	gtk_box_append (_tmp35_, (GtkWidget*) _tmp36_);
#line 152 "../lib/Widgets/TimePicker.vala"
	_tmp37_ = pop_grid_top;
#line 152 "../lib/Widgets/TimePicker.vala"
	_tmp38_ = self->priv->minutes_spinbutton;
#line 152 "../lib/Widgets/TimePicker.vala"
	gtk_box_append (_tmp37_, (GtkWidget*) _tmp38_);
#line 153 "../lib/Widgets/TimePicker.vala"
	_tmp39_ = pop_grid_top;
#line 153 "../lib/Widgets/TimePicker.vala"
	_tmp40_ = self->priv->am_pm_box;
#line 153 "../lib/Widgets/TimePicker.vala"
	gtk_box_append (_tmp39_, (GtkWidget*) _tmp40_);
#line 155 "../lib/Widgets/TimePicker.vala"
	_tmp41_ = he_time_picker_clock_widget_new ();
#line 155 "../lib/Widgets/TimePicker.vala"
	g_object_ref_sink (_tmp41_);
#line 155 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (self->priv->clock);
#line 155 "../lib/Widgets/TimePicker.vala"
	self->priv->clock = _tmp41_;
#line 156 "../lib/Widgets/TimePicker.vala"
	_tmp42_ = self->priv->clock;
#line 156 "../lib/Widgets/TimePicker.vala"
	g_signal_connect_object (_tmp42_, "time-selected", (GCallback) __he_time_picker___lambda182__he_time_picker_clock_widget_time_selected, self, 0);
#line 169 "../lib/Widgets/TimePicker.vala"
	_tmp43_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 6);
#line 169 "../lib/Widgets/TimePicker.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp43_, 12);
#line 169 "../lib/Widgets/TimePicker.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp43_, 12);
#line 169 "../lib/Widgets/TimePicker.vala"
	g_object_ref_sink (_tmp43_);
#line 169 "../lib/Widgets/TimePicker.vala"
	pop_grid_middle = _tmp43_;
#line 173 "../lib/Widgets/TimePicker.vala"
	_tmp44_ = pop_grid_middle;
#line 173 "../lib/Widgets/TimePicker.vala"
	_tmp45_ = self->priv->clock;
#line 173 "../lib/Widgets/TimePicker.vala"
	gtk_box_append (_tmp44_, (GtkWidget*) _tmp45_);
#line 175 "../lib/Widgets/TimePicker.vala"
	_tmp46_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 24);
#line 175 "../lib/Widgets/TimePicker.vala"
	g_object_ref_sink (_tmp46_);
#line 175 "../lib/Widgets/TimePicker.vala"
	pop_grid = _tmp46_;
#line 176 "../lib/Widgets/TimePicker.vala"
	_tmp47_ = pop_grid;
#line 176 "../lib/Widgets/TimePicker.vala"
	_tmp48_ = pop_grid_top;
#line 176 "../lib/Widgets/TimePicker.vala"
	gtk_box_append (_tmp47_, (GtkWidget*) _tmp48_);
#line 177 "../lib/Widgets/TimePicker.vala"
	_tmp49_ = pop_grid;
#line 177 "../lib/Widgets/TimePicker.vala"
	_tmp50_ = pop_grid_middle;
#line 177 "../lib/Widgets/TimePicker.vala"
	gtk_box_append (_tmp49_, (GtkWidget*) _tmp50_);
#line 179 "../lib/Widgets/TimePicker.vala"
	_tmp51_ = pop_grid;
#line 179 "../lib/Widgets/TimePicker.vala"
	_tmp52_ = _g_object_ref0 ((GtkWidget*) _tmp51_);
#line 179 "../lib/Widgets/TimePicker.vala"
	_tmp53_ = (GtkPopover*) gtk_popover_new ();
#line 179 "../lib/Widgets/TimePicker.vala"
	gtk_popover_set_autohide (_tmp53_, TRUE);
#line 179 "../lib/Widgets/TimePicker.vala"
	gtk_popover_set_child (_tmp53_, _tmp52_);
#line 179 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (_tmp52_);
#line 179 "../lib/Widgets/TimePicker.vala"
	gtk_popover_set_has_arrow (_tmp53_, FALSE);
#line 179 "../lib/Widgets/TimePicker.vala"
	gtk_popover_set_position (_tmp53_, GTK_POS_BOTTOM);
#line 179 "../lib/Widgets/TimePicker.vala"
	g_object_ref_sink (_tmp53_);
#line 179 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (self->priv->popover);
#line 179 "../lib/Widgets/TimePicker.vala"
	self->priv->popover = _tmp53_;
#line 185 "../lib/Widgets/TimePicker.vala"
	_tmp54_ = self->priv->popover;
#line 185 "../lib/Widgets/TimePicker.vala"
	gtk_widget_set_parent ((GtkWidget*) _tmp54_, (GtkWidget*) self);
#line 186 "../lib/Widgets/TimePicker.vala"
	_tmp55_ = self->priv->popover;
#line 186 "../lib/Widgets/TimePicker.vala"
	gtk_popover_set_has_arrow (_tmp55_, FALSE);
#line 188 "../lib/Widgets/TimePicker.vala"
	_tmp56_ = (GtkEventControllerFocus*) gtk_event_controller_focus_new ();
#line 188 "../lib/Widgets/TimePicker.vala"
	focus_controller = _tmp56_;
#line 189 "../lib/Widgets/TimePicker.vala"
	_tmp57_ = (GtkEventControllerScroll*) gtk_event_controller_scroll_new (GTK_EVENT_CONTROLLER_SCROLL_BOTH_AXES | GTK_EVENT_CONTROLLER_SCROLL_DISCRETE);
#line 189 "../lib/Widgets/TimePicker.vala"
	scroll_controller = _tmp57_;
#line 193 "../lib/Widgets/TimePicker.vala"
	_tmp58_ = focus_controller;
#line 193 "../lib/Widgets/TimePicker.vala"
	_tmp59_ = _g_object_ref0 ((GtkEventController*) _tmp58_);
#line 193 "../lib/Widgets/TimePicker.vala"
	gtk_widget_add_controller ((GtkWidget*) self, _tmp59_);
#line 194 "../lib/Widgets/TimePicker.vala"
	_tmp60_ = scroll_controller;
#line 194 "../lib/Widgets/TimePicker.vala"
	_tmp61_ = _g_object_ref0 ((GtkEventController*) _tmp60_);
#line 194 "../lib/Widgets/TimePicker.vala"
	gtk_widget_add_controller ((GtkWidget*) self, _tmp61_);
#line 196 "../lib/Widgets/TimePicker.vala"
	_tmp62_ = focus_controller;
#line 196 "../lib/Widgets/TimePicker.vala"
	g_signal_connect_object (_tmp62_, "leave", (GCallback) __he_time_picker___lambda183__gtk_event_controller_focus_leave, self, 0);
#line 200 "../lib/Widgets/TimePicker.vala"
	_tmp63_ = scroll_controller;
#line 200 "../lib/Widgets/TimePicker.vala"
	g_signal_connect_object (_tmp63_, "scroll", (GCallback) __he_time_picker___lambda184__gtk_event_controller_scroll_scroll, self, 0);
#line 212 "../lib/Widgets/TimePicker.vala"
	g_signal_connect_object ((GtkEntry*) self, "activate", (GCallback) _he_time_picker_is_unfocused_gtk_entry_activate, self, 0);
#line 214 "../lib/Widgets/TimePicker.vala"
	_tmp64_ = self->priv->am_togglebutton;
#line 214 "../lib/Widgets/TimePicker.vala"
	g_signal_connect_object ((GtkButton*) _tmp64_, "clicked", (GCallback) __he_time_picker___lambda185__gtk_button_clicked, self, 0);
#line 218 "../lib/Widgets/TimePicker.vala"
	_tmp65_ = self->priv->pm_togglebutton;
#line 218 "../lib/Widgets/TimePicker.vala"
	g_signal_connect_object ((GtkButton*) _tmp65_, "clicked", (GCallback) __he_time_picker___lambda186__gtk_button_clicked, self, 0);
#line 222 "../lib/Widgets/TimePicker.vala"
	gtk_widget_add_css_class ((GtkWidget*) self, "text-field");
#line 224 "../lib/Widgets/TimePicker.vala"
	he_time_picker_update_text (self, FALSE);
#line 82 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (scroll_controller);
#line 82 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (focus_controller);
#line 82 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (pop_grid);
#line 82 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (pop_grid_middle);
#line 82 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (pop_grid_top);
#line 82 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (separation_label);
#line 82 "../lib/Widgets/TimePicker.vala"
	return obj;
#line 4841 "TimePicker.c"
}

static void
he_time_picker_class_init (HeTimePickerClass * klass,
                           gpointer klass_data)
{
#line 19 "../lib/Widgets/TimePicker.vala"
	he_time_picker_parent_class = g_type_class_peek_parent (klass);
#line 19 "../lib/Widgets/TimePicker.vala"
	g_type_class_adjust_private_offset (klass, &HeTimePicker_private_offset);
#line 19 "../lib/Widgets/TimePicker.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_he_time_picker_get_property;
#line 19 "../lib/Widgets/TimePicker.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_he_time_picker_set_property;
#line 19 "../lib/Widgets/TimePicker.vala"
	G_OBJECT_CLASS (klass)->constructor = he_time_picker_constructor;
#line 19 "../lib/Widgets/TimePicker.vala"
	G_OBJECT_CLASS (klass)->finalize = he_time_picker_finalize;
#line 4860 "TimePicker.c"
	/**
	     *  The string format of how to display the time when in 12h mode.
	     */
#line 19 "../lib/Widgets/TimePicker.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_TIME_PICKER_FORMAT_12_PROPERTY, he_time_picker_properties[HE_TIME_PICKER_FORMAT_12_PROPERTY] = g_param_spec_string ("format-12", "format-12", "format-12", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 4866 "TimePicker.c"
	/**
	     *  The string format of how to display the time when in 24h mode.
	     */
#line 19 "../lib/Widgets/TimePicker.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_TIME_PICKER_FORMAT_24_PROPERTY, he_time_picker_properties[HE_TIME_PICKER_FORMAT_24_PROPERTY] = g_param_spec_string ("format-24", "format-24", "format-24", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 19 "../lib/Widgets/TimePicker.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_TIME_PICKER_TIME_PROPERTY, he_time_picker_properties[HE_TIME_PICKER_TIME_PROPERTY] = g_param_spec_boxed ("time", "time", "time", G_TYPE_DATE_TIME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 4874 "TimePicker.c"
	/**
	     *  The signal when time is changed with this widget.
	     */
#line 19 "../lib/Widgets/TimePicker.vala"
	he_time_picker_signals[HE_TIME_PICKER_TIME_CHANGED_SIGNAL] = g_signal_new ("time-changed", HE_TYPE_TIME_PICKER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 4880 "TimePicker.c"
}

static void
he_time_picker_instance_init (HeTimePicker * self,
                              gpointer klass)
{
	gchar* _tmp0_;
#line 19 "../lib/Widgets/TimePicker.vala"
	self->priv = he_time_picker_get_instance_private (self);
#line 35 "../lib/Widgets/TimePicker.vala"
	self->priv->_time = NULL;
#line 62 "../lib/Widgets/TimePicker.vala"
	self->priv->changing_time = FALSE;
#line 63 "../lib/Widgets/TimePicker.vala"
	_tmp0_ = g_strdup ("");
#line 63 "../lib/Widgets/TimePicker.vala"
	self->priv->old_string = _tmp0_;
#line 4898 "TimePicker.c"
}

static void
he_time_picker_finalize (GObject * obj)
{
	HeTimePicker * self;
#line 19 "../lib/Widgets/TimePicker.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_TIME_PICKER, HeTimePicker);
#line 28 "../lib/Widgets/TimePicker.vala"
	_g_free0 (self->priv->_format_12);
#line 33 "../lib/Widgets/TimePicker.vala"
	_g_free0 (self->priv->_format_24);
#line 35 "../lib/Widgets/TimePicker.vala"
	_g_date_time_unref0 (self->priv->_time);
#line 63 "../lib/Widgets/TimePicker.vala"
	_g_free0 (self->priv->old_string);
#line 64 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (self->priv->am_pm_box);
#line 65 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (self->priv->popover);
#line 66 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (self->priv->hours_spinbutton);
#line 67 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (self->priv->minutes_spinbutton);
#line 68 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (self->priv->am_togglebutton);
#line 69 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (self->priv->pm_togglebutton);
#line 70 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (self->priv->clock);
#line 19 "../lib/Widgets/TimePicker.vala"
	G_OBJECT_CLASS (he_time_picker_parent_class)->finalize (obj);
#line 4931 "TimePicker.c"
}

static GType
he_time_picker_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HeTimePickerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) he_time_picker_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HeTimePicker), 0, (GInstanceInitFunc) he_time_picker_instance_init, NULL };
	GType he_time_picker_type_id;
	he_time_picker_type_id = g_type_register_static (gtk_entry_get_type (), "HeTimePicker", &g_define_type_info, 0);
	HeTimePicker_private_offset = g_type_add_instance_private (he_time_picker_type_id, sizeof (HeTimePickerPrivate));
	return he_time_picker_type_id;
}

GType
he_time_picker_get_type (void)
{
	static volatile gsize he_time_picker_type_id__once = 0;
	if (g_once_init_enter (&he_time_picker_type_id__once)) {
		GType he_time_picker_type_id;
		he_time_picker_type_id = he_time_picker_get_type_once ();
		g_once_init_leave (&he_time_picker_type_id__once, he_time_picker_type_id);
	}
	return he_time_picker_type_id__once;
}

static void
_vala_he_time_picker_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec)
{
	HeTimePicker * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_TIME_PICKER, HeTimePicker);
#line 19 "../lib/Widgets/TimePicker.vala"
	switch (property_id) {
#line 19 "../lib/Widgets/TimePicker.vala"
		case HE_TIME_PICKER_FORMAT_12_PROPERTY:
#line 19 "../lib/Widgets/TimePicker.vala"
		g_value_set_string (value, he_time_picker_get_format_12 (self));
#line 19 "../lib/Widgets/TimePicker.vala"
		break;
#line 19 "../lib/Widgets/TimePicker.vala"
		case HE_TIME_PICKER_FORMAT_24_PROPERTY:
#line 19 "../lib/Widgets/TimePicker.vala"
		g_value_set_string (value, he_time_picker_get_format_24 (self));
#line 19 "../lib/Widgets/TimePicker.vala"
		break;
#line 19 "../lib/Widgets/TimePicker.vala"
		case HE_TIME_PICKER_TIME_PROPERTY:
#line 19 "../lib/Widgets/TimePicker.vala"
		g_value_set_boxed (value, he_time_picker_get_time (self));
#line 19 "../lib/Widgets/TimePicker.vala"
		break;
#line 4984 "TimePicker.c"
		default:
#line 19 "../lib/Widgets/TimePicker.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 19 "../lib/Widgets/TimePicker.vala"
		break;
#line 4990 "TimePicker.c"
	}
}

static void
_vala_he_time_picker_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec)
{
	HeTimePicker * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_TIME_PICKER, HeTimePicker);
#line 19 "../lib/Widgets/TimePicker.vala"
	switch (property_id) {
#line 19 "../lib/Widgets/TimePicker.vala"
		case HE_TIME_PICKER_FORMAT_12_PROPERTY:
#line 19 "../lib/Widgets/TimePicker.vala"
		he_time_picker_set_format_12 (self, g_value_get_string (value));
#line 19 "../lib/Widgets/TimePicker.vala"
		break;
#line 19 "../lib/Widgets/TimePicker.vala"
		case HE_TIME_PICKER_FORMAT_24_PROPERTY:
#line 19 "../lib/Widgets/TimePicker.vala"
		he_time_picker_set_format_24 (self, g_value_get_string (value));
#line 19 "../lib/Widgets/TimePicker.vala"
		break;
#line 19 "../lib/Widgets/TimePicker.vala"
		case HE_TIME_PICKER_TIME_PROPERTY:
#line 19 "../lib/Widgets/TimePicker.vala"
		he_time_picker_set_time (self, g_value_get_boxed (value));
#line 19 "../lib/Widgets/TimePicker.vala"
		break;
#line 5022 "TimePicker.c"
		default:
#line 19 "../lib/Widgets/TimePicker.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 19 "../lib/Widgets/TimePicker.vala"
		break;
#line 5028 "TimePicker.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

